/*****************************************************************************
 *                                                                           *
 *              hash table utility   1996.5.21   - Zheng Gengbin             *
 *                                                                           *
 *****************************************************************************/

#   include "tags.h"
#   include "typedef.h"

#   include "bif.h"

#   include "ll.h"

#   include "symb.h"

#include "defnodes.h"
#include "makenodes.h"


#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>


/****************************************************************
 *								*
 *   init_hash -- initialize the hash table			*
 *								*
 *   Input:							*
 *	hash_tbl - pointer to the hash table to be initializes	*
 *								*
 ****************************************************************/
static void
init_hash(hash_tbl)
	PTR_HASH hash_tbl[];
{
    register i = hashMax;
    register PTR_HASH *p = hash_tbl;

    for (; i; --i)
	*p++ = (PTR_HASH) NULL;
}


/****************************************************************
 *								*
 *   hash -- computes the hash value of a given string		*
 *								*
 *   Input:							*
 *		str - a character string			*
 *								*
 *   Output:							*
 *		an integer representing the hash value of the	*
 *		given string					*
 *								*
 ****************************************************************/
int 
hash(str)
	register char *str;
{
    register int i;

    for (i = 0; *str;)
	i += toupper(*str++);             /* modified by zheng.gb 1996.5.21 */
    return (i % hashMax);
}


/****************************************************************
 *								*
 *  insert_hash -- insert the given symbol table entry into	*
 *		   the hash table				*
 *  input:							*
 *	   symb - the symbol entry to be inserted		*
 *	   head_hash - start of hash table			*
 *								*
 ****************************************************************/
void
insert_hash(symb, head_hash)
	register PTR_SYMB symb;
	PTR_HASH head_hash[];
{
    int    index;
    PTR_HASH entry;

    index = hash(symb->ident);
    if (entry = (PTR_HASH) calloc(1, sizeof(struct hash_entry))) {
	entry->id_attr = symb;
	entry->next_entry = head_hash[index];
	head_hash[index] = entry;
    } else 
	printf("No more space\n");
/*
	(void) strcpy(db_err_msg, "No more space");
*/
}


/****************************************************************
 *								*
 *  build_hash -- build the hash table for all symbols in the	*
 *		  project					*
 *								*
 *  Inputs:							*
 *	   head_symb - starting point of the symbol entries	*
 *	   head_hash - starting point of the hash table 	*
 *								*
 ****************************************************************/
void
build_hash(head_symb, head_hash)
	PTR_SYMB head_symb;
	PTR_HASH head_hash[];
{
    register PTR_SYMB s;

    for (s = head_symb; s; s = s->thread)
	insert_hash(s, head_hash);
}

