/*********************************************************************/
/*                                                                   */
/*      makelabel()...     1995.12.21.     Zheng.                    */
/*                                                                   */
/*********************************************************************/
#ifndef __TYPEDEF__
#   include "typedef.h"
#endif

#ifndef __BIF_DEF__
#   include "bif.h"
#endif

#ifndef __LL_DEF__
#   include "ll.h"
#endif

#ifndef __SYMB_DEF__
#   include "symb.h"
#endif
#include "makenodes.h"


#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

PTR_LLND alloc_llnd();

PTR_LABEL
alloc_lab (fi)
        PTR_FILE fi;
{
        PTR_LABEL new;

        new = (struct Label *) chkalloc(sizeof(struct Label));
        new->id = ++(fi->num_label);
        new->next = LBNULL;
        if (fi->num_label == 1)
                fi->head_lab = new;
        else
                fi->cur_lab->next = new;
        fi->cur_lab = new;
        return (new);
}

/*
 * Make a new low level node for label
 */
PTR_LLND
make_llnd_label (fi, node_type, lab)
        PTR_FILE  fi;
        int       node_type;
        PTR_LABEL lab;
{
        PTR_LLND new_llnd;

        new_llnd = alloc_llnd (fi);     /* should set up id field */

        new_llnd->variant = node_type;
        new_llnd->type = TYNULL;
        new_llnd->entry.label_list.lab_ptr = lab;
        new_llnd->entry.label_list.null_1 = LLNULL;
        new_llnd->entry.label_list.next = LLNULL;
        return (new_llnd);
}

/*
 * Make a new label node for Fortran.  VPC has its own get_labe
 */
PTR_LABEL
make_label (fi, l)
        PTR_FILE fi;
        long     l;
{
        PTR_LABEL new_lab;
        PTR_BFND  this_scope;

        if (l <= 0 || l > 99999) {
                fprintf (stderr, "Label out of range\n");
                l = 0;
        }

	this_scope = cur_scope();

	/* locate the label in the label list if it exists */
        for (new_lab = fi->head_lab; new_lab; new_lab = new_lab->next)
                if (new_lab->stateno == l && new_lab->scope == this_scope)
                        return (new_lab);

	/* And make a new one if it does not exist */
        new_lab = alloc_lab (fi);

        new_lab->stateno = l;
        new_lab->scope = this_scope;
        /* new_lab->labused = NO;
        new_lab->labdefined = NO;
        new_lab->labinacc = NO;
        new_lab->labtype = LABUNKNOWN; */
        new_lab->statbody = BFNULL;
        return (new_lab);
}
