/****************************************************************/
/*								*/
/*        makeList of bfnd,llnd,symb ...  			*/
/*     		11.30 1995    Lxy.			        */
/*								*/
/****************************************************************/
# include "tags.h"
#   include "typedef.h"

#   include "bif.h"

#   include "ll.h"

#   include "symb.h"
#include "makenodes.h"

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

PTR_LLND makeLlnd();

/*
 * Follow a chain of blob nodes to get the last
 *
 * input:
 *       blob - the list to be searched
 *
 * output:
 *       pointer to the last node in the list
 */

PTR_BLOB
follow_blob(blob)
        PTR_BLOB blob;
{
        register PTR_BLOB next, last;

        for (next = last = blob; next; next = next->next)
                last = next;
        return (last);
}

/*
 *  "close_groups"  in sage++/f2dep/stat.c  
 */

void
close_groups()
{
     PTR_BFND past_pred;
     PTR_BLOB q;

     while (end_group > 0) {
          past_pred = pred_bfnd;
          pred_bfnd = pred_bfnd->control_parent;
          q = follow_blob(pred_bfnd->entry.Template.bl_ptr1);
          cur_blob = (q && (q->ref == past_pred)) ?
               q : follow_blob(pred_bfnd->entry.Template.bl_ptr2);
/*        cur_blob = follow_blob(pred_bfnd->entry.Template.bl_ptr1); */
          --end_group;
     }
}

/*   setBfndList    sage++/f2dep/stat.c:"set_stat_list"   */
/*
 * setBfndList  -- links together an old BIF node list with a new one
 *
 * input:
 *        old_list - old BIF node list
 *        stat     - new BIF node
 *
 * output:
 *        a BIF node list that links these two together
 */

PTR_BFND
setBfndList(old_list,stat)
PTR_BFND old_list, stat;
{
	if (!old_list)
	   old_list=stat;
        if (!stat) return (old_list);
		/*  add blob for the new stat and connect them */
	setBlob(stat,pred_bfnd);
	close_groups();  
	return(old_list);
}
	
/*
 *   The follow is abstracted from sage++/f2dep/lists.c
 */

/*
 * set_ll_list attaches a new node to a given old_list and
 * makes sure that the old_list is of the same type as ll_type
 */

PTR_LLND 
set_ll_list(old_list, node, ll_type)
	PTR_LLND old_list, node;
	int     ll_type;
{
	register PTR_LLND temp, new;

	if (!node) {	/* the first item in the list */
		new = makeLlnd(fi,ll_type, old_list, LLNULL, SMNULL);
		new->type = global_default;    
		return (new);
	}
	if (old_list->variant != ll_type) { 	/* first two items */
		new = makeLlnd(fi,ll_type, old_list,
				makeLlnd(fi,ll_type, node, LLNULL, SMNULL),
				SMNULL);
		new->type = global_default;  
		new->entry.Template.ll_ptr2->type = global_default; 
		return (new);
	}
	new = makeLlnd(fi,ll_type, node, LLNULL, SMNULL);
	for (temp = old_list;
	     temp->entry.Template.ll_ptr2;
	     temp = temp->entry.Template.ll_ptr2)
		;
	temp->entry.Template.ll_ptr2 = new;
	new->type = global_default;  
	return (old_list);
}


/*
 * set_id_list takes an old id list and runs down the list attaching new 
 * id at the end
 */

PTR_SYMB 
set_id_list(old_list, id)
	PTR_SYMB old_list, id;
{
	register PTR_SYMB temp;

	if (!id)
		return (old_list);

	for (temp = old_list; temp->id_list; temp = temp->id_list)
		;

	temp->id_list = id;
	return (old_list);
}

/*
 *  "add_to_lowLevelList" and "add_to_LowList" comes from sage++/f2dep/lists.c
 */

PTR_LLND
add_to_lowLevelList(ele, oldList)
PTR_LLND ele, oldList;
{
        register PTR_LLND temp;

        if (!ele)
             return (oldList);

        for(temp = oldList; temp->entry.list.next; temp = temp->entry.list.next)
                ;

        temp->entry.list.next = ele;
        return (oldList);
}

PTR_LLND
add_to_lowList(ele, oldList)
PTR_LLND ele, oldList;
{
        register PTR_LLND temp;

        if (!ele)
             return (oldList);

        for (temp = oldList; temp->entry.Template.ll_ptr2; temp = temp->entry.Template.ll_ptr2)
             ;

        temp->entry.Template.ll_ptr2 = ele;

        return (oldList);
}

