/*********************************************************************/
/*                                                                   */
/*      makeSymb()...     1995.11.16.   Lxy.                         */
/*                                                                   */
/*********************************************************************/
#   include "tags.h"
#   include "typedef.h"

#   include "bif.h"

#   include "ll.h"

#   include "symb.h"
#include "makenodes.h"


#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

/*
 *    cur_scope()...     1995.1.3.   Lxy.  
 */

void
init_scope_table()
{
     scope_table[0] = global_bfnd;
     top_scope_level = 0;
     scope_starts[0]= 0;
     top_scope_starts = 0;
}

PTR_BFND
cur_scope()
{
     return (scope_table[top_scope_level]);
}

PTR_BFND
parent_scope(present_scope_level)
int present_scope_level;
{
     if (present_scope_level > 0)
          return (scope_table[--present_scope_level]);
     else printf("parent_scope: requested scope level non-existent");
}

void
add_scope_level(new_scope, due_to_use_stat)
PTR_BFND new_scope;
int due_to_use_stat;
{
     PTR_BFND tmp;

     if (due_to_use_stat)
     {
          tmp = scope_table[top_scope_level];
          scope_table[top_scope_level] = new_scope;
          scope_table[++top_scope_level] = tmp;
     }
     else
     {
          scope_table[++top_scope_level] = new_scope;
          scope_starts[++top_scope_starts] = top_scope_level;
     }
}

void
delete_beyond_scope_level(level)
PTR_BFND level;
{
     top_scope_level = scope_starts[top_scope_starts] -  1;
     top_scope_starts --;
     if (top_scope_level < 0)
         printf("delete_scope: requested scope level non-existent\n");
}

int
cur_scope_level()
{
     return (top_scope_level);
}

/*
PTR_BFND
scope_at_level(level)
int level;
{
     if (level >= 0)
          return (scope_table[level]);
     else  errstr("sym.c:scope_at_level: requested scope non-existent");
}
*/


/*
 *     make_symb()...    Lxy.
 */

/*
 * copyn -- makes a copy of a string with known length
 *
 * input:
 *        n - length of the string "s"
 *        s - the string to be copied
 *
 * output:
 *        pointer to the new string
 */
char   *
copyn(n, s)
        int n;
        char *s;
{
        char *p, *q;

        p = q = (char *) calloc(1, (unsigned) n);
        while (--n >= 0)
                *q++ = *s++;
        return (p);
}


/*
 * copys -- makes a copy of a string
 *
 * input:
 *        s - string to be copied
 *
 * output:
 *        pointer to the new string
 */
char   *
copys(s)
        char   *s;
{
        return (copyn(strlen(s) + 1, s));
}


PTR_SYMB
alloc_symb (fi)
        PTR_FILE fi;
{
        PTR_SYMB new;

   /*     if (fi->cur_symb && (fi->cur_symb->variant == 0))
                return (fi->cur_symb);    */
        new = (struct symb *) chkalloc(sizeof(struct symb));
        new->id = ++(fi->num_symbs);
        new->thread = SMNULL;
        if (fi->num_symbs == 1)
                fi->head_symb = new;
        else
                fi->cur_symb->thread = new;
        fi->cur_symb = new;
        return (new);
}

/*
 * Make a new symb node
 */

PTR_SYMB
make_symb (fi, node_type, string)
        PTR_FILE fi;
        int      node_type;
        char    *string;
{
        PTR_SYMB new_symb;
	extern int  default_access;

        new_symb = alloc_symb (fi);
        new_symb->variant = node_type;
        new_symb->ident = copys (string);
	
	new_symb->type = TYNULL;
	new_symb->attr = 0;
				/*  Zheng Gengbin 1996.5.23 */
        if (node_type!=FIELD_NAME && default_access)
            new_symb->attr |= default_access;

	new_symb->id_list=SMNULL;
        new_symb->decl = SOFT;
        new_symb->scope=cur_scope();
        new_symb->outer=cur_scope()->entry.prog_stmt.prog_symb;
	new_symb->entry.var_decl.local = LOCAL;
	new_symb->entry.var_decl.const_value = LLNULL;
        return (new_symb);
}

void
err_g(str,linenum,name)
char *str,*name;
int linenum;
{
  globeErr_g=1;
  printf("line(%d) syntax error: %s '%s' \n",linenum,str,name);
}

PTR_SYMB
lookupSymb(string,symb)  
char *string;
PTR_SYMB symb;
{
   PTR_SYMB temp,temp1;
   int flag=0;
   int cmpr;
 
   for(temp=symb;(temp!=NULL)&&(flag!=1);temp=temp->thread)
					/* modified by zheng.gb  strcasecmp */
   {
    if(fi->lang == 2) /* java */
       cmpr=strcmp(temp->ident,string);
    else cmpr = strcasecmp(temp->ident,string);

    if(cmpr==0)
	  if(temp->scope->control_parent== symb->scope)
        { flag=1;
          temp1=temp;
          }
   }
   if(flag==1)
     return(temp1);
   else
     return(temp);
}

PTR_SYMB
makeSymb (fi,scope,node_type,string,decl)
PTR_FILE fi;
PTR_BFND scope;
int      node_type;
char    *string;
int decl;
{
   PTR_SYMB new_symb;
   PTR_BFND scope1;
   int i,num;
   char c;

   int cmpr;

   if(decl==1)
      {
                  /* by zheng.gb 1996.5.5 */
       if (scope->variant == FUNC_HEDR) {
            if(fi->lang == 2)          /* java  xli 5/7/1997 */
		       cmpr=strcmp(string,scope->entry.prog_stmt.prog_symb->ident);
    		else cmpr = strcasecmp(string,scope->entry.prog_stmt.prog_symb->ident);

            if (cmpr==0)
	    	   {
                new_symb=scope->entry.prog_stmt.prog_symb;
				return new_symb;
            	}
            }
       new_symb = lookupSymb(string,scope->entry.prog_stmt.prog_symb);
       if(new_symb == SMNULL)
       {
	  	  new_symb = make_symb(fi,node_type,string);
          c=toupper(new_symb->ident[0]);
          if (c>='A' && c<='Z')
	  		new_symb->type = impltype[c - 'A'];
       }
       else {
          if (new_symb->variant != node_type )  
                                    /* LOCAL means not determined yet */
                 if (node_type != VARIABLE_NAME)
                          new_symb->variant = node_type;
       }
       
                   /* modified by zheng.gb 1995.5.5  */
/*
       else
	  {
	   if(!((new_symb->entry.var_decl.local==INPUT)
		  ||(new_symb->entry.var_decl.local==OUTPUT)
		  ||(new_symb->entry.var_decl.local==IO)))
              err_g("variable redeclaration",lineNum_g,new_symb->ident);
	  }
	new_symb -> decl = HARD;
*/
      }
   else     /* decl=0 */
      {
                  /* by zheng.gb 1996.5.5 */
       if (scope->variant == FUNC_HEDR) {
			if(fi->lang == 2)          /* java  xli 5/7/1997 */
               cmpr=strcmp(string,scope->entry.prog_stmt.prog_symb->ident);
            else cmpr = strcasecmp(string,scope->entry.prog_stmt.prog_symb->ident);

            if (cmpr==0)
			    {
                new_symb=scope->entry.prog_stmt.prog_symb;
				return new_symb;
            	}
            }
       new_symb = lookupSymb(string,scope->entry.prog_stmt.prog_symb);
       if((new_symb== SMNULL)&&(containsNum_g))
	  {	 /* can't find the variable in local */
           num=cur_scope_level();
           for (i=containsNum_g ;i > 0; i--)
	     {
              scope1 = parent_scope(num);
              new_symb = lookupSymb(string,scope1->entry.prog_stmt.prog_symb);
	      if(new_symb!=SMNULL)
		  break;
              num--;
	      }
	   }
       if (new_symb == SMNULL)
	  {
	   new_symb = make_symb(fi,node_type,string);
           if (implicitNone_g) ;
/*					modified by zheng.gb  4.29 1996
	       err_g("variable nondeclared type",lineNum_g,new_symb->ident);
*/
	   else {
               c=toupper(new_symb->ident[0]);
               if (c>='A' && c<='Z')
	  	  new_symb->type = impltype[c - 'A'];
           }
          }
     }

   return (new_symb);
}

PTR_SYMB
makeSymbVar(fi,scope,local,string,decl)
PTR_FILE fi;
PTR_BFND scope;
int local;    /* input, output,io,local_var */
char *string;
int decl;
{
   PTR_SYMB symb_ptr;
   symb_ptr = makeSymb(fi,scope,VARIABLE_NAME,string,decl);
   if(symb_ptr->entry.var_decl.local==LOCAL)
       symb_ptr->entry.var_decl.local=local;
   return(symb_ptr);
}

PTR_SYMB
lookupSymbglobal(string)
char *string;
{
    PTR_SYMB symb;
    PTR_SYMB temp,temp1;
    int flag=0;
    int cmpr;

    symb = fi->head_symb;

    for(temp=symb;(temp!=NULL)&&(flag!=1);temp=temp->thread)
					/* modified by zheng.gb strcasecmp */
     {
      if(fi->lang == 2) /* java */
       cmpr=strcmp(temp->ident,string);
      else cmpr = strcasecmp(temp->ident,string);

      if(cmpr==0)
        { flag=1;
          temp1=temp;
          }
      }
   if(flag==1)
     return(temp1);
   else
     return(temp);
}
