/***************************************************

    HPF2.0 
   
    Xinying Li  Jan.3,1997

***************************************************/

/**************  LANGUAGE  ***************/

/* independent_directive in fD.y */

independent_directive
    :  INDEPENDENT COMMA new_clause COMMA reduction_clause in_prog {
          $$ = fdmakebfnd(fi,INDEPENDENT_STMT, LBNULL, BFNULL, SMNULL, $3, $5, LLNULL,LBNULL); 
       }
    |  INDEPENDENT COMMA reduction_clause in_prog {
          $$ = fdmakebfnd(fi,INDEPENDENT_STMT, LBNULL, BFNULL, SMNULL, LLNULL, $3, LLNULL,LBNULL);
       }
    ;

reduction_clause
    :  REDUCTION LEFTBRACKET reduction_variable_list  RIGHTBRACKET {
          $$ = $3;
       }
    ;

reduction_variable_list 
    :  variable_list
    ;

/**************  APPOVED EXTENSIONS  **************/

hpf_spec_directives
    :  range_directive
    |  shadow_directive
    ;

hpf_exec_directives
    :  active_directive
    |  simple_on_directive
    |  simple_resident_directive
/*    |  on_block   */
    |  block_on_directive
    |  end_on_directive
/*    |  resident_block  */
    |  block_resident_directive
    |  end_resident_directive
    |  task_region_directive
    |  end_task_directive 
 /*   |  task_region */
    |  on_resident_end
    |  wait_directive
    ;  


/* Data Mapping */

combined_attribute
    :  ACTIVE {
          $$=fdmakellnd(fi,ACTIVE_OP,LLNULL,LLNULL,SMNULL,0);
       }
/*			zheng.gb
    |  RANGE LEFTBRACKET range_attr_stuff_list RIGHTBRACKET {
          $$=fdmakellnd(fi,DIR_RANGE_OP,$3,LLNULL,SMNULL,0);
       }   ?? I modify this syntactic rule by add (). xli. 1/21/97 
*/
    |  RANGE range_attr_stuff_list {
          $$=fdmakellnd(fi,DIR_RANGE_ATTR,$2,LLNULL,SMNULL,0);
       }   
    |  SHADOW shadow_attr_stuff {
          $$=fdmakellnd(fi,SHADOW_OP,$2,LLNULL,SMNULL,0);
       }
    ; 


range_directive
    :  RANGE ranger range_attr_stuff_list {
/*       modified by zheng.gb  1997/3/19 in order to keep range directive same of distribute 
          $$ = fdmakebfnd(fi,RANGE_STMT, LBNULL, BFNULL, $2, $3, LLNULL, LLNULL,LBNULL);
*/
          PTR_LLND ll,dd;
          ll= fdmakellnd(fi,EXPR_LIST,$2,LLNULL,SMNULL,0);
          dd= fdmakellnd(fi,EXPR_LIST,$3,LLNULL,SMNULL,0);
          $$ = fdmakebfnd(fi,RANGE_STMT, LBNULL, BFNULL, SMNULL, ll, LLNULL, dd,LBNULL);
          } 
    ;

ranger
    :  name {
         /*$$ = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);*/
         PTR_SYMB s;
         s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
         $$= fdmakellnd(fi,VAR_REF,LLNULL,LLNULL,s,0);
         }
    ;

range_attr_stuff_list
    : range_attr_stuff   {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  range_attr_stuff_list COMMA range_attr_stuff {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;

range_attr_stuff
    :  LEFTBRACKET /*LEFTBRACKET_DIST*/ range_attr_list RIGHTBRACKET {
          $$ = makeLlnd(fi,DIR_RANGE_OP,$2,LLNULL,SMNULL);
          }
    ;

range_attr_list
    :  range_attr  {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  range_attr_list COMMA range_attr {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;

range_attr
    :  range_dist_format
    |  ALL {
          $$= fdmakellnd(fi,ALL_OP,LLNULL,LLNULL,SMNULL,0);
          }
    ;

range_dist_format
    :  BLOCK {
          $$= fdmakellnd(fi,BLOCK_OP,LLNULL,LLNULL,SMNULL,0);
          }
    |  BLOCK LEFTBRACKET RIGHTBRACKET {
          PTR_LLND p;
          p = makeLlnd(fi,BLOCK_ANY,LLNULL,LLNULL,SMNULL);
          $$= fdmakellnd(fi,BLOCK_OP,p,LLNULL,SMNULL,0);
          }   
    |  CYCLIC {
          $$= fdmakellnd(fi,CYCLIC_OP,LLNULL,LLNULL,SMNULL,0);
          }
    |  CYCLIC LEFTBRACKET RIGHTBRACKET {
          PTR_LLND p;
          p = makeLlnd(fi,CYCLIC_ANY,LLNULL,LLNULL,SMNULL);
          $$= fdmakellnd(fi,CYCLIC_OP,p,LLNULL,SMNULL,0);
          }
    |  GEN_BLOCK {
          $$= fdmakellnd(fi,GEN_BLOCK_OP,LLNULL,LLNULL,SMNULL,0);
          }
    |  INDIRECT {
          $$= fdmakellnd(fi,INDIRECT_OP,LLNULL,LLNULL,SMNULL,0);
          }
    |  MULTIPLY {
          $$= fdmakellnd(fi,STAR_OP,LLNULL,LLNULL,SMNULL,0);
          }
    ;

shadow_directive
    :  SHADOW  shadow_target shadow_attr_stuff {
/*   zheng.gb  1997/3/25
          $$ = fdmakebfnd(fi,SHADOW_STMT, LBNULL, BFNULL, $2, $3, LLNULL, LLNULL,LBNULL);
*/
          PTR_LLND ll,dd;
          ll= fdmakellnd(fi,EXPR_LIST,$2,LLNULL,SMNULL,0);
          dd= fdmakellnd(fi,EXPR_LIST,$3,LLNULL,SMNULL,0);
          $$ = fdmakebfnd(fi,SHADOW_STMT, LBNULL, BFNULL, SMNULL, ll, LLNULL, dd,LBNULL);
           }
    ;

shadow_target
    :  name {
         /*$$ = makeSymbVar(fi,cur_scope(),LOCAL,$1,0); zheng.gb */
         PTR_SYMB s;
         s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
         $$= fdmakellnd(fi,VAR_REF,LLNULL,LLNULL,s,0);
         }
    ;

shadow_attr_stuff
    :  LEFTBRACKET shadow_spec_list RIGHTBRACKET {
         $$ = $2;
         }
    ;

shadow_spec_list
    :  shadow_spec  {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  shadow_spec_list COMMA shadow_spec {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;

shadow_spec
    :  width {
          PTR_LLND llnd1;
          llnd1 = makeLlnd(fi,RANGE_OP,LLNULL,$1,SMNULL);
          $$ = makeLlnd(fi,DDOT,llnd1,LLNULL,SMNULL);
          }
    |  low_width COLON high_width {
          PTR_LLND llnd1;
          llnd1 = makeLlnd(fi,RANGE_OP,$1,$3,SMNULL);
          $$ = makeLlnd(fi,DDOT,llnd1,LLNULL,SMNULL);
          }
    ;

width
    :  expr
    ;
  
low_width
    :  expr
    ;

high_width
    :  expr
    ;


/* Data and Task Parallelism */


active_directive
    :  EXE_ACTIVE processors_name {
          $$ = fdmakebfnd(fi,ACTIVE_STMT, LBNULL, BFNULL, $2, LLNULL, LLNULL, LLNULL,LBNULL);
          }
    ;


simple_on_directive
    :  ON_HOME home_expr {
          $$ = fdmakebfnd(fi,SIMPLE_ON_STMT, LBNULL, BFNULL, SMNULL, $2,
LLNULL,LLNULL,LBNULL);
          }
    |  ON_HOME home_expr COMMA resident_clause {
          $$ = fdmakebfnd(fi,SIMPLE_ON_STMT, LBNULL, BFNULL, SMNULL, $2,
$4, LLNULL,LBNULL);
          }
    |  ON_HOME home_expr COMMA new_clause {
          $$ = fdmakebfnd(fi,SIMPLE_ON_STMT, LBNULL, BFNULL, SMNULL, $2,
LLNULL, $4, LBNULL);
          }
    |  ON_HOME home_expr COMMA resident_clause COMMA new_clause {
          $$ = fdmakebfnd(fi,SIMPLE_ON_STMT, LBNULL, BFNULL, SMNULL, $2, $4, $6, LBNULL);
          }
    ;

home_expr 
    :  HOME LEFTBRACKET variable RIGHTBRACKET {
          $$ = makeLlnd(fi,HOME_OP,$3,LLNULL,SMNULL);
          }
/*
    |  HOME LEFTBRACKET template_elmt RIGHTBRACKET {
          $$ = $3;
          }
*/
    |  LEFTBRACKET processors_elmt RIGHTBRACKET {
          $$ = makeLlnd(fi,HOME_PROCS,$2,LLNULL,SMNULL);
          }
    ;

/*
template_elmt
    :  template_name 
    |  template_name LEFTBRACKET section_subscript_list RIGHTBRACKET
    ;

processors_elmt
    :  processors_name
    |  processors_name LEFTBRACKET section_subscript_list RIGHTBRACKET
    ;
*/

processors_elmt
    :  variable
    ;

block_on_directive
    :  simple_on_directive DIRBEGIN {
         $1->variant = BLOCK_ON_STMT;
         $$ = $1;
          }
    ;

end_on_directive
    :  /*DIREND {
           $$ = makeBfnd(fi,CONTROL_END);
          }
    | */ ENDON_HOME {
      /*    $$ = makeEnd(fi); */
            $$ = makeBfnd(fi,DIR_END);
          }
    ;
/*
on_block
    :  block_on_directive
       block
       end_on_directive {
          setBfndList($2,$3);
          }
    ;
*/

resident_clause
    :  RESIDENT {
          $$= fdmakellnd(fi,RESIDENT_OP,LLNULL,LLNULL,SMNULL,0);
          } 
    |  RESIDENT LEFTBRACKET local_var_list RIGHTBRACKET {
          $$= fdmakellnd(fi,RESIDENT_OP,$3,LLNULL,SMNULL,0);
          }
    ;

local_var_list
    :  local_var  {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  local_var_list COMMA local_var {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;

local_var
    :  variable
    ;

simple_resident_directive
    :  resident_clause {
          $$ = fdmakebfnd(fi,SIMPLE_RESIDENT_STMT, LBNULL, BFNULL, SMNULL, $1, LLNULL, LLNULL,LBNULL);
          }
    ;

block_resident_directive
    :  resident_clause DIRBEGIN {
          $$ = fdmakebfnd(fi,BLOCK_RESIDENT_STMT, LBNULL, BFNULL, SMNULL, $1, LLNULL, LLNULL,LBNULL);
          }
    ;

end_resident_directive
    : /* DIREND {
            $$ = makeBfnd(fi,CONTROL_END);
          }
    | */ ENDRESIDENT {
      /*    $$ = makeEnd(fi); */
            $$ = makeBfnd(fi,DIR_END);
          }
    ;

/*
resident_block
    :  block_resident_directive
       block
       end_resident_directive {
          setBfndList($2,$3);
          }
    ; 

*/

on_resident_end
    :  DIREND {
            $$ = makeBfnd(fi,DIR_END);
          }
    ;

/*
task_region
    :  task_region_directive cmnt
       block
       end_task_directive {
          setBfndList($3,$4); 
          }
    ;
*/

task_region_directive
    :  TASK_REGION {
          $$= fdmakebfnd(fi,TASK_STMT, LBNULL, BFNULL, SMNULL, LLNULL, LLNULL, LLNULL,LBNULL);
          }         
    ;

end_task_directive
    :  ENDTASK_REGION {
       /*  $$ = makeEnd(fi); */
           $$ = makeBfnd(fi,DIR_END);
          }
    ;


/* Asynchronous I/O */

wait_directive
    :  WAIT LEFTBRACKET wait_spec_list RIGHTBRACKET {
          $$= fdmakebfnd(fi,WAIT_STMT, LBNULL, BFNULL, SMNULL, $3, LLNULL,LLNULL,LBNULL);
          }
    ;

wait_spec_list
    :  wait_spec {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  wait_spec_list COMMA wait_spec {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;

wait_spec
    :  ID default_int_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"id";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  ERR label {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"err";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  IOSTAT label {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"iostat";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  DONE logical_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"done";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    ;
 

default_int_expr
    :  variable
    ;

/****************  Special extended  *****************/

dist_format
    :  GEN_BLOCK LEFTBRACKET int_array RIGHTBRACKET {
			  /* modified by zheng.gb */
          $$= makeLlnd(fi,GEN_BLOCK_OP,$3,LLNULL,SMNULL);
          /* $$= makeLlnd(fi,GEN_BLOCK_OP,LLNULL,LLNULL,$3); */
          }
    |  INDIRECT LEFTBRACKET int_array RIGHTBRACKET { 
          $$= makeLlnd(fi,INDIRECT_OP,$3,LLNULL,SMNULL);
          }
    ;

int_array
    :  name {
		/* modified by zheng.gb */
	 	 PTR_SYMB sym;
          sym = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          $$= makeLlnd(fi,VAR_REF,LLNULL,LLNULL,sym);
          } 
    ;

dist_target  
    :  name LEFTBRACKET section_subscript_list RIGHTBRACKET {
          PTR_LLND ll;
          PTR_SYMB s;
          s=makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          s->attr = s->attr | PROCESSORS_BIT;
          ll = makeLlnd(fi,ARRAY_REF,$3,LLNULL,s);

                $$= fdmakellnd(fi,DIST_TARGET_OP,LLNULL,ll,SMNULL,0);
          }
    |  MULTIPLY name LEFTBRACKET section_subscript_list RIGHTBRACKET {
          PTR_LLND ll,tt;
          PTR_SYMB s;
          s=makeSymbVar(fi,cur_scope(),LOCAL,$2,0);
          s->attr = s->attr | PROCESSORS_BIT;
          tt = makeLlnd(fi,ARRAY_REF,$4,LLNULL,s);

                ll= fdmakellnd(fi,STAR_OP,LLNULL,LLNULL,SMNULL,0);
                $$= fdmakellnd(fi,DIST_TARGET_OP,ll,tt,SMNULL,0);
          }
    ;

/* ?? The following 3 rules are modified by adding (). xli, 1/21/97 */

distributee 
    :  LEFTBRACKET structure_component RIGHTBRACKET{
          $$ = $2;
          }
    ;

alignee
    :  LEFTBRACKET structure_component RIGHTBRACKET {
          $$ = $2;
          }
    ;

align_target1
    :  LEFTBRACKET structure_component RIGHTBRACKET {
          $$ = $2;
          }
    ;

align_spec
    :  align_target1 {
                PTR_LLND  ll;

                ll= fdmakellnd(fi,ARRAY_REF,LLNULL,LLNULL,$1->entry.
          record_ref_s.field->entry.Template.symbol,0);
                $$= fdmakellnd(fi,ALIGN_WITH_OP,LLNULL,ll,SMNULL,0);
        }
    |  align_target1 LEFTBRACKET align_subscript_list
       RIGHTBRACKET {
                PTR_LLND  ll;

                ll= fdmakellnd(fi,ARRAY_REF,$3,LLNULL,$1->entry.
          record_ref_s.field->entry.Template.symbol,0);
                $$= fdmakellnd(fi,ALIGN_WITH_OP,LLNULL,ll,SMNULL,0);
        }
    |  MULTIPLY align_target1 {
                PTR_LLND  ll,tt;

                ll= fdmakellnd(fi,ARRAY_REF,LLNULL,LLNULL,$2->entry.
          record_ref_s.field->entry.Template.symbol,0);
                tt= fdmakellnd(fi,STAR_OP,LLNULL,LLNULL,SMNULL,0);
                $$= fdmakellnd(fi,ALIGN_WITH_OP,tt,ll,SMNULL,0);
        }
    |  MULTIPLY align_target1 LEFTBRACKET align_subscript_list
       RIGHTBRACKET {
                PTR_LLND  ll,tt;

                ll= fdmakellnd(fi,ARRAY_REF,$4,LLNULL,$2->entry.
          record_ref_s.field->entry.Template.symbol,0);
                tt= fdmakellnd(fi,STAR_OP,LLNULL,LLNULL,SMNULL,0);
                $$= fdmakellnd(fi,ALIGN_WITH_OP,tt,ll,SMNULL,0);
        }
    ;


component_def_stmt
    :  combined_directive
    |  align_directive
    |  distribute_directive
    |  dynamic_directive            /* add by zheng.gb 1997/3/14 */
    ;

/* IO */

connect_spec
    :  ASYNCH default_char_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"asynch";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    ;

io_control_spec
    :  ID default_int_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"id";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    ;

inquire_spec
    :  ASYNCH default_char_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"asynch";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    ;

/*   Extrinsic Perfix  */

prefix
    :  ELEMENTAL {
          $$ = makeLlnd(fi,PREFIX_ELEMENTAL,LLNULL,LLNULL,SMNULL);
          }
    ;

extrinsic_kind_keyword
    :  extrinsic_spec_arg_list
    |  HPF_SERIAL {
          $$ = makeLlnd(fi,PREFIX_HPFSERIAL,LLNULL,LLNULL,SMNULL);
          }
    ;

extrinsic_spec_arg_list
    :  extrinsic_spec_arg {
          $$=makeLlnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);
          }
    |  extrinsic_spec_arg_list COMMA extrinsic_spec_arg {
          $$=set_ll_list($1,$3,EXPR_LIST);
          }
    ;

extrinsic_spec_arg
    :  language
    |  model
    |  external_name
    ;

language
    :  LANGUAGE char_literal_constant {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"language";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  char_literal_constant {
          $$ = makeLlnd(fi,SPEC_PAIR,LLNULL,$1,SMNULL);
          }
    ;

model
    :  MODEL char_literal_constant {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"model";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    ;

external_name
    :  EXTERNAL_NAME char_literal_constant {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"external_name";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    ;

attr_spec
    :  MAP_TO LEFTBRACKET char_literal_constant RIGHTBRACKET {
          $$ = makeLlnd(fi,MAP_OP,$3,LLNULL,SMNULL);
          }
    |  LAYOUT LEFTBRACKET char_literal_constant RIGHTBRACKET {
          $$ = makeLlnd(fi,LAYOUT_OP,$3,LLNULL,SMNULL);
          }
    |  PASS_BY LEFTBRACKET char_literal_constant RIGHTBRACKET {
          $$ = makeLlnd(fi,PASS_BY_OP,$3,LLNULL,SMNULL);
          }
    ;

