
/*
 In order to elimate verbose DISTRIBUTE_OP and ALIGN_OP, I change some action part
 in each change, I comment the old stmts with *wzl* .
Wang Zhenlin.  Jan. 24.
 

 Modified by Zheng Gengbin
  in order to rememeber my changes , I comment my changes with  *zheng.gb* .
*/

specification                                   /* modified by zheng.gb & wzl */
    : hpf_spec_directives_init hpf_spec_directives
       {
        $$ = $2;
       }  
    ;

executable
    :  hpf_exec_directives
    |  forall_construct
    ;

hpf_spec_directives
    :  processors_directive
    |  align_directive
    |  distribute_directive
    |  dynamic_directive
    |  inherit_directive
    |  template_directive
    |  combined_directive
    |  sequence_directive
    ;

hpf_exec_directives
    :  realign_directive
    |  redistribute_directive
    |  independent_directive
    ;

                                        /* new!!! add by wzl */
hpf_spec_directives_init
    :
        {
                vartype = TYNULL;
        }
    ;

                                                       /* modified by wzl */
combined_directive
    :  combined_attribute_list  DOUBLECOLON  entity_decl_list in_prog
	{
                /*wzl* $$ = fdmakebfnd(fi,COMBINED_DIRECTIVE_DECL, LBNULL, BFNULL, SMNULL, $3, LLNULL, $1,LBNULL);*/

                PTR_LLND  attr_list,var_list;
                PTR_LLND  combined_type=LLNULL;
                int       attr;

		attr_list = $1;
		attr = 0;
		while (attr_list != LLNULL)  {
		  switch (attr_list->entry.Template.ll_ptr1->variant) {
		      case PROCESSORS_VAL:  
		             combined_type= makeTypespec_ll(fi,global_processors,LLNULL);
                             break;
                      case TEMPLATE_VAL: 
                             combined_type= makeTypespec_ll(fi,global_template,LLNULL);
			     break;
		      case INHERIT_OP:
			      attr = attr | INHERIT_BIT;
			      break;
                      case DYNAMIC_OP:
			      attr = attr | DYNAMIC_BIT;
			      break;
		      case DISTRIBUTE_ATT:
			      attr = attr | DISTRIBUTE_BIT;
                              break;
		      case ALIGN_ATT:
			      attr = attr | ALIGN_BIT;
			      break;
                      case DIMENSION_OP:
			      attr = attr | DIMENSION_BIT;
			      break;
		  }
		  attr_list = attr_list->entry.Template.ll_ptr2;
		}

                var_list = $3;               
                while ( var_list != LLNULL) {
/*                  if (var_list->entry.Template.ll_ptr1->entry.Template.symbol->attr & DYNAMIC_BIT)  
                  printf("dynamic****\n"); */
		  var_list->entry.Template.ll_ptr1->entry.Template.symbol->attr |= attr;
		  var_list = var_list->entry.Template.ll_ptr2;
		}

                $$ = fdmakebfnd(fi,COMBINED_DIRECTIVE_DECL, LBNULL, BFNULL, SMNULL, $3,combined_type, $1,LBNULL);

		combinedFlag_g = 0;  /* added by Lxy. 1/10/1996 */
                vartype=TYNULL ;        /* added by zheng.gb 1996.5.5 */
	}
    ;

combined_attribute_list
    :  combined_attribute
	{
		combinedFlag_g = 1;  /* added by Lxy. 1/10/1996 */
                $$ = fdmakellnd(fi,EXPR_LIST,$1,LLNULL,SMNULL,0);
	}
    |  combined_attribute_list COMMA combined_attribute
	{
		PTR_LLND  ll;

                ll = fdmakellnd(fi,EXPR_LIST,$3,LLNULL,SMNULL,0);
		fdaddtolllist($1,ll);
		$$=$1;
	}
    ;

combined_attribute
    :  ALIGN align_attribute_stuff
	{
                /*wzl* $$=fdmakellnd(fi,ALIGN_OP,$2,LLNULL,SMNULL,0);
                $$=$2;  */
					/* modified by zheng.gb */
                $$=fdmakellnd(fi,ALIGN_ATT,$2,LLNULL,SMNULL,0);
	}
    |  DISTRIBUTE dist_attribute_stuff
	{
               /*wzl* $$=fdmakellnd(fi,DISTRIBUTE_OP,$2,LLNULL,SMNULL,0);
               $$=$2;   */
					/* modified by zheng.gb */
               $$=fdmakellnd(fi,DISTRIBUTE_ATT,$2,LLNULL,SMNULL,0);
	}
    |  DYNAMIC   
	{
                $$=fdmakellnd(fi,DYNAMIC_OP,LLNULL,LLNULL,SMNULL,0);
	}
    |  INHERIT   
	{
                $$=fdmakellnd(fi,INHERIT_OP,LLNULL,LLNULL,SMNULL,0);
	}
    |  TEMPLATE  
	{
		vartype=global_template;             /* add by zheng.gb */
                $$=fdmakellnd(fi,TEMPLATE_VAL,LLNULL,LLNULL,SMNULL,0);
	}
    |  PROCESSORS 
	{
		vartype=global_processors;             /* add by zheng.gb */
                $$=fdmakellnd(fi,PROCESSORS_VAL,LLNULL,LLNULL,SMNULL,0);
	}
    |  DIRDIMENSION LEFTBRACKET explicit_shape_spec_list RIGHTBRACKET
	{
                $$=fdmakellnd(fi,DIMENSION_OP,$3,LLNULL,SMNULL,0);
		vartype= makeTypeArray($3,vartype);
	}
    ;

distribute_directive
    :  DISTRIBUTE distributee dist_directive_stuff in_prog
	{
                PTR_LLND  ll,tt,dd;

                ll= fdmakellnd(fi,EXPR_LIST,$2,LLNULL,SMNULL,0);
                /*wzltt= fdmakellnd(fi,DISTRIBUTE_OP,$3,LLNULL,SMNULL,0);
                dd= fdmakellnd(fi,EXPR_LIST,tt,LLNULL,SMNULL,0);*/
                dd= fdmakellnd(fi,EXPR_LIST,$3,LLNULL,SMNULL,0);
                $$= fdmakebfnd(fi,DISTRIBUTE_DECL, LBNULL, BFNULL, SMNULL, ll, LLNULL,dd,LBNULL);
	}
    ;

redistribute_directive
    :  REDISTRIBUTE distributee dist_directive_stuff in_prog
	{
		PTR_LLND  tt;

                /*wzl* tt= fdmakellnd(fi,DISTRIBUTE_OP,$3,LLNULL,SMNULL,0);
                $$= fdmakebfnd(fi,DISTRIBUTE_DECL, LBNULL, BFNULL, SMNULL, $2, tt, LLNULL,LBNULL);*/
                tt = fdmakellnd(fi,EXPR_LIST,$2,LLNULL,SMNULL,0);
						/* modified by zheng.gb */
                $$= fdmakebfnd(fi,REDISTRIBUTE_STMT, LBNULL, BFNULL, SMNULL, tt, $3, LLNULL,LBNULL);
	}
    |  REDISTRIBUTE dist_attribute_stuff DOUBLECOLON distributee_list in_prog
	{
                PTR_LLND  ll;

                /*wzl* ll= fdmakellnd(fi,DISTRIBUTE_OP,$2,LLNULL,SMNULL,0);
                $$= fdmakebfnd(fi, DISTRIBUTE_DECL, LBNULL, BFNULL, SMNULL, $4, ll, LLNULL,LBNULL);*/
						/* modified by zheng.gb */
                $$= fdmakebfnd(fi, CBREDISTRIBUTE_STMT, LBNULL, BFNULL, SMNULL, $4, $2, LLNULL,LBNULL);
	}
    ;

dist_directive_stuff
    :  dist_format_clause
	{
                $$=fdmakellnd(fi,DISTRIBUTE_OP,$1,LLNULL,SMNULL,0);
	}
    |  dist_format_clause dist_onto_clause
	{
                $$=fdmakellnd(fi,DISTRIBUTE_OP,$1,$2,SMNULL,0);
	}
    ;

dist_attribute_stuff
    :  dist_directive_stuff
    |  dist_onto_clause
        {
                $$=fdmakellnd(fi,DISTRIBUTE_OP,LLNULL,$1,SMNULL,0);            
        }
    ;

distributee_list
    :  distributee
        {
                $$= fdmakellnd(fi,EXPR_LIST,$1,LLNULL,SMNULL,0);
        }
    |  distributee_list COMMA distributee
        {
                PTR_LLND  ll;

                ll = fdmakellnd(fi,EXPR_LIST,$3,LLNULL,SMNULL,0);
                fdaddtolllist($1,ll);
                $$=$1;
        }
    ;

distributee
    :  name  
	{
	 PTR_SYMB s; 
         s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0); 
         /* next stmt  added by wzl*/
         s->attr |= DISTRIBUTE_BIT;
         $$= fdmakellnd(fi,VAR_REF,LLNULL,LLNULL,s,0);          
	 /*   check for HPF 2.0  zheng.gb */
	 if (s->variant == FIELD_NAME) {
		PTR_BFND stmt=cur_scope();
		if (stmt->variant == STRUCT_DECL)
			stmt->entry.Template.symbol->type->entry.re_decl.mapped_flag= 1;
	 }
	}
    ;

dist_format_clause
    :  LEFTBRACKET /* LEFTBRACKET_DIST */ dist_format_list  RIGHTBRACKET
	{
                $$= fdmakellnd(fi,DIST_FORMAT_OP,LLNULL,$2,SMNULL,0);

	}
    |  MULTIPLY LEFTBRACKET /*LEFTBRACKET_DIST*/ dist_format_list  RIGHTBRACKET
	{
		PTR_LLND  ll;

		ll= fdmakellnd(fi,STAR_OP,LLNULL,LLNULL,SMNULL,0);
                $$= fdmakellnd(fi,DIST_FORMAT_OP,ll,$3,SMNULL,0);
	}
    |  MULTIPLY
	{
                PTR_LLND  ll;

		ll= fdmakellnd(fi,STAR_OP,LLNULL,LLNULL,SMNULL,0);
                $$= fdmakellnd(fi,DIST_FORMAT_OP,ll,LLNULL,SMNULL,0);
	}
    ;

dist_format_list
    :  dist_format
	{
                $$ = fdmakellnd(fi,EXPR_LIST,$1,LLNULL,SMNULL,0);
	}
    |  dist_format_list COMMA dist_format
	{
                PTR_LLND  ll;

                ll = fdmakellnd(fi,EXPR_LIST,$3,LLNULL,SMNULL,0);
                fdaddtolllist($1,ll);
                $$=$1;
	}
    ;

dist_format
    :  BLOCK      
	{
                $$= fdmakellnd(fi,BLOCK_OP,LLNULL,LLNULL,SMNULL,0);
	}
    |  CYCLIC     
	{
                $$= fdmakellnd(fi,CYCLIC_OP,LLNULL,LLNULL,SMNULL,0);      
	}
    |  MULTIPLY   
        {
                $$= fdmakellnd(fi,STAR_OP,LLNULL,LLNULL,SMNULL,0);
        }
    |  BLOCK LEFTBRACKET expr RIGHTBRACKET
	{
                $$= fdmakellnd(fi,BLOCK_OP,$3,LLNULL,SMNULL,0);
	}
    |  CYCLIC LEFTBRACKET expr RIGHTBRACKET
        {
                $$= fdmakellnd(fi,CYCLIC_OP,$3,LLNULL,SMNULL,0);
        }
    ;

dist_onto_clause
    :  ONTO dist_target
	{
		$$=$2;
	}
    ;

dist_target
    :  name
	{
		PTR_LLND  ll;
		PTR_SYMB s;   	 /* Symbol is made by Lxy. 1/5  */
         	s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
		s->attr = s->attr | PROCESSORS_BIT;

                ll= fdmakellnd(fi,VAR_REF,LLNULL,LLNULL,s,0);
                $$= fdmakellnd(fi,DIST_TARGET_OP,LLNULL,ll,SMNULL,0);
	}
    |  MULTIPLY name
	{
                PTR_LLND  ll,tt;
		PTR_SYMB s;      /* Symbol is made by Lxy. 1/5  */
                s = makeSymbVar(fi,cur_scope(),LOCAL,$2,0);
                s->attr = s->attr | PROCESSORS_BIT;

                tt= fdmakellnd(fi,VAR_REF,LLNULL,LLNULL,s,0);
                ll= fdmakellnd(fi,STAR_OP,LLNULL,LLNULL,SMNULL,0);
                $$= fdmakellnd(fi,DIST_TARGET_OP,ll,tt,SMNULL,0);
	}
    |  MULTIPLY
	{
                PTR_LLND  ll;

                ll= fdmakellnd(fi,STAR_OP,LLNULL,LLNULL,SMNULL,0);
                $$= fdmakellnd(fi,DIST_TARGET_OP,ll,LLNULL,SMNULL,0);
	}
    ;

processors_name
    :  name
	{
	 PTR_SYMB s;   		/* Symbol is made by Lxy. 1/5  */
         s = makeSymbVar(fi,cur_scope(),LOCAL,$1,1);
         s->attr = s->attr | PROCESSORS_BIT;
	 $$= s;
	}
    ;

align_directive
    :  ALIGN alignee align_directive_stuff in_prog
	{
/* commented by LY, 03/18
                PTR_LLND  ll,tt;

                ll= fdmakellnd(fi,EXPR_LIST,$2,LLNULL,SMNULL,0);
                tt= fdmakellnd(fi,ALIGN_OP,$3,LLNULL,SMNULL,0);
                $$= fdmakebfnd(fi,ALIGN_DECL, LBNULL, BFNULL, SMNULL, ll, LLNULL, tt,LBNULL);
*/
/* added by wzl-LY, 03/18 */
                PTR_LLND  ll,dd,tt;

                ll= fdmakellnd(fi,EXPR_LIST,$2,LLNULL,SMNULL,0);
                dd= fdmakellnd(fi,EXPR_LIST,$3,LLNULL,SMNULL,0);
                $$= fdmakebfnd(fi,ALIGN_DECL, LBNULL, BFNULL, SMNULL, ll, LLNULL, dd,LBNULL);
	}
    ;

realign_directive
    :  REALIGN alignee align_directive_stuff in_prog
        {
                PTR_LLND  tt;

                /*wzl* tt= fdmakellnd(fi,ALIGN_OP,$3,LLNULL,SMNULL,0);
                $$= fdmakebfnd(fi, REALIGN_STMT, LBNULL, BFNULL, SMNULL, $2, tt, LLNULL,LBNULL);*/
                tt = fdmakellnd(fi,EXPR_LIST,$2,LLNULL,SMNULL,0);
                $$= fdmakebfnd(fi, REALIGN_STMT, LBNULL, BFNULL, SMNULL, tt,$3, LLNULL,LBNULL);
        }
    |  REALIGN align_attribute_stuff DOUBLECOLON alignee_list in_prog
	{
                PTR_LLND  ll;

                /*wzl* ll= fdmakellnd(fi,ALIGN_OP,$2,LLNULL,SMNULL,0);
                $$= fdmakebfnd(fi, REALIGN_STMT, LBNULL, BFNULL, SMNULL, $4, ll, LLNULL,LBNULL);*/
                $$= fdmakebfnd(fi, CBREALIGN_STMT, LBNULL, BFNULL, SMNULL, $4, $2, LLNULL,LBNULL);
	}
    ;

align_directive_stuff
    :  LEFTBRACKET align_source_list RIGHTBRACKET 
       align_with_clause
	{
		$$=fdmakellnd(fi,ALIGN_OP,$2,$4,SMNULL,0);	
	}
    ;

align_attribute_stuff
    :  align_with_clause
	{
                $$=fdmakellnd(fi,ALIGN_OP,LLNULL,$1,SMNULL,0);
	}
    |  LEFTBRACKET align_source_list RIGHTBRACKET 
       align_with_clause
	{
                $$=fdmakellnd(fi,ALIGN_OP,$2,$4,SMNULL,0);
	}
    ;

alignee_list
    :  alignee
	{
                $$= fdmakellnd(fi,EXPR_LIST,$1,LLNULL,SMNULL,0);
	}	
    |  alignee_list COMMA alignee
	{
                PTR_LLND  ll;

                ll = fdmakellnd(fi,EXPR_LIST,$3,LLNULL,SMNULL,0);
                fdaddtolllist($1,ll);
                $$=$1;
	}
    ;

alignee
    :  name
	{
           PTR_SYMB s;       /* Symbol is made by Lxy. 1/5 */
           s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
           /* next stmt added by wzl*/
           s->attr |= ALIGN_BIT;
                $$= fdmakellnd(fi,VAR_REF,LLNULL,LLNULL,s,0);         
	   /* check for HPF 2.0 */
	   if (s->variant == FIELD_NAME) {
		PTR_BFND stmt=cur_scope();
		if (stmt->variant == STRUCT_DECL)
			stmt->entry.Template.symbol->type->entry.re_decl.mapped_flag= 1;
	   }

	}
    ;

align_source_list
    :  align_source
	{
                $$ = fdmakellnd(fi,EXPR_LIST,$1,LLNULL,SMNULL,0);
	}
    |  align_source_list COMMA  align_source
	{
                PTR_LLND  ll;

                ll = fdmakellnd(fi,EXPR_LIST,$3,LLNULL,SMNULL,0);
                fdaddtolllist($1,ll);
                $$=$1;
	}
    ;

align_source
    :  COLON
	{
                $$= fdmakellnd(fi,COLON_OP,LLNULL,LLNULL,SMNULL,0);
	}
    |  MULTIPLY 
	{
                $$= fdmakellnd(fi,STAR_OP,LLNULL,LLNULL,SMNULL,0);
	}
    |  align_dummy
    ;


						/* substitue by zheng.gb */
/*
align_dummy
    :  variable
    ;
*/
align_dummy
    :  name  {
          PTR_SYMB s;
          if(debugFlag_g==1) printf(" variable_name: %s\n",$1);
          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          $$ = makeLlnd(fi,VAR_REF, LLNULL, LLNULL, s);
          set_expr_type($$);
          }
    ;

align_with_clause
    :  WITH align_spec
	{
		$$=$2;
	}
    ;

align_spec
    :  align_target
	{
		PTR_LLND  ll;

		ll= fdmakellnd(fi,ARRAY_REF,LLNULL,LLNULL,$1,0);
                $$= fdmakellnd(fi,ALIGN_WITH_OP,LLNULL,ll,SMNULL,0);

	}
    |  align_target LEFTBRACKET align_subscript_list 
       RIGHTBRACKET
	{
                PTR_LLND  ll;

                ll= fdmakellnd(fi,ARRAY_REF,$3,LLNULL,$1,0);
                $$= fdmakellnd(fi,ALIGN_WITH_OP,LLNULL,ll,SMNULL,0);
	}
    |  MULTIPLY align_target
	{
                PTR_LLND  ll,tt;

                ll= fdmakellnd(fi,ARRAY_REF,LLNULL,LLNULL,$2,0);
		tt= fdmakellnd(fi,STAR_OP,LLNULL,LLNULL,SMNULL,0);
                $$= fdmakellnd(fi,ALIGN_WITH_OP,tt,ll,SMNULL,0);
	}
    |  MULTIPLY align_target LEFTBRACKET align_subscript_list 
       RIGHTBRACKET
	{
                PTR_LLND  ll,tt;

                ll= fdmakellnd(fi,ARRAY_REF,$4,LLNULL,$2,0);
                tt= fdmakellnd(fi,STAR_OP,LLNULL,LLNULL,SMNULL,0);
                $$= fdmakellnd(fi,ALIGN_WITH_OP,tt,ll,SMNULL,0);
	}
    ;

align_target
    :  name
	{
	     PTR_SYMB s;       /* made by Lxy. 1/5 */
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
         $$ = s;
	}
    ;

align_subscript_list
    :  align_subscript
	{
                $$ = fdmakellnd(fi,EXPR_LIST,$1,LLNULL,SMNULL,0);
	}
    |  align_subscript_list COMMA  align_subscript 
	{
                PTR_LLND  ll;

                ll = fdmakellnd(fi,EXPR_LIST,$3,LLNULL,SMNULL,0);
                fdaddtolllist($1,ll);
                $$=$1;
	}
    ;

align_subscript
    :  expr
/*  | align_subscript_use    */
    |  subscript_triplet
    |  MULTIPLY
	{
		$$= fdmakellnd(fi,STAR_OP,LLNULL,LLNULL,SMNULL,0);
	}
    ;

/*
align_subscript_use
    :  align_subscript_use:
       
*/
       
dynamic_directive
    :  DYNAMIC alignee_distributee_list in_prog
	{
		PTR_LLND  ll;

		ll= fdmakellnd(fi,DYNAMIC_OP,LLNULL,LLNULL,SMNULL,0);
                $$= fdmakebfnd(fi,DYNAMIC_DECL, LBNULL, BFNULL, SMNULL, $2, LLNULL,ll,LBNULL);
	}
    ;

alignee_distributee_list
    :  alignee_distributee
	{
                $$ = fdmakellnd(fi,EXPR_LIST,$1,LLNULL,SMNULL,0);
	}
    |  alignee_distributee_list COMMA alignee_distributee
	{
		PTR_LLND  ll;

		ll = fdmakellnd(fi,EXPR_LIST,$3,LLNULL,SMNULL,0);
		fdaddtolllist($1,ll);
                $$ = $1;
	}
    ;

alignee_distributee
    :  name
	{
	 PTR_SYMB s;       /* Symbol is made by Lxy. 1/5 */
         s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
         s->attr |= DYNAMIC_BIT; /*added by wzl*/
         $$ = fdmakellnd(fi,VAR_REF,LLNULL,LLNULL,s,0);
	}
    ;
/*  |  alignee
    |  distributee
*/		
       
processors_directive
    :  PROCESSORS processors_decl_list in_prog
	{
        /*wzl*  $$ = fdmakebfnd(fi, PROCESSORS_STMT, LBNULL, BFNULL, SMNULL, $2, LLNULL, LLNULL,LBNULL);
*/
          PTR_LLND type;
          type = makeTypespec_ll(fi,global_processors,LLNULL);

          $$ = fdmakebfnd(fi, PROCESSORS_STMT, LBNULL, BFNULL, SMNULL, $2,type, LLNULL,LBNULL);
          vartype = TYNULL;
	}
    ;

processors_decl_list
    :  processors_decl
	{
                $$ = fdmakellnd(fi,EXPR_LIST,$1,LLNULL,SMNULL,0);
	}
    |  processors_decl_list COMMA processors_decl
	{
                PTR_LLND  ll;

                ll = fdmakellnd(fi,EXPR_LIST,$3,LLNULL,SMNULL,0);
                fdaddtolllist($1,ll);
                $$=$1;
	}
    ;

processors_decl
    :  processors_name
	{
                $$ = fdmakellnd(fi,VAR_REF,LLNULL,LLNULL,$1,0);
		$1->type=global_processors;
	}
    |  processors_name LEFTBRACKET explicit_shape_spec_list
       RIGHTBRACKET
	{
              /*  $$ = fdmakellnd(fi,ARRAY_REF,$3,LLNULL,$1,0);
            next stmt add by wzl*/
            vartype= global_processors;
            $$ =  makeEntity_ll($1,$3,LLNULL,LLNULL);
	}
    ;

template_directive
    :  TEMPLATE template_decl_list in_prog
	{
                /*wzl* $$ = fdmakebfnd(fi, TEMPLATE_STMT, LBNULL, BFNULL, SMNULL, $2, LLNULL, LLNULL,LBNULL);*/
           PTR_LLND type;

           type = makeTypespec_ll(fi,global_template,LLNULL);
           $$ = fdmakebfnd(fi, TEMPLATE_STMT,LBNULL, BFNULL, SMNULL, $2,type, LLNULL,LBNULL);
           vartype=TYNULL;
	}
    ;

template_decl_list
    :  template_decl
	{
	  	$$ = fdmakellnd(fi,EXPR_LIST,$1,LLNULL,SMNULL,0);
	}
    |  template_decl_list COMMA template_decl
	{
                PTR_LLND  ll;

                ll = fdmakellnd(fi,EXPR_LIST,$3,LLNULL,SMNULL,0);
                fdaddtolllist($1,ll);
                $$=$1;
	}
    ;

template_decl
    :  template_name
	{
		$$ = fdmakellnd(fi,VAR_REF,LLNULL,LLNULL,$1,0);
	}
    |  template_name LEFTBRACKET explicit_shape_spec_list 
       RIGHTBRACKET   
	{
                /*$$ = fdmakellnd(fi,ARRAY_REF,$3,LLNULL,$1,0);
                  next stmt add by wzl*/
                vartype = global_template;
                $$ =  makeEntity_ll($1,$3,LLNULL,LLNULL);
	}
    ;

template_name
    :  name
	{
	    PTR_SYMB s;       /* Symbol is made by Lxy. 1/5 */
            s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
                /*next two stmts added by wzl*/
                s->type = global_template;
                vartype = global_template;
		$$=s;
	}
    ;

/*   Lxy 9/25 */
inhe_dummy_args
    :   name
     { 
          PTR_SYMB s;
		   PTR_LLND  ll_temp;

          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);

          ll_temp = fdmakellnd(fi,VAR_REF,LLNULL,LLNULL,s,0);
          $$=fdmakellnd(fi,EXPR_LIST,ll_temp,LLNULL,SMNULL,0);

     } 
    |  inhe_dummy_args COMMA name {
          PTR_SYMB s;     
           PTR_LLND  ll,tt,ll_temp;

          s = makeSymbVar(fi,cur_scope(),LOCAL,$3,0);

                ll_temp=fdmakellnd(fi,VAR_REF,LLNULL,LLNULL,s,0);
                tt=fdmakellnd(fi,EXPR_LIST,ll_temp,LLNULL,SMNULL,0);
                fdaddtolllist($1,tt);

          $$ = $1;
     }
    ;
inherit_directive
    :  INHERIT inhe_dummy_args in_prog
	{
                PTR_LLND  ll,tt,ll_temp;
/*
		PTR_SYMB  ss;

		ss=$2;

		if(!ss)
			ll=LLNULL;
		else
		{
			ll_temp=fdmakellnd(fi,VAR_REF,LLNULL,LLNULL,ss,0);
			ll=fdmakellnd(fi,EXPR_LIST,ll_temp,LLNULL,SMNULL,0);
			
			while(ss->id_list)
			{
				ss=ss->id_list;
				ll_temp=fdmakellnd(fi,VAR_REF,LLNULL,LLNULL,ss,0);
				tt=fdmakellnd(fi,EXPR_LIST,ll_temp,LLNULL,SMNULL,0);
				fdaddtolllist(ll,tt);
			}
		}
*/
                ll_temp= fdmakellnd(fi,INHERIT_OP,LLNULL,LLNULL,SMNULL,0);
                $$= fdmakebfnd(fi,INHERIT_DECL, LBNULL, BFNULL, SMNULL, $2 , LLNULL,ll_temp, LBNULL);
	}
    ;

independent_directive
    :  INDEPENDENT  in_prog
	{
                $$= fdmakebfnd(fi,INDEPENDENT_STMT, LBNULL, BFNULL, SMNULL, LLNULL, LLNULL, LLNULL,LBNULL);
	}
    |  INDEPENDENT COMMA new_clause in_prog
	{
                $$= fdmakebfnd(fi,INDEPENDENT_STMT, LBNULL, BFNULL, SMNULL, $3, LLNULL, LLNULL,LBNULL);
	}
    ;

new_clause
    :  NEW LEFTBRACKET variable_list RIGHTBRACKET
	{
		$$=$3;
	}
    ;

variable_list
    :  variable
	{
                $$ = fdmakellnd(fi,EXPR_LIST,$1,LLNULL,SMNULL,0);
	}
    |  variable_list COMMA variable
	{
                PTR_LLND  ll;

                ll = fdmakellnd(fi,EXPR_LIST,$3,LLNULL,SMNULL,0);
                fdaddtolllist($1,ll);
                $$=$1;
	}
    ;
