%e 5000
%p 20000
%n 2000
%k 5000
%a 10000
%o 10000

%start aa aaa bb cc hh ii  kk ll mm ww  
%start zz tt jj uu 
%start hpf ex pp

%{

/***
 aa indicates the inquire_stmt
 bb indicates the open_stmt
 cc indicates the read_stmt
 dd indicates all the stmts beginning with "end"
 ee indicates the case_stmt
 ff indicates the type_declaration_stmt
 gg indicates the use_stmt
 hh indicates the write_stmt
 ii indicates the close_stmt
 jj indicates the allocate_stmt
 kk indicates the backspace_stmt
 ll indicates the endfile_stmt
 mm indicates the rewind_stmt
 nn indicates the if_stmt
 oo indicates the assign_stmt
 pp indicates the interface_stmt
 qq indicates the intent_stmt
 rr indicates the function_stmt and entry_stmt: result
 ss indicates the print_stmt
 tt indictats the beginning with the label
 zz indicates the format_stmt
 uu indicates the implicit_stmt
**
 ww indicates the wait_stmt
 ex indicates extrinsic function statement EXTRINSIC
 pp indicates prefix RECURSIVE PURE ELEMENTAL
***/

#ifdef HAVE_CONFIG_H
#include <config.h>                     /* config header file */
#endif

#ifdef STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>
#include "keywords.h"
#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"
#include "hpfparser.tab.h"

/*extern char yytext[YYLMAX];  yytext[0x400] (sun20) ; *yytext  (Linux) */ 


extern  int  debugFlag_g,intrFlag_g;
extern  int  fixedFormat_g;
extern  int  lineNum_g,lineNum_l;
extern int countCont;
extern  FILE *inf_ptr;
extern  int  keyword_flag;                  /* zheng.gb */
int namelist=0,common=0,acimp=0,acimp1=0,branu=0;
int cont;
char *copys();
void continued_line();
void put_back_input();

%}

Digit                           [0-9]
Letter                          [a-zA-Z]
Identifier                      ({Letter}|{Digit}|"_"|"$")
Name                            {Letter}{Identifier}*

BinaryConst                     [bB](\'[01]+\'|\"[01]+\")
OctalConst                      [oO](\'[0-7]+\'|\"[0-7]+\")
HexConst                        [zZ](\'[0-9a-fA-F]+\'|\"[0-9a-fA-F]+\")

DigitString                     {Digit}+

DefinedOperator                 ("."{Letter}+".")

SignedDigitString               [+-]?{DigitString}
Significand                     (({DigitString}"."{DigitString}?)|("."{DigitString}))

RealLiteralConstant             ({Significand}([Ee]{SignedDigitString})?|{DigitString}[eE]{SignedDigitString})

DoubleLiteralConstant           ({Significand}([Dd]{SignedDigitString})?|{DigitString}[dD]{SignedDigitString})

%%

%{
   yyin=inf_ptr;
					/* zheng.gb 1996.5.29 */

#ifdef YYTEXT_IS_POINTER
#ifdef IS_UNSIGNED_CHAR
   yytext = (unsigned char *) calloc(1,(unsigned)0x400);
#else
   yytext = (char *) calloc(1,(unsigned)0x400);
#endif
#endif


%}
^"#"[ ]*[0-9]*[ ]*\".*\"\n  {
				/*  add by zheng.gb  1996/11/29 */
	int   lineno;
	char  filen[100];
	extern char *input_file;
	sscanf(yytext,"# %d \"%s",&lineno,filen);
	if (strncasecmp(input_file,filen,strlen(input_file))==0) {
		if (lineno!=0) lineNum_g=lineno;
	}
	else
		lineNum_g=0;
}

^[C*].*\n	 {
   char  temp[160];
   strcpy(temp,yytext);
   temp[6]='\0';
   if((strcasecmp(temp,"CHPF$ ")==0)||(strcasecmp(temp,"*HPF$ ")==0)||(strcasecmp(temp,"CHPF$	")==0)||(strcasecmp(temp,"*HPF$	")==0))
    {
      yyless(5);
#ifdef _flex_
    yy_set_bol(0);
    /* yy_current_buffer->yy_at_bol = 0;   Lxy. 10/4/96  */
#endif
      if(debugFlag_g==1)
          printf("(Chpf$)");
      BEGIN hpf;
      }
   else 
   {
     if(fixedFormat_g==1)
     {
      if(debugFlag_g==1)
           printf("(fixed_C)\n");
      lineNum_g++;
      lineNum_l++;
      continued_line();
#ifdef _flex_
    yy_set_bol(1);
    /* yy_current_buffer->yy_at_bol = 1;  Lxy. 10/4/96 */ 
#endif
      }
     else
     { 
       int i=0;
       int temp[160];
       temp[0]=' ';
       while ( yytext[i]!='\0')
        {  
            temp[i+1]=(int)yytext[i];
            i++;
           }
       if(debugFlag_g==1)
            printf("yytext :%s;%s\n",yytext,temp);
       put_back_input(temp,i);
     }
   }
}


[ \t]	;

^[ \t]*"\n"  {
   lineNum_g++;
   lineNum_l++;
   continued_line();
#ifdef _flex_
    yy_set_bol(1);
    /* yy_current_buffer->yy_at_bol = 1;    Lxy. 10/4/96  */
#endif
}

^[ \t]*!.*\n  {
   char  temp[7];
   int i=0,j;
   while (yytext[i]!='!') { 
       i++;
   }
   for(j=0;j<6;j++)
       temp[j]=yytext[i+j];
   temp[6]='\0';
   if(debugFlag_g==1)
         printf("(%s)",temp);
   if((strcasecmp(temp,"!HPF$ ")==0)||(strcasecmp(temp,"!HPF$	")==0))
    { 
      yyless(i+5);
#ifdef _flex_
	yy_set_bol(0);
    /*  yy_current_buffer->yy_at_bol = 0;   Lxy. 10/4/96  */
#endif
      if(debugFlag_g==1)
          printf("(!hpf)");
      BEGIN hpf;
      }
   else
     {
      lineNum_g++;
      lineNum_l++;
      continued_line();
#ifdef _flex_
    yy_set_bol(1);
    /* yy_current_buffer->yy_at_bol = 1;   Lxy. 10/4/96  */
#endif
      if(debugFlag_g==1)
         printf("(!commnet:%s)\n",yytext);
      }
}

!.*\n  {
   if(debugFlag_g==1)
        printf("(commnet)");
   lineNum_g++;
   lineNum_l++;
   continued_line();
#ifdef _flex_
    yy_set_bol(1);
    /* yy_current_buffer->yy_at_bol = 1;    Lxy. 10/4/96  */
#endif
   yylval.charp=copys(yytext);	
   return(COMMENT);
}

&[ \t]*\n  {
   lineNum_g++; 
   lineNum_l++;
   continued_line();
#ifdef _flex_
    yy_set_bol(1);
    /* yy_current_buffer->yy_at_bol = 1;    Lxy. 10/4/96  */
#endif
   cont=1; 
}

&[ \t]*!.*\n   {
   lineNum_g++; 
   lineNum_l++;
   continued_line();
#ifdef _flex_
    yy_set_bol(1);
    /* yy_current_buffer->yy_at_bol = 1;    Lxy. 10/4/96  */
#endif
   cont=1; 
}

^[ \t]*&  ;

^[ \t]*[0-9]{1,5}[ \t]+  {
    /* yytext[6]='\0'; */
   yylval.charp=copys(yytext);
 /*  if(cont==1)
       return(DIGIT_STRING);  */
   if(debugFlag_g==1)
       printf("(label:%s)",yytext);
   BEGIN tt;	
   return(LABEL);
}


<hpf>[dD][iI][Mm][eE][nN][sS][iI][oO][nN]   {
   return(DIRDIMENSION);
}

<hpf>[sS][eE][Qq][uU][eE][nN][Cc][eE]  {
   return(DIRSEQUENCE);
}

<hpf>[rR][aA][nN][gG][eE] {
   return(RANGE);
}

<hpf>[aA][lL][lL] {
   return(ALL);
}

<hpf>[oO][nN] {
   return(ON_HOME);
}

<hpf>[bB][eE][gG][iI][nN] {
   return(DIRBEGIN);
}

<hpf>[eE][nN][dD][ ]*[oO][nN] {
   return(ENDON_HOME);
}

<hpf>[eE][nN][dD][ ]*[rR][eE][sS][iI][dD][eE][nN][tT] {
   return(ENDRESIDENT);
}

<hpf>[eE][nN][dD][ ]*[Tt][aA][sS][Kk][_][rR][eE][gG][iI][Oo][nN] {
   return(ENDTASK_REGION);
}

<hpf>[eE][nN][dD] {
   return(DIREND);
}

<hpf>[aA][cC][tT][iI][vV][eE]/[ \t]*{Name}  {
   if(debugFlag_g==1)
     printf("(executable ACTIVE)\n");
   return(EXE_ACTIVE);

/*
<hpf>"("/[ \t]*([bB][lL][oO][cC][kK]){
   if(debugFlag_g==1)
     printf("(LEFTBRACKET_DIST),\n");
   return(LEFTBRACKET_DIST);
}
*/

}

<ex>[lL][aA][nN][gG][uU][aA][gG][eE][ ]*[=] {
   return(LANGUAGE);
}

<ex>[mM][oO][dD][eE][lL][ ]*[=] {
   return(MODEL);
}

<ex>[eE][xX][tT][eE][Rr][nN][aA][lL][_][Nn][Aa][Mm][eE][ ]*[=] {
   return(EXTERNAL_NAME);
}

<ex,pp>[rR][eE][aA][lL]  {
   if(debugFlag_g==1)
       printf("(real<prefix>)");
   return(REAL);
}

<ex,pp>[lL][oO][gG][iI][cC][aA][lL] {
   if(debugFlag_g==1)
       printf("(logical<prefix>)");
   return(LOGICAL);
}


<zz>[Ii]/{DigitString} {
   if(debugFlag_g==1)
      printf("(f_i),");
   return(I);
}

<zz>[Bb]/{DigitString} {
   if(debugFlag_g==1)
     printf("(f_b),");
   return(B);
}

<zz>[oO]/{DigitString} {
   if(debugFlag_g==1)
       printf("(f_o),");
   return(O);
} 

<zz>[Zz]/{DigitString} {
   if(debugFlag_g==1)
       printf("(f_z),");
   return(Z);
}

<zz>[Ff]/{DigitString} {
   if(debugFlag_g==1)
       printf("(f_f),");
   return(F);
} 

<zz>[Ee]/{DigitString} {
   if(debugFlag_g==1)
       printf("(f_e),");
   return(E);
}

<zz>[Ee][Nn]/{DigitString} {
   if(debugFlag_g==1)
       printf("(f_en),");
   return(EN);
}

<zz>[Ee][Ss]/{DigitString} {
   if(debugFlag_g==1)
        printf("(f_es),");
   return(ES);
}

<zz>[gG]/{DigitString} {
   if(debugFlag_g==1)
       printf("(f_g),");
   return(G);
}

<zz>[lL]/{DigitString} {
   if(debugFlag_g==1)
       printf("(f_l),");
   return(L);
}

<zz>[aA]      | 
<zz>[aA]/{DigitString} {
   if(debugFlag_g==1)
        printf("(f_a),");
   return(A);
}

<zz>[dD]/{DigitString} {
   if(debugFlag_g==1)
        printf("(f_d),");
   return(D);
} 

<zz>[pP]  {
   if(debugFlag_g==1)
       printf("(f_p),");
   return(P);
}

<zz>[tT]/{DigitString} {
   if(debugFlag_g==1)
        printf("(f_t),");
   return(T);
}

<zz>[Tt][Ll]/{DigitString} {
   if(debugFlag_g==1)
       printf("(f_tl),");
   return(TL);
}

<zz>[Tt][Rr]/{DigitString} {
   if(debugFlag_g==1)
      printf("(f_tr),");
   return(TR);
}

<zz>[Xx]  {
   if(debugFlag_g==1)
        printf("(f_x),");
   return(X);
}

<zz>[Ss]  {
   if(debugFlag_g==1)
        printf("(f_s),");
   return(S);
}

<zz>[Ss][Pp]  {
   if(debugFlag_g==1)
         printf("(f_sp),");
   return(SP);
}

<zz>[Ss][Ss]  {
   if(debugFlag_g==1)
        printf("(f_ss),");
   return(SS);
}

<zz>[bB][nN]  {
   if(debugFlag_g==1)
       printf("(f_bn),");
   return(BN);
}

<zz>[Bb][Zz]  {
   if(debugFlag_g==1)
        printf("(f_bz),");
   return(BZ);
}

<zz>[hH][^,)]*  {
   if(debugFlag_g==1)
        printf("(fh_ %s ),",yytext);
   yylval.charp=copys(yytext);
   return(H);
}

<aa,bb>[aA][cC][cC][eE][sS][sS][ ]*[=]  {
   return(ACCESSL);
}

<aa,bb>[aA][cC][tT][iI][oO][nN][ ]*[=]  {
   return(ACTION);
}

<cc,hh>[aA][dD][vV][aA][nN][cC][eE][ ]*[=]	 {
   return(ADVANCE);
}

<cc,hh>"("	 {
   branu++;
   if(debugFlag_g==1)
         printf("(lb<cc,hh>),");
   return(LEFTBRACKET);
}

<cc,hh>")"	 {
   branu--;
   if(debugFlag_g==1)
        printf("(rb),");
   if(branu==0)
        BEGIN 0;
   return(RIGHTBRACKET);
}

<cc,hh>","	 {
   if(debugFlag_g==1)
       printf("(com2),");
   return(COMMA2);
}

<aa,bb>[bB][lL][aA][nN][kK][ ]*[=]  {
   return(BLANK);
}

<aa,bb>[dD][eE][lL][iI][mM][ ]*[=]	 {
   return(DELIM);
}

<aa>[dD][iI][rR][eE][cC][tT][ ]*[=]	 {
   return(DIRECT);
}

<cc>[eE][nN][dD][ ]*[=]  {
   return(ENDR);
}

<aa,bb,cc,hh,ii,kk,ll,mm,ww>[eE][rR][rR][ ]*[=]	 {
   return(ERR);
}

<aa>[eE][xX][iI][sS][tT][ ]*[=]	 {
   return(EXIST);
}

<bb,ii>[sS][tT][aA][tT][uU][sS][ ]*[=]	 {
   return(STATUS);
}

<aa>[rR][eE][aA][dD][wW][rR][iI][tT][eE][ ]*[=]	 {
   return(READWRITE);
}

<aa>[iI][oO][lL][eE][nN][gG][tT][hH][ ]*[=]	 {
   BEGIN 0;
   BEGIN aaa;
   return(IOLENGTH);
}

<aa,bb,cc,hh,ii,kk,ll,mm,ww>[iI][oO][sS][tT][aA][tT][ ]*[=]  {
   return(IOSTAT);
}

<aa>[wW][rR][iI][tT][eE][ ]*[=]  {
   return(WRITEI);
}

<aa>[uU][nN][fF][oO][rR][mM][aA][tT][tT][eE][dD][ ]*[=] {
   return(UNFORMATTED);
}

<aa,bb,cc,hh,ii,kk,ll,mm>[uU][nN][iI][tT][ ]*[=] {
   return(UNIT);
}

<aa>[sS][eE][qQ][uU][eE][nN][tT][iI][aA][lL][ ]*[=] {
   return(SEQUENTIAL);
}

<cc>[sS][iI][zZ][eE][ ]*[=]	 {
   return(SIZE);
}

<cc,hh>[rR][eE][cC][ ]*[=]	 {
   return(REC);
}

<aa,bb>[rR][eE][cC][lL][ ]*[=]	 {
   return(RECL);
}

<aa>[rR][eE][aA][dD][ ]*[=]	 {
   return(READI);
}

<aa,bb>[pP][oO][sS][iI][tT][iI][oO][nN][ ]*[=]	 {
   return(POSITION);
}

<aa,bb>[pP][aA][dD][ ]*[=]	 {
   return(PAD);
}

<aa>[oO][pP][eE][nN][eE][dD][ ]*[=]	 {
   return(OPENED);
}

<aa>[nN][uU][mM][bB][eE][rR][ ]*[=]	 {
   return(NUMBER);
}

<aa>[nN][eE][xX][tT][rR][eE][cC][ ]*[=]	 {
   return(NEXTREC);
}

<cc,hh>[nN][mM][lL][ ]*[=]	 {
   return(NML);
}

<aa>[nN][aA][mM][eE][ ]*[=]	 {
   return(NAMEI);
}

<aa>[nN][aA][mM][eE][dD][ ]*[=]	 {
   return(NAMED);
}

<cc>[eE][oO][rR][ ]*[=]	 {
   return(EOR);
}

<aa,bb>[fF][iI][lL][eE][ ]*[=]	 {
   return(FILEI);
}

<cc,hh>[fF][mM][tT][ ]*[=]	 {
   return(FMT);
}

<aa,bb>[fF][oO][rR][mM][ ]*[=]	 {
   return(FORM);
}

<aa>[fF][oO][rR][mM][aA][tT][tT][eE][dD][ ]*[=]	 {
   return(FORMATTED);
}


<aa,bb>[aA][sS][yY][nN][cC][hH][ ]*[=] {
   return(ASYNCH);
}

<cc,hh,ww>[iI][dD][ ]*[=] {
   return(ID);
}

<ww>[dD][oO][nN][eE][ ]*[=] {
   return(DONE);
}


<jj>[sS][tT][aA][tT][ ]*[=]	 {
   return(STAT);
}


^[ \t]*[rR][eE][aA][lL]  {
   if(cont==1)
       return(FUNNAME); 
   else
      return(REAL);
}

^[ \t]*[lL][oO][gG][iI][cC][aA][lL] {
   if(cont==1)
       return(FUNNAME);
   else
      return(LOGICAL);
}

<uu>[rR][eE][aA][lL]  {
   if(debugFlag_g==1)
       printf("(real<uu>)");
   return(REAL);
}

<uu>[lL][oO][gG][iI][cC][aA][lL] {
   if(debugFlag_g==1)
       printf("(logical<uu>)");
   return(LOGICAL);
}

<uu>"("[ ]*{Letter}[ ]*(","|"-"|")") {
   if(debugFlag_g==1)
        printf("(lb2<uu>)");
   yyless(1);
   return(LEFTBRACKET2);
}

<uu>{Letter}  {
   if(debugFlag_g==1)
        printf("(implicit_letter %s)",yytext);
   return(IMPLICITLETTER);
}

[kK][iI][nN][dD][ ]*[=]  {
   if(debugFlag_g==1)
       printf("(kind=)");
   return(KINDEQ);
}

[lL][eE][nN][ ]*[=]      {
   if(debugFlag_g==1)
        printf("(len=)");
   return(LENEQ);
}

[dD][oO][uU][bB][lL][eE][ ]*[pP][rR][eE][cC][iI][sS][iI][oO][nN]  {
   return(DOUBLEPRE);
}

[bB][lL][oO][cC][kK][ ]*[dD][aA][tT][aA]  {
   return(BLOCKDATA);
}

[iI][nN][ ]*[oO][uU][tT]  {
   return(INOUT);
}

[gG][oO][ ]*[tT][oO]  {
   return(GOTO);
}

[sS][eE][lL][eE][cC][tT][ ]*[cC][aA][sS][eE]  {
   return(SELECTCASE);
}

[eE][lL][sS][eE][ ]*[wW][hH][eE][rR][eE] {
   return(ELSEWHERE);
}

[eE][lL][sS][eE][ ]*[iI][fF][ (]  {
   yyless(yyleng-1);
   return(ELSEIF);
}

[eE][nN][dD][ ]*[dD][oO]  {
   return(ENDDO);
}

[eE][nN][dD][ ]*[iI][fF]  {
   return(ENDIF);
}

[eE][nN][dD][ ]*[sS][eE][lL][eE][cC][tT]  {
   return(ENDSELECT);
}

[eE][nN][dD][ ]*[wW][hH][eE][rR][eE]  {
   return(ENDWHERE);
}

[eE][nN][dD][ ]*[fF][oO][rR][aA][lL][lL]  {
   return(ENDFORALL);
}

[eE][nN][dD][ ]*[Tt][yY][pP][eE]  {
   return(ENDTYPE);
}

[eE][nN][dD][ ]*[iI][nN][tT][eE][rR][fF][aA][cC][eE]  {
   return(ENDINTERFACE);
}

[eE][nN][dD][ ]*[mM][oO][dD][uU][lL][eE]  {
   return(ENDMODULE);
}

[eE][nN][dD][ ]*[bB][lL][oO][cC][kK][ ]*[dD][aA][tT][aA]  {
   return(ENDBLOCKDATA);
}

[eE][nN][dD][ ]*[sS][uU][bB][rR][oO][uU][tT][iI][nN][eE]  {
   return(ENDSUBROUTINE);
}

[eE][nN][dD][ ]*[fF][uU][nN][cC][tT][iI][oO][nN]  {
   return(ENDFUNCTION);
}

[eE][nN][dD][ ]*[pP][rR][oO][gG][rR][aA][mM] {
   return(ENDPROGRAM);
}


"."[fF][aA][lL][sS][eE]"."  {
   return(FALSEL);
}

"."[tT][rR][uU][eE]"."   { 
   return(TRUEL);
}

"."[eE][qQ][vV]"."  {
   return(EQV);
}

"."[nN][eE][qQ][vV]"."  {
   return(NEQV);
}

"."[oO][rR]"."  {
   return(OR);
}

"."[aA][nN][dD]"."  {
   return(AND);
}

"."[nN][oO][tT]"."  {
   return(NOT);
}

"."[eE][qQ]"."  {
   return(EQ);
}

"=="  {
   return(EQ);
}

"."[nN][eE]"."  {
   return(NE);
}

"/="  {
   return(NE);
}

"."[lL][tT]"."  {
   return(LT);
}

"<"  {
   return(LT);
}

"."[lL][eE]"."  {
   return(LE);
}

"<="  {
   return(LE);
}

"."[gG][tT]"."  {
   return(GT);
}

">"  {
   return(GT);
}

"."[gG][eE]"."  {
   return(GE);
}

">="	 {
   return(GE);
}

"=>"  {
   if(debugFlag_g==1)
        printf("(=>)");
   return(EQGT);
}	

":"  {
   return(COLON);
}

";"  {
   if(debugFlag_g==1)
         printf("(;)"); 
   BEGIN 0;
   BEGIN aa;
   BEGIN bb;
   return(CARRIAGE2);
}

"?"  {
   return(QUESTION);
}

"="  {
   if(debugFlag_g==1)
        printf("(=)");
   return(EQUAL);
}

"::"   {
   return(DOUBLECOLON);
}

"_"    {
   return(UNDERSCORE);
}

"_'"   {
   yyless(yyleng-1);
   if(debugFlag_g==1)
       printf("(_1),");
   return(UNDERSCORE1);
}

"_"\"	 {
   yyless(yyleng-1);
   if(debugFlag_g==1)
         printf("(_1),");
   return(UNDERSCORE1);
}

","[ ]*"/"  {
  if(common==1 || namelist==1)
   {
     yyless(yyleng-1);
     return(COMMA1);
     }
   else
   {
     yyless(yyleng-1);
     return(COMMA);
     }
}

"\n"  {
   common=0;
   namelist=0;
   cont=0;
   if(debugFlag_g==1)
       printf("(car)%s\n",yytext);
   BEGIN 0;
   continued_line(); 
#ifdef _flex_
    yy_set_bol(1);
    /* yy_current_buffer->yy_at_bol = 1;    Lxy. 10/4/96  */
#endif
   if(debugFlag_g==1)
      printf("!!!%s!!!\n",yytext);
   return(CARRIAGE1);
}

"%"  {
   if(debugFlag_g==1)
         printf("(%),");
   return(PERCENT);
}

","  {
   if(debugFlag_g==1)
         printf("(,),");
   return(COMMA);
}

"."  {
   if(debugFlag_g==1)
        printf("(.),");
   return(FULLPOINT);
}

\"([^"]|"\"\"")*\"  {
   if(debugFlag_g==1)
         printf("(dqstr),");
   yylval.charp=copys(yytext);
   return(STRING);
}

\'([^']|"''")*\'  {
   if(debugFlag_g==1)
         printf("(sqstr),");
   yylval.charp=copys(yytext);
   return(STRING);
}

"("  {
   int i,j;
   char chara,cha_arr[80];

   if(acimp==1)
    { 
      i=1;j=0;
      while(i!=0)
        { 
          chara=input();
          if(chara=='(')
 		i++;
          if(chara==')')
		i--;
          cha_arr[j++]=chara;
          if(chara=='=')
             {
         	acimp1=1;
		break;
  		}
	  }
       j--;		
       for(j;j>=0;j--)
           unput(cha_arr[j]);	
       if(acimp1==1)		
        { 
          acimp1=0;		
          if(debugFlag_g==1)
              printf("(lb1),");
          return(LEFTBRACKET1);
          }
    	else
          { 
            if(debugFlag_g==1)
               printf("(lb),");
            return(LEFTBRACKET);
            }
        }
   else 
   { 
         if(debugFlag_g==1)
           printf("(lb),");
         return(LEFTBRACKET);
    }
}

"(//"    {
   yyless(1);
   return(LEFTBRACKET);
}

"(/"	 {
   acimp=1; 
   return(ACVALUE1);
}

")"	 {
   if(debugFlag_g==1)
          printf("(rb),");
   return(RIGHTBRACKET);
}

"+"	 {
   if(debugFlag_g==1)
        printf("(+),");
   return(PLUS);
}

"-"	 {
   if(debugFlag_g==1)
        printf("(-),");
   return(MINUS);
}

"*"	 {
   if(debugFlag_g==1)
        printf("(*),");
   return(MULTIPLY);
}

"/"	 {
   if(debugFlag_g==1)
        printf("(/),");
   return(DIVIDE);
}

"/)"	 {
   acimp=0;
   return(ACVALUE2);
}

"**"	 {
   if(debugFlag_g==1)
       printf("(**),");
   return(POWER);
}

"//"	 {
   if(common==1)
     { yyless(yyleng-1);
       return(DIVIDE);
       }
   else
      return(CONCAT);
}

{RealLiteralConstant}	 {
   yylval.charp=copys(yytext);
   return(REAL_LITERAL_CONST);
}

{DoubleLiteralConstant} {
   yylval.charp=copys(yytext);
   return(DOUBLE_LITERAL_CONST);
}

{Name} {
   return(keynameDeal_m(yytext));
}

{BinaryConst} {
   return(BINARY_CONST);
}

{OctalConst} {
   return(OCTAL_CONST);
}

{HexConst} {
   return(HEX_CONST);
}

{DigitString}	 {
   yylval.charp=copys(yytext);
   if(debugFlag_g==1)
        printf("(Digit %s)\n",yytext);
   return(DIGIT_STRING);
}

{DefinedOperator}	 {
   yylval.charp=copys(yytext);
   return(DEFINED_OPERATOR);
}

%%
yywrap()
{
  return(1);
}


/*******  "nameCmp_m" : if equl then return 0; nequl return 1  ********/

/*    int nameCmp_m(char buf1[35],char buf2[35])   */
int nameCmp_m(buf1,buf2)
char buf1[35];
char buf2[35];
{
   int i=0;
   int len1,len2;

   len1=strlen(buf1);
   len2=strlen(buf2);
   if(len1!=len2)return 1;

   do
    {
      if (buf1[i]!=buf2[i]&&buf1[i]-32!=buf2[i]&&buf1[i]!=buf2[i]-32)
           return 1;
        else i++;
     }while(i!=len1);
   return 0;
   }


/*********  "searchKey_m" : if find the keyword or funcname return it's
            index , else return limit         ***********/

/*   int searchKey_m(char name[35],char tab[120][35],int limit)  */
int searchKey_m(name,tab,limit)
char name[35];
char tab[120][35];
{
   int i=0;
   int flag=0;

   do
    {
        if(nameCmp_m(name,tab[i])==0)
            flag=1;
        else
             i++;
    }while (!((flag==1)||(i==limit))) ;
    return(i);
}

/*   int keynameDeal_m(char name[35])   */
int keynameDeal_m(name)
char name[35];
{
   int i;
   int returnValue_m;
   char chara;

   yylval.charp=copys( name ); 
   if((i=searchKey_m(name,FUNC_TAB_G,FUNC_TAB_LIMIT_G))<FUNC_TAB_LIMIT_G)
     {
     return (NAME);                           /* zheng.gb 1996.5.30 */

	 if (intrFlag_g ==1) return (NAME);

	 do {
             chara=input();
             }while(chara==' ');
         if(chara=='(')                 /*** "funname( )" : FUNNAME  ***/
               { unput(chara);
       	 	 if(debugFlag_g==1)
       	      		printf("(func_name: %s  %d)\n",name,i);
                 return(FUNNAME);
               }
          else 
               { unput(chara);
                 return(NAME);
               }
       }
   else
       { 
		/* add by zheng.gb */
	 if (keyword_flag == OFF) return (NAME);

         if((i=searchKey_m(name,KEY_WORD_G,KEY_WORD_LIMIT_G))<KEY_WORD_LIMIT_G)
             { 
	           if(debugFlag_g==1)
                     printf("(keyword: %s  %d)\n",name,i);
               switch(i){
	            case 0:  BEGIN zz;    /* format */
                         break;
		        case 1:
                case 2:  BEGIN jj;    /* (de)allocate */
                         break;
                case 3:  common=1;    /* common */
                         break;
                case 4:  namelist=1;  /* namelist */
                         break;
                case 5:  BEGIN bb;    /*  open  */
                         break;
                case 6:               /*  read  */
			             do {
			                chara=input();
			               }while(chara==' ');
                         if(chara=='(')
			             BEGIN cc;
                         unput(chara);
                         break;
                case 7:  BEGIN hh;    /*  write */
                         break;
                case 8:  BEGIN mm;    /* rewind */
                         break;
                case 9:  BEGIN kk;    /*backspace*/
                         break;
                case 10: BEGIN ll;    /*endfile */
                         break;
		        case 11: BEGIN ii;    /* close  */
			             break;
				case 12: BEGIN aa;    /* inquire */
			 			 break;
                case 13: BEGIN uu;    /* implicit */
                         break;
                case 14: BEGIN ww;    /* !HPF$ wait */
                         break;
                case 15: BEGIN ex;    /* extrisic function */
                         break;
                case 16:              /* prefix recursive */
                case 17:              /* prefix pure */
                case 18:              /* prefix elemental */
                         BEGIN pp;
                         break;
                default: ;
                }
		      /* returnValue_m=257+i; */
		        returnValue_m=FORMAT+i;    /* modified by zheng.gb */
                return(returnValue_m);   
              }
         else
             {
               if(debugFlag_g==1) 
                   printf("(It's a name: %s)\n",name);
               return(NAME);
               }
        }
}

/***  continued_line for free-fixed-format  Lxy. 9/14   ***/

void put_back_input(cha,limit)
int cha[800];
int limit;
{
   int i;

   for(i=limit;i>=0;i--)
      unput(cha[i]);
   return;
}

void continued_line()
{
   int chara,cha_s[800];
   int i=0;
   int re_fixed=0;
   int match1=0,match2=0;
   int hpfFlag = 0; /* xli 5/6/97 */ 

   countCont=0; /* xli 7/14/97 */

      /* whether this is a comment line   !*/
   if(fixedFormat_g != 1)
     { do {
#ifdef _flex_
          if((feof(yyin))&&( yy_hold_char == '\0')) return;  
#endif
          chara = input();
          cha_s[i]=chara;
          i++; 
        } while ((chara == ' ')||(chara == '\t'));
       if(chara == '!')
		 { 
		   char temp[4];
		   int k;
           for(k=0;k<=4;k++)
			 { 
#ifdef _flex_
          if((feof(yyin))&&( yy_hold_char == '\0')) return;
#endif
			   chara=input();
			   temp[k]=chara;
			   cha_s[i]=chara;
          	   i++;
			   }
           put_back_input(cha_s,i-1);
		   i=0;
		   if(!((strcasecmp(temp,"HPF$ ")==0)||(strcasecmp(temp,"HPF$	")==0)))
			 return;
           else
              hpfFlag = 1; /* xli 5/6/97 */
		   }
	   put_back_input(cha_s,i-1);
       i=0;
     }

for(;;)
{
int stop=0;

if( fixedFormat_g == 1)
{ /* fixed_format */

   int j=1;
   int no_blank=0;

   if(re_fixed==1)
       j=j+6;

   do {
#ifdef _flex_
      if((feof(yyin))&&(yy_hold_char == '\0'))
         {
        put_back_input(cha_s,i-1);
        return;
         }
#endif
      chara=input();
      if((chara != ' ')&&(chara != '\t')&&(chara != '\n')&&((int)chara != 0))
          no_blank = 1;
      if(chara == '\t')
       { int k;
         j=j+3;
         for(k=1;k<=4;k++)
          {
           cha_s[i]=(int)' ';
           i++;
           }
        }
      else
      {
      cha_s[i]=chara;
      i++;
       }
      j++;
     } while ((chara != '\n')&&((int)chara != 0)&&(j<73));

   if((j>=73)&&(chara != '\n')&&((int)chara != 0))
     {
      while ((chara != '\n')&&((int)chara != 0))
           chara=input();
      cha_s[i]=chara;
      i++;
      }       
     
   if(no_blank == 0)
       break;

   if((int)chara == 0)
     {
       put_back_input(cha_s,i-1);
       return;
       }

   
   for(j=1;(stop==0)&&(j<=6);j++) {
#ifdef _flex_
      if((feof(yyin))&&(yy_hold_char == '\0'))
         {
        put_back_input(cha_s,i-1);
        return;
         }
#endif
      chara=input();
	  if(chara == '\t')
       { int k;
         j=j+3;
         for(k=1;k<=4;k++)
		  {
           cha_s[i]=(int)' ';
           i++;
           }
         if(j>=6) stop = 1;
        }
      else
      {
      cha_s[i]=chara;
      i++;
       }
      if ((chara == '\n')||( chara == 0)||((chara== '!')&&(j<6)&&(j>1)))
          stop = 1;
      if(((chara=='C')||(chara=='*')||(chara=='!'))&&(j==1))
        {
    	   char temp[4];
			int k;
           for(k=0;k<=3;k++)
             { 
#ifdef _flex_
     if((feof(yyin))&&(yy_hold_char == '\0')) 
         {
        put_back_input(cha_s,i-1);
        return;
         }
#endif
			   chara=input();
			   temp[k]=chara;
               cha_s[i]=chara;
			   i++;
               }
           j= j+4;
           if(strcasecmp(temp,"HPF$")!=0)
				stop=1;
		 }
      }

   if(stop ==1)
      break;

   if((chara != ' ')&&(chara != '	'))     /* 6th column is not ' ' */
      {
         i=i-7;
         lineNum_g++;
         lineNum_l++;
         re_fixed = 1;
         }
   else
      break;
      
} /* fixed_format over */

else 
{ /*  free_format */

   do {
#ifdef _flex_
     if((feof(yyin))&&(yy_hold_char == '\0'))
         {
		put_back_input(cha_s,i-1);
        return;
         }
#endif
      chara=input();
      switch (chara) {
        case '&' : break;
        case '\'' :
				   if(match2 ==1 )
					{ cha_s[i]=chara;
                      i++;
					  break;
				     }
				   if(match1 == 1)
					{
					 match1--;
					 cha_s[i]=chara;
                     i++;
					}
				   else {
				    match1++;
					do{
                     cha_s[i]=chara;
                     i++;
                     chara = input();
                     } while ((chara != '\'')&&(chara != '\n'));
                    if (chara == '\'')
                       { cha_s[i]=chara;
                         i++;
						 match1--;
                         }
                     else
                     {
                       unput(chara);
                       chara = '&';
                       do {
                          i--;
                        } while (( cha_s[i] != '&')&&( cha_s[i]!= '\''));
                       if(cha_s[i] == '\'')
                          printf(" Syntax error:String is missing a Delimiter. line : %d\n",lineNum_g-1);
                      }
				    }
                    break;
 
        case '"' : 
				   if(match1 ==1 )
                    { cha_s[i]=chara;
                      i++;
                      break;
                     }
				   if(match2 == 1)
                    {
                     match2--;
                     cha_s[i]=chara;
                     i++;
                    }
				   else {
				    match2++;
					do{
				     cha_s[i]=chara;
                     i++;
                     chara = input();
                    } while ((chara != '"')&&(chara != '\n'));
                   if (chara == '"')
                       { cha_s[i]=chara;
                         i++;
						 match2--;
                         }
                   else
                     {
                       unput(chara);
                       chara = '&';
                       do {
                          i--;
                        } while (( cha_s[i] != '&')&&( cha_s[i]!= '"'));
				       if(cha_s[i] == '"')
                          printf(" Syntax error: No continued line flag &.  line : %d\n",lineNum_g-1);
					  }
				    }
                    break;
         case '!':  if(hpfFlag==1){        /* xli 5/6/97 */
					  cha_s[i]=chara;
                      i++;
                      hpfFlag = 0;
                      break;   /* same as before as default */
                    } else
					  {
						do {
                       		chara = input();
                       		} while (chara != '\n');
                        cha_s[i]=chara;
         	            i++;
                    	break;
                       }
         default :
                    cha_s[i]=chara;
                    i++;
                    break;
        }
     } while ((chara != '&')&&(chara != '\n')&&((int)chara != 0));

   if((chara == '\n')||((int)chara == 0))
     {
       put_back_input(cha_s,i-1);
       if(debugFlag_g==1) printf("(%s)\n",cha_s);
       return;
       }

   do {
      chara=input();
      if (chara == '\n')
        {
/* xli 7/19
         lineNum_g++;
         lineNum_l++;
*/
         countCont++;
         }
   } while (chara != '\n');

   do {
      chara=input();
      switch (chara) {
       case '!' : {
				  char temp[4];
            	  int k;
           		  for(k=0;(chara!='\n')&&(k<=3);k++)
             		{   chara=input();
               			temp[k]=(char)chara;
               		}
                   temp[k]='\0';
           		   if(nameCmp_m(temp,"HPF$")==0)
					 break;
				   if(chara!='\n')
				     do {
                       chara = input();
                       } while (chara != '\n');
/* xli 7/19
                   lineNum_g++;
                   lineNum_l++;
*/
                   countCont++;
                   break;
				   }
       case '&' :  stop=1;
                   break;
       case ' ' :
       case '\t':  break;
       case '\n':  printf("Warning : This blank line is not permitted. line:%d \n",lineNum_g+1);
                   lineNum_g++;
                   lineNum_l++;
                   break;
       default :  unput(chara); 
                   stop=1;
                   break;
       }
    }while (stop != 1);
} /* free_format over*/

}; /* for */

    put_back_input(cha_s,i-1);
    return;
}
