#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>
#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"
#include "tags.h"
#include "extern.h"
#include "makenodes.h"
#include "decl.h"

extern int  intrFlag_g;

/*insert use_module in the use_list of scope
return 0: success;1:failure 
*/
int	link_uselist( module_name, use_stmt)
PTR_SYMB	module_name;
PTR_BFND	use_stmt;
{	
	PTR_LLND	use_list;
	PTR_LLND	p,q;

	switch (pred_bfnd->entry.Template.symbol->variant) {
	case PROGRAM_NAME:
	case MODULE_NAME:
		use_list=pred_bfnd->entry.Template.symbol->entry.prog_decl.use_list;
		break;
	case FUNCTION_NAME:
		use_list=pred_bfnd->entry.Template.symbol->entry.func_decl.use_list;
		break;
	case PROCEDURE_NAME:
		use_list=pred_bfnd->entry.Template.symbol->entry.proc_decl.use_list;
		break;
	}

	p=makeLlnd(cur_file,VAR_REF,LLNULL,LLNULL,module_name);
	q=makeLlnd(cur_file,EXPR_LIST,p,LLNULL,SMNULL);
	q->entry.list_s.next=use_list;

	switch (pred_bfnd->entry.Template.symbol->variant) {
        case PROGRAM_NAME:
        case MODULE_NAME:
		pred_bfnd->entry.Template.symbol->entry.prog_decl.use_list=q;
                break;
        case FUNCTION_NAME:
		pred_bfnd->entry.Template.symbol->entry.func_decl.use_list=q;
                break;
        case PROCEDURE_NAME:
		pred_bfnd->entry.Template.symbol->entry.proc_decl.use_list=q;
                break;
        }
	return(0);
}


/*insert interface in the interface_list of scope
return 0: success;1:failure 
*/
int	link_interfacelist(interface_stmt)
PTR_BFND        interface_stmt;
{	
	PTR_LLND	interface_list;
	PTR_LLND	p,q;
	PTR_BFND        predbfnd;
	PTR_SYMB        interface_name;

		/* in order to make compiler of intrinsic.f fast */
	if (intrFlag_g == 1) return;

	predbfnd = interface_stmt->control_parent;
	
	interface_name=make_symb(fi,INTERFACE_NAME,"~~interface");
	interface_name->scope=interface_stmt;   /* used for push_interface */

	switch (predbfnd->entry.Template.symbol->variant) {
	case PROGRAM_NAME:
	case MODULE_NAME:
		interface_list=predbfnd->entry.Template.symbol->entry.prog_decl.interface_list;
		break;
	case FUNCTION_NAME:
		interface_list=predbfnd->entry.Template.symbol->entry.func_decl.interface_list;
		break;
	case PROCEDURE_NAME:
		interface_list=predbfnd->entry.Template.symbol->entry.proc_decl.interface_list;
		break;
	}

	p=makeLlnd(cur_file,VAR_REF,LLNULL,LLNULL,interface_name);
	q=makeLlnd(cur_file,EXPR_LIST,p,LLNULL,SMNULL);
	q->entry.list_s.next=interface_list;

	switch (predbfnd->entry.Template.symbol->variant) {
        case PROGRAM_NAME:
        case MODULE_NAME:
		predbfnd->entry.Template.symbol->entry.prog_decl.interface_list=q;
                break;
        case FUNCTION_NAME:
		predbfnd->entry.Template.symbol->entry.func_decl.interface_list=q;
                break;
        case PROCEDURE_NAME:
		predbfnd->entry.Template.symbol->entry.proc_decl.interface_list=q;
                break;
        }
	return(0);
}


char *trim_blank(str)
char *str;
{
	int i=0;
	char  *tmp;

	tmp=str;

	while (str[i]==' ') {
		tmp++;
		i++;
	}
	return tmp;
}
