/*****************************************************************************
	Semantic check about the reference of symbol

written by  Zheng Gengbin
	Peking University   P.R.C
*****************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if defined(STDC_HEADERS) && (STDC_HEADERS==1)
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>


#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"
#include "tags.h"
#include "decl.h"


#include "exglobal.h"

extern int  debug1;

extern PTR_BFND cur_bfnd, pred_bfnd, global_bfnd;
extern PTR_TYPE vartype, global_default, impltype[];
extern SYMB_LIST rename_list;
PTR_LLND make_llnd();
PTR_SYMB make_symb();


/*
 *     in_same_module , if sym is in current module 
 */
int in_same_module(sym)
PTR_SYMB sym;
{
	int lev,i,lev1;
	
	if (sym->scope == cur_scope() ) return 1;

	lev=bfnd_in_scope(sym->scope);
	for (i=top_scope_starts ; i>=1 ; i--) 
		if (scope_table[scope_starts[i]-1]->variant == MODULE_STMT)  break;
	if (i==0) return;
	lev1=scope_starts[i]-1;
	if ( lev>=lev1)  return 1;
	return 0;
}


PTR_SYMB
look_up_sym_from_scope_in_hash(string,scope,find_scope)
register char *string;
int            scope;
int	      *find_scope;
{

        int i,level;
        PTR_BFND scope_at_level(), p;
        PTR_SYMB  temp,head_symb;
	PTR_HASH  hash_entry;
	int       way;
	int       index;

		/* if in function , search current function name first */
	if (scope == top_scope_level)
	{
                p = scope_table[top_scope_level];
		if (p->variant == FUNC_HEDR || p->variant == PROC_HEDR)
		{
		if (p->entry.prog_stmt.prog_symb->ident)
                   if (!strcasecmp(string, p->entry.prog_stmt.prog_symb->ident))
			return p->entry.prog_stmt.prog_symb;	
		}
	}

	*find_scope=-1;
	index = hash(string);
        for (level=scope; level>=1; level--){
                p = scope_table[level];
		for ( hash_entry=hash_table[index]; hash_entry;
			hash_entry=hash_entry->next_entry)
		{
			temp=hash_entry->id_attr;
			if (temp->ident == NULL) continue;
					/* if has been rename in use */
			if (symb_in_rename_list(temp)) continue;
                        if (!strcasecmp(string, temp->ident) && p==temp->scope)
			{
				if (temp->attr & PRIVATE_BIT) 
				{
                			if (in_same_module(temp));
					else continue;
				}
				if (temp->variant == FIELD_NAME) continue ;
				*find_scope=level;
                        	return temp;
                        }
                }    /* for hash_entry */
        }
        return SMNULL;
}


PTR_SYMB
look_up_symb_at_scope_in_hash(string,scope)
register char *string;
PTR_BFND     scope;
{
	PTR_SYMB temp,head_symb;
	PTR_HASH hash_entry;
	int      way;
	int      index;
	
	index = hash(string);
	for ( hash_entry=hash_table[index]; hash_entry;
                        hash_entry=hash_entry->next_entry)
	{
	 temp=hash_entry->id_attr;
	 if (temp->ident == NULL) continue;
         if (!strcasecmp(string, temp->ident) && scope==temp->scope)
              return temp;
	}
        return SMNULL;
}

PTR_SYMB
look_up_sym_from_scope(string,scope,find_scope)
register char *string;
int            scope;
int	      *find_scope;
{
        int i,level;
        PTR_BFND scope_at_level(), p;
        PTR_SYMB  temp,head_symb;
	int       way;

		/* if in function , search current function name first */
	if (scope == top_scope_level)
	{
                p = scope_table[top_scope_level];
		if (p->variant == FUNC_HEDR || p->variant == PROC_HEDR)
		{
		if (p->entry.prog_stmt.prog_symb->ident)
                   if (!strcasecmp(string, p->entry.prog_stmt.prog_symb->ident))
			return p->entry.prog_stmt.prog_symb;	
		}
	}

	*find_scope=-1;
        for (level=scope; level>=1; level--){
                p = scope_table[level];
					/* modified by zheng.gb 1996.5.17 */
		head_symb=p->entry.Template.symbol;
		if (head_symb == SMNULL)
		{
			head_symb=fi->head_symb;
			way = 2;
		}
		else {
			way =2;
			head_symb=head_symb->thread;
		}
/*
                for (temp = fi->head_symb; temp; temp = temp->thread) {
*/
                for (temp = head_symb; temp; temp = (way==1? temp->thread : temp->next_symb) ) {
			if (temp->ident == NULL) continue;
                        if (!strcasecmp(string, temp->ident) && p==temp->scope)
			{
				if ((temp->attr & PRIVATE_BIT) &&
					temp->scope!=cur_scope() )
					continue;
				if (temp->variant == FIELD_NAME) continue ;
				*find_scope=level;
                        	return temp;
                        }
                }    /* for temp */
        }
        return SMNULL;

}
/*   
        called by search_symb_decl to find in parent interface block 
	look up symb in his control_parent
*/
PTR_SYMB
look_up_symb_at_scope(string,scope)
register char *string;
PTR_BFND     scope;
{
	PTR_SYMB temp,head_symb;
	int      way;
	
	head_symb=scope->entry.Template.symbol;
        if (head_symb == SMNULL)
        {
        	head_symb=fi->head_symb;
        	way = 2;
        }
        else {
        	way =2;
        	head_symb=head_symb->thread;
        }
/*
	for (temp = fi->head_symb; temp; temp = temp->thread) 
*/
	for (temp = head_symb; temp; temp = (way==1? temp->thread : temp ->next_symb) ) {
	 if (temp->ident == NULL) continue;
         if (!strcasecmp(string, temp->ident) && scope==temp->scope)
              return temp;
	}
        return SMNULL;
}

int  bfnd_in_scope(bfnd)
PTR_BFND bfnd;
{
        int i;

        for (i=1; i<=top_scope_level; i++)
                if (bfnd == scope_table[i] ) return i;
        return -1;
}

PTR_SYMB get_alias_name(sym)
PTR_SYMB sym;
{
	if (sym->variant == VARIABLE_NAME && sym->entry.Template.declared_name)
	{
		for (sym=sym->entry.Template.declared_name;
			sym->entry.Template.declared_name;
			sym=sym->entry.Template.declared_name);	
	}
	return sym;
}

/***************************************************************************

		SEARCH_SYMB_REF(sym)
	search the symbol table for another sym , if not any
	return sym itself.
***************************************************************************/

PTR_SYMB search_symb_ref(symbol)
PTR_SYMB symbol;
{
	PTR_SYMB sym,next,last;
	char	 *str;
	int       lev,lev1;

	if (symbol== SMNULL) return SMNULL;

	/*  if not declared in current scope search as normal !		*/
	/* if (symbol->decl==HARD && symbol->scope==cur_scope())   */
	if (symbol->decl==HARD ) {
/*   ??????            zheng.gb 1996.5.20
		lev=bfnd_in_scope(symbol->scope);
		lev1=scope_starts[top_scope_starts];
		if (lev1!=-1 && lev >= lev1) 
*/
			return get_alias_name(symbol);
	}

	str=symbol->ident;
	symbol->ident=NULL; 	 	      /* make current nullify */

	sym=look_up_sym_from_scope_in_hash(str,top_scope_level,&lev);
        if (sym && sym->decl != HARD) {
		next=look_up_sym_from_scope_in_hash(str,lev-1,&lev1);
		if (next) {
	  		if (symbol->variant == VARIABLE_NAME )
			{
						/* HARD is prefered */
		  		if (sym && sym->decl != HARD) {
		  			while (next && next->decl!=HARD)
		  			{
						next=look_up_sym_from_scope_in_hash(str,lev1-1,&lev);
						lev1=lev;
		  			}
		  			if (next && next->decl==HARD )
						sym=next;
		  		}
			}
		}                /* if (next) */
	}
	else if (sym && sym->scope && sym->scope != cur_scope() && 
		 sym->scope->entry.Template.symbol &&
		 sym->scope->entry.Template.symbol->variant==MODULE_NAME ) 
	     {
		next=look_up_sym_from_scope_in_hash(str,lev-1,&lev1);
		if (next && next->decl == HARD)
			if (sym->scope && next->scope && sym->scope->entry.Template.symbol && next->scope->entry.Template.symbol && sym->scope->entry.Template.symbol->variant==MODULE_NAME && next->scope->entry.Template.symbol->variant==MODULE_NAME)
				/* same name in diff module is illegal !  */
			if (sym != next)
	   			error1(124);
	     }   /* else */
	symbol->ident=str;

	if (sym == SMNULL) sym=symbol;

	sym = get_alias_name(sym);

	if (!sym) return symbol;
	else return sym;         /*   search new symb in parent scope */
}


/***************************************************************************

		SEARCH_SYMB_DECL(sym)
	search the symbol table for declare a sym , if not any
	return sym itself.
	for decl , we only search symbol in current scope !!
***************************************************************************/

PTR_SYMB search_symb_decl(symbol)
PTR_SYMB symbol;
{
	PTR_BFND scope;
	PTR_SYMB sym;
	char *str;

        scope = cur_scope();
		
	str = symbol->ident;
	symbol->ident = NULL;
        sym=look_up_symb_at_scope_in_hash(str,scope);
	symbol->ident =str;
        if (sym == SMNULL)
        	sym = symbol;
	return sym;
}





/*
	check the llnd's attributes and do some changes ,
  this function is a complement for the first parser . It recognize some
  semantics that maybe ambugouse in the yacc .
 		structure construct
		FUNC_CALL
*/
int check_symb_attr_and_change_llnd(llnd)
PTR_LLND llnd;
{
	PTR_SYMB tp,sym;
	int      attr;

			/* don't worry about if the symbol exists */
	tp=llnd->entry.Template.symbol;
	attr=tp->attr;

	sym=search_symb_ref(llnd->entry.Template.symbol);

			/* find if it's an intrinsic call  */
	if (llnd->entry.Template.symbol->decl != HARD &&
	   (is_intrinsic_call(llnd->entry.Template.symbol)==1) ) 
	{
		if (debug1) printf("Change LLND at line:%d from %d to %d.\n",
                        cur_bfnd->g_line,llnd->variant,INTRIN_FUNC_CALL);
                llnd->variant=INTRIN_FUNC_CALL;
	}

	if (sym->variant == ROUTINE_NAME || (sym->attr & EXTERNAL_BIT ))
	{
		if ((g_state & IS_VARIABLE) ==0) {
                        if (debug1) printf("Change LLND at line:%d from %d to %d.\n", cur_bfnd->g_line,llnd->variant,FUNC_CALL);
                        llnd->variant=FUNC_CALL;
			sym->variant=FUNCTION_NAME;
                }
	}

		/* turn the array_ref to STRUCTURE_CONSTRUCTOR if neccessary */
	if (sym->variant == TYPE_NAME) {
        	if (sym!=llnd->entry.Template.symbol)
        	{
                   llnd->entry.Template.symbol->scope=BFNULL;
                   llnd->entry.Template.symbol=sym;
                   if (debug1)
                        printf("Modified a SYMBOL ! name:%s line:%d \n"
                        ,llnd->entry.Template.symbol->ident,
                        cur_bfnd->g_line);
        	}
		if (debug1) printf("Change LLND at line:%d from %d to %d.\n",
			cur_bfnd->g_line,llnd->variant,STRUCTURE_CONSTRUCTOR);
		llnd->variant=STRUCTURE_CONSTRUCTOR;
		convert_array_to_type_structure(llnd);  /* 1996.5.10 */
	}	/* if */

			/*  recognize if is a function call in expr */
	if ( llnd->variant == ARRAY_REF && (tp->variant == FUNCTION_NAME 
					|| tp->variant == INTERFACE_NAME)) 
	{
		if ((g_state & IS_VARIABLE) ==0) {
			if (debug1) printf("Change LLND at line:%d from %d to %d.\n", cur_bfnd->g_line,llnd->variant,FUNC_CALL);
			llnd->variant=FUNC_CALL;
		}
	}

	/* if is not array , then consider it as function  zheng.gb 1996.6.17*/
	if (llnd->variant == ARRAY_REF && ! (attr & DIMENSION_BIT) ) {
		llnd->variant=FUNC_CALL;
	}
}

/*****************************************************************************
		check_leaf_sym(expr)
	check if the reference of any var is legal .

	type    :
		VAR_REF
		CONST_REF
**************************************************************************/
int check_leaf_sym(llnd)
PTR_LLND llnd;
{
	PTR_LLND lp,rp,tt;
	PTR_SYMB sym,s,local_name;
	PTR_TYPE tp;

	
	lp=llnd->entry.Template.ll_ptr1;
	rp=llnd->entry.Template.ll_ptr2;

	if (is_linking)
		if (llnd->variant == FUNC_CALL) {
			llnd->attr &= ~CHECKED_LEAF_SYMB;
		}
		else {
			if (lp) check_leaf_sym(lp);
        		if (rp) check_leaf_sym(rp);
			return;
		}

		/* if have checked , return */
	if (llnd->attr & CHECKED_LEAF_SYMB) return;
	else
		llnd->attr |= CHECKED_LEAF_SYMB;

	if (llnd->variant == SUB_STRING)  check_if_substring(llnd);
	switch (llnd->variant) {
	case KIND_VAL:
		get_kind_val_type(llnd);
		test_leaf_sym(llnd);
		return;
	case COMPLEX_VAL:
		get_complex_val_type(llnd);
		test_leaf_sym(llnd);
		return;
	case ARRAY_CONSTRUCTOR:
		get_array_constructor_type(llnd);
		test_leaf_sym(llnd);
		return;
	case STRUCTURE_CONSTRUCTOR:
	case CONSTRUCTOR_REF:
		get_type_structure_type(llnd);
		test_leaf_sym(llnd);
		return;
	case FUNC_CALL:
			/* check if is intrinsic function */
		if (is_intrinsic_call(llnd->entry.Template.symbol)==0) {
			get_func_type(llnd);
			test_leaf_sym(llnd);
			return;
		}
		else			/* continue down */
			llnd->variant=INTRIN_FUNC_CALL;
	case INTRIN_FUNC_CALL:
		/*is_intrinsic_call(llnd->entry.Template.symbol);*/
		check_intrinsic_func(llnd,FUNCTION_NAME);  /* add by zheng.gb */
		test_leaf_sym(llnd);
		return;
	case SUB_STRING:
		get_substring_type(llnd);
		test_leaf_sym(llnd);
		return;
	case VAR_REF:
	case CONST_REF:
	case ARRAY_REF:
		local_name=llnd->entry.Template.symbol;
		sym=search_symb_ref(llnd->entry.Template.symbol);
		if (sym == SMNULL) {
			error3(109,sym->ident);
			return;
		}
		if (sym!=llnd->entry.Template.symbol)
		{
/* make symbol nosense ! */
					/* modified  4.29 1996 */
/*
			s=llnd->entry.Template.symbol;
			if (!symb_in_use(s))  s->scope=BFNULL; 
*/
			llnd->entry.Template.symbol->scope=BFNULL;

			llnd->entry.Template.symbol=sym;
			if (debug1)   
				printf("Modified a SYMBOL ! name:%s id:%d line:%d \n" ,llnd->entry.Template.symbol->ident,sym->id,cur_bfnd->g_line);
		}
		check_symb_attr_and_change_llnd(llnd);
/*  check node type */
		switch (llnd->variant ){
		case ARRAY_REF: 
			get_array_type(llnd);
			test_leaf_sym(llnd);
			break;
		case FUNC_CALL:
                        /* check if is intrinsic function */
                	if (is_intrinsic_call(llnd->entry.Template.symbol)==0) 
			{
                        	get_func_type(llnd);
                        	test_leaf_sym(llnd);
                        	return;
                	}
                	else                    /* continue down */
                        	llnd->variant=INTRIN_FUNC_CALL;
        	case INTRIN_FUNC_CALL:
                	check_intrinsic_func(llnd,FUNCTION_NAME);
                	test_leaf_sym(llnd);
                	return;
		case STRUCTURE_CONSTRUCTOR:
		case CONSTRUCTOR_REF:
			get_type_structure_type(llnd);
			test_leaf_sym(llnd);
			return;
		default:
			check_sym_type(llnd->entry.Template.symbol);
                	llnd->type=llnd->entry.Template.symbol->type;
			llnd->attr=llnd->entry.Template.symbol->attr;
			test_leaf_sym(llnd);
			if (g_state!=IS_VARIABLE) {
			  if (is_assumed_size_spec(llnd->entry.Template.symbol))
				error3(252,llnd->entry.Template.symbol->ident);
			}
				/*  local_name = use_name */
			if (strcasecmp(llnd->entry.Template.symbol->ident ,
					local_name->ident) !=0 )
			{
			  llnd->entry.Template.symbol=local_name;
			}
			return;
		}		/* switch */
		break;
	case RECORD_REF:
		tt=lp->entry.Template.ll_ptr1;
		sym=search_symb_ref(tt->entry.Template.symbol);
		if (sym == SMNULL) {
			error3(109,sym->ident);
			return;
		}
                if (sym!=tt->entry.Template.symbol)
                {
/* make symbol nosense ! */
					/* modified  4.29 1996 */
/*
			s=tt->entry.Template.symbol;
			if (!symb_in_use(s))  s->scope=BFNULL; 
*/
			tt->entry.Template.symbol->scope= BFNULL;

                        tt->entry.Template.symbol=sym;
                        if (debug1)
                                printf("Modified a SYMBOL ! name:%s line:%d \n"
                                ,tt->entry.Template.symbol->ident,
                                cur_bfnd->g_line);
                }
                check_symb_attr_and_change_llnd(tt);
					/*  make sure it is really a RECORD  */
		if (!tt) error3(109,tt->entry.Template.symbol->ident);
		else {
		      tp=tt->entry.Template.symbol->type;
	      	      if (tp->variant==T_RECORD );
		      else if (tp->variant==T_ARRAY
			   && tp->entry.ar_decl.base_type->variant==T_RECORD);
		      else error3(109,tt->entry.Template.symbol->ident);
		      tt->type = tp;
	 	      get_record_type(llnd);               
		      test_leaf_sym(llnd);
		}
		return;
	}    /*  end of switch */


	if (lp) check_leaf_sym(lp);
	if (rp) check_leaf_sym(rp);
	
}

