/*****************************************************************************
        Semantic check about the type of symbol

written by   Zheng Gengbin
          Peking University  P.R.C
*****************************************************************************/

/*
	checktype.c
		check:  array
			record
			substring
			function
			array constructor
			structure constructor
*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>


#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"
#include "tags.h"
#include "decl.h"

#include "exglobal.h"

extern int  debug1;

extern PTR_BFND cur_bfnd, pred_bfnd, global_bfnd;
extern PTR_TYPE vartype, global_default, impltype[];

/*	add by zheng.gb */
PTR_SYMB   implied_do_table[100];
int	   top_implied_do;
PTR_TYPE   implied_do_type;


/*  look for the filed name 'field; in type */
PTR_SYMB  look_up_field(field,type)
char *field;
PTR_TYPE type;
{
	PTR_SYMB sym;

	for (sym=type->entry.re_decl.first; sym; sym=sym->next_symb)
		if (strcasecmp(field,sym->ident)==0)  return sym;
	return SMNULL;
}


PTR_TYPE look_up_record_at_cur_scope(symbol)
PTR_SYMB symbol;
{
        PTR_TYPE temp;
        PTR_BFND p;
        int      level;

        if (global_default== NULL) return TYNULL;
        p = scope_table[top_scope_level];
        for (temp = global_default; temp; temp = temp->thread) {
        	if (temp->variant != T_RECORD ) continue;
        	if (temp->name==NULL) continue;
        	if (!strcasecmp(symbol->ident, temp->name->ident)
        		&& temp->variant==T_RECORD  && p==temp->name->scope)
        	return temp;
        }
        return TYNULL;
}

PTR_TYPE look_up_record(fi,symbol)
PTR_FILE fi;
PTR_SYMB symbol;
{
	PTR_TYPE temp;
	PTR_BFND p;
	int      level;

	if (global_default== NULL) return TYNULL;
	for (level=top_scope_level; level>=1; level--){
                p = scope_table[level];
		for (temp = global_default; temp; temp = temp->thread) {
		    if (temp->variant != T_RECORD ) continue;
		    if (temp->name==NULL) continue;
         	    if (!strcasecmp(symbol->ident, temp->name->ident) 
			&& temp->variant==T_RECORD  && p==temp->name->scope)
              		return temp;
		}
	}
	return TYNULL;
}

int get_kind_val_type(llnd)
PTR_LLND llnd;
{
/* HIT */
	if (llnd->entry.Template.ll_ptr2->variant == STRING_VAL )
		llnd->type= llnd->entry.Template.ll_ptr2->type;
	else
		llnd->type= llnd->entry.Template.ll_ptr1->type;
	count_kindexp(llnd->type);
	llnd->attr |= PARAMETER_BIT;
}

int get_complex_val_type(llnd)
PTR_LLND llnd;
{
	PTR_LLND kindop,lp,rp;
	PTR_TYPE newtype;

	lp=llnd->entry.Template.ll_ptr1;
	rp=llnd->entry.Template.ll_ptr2;
	if (lp) check_leaf_sym(lp);
	if (rp) check_leaf_sym(rp);

	if (lp->type && lp->type->variant == T_KIND  && 
		rp->type && rp->type->variant == T_KIND) {
		kindop=makeLlnd(fi,EXPR_LIST,lp->type->entry.kind_decl.kindexp->entry.Template.ll_ptr1,rp->type->entry.kind_decl.kindexp,SMNULL);
		newtype=make_type(fi,T_KIND);
		newtype->entry.kind_decl.base_type=global_complex;
		newtype->entry.kind_decl.kindexp=kindop;
		llnd->type=newtype;
	}
	else if (lp->type && lp->type->variant == T_KIND)
			llnd->type=lp->type;
	     else if (rp->type && rp->type->variant == T_KIND)
			llnd->type=rp->type;
		  else llnd->type=global_complex;

	llnd->attr |= PARAMETER_BIT;

}

int get_const_type(llnd)
PTR_LLND llnd;
{
	check_expr_type(llnd->entry.Template.symbol->entry.Template.const_value);
	llnd->type = llnd->entry.Template.symbol->entry.Template.const_value->type;
	llnd->attr = llnd->entry.Template.symbol->entry.Template.const_value->attr;
}

/*			
				DDOT
				 |
			   +------------+
			   |            |
			 RANGE_OP     (stride)
			   |
		      +----------+
		      |          |
		   (lower)    (upper)

	check that :
	1 .  lower , upper , stride must be scalar integer type .
	2 .  set constant flag if it is .
	3.   assign global_int to root node .

*/
int checkDDOT(llnd,err_code)               /* err_code : report error No. */
PTR_LLND llnd;
int      err_code;
{
	PTR_LLND lp,rp;
	int	 is_constant=1;

	lp=llnd->entry.Template.ll_ptr1;		/* range_op */
	if (lp) lp->type= global_int;
	rp=llnd->entry.Template.ll_ptr2; 		/* stride */

	if (rp) {                                 
		check_expr_type(rp);
		if (is_constant && (rp->attr & PARAMETER_BIT) ==0)
			is_constant=0;
		if (!is_scalar(rp->type)) 
			error1(err_code);
		else if (g_state == IO_IMPDO) {
			if (!isInteger(rp) && !isFloat(rp) && !isDouble(rp) )
				error1(err_code);
		     }
		     else
			if (!isInteger(rp))   error1(err_code);
	}
	if (lp) {
		rp=lp->entry.Template.ll_ptr2;			/* upper */
		lp=lp->entry.Template.ll_ptr1;			/* lower */
		if (lp) {
			check_expr_type(lp);
			if (is_constant && (lp->attr & PARAMETER_BIT) ==0)
				is_constant=0;
			if (!is_scalar(lp->type)) 
                        	error1(err_code);
                	else if (g_state == IO_IMPDO) {
                        	if (!isInteger(lp) && !isFloat(lp) && 
					!isDouble(lp) )
                               	   error1(err_code);
                     	     }
                     	     else
                       	        if (!isInteger(lp))   error1(err_code);
		}
		if (rp) {
			check_expr_type(rp);
			if (is_constant && (rp->attr & PARAMETER_BIT )==0)
				is_constant=0;
			if (!is_scalar(rp->type)) 
                                error1(err_code);
                        else if (g_state == IO_IMPDO) {
                                if (!isInteger(rp) && !isFloat(rp) && 
                                        !isDouble(rp) )
                                   error1(err_code);
                       	     }
                             else
                         	if (!isInteger(rp))   error1(err_code);
		}
	}

	llnd->type=global_int;
	if (is_constant) llnd->attr |= PARAMETER_BIT;
}


/*   convert array to type structure */
int convert_array_to_type_structure(struc)
PTR_LLND struc;
{
	PTR_LLND ptr,expr_list;

	ptr=makeLlnd(fi,TYPE_OP,LLNULL, LLNULL,struc->entry.Template.symbol);
        expr_list=struc->entry.Template.ll_ptr1;
        struc->entry.Template.ll_ptr1=ptr;
        struc->entry.Template.ll_ptr2=expr_list;
        struc->entry.Template.symbol = SMNULL;
}

int get_type_structure_type(struc)
PTR_LLND struc;
{
	PTR_LLND expr_list,ptr,ele;
	PTR_TYPE type;
	PTR_SYMB  sym,fld,name;
	int n,fields=0,num;
	int       is_constant = 1;

	name = struc->entry.Template.ll_ptr1->entry.Template.symbol;	
	type=look_up_record(fi,name);
	if (type == TYNULL ) {
		error3(138,name->ident);
		return;
	}

	name->type = type;
	struc->type=type;
	struc->entry.Template.ll_ptr1->type= type;

	n=0;
	ptr=struc->entry.Template.ll_ptr2;
        for ( ; ptr ;ptr=ptr->entry.Template.ll_ptr2)
                n++;

	fields=name->type->entry.re_decl.num_fields;
	if (n != fields ) error3(246,name->ident);

	expr_list=struc->entry.Template.ll_ptr2;

	check_leaf_sym(expr_list);
	num=0;
	for (fld= type->entry.re_decl.first; expr_list ;expr_list=expr_list->entry.Template.ll_ptr2 ) 
	{
		num++;
		ele=expr_list->entry.Template.ll_ptr1;
		if (fld->attr & POINTER_BIT) error4(198,fld->ident,name->ident);
		check_sym_assign_compatiable(fld,fld->type,ele,num);
		if (is_constant && (ele->attr & PARAMETER_BIT) ==0)
			is_constant=0;
		if (fld)
			fld=fld->next_symb;
		else
			break;
	}	/* for */
	if (is_constant) struc->attr |= PARAMETER_BIT;
}

int get_func_type(func)
PTR_LLND func;
{
	PTR_SYMB symb_list;
	PTR_LLND call_args,dummy_arg,actual_arg;
	PTR_TYPE type;

	call_or_func(fi,cur_bfnd,func->entry.Template.symbol,
			func->entry.Template.ll_ptr1,FUNCTION_NAME,1,&func->type);
	if (func->type==TYNULL) func->type = global_default;
	if (cur_subname)
		func->attr = cur_subname->attr;
	if (cur_subname!=func->entry.Template.symbol) {
		func->entry.Template.symbol=cur_subname;
	}

	if (scope_status!=NON_PURE)
	  if ((func->attr & PURE_BIT)==0)
		if (scope_status>=FORALL_IN)
			error1(244);
		else
			error1(245);

}

int get_array_type(array)
PTR_LLND array;
{
	PTR_LLND expr_list,element,script2,ele;
	PTR_TYPE newtype=NULL;
	PTR_SYMB name;
	int      dim,rank=0,n,count;

	/* add by zheng.gb   1996.7.12 */
	array->type=global_default ;
	n=get_array_rank(array);
	if (array->entry.Template.symbol->type->variant != T_ARRAY)
	{                                  /* zheng.gb 1996.5.8 */
		if (!isStringType(array->entry.Template.symbol->type)) 
			error3(110,array->entry.Template.symbol->ident);
		else
			array->type=array->entry.Template.symbol->type;
		return;
	}
	name = array->entry.Template.symbol;
	dim=array->entry.Template.symbol->type->entry.ar_decl.num_dimensions;
	if (n != dim && n!=dim+1)
	{
		error1(117);
		return;
	}
	expr_list=array->entry.Template.ll_ptr1;
	check_leaf_sym(expr_list);
	for ( count=0; expr_list ;expr_list=expr_list->entry.Template.ll_ptr2) 
	{
		count++;
		element=expr_list->entry.Template.ll_ptr1;

		
		switch (element->variant) {
		case DDOT:
			checkDDOT(element,145);
			ele=element->entry.Template.ll_ptr1;
			if (check_bound(array->entry.Template.symbol,ele->entry.Template.ll_ptr1,count) || check_bound(array->entry.Template.symbol,ele->entry.Template.ll_ptr2,count))
				error1(258);
			if (count==n) {
				if (is_assumed_size_spec(array->entry.Template.symbol))
				{
					script2=element->entry.Template.ll_ptr1;
					if (script2==LLNULL || script2->entry.Template.ll_ptr2 == LLNULL)
					error3(251,array->entry.Template.symbol->ident);
				}
			}
			if (n == dim+1 && count == n );
			else rank++;
			break;
/*
		case VECTOR_SUBSCRIPT:
			check_expr_type(element);
			if (element->type                 basetype
			if (element->type->variant != T_INT) error1(116);
			rank++;
			break;
*/
		case KEYWORD_ARG:
			error3(259,element->entry.Template.ll_ptr2->entry.string_val);
			element=element->entry.Template.ll_ptr1;
		default:
			check_expr_type(element);
			if (element->type->variant  !=T_ARRAY)  {
				if (!isInteger(element) ) 
					error3(116,array->entry.Template.symbol->ident);
				if (check_bound(array->entry.Template.symbol,
							element,count)) 
					error1(258) ;
			}
			else {
				/*  vector subscript */
				if (!isIntegerType(element->type->
						entry.ar_decl.base_type))
					error3(116,array->entry.Template.symbol->ident);
				rank++;
			}
		}				/* switch */

		/*  when subscript is a vector */
		if (element->type->variant == T_ARRAY && 
		      element->type->entry.ar_decl.num_dimensions !=1)
			   error3(115,array->entry.Template.symbol->ident);

		if (count == dim && dim+1 == n)     /*   means  array section */
		{
			if (expr_list->entry.Template.ll_ptr2 == LLNULL)
			{
				error3(101,name->ident);
				break;
			}
			else if (expr_list->entry.Template.ll_ptr2->
                                entry.Template.ll_ptr1 == LLNULL)
				{
					error3(101,name->ident);
					break;
				}
			else if (expr_list->entry.Template.ll_ptr2->
				entry.Template.ll_ptr1->variant != DDOT )
				{
					error3(101,name->ident);
					break;
				}
			if (!isString(element))
				error1(120);
		}
	}		/* for */
	if (rank==0) {
/*				????????  				*/
		if (array->entry.Template.symbol->type->variant != T_ARRAY)
			array->type=array->entry.Template.symbol->type;	
		else
			array->type=array->entry.Template.symbol->
				type->entry.ar_decl.base_type;
	}
	else {
		newtype=make_type(fi,T_ARRAY);
		newtype->entry.ar_decl.base_type=
	                      array->entry.Template.symbol->type->
						entry.ar_decl.base_type;
		newtype->entry.ar_decl.num_dimensions = rank;
		array->type = newtype;
		if (debug1) printf("Create new type ! rank:%d \n",rank);
	}	
	if (array->entry.Template.symbol->attr & IN_BIT) 
		array->attr |=IN_BIT;
	if (array->entry.Template.symbol->attr & OUT_BIT) 
		array->attr |=OUT_BIT;
	if (array->entry.Template.symbol->attr & INOUT_BIT) 
		array->attr |=INOUT_BIT;
	if (array->entry.Template.symbol->attr & TARGET_BIT) 
		array->attr |=TARGET_BIT;
	if (array->entry.Template.symbol->attr & PARAMETER_BIT) 
		array->attr |=PARAMETER_BIT;
/* zheng.gb 1996.5.12 */
	if (array->entry.Template.symbol->attr & POINTER_BIT) 
		array->attr |=POINTER_BIT;
	if (array->entry.Template.symbol->attr & ALLOCATABLE_BIT) 
		array->attr |=ALLOCATABLE_BIT;
}

/* 
	dim : the dimension to check
	return value :
		0: suceess
		>0 : error code
*/
int check_bound(array,exp,dim)
PTR_SYMB array;
PTR_LLND exp;
int      dim;
{
	PTR_LLND dims,lbound,ubound;
	int      n=0,value,lb_val,ub_val,l_check=1,r_check=1;

	if (exp==LLNULL) return 0;
	if (!check_initialization_expr(exp)) return 0;
	if (comput_const_expr(exp,0)!=0)  return 0;
	value=exp->const_val;

	for (dims=array->type->entry.ar_decl.ranges; dims; 
		dims=dims->entry.Template.ll_ptr2) {
		n++;
		if (n==dim) break;
	}
	if (n != dim) return;
	dims=dims->entry.Template.ll_ptr1;        /* DDOT  */
	if (dims==LLNULL) return 0;

	if (dims && dims->variant == DDOT)
		dims=dims->entry.Template.ll_ptr1;   /* RANGE_OP */

	if (dims) {
		lbound=dims->entry.Template.ll_ptr1;
		ubound=dims->entry.Template.ll_ptr2;
	}
	else     return 0;                /* defered shape */

	if (ubound && ubound->variant == STAR_RANGE)
		ubound=LLNULL;

	if (lbound==LLNULL)
		lb_val=1;
	else
		if (lbound && check_initialization_expr(lbound)) {
			if (comput_const_expr(lbound,0)==0)
			   lb_val=lbound->const_val;
		}
		else    l_check=0;
	if (ubound && check_initialization_expr(ubound)) {
		if (comput_const_expr(ubound,0)==0)
		   ub_val=ubound->const_val;
	}
	else    r_check=0;

	if (r_check==1 && value > ub_val) return(258);
	if (l_check==1 && value < lb_val) return(258);
	return 0;
}


int get_record_type(record)
PTR_LLND record;
{
	PTR_LLND expr,lp,rp,leaf,entity;
	PTR_TYPE  type,newtype;
	PTR_SYMB   s,ss;
	int        rank=0,rank_num=0,no,lev;
	int	   attr = 0;

	expr=record->entry.Template.ll_ptr1;
	lp=expr->entry.Template.ll_ptr1;
	entity=lp;

	if (lp->variant == ARRAY_REF) get_array_type(lp);
	else lp->attr |= lp->entry.Template.symbol->attr;

	if (lp->type == TYNULL) {
		error3(230,lp->entry.Template.symbol->ident);
		return;
	}

	/* parent attributes */
	if (lp->attr & IN_BIT)  attr |=IN_BIT;
        if (lp->attr & OUT_BIT) attr |=OUT_BIT;
        if (lp->attr & INOUT_BIT) attr |=INOUT_BIT;
        if (lp->attr & TARGET_BIT) attr |=TARGET_BIT;
        if (lp->attr & PARAMETER_BIT) attr |=PARAMETER_BIT;


	type = get_base_type(lp->type);			/* base type */

	if (lp->type->variant == T_ARRAY ) 
	{
		  /* use rank_num to record the total number of record element
			whose rank is great than 1 */
		rank_num++;
			/* use rank to record the total rank of the structure */
		rank+=lp->type->entry.ar_decl.num_dimensions ;
	}

	no=0;
/*
	for (lp=record->entry.Template.ll_ptr2->entry.Template.ll_ptr1;
 	       lp; lp=lp->entry.Template.ll_ptr2 ? lp->entry.Template.ll_ptr2->
			entry.Template.ll_ptr1: LLNULL) 
*/
	for (lp=record->entry.Template.ll_ptr2; lp; 
					lp=lp->entry.Template.ll_ptr2 )
	{
		no++;
		leaf=lp->entry.Template.ll_ptr1;

		/*s=lookupSymb(leaf->entry.Template.symbol->ident,type->name);*/
		s=look_up_field(leaf->entry.Template.symbol->ident,type);
		if (!s) 
		{
			error3(112,leaf->entry.Template.symbol->ident);
			rank=0;  type=global_default;
			break;
		}
		else 
			leaf->entry.Template.symbol=s;

		if (s && (s->attr & PRIVATE_BIT)  && 
			entity->entry.Template.symbol->scope != cur_scope()) 
		{
			if (!in_module) {
				ss=get_var_name(record);
		        	error4(194,s->ident,ss->ident);
			}
		}

		switch (leaf->variant) {
		case ARRAY_REF:
			get_array_type(leaf);
				/* error must occurs */
			if (leaf->type == TYNULL) return;
			break;
		case VAR_REF:
			leaf->type=leaf->entry.Template.symbol->type;
			break;
		}
			/* if not found then set DEFAULT type ! */
		if (leaf->type == TYNULL)
			leaf->type=global_default;

		if (leaf->type->variant == T_ARRAY) 
		{
			if (rank_num==1)	
				error2(118,no);
			rank_num++;
			rank+=leaf->type->entry.ar_decl.num_dimensions;
		}
		if (leaf->type->variant == T_ARRAY)
			type=leaf->type->entry.ar_decl.base_type;
		else 
			type=leaf->type;

		if (leaf->entry.Template.symbol->attr & IN_BIT)
                	attr |=IN_BIT;
        	if (leaf->entry.Template.symbol->attr & OUT_BIT)
                	attr |=OUT_BIT;
        	if (leaf->entry.Template.symbol->attr & INOUT_BIT)
                	attr |=INOUT_BIT;
        	if (leaf->entry.Template.symbol->attr & TARGET_BIT)
                	attr |=TARGET_BIT;
        	if (leaf->entry.Template.symbol->attr & PARAMETER_BIT)
                	attr |=PARAMETER_BIT;
	}
	if (debug1) printf("line:%d,Give record type id: %d.\n",cur_bfnd->g_line,type->id);
		/* create final type of the structure */
	if (rank==0) 
		record->type=type;
	else {
		newtype=make_type(fi,T_ARRAY);
		newtype->entry.ar_decl.base_type=type;
		newtype->entry.ar_decl.num_dimensions = rank;
		record->type = newtype;
		if (debug1) printf("Record Create new type ! rank:%d \n",rank);
	}	

	/* asign the attr of the record */
	record->attr |= attr;
	if (leaf->entry.Template.symbol->attr & POINTER_BIT) 
		record->attr |=POINTER_BIT;
}

int get_substring_type(substr)
PTR_LLND substr;
{
	PTR_LLND pp,lp,rp;
	int	 is_constant = 1;
	
	lp=substr->entry.Template.ll_ptr1;
	rp=substr->entry.Template.ll_ptr2;                /*  DDOT   */
	
			/*	do it in check_if_substring() */
	check_leaf_sym(lp);
	if (is_constant && (lp->attr & PARAMETER_BIT) ==0 )
		is_constant=0;

	if (rp) {
		checkDDOT(rp,145);    
		if (is_constant && (rp->attr & PARAMETER_BIT) ==0)
			is_constant=0;
	}
			/* array section is allowed  Zheng Gengbin 1996.5.24 */
	/* if (!isString(lp)) error1(120); */

	if (rp->entry.Template.ll_ptr2) warn1(121);

	lp=rp->entry.Template.ll_ptr1;			/*    RANGE_OP   */
	pp=lp;
	lp=pp->entry.Template.ll_ptr1;
	rp=pp->entry.Template.ll_ptr2;
	if (lp) {
		check_expr_type(lp);
		if (is_constant && (lp->attr & PARAMETER_BIT) ==0)
				is_constant=0;
		if (!isInteger(lp)) error1(122);
	}
	if (rp) {
		check_expr_type(rp);
		if (is_constant && (rp->attr & PARAMETER_BIT) ==0)
				is_constant=0;
		if (!isInteger(rp)) error1(122);
	}

					/* modified by zheng.gb 4.5 1996 */
			/* array section of no character is allowed here ! */
	if (substr->entry.Template.ll_ptr1->type->variant == T_ARRAY) 
	{
/*                             Zheng Gengbin 1996.5.24 
		if (substr->entry.Template.ll_ptr1->type->
					entry.ar_decl.num_dimensions !=1){
			error1(125);
		}
*/
	}
	else                /* must be substring */
	{
		if (!isString(substr->entry.Template.ll_ptr1))
			error1(120);
	}
	substr->type=substr->entry.Template.ll_ptr1->type;
	if (is_constant) substr->attr |= PARAMETER_BIT;
}

int check_if_substring(substr)
PTR_LLND substr;
{
	PTR_LLND lp,rp,expr_list;

	lp=substr->entry.Template.ll_ptr1;
	check_leaf_sym(lp);
	rp=substr->entry.Template.ll_ptr2;		/*  DDOT  */

	if (isString(lp))  return;
							/*  record section */
	if (lp->variant == RECORD_REF) {
		if (lp->type->variant == T_ARRAY) {
			if (lp->type->entry.ar_decl.num_dimensions!=1)
			{
			/* 	error1(118);	 ??? zheng.gb 1996.5.20 */
			}
			else if(!isString(lp))
			       error3(128,lp->entry.Template.ll_ptr1->entry.
				Template.ll_ptr1->entry.Template.symbol->ident);
		}
	/*	else error(118);*/	/* ??? */
		return;
	}
					/*    convert tree to fit */
	substr->variant = ARRAY_REF ;
                                             /* modified  1996.5.7 */
	if (substr->entry.Template.ll_ptr1->variant == ARRAY_REF )
	{
		expr_list=makeLlnd(fi,EXPR_LIST,rp, LLNULL,SMNULL);
        	lp=substr->entry.Template.ll_ptr1->entry.Template.ll_ptr1;
		for (;lp->entry.Template.ll_ptr2;lp=lp->entry.Template.ll_ptr2);
		lp->entry.Template.ll_ptr2=expr_list;
		if (debug1) printf("is Substring id:%d\n",expr_list->id);
		substr->entry.Template.ll_ptr1=substr->entry.Template.ll_ptr1->
					entry.Template.ll_ptr1;
	}
	else {                    /* VAR_REF */
		expr_list=makeLlnd(fi,EXPR_LIST,rp, LLNULL,SMNULL);
		substr->entry.Template.ll_ptr1=expr_list;
        	substr->entry.Template.symbol=lp->entry.Template.symbol;
	}
	substr->entry.Template.ll_ptr2=LLNULL;

}

int checkIMPDO(llnd)
PTR_LLND llnd;
{
	PTR_LLND expr_list,objects,ranges,ele;
	PTR_SYMB sym;
	PTR_BFND it_scope;
	int	 i;
	int	 is_constant = 1,g_state_save;

	sym = search_symb_ref(llnd->entry.implied_do.symbol);
	if (sym!=llnd->entry.implied_do.symbol)
                {
/* make symbol nosense ! */
                        llnd->entry.implied_do.symbol->scope=BFNULL;
                        llnd->entry.implied_do.symbol=sym;
	}
	if (sym->type == TYNULL) check_sym_type(sym);
/*	use_I_N_rule(sym);  */

	objects=llnd->entry.implied_do.objects;
	ranges=llnd->entry.implied_do.range_stride;

	if (sym->attr & PARAMETER_BIT) error1(130);

	if (sym->type->variant == T_ARRAY) 
		error3(129,sym->ident);
	else if (g_state == IO_IMPDO)
	     {
		if (!isIntegerType(sym->type) && !isFloatType(sym->type) &&
		    !isDoubleType(sym->type) )
			error3(129,sym->ident);
             }
	     else if (!isIntegerType(sym->type)) 
		        error3(129,sym->ident);

	for (i=0;i<=top_implied_do;i++)
		if (implied_do_table[i]==sym) error1(131);
	implied_do_table[++top_implied_do]=sym;

	sym->decl=HARD;
	it_scope = sym->scope;
	sym->scope=cur_bfnd;
	add_scope_level(cur_bfnd,0);			/* for search symbol */
	
					/* check array constructure value */
	for (expr_list=objects;expr_list;expr_list=expr_list->
							entry.Template.ll_ptr2)
	{
		ele=expr_list->entry.Template.ll_ptr1;
		switch (ele->variant) {
		case IMPLIED_DO:
			checkIMPDO(ele);
			if (is_constant && (ele->attr & PARAMETER_BIT) ==0)
				is_constant=0;
			break;
		default:
			{
			/* donot change the g_state */
			g_state_save=g_state;  g_state=0;
			check_expr_type(ele);
			g_state=g_state_save;
			}
			if (is_constant && (ele->attr & PARAMETER_BIT )==0)
			{
				/* check if is do-var */
				if ( ele->variant == VAR_REF) {
					sym=ele->entry.Template.symbol;
					for (i=0;i<=top_implied_do;i++)
                				if (implied_do_table[i]==sym) 
							break;
					if (i==top_implied_do+1) is_constant=0;
				}
				else 
					is_constant=0;
			}
			if (ele->type->variant == T_ARRAY) 
			  if (ele->type->entry.ar_decl.num_dimensions !=1)
				error1(141);

			if (implied_do_type==TYNULL)
                                implied_do_type=ele->type;
                        else {
                             if (ele->type->variant == T_ARRAY)
			     {
                               if (!is_same_type(implied_do_type,ele->
                                        type->entry.ar_decl.base_type))
                                        error1(132);
			     }
                             else
                               if (!is_same_type(implied_do_type,ele->type))
                                        error1(132);
                        } /* else */
			break;
		}
	}		/* for */

					/* check imply do variable's range */
	checkDDOT(ranges,229);
	if ( (ranges->attr & PARAMETER_BIT)==0 )
		is_constant=0;
/*
	for (expr_list=ranges;expr_list;expr_list=expr_list->
                                                        entry.Template.ll_ptr2)
	{
		ele=expr_list->entry.Template.ll_ptr1;
		check_expr_type(ele);
		if (is_constant && (ele->attr & PARAMETER_BIT) ==0)
			is_constant=0;
		if (!isInteger(ele)) error1(229);
	}
*/

	delete_beyond_scope_level(0);
	sym->scope = it_scope;
	if (is_constant) llnd->attr |= PARAMETER_BIT;
	
}

int get_array_constructor_type(array)
PTR_LLND array;
{
	PTR_LLND expr_list,element;
	PTR_TYPE newtype=NULL;
	int      dim,rank=0,n,count;
	int	 is_constant = 1,g_state_save;

	n=get_array_rank(array);
	top_implied_do=-1;
	implied_do_type=NULL;
/* HIT */
	for (expr_list=array->entry.Template.ll_ptr2;
	     expr_list; expr_list=expr_list->entry.Template.ll_ptr2) 
	{
		element=expr_list->entry.Template.ll_ptr1;
		switch (element->variant) {
		case IMPLIED_DO:
			checkIMPDO(element);
			if (is_constant && (element->attr & PARAMETER_BIT) ==0)
				is_constant=0;
			break;
		default:
			{
			/* prevent it change the g_state  1996/9/23 zheng.gb*/
			g_state_save=g_state;
			g_state=0;
			check_expr_type(element);
			g_state=g_state_save;
			}
			if (is_constant && (element->attr & PARAMETER_BIT) ==0)
				is_constant=0;
			if (element->type->variant == T_ARRAY) 
			  if (element->type->entry.ar_decl.num_dimensions !=1)
			       error1(141);

			if (implied_do_type==TYNULL)
				implied_do_type=element->type;
			else {
			     if (element->type->variant == T_ARRAY)
			     {
			       if (!is_same_type(implied_do_type,element->
					type->entry.ar_decl.base_type))
					error1(132);
			     }
			     else
			       if (!is_same_type(implied_do_type,element->type))
					error1(132);
			} /* else */
			break;
		}		/* switch */

	}	/* for */
	
	newtype=make_type(fi,T_ARRAY);
	newtype->entry.ar_decl.base_type=implied_do_type;
	newtype->entry.ar_decl.num_dimensions = 1;
	array->type=newtype;
	array->attr |= DIMENSION_BIT;

	if (is_constant) array->attr |= PARAMETER_BIT;

}



int use_I_N_rule(sym)
PTR_SYMB sym;
{
	if (implicit_table[26][top_implicit_level]==NULL) return 0;
		/* if no type , then set type */
	if (sym->type && sym->type->variant == T_ARRAY)
		sym->type->entry.ar_decl.base_type = implicit_table[
				tolower(sym->ident[0])-'a'][top_implicit_level];
	else
	sym->type=implicit_table[tolower(sym->ident[0])-'a'][top_implicit_level];
	return 1;
}

/*  1: ok.   0: no  */
int check_sym_type(sym)
PTR_SYMB sym;
{
	if (sym->decl == HARD) return 1;
			/* zheng.gb 1996.6.4 */
	if (sym->scope!=cur_scope()) return 1;
	if (use_I_N_rule(sym)==0) {
		error3(111,sym->ident);
		return 0;
	}
	return 1;
}



int check_type_ref(llnd)
PTR_LLND llnd;
{
	switch (llnd->variant) {
	case SUB_STRING:
		get_substring_type(llnd);
		break;
	case ARRAY_REF:
		get_array_type(llnd);
		break;
	case RECORD_REF:
		get_record_type(llnd);
		break;
	case VAR_REF:
		break;
	default:
		printf("Abornal llnd in line:%d.\n",cur_bfnd->g_line);
	}  /* switch */
}



