/*****************************************************************************
        Semantic check about the execution statements

written by  Zheng Gengbin
        Peking University , P.R.C
*****************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if defined(STDC_HEADERS) && (STDC_HEADERS==1)
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>

#include <stdlib.h>

#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"
#include "tags.h"
#include "decl.h"

#include "exglobal.h"


/****************************************************************************
				ASSIGN_STAT
****************************************************************************/
/*
static int type_compatiable(ltype,rtype)
PTR_TYPE ltype,rtype;
{
	int      lrank=0,rrank=0;
	int       l_kind ,r_kind;
	PTR_TYPE  l_type=ltype,r_type=rtype;

	if (l_type == TYNULL) return ;

	l_kind=get_kind(l_type);
        r_kind=get_kind(r_type);

	if (l_type->variant == T_ARRAY)
        {
                lrank = l_type->entry.ar_decl.num_dimensions;
                l_type = l_type->entry.ar_decl.base_type;
        }
	if (l_type->variant == T_KIND)
                l_type = l_type->entry.kind_decl.base_type;

        if (r_type->variant == T_ARRAY)
        {
                rrank = r_type->entry.ar_decl.num_dimensions;
                r_type = r_type->entry.ar_decl.base_type;
        }
	if (r_type->variant == T_KIND)
                r_type = r_type->entry.kind_decl.base_type;

        if (rrank && lrank && rrank !=lrank) error1(113);
        if (lrank==0 && rrank >0) error1(123);

	switch (l_type->variant) {
        case T_INT:
        case T_FLOAT:
        case T_COMPLEX:
	case T_DCOMPLEX:
	case T_DOUBLE:
                switch (r_type->variant) {
                case T_INT:
                case T_FLOAT:
                case T_COMPLEX:
		case T_DCOMPLEX:
		case T_DOUBLE:
                        break;
                default:
                        error1(148);
                }
                break;
        case T_CHAR:
        case T_STRING:
                if (r_type->variant != T_STRING) error1(148);
                break;
        case T_BOOL:
                if (r_type->variant != T_BOOL) error1(148);
                break;
        case T_RECORD:
                if (l_type != r_type) error1(148);
                break;
        default:
                error2(100,l_type->variant);
        }
}
*/
 

/* ?????? if l_sym is a record  is a null point ?????? */
static int check_type_compatiable(l_sym,l_type,l_attr,r_value,kind)
PTR_SYMB l_sym;
PTR_TYPE l_type;
int	 l_attr;
PTR_LLND r_value;
int	 kind;                   /* 1 :report error ; 0: not */
{
	PTR_LLND expr_list;
	PTR_TYPE r_type;
	int      lrank=0,rrank=0;
	int       l_kind ,r_kind;
	int	  err_code;



	err_code=0;
	if (l_attr & PARAMETER_BIT )  
		if (g_state & INITIALIZATION_EXPR_ASSIGN);
		else if (kind) error1(114);
		     else err_code= 114;

	switch (l_sym->variant) {
	case PROCEDURE_NAME:
	case PROGRAM_NAME:
	case MODULE_NAME:
	case STRUCT_NAME:
	case INTERFACE_NAME:
	case TYPE_NAME:
		if (kind) error3(134,l_sym->ident);
		else err_code=134;
	}	/* switch */

	if (is_assumed_size_spec(l_sym))
        	if (kind) error3(186,l_sym->ident);
		else err_code =186;
        check_expr_type(r_value);
	r_type= r_value->type;

	/* by pass the checking if global default */
	if (r_type==global_default) {
		return 0;
	}

	if (l_type == TYNULL) return err_code;

/* get kind value */
	l_kind=get_kind(l_type);
        r_kind=get_kind(r_type);
	
	if (l_attr & IN_BIT) 
		if (kind) error3(140,l_sym->ident);
		else err_code = 140;

	if (l_type->variant == T_ARRAY)
	{
		lrank = l_type->entry.ar_decl.num_dimensions; 
		l_type = l_type->entry.ar_decl.base_type;
	}
	if (l_type->variant == T_KIND)
                l_type = l_type->entry.kind_decl.base_type;

	if (r_type->variant == T_ARRAY)
	{
		rrank = r_type->entry.ar_decl.num_dimensions; 
		r_type = r_type->entry.ar_decl.base_type;
	}
	if (r_type->variant == T_KIND)
                r_type = r_type->entry.kind_decl.base_type;

	if (rrank && lrank && rrank !=lrank) 
		if (kind) error1(113);
		else err_code=113;
	if (lrank==0 && rrank >0) 
		if (kind) error1(123);
		else err_code=123;

	switch (l_type->variant) {
	case T_INT:
	case T_FLOAT:
	case T_DOUBLE:
	case T_COMPLEX:
	case T_DCOMPLEX:
		switch (r_type->variant) {
		case T_INT:
		case T_FLOAT:
		case T_DOUBLE:
		case T_COMPLEX:
		case T_DCOMPLEX:
			break;
		default:
			err_code=(g_state&INITIALIZATION_EXPR_ASSIGN ?249:148);
			if (kind) error1(err_code);
		}
		break;
	case T_CHAR:
	case T_STRING:
		if (r_type->variant != T_STRING) 
		{
			err_code=(g_state&INITIALIZATION_EXPR_ASSIGN ?249:148);
			if (kind) error1(err_code);
		}
		break;
	case T_BOOL:
		if (r_type->variant != T_BOOL) 
		{
			err_code=(g_state&INITIALIZATION_EXPR_ASSIGN ?249:148);
			if (kind) error1(err_code);
		}
		break;
	case T_RECORD:
		if (l_type != r_type) 
		{
			err_code=(g_state&INITIALIZATION_EXPR_ASSIGN ?249:148);
			if (kind) error1(err_code);
		}
		break;
	default:
		if (kind) error2(235,l_type->variant);
		else err_code=235;
	}

	return err_code;
}

/*
	only be called by  get_type_structure_type 
	in checktype.c
*/
int check_sym_assign_compatiable(l_sym,ltype,r_value,num)
PTR_SYMB l_sym;
PTR_TYPE ltype;
PTR_LLND r_value;
int      num;
{
	int err_code;

	/* modified by zheng.gb 96.4.26 ,l_sym is field name ,no need to check*/
/*	check_sym_type(l_sym);  */

	err_code=check_type_compatiable(l_sym,ltype,l_sym->attr,r_value,0);
	if (err_code == 0) return;
	else error2(241,num);
}

int check_assign_compatiable(l_var,r_value)
PTR_LLND l_var,r_value;
{
	PTR_SYMB l_sym;

/*   F(F is function name) = expr  */
	if (!is_linking) {
		g_state=IS_VARIABLE;
		check_leaf_sym(l_var);
		g_state=0;
	}
	
	l_sym=get_var_name(l_var);

	if (l_sym==SMNULL)
	{
		if (l_var->variant == FUNC_CALL)
			error1(261);
		return;
	}

	/* check if sym is a do loop variable */
	check_do_variable(cur_bfnd,l_sym);

	check_type_compatiable(l_sym, l_var->type,l_var->attr,r_value,1);
}

int check_initialization_assign_compatiable(l_sym,r_value)
PTR_SYMB  l_sym;
PTR_LLND  r_value;
{
	g_state = INITIALIZATION_EXPR_ASSIGN;
	check_type_compatiable(l_sym,l_sym->type,l_sym->attr,r_value,1);
	g_state = 0;
}

int check_assign_stmt()
{
	PTR_LLND ll_head,l_var,r_value;
	PTR_SYMB intrin_ass,sym;
	int	 status,err;

	l_var  =cur_bfnd->entry.Template.ll_ptr1;
	r_value=cur_bfnd->entry.Template.ll_ptr2;

        intrin_ass=is_defined_op("=");
        if (intrin_ass){
		ll_head=makeLlnd(fi,EXPR_LIST,l_var,r_value,intrin_ass);
        	status=check_defined_intrinsic_op(ll_head,intrin_ass,
							PROCEDURE_NAME);
        	if (status==0) {
                               /* in where stetament , cannot be defined
                                  assignment */
			if (cur_bfnd->control_parent->variant==WHERE_BLOCK_STMT
			     ||  cur_bfnd->control_parent->variant==WHERE_NODE)
                        	error1(243);
			return;
		}
	}

	check_assign_compatiable(l_var,r_value);
	if ( !is_linking )
	{
	   if (err=pure_var_llnd(l_var)) 
		if (err==2) 
			error1(207);
		else {
			sym=get_var_name(l_var);
			error3(234,sym->ident);
		}
	}
}
	

int check_pointer_assign_stmt()
{
	PTR_LLND l_var,r_value,expr_list,ele;

	l_var=cur_bfnd->entry.Template.ll_ptr1;
	r_value=cur_bfnd->entry.Template.ll_ptr2;

	check_assign_compatiable(l_var,r_value);
	if (pure_var_llnd(l_var)!=0) error1(209);
	if (r_value->variant == VAR_REF)
		if (pure_var_llnd(r_value)!=0) error1(209);

	if (r_value->variant==ARRAY_REF) 
		for (expr_list=r_value->entry.Template.ll_ptr1; expr_list ;
			expr_list=expr_list->entry.Template.ll_ptr2) {
			ele=expr_list->entry.Template.ll_ptr1;
			if (!is_scalar(ele->type))
				error1(255);
		}

	if ((l_var->attr & POINTER_BIT)==0 ) error1(135);
	if ((r_value->attr & TARGET_BIT)==0  &&
		(r_value->attr & POINTER_BIT) ==0 ) error1(136);
	/* if (r_value->type != l_var->type) error1(137); */
	if (!is_same_type(l_var->type,r_value->type)) error1(137);
}


int check_stmt_function()
{
        PTR_SYMB sym;

	if (cur_bfnd->variant != ASSIGN_STAT ) return;
        if (cur_bfnd->entry.Template.ll_ptr1->variant== ARRAY_REF) {
                sym=search_symb_ref(cur_bfnd->entry.Template.ll_ptr1->
					entry.Template.symbol);
/*				1996 . 4.26 zheng.gb
                if (sym->type->variant != T_ARRAY && sym == cur_bfnd->
				entry.Template.ll_ptr1->entry.Template.symbol)
*/
                if (sym->type->variant != T_ARRAY && sym->scope == cur_bfnd->
				control_parent)
                {
			cur_bfnd->variant = STMTFN_STAT;
                        return;
                }
        }
}

/*****************************************************************************
			Label
******************************************************************************/


static int get_label_depth_from(blob_head,stat,level)
PTR_BLOB blob_head;
PTR_BFND stat;
int level;
{
	PTR_BLOB blob;
	int	 result;
	
	for (blob=blob_head;blob;blob=blob->next) 
	{
		if (blob->ref==stat) return level+1;
		if (blob->ref->entry.Template.bl_ptr1) {
			result=get_label_depth_from(blob->ref->
					entry.Template.bl_ptr1,stat,level+1);
			if (result !=-1) return result;
		}
		if (blob->ref->variant == LOGIF_NODE &&
			blob->ref->entry.Template.bl_ptr2) 
		{
			result=get_label_depth_from(blob->ref->
					entry.Template.bl_ptr2,stat,level+1);
			if (result !=-1) return result;
		}
	}
	return -1;

}

/*  -1 if not seen */
int get_label_depth(stat)
PTR_BFND stat;
{
	PTR_BFND scope;

	scope=cur_scope();
	return get_label_depth_from(scope->entry.Template.bl_ptr1,stat,0);
}


int get_label_in_blob(blob_head,stat)
PTR_BLOB blob_head;
PTR_BFND stat;
{
	PTR_BLOB blob;

	if (blob_head==NULL) return 0;
	for (blob=blob_head; blob; blob=blob->next)
		if (blob->ref == stat) return 1;
	return 0;
}

static int label_is_visible(this_bfnd,stat)
PTR_BFND this_bfnd,stat;
{
	PTR_BFND curb,bfnd,current_scope;
	int      flag;

	current_scope=cur_scope();
	curb=this_bfnd;

	for(bfnd=this_bfnd->control_parent;bfnd!=current_scope->control_parent;
		bfnd=bfnd->control_parent)
	{
	  if (bfnd->variant == LOGIF_NODE) 
	  {
		if (bfnd_in_blob(curb,bfnd->entry.if_then_else.control_true))
			flag=1;
		else flag =2;	
	  }
	  else flag=1;

	  if (flag==1){
	  	if (get_label_in_blob(bfnd->entry.Template.bl_ptr1,stat))
			return 1;
	  }
	  else if (get_label_in_blob(bfnd->entry.Template.bl_ptr2,stat))
                        return 1;

	  curb=bfnd;
	}			/* for */
	return 0;
}


/*   for others call to check label's goto  
		0:   suceed
		1:   label not exist 
		2:   illegal jump
		3:   illegal jump into a do construct
*/
int check_goto_stmt(this_bfnd,that_bfnd)
PTR_BFND this_bfnd,that_bfnd;
{
	PTR_BFND bfnd;

	if (that_bfnd == BFNULL) return 1;
	/* endif */
	if (that_bfnd->variant == CONTROL_END &&
                that_bfnd->control_parent->variant == LOGIF_NODE &&
                that_bfnd->control_parent->control_parent ==
                        this_bfnd->control_parent )
                return 0;
	/* enddo stmt */
	if (is_in_do_construct(that_bfnd)) {
		bfnd = this_bfnd;
		while (bfnd->control_parent) {
			if (bfnd->control_parent == that_bfnd->control_parent)
			return 0;
			bfnd = bfnd->control_parent;
		}
		return 3;
	}
	if (!label_is_visible(this_bfnd,that_bfnd)) return 2;
	else return 0;
}

int goto_stmt()
{
	int thisdepth,gotodepth;
	PTR_BFND stat;
	PTR_LABEL tolabel;
	PTR_BLOB  blob;
	int	  n1=0,n2=0,status;

	thisdepth=get_label_depth(cur_bfnd,0);

	tolabel=cur_bfnd->entry.goto_stmt.target_label->
						entry.label_list.lab_ptr;
	tolabel->labused=1;		/* is used */

	if (tolabel->statbody == BFNULL) {
		error2(142,tolabel->stateno);
		return;
	}
/*
	gotodepth=get_label_depth(tolabel->statbody);
	if (thisdepth < gotodepth) error1(139);
*/
/*
	if (thisdepth == gotodepth &&
		cur_bfnd->control_parent->variant == LOGIF_NODE ) {
		for (blob =cur_bfnd->control_parent->
					entry.if_then_else.control_true;
 			blob; blob=blob->next) 
		{
			if (cur_bfnd == blob->ref) n1=1;
			if (tolabel->statbody == blob->ref) n2=1;
		}
		for (blob=cur_bfnd->control_parent->
					entry.if_then_else.control_false;
 			blob; blob=blob->next) 
		{
			if (cur_bfnd == blob->ref) n1=2;
			if (tolabel->statbody == blob->ref) n2=2;
		}
		if ((n1==1 && n2==2) || (n1==2 && n2==1)) {
			error1(175);
			return;
		}
	}
*/

	status=check_goto_stmt(cur_bfnd,tolabel->statbody);
	switch (status) {
	case 1: error2(142,tolabel->stateno);
		break;
	case 2: error1(176);
		break;
	case 3: error2(254,tolabel->stateno);
		break;
	}
}


int comput_goto_stmt()
{
	PTR_LLND   expr,label_list,ele;
	PTR_LABEL  label;
	int 	   status;

	label_list= cur_bfnd->entry.Template.ll_ptr1;
	expr= cur_bfnd->entry.Template.ll_ptr2;

	check_expr_type(expr);

	if (!is_scalar(expr->type)) error1(178);
	else if (!isIntegerType(expr->type)) error1(179); 

	for ( ; label_list ; label_list=label_list->entry.Template.ll_ptr2)
	{
/* HIT */
		ele=label_list->entry.Template.ll_ptr1;
		label=ele->entry.label_list.lab_ptr;
		label->labused =1;

		status=check_goto_stmt(cur_bfnd,label->statbody);
		if (status == 2) error2(180,label->stateno);
		else if(status == 1) error2(142,label->stateno);
	}
}

int assign_to_stmt()
{
	PTR_LABEL label;
	PTR_LLND  var;
	

	/*  modified according to the modification of HIT */
/*
	label=cur_bfnd->entry.Template.ll_ptr1->entry.label_list.lab_ptr;
	var=cur_bfnd->entry.Template.ll_ptr2;
*/
	label=cur_bfnd->entry.Template.ll_ptr2->entry.label_list.lab_ptr;
	var=cur_bfnd->entry.Template.ll_ptr1;
	check_leaf_sym(var);
	if (var->attr & PARAMETER_BIT) error1(181);
	if (var->attr & DIMENSION_BIT) error1(182);
	else if (!isInteger(var)) error3(183,var->entry.Template.symbol->ident);
	if (pure_var_llnd(var)!=0) error1(221);

	if (label->statbody == BFNULL) error2(142,label->stateno);
        label->labused =1;
}

int assign_goto_stmt()
{
	PTR_SYMB var;
	PTR_LLND   label_list,ele;
	PTR_LABEL  label;
	int 	   status;

	label_list= cur_bfnd->entry.Template.ll_ptr1;
	var=cur_bfnd->entry.Template.symbol;
	if (var->attr & PARAMETER_BIT) error1(181);
        if (var->attr & DIMENSION_BIT) error1(182);
        else if (var->type->variant != T_INT ) error3(183,var->ident);

	for ( ; label_list ; label_list=label_list->entry.Template.ll_ptr2)
        {
/* HIT */
		ele = label_list->entry.Template.ll_ptr1;
                label=ele->entry.label_list.lab_ptr;
                label->labused =1;

                status=check_goto_stmt(cur_bfnd,label->statbody);
                if (status == 2) error2(180,label->stateno);
                else if(status == 1) error2(142,label->stateno);
        }
}

int arithmetic_if_stmt()
{
	PTR_LLND   expr,label_list;
	PTR_LABEL  label;
	int 	   status;

	expr=cur_bfnd->entry.Template.ll_ptr1;
	label_list=cur_bfnd->entry.Template.ll_ptr2;

	check_expr_type(expr);
	if (expr->type->variant == T_ARRAY) error1(184);
	else if (!isInteger(expr) && !isFloat(expr) &&
			!isDouble(expr) ) error1(185);

	for (;label_list;label_list=label_list->entry.Template.ll_ptr2)
	{
		label=label_list->entry.Template.ll_ptr1->
						entry.label_list.lab_ptr;
                label->labused =1;

                status=check_goto_stmt(cur_bfnd,label->statbody);
                if (status == 2) error2(180,label->stateno);
                else if(status == 1) error2(142,label->stateno);
	}
}

int exit_stmt()
{
	PTR_SYMB do_construct_name,sym;
	PTR_BFND bfnd;

	do_construct_name=cur_bfnd->entry.Template.symbol;
	bfnd= cur_bfnd->control_parent;
	while (bfnd) {
		if (bfnd->variant == FOR_NODE ) {
			     /* no do_construct_name , then it's ok.  */
			if (do_construct_name == SMNULL) break;
			     /* this FOR_NODE has no do_construct_name , next */
			if (bfnd->entry.do_stmt.construct_name == LLNULL) {
				bfnd=bfnd->control_parent;
				continue;
			}
			     /* make sure symbol do has a ident */
			if (bfnd->entry.do_stmt.construct_name->entry.Template.
				symbol == SMNULL) {
				bfnd=bfnd->control_parent;
				continue;
			}
			if (!strcasecmp(bfnd->entry.do_stmt.construct_name->
			 entry.Template.symbol->ident,do_construct_name->ident))
			break;
		}
		bfnd=bfnd->control_parent;
	}
	if (!bfnd) {
		if (cur_bfnd->variant == EXIT_STMT) {
			if (do_construct_name) 
				error3(157,do_construct_name->ident);
			else	error1(156); 
		}
		if (cur_bfnd->variant == CYCLE_STMT) {
			if (do_construct_name) 
				error3(155,do_construct_name->ident);
			else	error1(154); 
		}
	}
}

int check_stop_code(llnd)
PTR_LLND llnd;
{
	if (llnd == LLNULL) return;
	switch (llnd->variant) {
	case VAR_REF:
		if (!check_initialization_expr(llnd))
			error1(177);
		else {
			if (!isString(llnd)) error1(220);
			if (!is_scalar(llnd->type)) error1(219);
		}
		break;
	}
}

int stop_stmt()
{
	if (is_in_pure()) error1(210);
	check_stop_code(cur_bfnd->entry.stop.stop_code);
}

int pause_stmt()
{
	if (is_in_pure()) error1(211);
	check_stop_code(cur_bfnd->entry.stop.stop_code);
}

int stmt_label()
{
	if (cur_bfnd->label)
		cur_bfnd->label->labdefined=1;
}

int illegal_stmt_label()
{
	if (cur_bfnd->label && cur_bfnd->variant != FORMAT_STAT )
		error1(174);
}

int check_scope_labels()
{
	PTR_LABEL label;
	PTR_BFND  scope,tmp;

	scope=cur_scope();
	for (label=fi->head_lab; label; label=label->next )
	  if (label->scope == scope) {
		if (label->labused == 0 && label->labdefined ==1) {
			tmp=cur_bfnd;
			cur_bfnd=label->statbody;
			warn2(143,label->stateno);
			cur_bfnd=tmp;
		}
	  }
}

/***************************************************************************
			if_construct
			   &
			if_stmt
*****************************************************************************/


static int check_a_block(blob_head)
PTR_BLOB blob_head;
{
	PTR_BLOB blob;

	for (blob=blob_head ; blob; blob=blob->next){
		cur_bfnd=blob->ref;
		if (cur_bfnd->variant == CONTROL_END) return;
		if (! block()) error2(11,cur_bfnd->variant);
	}
}

int if_construct()
{
	if_stmt_test(0,NULL);
}

int if_stmt_test(level,construct_name)
int level;
PTR_SYMB  construct_name;
{
	PTR_BLOB true_b,false_b;
	PTR_LLND expr;
	int	 mode;
	PTR_BFND bf1,bf2,bf3;
	PTR_SYMB if_construct_name=construct_name;
	
	if (level ==0 ) if_construct_name=NULL;

	true_b=cur_bfnd->entry.Template.bl_ptr1;
	false_b=cur_bfnd->entry.Template.bl_ptr2;

	expr=cur_bfnd->entry.if_stmt.condition;
	check_expr_type(expr);

	if (!is_scalar(expr->type)) error1(144);
	else if (!isBool(expr)) error1(144);

	mode=0;
	if (false_b)
		if(false_b->ref->variant == ELSEIF_NODE ) mode=2;
		else mode=1;

/*
	mode 0:
			LOGIF
				...
			CONTROL_END
	     1:
			LOGIF
				...
			CONTROL_END
				...
			
			CONTROL_END
	     2:
			LOGIF
				...
			ELSEIF_NODE	----
					   +  ...
					   +  CONTROL_END
*/
	switch (mode) {
	case 0:			/*  if then endif */
		bf1=cur_bfnd;
		check_a_block(true_b);
		bf2=cur_bfnd;
		if (bf1->entry.Template.symbol) 
				if_construct_name=bf1->entry.Template.symbol;
		if (bf2->entry.Template.symbol !=if_construct_name)
				error1(146);
		cur_bfnd=cur_bfnd->thread;	/* first control end */
		break;
	case 1:			/*  if then else endif */
		bf1=cur_bfnd;
		if (bf1->entry.Template.symbol)  
				if_construct_name=bf1->entry.Template.symbol;
		check_a_block(true_b);
		bf2=cur_bfnd;
		cur_bfnd=cur_bfnd->thread;
		check_a_block(false_b);
		bf3=cur_bfnd;
		if (bf3->entry.Template.symbol !=if_construct_name)
				error1(146);
		if (bf2->entry.Template.symbol )
			if (!if_construct_name)
				error3(147,bf2->entry.Template.symbol->ident);
			else if (bf2->entry.Template.symbol !=if_construct_name)
				error1(146);
		cur_bfnd=cur_bfnd->thread;   /* first control_end */
		break;
	case 2:
		bf1=cur_bfnd;
		if (bf1->entry.Template.symbol)  
				if_construct_name=bf1->entry.Template.symbol;
                check_a_block(true_b);
                bf2=cur_bfnd;
		if (bf2->entry.Template.symbol )
			if (!if_construct_name)
				error3(147,bf2->entry.Template.symbol->ident);
			else if (bf2->entry.Template.symbol !=if_construct_name)
				error1(146);
                cur_bfnd=cur_bfnd->thread;
		if_stmt_test(level+1,if_construct_name);
/*
		bf3=cur_bfnd;
		if (bf3->entry.Template.symbol !=if_construct_name)
				error1(146);
*/
		break;	
	}
/*
	if (level == 0 && cur_bfnd->thread->variant == CONTROL_END ) 
			cur_bfnd = cur_bfnd->thread;
*/
}

int if_stmt()
{
	PTR_BLOB true_b;
	PTR_LLND expr;
	int	 mode;
	PTR_BFND stmt;
	

	true_b=cur_bfnd->entry.Template.bl_ptr1;

	expr=cur_bfnd->entry.if_stmt.condition;
	check_expr_type(expr);

	if (!is_scalar(expr->type)) error1(144);
	else if (!isBool(expr)) error1(144);

	cur_bfnd = stmt = true_b->ref;

	if (!action_stmt()) {
		cur_bfnd = cur_bfnd->thread;
		error1(218);
	}
	else 
		switch (stmt->variant)
		{
		case LOGIF_STMT:
			error1(217);
			break;
		}

}

/*****************************************************************************
			    FOR_NODE
******************************************************************************/

int check_loopcontrol(llnd)
PTR_LLND llnd;
{
        PTR_LLND lp,rp;

	if (!llnd) return;
        lp=llnd->entry.Template.ll_ptr1;                /* range_op */
        rp=llnd->entry.Template.ll_ptr2;                /* stride */

        if (rp) {
                check_expr_type(rp);
/*
                if (rp->type->variant != T_INT &&
			rp->type->variant != T_FLOAT &&
			rp->type->variant != T_DOUBLE	) 
*/
		if (!isInteger(rp) && !isFloat(rp) && !isDouble(rp) )
		error1(165);
        }
        rp=lp->entry.Template.ll_ptr2;                          /* upper */
        lp=lp->entry.Template.ll_ptr1;                          /* lower */
        if (lp) {
                check_expr_type(lp);
/*
                if (lp->type->variant != T_INT &&
			lp->type->variant != T_FLOAT &&
			lp->type->variant != T_DOUBLE	) 
*/
		if (!isInteger(lp) && !isFloat(lp) && !isDouble(lp) )
		error1(166);
        }
        if (rp) {
                check_expr_type(rp);
/*
                if (rp->type->variant != T_INT &&
			rp->type->variant != T_FLOAT &&
			rp->type->variant != T_DOUBLE	) 
*/
		if (!isInteger(rp) && !isFloat(rp) && !isDouble(rp) )
		error1(166);
        }
}


/*    label do   or  nonolabel do */
int do_block(blob_head)
PTR_BLOB blob_head;
{
	PTR_BLOB blob;

	cur_bfnd=blob_head->ref;
		/* loop until the last statement :enddo , continue , do_term */
	for (blob=blob_head ; blob->next->next; blob=blob->next){
		cur_bfnd=blob->ref;
		if (! block()) error1(167);
	}
}

/* no use now */
int enddo_stmt()
{
	PTR_SYMB  do_construct_name,sym;

	do_construct_name=cur_bfnd->control_parent->
			entry.do_stmt.construct_name->entry.Template.symbol;
	sym = cur_bfnd->entry.Template.symbol;

	if (do_construct_name && !sym) 
		error3(172,do_construct_name->ident);
}

int do_stmt()
{
	PTR_SYMB  do_var;
	PTR_LABEL do_label;
	PTR_SYMB  do_construct_name=SMNULL;
        PTR_BLOB  blob;
	int 	  flag;

	do_var=cur_bfnd->entry.do_stmt.control_var;
	do_label=cur_bfnd->entry.do_stmt.do_label;
	if (do_label) {
		do_label->labused=1;
	}

	if (cur_bfnd->entry.do_stmt.construct_name)
		do_construct_name=cur_bfnd->entry.do_stmt.construct_name->
			entry.Template.symbol;

	if (do_var){
		if (do_var->type->variant == T_ARRAY) error1(163);
		else if (!isIntegerType(do_var->type) &&
			 do_var->type != global_float &&
			 do_var->type != global_double )
			error1(164);
		if (pure_var_sym(do_var)!=0) error1(208);
	}

	check_loopcontrol(cur_bfnd->entry.do_stmt.range);

	blob = cur_bfnd->entry.do_stmt.control;
	do_block(blob);

	if (do_label)	{
		flag = is_shared_stmt(cur_bfnd);
		if (flag) {
			if (!is_do_term_shared_stmt(cur_bfnd)) {
				error1(201);
				cur_bfnd = cur_bfnd->thread;   /* control_end */
				return;
			}
		}
	}

		/* deal with the last statement */
	switch (cur_bfnd->variant ) {
	case ENDDO_STMT:
		if (cur_bfnd->label)
			cur_bfnd->label->labdefined=1;
		if (do_construct_name) {
			if (do_construct_name != cur_bfnd->
					entry.Template.symbol)
			error3(172,do_construct_name->ident);
		}
		if (do_label) {
			if (!cur_bfnd->label) error1(168);
			if (cur_bfnd->label !=do_label) error1(169);
		}
		break;
	case CONTINUE_NODE:
		if( do_construct_name) error1(173);
		if (do_label) {
			if (!cur_bfnd->label) error1(170);
			if (cur_bfnd->label !=do_label) error1(169);
		}
		else error1(171);
		break;
	case FOR_NODE:
	case DO_WHILE_NODE:
		block();
		return;
	default:
		if (!is_do_term_action_stmt(cur_bfnd)) {
			error1(202);
			cur_bfnd=cur_bfnd->thread;
		}
		else 
			if (! block()) error1(167);
		return;
	}
/*
	for (; blob->next ; blob=blob->next);
	cur_bfnd = blob->ref;
*/
	cur_bfnd=cur_bfnd->thread;
}

int do_while_stmt()
{
        PTR_LABEL do_label;
        PTR_SYMB  do_construct_name=SMNULL;
	PTR_BLOB  blob;
	int	  flag;

        do_label=cur_bfnd->entry.do_while.do_label;
        if (do_label) {
                do_label->labused=1;
        }
	if (cur_bfnd->entry.do_while.construct_name)
                do_construct_name=cur_bfnd->entry.do_while.construct_name->
                        entry.Template.symbol;
	check_expr_type(cur_bfnd->entry.do_while.conditional);
	if (!isBool(cur_bfnd->entry.do_while.conditional))
		error1(200);
	else if (!is_scalar(cur_bfnd->entry.do_while.conditional))
		error1(200);

	blob = cur_bfnd->entry.do_stmt.control;
        do_block(blob);

	if (do_label)   {
                flag = is_shared_stmt(cur_bfnd);
                if (flag) {
                        if (!is_do_term_shared_stmt(cur_bfnd)) {
                                error1(201);
                                cur_bfnd = cur_bfnd->thread;
                                return;
                        }
                }
        }

        switch (cur_bfnd->variant ) {
        case ENDDO_STMT:
		if (cur_bfnd->label)
			cur_bfnd->label->labdefined=1;
                if (do_construct_name) {
                        if (do_construct_name != cur_bfnd->
                                        entry.Template.symbol)
                        error3(172,do_construct_name->ident);
                }
                if (do_label) {
                        if (!cur_bfnd->label) error1(168);
                        if (cur_bfnd->label !=do_label) error1(169);
                }
                break;
        case CONTINUE_NODE:
                if( do_construct_name) error1(173);
                if (do_label) {
                        if (!cur_bfnd->label) error1(170);
                        if (cur_bfnd->label !=do_label) error1(169);
                }
                else error1(171);
                break;
	case FOR_NODE:
	case DO_WHILE_NODE:
		block();
		return;
	default:
		if (!is_do_term_action_stmt(cur_bfnd)) {
			error1(202);
			cur_bfnd=cur_bfnd->thread;
		}
		else 
			if (! block()) error1(167);
		return;
        }

	cur_bfnd=cur_bfnd->thread;
}

int is_do_term_action_stmt(bfnd)
PTR_BFND bfnd;
{
	switch (bfnd->variant) {
        case GOTO_NODE:
        case RETURN_STAT:
        case STOP_STAT:
        case EXIT_STMT:
        case CYCLE_STMT:
        case ARITHIF_NODE:
        case ASSGOTO_NODE:
                return 0;
        }
	return 1;
}

int is_do_term_shared_stmt(bfnd)
PTR_BFND bfnd;
{
	switch (bfnd->variant) {
	case GOTO_NODE:
	case RETURN_STAT:
	case STOP_STAT:
	case EXIT_STMT:
	case CYCLE_STMT:
	case ARITHIF_NODE:
	case ASSGOTO_NODE:
		return 0;
	}
	return 1;
}

/*   check  to the outest bfnd control_end */
int is_shared_stmt(bfnd)
PTR_BFND bfnd;
{
	PTR_BFND bf,last;
	PTR_LABEL label;
	int 	  num=0;

	label=bfnd->label;
	bf = bfnd->thread;
	last=BFNULL;

	while (bf->control_parent->entry.Template.lbl_ptr == label &&
		(bf->control_parent->variant == FOR_NODE ||
		 bf->control_parent->variant == DO_WHILE_NODE ) )
	{
		last=bf;
		bf=bf->thread;
		num++;
	}
	return num>1? 1:0;
}


int check_do_variable(bfnd,sym)
PTR_BFND bfnd;
PTR_SYMB sym;
{
	PTR_BFND scope;
	PTR_SYMB do_var;

	if (!sym) return;

        scope = bfnd->control_parent;
        while (!is_main_header(scope)) {
                if (scope->variant == FOR_NODE)
                {
                        do_var=scope->entry.do_stmt.control_var;
                        if (do_var && strcasecmp(sym->ident,do_var->ident)==0)
                                error3(253,sym->ident);
                }
                scope = scope->control_parent;
        }
}

/****************************************************************************
			   WHERE_NODE
		           WHERE_STMT
****************************************************************************/
int where_assignment(blob)
PTR_BLOB  blob;
{
	while (blob ) {
		cur_bfnd=blob->ref;
		switch (cur_bfnd->variant) {
		case ASSIGN_STAT:
			check_assign_stmt();
			break;
		case CONTROL_END:
			return;
		default:
			error1(162);
		}
		blob=blob->next;
	}
}

int where_block_stmt()
{
	PTR_BLOB true_b, false_b;
	PTR_LLND expr;

	true_b =cur_bfnd->entry.where_block.control_true;
	false_b=cur_bfnd->entry.where_block.control_false;
	
	expr=cur_bfnd->entry.where_block.condition;
	check_expr_type(expr);
	if (expr->type->variant != T_ARRAY ) error1(160);
	else 
	  if (!isBoolType(expr->type->entry.ar_decl.base_type)) error1(161);
/*
	  if (expr->type->entry.ar_decl.base_type->variant!=T_BOOL) error1(161);
*/

	if (true_b)  where_assignment(true_b);
	if (false_b) {
		where_assignment(false_b);
		cur_bfnd=cur_bfnd->thread;
	}
}

int where_stmt()
{
	PTR_BLOB blob;
	PTR_LLND expr;

	expr=cur_bfnd->entry.where_block.condition;
	check_expr_type(expr);
	if (expr->type->variant != T_ARRAY ) error1(160);
	else 
	  if (!isBoolType(expr->type->entry.ar_decl.base_type)) error1(161);

	blob=cur_bfnd->entry.where_stmt.control_true;
	cur_bfnd = blob->ref;
	check_assign_stmt();
	blob=blob->next;
	cur_bfnd = blob->ref;
}

/*****************************************************************************
			SWITCH NODE

			case_stmt
*****************************************************************************/

typedef struct ord_node {
	struct ord_node *right,*left;
	int		value ,attr;
} ORD_NODE;

typedef ORD_NODE *PTR_ORD;

typedef struct _stack {
	PTR_ORD  ele;
	struct _stack * next;
} STACK;

typedef STACK *PTR_STACK ;

PTR_STACK  stackp=NULL;

push(ptr)
PTR_ORD ptr;
{
	PTR_STACK p;

	p= (PTR_STACK) malloc(sizeof(STACK));
	p->ele=ptr;   
	if (stackp==NULL) {
		stackp=p;
		return;
	}
	p->next=stackp;
	stackp=p;
}

pop()
{
	stackp=stackp->next;
}

PTR_ORD top()
{
	return stackp->ele;
}


static PTR_ORD make_ord_node(value)
int value;
{
	PTR_ORD p;

	p=(PTR_ORD) malloc(sizeof(ORD_NODE));
	if (!p) return;
	p->right=p->left=NULL;
	p->value=value;
	p->attr=0;
	return p;
}

int case_stmt()
{
	PTR_BLOB blob;
	PTR_LLND expr;
	PTR_SYMB case_construct_name=cur_bfnd->entry.case_stmt.construct_name;
	PTR_ORD  head_node=NULL;
	int      default_ok=0;
	
	push(head_node);

	expr=cur_bfnd->entry.case_stmt.selector;
	check_expr_type(expr);
	if (expr->type->variant == T_ARRAY ) error1(144);
	else if (!isInteger(expr) && !isBool(expr) && !isString(expr))
	     {
	     error1(149);
	     expr->type=TYNULL;
	     }


	for (blob=cur_bfnd->entry.Template.bl_ptr1; blob && blob->ref->variant
		!= CONTROL_END ; blob=blob->next)
	{
		if (blob->ref->entry.case_option.construct_name &&
	        	blob->ref->entry.case_option.construct_name!=
			case_construct_name)
		   error3(151,blob->ref->entry.case_option.construct_name
				->ident);

		if (blob->ref->entry.case_option.case_option_expr_list->variant
							 == DEFAULT)
		/*if (!blob->ref->entry.case_option.case_option_expr_list) */
		{					/* DEFAULT */
			if (default_ok == 0)
				default_ok =1;
			else error1(158);
		}
		else 
			case_option(blob,expr->type,case_construct_name);
	}

	if (case_construct_name)
		if (!blob->ref->entry.Template.symbol ||
			blob->ref->entry.Template.symbol != case_construct_name)
			error3(199,case_construct_name->ident);

	free_nodes(top());
	pop();
/*
	if (cur_bfnd->entry.Template.symbol !=case_construct_name) 
		error(152);
*/
}

/* 	?????	default not check */
int case_option(blob,type)
PTR_BLOB blob;
PTR_TYPE type;
{
	PTR_LLND range_list,range,ele1,ele2;
	PTR_ORD  head_node;
	int 	 value;

	head_node=top();

	cur_bfnd=blob->ref;

	for (range_list=cur_bfnd->entry.case_option.case_option_expr_list;
		range_list;range_list=range_list->entry.Template.ll_ptr2)
	{
		if (range_list->entry.Template.ll_ptr1->variant == RANGE_OP)
		{
		  if (get_base_type(type) == global_bool ) {
			error1(159);
			continue;
		  }
		  range=range_list->entry.Template.ll_ptr1;
		  ele1=range->entry.Template.ll_ptr1;
		  ele2=range->entry.Template.ll_ptr2;
		  if (ele1) {
			  if (check_initialization_expr(ele1)) 
			  {
			    if (isIntegerType(type) && isInteger(ele1) ) 
			  	comput_const_expr(ele1,1);
			    if (type && !is_same_type(ele1->type,type))
				error1(150);
			  }
			  else error1(177);
		  }
		  if (ele2) {
			  if (check_initialization_expr(ele2)) 
			  {
			    if (isIntegerType(type) && isInteger(ele2) )
			  	comput_const_expr(ele2,1);
			    if (type && !is_same_type(ele2->type,type))
				error1(150);
			  }
			  else error1(177);
		  }
		 
		  if (ele1 && !isInteger(ele1) ) continue;
		  if (ele2 && !isInteger(ele2) ) continue;
		  if (isIntegerType(type) )
		     if ( (ele1 && (ele1->attr & PARAMETER_BIT) || !ele1) &&
		          (ele2 && (ele2->attr & PARAMETER_BIT) || !ele2 ) )
		      	   check_case_range(ele1?1:0,ele1?ele1->const_val:0,
					    ele2?1:0,ele2?ele2->const_val:0);
		}      /* if RANGE_OP */
		else  {
		  range=range_list->entry.Template.ll_ptr1;
		  if (check_initialization_expr(range)) 
		  {
		    if (type && isIntegerType(type) && isInteger(range)) {
		    comput_const_expr(range,1);
		    value=range->const_val;
		    check_case_range(1,value,1,value);
		    }
		    if (type && !is_same_type(range->type,type) ) error1(150);
		  }
		  else error1(177);
		}
	}

	check_a_block(cur_bfnd->entry.case_option.control);
	
	cur_bfnd=cur_bfnd->thread;
}


int check_case_range(hasl,l,hasr,r)
int hasl,l,hasr,r;
{
	PTR_ORD lptr=NULL,rptr=NULL,head_node;
	
	head_node=top();

	if (!hasl && !hasr) return;
	if (l==r) {
		lptr=rptr=make_ord_node(l); 
		goto next;
	}

	if (hasl) lptr=make_ord_node(l);
	if (hasr) rptr=make_ord_node(r);

	if (lptr && rptr) {
		lptr->attr=1;
		rptr->attr=-1;
	}
	if (lptr && !rptr) lptr->attr=1;
	if (!lptr && rptr) rptr->attr=-1;

next:	if (lptr) if (!insert_node(lptr)) return;
	if (rptr && rptr!=lptr ) if (!insert_node(rptr)) return ;

	if (lptr==rptr) {					
		if (lptr->right && lptr->right->attr == -1) {
			error1(153);
			return;
		}
		if (lptr->left && lptr->left->attr == 1) {
			error1(153);
			return;
		}
		return;
	}

	if (lptr && rptr )
		if ( lptr->right != rptr && lptr!=rptr) {
			error1(153);
			return;
		}

	if (lptr && lptr->left ) 
		if (lptr->attr==lptr->left->attr && lptr->attr !=0 ) {
			error1(153);
			return;
		}
	if (lptr && lptr->right && !rptr) {
		error1(153);
		return;
	}
	if (rptr && rptr->right) 
		if (rptr->attr==rptr->right->attr && rptr->attr !=0 ) {
			error1(153);
			return;
		}
	if (rptr && rptr->left && !lptr) {
		error1(153);
		return;
	}
}

int insert_node(ptr)
PTR_ORD ptr;
{
	PTR_ORD p,last,head_node;
	
	head_node=top();

	if (head_node == NULL) {
		pop();
		push(ptr);
		return 1;
	}

	if (ptr->value < (head_node)->value) {
		ptr->right=head_node;
		(head_node)->left=ptr;
		pop();
		push(ptr);
		return 1;
	}
	last=head_node;
	for (p=head_node ; p; p=p->right) {
		if (ptr->value == p->value) {
			error1(153);
			return 0;
		}
		if (ptr->value < p->value) {
			last=p->left;
			break;
		}
		last=p;
	}
	p=last->right;
	last->right = ptr;
	ptr->right=p;
	ptr->left=last;
	if (p) p->left=ptr;
	return 1;
}


int free_nodes(ptr)
PTR_ORD ptr;
{
	PTR_ORD p;
	for (p=ptr; p;p=ptr) {
		ptr=p->right;
		free(p);
	}
}


/******************************************************************************
		
			ALLOCATE STMT

******************************************************************************/

int allocate_stmt()
{
	PTR_SYMB sym;
	PTR_LLND var,expr_list,ele;
	int      rank,err;
	
	var=cur_bfnd->entry.Template.ll_ptr2;
	expr_list=cur_bfnd->entry.Template.ll_ptr1;

	/* check err variable */
	if (var) {
		check_leaf_sym(var);
		if (pure_var_llnd(var)!=0) error3(215,var->entry.Template.symbol
				->ident);
	}
	
	/* check allocate objects */
	for (;expr_list;expr_list=expr_list->entry.Template.ll_ptr2)
	{
		ele=expr_list->entry.Template.ll_ptr1;
		check_leaf_sym(ele);
		if (!(ele->attr & POINTER_BIT) && 
				!(ele->attr & ALLOCATABLE_BIT))
		{
			error1(190);
		}
		switch (ele->variant) {
		case RECORD_REF:
			sym = get_record_name(ele);
			break;
		case ARRAY_REF:
			sym = ele->entry.Template.symbol;
			break;
		}
		if (err=pure_var_sym(sym)) 
			if (err==1)
				error3(233,sym->ident);
			else
				error3(216,sym->ident);
	}
}

int deallocate_stmt()
{
        PTR_LLND var,expr_list,ele;

        var=cur_bfnd->entry.Template.ll_ptr2;
        expr_list=cur_bfnd->entry.Template.ll_ptr1;

	if (var) {
		check_leaf_sym(var);
		if (pure_var_llnd(var)!=0) error3(215,var->entry.Template.symbol
				->ident);
	}

        for (;expr_list;expr_list=expr_list->entry.Template.ll_ptr2)
        {
                ele=expr_list->entry.Template.ll_ptr1;
                check_leaf_sym(ele);
                if (!(ele->attr & POINTER_BIT) &&
                                !(ele->attr & ALLOCATABLE_BIT))
                {
                        error1(214);
                }
        }
}



int nullify_stmt()
{
	PTR_LLND expr_list,ele;

	expr_list=cur_bfnd->entry.Template.ll_ptr1;

	
	for (;expr_list;expr_list=expr_list->entry.Template.ll_ptr2)
	{
		ele=expr_list->entry.Template.ll_ptr1;
		check_leaf_sym(ele);
		if (!(ele->attr & POINTER_BIT))
		{
			error1(213);
		}
	}
}


/******************************************************************************
			FORALL statement
			FORALL construct
***************************************************************************/


int forall_stmt_header()
{
	PTR_LLND  exp , mask,control_list;
	PTR_LLND  ddot,var;
	int 	  no;

	exp = cur_bfnd->entry.forall_Stat.head_exp_list;
	mask = cur_bfnd->entry.forall_Stat.scalar_mask_expr;

	if (mask) {
		check_expr_type(mask);
		if (!isBool(mask)) error1(226);
		else if (!is_scalar(mask->type)) error1(227);
	}

	no=0;
	for (control_list=exp->entry.Template.ll_ptr1;
		control_list ; 
		control_list=control_list->entry.Template.ll_ptr2)
	{
		no++;
		ddot = control_list->entry.Template.ll_ptr1;
		var  = ddot->entry.Template.ll_ptr1;
		ddot = ddot->entry.Template.ll_ptr2;

		if (var){
			check_expr_type(var);
               		if (var->type->variant == T_ARRAY) error1(163);
               		else if (!isInteger(var))
                       		error3(228,var->entry.Template.symbol->ident);
               		if (pure_var_llnd(var)!=0) error1(208);
        	}
		if (ddot) checkDDOT(ddot,145);
	}
}

int forall_block(blob_head)
PTR_BLOB blob_head;
{
        PTR_BLOB blob;

        for (blob=blob_head ; blob; blob=blob->next){
                if (blob->next == NULL) return;
                cur_bfnd=blob->ref;
                if (! block()) error1(167);
        }
}


int forall_stmt()
{
	int scope_status_bak;

	scope_status_bak = scope_status;
	switch (scope_status) {
	case NON_PURE :      scope_status=FORALL_IN; break;
	case PURE_FUNC:      scope_status=FORALL_PURE_FUNC ; break;
	case PURE_PROC:      scope_status=FORALL_PURE_PROC ; break;
	}

	forall_stmt_header();
	cur_bfnd = cur_bfnd->thread;
	action_stmt();

	scope_status = scope_status_bak;

}


int forall_construct_stmt()
{
	int scope_status_bak;

	scope_status_bak = scope_status;
	switch (scope_status) {
	case NON_PURE :      scope_status=FORALL_IN; break;
	case PURE_FUNC:      scope_status=FORALL_PURE_FUNC ; break;
	case PURE_PROC:      scope_status=FORALL_PURE_PROC ; break;
	}

	forall_stmt_header();
	forall_block(cur_bfnd->entry.forall_Stat.control);

	scope_status = scope_status_bak;
}



