/*****************************************************************************
        Semantic check about the intrinsic subroutines

written by   Zheng Gengbin
          Peking University , P.R.C
*****************************************************************************/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>

#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"
#include "dep.h"
#include "dep_struct.h"
#include "tags.h"
#include "decl.h"

#include "exglobal.h"

extern debug1;
extern intrinc_flag;


PTR_FILE  v_file=NULL;		/* use to link intrinsic function symbol */

PTR_TYPE get_first_arg_type();

/**************************************************************************

			Intrinsic function & procedure

**************************************************************************/

int init_intrinsic_function()
{
	PTR_SYMB   sym;
	FILE *fid;
	char  HPFSRCINTR_LIB[100],HPFLIBINTR_LIB[100];

	if (intrinc_flag == 1) return ;
		/* if alread load , just adjust global type */
	if (v_file) goto jump;

/*   Configure change INTRINSIC Library to correct path */
	sprintf(HPFSRCINTR_LIB,"%s/src/hpfsc/libhpf.sl",SRCDIR);
	sprintf(HPFLIBINTR_LIB,"%s/libhpf.sl",LIBDIR);
	if ((fid=fopen(HPFSRCINTR_LIB, "r")) == NULL) {
          if ((fid=fopen(HPFLIBINTR_LIB, "r")) == NULL) {
                fprintf(stderr,"Cannot open Intrinsic libary .\n");
                exit(1);
          }
        }

        if ((v_file = (PTR_FILE) calloc(1, sizeof(struct file_obj))) == NULL) {
                fprintf(stderr, "main -- No more space\n");
                exit(1);
        }

	v_file->fid = fid;

        if (readNodes(v_file) >= 0) {
                v_file->global_bfnd->control_parent = NULL;
        }
						/* adjust global type */
jump:	for (sym = v_file->head_symb->thread ; sym; sym=sym->thread) {
		if (sym->type == TYNULL)  continue;
		switch (sym->type->variant) {
		case T_INT : 
			sym->type =global_int;
			break;
		case T_FLOAT : 
			sym->type =global_float;
			break;
		case T_DOUBLE : 
			sym->type =global_double;
			break;
		case T_COMPLEX : 
			sym->type =global_complex;
			break;
		case T_DCOMPLEX : 
			sym->type =global_dcomplex;
			break;
		case T_BOOL : 
			sym->type =global_bool;
			break;
		case T_STRING : 
			sym->type =global_string;
			break;
		}
	}
}


PTR_SYMB search_intrinsic_func(name)
char *name;
{
	PTR_SYMB sym;
	PTR_BFND module_head;

	module_head = v_file->global_bfnd->entry.Template.bl_ptr1->ref;
	sym=lookupSymb(name,v_file->head_symb);
	return sym;
}

int is_intrinsic_call(sym)
PTR_SYMB sym;
{
	if (sym == SMNULL) return 0;
	return search_intrinsic_func(sym->ident) ? 1:0;
}

int  check_intrinsic_func(llnd,kind)
PTR_LLND llnd;
int      kind;
{
	PTR_SYMB func_symb,dummy;
	PTR_LLND ele,arg;
	int      status,is_spec;

	func_symb=search_intrinsic_func(llnd->entry.Template.symbol->ident);
if (debug1) printf("SYMBOL:%s , Var:%d\n",func_symb->ident,func_symb->variant);
	if (func_symb == SMNULL) {
		if (debug1) printf("Intrinsic function :%s cannot found in intrinsic library .\n",llnd->entry.Template.symbol->ident);
		return 0;
	}

	llnd->entry.Template.symbol->variant=kind;

	in_intrinsic_call=1;      /* used in test_spec_expr_bit */
	status=call_or_func(fi,cur_bfnd,func_symb, llnd->entry.Template.ll_ptr1,
		kind==FUNCTION_NAME? -1 : -2, 1,&llnd->type);
	if (status != 0 && kind==FUNCTION_NAME )
		llnd->type=global_default;
	in_intrinsic_call=0;

	if (kind == FUNCTION_NAME)
	{
			/* flag in_type  indicate use the first arg's type */
		if (llnd->type->variant==T_RECORD)
			if ((strcasecmp(llnd->type->name->ident,"in_type") ==0) ) 
			{
				llnd->type = get_first_arg_type(cur_subname,
					llnd->entry.Template.ll_ptr1); 
			}
		else if ((strcasecmp(llnd->type->name->ident,"shape_type") ==0) ) 
		     {
				get_shape_type(cur_subname,llnd);
		     }
		get_special_type(llnd,cur_subname);
	}


	for ( arg=llnd->entry.Template.ll_ptr1;
		arg ; arg=arg->entry.Template.ll_ptr2) {
		ele= arg->entry.Template.ll_ptr1;
		/*  !!! do not consider specification expr yet */
		test_initialization_bit(ele);
	}


	if (strcasecmp(func_symb->ident,"ALLOCATED")==0)
		return;
	if (strcasecmp(func_symb->ident,"REPEAT")==0 ||
	    strcasecmp(func_symb->ident,"RESHAPE")==0 ||
	    strcasecmp(func_symb->ident,"SELECTED_INT_KIND")==0 ||
	    strcasecmp(func_symb->ident,"SELECTED_REAL_KIND")==0 ||
	    strcasecmp(func_symb->ident,"TRANSFER")==0 ||
	    strcasecmp(func_symb->ident,"TRIM")==0  )
	{
		if (g_state & NEED_INITIALIZATION_EXPR_BIT) 
		         llnd->attr |= PARAMETER_BIT;
	}
	if (g_state & NEED_INITIALIZATION_EXPR_BIT) 
	{
	        llnd->attr |= PARAMETER_BIT;
	}

}


int get_special_type(llnd,func)
PTR_LLND llnd;
PTR_SYMB func;
{
	PTR_LLND actual_list,actual_arg;

	actual_list = llnd->entry.Template.ll_ptr1;
	if (actual_list== LLNULL) return ;

	if ((strncasecmp(func->ident,"transpose",9) ==0) )
        {
        	get_transpose_type(func,llnd);
        }
}



int is_any_type(type)
PTR_TYPE type;
{
	PTR_TYPE basetype;
	basetype=get_base_type(type);
        if (basetype->variant == T_RECORD)
		if (!strcasecmp(basetype->name->ident,"any_type"))
			return 1;
	return 0;
}

int is_all_type(type)
PTR_TYPE type;
{
	PTR_TYPE basetype;
	basetype=get_base_type(type);
        if (basetype->variant == T_RECORD)
		if (!strcasecmp(basetype->name->ident,"all_type"))
			return 1;
	return 0;
}

PTR_TYPE get_first_arg_type(sub_name,actual_list)
PTR_SYMB sub_name;
PTR_LLND actual_list;
{
	PTR_SYMB first_dummy;
	PTR_LLND actual_arg,first_arg;
	char     *dummy_name;
	first_dummy=sub_name->entry.proc_decl.symb_list;
	if (first_dummy == SMNULL || actual_list== LLNULL )
		return TYNULL;
	dummy_name = first_dummy->ident;
	first_arg  = actual_list->entry.Template.ll_ptr1;
	for ( ; actual_list ; actual_list=actual_list->entry.Template.ll_ptr2)
	{
		actual_arg=actual_list->entry.Template.ll_ptr1;
		if (actual_arg->variant == KEYWORD_ARG)
			if (!strcasecmp(actual_arg->entry.keyword.keyword->entry.string_val,dummy_name))
			return actual_arg->entry.keyword.expr->type;
	}
	return first_arg->type;
}


/*  deal with function    reshape */
int get_shape_type(sub_name,llnd)
PTR_SYMB sub_name;
PTR_LLND llnd;
{
	PTR_LLND actual_list,actual_arg,find_arg=LLNULL,exp;
	PTR_TYPE first_args_type,newtype;
	char     *dummy_name;
	int      dim;

	actual_list=llnd->entry.Template.ll_ptr1;
	if (actual_list== LLNULL )
		return ;
		/* get first arg's type */
	first_args_type=get_first_arg_type(sub_name,actual_list);
	if (first_args_type==TYNULL) return;
		/* search arg of shape */
	dummy_name = "shape";
	for ( ; actual_list ; actual_list=actual_list->entry.Template.ll_ptr2)
	{
		actual_arg=actual_list->entry.Template.ll_ptr1;
		if (actual_arg->variant == KEYWORD_ARG)
			if (!strcasecmp(actual_arg->entry.keyword.keyword->entry.string_val,dummy_name))
			find_arg= actual_arg->entry.keyword.expr;
	}
		/* no keyword of shape found , then get 2_th arg */
	if (find_arg==LLNULL)
	{
		find_arg=llnd->entry.Template.ll_ptr1;            /* first */
		find_arg=find_arg->entry.Template.ll_ptr2;        /* second */
		if (find_arg==LLNULL) return ;
	}

		/* now get shape of find_arg */
	exp=find_arg->entry.Template.ll_ptr1;
/*
	if (!check_initialization_expr(exp))
	{
		error1(247);
		return;
	}
*/
	if (exp->variant == ARRAY_CONSTRUCTOR)
	{
		dim=get_array_rank(exp);
	}
	else if (exp->variant == VAR_REF || exp->variant == CONST_REF) {
		/*exp=exp->entry.Template.symbol->entry.Template.const_value;*/
		dim=0;
	     }
	else return;


	newtype=make_type(fi,T_ARRAY);
        newtype->entry.ar_decl.base_type=get_base_type(first_args_type);
        newtype->entry.ar_decl.num_dimensions = dim;
        llnd->type=newtype;
        llnd->attr |= DIMENSION_BIT;
}



/*  deal with function    transpose */
int get_transpose_type(sub_name,llnd)
PTR_SYMB sub_name;
PTR_LLND llnd;
{
	PTR_LLND actual_list;
	PTR_TYPE first_args_type,newtype;
	PTR_LLND expr1,expr2,dim1,dim2;

	actual_list=llnd->entry.Template.ll_ptr1;
	if (actual_list== LLNULL )
		return ;

	first_args_type=get_first_arg_type(sub_name,actual_list);
        if (first_args_type==TYNULL) return;
	if (first_args_type->entry.ar_decl.num_dimensions!=2) return;
	if (first_args_type->entry.ar_decl.ranges == LLNULL) return ;

	dim1=first_args_type->entry.ar_decl.ranges->entry.Template.ll_ptr1;
	dim2=first_args_type->entry.ar_decl.ranges->entry.Template.ll_ptr2->entry.Template.ll_ptr1;
	expr2 = makeLlnd(fi,EXPR_LIST,dim1,LLNULL,SMNULL);
	expr1 = makeLlnd(fi,EXPR_LIST,dim2,expr2,SMNULL);
	newtype=make_type(fi,T_ARRAY);
        newtype->entry.ar_decl.base_type=get_base_type(first_args_type);
        newtype->entry.ar_decl.num_dimensions = 2;
        newtype->entry.ar_decl.ranges = expr1;
        llnd->type=newtype;
        llnd->attr |= DIMENSION_BIT;
}





