/*******************************************************************/
/*	         " make specification "				   */
/*       In this file I will perform special actions on 	   */
/*       each statment of specification_stmt part.		   */
/*                  	   Lxy.  				   */
/*******************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include "tags.h"
#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"
#include "defnodes.h"
#include "extern.h"
#include "makenodes.h"
#include "decl.h"

extern int combinedFlag_g ;			/* add by zheng.gb */

PTR_BFND
makeProgram(fi,symb_ptr)
PTR_SYMB symb_ptr;
PTR_FILE fi;
{
   PTR_BFND p;

   line_l[++lineIndex_l]=lineNum_l;
   lineNum_l = 1;

   p = makeBfnd(fi,PROG_HEDR);  /*  PROGRAM_STMT  */
 			/* in the symbol of program name it is needed */
   if(symb_ptr!=SMNULL)
      {
      symb_ptr->entry.prog_decl.prog_hedr=p;
      symb_ptr->entry.prog_decl.symb_list=NULL;
      }
   p->entry.prog_stmt.prog_symb=symb_ptr;

   setBlob(p,global_bfnd); 
   cur_blob = make_blob(fi,BFNULL, BLNULL);
   p->entry.prog_stmt.control=cur_blob;
   pred_bfnd=p;

   return(p);
}

PTR_BFND
makeEnd(fi)
PTR_FILE fi;
{
   PTR_BFND p;
   p = makeBfnd(fi,CONTROL_END);
   ++end_group;

   return(p);  
}

PTR_BFND
makeModule(fi,symb_ptr)
PTR_SYMB symb_ptr;
PTR_FILE fi;
{
   PTR_BFND p;

   line_l[++lineIndex_l]=lineNum_l;
   lineNum_l=1;

   p = makeBfnd(fi,MODULE_STMT);
   p->entry.module_stmt.module_symb=symb_ptr;

   setBlob(p,pred_bfnd);
   cur_blob = make_blob(fi,BFNULL, BLNULL);
   p->entry.module_stmt.control=cur_blob;
   pred_bfnd=p;
   
   return(p);
}

PTR_BFND
makeBlock(fi,symb_ptr)
PTR_SYMB symb_ptr;
PTR_FILE fi;
{
   PTR_BFND p;

   line_l[++lineIndex_l]=lineNum_l;
   lineNum_l=1;

   p = makeBfnd(fi,BLOCK_DATA);  
   p->entry.block_data.blockdata_symb=symb_ptr;

   setBlob(p,pred_bfnd);
   cur_blob = make_blob(fi,BFNULL, BLNULL);
   p->entry.block_data.control=cur_blob;
   pred_bfnd=p;

   return(p);
}

PTR_BFND
makeFunction(fi,symb_ptr,arg,result,prefix)
PTR_FILE fi;
PTR_SYMB symb_ptr,arg;
PTR_LLND result,prefix;
{
   PTR_BFND p;
   PTR_SYMB s;

   line_l[++lineIndex_l]=lineNum_l;
   lineNum_l=1;

   p = makeBfnd(fi,FUNC_HEDR);
   s=arg;
   while(s)
     {
       s->scope=p;
       s=s->id_list;
       }
   symb_ptr->entry.func_decl.func_hedr=p;
   symb_ptr->entry.func_decl.symb_list=arg;
   p->entry.func_stmt.func_symb=symb_ptr;
   if(result)
      result->entry.Template.symbol->scope = p;
   p->entry.func_stmt.ftype=result;

   p->entry.func_stmt.prefix=prefix;  
		/* it's dif.h is modified by Lxy (12/7/1995) */

   setBlob(p,pred_bfnd);
   cur_blob = make_blob(fi,BFNULL, BLNULL);
   p->entry.func_stmt.control=cur_blob;
   pred_bfnd=p;

   return(p);
}

PTR_BFND
makeSubroutine(fi,symb_ptr,arg,prefix)
PTR_FILE fi;
PTR_SYMB symb_ptr,arg;
PTR_LLND prefix;
{
   PTR_BFND p;
   PTR_SYMB s;

   line_l[++lineIndex_l]=lineNum_l;
   lineNum_l=1;

   p = makeBfnd(fi,PROC_HEDR);
   s=arg;
   while(s)
     {
       s->scope=p;
       s=s->id_list;
       }
   symb_ptr->entry.proc_decl.proc_hedr=p;
   symb_ptr->entry.proc_decl.symb_list=arg;
   p->entry.subroutine_stmt.proc_symb=symb_ptr;
   p->entry.subroutine_stmt.prefix=prefix;

   setBlob(p,pred_bfnd);
   cur_blob = make_blob(fi,BFNULL, BLNULL);
   p->entry.subroutine_stmt.control=cur_blob;
   pred_bfnd=p;

   return(p);
}

PTR_SYMB
makeSymbUnithead(fi,node_type,string)
PTR_FILE fi;
int node_type;
char *string;
{
   PTR_SYMB symb_ptr;
   /*
   symb_ptr = lookupSymbglobal(string);
   if((symb_ptr != SMNULL)&&(symb_ptr->scope == global_bfnd))
        err_g("Unit name redeclared",lineNum_g,string);
   */
   symb_ptr = make_symb(fi,node_type,string);
   symb_ptr->decl=HARD;
   symb_ptr->entry.prog_decl.label_list=LBNULL;
   return(symb_ptr);
}

/*------------------- 11.30 1995 -------------------------*/
/*
 * makeMain_l  is used as building a program unit
 * bf1:program_unit head_state
 * bf2:specification...  bf3:executable...
 * bf4:internal_subroutines or functions
 * bf5:end_statement
 */

PTR_BFND
makeMain_l(bf1,bf2,bf3,bf4,bf5)  
PTR_BFND bf1,bf2,bf3,bf4,bf5;
{
   PTR_BFND p;
   PTR_BLOB temp,tp;
   PTR_SYMB s;

	/* build a Program_head node if it does'n exsist*/
/*
   if (bf1==BFNULL)
     {
      s = makeSymbUnithead(fi,PROGRAM_NAME,"PROG_NAME");
      bf1= makeProgram(fi,s);
      }
*/  /* modified on 4/25 Lxy */

        /* connect the End_statement together */
   p = setBfndList(bf2,bf5);

	/* deal with the "internal_subroutine or function" , 
	   delete them from "bl_ptr1" and added them to "bl_ptr2" */
   if(bf4!=BFNULL)
      {
       p=bf4->control_parent;
       if((bf2==NULL)&&(bf3==NULL)) {
          bf1->entry.prog_stmt.format_group=p->entry.prog_stmt.control;
					/* add by zheng.gb */
		/* find CONTROL_END and set to control list end  */
	  for(temp=p->entry.prog_stmt.control;temp->ref!=bf5;temp=temp->next) ;
          bf1->entry.prog_stmt.control = temp;
		/* delete CONTROL_END of  contain list */
          for(tp=p->entry.prog_stmt.format_group;tp->next->ref!=bf5;tp=tp->next)		;
          tp->next=BLNULL;
       }
       else
       {
       for(temp=p->entry.prog_stmt.control;temp->next->ref!=bf4;temp=temp->next)
	  ;
       bf1->entry.prog_stmt.format_group=temp->next;
       for(tp=temp->next;tp->next->ref!=bf5;tp=tp->next)
	  ;
       temp->next=tp->next;
       tp->next=BLNULL;
       }
      }
   return(bf1);
}

/*------------ Specification statements --------------*/

/*
 * Implicit_stmt   (12/8/1995)
 */

PTR_BFND
makeImplicit(fi,node_type,ll1)
PTR_FILE fi;
int      node_type;
PTR_LLND ll1;
{
   PTR_BFND p;
   p = makeBfnd(fi,node_type);
   p->entry.implicit_decl.list=ll1;

   return(p);
}

/*
 * Set implicit type and length for each alphabetic chars in the range c1 - c2
 * it comes from "sage++/f2dep/init.c" .
 */

void
setimpl(type, c1, c2)
        PTR_TYPE type;
        int     c1, c2;
{
        register int i;
        char    buff[100];

        if (c1 == 0 || c2 == 0)
                return;

        if (c1 > c2) {
           printf("characters out of order in implicit:%c-%c\n", c1,c2);
        } else {
                for (i = c1; i <= c2; ++i) {
			if(c2>='a')
			   impltype[i - 'A' - 6 ] = type;
			else
                           impltype[i - 'A'] = type;   /*  modified by Lxy */
                }
        }
}

/*
 *  Entry_stmt   (12/12/1995)
 */

PTR_BFND
makeEntry(fi,symb_ptr,arg,result)
PTR_FILE fi;
PTR_LLND result;
PTR_SYMB symb_ptr,arg;
{
   PTR_BFND p;
   PTR_SYMB s;
   p = makeBfnd(fi,ENTRY_STAT);
   for(s=arg;s;s=s->id_list)
       s->scope=p;
   symb_ptr->entry.func_decl.symb_list=arg;
   p->entry.entry.entry_name=symb_ptr;
   if(result)
      result->entry.Template.symbol->scope = p;
   p->entry.entry.result=result;
   return(p);
}

/*
 *  Use_stmt   (12/12/1995)
 */

PTR_BFND
makeUse(fi,symb_ptr,ll1,ll2)
PTR_FILE fi;
PTR_LLND ll1,ll2;
PTR_SYMB symb_ptr;
{
   PTR_BFND p;
   p = makeBfnd(fi,USE_STMT);
   p->entry.use_stmt.module_symb=symb_ptr;
   p->entry.use_stmt.useonly_expr=ll1;
   p->entry.use_stmt.userename_expr=ll2;
   return(p);
}

PTR_SYMB
lookupSymbModule(string)
char *string;
{
   PTR_SYMB symb;
   do {
     symb = lookupSymbglobal(string);
   } while((symb!=SMNULL)&&(symb->variant != MODULE_NAME));
   
   if(symb==SMNULL)
      {
       err_g("Module must be pred_defined.",lineNum_g,string);
       exit(1);
	}
   return(symb);
}
          
PTR_SYMB
lookupSymbrename(string,symb)
char *string;
PTR_BFND symb;
{
   PTR_SYMB s;
   s = lookupSymb(string,symb);
   if(s == SMNULL)
      {
       err_g("Variable nondeclared in Module.",lineNum_g,string);
       }
   return(s);
}

/* 
 *  Interface   (12/11/1995)
 */

PTR_BFND
makeInterface(fi,symb_ptr)
PTR_FILE fi;
PTR_SYMB symb_ptr;
{
   PTR_BFND p;

   line_l[++lineIndex_l]=lineNum_l;
   lineNum_l=1;

   if(symb_ptr != SMNULL)
      {
       symb_ptr->variant=INTERFACE_NAME;
       symb_ptr->decl=HARD;
	}
   p = makeBfnd(fi,INTERFACE_STMT);
   p->entry.interface.interface_symb=symb_ptr;
   
   setBlob(p,pred_bfnd);  
   cur_blob = make_blob(fi,BFNULL, BLNULL);
   p->entry.interface.control=cur_blob;
   pred_bfnd=p;

   return(p);
}

/*
 *  Include    (12/10/1995)
 */

PTR_BFND
makeInclude(fi,symb_ptr)        
PTR_FILE fi;
PTR_SYMB symb_ptr;
{
   PTR_BFND p;
   p = makeBfnd(fi,INCLUDE_STAT);
   p->entry.include.symb=symb_ptr;

   return(p);
}

/* 
 *  common_stmt , namelist_stmt , equivelance_stmt   (12/13/1995)
 */

PTR_BFND
makeNest(fi,node_type,ll1)
PTR_FILE fi;
int      node_type;
PTR_LLND ll1;
{
   PTR_BFND p;
   p = makeBfnd(fi,node_type);
   p->entry.nest_decl.list=ll1;

   return(p);
}

/*
 * Intent_stmt    (12/10/1995)
 */

PTR_BFND
makeIntent(fi,ll1,ll2)
PTR_FILE fi;
PTR_LLND ll1,ll2;
{
   PTR_BFND p;
   p = makeBfnd(fi,INTENT_STMT);
/****** modified by Feng Xiaobing ******/

   p->entry.intent.list=ll2;
   p->entry.intent.attr_expr=ll1;

   return(p);
/*
   p = makeBfnd(fi,INTENT_STMT);
   p->entry.intent.list=ll1;
   p->entry.intent.attr_expr=ll2;

   return(p);
*/
}

/*
 * Contains_stmt , private_stmt, sequence_stmt   (12/11/1995)
 */
 
PTR_BFND
makeMiscell(fi,node_type)
PTR_FILE fi;
int      node_type;
{
   PTR_BFND p;
   p = makeBfnd(fi,node_type);
   return(p);
}

/*
 *  Module_procedure_stmt,Parameter_stmt,Save_stmt,dimension_stmt,
 *  External_stmt,intrinsic_stmt,public_stmt,private_stmt,
 *  Optional_stmt,allocatable_stmt,pointer_stmt,target_stmt,
 *  Data_stmt 		(12/13/1995)
 */
   
PTR_BFND
makeVarlistdecl(fi,node_type,ll1)
PTR_FILE fi;
int      node_type;
PTR_LLND ll1;
{
   PTR_BFND p;
   p = makeBfnd(fi,node_type);
   p->entry.var_list_decl.list=ll1;
   return(p);
}

/*
 *  Type_declaration_stmt        (12/15/1995)
 */

PTR_BFND
makeTypedecl(fi,ll1,ll2,ll3)
PTR_FILE fi;
PTR_LLND ll1,ll2,ll3;
{
   PTR_BFND p;
   p = makeBfnd(fi,VAR_DECL);
   p->entry.var_decl.entities=ll1;
   p->entry.var_decl.type=ll2;
   p->entry.var_decl.attributes=ll3;
   
   return(p);
}

PTR_LLND
makeTypespec_ll(fi,type,seletor)
PTR_FILE fi;
PTR_TYPE type;
PTR_LLND seletor;
{
   PTR_LLND p,l;
   PTR_TYPE atype;              /* add by zheng.gb */

   l=LLNULL;
   atype=type;					/* add by zheng.gb */
   if(seletor!=LLNULL)
      {
      atype=make_type(fi,T_KIND);               /* by zheng.gb */
      l=makeLlnd(fi,EXPR_LIST,seletor,LLNULL,SMNULL);
      atype->entry.kind_decl.kindexp=l;
      atype->entry.kind_decl.base_type=type;            /* by zheng.gb */
/*
      type->entry.kind_decl.kindexp=l;
*/
      }
   p = makeLlnd(fi,TYPE_OP,l,LLNULL,SMNULL);
   /*p->type=atype;*/				/* modified by zheng.gb */
   p->type=type;
   vartype=atype;				/* modified by zheng.gb */

   type_options=0;

   return(p);
}

                                                /* NEW ! add by zheng.gb */
PTR_TYPE
modify_type_len(type, len)
PTR_TYPE type;
PTR_LLND len;
{
        PTR_TYPE atype,base_type=type;
        PTR_LLND kindexp,lenexp,l;

        if (len == LLNULL) return type;

        if (type->variant == T_ARRAY)
                base_type=type->entry.ar_decl.base_type;

        if (base_type->variant != T_KIND)
        {
                atype=make_type(fi,T_KIND);
                l=makeLlnd(fi,EXPR_LIST,len,LLNULL,SMNULL);
                atype->entry.kind_decl.kindexp=l;
                atype->entry.kind_decl.base_type=base_type;
                if (type->variant == T_ARRAY) {
                        type->entry.ar_decl.base_type=atype;
                        return type;
                }
                else return atype;
        }
                                        /* now  already have a T_KIND */
        kindexp=base_type->entry.kind_decl.kindexp->entry.Template.ll_ptr1;
        for (;kindexp;kindexp=kindexp->entry.Template.ll_ptr2)
        {
                if (kindexp->variant == KIND_OP) break;
        }
	if (kindexp)  {
                kindexp=makeLlnd(fi,KIND_OP,kindexp->entry.Template.ll_ptr1,
                        len,SMNULL);
        }
        else kindexp=len;

        kindexp=makeLlnd(fi,EXPR_LIST,kindexp,LLNULL,SMNULL);

        atype=make_type(fi,T_KIND);
        atype->entry.kind_decl.base_type=base_type->entry.kind_decl.base_type;
        atype->entry.kind_decl.kindexp  =kindexp;

        if (type->variant == T_ARRAY) {
                type->entry.ar_decl.base_type=atype;
                return type;
        }
        else return atype;
}


PTR_TYPE
makeTypederivedref(fi,string)
PTR_FILE fi;
char *string;
{
	PTR_TYPE t;
        PTR_SYMB s;
        if(derivedTypeFlag_g == 1)
	    s = makeSymb(fi,cur_scope()->control_parent,TYPE_NAME,string,0);
        else
            s = makeSymb(fi,cur_scope(),TYPE_NAME,string,0);
        t = look_up_type(T_RECORD,s);
					/* modified by zheng.gb */
        if(t==NULL) {
		t = make_type(fi,DEFAULT);
        	t->name = s;
/*
             err_g("Type name is not defined.",lineNum_g, s->ident);
*/
	}
	return(t);
}

PTR_TYPE
makeTypeArray(array_spec,basetype)
PTR_LLND array_spec;
PTR_TYPE basetype;
{
   PTR_TYPE t;
   PTR_LLND temp;
   int i=1;
   if(array_spec == LLNULL)
      return(TYNULL);
   t = make_type(fi,T_ARRAY);
   t->entry.ar_decl.base_type=basetype;
   t->entry.ar_decl.ranges=array_spec;
   for(temp = array_spec; temp->entry.list.next; temp = temp->entry.list.next)
        i++;
   t->entry.ar_decl.num_dimensions=i;
   return(t);
}

PTR_LLND
makeEntity_ll(name,dim,leng,init)
PTR_SYMB name;
PTR_LLND dim,leng,init;
{
   PTR_LLND l;
   PTR_LLND p,q;
   PTR_TYPE vartype1;					/* add by zheng.gb */
   int type_opts;

   type_opts = type_options;

   vartype1=vartype;                                    /* add by zheng.gb */
   if (dim==LLNULL)
	l=makeLlnd(fi,VAR_REF,LLNULL,LLNULL,name);
   else
	{
        /*  p=makeLlnd(fi,EXPR_LIST,dim,LLNULL,SMNULL); */
	vartype1=makeTypeArray(dim,vartype);
        l=makeLlnd(fi,ARRAY_REF,dim,LLNULL,name);
        type_opts = type_opts | DIMENSION_BIT;
	}
   if(init!=LLNULL)
        { q=makeLlnd(fi,ASSGN_OP,l,init,SMNULL);
          l=q;
          }
   if(leng!=LLNULL)
	{
	q=makeLlnd(fi,EXPR_LIST,leng,LLNULL,SMNULL);
/* HIT */
	/*p=makeLlnd(fi,STAR_LIST,l,q,SMNULL);*/ /* Added by Zheng Qiang in order for the convenience for unparse*/
	p=makeLlnd(fi,EXPR_LIST,l,q,SMNULL); /* deleted by Zheng Qiang */
	l=p;
	                                              /* modified by zheng.gb */
/*
        make_type_node(vartype1,leng);
*/
	vartype1=modify_type_len(vartype1,leng);
	}  

						/* changed by zheng.gb */
   if (combinedFlag_g == 1)
	name->attr|=type_opts;
   else 
	name->attr=type_opts;

   /* name->type=vartype1; */
                               /* changed by zheng.gb */
   if (combinedFlag_g == 1)
        {
        if (vartype1) name->type=vartype1;
        }
   else name->type=vartype1;

   return(l);
}

/*
 *   Derived_type_define      (12/20/1995)
 */

PTR_BFND
makeDerived(fi,symb_ptr,ll1)
PTR_FILE fi;
PTR_SYMB symb_ptr;
PTR_LLND ll1;
{
   PTR_BFND p;
   PTR_TYPE t;

   derivedTypeFlag_g = 1;
   derived_l=0;

   symb_ptr->decl=HARD;
   
   t=make_type(fi,T_RECORD);
   t->name=symb_ptr;
   basename_l=symb_ptr;
   symb_ptr->type = t; /* added by Feng Xiaobing */

   p = makeBfnd(fi,STRUCT_DECL);
   p->entry.struct_decl.symbol=symb_ptr;
   p->entry.struct_decl.attribute=ll1;

   setBlob(p,pred_bfnd);
   cur_blob = make_blob(fi,BFNULL, BLNULL);
   p->entry.module_stmt.control=cur_blob;
   pred_bfnd=p;

   return(p);
} 

PTR_BFND
derivedDeal(bf1,bf2,bf3,bf4)
PTR_BFND bf1,bf2,bf3,bf4;
{
   PTR_BFND p;
   PTR_TYPE t;
   PTR_SYMB s;

   p = setBfndList(bf2,bf4);

   t = look_up_type(T_RECORD,bf1->entry.struct_decl.symbol);
   if(t==NULL)
       return(bf1);
   t->entry.re_decl.num_fields=derived_l;
   /* t->entry.re_decl.recordize=0;  ?? */

   s=bf3->entry.var_decl.entities->entry.list.item->entry.Template.symbol;
   t->entry.re_decl.first=s?s:bf3->entry.var_decl.entities->entry.list.item->entry.list.item->entry.Template.symbol;
   
   derivedTypeFlag_g = 0;
   return(bf1);
}

PTR_SYMB
makeSymbField(fi,string)
PTR_FILE fi;
char *string;
{
   PTR_SYMB symb_ptr;

   derived_l++;
   symb_ptr=makeSymb(fi,cur_scope(),FIELD_NAME,string,1);
   symb_ptr->entry.field.offset=derived_l-1;
   symb_ptr->entry.field.base_name= basename_l;
   /*  symb_ptr->entry.field.next=        ?? */
   symb_ptr->entry.field.tag=vartype->variant;
   return(symb_ptr);
}

PTR_SYMB
lookupSymbField(string,symb)
char *string;
PTR_BFND symb;
{
   PTR_SYMB s;
   s = lookupSymb(string,symb);
   if(s == SMNULL)
      {
       err_g("Variable nondeclared in Derived_type.",lineNum_g,string);
       }
   return(s);
}

/* 
 *     Constant   (12/16/1995)
 */
PTR_SYMB
makeSymbConst(fi,string)
PTR_FILE fi;
char *string;
{
   PTR_SYMB symb_ptr;
   symb_ptr = makeSymb(fi,cur_scope(),CONST_NAME,string,0);
   symb_ptr->variant=CONST_NAME;/* add by zheng.gb */

   symb_ptr->decl=HARD;
   symb_ptr->entry.const_value=LLNULL;
   return(symb_ptr);
}

/*
 *    Operator  
 */

struct operand
{
     int opval;
     char *opname;
} oplist [] = {
        {ADD_OP, "+"},
        {MINUS_OP, "-"},
        {MULT_OP, "*"},
        {EXP_OP, "**"},
        {DIV_OP, "/"},
        {CONCAT_OP, "//"},
        {AND_OP, ".and."},
        {OR_OP, ".or."},
        {XOR_OP, ".xor."},
        {NOT_OP, ".not."},
        {EQ_OP, ".eq."},
        {NOTEQL_OP, ".ne."},
	{LT_OP, ".lt."},
        {GT_OP, ".gt."},
	{LTEQL_OP, ".le."},
        {GTEQL_OP, ".ge."},
        {NEQV_OP, ".neqv."},
        {EQV_OP, ".eqv."},
        {0, 0}
};

/*    "look_up_op" is in "sage++/f2dep/sym.c"    */

PTR_SYMB
lookupOp(operator)
int operator;
{
     struct operand *p;

     for (p = oplist; p->opname; p++)
          if (p->opval == operator)
               return (makeSymb(fi,cur_scope(),LOCAL,p->opname,1));
     err_g("unknown operator ",lineNum_g, operator);
}

/*   "set_expr_type" is in sage++/f2dep/types.c   */
/*
 * set_expr_type sets the type of an expression and
 *    performs other semantic checks
 */

void
set_expr_type(expr)
        PTR_LLND expr;
{
	switch (expr->variant) {
            case (VAR_REF):
                expr->type = expr->entry.var_ref.symbol->type;
                /*  if (expr->type == global_default)
                        err(" Identifier not declared");   */
                break;
            case (ARRAY_REF):   /* check to see if symbol is array ?? */
                expr->type = expr->entry.array_ref.symbol->type;
                break;
            case (RECORD_REF):
                expr->type = expr->entry.record_ref.rec_field->type ;
                break;

	    default :
		break;
	 }
}

/*
 *   "endlineNum()" : set the relative linenum "lineNum_l"  (12/21/1995)
 */

void
endlineNum()
{
   lineNum_l=line_l[lineIndex_l]+lineNum_l-1;
   lineIndex_l--;

   implicitNone_g=0;
}

/*
 * install_param_list gets an proc id and a parameter list
 * and sets them up as parameters
 *  it comes from "sage++/f2dep/types.c"
 */

void
install_param_list(id, id_list, result_clause, func)
PTR_SYMB id, id_list;
int func;
PTR_LLND result_clause;
{
        int     num_input = 0;
        register PTR_SYMB temp, last, result_sym_ptr;

        temp = id_list;
        while (temp) {
                temp->variant = VARIABLE_NAME;
                temp->entry.var_decl.next_in = temp->id_list;
                temp->entry.var_decl.local = IO;
                ++num_input;
                last = temp;
                temp = last->id_list;
                /* last->id_list = SMNULL; */ /* Lxy. 1/6 */
        }
        id->entry.proc_decl.in_list = id_list;
        id->entry.proc_decl.num_io = 0;
        id->entry.proc_decl.num_input = num_input;
        id->entry.proc_decl.num_output = (func == FUNCTION_NAME);
        if (result_clause)
        {
             result_sym_ptr = result_clause->entry.Template.symbol;
             id->entry.Template.declared_name = result_sym_ptr;
             result_sym_ptr->type = id->type;
        }
}


