/****************************************************************
 *								*
 *	 Structure of the dep files generated by parsers	*
 *								*
 ****************************************************************/

#include <sys/types.h>

struct _preamble {		/* structure of preamble of dep file */
        u_short ptrsize;        /* bit length of pointers (32 or 64) phb */
	u_short language;	/* source language type */
	u_short num_llnds;	/* number of low level nodes */
	u_short num_symbs;	/* number of symbol nodes */
	u_short num_types;	/* number of type nodes */
	u_short global_bfnd;	/* id of the global bif node */
};


struct _locs {
	long llnd;		/* offset of llnd in the dep file */
	long symb;		/* 	     symbol nodes	  */
	long type;		/*	     type nodes		  */
	long strs;		/*	     string tables	  */
};


/*     modified by zheng.gb   */
struct _ll_nd {
	u_short id;
	u_short variant;
	int type;
	int         attr;   /*    add by zheng.gb to indicate intermediate
 expression has been computed !*/
        int         const_val;    /*    add by zheng.gb to  hold intermediate ex
pression */
};




struct _sym_nd {
	u_short id;
	u_short variant;
	int type;
	int     attr;
	int next;
	int scope;
	int ident;
};


struct _typ_nd {
	u_short id;
	u_short variant;
	int name;
};



