/*************************************************************************

		Multi.c -- Separate compilation

written by Zheng Gengbin
*************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>

#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"
#include "defnodes.h"
#include "dep.h"
#include "dep_struct.h"
#include "tags.h"
#include "decl.h"

#include "exglobal.h"


/***************************************************************************
		gen_mod_name()
		gen_dep_name()
		gen_log_name()

		gen_src_name()
***************************************************************************/

char *gen_mod_name(mod_name)
char *mod_name;
{
	char *outname;

	if (!mod_name )
     		return NULL;

	outname = (char *) malloc((unsigned)(strlen(mod_name)+5));
	outname[0]='\0';

	strcpy (outname,mod_name);
	strcat(outname,".mod");
	return outname;
}


char *gen_dep_name(fname)
char *fname;
{
        char *outname,*q,*r;
	int 	i,flag=0;

        if (!fname )
                return NULL;

        outname = (char *) malloc((unsigned)(strlen(fname)+5));
        outname[0]='\0';

        strcpy (outname,fname);
	for (i = strlen(fname)-1 ; i >= 0 ; i --)
   	{
        if ( fname[i] == '.' )
         {
           q = &(outname[i+1]);
	   flag=1;
           break;
         }
        }
	if(flag==1)
     {
      r = q;
      *r++ = 'd';
      *r++ = 'e';
      *r++ = 'p';
      *r++ = '\0';
      }
        return outname;
}

char *gen_log_name(fname)
char *fname;
{
        char *outname,*q,*r;
	int 	i,flag=0;

        if (!fname )
                return NULL;

        outname = (char *) malloc((unsigned)(strlen(fname)+5));
        outname[0]='\0';

        strcpy (outname,fname);
	for (i = strlen(fname)-1 ; i >= 0 ; i --)
   	{
        if ( fname[i] == '.' )
         {
           q = &(outname[i+1]);
	   flag=1;
           break;
         }
        }
	if(flag==1)
     {
      r = q;
      *r++ = 'l';
      *r++ = 'o';
      *r++ = 'g';
      *r++ = '\0';
      }
        return outname;
}

char *gen_src_name(fname)
char *fname;
{
        char *outname,*q,*r;
	int 	i,flag=0;

        if (!fname )
                return NULL;

        outname = (char *) malloc((unsigned)(strlen(fname)+5));
        outname[0]='\0';

        strcpy (outname,fname);
	for (i = strlen(fname)-1 ; i >= 0 ; i --)
   	{
        if ( fname[i] == '.' )
         {
           q = &(outname[i+1]);
	   flag=1;
           break;
         }
        }
	if(flag==1)
     {
      r = q;
      *r++ = 'f';
      *r++ = '\0';
      }
	else
		strcat(outname,".f");
        return outname;
}

int change_file_name(file,fname)
PTR_FILE file;
char *fname;
{
	char *srcname=gen_src_name(fname);
	
	file->head_file->name = srcname ;
}

/************************************************************************/
/*			load_mod_files(root)                            */
/*                                                                      */
/*           called by preprocess()                                     */
/*          load module files recursively                               */
/************************************************************************/
int load_mod_files(node)
PTR_MOD node;
{
	if (node==(PTR_MOD)NULL) return ;
	if (node->lp)
		load_mod_files(node->lp);
	if (show_mod_flag) 
		printf(" %s\n",gen_mod_name(node->name));
	else
		read_mod_nodes(fi,gen_mod_name(node->name));
	if (node->rp)
		load_mod_files(node->rp);
}



/**************************************************************************
                 write dep procedures 

     including  write_modules()
		write_mod_from_dep()
***************************************************************************/

/*************************************************************************/
/*                       write_mod_from_dep(bfnd)                        */
/*                                                                       */
/*        called by write_modules()                                      */
/*                                                                       */
/*  write module symbol table of 'bfnd' to .mod file                     */
/*************************************************************************/
int write_mod_from_dep(bfnd)
PTR_BFND bfnd;
{
	PTR_FILE  mod_fi;
	PTR_SYMB modsym;
	FILE      *fd;
	char      *modfilename;

	modsym=bfnd->entry.Template.symbol;
	modfilename = gen_mod_name(modsym->ident);
	write_mod_nodes(fi,bfnd,modfilename);
}


/*************************************************************************/
/*                       write_modules()                                 */
/*                                                                       */
/*        write the modules in fi to .mod files                          */
/*************************************************************************/
int write_modules()
{
	PTR_BFND bfnd;
	PTR_BLOB blob;
	
	bfnd = fi->global_bfnd;
	for (blob=bfnd->entry.Template.bl_ptr1; blob; blob=blob->next) 
	{
		bfnd=blob->ref;
		if (bfnd->variant==MODULE_STMT)
		 if (bfnd->checked != VIRTUAL_BFND)
			write_mod_from_dep(bfnd);
	}
}



/***************************************************************************
		load_modules()

	function: loads all module used by this file 
***************************************************************************/

int load_modules()
{
	PTR_BLOB blob;
	PTR_BFND bfnd;

	blob= fi->global_bfnd->entry.Template.bl_ptr1;
        for ( ; blob ; blob=blob->next) {
                bfnd = blob->ref;
                load_0(bfnd);
        }
	if (root) load_mod_files(root);
}


int load_0(bfnd)
PTR_BFND bfnd;
{
	PTR_LLND interface_list,ptr;
	PTR_BLOB interface_blob,contains_blob;
	PTR_BFND interface;
	PTR_SYMB symb;

	load_modules_of_scope(bfnd);
        interface_list=get_interface_list(bfnd);
        for (ptr=interface_list; ptr; ptr=ptr->entry.Template.ll_ptr2)
        {
                symb=ptr->entry.Template.ll_ptr1->entry.Template.symbol;
                interface = symb->scope;
                interface_blob= interface->entry.Template.bl_ptr1;
                for (; interface_blob->next ; interface_blob=interface_blob->next)
                {
                        load_modules_of_scope(interface_blob->ref);
                }
        }

	contains_blob = get_contain_blob(bfnd);
        if (contains_blob) {
                for (contains_blob=contains_blob->next;contains_blob;
                        contains_blob=contains_blob->next)
                load_0(contains_blob->ref);
        }
}

int load_modules_of_scope(bfnd)
PTR_BFND bfnd;
{
	PTR_BLOB blob;
	PTR_LLND use_list;
	PTR_BFND bf;

	/* if is scope unit */
	if (!is_main_header(bfnd)) return 0;

	use_list=bfnd->entry.Template.symbol->entry.Template.use_list;
	for ( ; use_list; use_list=use_list->entry.Template.ll_ptr2)
	{
		bf=search_head_name(fi,use_list->entry.Template.ll_ptr1->entry.Template.symbol->ident);
		if (bf==BFNULL)
		insert_module(use_list->entry.Template.ll_ptr1->entry.Template.symbol->ident);
		else if (show_mod_flag &&  bf->checked==VIRTUAL_BFND)
			insert_module(use_list->entry.Template.ll_ptr1->entry.Template.symbol->ident);      
		/* if -D flag , insert anyway */
	}
}


int insert_module(mod)
char *mod;
{
	PTR_MOD new_node,tmp;

	if (present(mod,root)) return;
	new_node = (PTR_MOD)chkalloc(sizeof(struct _binary_mod_tree));
	new_node->lp=NULL;
	new_node->rp=NULL;
	new_node->name=mod;
	if (root==(PTR_MOD)NULL)
		root=new_node;
	else {
		for (tmp=root;tmp->rp;tmp=tmp->rp);
		tmp->rp=new_node;
	}
	expand_by_use(new_node); 
}


int present(name,node)
char *name;
PTR_MOD node;
{
	if (node==(PTR_MOD)NULL) return 0;
	if (strcasecmp(node->name,name)==0) return 1;
	if (node->lp)
		if (present(name,node->lp)) return 1;
	if (node->rp)
		if (present(name,node->rp)) return 1;
	return 0;
}


int expand_by_use(node)
PTR_MOD node;
{
	char *modname,*fname,*str;
	FILE *fd;
	int   status,i;
	u_short sum;
	PTR_MOD  new_node,tmp;

	modname=gen_mod_name(node->name);
	if ((fd = fopen (modname, "r")) == NULL) {
                fprintf(stderr, "Could not open %s for read\n", modname);
                return (-1);
        }
	status=check_if_mod(fd);
	if (status !=0)  return status;

	fname=read_string(fd);

	if ((int)fread(&sum, sizeof(u_short), 1, fd) < 0)
            return -1;

        for (i=0; i<sum ; i++) {
                str=read_string(fd);
		if (present(str,root)) continue;
/*
printf("inserted use :%s\n",str);
*/
		new_node = (PTR_MOD)chkalloc(sizeof(struct _binary_mod_tree));
        	new_node->lp=NULL;
        	new_node->rp=NULL;
        	new_node->name=str;
        	if (node->lp==(PTR_MOD)NULL)
                	node->lp=new_node;
        	else {
                	for (tmp=node->lp;tmp->rp;tmp=tmp->rp);
                	tmp->rp=new_node;
        	}
        	expand_by_use(new_node);
        }
        return 0;
}




/****************************************************************************
		make_sequence()
	function:
                  make a sequence to link 
	return :
		  a list (PTR_FNAME) of filename to link .
****************************************************************************/


PTR_FNAME make_sequence(proj)
PTR_PROJ proj;
{
	PTR_BLOB blob;
	PTR_FILE fi;
	PTR_FNAME head;

	head = (struct file_name *) chkalloc(sizeof(struct file_name));
        head->id=0;
        head->name=NULL;
        head->next=(PTR_FNAME)NULL;

	for (blob=proj->file_chain; blob ; blob=blob->next)
	{
		fi=(PTR_FILE)blob->ref;
		insert_to_seq_blob(proj,fi,head);
	}
/*
for (;head;head=head->next) 
printf("file:'%s'\n",head->name);
*/
	return head;
}

PTR_FILE name_in_proj(fname,proj)     /* fname: .dep */
char *fname;
PTR_PROJ proj;
{
	PTR_BLOB blob;
	PTR_FILE fi;
	char     *depname;

	for (blob=proj->file_chain; blob ; blob=blob->next)
	{
		fi=(PTR_FILE)blob->ref;
		depname=gen_dep_name(fi->filename);
		if (strcasecmp(depname,fname)==0) {
			free(depname);
			return fi;
		}
		free(depname);
	}
	return (PTR_FILE)NULL;
}

static int file_in_list(fname,head)     /* fname: .dep */
char *fname;
PTR_FNAME head;
{
	PTR_FNAME tmp;

	for (tmp=head->next; tmp; tmp=tmp->next)
		if (strcasecmp(tmp->name,fname)==0) return 1;
	return 0; 	
}

/* fname -- .dep */
static insert_at_end(fname,head)
char *fname;
PTR_FNAME head;
{
	PTR_FNAME tmp,new;

	new = (struct file_name *) chkalloc(sizeof(struct file_name));
        new->id=0;
        new->name=fname;
        new->next=(PTR_FNAME)NULL;
	for (tmp=head; tmp->next; tmp=tmp->next);
	tmp->next=new;
}

static insert_at_head(fname,head)
char *fname;
PTR_FNAME head;
{
	PTR_FNAME new;

	new = (struct file_name *) chkalloc(sizeof(struct file_name));
        new->id=0;
        new->name=fname;
        new->next=head->next;
	head->next=new;
}


/*
	call by make_sequence()

	function:  insert file (fi) of proj into list (head)
*/
int insert_to_seq_blob(proj,fi,head)
PTR_PROJ proj;
PTR_FILE fi;
PTR_FNAME head;
{
	PTR_BLOB blob;
	PTR_BFND bfnd;
	PTR_FILE ffi;
	char    *modname,*fname,*depname,*maindep;
	FILE    *fd;
	int      status;

	maindep=gen_dep_name(fi->filename);
	if (file_in_list(maindep,head)) return 0;

	for (blob=fi->head_bfnd->entry.Template.bl_ptr1; blob;
		blob=blob->next)
	{
		bfnd=blob->ref;
		if (bfnd->checked==VIRTUAL_BFND) {
			modname=gen_mod_name(bfnd->entry.Template.symbol->ident);
        		if ((fd = fopen (modname, "r")) == NULL) {
                	fprintf(stderr, "Could not open %s for read\n", modname);
                	return (-1);
        		}
				/* try to read file as mod file */
        		status=check_if_mod(fd);
        		if (status !=0)  return status;

        		fname=read_string(fd);
			fclose(fd);
			depname=gen_dep_name(fname);
			ffi=name_in_proj(depname,proj);
			if (!ffi) continue;
			if (file_in_list(depname,head)) continue;
				/* call recursively */
			insert_to_seq_blob(proj,ffi,head);
		}
	}

	if (file_in_list(maindep,head)) return 0;
	insert_at_end(maindep,head);
	return 0;
}


