/******************************************************************************
		PREPROCESS()

written by Zheng Gengbin              1996 7/17
******************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if defined(STDC_HEADERS) && (STDC_HEADERS==1)
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>

#   include "tags.h"
#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"
#   include "macro.h"

#include "decl.h"
#include "defnodes.h"

#include "exglobal.h"

int     pre_processing;


/*
 *    PREPROCESS() ---  
	1. preprocess the AST to decide dummy type .
	2. load .mod file if necessary
 */
int preprocess()
{
	PTR_BLOB blob;
	PTR_BFND bfnd;

printf("Preprocessing ...\n");
	pre_processing = 1;
	blob= fi->global_bfnd->entry.Template.bl_ptr1;
	for ( ; blob ; blob=blob->next) {
		bfnd = blob->ref;
		pre_0(bfnd);
	}
	/* if (root) load_mod_files(root); */
	pre_processing = 0;
printf("Preprocessing done. \n");
}



int pre_0(bfnd)
PTR_BFND bfnd;
{
	PTR_BLOB contains_blob,interface_blob;
	PTR_LLND interface_list,ptr;
	PTR_SYMB symb;
	PTR_BFND  interface,subroutine;

	cur_bfnd = bfnd;
	contains_blob = get_contain_blob(cur_bfnd);

	push_scope(fi,cur_bfnd);

	while (cur_bfnd)
	{
		switch (cur_bfnd->variant)
		{
		case FUNC_HEDR:
		case PROC_HEDR:
			check_sub_hedr(cur_bfnd);
			check_dummy_type(cur_bfnd->entry.Template.symbol);
			check_interface_dummy(cur_bfnd);
			break;
		case DIRSEQUENCE_STMT: 
			brief_check_sequence(cur_bfnd);
			break;
		}
		cur_bfnd=cur_bfnd->thread;
	}

	if (contains_blob) {
		for (contains_blob=contains_blob->next;contains_blob;
			contains_blob=contains_blob->next)
		pre_0(contains_blob->ref);
	}

	delete_beyond_scope_level(0);
}

int check_sub_hedr(this_bfnd)
PTR_BFND this_bfnd;
{
	PTR_SYMB sub_name;
	PTR_LLND prefix;
	int      attr;

	sub_name = BIF_SYMB(this_bfnd);
	prefix=BIF_LL2(this_bfnd);
	attr=sub_name->attr;
	for(;prefix!=LLNULL;prefix=prefix->entry.list_s.next)
		{	switch (prefix->entry.list_s.item->variant )
			{	case PREFIX_PURE:	attr=attr | PURE_BIT;
									break;
				case PREFIX_RECURSIVE:	attr=attr | RECURSIVE_BIT;
									break;
				case PREFIX_HPF:	attr=attr | EXTRINSIC_HPF_BIT;
								break;
				case PREFIX_HPFLOCAL:	attr=attr | EXTRINSIC_HPFLOCAL_BIT;
								break;
			}
		}
	sub_name->attr=attr;
}

check_dummy_type(sub_name)
PTR_SYMB sub_name;
{
	PTR_SYMB dummy,sym;
	PTR_TYPE type , base_type,default_type;

	for (dummy=sub_name->entry.proc_decl.symb_list; dummy ;
		dummy=dummy->entry.var_decl.next_in)
	{
		type = dummy->type;
		if (type == TYNULL) continue;

        	base_type=get_base_type(type);
        	if (base_type->variant == DEFAULT)
        	{
                	sym=search_symb_ref(base_type->name);
                	if (sym != dummy->type->name &&
                        	sym->variant == TYPE_NAME ) {
                        	default_type = look_up_record(fi,sym);
                        	dummy->type=default_type;
                	}
                }
	}
}


int check_interface_dummy(bfnd)
PTR_BFND bfnd;
{
	PTR_LLND  interface_list,ptr;
	PTR_SYMB  symb,dummy,sub_name,vname;
	PTR_BFND  inter_scope;
	extern PTR_SYMB  look_up_symb_at_scope_in_hash();
	
	interface_list=get_interface_list(cur_bfnd);
	if (interface_list == LLNULL) return;
	sub_name=bfnd->entry.Template.symbol;
	
	for (ptr=interface_list; ptr; ptr=ptr->entry.Template.ll_ptr2)
        {
                symb=ptr->entry.Template.ll_ptr1->entry.Template.symbol;
                inter_scope = symb->scope;
		for (dummy=sub_name->entry.proc_decl.symb_list; dummy ;
                	dummy=dummy->entry.var_decl.next_in)
        	{
			vname=look_up_symb_at_scope_in_hash(dummy->ident,inter_scope);
			if (vname)
				dummy->entry.Template.declared_name = vname;
		}
	}
}

int brief_check_sequence(this_bfnd)
PTR_BFND this_bfnd;
{
	PTR_LLND ptr;
	PTR_SYMB symbol;

	ptr = BIF_LL1(cur_bfnd);
        for (;ptr;ptr=ptr->entry.Template.ll_ptr2) {
                symbol = ptr->entry.Template.ll_ptr1->entry.Template.symbol;
		if (symbol && is_dummy(cur_scope(),symbol) )
			symbol->attr |= SEQUENCE_BIT;
	}
}

int remove_dummy_attr(this_bfnd)
PTR_BFND this_bfnd;
{
	PTR_SYMB sub_name,io_list;

	sub_name = BIF_SYMB(this_bfnd);
	io_list = sub_name->entry.proc_decl.symb_list;
        for ( ; io_list ; io_list=io_list->entry.var_decl.next_in ) 
	{
		if (io_list->attr & SEQUENCE_BIT)
			io_list->attr  &= ~SEQUENCE_BIT;
	}
}

