#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>

#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"

#include "exglobal.h"
#include "tags.h"
#include "decl.h"

extern int debug1;
extern SYMB_LIST  rename_list;


#define  s_bool   1
#define  s_int0   4
#define  s_int1   2
#define  s_int2   8
#define  s_real0  4
#define  s_real1  8
#define  s_real2  16
#define  s_double 8

struct equi_link_ring {
	PTR_SYMB        header; /* the header of this equivalence link */
	PTR_SYMB        common_object; /* point common object that appear in
						this equivalence link */
	int             first,last; /* offset of the first and last memory 
						unit */
	struct equi_link_ring * next;
};
/*rerturn the size of type*/

			/* check common statement */
int check_comm_stmt();

/************* the following part is added by Feng Xiaobing ************/


/************************************************************************
*       function name : is_specification_expr                           *
*       input parameter : ddot, the root of this expression             *
*       output : 0, this expression is no a specification expression    *
*                1, this expression is a sepcificaton expression        *
*       function : check if this expression is a specification          *
*                       expression                                      *
************************************************************************/

int is_specification_expr(ddot)
PTR_LLND        ddot;
{
	return check_spec_expr(ddot) ? 0:1;
}


/************************************************************************
*       function name : is_assume_shape                                 *
*       input parameter : range, array boundary describtion             *
*       output : 0, this array is not an assume shape array             *
*                1, this array is an assume shape array                 *
*       function : check if this array is an assume shape array         *
************************************************************************/

int is_assume_shape(range)
PTR_LLND        range;
{
	PTR_LLND        expr_list,ele;

	for (expr_list = range; expr_list;
		expr_list = expr_list->entry.Template.ll_ptr2) {
			/* ele point to  DDOT now */
		ele = expr_list->entry.Template.ll_ptr1;
		if (ele == LLNULL)  continue;
			/* ele point to RANGE_OP */
		ele = ele->entry.Template.ll_ptr1;
		if (ele == LLNULL)  continue;
		if (ele->entry.Template.ll_ptr1) {
			if (!is_specification_expr(ele->entry.Template.ll_ptr1))
				return 0;
		}
		if (ele->entry.Template.ll_ptr2) 
			return 0;
	}
	return 1;
}


/************************************************************************
*       function name : is_assume_size                                  *
*       input paramter : range , array boundary describtion             *
*       output : 0, this array is not an assume size array              *
*                1, this array is an assume size array                  *
*       function : check if this array is an assuem size array          *
************************************************************************/

int is_assume_size(range)
PTR_LLND        range;
{
	PTR_LLND        expr_list,ele;

	for (expr_list = range; expr_list;
		expr_list = expr_list->entry.Template.ll_ptr2) {
			/* ele point to  DDOT now */
		ele = expr_list->entry.Template.ll_ptr1;
		if (ele == LLNULL) return 0;
		ele = ele->entry.Template.ll_ptr1;
		if (ele == LLNULL) return 0;
		if (ele->entry.Template.ll_ptr1) 
			if (!is_specification_expr(ele->entry.Template.ll_ptr1))
				return 0;
						/* if is the last dimension */
		if (expr_list->entry.Template.ll_ptr2) {
			if (ele->entry.Template.ll_ptr2)
			{
			   if (!is_specification_expr(ele->entry.Template.
								ll_ptr2))
				return 0;
			}
			else return 0;
		}
		else if ( ele->entry.Template.ll_ptr2 == LLNULL  ||  
			    ele->entry.Template.ll_ptr2->variant != STAR_RANGE)
			return 0;
	}
	return 1;
}


/************************************************************************
*       function name : is_defer                                        *
*       input parameter : range, array boundary describtion             *
*       output : 0, this array is not a deferred array                  *
*                1, this array is a deferred array                      *
*       function : check if the array specification is an deferred shape*
*                       array                                           *
************************************************************************/

int is_defer(range)
PTR_LLND range;
{
	PTR_LLND        expr_list,ele;

	for (expr_list = range; expr_list;
		expr_list = expr_list->entry.Template.ll_ptr2) {
		ele = expr_list->entry.Template.ll_ptr1;
		if ((ele->variant != DDOT) || ele->entry.Template.ll_ptr1 
					|| ele->entry.Template.ll_ptr2)
			return 0;
	}
	return 1;
}


/************************************************************************
*       function name : is_exp_shape                                    *
*       input parameter : range, array boundary describtion             *
*       output : 0, this array is not an explicit array                 *
*                1, this array is an explicit array                     *
*       function : check if the array specification is an explicit shape*
*                       array                                           *
************************************************************************/

int is_exp_shape(range)
PTR_LLND range;
{
	PTR_LLND        expr_list,ele;

	for (expr_list = range ; expr_list;
		expr_list = expr_list->entry.Template.ll_ptr2) {
		ele = expr_list->entry.Template.ll_ptr1->entry.Template.ll_ptr1;
		if (ele == LLNULL) return 0;
		if (ele->entry.Template.ll_ptr2->variant ==STAR_RANGE) return 0;
		if (!is_specification_expr(ele->entry.Template.ll_ptr2))
			return 0;
		if (ele->entry.Template.ll_ptr1) 
			if (!is_specification_expr(ele->entry.Template.ll_ptr1))
				return 0;
	}
	return 1;
}


int is_const_exp_shape(range)
PTR_LLND range;
{
        PTR_LLND        expr_list,ele;

        for (expr_list = range ; expr_list;
                expr_list = expr_list->entry.Template.ll_ptr2) {
                ele = expr_list->entry.Template.ll_ptr1->entry.Template.ll_ptr1;
                if (ele == LLNULL) return 0;
                if (ele->entry.Template.ll_ptr2->variant ==STAR_RANGE) return 0;
                if (!check_initialization_expr(ele->entry.Template.ll_ptr2))
                        return 0;
                if (ele->entry.Template.ll_ptr1)
                        if (!check_initialization_expr(ele->entry.Template.ll_ptr1))
                                return 0;
        }
        return 1;
}

/************************************************************************
*       function name : component_check                                 *
*       input parameter : NONE                                          *
*       output : NONE                                                   *
*       function : check component declaration of a derived type and    *
*                       report errors                                   *
************************************************************************/

int component_check()
{
	PTR_LLND        entities,length,attr,ptr,node,expr_list,ele,ddot,range;
	PTR_TYPE        type,base_type,newtype=TYNULL,default_type=TYNULL;
	PTR_SYMB        symbol,sym;
	PTR_BFND        scope,parent;
	int             pointer_flag,dimension_flag,attr_option,flag;
	int             err_code;

	pointer_flag = 0;
	dimension_flag = 0;
	attr_option = 0;
	if (type_sequence_flag) 
		attr_option = attr_option | SEQUENCE_BIT;
	if (type_private_flag)
		attr_option = attr_option | PRIVATE_BIT;
	if ((in_module) && (empty_access_stmt == 2)) 
		attr_option = attr_option | PRIVATE_BIT;
	
	/***** check component attribute specification list *****/
	expr_list = cur_bfnd->entry.Template.ll_ptr3;
	for ( ; expr_list ; expr_list = expr_list->entry.Template.ll_ptr2) 
	{
		ele = expr_list->entry.Template.ll_ptr1;
		if (ele->variant == POINTER_OP) {
			if (pointer_flag == 1) 
				error1(434);
			else {
				pointer_flag = 1;
				attr_option = attr_option | POINTER_BIT;
			}
		}
		else if (ele->variant == DIMENSION_OP) {
			if (dimension_flag == 1) 
				error1(435);
			else {
				dimension_flag = 1;
				ele = ele->entry.Template.ll_ptr1;
				attr_option = attr_option | DIMENSION_BIT;
				if (!is_exp_shape(ele->entry.Template.ll_ptr1))
				    if (!is_defer(ele->entry.Template.ll_ptr1))
					error1(438);
			}
		}
	}

	/***** check type_spec *****/
	/***** check type  op , and len or NON_LEN KIND NONKIND op */
		/* since now TYPE_OP already point to the base type, there
			seems no need to call get_base_type , zheng.gb */  
	node = cur_bfnd->entry.Template.ll_ptr2;
	type = node->type;

	base_type=get_base_type(type);
	if (base_type->variant == DEFAULT) 
	{
		sym=search_symb_ref(base_type->name);
		if (sym != node->type->name &&
			sym->variant == TYPE_NAME ) {
			default_type = look_up_record(fi,sym);
			node->type=default_type;
		}
                else {
			error3(206,type->name->ident);
			return;
		}
	}
	if (node->entry.Template.ll_ptr1)
	    for(expr_list=node->entry.Template.ll_ptr1->
			entry.Template.ll_ptr1;
		expr_list; expr_list=expr_list->entry.Template.ll_ptr2) 
	    {
		ele=expr_list->entry.Template.ll_ptr1;
		switch (expr_list->variant) {
		case LEN_OP:
		case NON_LEN_OP:
			if (ele->variant == VAR_REF && (
			  strcasecmp(ele->entry.Template.symbol->ident,"*")==0))
				break;
			if (err_code=check_spec_expr(ele) )
                                    error1(err_code);
			break;
			   /*   should be scalar int initialization expr */
		case KIND_OP:
		case NON_KIND_OP:
			if (!check_initialization_expr(ele)) {
                                error1(236);	
				break;
			}
			if (!is_scalar(ele->type)) {error1(237);break;}
			if (!isInteger(ele)) {error1(237);break;}
			comput_const_expr(ele,0);
			if(ele->const_val<0)
                                error1(238);
			break;
			    /*  then it should be scalar int literal constant */
		default:
			if (!check_initialization_expr(expr_list))
                                    error1(192);
	 	}   /* switch */
	    }    /* for */


	node = cur_bfnd->entry.Template.ll_ptr2;
	type = node->type;


		/* now the type is proved to already exist */
	if (type->variant == T_RECORD) {
		parent = cur_bfnd->control_parent;
/*
		newtype = look_up_record(fi,type->name);
		if (newtype != TYNULL) flag = 1;
		if (flag == 0) 
			if (pointer_flag == 0)
				error1(436);
			else if (type->name != cur_bfnd->control_parent->entry.Template.symbol)
			error1(436);
		if ((pointer_flag) && (strcmp(type->name->ident,cur_bfnd->control_parent->entry.Template.symbol->ident)==0))
			node->type = cur_bfnd->control_parent->entry.Template.symbol->type;     
		else if (flag) node->type = newtype;
*/
			/* if have no pointer attr , cannot refer the type
			   that is being defined */
		if (type->name == cur_bfnd->control_parent->
			entry.Template.symbol)
		   if (pointer_flag==0)
			error1(436);

		/***** if the type of component is a sequence derived type*****/
		if ((type_sequence_flag) && ((type->name->attr & SEQUENCE_BIT) == 0))
			error1(437);

		/***** set the attribute of component *****/
		attr_option = attr_option | type->name->attr;
	}


	/***** check component declaration list *****/
	expr_list = cur_bfnd->entry.Template.ll_ptr1;
	node = cur_bfnd->entry.Template.ll_ptr2;
	attr = cur_bfnd->entry.Template.ll_ptr3;

	for ( ; expr_list ;
		expr_list = expr_list->entry.Template.ll_ptr2) {
		ptr = expr_list->entry.Template.ll_ptr1;
		if (ptr->variant == STAR_LIST || ptr->variant == EXPR_LIST) {
			length = ptr->entry.Template.ll_ptr2;
			ptr = ptr->entry.Template.ll_ptr1;
		}
		else 
			length = LLNULL;
		if ((ptr->variant == VAR_REF) || (ptr->variant == ARRAY_REF)) {
			symbol = ptr->entry.Template.symbol;
			range = ptr->entry.Template.ll_ptr1;
		}
/*
		else {
			symbol = ptr->entry.Template.ll_ptr1->entry.Template.symbol;
			range = ptr->entry.Template.ll_ptr1->entry.Template.ll_ptr1;
			length = ptr->entry.Template.ll_ptr2;
		}
*/
			/* decide a record which is defined in other module */
		if (default_type!=TYNULL) symbol->type=default_type;
		if (range != LLNULL) {
			if (pointer_flag) {
				if (!is_defer(range)) 
					error1(438);
			}
			else {
					/* R428 ,the explicit spec must be constant */
				if (!is_const_exp_shape(range))
					error1(438);
			}
		}
		if (length != LLNULL) {
			if (!isStringType(node->type)) 
				error1(439);
			length=length->entry.Template.ll_ptr1;
			if (length->variant == NON_LEN_OP)
				length=length->entry.Template.ll_ptr1;
			  /* char length must be constants */
			if (!check_initialization_expr(length))
				error3(474,symbol->ident);
		}
		
		symbol->attr = symbol->attr | attr_option;
		if (type_sequence_flag) {
/*      zheng.gb 1996.5.12 ??? 
			if (symbol->attr & POINTER_BIT)
				error1(478);
*/
			if ((symbol->type->variant == T_RECORD) &&
				(!(symbol->type->name->attr & SEQUENCE_BIT)))
				error1(478);
		}
	}
}


/************************************************************************
*       function name : check_var_ref                                   *
*       input parameter : symbol, name of this variabel                 *
*                         attr, attribute word                          *
*       output : NONE                                                   *
*       function : check if this variable reference is correct and      *
*                       report errors                                   *
************************************************************************/

int check_var_ref(symbol,attr_option)
PTR_SYMB symbol;
int attr_option;
{
	PTR_BFND scope;

	scope=cur_scope();
	if (symbol->variant == FUNCTION_NAME) {
		if (symbol== scope->entry.Template.symbol &&
		    ((attr_option & EXTERNAL_BIT) ||
                    (attr_option & INTRINSIC_BIT)) )
			error3(475,symbol->ident);
		if (debug1) printf("check_function name \n");
	}
	else {
/*       zheng.gb 1996.5.12 
		if ((attr_option & EXTERNAL_BIT) ||
		    (attr_option & INTRINSIC_BIT))  
			 error3(446,symbol->ident);
*/
	}
	if (attr_option & ALLOCATABLE_BIT) {
		if (!(attr_option & DIMENSION_BIT) && !(symbol->attr & DIMENSION_BIT))
			error3(445,symbol->ident);
		else if ((symbol->entry.var_decl.local == IO) || (symbol->entry.var_decl.local == OUTPUT))
			error3(453,symbol->ident);
	}
	if ((attr_option & IN_BIT) ||
	    (attr_option & OUT_BIT) ||
	    (attr_option & INOUT_BIT)) {
		if (symbol->entry.var_decl.local != IO)
			error3(425,symbol->ident);
		else if (attr_option & POINTER_BIT)
			error3(429,symbol->ident);
	}
	if (attr_option & SAVE_BIT) {
		if (symbol->entry.Template.common_link.common_item) 
			error3(418,symbol->ident);
		if ((symbol->variant == FUNCTION_NAME) ||
		    (symbol->variant == PROCEDURE_NAME)) 
			error3(447,symbol->ident);
		if ((symbol->entry.var_decl.local == IO) ||
		    (symbol->entry.var_decl.local == OUTPUT) ||
		    (symbol->variant == PROCEDURE_NAME))
			error3(447,symbol->ident);
			/* if is result name */
/*
		if (scope->variant == FUNC_HEDR && scope->entry.Template.symbol && symbol==scope->entry.Template.symbol->entry.Template.declared_name)
*/
		if (is_result_name(symbol,scope))
			error3(482,symbol->ident);
		/* automatic object */
		if (isStringType(symbol->type))
			if (!is_const_size_string(symbol)) 
				error3(404,symbol->ident);
		if (symbol->type->variant == T_ARRAY) 
			if (type_size(symbol)==-1)
				error3(404,symbol->ident);
	}
	if (attr_option & OPTIONAL_BIT) {
		if (symbol->entry.var_decl.local != IO)
			error3(448,symbol->ident);
	}
	if (attr_option & POINTER_BIT) {
		if ((attr_option & TARGET_BIT) ||
		    (attr_option & IN_BIT) || (attr_option & OUT_BIT) ||
		    (attr_option & INOUT_BIT) || (attr_option & EXTERNAL_BIT) ||
		    (attr_option & INTRINSIC_BIT))
			error3(410,symbol->ident);
	}
	if (attr_option & TARGET_BIT) {
		if ((attr_option & POINTER_BIT) ||
		    (attr_option & EXTERNAL_BIT) || 
		    (attr_option & INTRINSIC_BIT) || 
		    (attr_option & PARAMETER_BIT))
			error3(457,symbol->ident);
	}
	if (attr_option & PARAMETER_BIT) {
		if (symbol->entry.var_decl.local == IO) 
			error3(419,symbol->ident);
		if ((attr_option & POINTER_BIT) || (symbol->attr & POINTER_BIT))
			error3(419,symbol->ident);
		if ((attr_option & ALLOCATABLE_BIT) ||
		    (symbol->attr& ALLOCATABLE_BIT))
			error3(419,symbol->ident);
		if (symbol->variant == FUNCTION_NAME) 
			error3(419,symbol->ident);
		if (symbol->entry.Template.common_link.common_item) 
			error3(419,symbol->ident);
	}
}


/************************************************************************
*	function name : is_init_valid					*
*	input parameter : symbol, variable symbol table item pointer	*
*			  attr_option, attribute option			*
*	output : 0, this symbol can not be initialized			*
*		 1, otherwise						*
*	function : check if a variable can be initialized		*
************************************************************************/

int is_init_valid(symbol,attr_option)
PTR_SYMB symbol;
int attr_option;
{
	if (symbol->variant == FUNCTION_NAME)  return 0;	/* by zheng.gb*/

	if ((symbol->entry.var_decl.local == IO) ||
	    (symbol->entry.var_decl.local == OUTPUT) ||
	    (attr_option & ALLOCATABLE_BIT) ||
	    (symbol->attr & ALLOCATABLE_BIT) ||
	    (symbol->attr & POINTER_BIT) ||
	    (attr_option & POINTER_BIT) ||
	    (attr_option & EXTERNAL_BIT) ||
	    (symbol->attr & EXTERNAL_BIT) ||
	    (attr_option & INTRINSIC_BIT) ||
	    (symbol->attr & INTRINSIC_BIT))
		return 0;
/* zheng.gb 1996.5.12   ?????????? */
/*
	if (isStringType(symbol->type)) 
		if (!is_const_size_string(symbol))
			return 0;
*/
	if (symbol->type->variant == T_ARRAY)
		if (type_size(symbol) == -1) 
			return 0;
	if (symbol->entry.Template.common_link.common_item) {
		if (symbol->entry.Template.common_link.common_item->symbol == SMNULL)
			return 0;
		if (symbol->scope->variant != BLOCK_DATA)
			return 0;
	}
	return 1;
	
}


int check_func_hedr(node)
PTR_LLND node;
{
	PTR_BFND scope;
	PTR_SYMB symbol;

	scope= cur_bfnd->control_parent;
	symbol = node->entry.Template.symbol; 
	if (!strcasecmp(scope->entry.Template.symbol->ident, symbol->ident) && scope->variant == FUNC_HEDR )
	{
		symbol=scope->entry.Template.symbol;
		symbol->type=node->entry.Template.symbol->type;
		node->entry.Template.symbol=symbol;
	}
}

/************************************************************************
*       function name : check_var_decl_stmt                             *
*       input parameter : NONE                                          *
*       output : NONE                                                   *
*       fnnction : check variable declaration statement and report      *
*                       errors                                          *
************************************************************************/

int check_var_decl_stmt() 
{
	PTR_LLND  entities,type_op,attr,ptr,node,expr_list,ele,ddot,range,array_range,char_len,ass_list,llnd;
	PTR_TYPE  type,base_type,newtype=TYNULL;
	PTR_SYMB  sym,symbol;
	PTR_BFND  scope;
	int attr_option;
	int err_code, is_inited;

	if (in_type_define) {
		component_check();
		return 0;
	};
	entities=cur_bfnd->entry.var_decl.entities;
	type_op =cur_bfnd->entry.var_decl.type;
	attr    =cur_bfnd->entry.var_decl.attributes;

	/***** check if the attribute is correct *****/
	attr_option = 0;
	range = LLNULL;
	for (expr_list = attr ; expr_list ;
		expr_list = expr_list->entry.Template.ll_ptr2) {
		ele = expr_list->entry.Template.ll_ptr1;
		switch (ele->variant) {
			case PUBLIC_OP :
				if ((attr_option & PUBLIC_BIT) ||
					(attr_option & PRIVATE_BIT) ||
					(in_module == 0) ||
					(in_block_data))
					error1(443);
				else attr_option = attr_option | PUBLIC_BIT;
				break;
			case PRIVATE_OP :
				if ((attr_option & PUBLIC_BIT) ||
					(attr_option & PRIVATE_BIT) ||
					(in_module == 0) ||
					(in_block_data))
					error1(443);
				else attr_option = attr_option | PRIVATE_BIT;
				break;
			case ALLOCATABLE_OP :
				if ((attr_option & ALLOCATABLE_BIT) ||
					(attr_option & POINTER_BIT) ||
					(attr_option & PARAMETER_BIT) ||
					(in_block_data))
					error1(443);
				else attr_option = attr_option | ALLOCATABLE_BIT;
				break;
			case EXTERNAL_OP : 
				if ((attr_option & EXTERNAL_BIT) ||
					(attr_option & INTRINSIC_BIT) ||
					(in_block_data))
					error1(443);
				else attr_option = attr_option | EXTERNAL_BIT;
				break;
			case INTRINSIC_OP :
				if ((attr_option & INTRINSIC_BIT) ||
					(attr_option & EXTERNAL_BIT))
					error1(443);
				else attr_option = attr_option | INTRINSIC_BIT;
				break;
			case DIMENSION_OP :
				if (attr_option & DIMENSION_BIT)
					error1(443);
				else attr_option = attr_option | DIMENSION_BIT;
				range = expr_list->entry.Template.ll_ptr1->entry.Template.ll_ptr1;
				/* check range if present in dimension */
				check_array_range(range);
				break;
			case IN_OP :
				if ((attr_option & IN_BIT) ||
					(attr_option & OUT_BIT) ||
					(attr_option & INOUT_BIT) ||
					(attr_option & PARAMETER_BIT) ||	
					(in_block_data))
					error1(443);
				else attr_option = attr_option | IN_BIT;
				break;
			case OUT_OP :
				if ((attr_option & IN_BIT) ||
					(attr_option & OUT_BIT) ||
					(attr_option & INOUT_BIT) ||
					(attr_option & PARAMETER_BIT) ||
					(in_block_data))
					error1(443);
				else attr_option = attr_option | OUT_BIT;
				break;
			case INOUT_OP :
				if ((attr_option & IN_BIT) ||
					(attr_option & OUT_BIT) ||
					(attr_option & INOUT_BIT) ||
					(attr_option & PARAMETER_BIT) ||
					(in_block_data))
					error1(443);
				else attr_option = attr_option | INOUT_BIT;
				break;
			case OPTIONAL_OP :
				if ((attr_option & OPTIONAL_BIT) ||
/*        zheng.gb 1996.5.12  ??? 
					(in_module ==0) ||  
					(in_interface_body ==0) ||
					(in_block_data))
*/
			       (cur_bfnd->control_parent->variant!= FUNC_HEDR &&
			        cur_bfnd->control_parent->variant!= PROC_HEDR ))
					error1(443);
				else attr_option = attr_option | OPTIONAL_BIT;
				break;
			case POINTER_OP :
				if ((attr_option & POINTER_BIT) ||
					(attr_option & ALLOCATABLE_BIT) ||
					(attr_option & PARAMETER_BIT))
					error1(443);
				else attr_option = attr_option | POINTER_BIT;
				break;
			case SAVE_OP :
				if (attr_option & SAVE_BIT)
					error1(443);
				else attr_option = attr_option | SAVE_BIT;
				break;
			case TARGET_OP :
				if (attr_option & TARGET_BIT)
					error1(443);
				else attr_option = attr_option | TARGET_BIT;
				break;
						/* add by zheng.gb */
			case PARAMETER_OP:
				if ((attr_option & POINTER_BIT) ||
				    (attr_option & IN_BIT) ||
				    (attr_option & OUT_BIT) ||
				    (attr_option & INOUT_BIT) ||
				    (attr_option & ALLOCATABLE_BIT))
					error1(443);
				else attr_option = attr_option | PARAMETER_BIT;
				break;
		}
	}
	if (attr_option & POINTER_BIT) {
		if ((attr_option & TARGET_BIT) || (attr_option & IN_BIT) ||
		    (attr_option & OUT_BIT) || (attr_option & INOUT_BIT) ||
		    (attr_option & EXTERNAL_BIT) || (attr_option & INTRINSIC_BIT))
			error1(443);
	};
	if (attr_option & TARGET_BIT) {
		if ((attr_option & POINTER_BIT) || (attr_option & EXTERNAL_BIT)                 || (attr_option & INTRINSIC_BIT) || (attr_option & PARAMETER_BIT))
			error1(443);
	}

	if ((attr_option & ALLOCATABLE_BIT) && (attr_option & DIMENSION_BIT))
		if (!is_defer(range)) 
			error1(443);

	/***** check type  op , and len or NON_LEN KIND NONKIND op */
		/* since now TYPE_OP already point to the base type, there
			seems no need to call get_base_type , zheng.gb */  
	base_type=get_base_type(type_op->type);
	if (base_type->variant == DEFAULT) 
	{
		sym=search_symb_ref(base_type->name);
		if (sym != type_op->type->name &&
			sym->variant == TYPE_NAME ) {
			newtype = look_up_record(fi,sym);
			type_op->type=newtype;
		}
		else error3(206,type_op->type->name->ident);
	}
	if (type_op->entry.Template.ll_ptr1)
	    for(expr_list=type_op->entry.Template.ll_ptr1->
			entry.Template.ll_ptr1;
		expr_list; expr_list=expr_list->entry.Template.ll_ptr2) 
	    {
		ele=expr_list->entry.Template.ll_ptr1;
		switch (expr_list->variant) {
		case LEN_OP:
		case NON_LEN_OP:
			if (ele->variant == VAR_REF && (
			  strcasecmp(ele->entry.Template.symbol->ident,"*")==0))
				break;
			if (err_code=check_spec_expr(ele) )
                                    error1(err_code);
			break;
			   /*   should be scalar int initialization expr */
		case KIND_OP:
		case NON_KIND_OP:
			if (!check_initialization_expr(ele)) {
                                error1(236);	
				break;
			}
			if (!is_scalar(ele->type)) {error1(237);break;}
			if (!isInteger(ele)) {error1(237);break;}
			comput_const_expr(ele,0);
			if(ele->const_val<0)
                                error1(238);
			break;
			    /*  then it should be scalar int literal constant */
		default:
			if (!check_initialization_expr(expr_list))
                                    error1(192);
	 	}   /* switch */
	    }    /* for */

			

	/***** check the entity decl list *****/
	for (ptr=entities;ptr;ptr=ptr->entry.Template.ll_ptr2) 
	{
		node=ptr->entry.Template.ll_ptr1;
			/* judge if initializtion expr occurs */
		is_inited=0;
		array_range=NULL;
		switch (node->variant) {
			case VAR_REF :
				check_func_hedr(node);
				symbol = node->entry.Template.symbol;
				check_var_ref(symbol,attr_option);
				if ((attr_option & DIMENSION_BIT) ||
				    (symbol->attr & DIMENSION_BIT)) {
					if ((attr_option & POINTER_BIT) ||
				    	    (attr_option & ALLOCATABLE_BIT) ||
				    	    (symbol->attr & POINTER_BIT) ||
				    	    (symbol->attr & ALLOCATABLE_BIT)) {
						if (!range) 
							error3(443,symbol->ident);
						else if (!is_defer(range))
							error3(443,symbol->ident);
					}
				}
				if ((symbol->entry.var_decl.local == OUTPUT) &&
				    !(attr_option & POINTER_BIT) &&
				    !(symbol->attr &POINTER_BIT))
					if (!is_exp_shape(range)) 
						error3(443,symbol->ident);
				symbol->decl = HARD;
				symbol->attr = symbol->attr | attr_option;
				if (newtype) symbol->type = newtype;
				break;
			case ASSGN_OP :
				is_inited=1;
				symbol = node->entry.Template.ll_ptr1->entry.Template.symbol;
				/*sym = search_symb_decl(symbol); 1996.5.20 
				if (sym->variant==FUNCTION_NAME ) 
				{
					sym->type = node->entry.Template.symbol->type;
					node->entry.Template.ll_ptr1->entry.Template.symbol=sym;
					symbol = sym;
				}
*/
				switch (node->entry.Template.ll_ptr1->variant) {
					case VAR_REF : 
						check_var_ref(symbol,attr_option);
		                                if (((attr_option & POINTER_BIT) ||
                		                    (attr_option & ALLOCATABLE_BIT) ||
                                		    (symbol->attr & POINTER_BIT) ||
                                  		    (symbol->attr & ALLOCATABLE_BIT)) &&
						    ((symbol->attr & DIMENSION_BIT) ||
						    (attr_option & DIMENSION_BIT))) {
                       			                 if (!range)
                                        		        error3(443,symbol->ident);
                                       			 else if (!is_defer(range))
                                             			   error3(443,symbol->ident);
                                		}
						if ((symbol->entry.var_decl.local == OUTPUT) 
						 &&!(symbol->attr & POINTER_BIT)						 &&!(attr_option & POINTER_BIT))
							if (!is_exp_shape(range))
								error3(443,symbol->ident);
							/* add by zheng.gb */
						if (node->entry.Template.ll_ptr1
->entry.Template.symbol->attr & PARAMETER_BIT)
                                                {
                                                        node->entry.Template.ll_ptr1->entry.Template.symbol->entry.Template.const_value=node->entry.Template.ll_ptr2;
                                                }
						symbol->decl = HARD;	
						if (newtype) symbol->type = newtype;
						break;
					case ARRAY_REF :
						check_var_ref(symbol,attr_option);
						array_range = node->entry.Template.ll_ptr1->entry.Template.ll_ptr1;
						check_array_range(array_range);
		                                if ((attr_option & POINTER_BIT) ||
                		                    (attr_option & ALLOCATABLE_BIT) ||
                                		    (symbol->attr & POINTER_BIT) ||
 		                                   (symbol->attr & ALLOCATABLE_BIT)) {
                		                        if (!array_range)
                                		                error3(443,symbol->ident);
                		                        else if (!is_defer(array_range))
                                		                error3(443,symbol->ident);
                                		}
  	                                        if ((symbol->entry.var_decl.local == OUTPUT) &&
        		                            !(attr_option & POINTER_BIT) &&
                        		            !(symbol->attr &POINTER_BIT))
                                        		if (!is_exp_shape(array_range))
                                          		      error3(443,symbol->ident);
/*
			                        if (!check_initialization_expr(node->entry.Template.ll_ptr2)) {
                                			error1(192);
                        			}
*/
                        			if (node->entry.Template.ll_ptr1->entry.Template.symbol->attr & PARAMETER_BIT)
                        			{
                                			node->entry.Template.ll_ptr1->entry.Template.symbol->entry.Template.const_value=node->entry.Template.ll_ptr2;
                        			}
						symbol->decl = HARD;
							/* zheng.gb 1996.5.9 */
						if (newtype) symbol->type->entry.ar_decl.base_type = newtype;
						break;
				}
				if (!is_init_valid(symbol,attr_option)) 
					error3(458,symbol->ident);
				symbol->attr = symbol->attr | attr_option;

				node=ptr->entry.Template.ll_ptr1;
				if (!check_initialization_expr(node->entry.Template.ll_ptr2)) 
				{
                                	error1(192);
                                }
				else check_initialization_assign_compatiable(symbol,node->entry.Template.ll_ptr2);
				break;
			case ARRAY_REF :
				check_func_hedr(node);
				symbol = node->entry.Template.symbol;
				array_range = node->entry.Template.ll_ptr1;
				check_array_range(array_range);
				check_var_ref(symbol,attr_option);
                                if ((attr_option & POINTER_BIT) ||
                                    (attr_option & ALLOCATABLE_BIT) ||
                                    (symbol->attr & POINTER_BIT) ||
                                    (symbol->attr & ALLOCATABLE_BIT)) {
                                        if (!array_range)
                                                error3(443,symbol->ident);
                                        else if (!is_defer(array_range))
                                                error3(443,symbol->ident);
                                }
                                if ((symbol->entry.var_decl.local == OUTPUT) &&
                                    !(attr_option & POINTER_BIT) &&
                                    !(symbol->attr &POINTER_BIT))
                                        if (!is_exp_shape(array_range))
                                                error3(443,symbol->ident);
                                symbol->decl = HARD;
                                symbol->attr = symbol->attr | attr_option;
				if (newtype) symbol->type->entry.ar_decl.base_type = newtype;
				break;
			case EXPR_LIST :
                        case STAR_LIST :
						/* delete by zheng.gb */
/*
				if (!check_initialization_expr(node->entry.Template.ll_ptr2->entry.Template.ll_ptr1)) {
					error1(177);
				}
*/
				char_len=node->entry.Template.ll_ptr2->entry.Template.ll_ptr1;
				node = node->entry.Template.ll_ptr1;  
					/* now node => ARRAY_REF */

					/* modified by zheng.gb 4.18.1996*/
				symbol = node->entry.Template.symbol;
				if (node->variant == ASSGN_OP) {
					is_inited=1;
					ele = node;
					node = node->entry.Template.ll_ptr1;
					symbol = node->entry.Template.symbol;
					if (symbol && (symbol->attr & 
					   PARAMETER_BIT) || (attr_option & 
					   PARAMETER_BIT))
						symbol->entry.Template.const_value = ele->entry.Template.ll_ptr2;
					if (newtype) symbol->type = newtype;
					if (!is_init_valid(symbol,attr_option))
						error3(458,symbol->ident);

					if (!check_initialization_expr(ele->entry.Template.ll_ptr2)) {
                                		error1(192);
                                	}
					else check_initialization_assign_compatiable(symbol,ele->entry.Template.ll_ptr2);
				}
				symbol = node->entry.Template.symbol;
/*			zheng.gb 1996.5.20
				sym = search_symb_decl(symbol);
				if (sym->variant == FUNCTION_NAME  )
				{
					sym->type = symbol->type;
					node->entry.Template.symbol = sym;
					symbol = sym;
				}
*/
				check_var_ref(symbol,attr_option);
				if (node->variant == VAR_REF) 
					array_range = range;
				else array_range = node->entry.Template.ll_ptr1;
				check_array_range(array_range);
				if ((attr_option & POINTER_BIT) ||
				    (attr_option & ALLOCATABLE_BIT) ||
				    (symbol->attr & POINTER_BIT) ||
				    (symbol->attr & ALLOCATABLE_BIT)){
					if (!array_range) 
					/*	error3(443,symbol->ident)*/ ;
					else if (!is_defer(array_range))
						error3(443,symbol->ident);
				}
				if ((symbol->entry.var_decl.local == OUTPUT) &&
				    !(attr_option & POINTER_BIT) &&
				    !(symbol->attr & POINTER_BIT))
					if (!is_exp_shape(array_range))
						error3(443,symbol->ident);
				if (newtype) {
					if (!isStringType(newtype)) 
						error3(454,symbol->ident);
				}
				else if (!isStringType(symbol->type))
					error3(454,symbol->ident);
				if (newtype) 
					symbol->type = newtype;
						/* add by zheng.gb */
				if (isStringType(symbol->type))
					if (is_const_size_string(symbol))
					{
						if (!check_initialization_expr(
							char_len))
						error1(177);
                                	}
					else
					{
						llnd = char_len->entry.
							Template.ll_ptr1;
						sym=llnd->entry.Template.symbol;
						if (llnd->variant==VAR_REF&&sym &&strcmp(sym->ident,"*")
							==0);
						else
						  if (err_code=check_spec_expr(char_len->entry.Template.ll_ptr1))
							error1(err_code);
					}
				symbol->decl = HARD;
				break;
		}
		if (attr_option & PARAMETER_BIT)
			if (is_inited==0)
				error3(476,symbol->ident);
		/* if is array , check if must be a dummy */
		if (array_range) {
			if (is_assume_size(array_range) )
                          	{  /*  must be a dummy */
                                	if (symbol->entry.var_decl.local != IO)
                                        	error3(480,symbol->ident);
                          	}
                          	else if (is_assume_shape(array_range)
                                	&& (symbol->attr & POINTER_BIT) ==0 
					&& (symbol->attr & ALLOCATABLE_BIT)==0 )
                               	     { /*assume_shape_array have no pointer attr
                                        but be a dummy . P.48  */
                                	if (symbol->entry.var_decl.local != IO)
                                        	error3(481,symbol->ident);
                               	     }
		}  /* if(range) */
	}  /* for */
}


/************************************************************************
*       function name : check_dim_stmt                                  *
*       input parameter : NONE                                          *
*       output :  NONE                                                  *
*       function : check the dimension statement                        *
************************************************************************/

int check_dim_stmt()
{
	PTR_LLND  expr_list,ele;
	PTR_SYMB  symbol;

	for (expr_list=cur_bfnd->entry.Template.ll_ptr1;
		expr_list; expr_list=expr_list->entry.Template.ll_ptr2)
	{
		ele=expr_list->entry.Template.ll_ptr1;
		symbol = ele->entry.Template.symbol;
	
		/***** check if the range of this array is correct *****/
		if (!ele->entry.Template.ll_ptr1) 
			error3(442,ele->entry.Template.symbol->ident);
		else if (!(is_defer(ele->entry.Template.ll_ptr1) ||
			is_exp_shape(ele->entry.Template.ll_ptr1) ||
			is_assume_shape(ele->entry.Template.ll_ptr1) ||
			is_assume_size(ele->entry.Template.ll_ptr1)))
			error3(442,ele->entry.Template.symbol->ident);
						/* zheng.gb 1996.5.22 */
		     else if (is_assume_size(ele->entry.Template.ll_ptr1) )
			  {  /*  must be a dummy */
				if (symbol->entry.var_decl.local != IO)
					error3(480,symbol->ident);
			  }
			  else if (is_assume_shape(ele->entry.Template.ll_ptr1)
				&& (symbol->attr & POINTER_BIT) ==0 
				&& (symbol->attr & ALLOCATABLE_BIT)==0 )
			       {  /*  assume_shape_array have no pointer attr
					but be a dummy . P.48  */
				if (symbol->entry.var_decl.local != IO)
                                        error3(481,symbol->ident);
			       }
		/*sym = search_symb_decl(symbol);   zheng.gb 1996.5.20 */
		if (symbol->variant == FUNCTION_NAME )
		{
			error3(405,symbol->ident);
		}
		symbol->decl = HARD;
	}
}


/************************************************************************
*       function name : check_save_object                               *
*       input parameter : symbol,       symbol pointer of save object   *
*       return value :  0, correct                                      *
*                       1, error                                        *
*       function : check the save object                                *
************************************************************************/

int check_save_object(symbol)
PTR_SYMB symbol;
{
	PTR_TYPE base_type;
	PTR_BFND scope;

	scope = cur_scope();

	/***** if the save object is a dummmy *****/
	if (symbol->entry.var_decl.local == IO) {
		error3(402,symbol->ident);
		return 1;
	}

	/***** if this save object is an automatic object *****/
	if (symbol->variant == VARIABLE_NAME) {
		base_type = get_base_type(symbol->type);
		if (base_type->variant == T_STRING) {
			if (is_const_size_string(symbol)==0) {
				error3(404,symbol->ident);
				return 1;
			}
		}
		if (symbol->type->variant == T_ARRAY)
			if (type_size(symbol) == -1) {
				error3(404,symbol->ident);
				return 1;
			}
	}

	/***** if this save object is a function result name *****/
	if (symbol->entry.var_decl.local == OUTPUT) {
		error3(407,symbol->ident);
		return 1;
	}
	if (is_result_name(symbol,scope)) {
                error3(482,symbol->ident);
		return 1;
	}

	/***** if this save object is a common object *****/
	if (symbol->entry.Template.common_link.common_item != CNTNULL) {
		error3(418,symbol->ident);
		return 1;
	}
	
	/***** if this save object has PARAMETER attribute *****/
	if (symbol->attr & PARAMETER_BIT) {
		error3(419,symbol->ident);
		return 1;
	}

	/***** if this save object is a procedure name *****/
	if (symbol->variant == PROCEDURE_NAME) {
		error3(420,symbol->ident);
		return 1;
	}
}

/************************************************************************
*       function name : check_save_decl_stmt                            *
*       input parameter : NONE                                          *
*       output : NONE                                                   *
*       extern variable : save_flag,    appearing flag of save statement*
*                                         or save attribute             *
*                         empty_save_flag, appearing flag of empty save *
*                                               statement               *
*       function : check the save statement                             *
************************************************************************/

int check_save_decl_stmt()
{
	PTR_LLND  expr_list,ele;
	PTR_SYMB  symbol;

	/* An empty save statement has appeared in this scope unit, error */
	if (empty_save_flag) {
		error1(417);
	};

	/* Someother save statements or save attributes have appeared, and
		this save statement is an empty save statement, error */
	if (save_flag && cur_bfnd->entry.Template.ll_ptr1 == LLNULL) {
		error1(417);
	};

	/* set the flag of appearing of save statement */
	save_flag = 1;

	/* set the flag of appearing of empty save statement */
	if (cur_bfnd->entry.Template.ll_ptr1 == LLNULL) {
		empty_save_flag = 1;
	};

	for (expr_list=cur_bfnd->entry.Template.ll_ptr1;
		expr_list; expr_list=expr_list->entry.Template.ll_ptr2)
	{
		symbol = expr_list->entry.Template.ll_ptr1->entry.Template.symbol;
		/* sym = search_symb_decl(symbol);  zheng.gb 1996.5.20 */
		if (symbol->variant == FUNCTION_NAME )
		{
			error3(405,symbol->ident);
		}
		symbol->decl = HARD;
		if (check_save_object(symbol)!=1) 
			symbol->attr = symbol->attr || SAVE_BIT;
	}
}


/************************************************************************
*       function name : check_param_decl                                *
*       input parameter : NONE                                          *
*       output : NONE                                                   *
*       function : check parameter statement                            *
************************************************************************/

int check_param_decl()
{
	PTR_LLND ptr,const_value;
	PTR_SYMB symbol;
	int i;

	ptr = cur_bfnd->entry.Template.ll_ptr1;
	for (ptr;ptr;ptr=ptr->entry.Template.ll_ptr2) 
	{
			/* add by zheng.gb only integer type can be counted*/
		const_value = ptr->entry.Template.ll_ptr1->
			entry.Template.symbol->entry.Template.const_value;
		check_expr_type(const_value);	
		if (isInteger(const_value) && is_scalar(const_value->type)) {
			i = comput_const_expr(const_value,1);
			if (i!=0) {
			    error3(414,ptr->entry.Template.ll_ptr1->entry.Template.symbol->ident);
			};
		}           /* if */

		symbol = ptr->entry.Template.ll_ptr1->entry.Template.symbol;
		/* sym = search_symb_decl(symbol);    zheng.gb 1996.5.20 */
		if (symbol->variant == FUNCTION_NAME )
		{
			error3(405,symbol->ident);
		}
		symbol->decl=HARD;
	}			/* for */
	return (0);
}


/************************************************************************
*       function name : common_object_check                             *
*       input parameter : PTR_SYMB symbol ; common object variable      *
*                         PTR_LLND dimension; if symbol is a array      *
*                                               object, dimension point *
*                                               dimension describetion  *
*       output : 0 ; this object is a valid common object               *
*                1 ; this object is a illeagal common object and write  *
*                               the error code in error report file             *       function : check if a common object is valid                    *
************************************************************************/

int common_object_check(symbol,dimension)
PTR_SYMB symbol;        /* a pointer, point the common object variable */
PTR_LLND dimension;     /* a pointer, point the dimension describetion */
{
	PTR_LLND bound_ptr,range_ptr;   /* bound_ptr is a pointer which point
						the up and down boundary;
					   range_ptr is a pointer which point
						the subscript of a variable 
						with dimension attribute */
	int i;
	PTR_TYPE base_type;

	/***** if this variable has been implicitly declarated. *****/
	if (check_sym_type(symbol)==0) return(1); 

	/****** if this variable is a variable name ******/
	if (symbol->variant != VARIABLE_NAME) {  
		error1(411);
		return(1);
	}

	/***** use or host association *****/
	if (symbol->scope != cur_scope()) {
		error3(412,symbol->ident);
		return(1);
	}

	/***** if this variable appear more than once in common block *****/
	if (symbol->entry.Template.common_link.group_next != SMNULL) {
		error3(401,symbol->ident);
		return(1);
	}

	/***** if this variable is an allocatable array *****/
	if (symbol->attr & ALLOCATABLE_BIT) {
		error3(403,symbol->ident);
		return(1);
	}

	/***** if this variable has save attribute *****/
	if (symbol->attr & SAVE_BIT) {
		error3(418,symbol->ident);
		return(1);
	}

	/***** if this variable is a dummy argument *****/
	if (symbol->entry.var_decl.local == IO) {
		error3(402, symbol->ident);
		return(1);
	}

	/***** if this variable is an automatic variable *****/
	base_type = get_base_type(symbol->type);
	if (base_type->variant == T_STRING)
		if (is_const_size_string(symbol)==0) {
			error3(404,symbol->ident);
			return(1);
		}
	if (symbol->type->variant == T_ARRAY) 
		if (type_size(symbol)==-1) {
			error3(404,symbol->ident);
			return(1);
		}

	/***** if this variable is a result name *****/
	if (symbol->entry.var_decl.local == OUTPUT) {
		error3(407,symbol->ident);
		return(1);
	}
/* if each bound of this variable is a constant specification expression */
	if (dimension != LLNULL) {
		for (bound_ptr=dimension;bound_ptr;bound_ptr=bound_ptr->entry.Template.ll_ptr2) {
			range_ptr = bound_ptr->entry.Template.ll_ptr1;
			i = comput_const_expr(range_ptr->entry.Template.ll_ptr1->entry.Template.ll_ptr2,1);
			if (i!=0) {
				error3(408,symbol->ident);
				return(1);
			}
			if (range_ptr->entry.Template.ll_ptr1->entry.Template.ll_ptr1 != LLNULL) {
				if (comput_const_expr(range_ptr->entry.Template.ll_ptr1->entry.Template.ll_ptr1,1)!=0) {
					error3(408,symbol->ident);
					return (1);
				}
			}
		}
		
	}

	/***** this variable's type is a derived type *****/
	if (symbol->type->name!=SMNULL) {
		if ((symbol->type->name->attr & SEQUENCE_BIT) == 0) {
			error3(409,symbol->ident);
			return(1);
		}
	}

/* if a variable with explicit-shape-spec-list has the POINTER attribute*/
	if ((dimension != LLNULL) && (symbol->attr & POINTER_BIT) != 0){
		error3(410,symbol->ident);
		return(1);
	}


	return(0);
}


/************************************************************************
*       function name : make_common_list                                *
*       input parameter : PTR_LLND comm_list; a llnd pointer, point the *
*                                               common object list of   *
*                                               one common block        *
*       output : NONE                                                   *
*       function : make common link of a common block                   *
************************************************************************/

int make_common_list(comm_list)
PTR_LLND comm_list;     /* a llnd pointer, point the common object list of one
				common block */
{
	PTR_BFND header;/* point the first common object of the common object
			 list */ 
	PTR_CNT  common_name_table,common_ptr;/* common_name_table : point the
							common name table of                                                            current program scope
							unit 
						 common_ptr : point the item of
							common name table which
							is the processing common
							block   */
	int      check_flag=0;
	PTR_SYMB symbol;
	PTR_LLND object_ptr,expr_ptr;
	int      length,offset;
	PTR_CNT  common_first;

	header = cur_scope();
	switch (header->variant) {
				/* initialize the common_name_table by the
					common name table of current program 
					scope unit */
		case PROG_HEDR :
		case MODULE_STMT :
			common_name_table = header->entry.Template.symbol->entry.prog_decl.common_table;
			break;
		case MODULE_PROC_STMT :
		case PROC_HEDR :
			common_name_table = header->entry.Template.symbol->entry.proc_decl.common_table;
			break;
		case FUNC_HEDR :
			common_name_table = header->entry.Template.symbol->entry.func_decl.common_table;
			break;
		case BLOCK_DATA : 
			common_name_table = header->entry.Template.symbol->entry.Template.common_table;
			break;
	};

/****************************************************************************
	search in current program scope unit common name table with this 
	common name, if successful, check_flag = 1,
			otherwise,  check_flag = 0, this is a new common block
****************************************************************************/

	common_first = common_name_table;
	while ((common_name_table!=CNTNULL) && (check_flag==0)) { 
		if (common_name_table->symbol == cur_bfnd->entry.Template.symbol)
		{
			/* zheng.gb ??? 1996.6.26 */
			check_flag=1;
			common_ptr=common_name_table;
		}
		else common_name_table = common_name_table->next_common_item;
	};

	if (check_flag==0) {                    /* this common block is new,
						   add a new common table item
						   in common name table of current
						   program scope unit */
		common_ptr=ALLOC(cnt);
		common_ptr->symbol = comm_list->entry.Template.symbol;
		common_ptr->ft = SMNULL;
		common_ptr->lt = SMNULL;
		common_ptr->size = 0;
		common_ptr->attr = 0;
		common_ptr->next_common_item = common_first;
		switch (header->variant) {
			case PROG_HEDR :
			case MODULE_STMT :
				header->entry.Template.symbol->entry.prog_decl.common_table = common_ptr;
				break;
			case PROC_HEDR : 
			case MODULE_PROC_STMT :
				header->entry.Template.symbol->entry.proc_decl.common_table = common_ptr;
				break;
			case FUNC_HEDR :
				header->entry.Template.symbol->entry.func_decl.common_table = common_ptr;
				break;
			case BLOCK_DATA :
				header->entry.Template.symbol->entry.Template.common_table = common_ptr;
				break;
		}
	};

/*************************************************************************
	processing the common object list, the common table item which
	these common objects included is pointed by varaible 'common_ptr
*************************************************************************/ 

	object_ptr = comm_list;
			/* comm_list => EXPR_LIST */
	comm_list=comm_list->entry.Template.ll_ptr1;
	while (comm_list) {
		check_type_ref(comm_list->entry.Template.ll_ptr1);
                symbol=get_var_name(comm_list->entry.Template.ll_ptr1);
		symbol->decl = HARD;
		expr_ptr = comm_list->entry.Template.ll_ptr1->entry.Template.ll_ptr1;
/*                      zheng.gb 1996.5.20 
		expr_ptr = comm_list->entry.Template.ll_ptr1->entry.Template.ll_ptr1->entry.Template.ll_ptr1;
		if (object_ptr==comm_list) 
			comm_list = comm_list->entry.Template.ll_ptr1->entry.Template.ll_ptr2;
		else comm_list = comm_list->entry.Template.ll_ptr2;
*/
		comm_list = comm_list->entry.Template.ll_ptr2;
		if (common_object_check(symbol,expr_ptr)==0) {
			if (common_ptr->ft==SMNULL) {
				symbol->entry.Template.common_link.previouse = SMNULL;
				symbol->entry.Template.common_link.next = SMNULL;
				common_ptr->ft = symbol;
				common_ptr->lt = symbol;
				offset = 0;
			}
			else {
				symbol->entry.Template.common_link.next = SMNULL;
				symbol->entry.Template.common_link.previouse = common_ptr->lt;
				offset = common_ptr->lt->entry.Template.common_link.offset + type_size(common_ptr->lt->type);
				common_ptr->lt->entry.Template.common_link.next = symbol;
				common_ptr->lt = symbol;
			};
			symbol->entry.Template.common_link.common_item = common_ptr;
			symbol->entry.Template.common_link.offset = offset;
			length = type_size(symbol->type);
			if (common_ptr->attr == 1) {
				if (symbol != common_ptr->ft)
					symbol->entry.Template.common_link.previouse->entry.Template.common_link.group_next = symbol;
				symbol->entry.Template.common_link.group_next = common_ptr->ft;
			}
			else if (offset < common_ptr->size) {
				symbol->entry.Template.common_link.group_next = symbol->entry.Template.common_link.previouse->entry.Template.common_link.group_next;
				symbol->entry.Template.common_link.previouse->entry.Template.common_link.group_next = symbol;
			}
			else symbol->entry.Template.common_link.group_next = symbol;
			if (offset+length-1>common_ptr->size)
				common_ptr->size = offset + length;
		}
	}
	
}

int check_comm_stmt()
{
	PTR_LLND comm_list,ele;
	PTR_BFND cur_header;
	struct cnt * ptr;
	struct cnt * scope_common_table;
	PTR_SYMB symbol;

	for (comm_list=cur_bfnd->entry.Template.ll_ptr1;
		comm_list; comm_list=comm_list->entry.Template.ll_ptr2)
		make_common_list(comm_list);
/*	cur_header = cur_scope();
	switch(cur_header->variant) {
		case PROG_HEDR :
		case MODULE_STMT :
			scope_common_table = cur_header->entry.Template.symbol->entry.prog_decl.common_table;
			break;
		case MODULE_PROC_STMT :
		case PROC_HEDR :
			scope_common_table = cur_header->entry.Template.symbol->entry.proc_decl.common_table;
			break;
		case FUNC_HEDR :
			scope_common_table = cur_header->entry.Template.symbol->entry.func_decl.common_table;
			break;
		case BLOCK_DATA :
			scope_common_table = cur_header->entry.Template.symbol->entry.Template.common_table;
			break;
	}
	for (ptr = scope_common_table; ptr ; ptr = ptr->next_common_item) {
		printf("\n%s:   ",ptr->symbol->ident);
		for (symbol = ptr->ft; symbol; symbol = symbol->entry.Template.common_link.next)
		 	printf("%s,",symbol->ident);
	}*/
}


/************************************************************************
*       function name : check_derived_pointer                           *
*       input parameter : symbol,       a pointer pointing components of*
*                                         derived type                  *
*       output : 0,     there is no component with pointer attribute    *
*                1,     there is a component with pointer attribute     *
*       function : checking if there is any component of a derived type *
*                       with pointer attribute                          *
************************************************************************/

int check_derived_pointer(symbol)
PTR_SYMB symbol;
{
	PTR_SYMB        tmp_symbol;

	for (symbol;symbol;symbol=symbol->entry.field.next) {
		if (symbol->attr & POINTER_BIT) 
			return 1;
		if (symbol->entry.field.base_name != SMNULL) {
			tmp_symbol = symbol->entry.field.base_name;
			if (check_derived_pointer(tmp_symbol)) 
				return 1;
			}
		}
	return 0;       
}


/************************************************************************
*       function name : check_equi_object                               *
*       input parameter : PTR_SYMB symbol,      equivalence object      *
*                         PTR_LLND range,       if this object is an    *
*                                               array, range point the  *
*                                               dimension describetion  *
*       output : 0, this object is a valid equivalence object           *
*                1, this object is a illeagal equivalence object        *
*       fucntion : check if an equivalence object is valid              *
************************************************************************/

int check_equi_object(symbol,range)
PTR_SYMB  symbol;
PTR_LLND  range;
{
	PTR_SYMB        tmp_symbol;     /* for checking if there is a component
						of a derived type which has
						pointer attribute */
	PTR_TYPE	base_type;

	/***** if this object is a pointer *****/
	if ((symbol->attr & POINTER_BIT) !=0) {
		error3(410,symbol->ident);
		return 1;
	}

	/***** if this object is a dummy *****/
	if (symbol->entry.var_decl.local == IO) {
		error3(402,symbol->ident);
		return 1;
	}

	/***** if this object is an allocatable array *****/
	if (symbol->attr & ALLOCATABLE_BIT) {
		error3(403,symbol->ident);
		return 1;
	}

	/***** if this object is an object of nosequence derived type *****/
	if (symbol->type->variant == T_RECORD) {
		if (symbol->type->name != SMNULL)
			if ((symbol->type->name->attr & SEQUENCE_BIT) == 0) {
				error3(409,symbol->ident);
				return 1;
			}
	}

	/***** if this object is an automatic object *****/
	base_type = get_base_type(symbol->type);
	if (base_type->variant == T_STRING ) 
		if (is_const_size_string(symbol)==0) {
			error3(404,symbol->ident);
			return 1;
		}
	if (symbol->type->variant == T_ARRAY)
		if (type_size(symbol) == -1) {
			error3(404,symbol->ident);
			return 1;
		}

	/***** if this object is a function name *****/
	if (symbol->variant == FUNCTION_NAME) {
		error3(421,symbol->ident);
		return 1;
	}

	/***** if this object is a variable which is accessible *****/
	/***** by use or host association *****/
	if (symbol->scope != cur_scope()) {
		error3(412,symbol->ident);
		return 1;
	}

	/***** if this object has been implicitly declarated *****/
	if (check_sym_type(symbol)==0) 
		return 1;
	
	/***** if this object is a result name *****/
	if (symbol->entry.var_decl.local == OUTPUT) {
		error3(407,symbol->ident);
		return 1;
	}

	/***** if this object is a const *****/
	if (symbol->attr & PARAMETER_BIT) {
		error3(422,symbol->ident);
		return 1;
	}

	/***** if this object is an entry name *****/
	if (symbol->attr & ENTRY_BIT) {
		error3(423,symbol->ident);
		return 1;
	}
	
	/***** if this object is an variable with derived type *****/
	/***** and this derived type is a sequence type *****/
	if ((symbol->type->name != SMNULL) 
	     && (symbol->type->name->attr & SEQUENCE_BIT)) {
		tmp_symbol = symbol->type->entry.re_decl.first;
		if (check_derived_pointer(tmp_symbol)) {
			error3(424,symbol->ident);
			return 1;
		}
	}
	
	return 0;
}

int array_element_offset(symbol,range)
PTR_SYMB symbol;
PTR_LLND range;
{
	int offset,size,d,width,up,bottom;
	PTR_LLND type,range1;
	
	type = symbol->type->entry.ar_decl.ranges;
	size = 1;
	offset = 1;
	range1 = range;
	for (type,range1;type && range1;type=type->entry.Template.ll_ptr2,range1=range1->entry.Template.ll_ptr2) {
		if (range1->entry.Template.ll_ptr1->variant == DDOT )
			return(-1);
		if (comput_const_expr(range1->entry.Template.ll_ptr1,1)) 
			return (-1);
		else d = range1->entry.Template.ll_ptr1->const_val;
		if (comput_const_expr(type->entry.Template.ll_ptr1->entry.Template.ll_ptr1->entry.Template.ll_ptr2,1)) 
			return(-1);
		else up = type->entry.Template.ll_ptr1->entry.Template.ll_ptr1->entry.Template.ll_ptr2->const_val;
		if (type->entry.Template.ll_ptr1->entry.Template.ll_ptr1->entry.Template.ll_ptr1 != LLNULL) { 
			if (comput_const_expr(type->entry.Template.ll_ptr1->entry.Template.ll_ptr1->entry.Template.ll_ptr1,1))
				return(-1);
			else bottom = type->entry.Template.ll_ptr1->entry.Template.ll_ptr1->entry.Template.ll_ptr1->const_val;
		}
		else bottom = 1;
		if (d<bottom || d>up) return (-1);
		if (bottom > up) width = 0;
		else width = up - bottom + 1;
		offset = offset + size * (d - bottom);
		size = size * width;
	}
	return (offset);
}

int evaluate_offset(base,symbol,range,offset)
int base;
PTR_SYMB symbol;
PTR_LLND range;
int * offset;
{

	
	if (symbol->type->variant == T_ARRAY) {
		*offset = array_element_offset(symbol,range);
		if (*offset == -1) {
			error3(415,symbol->ident);
			return (1);
		}
		else {
			*offset = base-(*offset-1)*type_size(symbol->type->entry.ar_decl.base_type);
			return (0);
		}
	}
	else {
		*offset = 0;
		return (0);
	}
}

int make_equi_ring(equi_list)
PTR_LLND equi_list;
{
	PTR_SYMB previous,header,symbol,sym;
	PTR_LLND range;
	int base = 0;
	int offset;
	PTR_MR_LINK mr;

	previous = SMNULL;
	header = SMNULL;


	for (equi_list;equi_list;equi_list = equi_list->entry.Template.ll_ptr2){
/*                       zheng.gb 1996.5.20 
		check_leaf_sym(equi_list->entry.Template.ll_ptr1);
*/
		check_type_ref(equi_list->entry.Template.ll_ptr1);
		symbol=get_var_name(equi_list->entry.Template.ll_ptr1);
/*
		symbol = equi_list->entry.Template.ll_ptr1->entry.Template.symbol;
		sym = search_symb_ref(symbol);
		if (sym->variant == FUNCTION_NAME && !strcasecmp(symbol->scope->entry.Template.symbol->ident,sym->ident)) {
			sym->type = symbol->type;
			equi_list->entry.Template.ll_ptr1->entry.Template.symbol = sym;
			symbol = sym;
		}
*/
		symbol->decl = HARD;
		range = equi_list->entry.Template.ll_ptr1->entry.Template.ll_ptr1;
		if (check_equi_object(symbol,range) == 0) {
			if (evaluate_offset(base,symbol,range,&offset)==0) {
				if (header == SMNULL) {
					header = symbol;
					equi_ring_number++;
				}
				mr = ALLOC(mr_link);
				mr->code = equi_ring_number;
				mr->line_number = cur_bfnd->g_line;
				mr->offset = offset;
				mr->next_object = header;
				if (previous != SMNULL) 
				  previous->entry.Template.MR->next_object = symbol;
				previous = symbol;
				mr->next = symbol->entry.Template.MR;
				symbol->entry.Template.MR = mr;
			}
		}
	}
	previous->entry.Template.MR->next_object = header;
}

int check_equi_stmt()
{
	PTR_LLND equi_list;

	for (equi_list = cur_bfnd->entry.Template.ll_ptr1; equi_list;
		equi_list = equi_list->entry.Template.ll_ptr2)
		make_equi_ring(equi_list->entry.Template.ll_ptr1);
}


/************************************************************************
*       function name : make_aggregate_group                            *
*       input paramter : symbol, common block object in an aggregate    *
*                                       group                           *
*                        * first, the first offset of this aggregate    *
*                                       group                           *
*                        * last, the last offset of this aggregate      *
*                                       group                           *
*       output : first,last, if last < first then error                 *
*       function : make an aggregate group in a common link , introduced*
*                       by an equivalence link                          *
************************************************************************/
	
int make_aggregate_group(symbol,first,last)
PTR_SYMB symbol;
int * first;
int * last;
{
	PTR_SYMB        tmp,previouse,ft,lt;
	int             i;

/*	*first = symbol->entry.Template.eq_link.offset;
	*last = *first + type_size(symbol->type) - 1;
	tmp = symbol->entry.Template.eq_link.next;
	while (tmp != symbol) {
		if (*first > tmp->entry.Template.eq_link.offset) 
			*first = tmp->entry.Template.eq_link.offset;
		i = tmp->entry.Template.eq_link.offset + type_size(tmp->type) -1;
		if (*last < i)
			*last = i; 
	}*/

	if (symbol->entry.Template.eq_link.offset - *first > symbol->entry.Template.common_link.offset) {
		error3(416,symbol->entry.Template.common_link.common_item->symbol->ident);
		return 1;
	}
	tmp = symbol;
	while (tmp->entry.Template.common_link.next == tmp->entry.Template.common_link.group_next)
		tmp = tmp->entry.Template.common_link.next;
	ft = tmp->entry.Template.common_link.group_next;
	lt = tmp;

	if (*first < ft->entry.Template.common_link.offset - symbol->entry.Template.common_link.offset + symbol->entry.Template.eq_link.offset) {
		while (ft->entry.Template.common_link.offset - symbol->entry.Template.common_link.offset 
			> *first - symbol->entry.Template.eq_link.offset) {
			tmp = ft->entry.Template.common_link.previouse;
			lt->entry.Template.common_link.group_next = ft->entry.Template.common_link.group_next;
			tmp->entry.Template.common_link.group_next = ft;
			ft = lt->entry.Template.common_link.group_next;
		}
	}
	*first = ft->entry.Template.common_link.offset - symbol->entry.Template.common_link.offset + symbol->entry.Template.eq_link.offset;

	tmp = symbol->entry.Template.common_link.common_item->lt;
	if (*last >= tmp->entry.Template.eq_link.offset + type_size(tmp->type) + tmp->entry.Template.common_link.offset - symbol->entry.Template.common_link.offset -1) {
		tmp->entry.Template.common_link.group_next = ft;
		lt = tmp;
		for (tmp = symbol; tmp;
			 tmp = tmp->entry.Template.common_link.next) 
			tmp->entry.Template.common_link.group_next = tmp->entry.Template.common_link.next;
		i = symbol->entry.Template.eq_link.offset + symbol->entry.Template.common_link.common_item->size - symbol->entry.Template.common_link.offset - 1;
		if (*last <= i) *last = i;
		else symbol->entry.Template.common_link.common_item->size = *last - symbol->entry.Template.eq_link.offset + symbol->entry.Template.common_link.offset;
	}
	else {
		while (*last - symbol->entry.Template.eq_link.offset + 1 > type_size(lt->type) + lt->entry.Template.common_link.offset - symbol->entry.Template.common_link.offset) {
			tmp = lt->entry.Template.common_link.next;
			lt->entry.Template.common_link.group_next = tmp;
			while (tmp->entry.Template.common_link.next == tmp->entry.Template.common_link.group_next) 
				tmp = tmp->entry.Template.common_link.next;
			tmp->entry.Template.common_link.group_next = ft;
		}
		*last = symbol->entry.Template.eq_link.offset + lt->entry.Template.common_link.offset + type_size(lt->type) - symbol->entry.Template.common_link.offset - 1;
	}
}

int merge_equivalence(symbol,link_header)
PTR_SYMB symbol;
struct equi_link_ring * link_header;
{
	PTR_SYMB header,merge_current,current,previous,eq_previous,mr_previous;
	int base_offset,first, last,mr_offset,code,offset,tmp;
	PTR_MR_LINK current_ring,previous_ring;
	
	header = symbol;
	previous = SMNULL;
	first = header->entry.Template.MR->offset;
	last = type_size(symbol->type)+first-1;
	header->entry.Template.eq_link.offset=first;
	header->entry.Template.eq_link.next=header;
	merge_current=header;
	link_header->header = header;
	link_header->next = NULL;
	if (header->entry.Template.common_link.common_item != CNTNULL)
		link_header->common_object = header;
	else link_header->common_object = SMNULL;
	while (merge_current != header || merge_current->entry.Template.MR != MRNULL) {
		base_offset = merge_current->entry.Template.eq_link.offset;
		while (merge_current->entry.Template.MR != MRNULL) {
			equi_ring_number--;
			code=merge_current->entry.Template.MR->code;
			eq_previous = merge_current;
			mr_previous = merge_current;
			mr_offset = merge_current->entry.Template.MR->offset - base_offset;
			current = merge_current->entry.Template.MR->next_object;
			current_ring = merge_current->entry.Template.MR;
			merge_current->entry.Template.MR = current_ring->next;
			free(current_ring);
			while (current != merge_current) {
				current_ring = current->entry.Template.MR;
				while (current_ring != MRNULL && code != current_ring->code) {
					previous_ring = current_ring;
					current_ring = current_ring->next;
				}
				if (current_ring == MRNULL) {
					printf("Abort!!!!\n");
					exit(0);
				}
				offset = current_ring->offset-mr_offset;
				if (current->entry.Template.eq_link.next!=SMNULL &&
					offset!=current->entry.Template.eq_link.offset) 
					error3(415,current->ident);
				else if (current->entry.Template.eq_link.next == SMNULL) {
					current->entry.Template.eq_link.offset = offset;
					current->entry.Template.eq_link.next = eq_previous->entry.Template.eq_link.next;
					eq_previous->entry.Template.eq_link.next = current;
					eq_previous = current;
					tmp = offset + type_size(current->type) -1;
					if (offset < first) first = offset;
					if (last < tmp) last = tmp;
					if ((current->entry.Template.common_link.common_item!= CNTNULL) 
						&& (link_header->last>=link_header->first)) {
						if (current->entry.Template.common_link.offset<current->entry.Template.eq_link.offset-first)
							error3(416,current->entry.Template.common_link.common_item->symbol->ident);
						else if (current->entry.Template.common_link.common_item->size-current->entry.Template.common_link.offset<last-offset)
							current->entry.Template.common_link.common_item->size=current->entry.Template.common_link.offset+last-offset;
						if (link_header->common_object == SMNULL) 
							link_header->common_object = current;
						if (current->entry.Template.common_link.common_item != link_header->common_object->entry.Template.common_link.common_item) {
							error4(440,current->ident,link_header->common_object->ident);
							link_header->last=link_header->first-1;
						}       
						else if (current->entry.Template.common_link.offset - link_header->common_object->entry.Template.common_link.offset != current->entry.Template.eq_link.offset - link_header->common_object->entry.Template.eq_link.offset) {
							error3(441,current->ident);
							link_header->last=link_header->first-1;
						}
						else if (current->entry.Template.eq_link.offset - first > current->entry.Template.common_link.offset)
							link_header->last=link_header->first-1;
					}
				}
				if (current_ring == current->entry.Template.MR)
					current->entry.Template.MR = current_ring->next;
				else previous_ring->next = current_ring->next;
				current = current_ring->next_object;
				free(current_ring);
			}
		}
		merge_current = merge_current->entry.Template.eq_link.next;
	}
	if (link_header->last>=link_header->first) {
		link_header->first = first;
		link_header->last = last;
	}
}

int common_equi_process()
{
	PTR_SYMB symbol,tmp;
	PTR_BFND cur_header;
	struct equi_link_ring * header;
	struct equi_link_ring * last;
	struct equi_link_ring * ptrtmp;
	struct cnt * scope_common_table;
	struct cnt * ptr;

	cur_header = cur_scope();
if (debug1) printf("CUR_SCOPE:%s .\n",cur_header->entry.Template.symbol->ident);
	switch(cur_header->variant) {
		case PROG_HEDR :
		case MODULE_STMT :
			scope_common_table = cur_header->entry.Template.symbol->entry.prog_decl.common_table;
			break;
		case MODULE_PROC_STMT :
		case PROC_HEDR:
			scope_common_table = cur_header->entry.Template.symbol->entry.proc_decl.common_table;
			break;
		case FUNC_HEDR :
			scope_common_table = cur_header->entry.Template.symbol->entry.func_decl.common_table;
			break;
		case BLOCK_DATA : 	
			scope_common_table = cur_header->entry.Template.symbol->entry.Template.common_table;
			break;
	}
	ptr = scope_common_table;
	while(ptr) {
	  if (ptr->ft != SMNULL) {
		if ((ptr->attr == 1) || 
		    ((empty_sequence_directive) && ((ptr->symbol->attr & NOSEQUENCE_BIT) != 0))) {
			for (symbol = ptr->ft; symbol != ptr->lt;
				symbol = symbol->entry.Template.common_link.next)
				symbol->entry.Template.common_link.group_next = symbol->entry.Template.common_link.next;
			ptr->lt->entry.Template.common_link.group_next = ptr->ft;
			ptr->attr = 1;
		}
	  }
	  else if ((empty_sequence_directive) && ((ptr->symbol->attr & NOSEQUENCE_BIT) != 0))
		ptr->attr = 1;
	  ptr = ptr->next_common_item;
	}

	header = NULL;
	while (equi_ring_number>0)
		for (symbol=cur_bfnd->control_parent->entry.Template.symbol->thread;symbol;symbol=symbol->next_symb)
			if (symbol->variant == VARIABLE_NAME && symbol->scope != BFNULL ) {
				if (symbol->entry.Template.MR != MRNULL) {
					ptrtmp = ALLOC(equi_link_ring);
					ptrtmp->header=symbol;
					ptrtmp->common_object = SMNULL;
					ptrtmp->first=0;
					ptrtmp->last=0;
					ptrtmp->next=0;
					if (header == NULL) {
						header=ptrtmp;
						last = ptrtmp;
					}
					else {
						last->next = ptrtmp;
						last = ptrtmp;
					}
					while (symbol->entry.Template.MR != MRNULL) {
						tmp = symbol;
						merge_equivalence(tmp,ptrtmp);
					}
				}
			}
	for (ptrtmp = header; ptrtmp; ptrtmp=ptrtmp->next)
		if (ptrtmp->common_object != SMNULL)
			make_aggregate_group(ptrtmp->common_object,&(ptrtmp->first),&(ptrtmp->last));
	for (ptrtmp = header; ptrtmp; ptrtmp=ptrtmp->next) {
		symbol = ptrtmp->header;
		if ((symbol->entry.Template.eq_link.offset==ptrtmp->first) &&
			(type_size(symbol->type) == ptrtmp->last - ptrtmp->first +1))
			symbol->attr = symbol->attr | COVER_BIT;
		for (symbol = symbol->entry.Template.eq_link.next; symbol != ptrtmp->header;
			symbol = symbol->entry.Template.eq_link.next) 
			if ((symbol->entry.Template.eq_link.offset == ptrtmp->first) && 
				(type_size(symbol->type) == ptrtmp->last - ptrtmp->first + 1)) 
				symbol->attr = symbol->attr | COVER_BIT;
	}
	while (header) {
		last = header;
		header = header->next;
		free(last);
	}
	switch (cur_bfnd->control_parent->variant) {
		case PROG_HEDR :
		case MODULE_STMT :
			scope_common_table = cur_bfnd->control_parent->entry.Template.symbol->entry.prog_decl.common_table;
			break;
		case MODULE_PROC_STMT :
		case PROC_HEDR :
			scope_common_table = cur_bfnd->control_parent->entry.Template.symbol->entry.proc_decl.common_table;
			break;
		case FUNC_HEDR :
			scope_common_table = cur_bfnd->control_parent->entry.Template.symbol->entry.func_decl.common_table;
			break;
						/* by zheng.gb */
		case BLOCK_DATA:
			scope_common_table = cur_bfnd->control_parent->entry.Template.symbol->entry.Template.common_table;
			break;
		default : printf("Abort!... %d %d\n", cur_bfnd->control_parent->variant,cur_bfnd->variant);
			exit(0);
	}

	/***** checking for PURE subroutine *****/
	if (scope_status != NON_PURE) {
		for (symbol=cur_bfnd->control_parent->entry.Template.symbol->thread;symbol;symbol=symbol->next_symb) {
			if (symbol->entry.var_decl.local == IO) {
				if ((symbol->variant != PROCEDURE_NAME) &&
				    ((symbol->attr & POINTER_BIT) == 0))
					if ((symbol->attr & IN_BIT) == 0)
						error3(460,symbol->ident);
			}
			if (symbol->attr & SAVE_BIT)
				error3(447,symbol->ident);
		}
	}
}

int check_dirsequence_attribute()
{
	PTR_SYMB symbol,tmp,field_name;
	PTR_BFND cur_header;

	cur_header = cur_scope();
	if (debug1) printf("CUR_SCOPE:%s .\n",cur_header->entry.Template.symbol->ident);
	for (symbol=cur_bfnd->control_parent->entry.Template.symbol->thread;symbol;symbol=symbol->next_symb) {
		if (symbol->entry.Template.common_link.common_item) {
			if (symbol->entry.Template.common_link.common_item->attr) {
				symbol->attr = symbol->attr | SEQUENCE_BIT;
				symbol->attr &= (~NOSEQUENCE_BIT);
			}
			if (symbol->entry.Template.common_link.group_next != symbol) {
				symbol->attr = symbol->attr | SEQUENCE_BIT;
				symbol->attr &= (~NOSEQUENCE_BIT);
			}
			else if (symbol->entry.Template.eq_link.next) {
				symbol->attr = symbol->attr | SEQUENCE_BIT;
				symbol->attr &= (~NOSEQUENCE_BIT);
			}
		}
		else if (symbol->entry.Template.eq_link.next) {
			symbol->attr = symbol->attr | SEQUENCE_BIT;
			symbol->attr &= (~NOSEQUENCE_BIT);
		}
				/* modified by zheng.gb */
		else if (is_named_var(symbol) && symbol->type && symbol->type->variant == T_ARRAY) {
			if (is_assume_size(symbol->type->entry.Template.ranges))
			{
				symbol->attr = symbol->attr | SEQUENCE_BIT;
				symbol->attr &= (~NOSEQUENCE_BIT);
			}
		}
		else if (symbol->variant == TYPE_NAME) {
			if (symbol->attr & SEQUENCE_BIT)
				for (field_name = symbol->thread; field_name;
					field_name = field_name->next_symb) {
					field_name->attr = field_name->attr | SEQUENCE_BIT;
					field_name->attr &= (~NOSEQUENCE_BIT);
				}
			else for (field_name = symbol->thread; field_name;
				  field_name = field_name->next_symb) {
				field_name->attr = field_name->attr | NOSEQUENCE_BIT;
				field_name->attr &= (~SEQUENCE_BIT);
			}
		}
		if ((symbol->variant == VARIABLE_NAME) && 
		    ((symbol->attr & SEQUENCE_BIT) == 0) && 
		    ((symbol->attr & NOSEQUENCE_BIT) == 0))
			symbol->attr = symbol->attr | NOSEQUENCE_BIT;
	}
}

int check_dirsequence_stmt()

{
	PTR_LLND ptr;
	PTR_SYMB symbol;
	PTR_BFND header;
	PTR_CNT  common_table,tmp;

	if (in_block_data) {
		error1(463);
		return 1;
	}

	ptr = cur_bfnd->entry.Template.ll_ptr1;
	if (!ptr) {
		empty_sequence_directive = 1;
		return 0;
	}
	for (;ptr;ptr=ptr->entry.Template.ll_ptr2) {
		symbol = ptr->entry.Template.ll_ptr1->entry.Template.symbol;
		/* sym = search_symb_decl(symbol);    zheng.gb 1996.5.20 */
		if (symbol->variant == FUNCTION_NAME )
		{
			error3(405,symbol->ident);
		}
		if ((symbol->attr & SEQUENCE_BIT) || (symbol->attr & NOSEQUENCE_BIT))
			error3(449,symbol->ident);
		else if((symbol->entry.var_decl.local == OUTPUT) &&
			(symbol->variant == FUNCTION_NAME) &&
			((symbol->attr | INTRINSIC_BIT) == 0)) 
			error3(450,symbol->ident);
		else {
			symbol->attr = symbol->attr | SEQUENCE_BIT;
			symbol->attr &= (~NOSEQUENCE_BIT);
			if (symbol->variant == COMMON_NAME) {
				header = cur_scope();
				switch (header->variant) {
					case PROG_HEDR :
					case MODULE_STMT :
						common_table = header->entry.Template.symbol->entry.prog_decl.common_table;
						break;
					case PROC_HEDR :
					case MODULE_PROC_STMT :
						common_table = header->entry.Template.symbol->entry.proc_decl.common_table;
						break;
					case FUNC_HEDR :
						common_table = header->entry.Template.symbol->entry.func_decl.common_table;
						break;
					case BLOCK_DATA :
						common_table = header->entry.Template.symbol->entry.Template.common_table;
						break;
				}
				tmp = common_table;
				while (tmp && (tmp->symbol != symbol))
					tmp = tmp->next_common_item;
				if (!tmp) {
					tmp = ALLOC(cnt);
					tmp->ft = SMNULL;
					tmp->lt = SMNULL;
					tmp->symbol = symbol;
					tmp->size = 1;
					tmp->next_common_item=common_table;
					switch (header->variant) {
						case PROG_HEDR :
						case MODULE_STMT :
							header->entry.Template.symbol->entry.prog_decl.common_table = tmp;
							break;
						case PROC_HEDR :
						case MODULE_PROC_STMT :
							header->entry.Template.symbol->entry.proc_decl.common_table = tmp;
							break;
						case FUNC_HEDR :
							header->entry.Template.symbol->entry.func_decl.common_table = tmp;
							break;
						case BLOCK_DATA :
							header->entry.Template.symbol->entry.Template.common_table = tmp;
							break;
					}
				}
				tmp->attr = 1;
			}
		}
	}
}

int check_nosequence_stmt()
{
	PTR_LLND ptr;
	PTR_SYMB symbol,sym;

	if (in_block_data) {
		error1(464);
		return 1;
	}

	ptr = cur_bfnd->entry.Template.ll_ptr1;
	if (ptr==LLNULL) {
		empty_no_sequence_directive = 1;
		return 0;
	}
	for (ptr;ptr;ptr=ptr->entry.Template.ll_ptr2) {
		symbol = ptr->entry.Template.ll_ptr1->entry.Template.symbol;
		/* sym = search_symb_decl(symbol);  zheng.gb 1996.5.20 */
		if (symbol->variant == FUNCTION_NAME )
		{
			error3(405,symbol->ident);
		}
		if ((symbol->attr & SEQUENCE_BIT) || (symbol->attr & NOSEQUENCE_BIT))
			error3(449,symbol->ident);
		else if ((symbol->entry.var_decl.local == OUTPUT) &&
			 (symbol->variant == FUNCTION_NAME) &&
			 ((symbol->attr | INTRINSIC_BIT) == 0))
			error3(450,symbol->ident);
		else {
			symbol->attr = symbol->attr | NOSEQUENCE_BIT;
			symbol->attr &= (~SEQUENCE_BIT);
		}
	}
}

/************************************************************************
*       function name : check_intent_stmt                               *
*       input parameter : NONE                                          *
*       output : NONE                                                   *
*       function : check the intent statement, if it is no right, then  *
*                       report                                          *
************************************************************************/

int check_intent_stmt()
{
	PTR_LLND        expr_list;
	PTR_SYMB        symbol;

	if (in_block_data) {
		error1(465);
		return 1;
	}

	/***** if this intent statement is in a subprogram *****/
	/***** or in a interface body *****/
	if ((in_subprogram != 1) && (in_interface_body == 0)) {
		error1(424);
		return 1;
	}

	/***** check the dummy list *****/
	for (expr_list = cur_bfnd->entry.intent.list; expr_list;
		expr_list = expr_list->entry.Template.ll_ptr2) {
		symbol = expr_list->entry.Template.ll_ptr1->entry.Template.symbol;
		/* sym = search_symb_decl(symbol);  zheng.gb 1996.5.20 */
		if (symbol->variant == FUNCTION_NAME )
		{
			error3(405,symbol->ident);
		}
		symbol->decl = HARD;
		
	/***** if this object is a dummy *****/
		if (symbol->entry.var_decl.local != IO) {
			error3(425,symbol->ident);
		}

	/***** if this object is a name of dummy pointer *****/
		if (symbol->attr & POINTER_BIT) {
			error3(410,symbol->ident);
		}
	
	/***** if this object is a name of dummy procedure *****/
		if (symbol->variant != VARIABLE_NAME) {
			error3(426,symbol->ident);
		}
	}
}


/************************************************************************
*       function name : check_optional_stmt                             *
*       input parameter : NONE                                          *
*       output : NONE                                                   *
*       function : check the optional statement and report the errors   *
************************************************************************/

int check_optional_stmt()
{
	PTR_LLND        expr_list;
	PTR_SYMB        symbol;

	if (in_block_data) {
		error1(466);
		return 1;
	}

	/***** if this optional statement is in a subprogram *****/
	/***** or in a interface body *****/
	if ((in_subprogram != 1) && (in_interface_body == 0)) {
		error1(427);
		return 1;
	}

	/***** check the dummy list *****/
	for (expr_list = cur_bfnd->entry.Template.ll_ptr1; expr_list;
		expr_list = expr_list->entry.Template.ll_ptr2) {
		symbol = expr_list->entry.Template.ll_ptr1->entry.Template.symbol;
		/* sym = search_symb_decl(symbol); zheng.gb 1996.5.20 */
		if (symbol->variant == FUNCTION_NAME )
		{
			error3(405,symbol->ident);
		}
		symbol->decl = HARD;
	/***** if this object is a dummy *****/
		if (symbol->entry.var_decl.local != IO) {
			error3(425,symbol->ident);
		}
		else symbol->attr = symbol->attr | OPTIONAL_BIT;
	}       
}


/************************************************************************
*       function name : check_access_stmt                               *
*       input parameter : NONE                                          *
*       output : NONE                                                   *
*       function : check access statement , and report errors           *
************************************************************************/

int check_access_stmt()
{
	PTR_LLND        expr_list;
	PTR_LLND        access_expr;
	PTR_SYMB        symbol;

	if (in_block_data) {
		error1(467);
		return 1;
	}

	if (!in_module) {
		error1(479);
		return 1;
	}

	expr_list = cur_bfnd->entry.var_list_decl.list;
	access_expr = cur_bfnd->entry.var_list_decl.access_expr;
	if (expr_list == LLNULL) 
		if (empty_access_stmt) 
			error1(430);
		else if (access_expr->variant == PUBLIC_OP) 
			empty_access_stmt = 1;
		else if (access_expr->variant == PRIVATE_OP) 
			empty_access_stmt =2;
		else error1(430);
	
	for (expr_list;expr_list;
		expr_list = expr_list->entry.Template.ll_ptr2) {
		symbol = expr_list->entry.Template.ll_ptr1->entry.Template.symbol;
		/* sym = search_symb_decl(symbol); zheng.gb 1996.5.20 */

		if (symbol->variant == FUNCTION_NAME)
		{
			error3(405,symbol->ident);
		}
		if (access_expr->variant == PUBLIC_OP)
			symbol->attr = symbol->attr | PUBLIC_BIT;
		else symbol->attr = symbol->attr | PRIVATE_BIT;
		symbol->decl = HARD;
	}
}


/************************************************************************
*       function name : check_allocatable_stmt                          *
*       input parameter : NONE                                          *
*       output : NONE                                                   *
*       function : check the allocatable statement and report errors    *
************************************************************************/

int check_allocatable_stmt()
{
	PTR_LLND        expr_list;
	PTR_LLND        range;
	PTR_SYMB        symbol;

	if (in_block_data) {
		error1(468);
		return 1;
	}

	expr_list = cur_bfnd->entry.Template.ll_ptr1;
	for (expr_list;expr_list;
		expr_list = expr_list->entry.Template.ll_ptr2) {
		symbol = expr_list->entry.Template.ll_ptr1->entry.Template.symbol;
		/* sym = search_symb_decl(symbol);  zheng.gb 1996.5.20 */
		if (symbol->variant == FUNCTION_NAME )
		{
			error3(405,symbol->ident);
		}
		/***** if this object is a dummy *****/
		if (symbol->entry.var_decl.local == IO) 
			error3(402,symbol->ident);

		/***** if this object is a result name *****/
		if (symbol->entry.var_decl.local == OUTPUT)
			error3(407,symbol->ident);

		/***** if this object is a deferred shape array *****/
		if (symbol->type->variant == T_ARRAY) {
			range = symbol->type->entry.ar_decl.ranges;
			if (!is_defer(range))
				error3(428,symbol->ident);
		}
		symbol->attr = symbol->attr | ALLOCATABLE_BIT;
		symbol->decl = HARD;
	}
}


/************************************************************************
*       function name : check_pointer_stmt                              *
*       input parameter : NONE                                          *
*       output : NONE                                                   *
*       function : check the pointer statement and report errors        *
************************************************************************/

int check_pointer_stmt()
{
	PTR_LLND        expr_list;
	PTR_LLND        range;
	PTR_SYMB        symbol;

	for (expr_list = cur_bfnd->entry.Template.ll_ptr1; expr_list;
		expr_list = expr_list->entry.Template.ll_ptr2) {
		symbol = expr_list->entry.Template.ll_ptr1->entry.Template.symbol;
		/* sym = search_symb_decl(symbol);  zheng.gb 1996.5.20 */
		if (symbol->variant == FUNCTION_NAME )
		{
/*
			sym->type = symbol->type;
			expr_list->entry.Template.ll_ptr1->entry.Template.symbol = sym;
			symbol = sym;
*/
			error3(405,symbol->ident);
		}
		/***** if this object has intent attribute *****/
		if ((symbol->attr & IN_BIT) || (symbol->attr & OUT_BIT)
			|| (symbol->attr & INOUT_BIT)) 
			error3(429,symbol->ident);

		/***** if this object has parameter attribute *****/
		if (symbol->attr & PARAMETER_BIT)
			error3(419,symbol->ident);

		/***** if this object is a deferred shape array *****/
		if (symbol->type->variant == T_ARRAY) {
			range = symbol->type->entry.ar_decl.ranges;
			if (!is_defer(range))
				error3(428,symbol->ident);
		}
		symbol->attr = symbol->attr | POINTER_BIT;
		symbol->decl = HARD;
	}
}


/************************************************************************
*       function name : check_target_stmt                               *
*       input parameter : NONE                                          *
*       output : NONE                                                   *
*       function : check the target statement and report errors         *
************************************************************************/

int check_target_stmt()
{
	PTR_LLND        expr_list;
	PTR_SYMB        symbol;

	expr_list = cur_bfnd->entry.Template.ll_ptr1;
	for ( expr_list ; expr_list ;
		expr_list = expr_list->entry.Template.ll_ptr2) {
		symbol = expr_list->entry.Template.ll_ptr1->entry.Template.symbol;
		/* sym = search_symb_decl(symbol);  zheng.gb 1996.5.20 */
		if (symbol->variant == FUNCTION_NAME )
		{
			error3(405,symbol->ident);
		}
		/***** if this object has PARAMETER attribute *****/
		if (symbol->attr & PARAMETER_BIT) 
			error3(419,symbol->ident);

		/***** if this object is in a module *****/
		if (in_module) {
			/***** set access attribute *****/
			if (empty_access_stmt == 1) 
				symbol->attr = symbol->attr | PUBLIC_BIT;
			else if (empty_access_stmt == 2)
				symbol->attr = symbol->attr | PRIVATE_BIT;
		}

		symbol->attr = symbol->attr | TARGET_BIT;
		symbol->decl = HARD;
	}
}


/************************************************************************
*	function name : check_data_variable				*
*	input parameter : symbol, symbol table item of this variable	*
*	output : the pointer of symbol table item			*
*	function : check the variable appearing in a data statement	*
*			and report errors				*
************************************************************************/

PTR_SYMB check_data_variable(symbol)
PTR_SYMB symbol;
{

	/* sym = search_symb_decl(symbol);  zheng.gb 1996.5.20 */
	if (symbol->entry.var_decl.local == IO)
		error3(402,symbol->ident);
	if (symbol->scope != cur_bfnd->control_parent)
		error3(412,symbol->ident);
	if (symbol->entry.Template.common_link.common_item) {
		if (cur_bfnd->control_parent->variant == BLOCK_DATA)
			return(symbol);
	/*	if (!(symbol->entry.Template.common_link.common_item->symbol))
			error3(459,symbol->ident);
		else if (cur_bfnd->control_parent->variant != BLOCK_DATA)
			error3(459,symbol->ident);*/
	}
	if (symbol->variant == FUNCTION_NAME)
		error3(421,symbol->ident);
	if (symbol->entry.var_decl.local == OUTPUT)
		error3(407,symbol->ident);
 	if (symbol->attr & POINTER_BIT)
		error3(410,symbol->ident);
	if (symbol->attr & ALLOCATABLE_BIT)
		error3(453,symbol->ident);
	if (symbol->type == TYNULL)
	{
		error3(107,symbol->ident);
		symbol->type = global_int;
	}
	else
	{
		if (isStringType(symbol->type)) 
			if (!is_const_size_string(symbol))
				error3(404,symbol->ident);
		if (symbol->type->variant == T_ARRAY) 
			if (type_size(symbol)==-1)
				error3(404,symbol->ident);
	}
	if (symbol->attr & DATA_BIT)
                error3(477,symbol->ident);
        else symbol->attr = symbol->attr | DATA_BIT;
	return (symbol);
}


			/* zheng.gb 1996.5.21 */
int check_data_ele(llnd)
PTR_LLND llnd;
{
	PTR_SYMB  symbol;
	PTR_LLND tmp,data_ele;


	switch (llnd->variant) {
	case ARRAY_REF:             /* ??? zheng.gb */
			symbol = llnd->entry.Template.symbol;
			llnd->entry.Template.symbol = check_data_variable(symbol);
			get_array_type(llnd);
			break;
	case VAR_REF :
			symbol = llnd->entry.Template.symbol;
			llnd->entry.Template.symbol = check_data_variable(symbol);
			break;
	case DATA_IMPL_DO : 
			for (data_ele=llnd->entry.Template.ll_ptr1; data_ele ; data_ele=data_ele->entry.Template.ll_ptr2)
			{
				check_data_ele(data_ele->entry.Template.ll_ptr1);
			}
			checkDDOT(llnd->entry.Template.ll_ptr2,145);
			break;
	case RECORD_REF :
			tmp = llnd->entry.Template.ll_ptr1->entry.Template.ll_ptr1;
			symbol = tmp->entry.Template.symbol;
			tmp->entry.Template.symbol = check_data_variable(symbol);
			break;
	}   /* switch */
}



/************************************************************************
*       function name : check_data_decl                                 *
*       input parameter : NONE                                          *
*       output : NONE                                                   *
*       function : check data statement and report errors               *
************************************************************************/

int check_data_decl()
{
	PTR_LLND        expr_list,ele,object_list,object_llnd,tmp,
			data_ele,data_value,value_list,value_llnd,lp,rp;
	PTR_SYMB        symbol;
	int		num;

	for (expr_list = cur_bfnd->entry.Template.ll_ptr1; expr_list;
		expr_list = expr_list->entry.Template.ll_ptr2) {
			/* ele => DATA_STMT_SET */
		ele = expr_list->entry.Template.ll_ptr1;
		object_list = ele->entry.Template.ll_ptr1;
		value_list = ele->entry.Template.ll_ptr2;
		for (object_list ; object_list ;
			object_list = object_list->entry.Template.ll_ptr2) {
			object_llnd = object_list->entry.Template.ll_ptr1;
			check_data_ele(object_llnd);
/*
			switch (object_llnd->variant) {
				case VAR_REF :
					symbol = object_llnd->entry.Template.symbol;
					object_llnd->entry.Template.symbol = check_data_variable(symbol);
					break;
				case DATA_IMPL_DO : 
					tmp = object_llnd->entry.Template.ll_ptr1->entry.Template.ll_ptr1;
					while(tmp->variant != ARRAY_REF) {
						tmp = tmp->entry.Template.ll_ptr1->entry.Template.ll_ptr1;
					}
					symbol = tmp->entry.Template.symbol;
					tmp->entry.Template.symbol = check_data_variable(symbol);
					break;
				case RECORD_REF :
					tmp = object_llnd->entry.Template.ll_ptr1->entry.Template.ll_ptr1;
					symbol = tmp->entry.Template.symbol;
					tmp->entry.Template.symbol = check_data_variable(symbol);
					break;
			}*/
					/* switch */
		}	/* for */
							/* add by zheng.gb */
		num=0;
		for (value_list ; value_list ;
			value_list = value_list->entry.Template.ll_ptr2) 
		{
			num++;
			data_value = value_list->entry.Template.ll_ptr1;
				/* repeat */
			lp=data_value->entry.Template.ll_ptr1;
				/* value */
			rp=data_value->entry.Template.ll_ptr2;
			if (lp) {
			    if (!check_initialization_expr(lp)) error2(472,num);
                            else if (!is_scalar(lp)) error2(472,num);
                        	 else if (!isInteger(lp)) error2(472,num);
				      else comput_const_expr(lp,0);
			}  /* if lp */
			                 /* now check value */
			if (!check_initialization_expr(rp)) error3(473,num);
		}    /* for */
	 }
}


/************************************************************************
*       function name : check_struct_decl                               *
*       input parameter : NONE                                          *
*       output : NONE                                                   *
*       function : check derived type defination statement and report   *
*                       errors                                          *
************************************************************************/

int check_struct_decl()
{
	PTR_SYMB        symbol;
	PTR_BFND        header;
	PTR_TYPE        derived_type,tp;
	int             i,flag = 0;
	static char    *keyword[]={"real","double","character","integer","logical","complex"};
	static int      sum=6;
	char            *tmp;

	in_type_define = 1;
	type_private_flag = 0;
	type_sequence_flag = 0;

	/***** check if the type name is redeclarated *****/
	symbol=cur_bfnd->entry.Template.symbol;
	derived_type=look_up_record_at_cur_scope(symbol);
		/* make sure the record found is the current record type */
	if (derived_type==TYNULL ) {
printf("Abornomal !!!\n");
		return;
	}
	if (derived_type->name !=symbol ) {
                error3(431,symbol->ident);
                return;
        }
	derived_type->variant=DEFAULT;
	tp=look_up_record_at_cur_scope(symbol);
	derived_type->variant=T_RECORD;
	if (tp) {
		error3(431,symbol->ident);
		return;
	}
	
	for (i=0; i< sum ; i++)
		if (strcasecmp(symbol->ident,keyword[i])==0)
		   error3(240,symbol->ident);
	
	symbol->decl=HARD;
					/* rewrite by zheng.gb */
/*
	header = cur_bfnd->control_parent;
	symbol = header->entry.Template.symbol->thread;
	if (symbol->scope == header) 
		for (; symbol!=cur_bfnd->entry.Template.symbol && flag==0;
			 symbol = symbol->next_symb) 
			if (symbol->variant == TYPE_NAME &&
			  strcasecmp(symbol->ident,cur_bfnd->entry.Template.symbol->ident) == 0) 
				flag = 1;
	if (flag) error3(431,symbol->ident);
*/
}


/************************************************************************
*       function name : check_private_stmt                              *
*       input parameter : NONE                                          *
*       output : NONE                                                   *
*       function : check private statement and report errors            *
************************************************************************/

int check_private_stmt()
{
	/***** if in a type defination *****/
	if (in_type_define) {
		if (type_private_flag == 1 || in_module == 0) error1(432);
		else type_private_flag = 1;
	}
}


/************************************************************************
*       function name : check_sequence_stmt                             *
*       input paramter : NONE                                           *
*       output : NONE                                                   *
*       function : check sequence statement and report errors           *
************************************************************************/

int check_sequence_stmt()
{
	PTR_SYMB        symbol;

	/***** if in a type defination *****/
	if (in_type_define) {
			/* have reported error in hpf2dep */
		if (type_sequence_flag) ;   /* error1(433); */
		else {
			type_sequence_flag = 1;
			symbol = cur_bfnd->control_parent->entry.Template.symbol;
			symbol->attr = symbol->attr | SEQUENCE_BIT;
		}
	}
}


/************************************************************************
*	function name : check_namelist_stat				*
*	input parameter : NONE						*
*	output : NONE							*
* 	function : check namelist statement and report errors		*
************************************************************************/

int check_namelist_stat()
{
	PTR_LLND expr_list,ele;
	PTR_SYMB symbol,group_name;

	if (in_block_data) {
		error1(469);
		return 1;
	}
 
			/* go through the NAME_LIST link */
	for (expr_list = cur_bfnd->entry.Template.ll_ptr1; expr_list;
		expr_list = expr_list->entry.Template.ll_ptr2) {
			/*  NAME_LIST */
		group_name = expr_list->entry.Template.symbol;
		for (ele = expr_list->entry.Template.ll_ptr1; ele;
			ele = ele->entry.Template.ll_ptr2) {
/* HIT */
			symbol = ele->entry.Template.ll_ptr1->entry.Template.symbol;
			/* sym = search_symb_decl(symbol); zheng.gb 1996.5.20 */
			if (symbol->variant == FUNCTION_NAME )
			{
				error3(405,symbol->ident);
			}
			if (group_name->attr & PUBLIC_BIT) {
				if (symbol->attr & PRIVATE_BIT)
					error3(452,symbol->ident);
			}
			if (symbol->attr & POINTER_BIT) 
				error3(410,symbol->ident);
			if (symbol->attr & ALLOCATABLE_BIT)
				error3(453,symbol->ident);
			if (isStringType(symbol->type)) {
				if (is_const_size_string(symbol)==0)
					error3(404,symbol->ident);
			}
			if (symbol->type->variant == T_ARRAY) {
				if (type_size(symbol) == -1) 
					error3(404,symbol->ident);
			}
		}
	}
}

int check_common_unity()
{
	PTR_SYMB symbol,tmp,sym_temp_header,sym_temp;
	PTR_BFND cur_header;
	struct cnt * scope_common_table;
	struct cnt * ptr;
	struct cnt * template_tmp;
	int found,end,length,length_temp;

	cur_header = cur_scope();
	if (debug1) printf("CUR_SCOPE: %s ,\n",cur_header->entry.Template.symbol->ident);
	switch(cur_header->variant) {
		case PROG_HEDR :
		case MODULE_STMT :
			scope_common_table = cur_header->entry.Template.symbol->entry.prog_decl.common_table;
			break;
		case MODULE_PROC_STMT :
		case PROC_HEDR :
			scope_common_table = cur_header->entry.Template.symbol->entry.proc_decl.common_table;
			break;
		case FUNC_HEDR : 
			scope_common_table = cur_header->entry.Template.symbol->entry.func_decl.common_table;
			break;
		case BLOCK_DATA :
			scope_common_table = cur_header->entry.Template.symbol->entry.Template.common_table;
			break;
	}
	ptr = scope_common_table;
	while (ptr) {
		found = 0;
		template_tmp = common_table;
		while ((template_tmp != CNTNULL) && (found == 0))
			if (template_tmp->symbol == ptr->symbol) found = 1;
			else template_tmp = template_tmp->next_common_item;
		if (found == 0) {
			template_tmp = ALLOC(cnt);
			template_tmp->symbol = ptr->symbol;
			template_tmp->attr = ptr->attr;
			template_tmp->size = ptr->size;
			template_tmp->ft = ptr->ft;
			template_tmp->lt = ptr->lt;
			template_tmp->next_common_item = common_table;
			common_table = template_tmp;
		}
		else {
			if (ptr->size != template_tmp->size) 
				error3(469,ptr->symbol->ident);
			if (ptr->attr != template_tmp->attr)
				error3(470,ptr->symbol->ident);
			if (!(ptr->attr)) {
				end = 0;
				symbol = ptr->ft;
				tmp = symbol;
				sym_temp_header = template_tmp->ft;
				sym_temp = sym_temp_header;
				if (!symbol) {
					if (sym_temp_header) 
						error3(471,ptr->symbol->ident);
					end = 1;
				}
				else if (!sym_temp_header) {
					error3(471,ptr->symbol->ident);
					end = 1;
				}
				while (end==0) {
					if (sym_temp_header->attr & NOSEQUENCE_BIT) {
						if (symbol->attr & SEQUENCE_BIT)
							error3(471,ptr->symbol->ident);
						if (symbol->type != sym_temp_header->type)
							error3(471,ptr->symbol->ident);
					}
					else if (symbol->attr & NOSEQUENCE_BIT)
						error3(471,ptr->symbol->ident);
					else {
						for (tmp = symbol->entry.Template.common_link.group_next; 
						     tmp->entry.Template.common_link.group_next != symbol;
						     tmp = tmp->entry.Template.common_link.group_next) ;
						for (sym_temp = sym_temp_header->entry.Template.common_link.group_next;
						     sym_temp->entry.Template.common_link.group_next != sym_temp_header;
						     sym_temp = sym_temp->entry.Template.common_link.group_next) ;
						if (sym_temp->entry.Template.common_link.next == SMNULL) {
							end = 1;
							if (tmp->entry.Template.common_link.next != SMNULL)
								error3(471,ptr->symbol->ident);
							else if (tmp->entry.Template.common_link.offset != sym_temp->entry.Template.common_link.offset)
								error3(471,ptr->symbol->ident);
						}
						else if (tmp->entry.Template.common_link.next == SMNULL) {
							error3(471,ptr->symbol->ident);
							end = 1;
						}
						else {
							if (tmp->entry.Template.common_link.next)
								length = tmp->entry.Template.common_link.next->entry.Template.common_link.offset - tmp->entry.Template.common_link.offset;
							else length = ptr->size - tmp->entry.Template.common_link.offset + 1;
							if (sym_temp->entry.Template.common_link.next)
								length_temp = sym_temp->entry.Template.common_link.next->entry.Template.common_link.offset - sym_temp->entry.Template.common_link.offset;
							else length_temp = template_tmp->size - sym_temp->entry.Template.common_link.offset + 1;
							if (length != length_temp)
								error3(471,ptr->symbol->ident);
						}
					}
					if (tmp)
						symbol = tmp->entry.Template.common_link.next;	
					else symbol = SMNULL;
					tmp = symbol;
					if (sym_temp)
						sym_temp_header = sym_temp->entry.Template.common_link.next;
					else sym_temp_header = SMNULL;
					sym_temp = sym_temp_header;
					if (symbol == SMNULL) {
						if (sym_temp_header != SMNULL)
							error3(471,ptr->symbol->ident);
						end = 1;
					}
					else if (sym_temp_header == SMNULL) {
						error3(471,ptr->symbol->ident);
						end = 1;
					}	
				}
			}
		}
		ptr = ptr->next_common_item;
	}
}

/* end of addition */


PTR_BFND search_head_name(fi,string)
PTR_FILE fi;
char *string;
{
	PTR_BLOB blob;

	for(blob=fi->global_bfnd->entry.Template.bl_ptr1;blob;blob=blob->next)
		if (!strcasecmp(string,blob->ref->entry.Template.symbol->ident))
		{
if (debug1) printf("searched ident:%s\n", cur_bfnd->entry.Template.symbol->ident);
			break;
		}
	return  blob ? blob->ref:BFNULL;
}

static int  bfnd_in_scopetable(bfnd)
PTR_BFND bfnd;
{
	int i;

	for (i=1; i<top_scope_level; i++)
		if (bfnd == scope_table[i] ) return 1;
	return 0;
}

/*  get use_list of a scope bfnd */
PTR_LLND  get_use_list(bfnd)
PTR_BFND bfnd;
{
	PTR_LLND use_list;

	if (bfnd->entry.Template.symbol == SMNULL) return LLNULL;

	switch (bfnd->entry.Template.symbol->variant) {
        case PROGRAM_NAME:
        case MODULE_NAME:
               use_list = bfnd->entry.Template.symbol->entry.prog_decl.use_list;
               break;
        case PROCEDURE_NAME:
               use_list = bfnd->entry.Template.symbol->entry.proc_decl.use_list;
               break;
        case FUNCTION_NAME:
               use_list = bfnd->entry.Template.symbol->entry.func_decl.use_list;
               break;
	case BLOCKDATA_NAME:
		use_list = LLNULL;
		break;
        }
	return use_list;
}

/*  get interface_list of a scope bfnd */
PTR_LLND  get_interface_list(bfnd)
PTR_BFND bfnd;
{
	PTR_LLND interface_list;

	if (bfnd->entry.Template.symbol == SMNULL) return LLNULL;

	switch (bfnd->entry.Template.symbol->variant) {
        case PROGRAM_NAME:
        case MODULE_NAME:
               interface_list = bfnd->entry.Template.symbol->entry.prog_decl.interface_list;
               break;
        case PROCEDURE_NAME:
               interface_list = bfnd->entry.Template.symbol->entry.proc_decl.interface_list;
               break;
        case FUNCTION_NAME:
               interface_list = bfnd->entry.Template.symbol->entry.func_decl.interface_list;
               break;
	case BLOCKDATA_NAME:
		interface_list = LLNULL;
		break;
        }
	return interface_list;
}

int  push_use(fi,use_list)
PTR_FILE fi;
PTR_LLND use_list;
{
	PTR_LLND ptr,interface_list,next_use_list;
	PTR_BFND bfnd;
	extern  int pre_processing;

	for (ptr=use_list; ptr; ptr=ptr->entry.Template.ll_ptr2)
        {
                bfnd=search_head_name(fi,ptr->entry.Template.ll_ptr1->entry.Template.symbol->ident);
		if (bfnd==BFNULL ) {
			if (pre_processing==0)
				error3(248,ptr->entry.Template.ll_ptr1->entry.Template.symbol->ident);
			continue;
		}
                if (bfnd_in_scopetable(bfnd))  continue;
                add_scope_level(bfnd,1);
			/* push  interface of this scope also */
		interface_list = get_interface_list(bfnd);
		push_interface(interface_list);
			/* now push the use list of this scope recursively */
		next_use_list = get_use_list(bfnd);
		push_use(fi,next_use_list);
                if (debug1)
                        printf("PUSH : add_scope_level ---- %s.",bfnd->entry.Template.symbol->ident);
        }
}

int  push_interface(interface_list)
PTR_LLND interface_list;
{
	PTR_LLND ptr;
	PTR_SYMB symb;
	PTR_BFND bfnd;

	for (ptr=interface_list; ptr; ptr=ptr->entry.Template.ll_ptr2)
	{
		symb=ptr->entry.Template.ll_ptr1->entry.Template.symbol;
		bfnd = symb->scope;
		if (bfnd_in_scopetable(bfnd))  continue;
		add_scope_level(bfnd,1);
	}
}
	
use_stmt()
{
	PTR_BFND bfnd;
	PTR_LLND use_list,ptr,interface_list,expr_list;
	PTR_SYMB symb,sym_mod;

		/* find if the module used can be found */
	bfnd = search_head_name(fi,cur_bfnd->entry.Template.symbol->ident);
	if (!bfnd) {
		error1(127);
		return;
	}

	/*added by Yanmi*/
	if (cur_bfnd->entry.Template.ll_ptr1 && 
		cur_bfnd->entry.Template.ll_ptr1->variant==ONLY_NODE)
	{
		expr_list=cur_bfnd->entry.Template.ll_ptr1->entry.Template.ll_ptr1;
		for (; expr_list ; expr_list=expr_list->entry.Template.ll_ptr2)
		{
			ptr=expr_list->entry.Template.ll_ptr1;
			if (ptr->variant == RENAME_NODE)
			{
				symb=ptr->entry.Template.ll_ptr2->
							entry.Template.symbol;
				sym_mod=look_up_symb_at_scope_in_hash(symb->ident,bfnd);
				if (sym_mod == SMNULL) 
					error6(600,symb->ident,cur_bfnd->entry.Template.symbol->ident);
				else if (sym_mod!=symb)
					ptr->entry.Template.ll_ptr2->entry.Template.symbol=sym_mod;
				insert_rename_list(ptr->entry.Template.ll_ptr2->entry.Template.symbol);
				symb=ptr->entry.Template.ll_ptr1->
							entry.Template.symbol;
			}
			else
				symb=ptr->entry.Template.symbol;
			symb->decl = HARD;
		}
	}
			/* RENAME_NODE */
	if (cur_bfnd->entry.Template.ll_ptr2)
	{
		expr_list=cur_bfnd->entry.Template.ll_ptr2;
		for (;expr_list;expr_list=expr_list->entry.Template.ll_ptr2)
		{
				/* ptr=> RENAME_NODE */
			ptr=expr_list->entry.Template.ll_ptr1;
			symb=ptr->entry.Template.ll_ptr2->entry.Template.symbol;
				/* find symbol in the module scope */
			sym_mod=look_up_symb_at_scope_in_hash(symb->ident,bfnd);
			if (sym_mod == SMNULL) 
				error6(600,symb->ident,cur_bfnd->entry.Template.symbol->ident);
			else if (sym_mod!=symb)
				ptr->entry.Template.ll_ptr2->entry.Template.symbol=sym_mod;
			insert_rename_list(symb);
			symb=ptr->entry.Template.ll_ptr1->entry.Template.symbol;
			symb->decl = HARD;
		}
	}

/*
	add_scope_level(bfnd,1);
	interface_list = get_interface_list(bfnd);
	push_interface(interface_list);
	
	use_list=get_use_list(bfnd);
	push_use(fi,use_list);

	if (debug1) {
		printf("PUSH : add_scope_level ---- %s.",cur_bfnd->entry.Template.symbol->ident);
		show_cur_scope();
	}
*/

}

/* push  uselist and interface list of a scope recursivle */
int push_scope(fi,bfnd)
PTR_FILE fi;
PTR_BFND bfnd;
{	
	PTR_LLND interface_list,use_list;
	
	add_scope_level(bfnd,0);
        interface_list = get_interface_list(bfnd);
        push_interface(interface_list);

        use_list=get_use_list(bfnd);
        push_use(fi,use_list);
}


int check_impl_decl()
{
	PTR_LLND expr_list,ele,range,ptr;
	PTR_TYPE type;
	int i,l,u;

	ptr = cur_bfnd->entry.Template.ll_ptr1;
	if (ptr==LLNULL) {
		if (implicit_flag) error1(451);
		else implicit_table[26][top_implicit_level]=TYNULL;
	}
	else {
		if (implicit_table[26][top_implicit_level]==TYNULL) 
			error1(456);
		for (expr_list = ptr; expr_list ;
			expr_list = expr_list->entry.Template.ll_ptr2){
			ele = expr_list->entry.Template.ll_ptr1;
			type = ele->entry.Template.ll_ptr2->type;
			for (ele = ele->entry.Template.ll_ptr1; ele;
				ele = ele->entry.Template.ll_ptr2) {
				range = ele->entry.Template.ll_ptr1;
				switch (range->variant) {
					case CHAR_VAL :
						implicit_table[toupper(range->entry.cval)-'A'][top_implicit_level] = type;
						break;
					case DDOT :
						l=toupper(range->entry.Template.ll_ptr1->entry.cval)-'A';
						u=toupper(range->entry.Template.ll_ptr2->entry.cval)-'A';
						if (l>=u) error1(455);
						else for(i=l;i<=u;i++) 
							implicit_table[i][top_implicit_level] = type;
						break;
				}
			}
		}
		implicit_table[26][top_implicit_level]=global_int;
	}
	implicit_flag = 1;
}
