/*****************************************************************************

		Utilities

written by  Zheng Gengbin
           Peking University , P.R.C
*****************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if defined(STDC_HEADERS) && (STDC_HEADERS==1)
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>

#include <varargs.h>

#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"
#include "dep.h"
#include "dep_struct.h"
#include "tags.h"
#include "decl.h"
#include "macro.h"

#include "exglobal.h"

extern debug1;

/* stack to record Current subname */
PTR_SYMB record_table[30];
int      top_record;

/*****************************************************************************

			SCOPE

*****************************************************************************/

int bfnd_in_blob(bfnd,blob)
PTR_BFND bfnd;
PTR_BLOB blob;
{
	PTR_BLOB  bb;
	for (bb=blob; bb; bb=bb->next)
		if (bfnd == bb->ref) return 1;
	return 0;
}


/*
 * look_up(string) -- lookup string
                        in cur_scope and his scope parent
 */
PTR_SYMB
look_up_sym(string)
register char *string;
{
        int i,level;
        PTR_BFND scope_at_level(), p;
        PTR_SYMB  temp;

        for (level=top_scope_level; level>=1; level--){
                p = scope_table[level];
                for (temp = fi->head_symb; temp; temp = temp->thread) {
                        if (!strcasecmp(string, temp->ident) && p==temp->scope){
                        return temp;
                        }
                }
        }
        return SMNULL;

}


PTR_SYMB search_defined_intrinsic_op(name)
char *name;
{
        PTR_SYMB temp;
        PTR_BFND p,scope;
        int      level;

        scope=cur_scope();
/*
printf("HERE%s,%d\n",name,cur_bfnd->g_line);
	scope = cur_bfnd;
	while (!is_main_header(scope))
        {
                scope=scope->control_parent;
        }
*/
        for (level=top_scope_level; level>=1; level--){
                p = scope_table[level];
                for (temp = fi->head_symb; temp; temp = temp->thread) {
                        if (!strcasecmp(name, temp->ident) && p==temp->scope
                                && temp->variant == INTERFACE_NAME )
                        {
                                if ((temp->attr & PRIVATE_BIT) &&
                                        temp->scope!=scope )
                                        continue;
                                return temp;
                        }
                }
        }
        return SMNULL;
}

PTR_SYMB  get_interface_one_by_one(sym,first)
PTR_SYMB sym;
int first;		/* 1 : get first  0: next */
{
	static int level;
	PTR_SYMB  temp;
	PTR_BFND  p;

	if (first) level = top_scope_level;
	else level --;

	for ( ; level>=1; level--){
                p = scope_table[level];
                for (temp = fi->head_symb; temp; temp = temp->thread) {
                        if (!strcasecmp(sym->ident,temp->ident)&&p==temp->scope
                                && temp->variant == INTERFACE_NAME )
                        {
                                if ((temp->attr & PRIVATE_BIT) &&
                                        temp->scope!=cur_scope())
                                        continue;
                                return temp;
                        }
                }
        }
        return SMNULL;
}


/*****************************************************************************

			ARRAY

*****************************************************************************/

int is_scalar(type)
PTR_TYPE type;
{
	if (type->variant == T_ARRAY ) return 0;
	return 1;
}

int get_dimension(sym)
PTR_SYMB sym;
{
	if ( is_scalar(sym->type) ) 
                return 0;
        else 
                return sym->type->entry.ar_decl.num_dimensions;
}

int is_assumed_shape_spec(sym)
PTR_SYMB sym;
{
	PTR_LLND expr_list,range_op,ddot,ele;
	int      is_defer;

	if (sym->type == TYNULL) return 0;
	if (sym->type->variant != T_ARRAY ) return 0;
	expr_list = sym->type->entry.ar_decl.ranges;
/*
	ddot   = expr_list->entry.Template.ll_ptr1;
	range_op =ddot->entry.Template.ll_ptr1; 
	if (range_op && range_op->entry.Template.ll_ptr2 == LLNULL) return 1;
	else return 0;
*/
	is_defer = 1;
	for (; expr_list; expr_list = expr_list->entry.Template.ll_ptr2) {
                        /* ele point to  DDOT now */
                ele = expr_list->entry.Template.ll_ptr1;
                if (ele == LLNULL)  continue;
                        /* ele point to RANGE_OP */
                ele = ele->entry.Template.ll_ptr1;
                if (ele == LLNULL)  continue;
		if (ele->entry.Template.ll_ptr1)
			is_defer = 0;
                if (ele->entry.Template.ll_ptr2)
                        return 0;
        }
		/* it is possible that sym is also a defer , use attribute to
		   discriminate them . Pg48 book */
	if (is_defer)
		if ((sym->attr & POINTER_BIT) ==0 && 
			(sym->attr & ALLOCATABLE_BIT)==0 )
			return 1;
		else
			return 0;
	else 
		return 1;
}

int is_assumed_size_spec(sym)
PTR_SYMB sym;
{
	PTR_LLND expr_list,range_op,ddot;

	if (sym->type == TYNULL) return 0;
	if (sym->type->variant != T_ARRAY ) return 0;
	expr_list = sym->type->entry.ar_decl.ranges;
	if (expr_list == LLNULL) return 0;

	for (; expr_list->entry.Template.ll_ptr2; 
			expr_list=expr_list->entry.Template.ll_ptr2);
	ddot   = expr_list->entry.Template.ll_ptr1;
	if (ddot == LLNULL) return 0;
	range_op =ddot->entry.Template.ll_ptr1; 
	if (range_op == LLNULL) return 0;
	if (range_op->entry.Template.ll_ptr2 && range_op->entry.Template.
			ll_ptr2->variant == STAR_RANGE) 
	     return 1;
	else return 0;
}


/* 1: ok , 0: failed  dim is from 1*/
int get_array_lbound(type,dim,lbound)
PTR_TYPE type;
int dim;
int *lbound;
{
	PTR_LLND   expr_list,ddot,range_op,lp;
	int	   i;

	if (type->variant != T_ARRAY ) return 0;
	expr_list = type->entry.ar_decl.ranges;
	if ( dim > type->entry.ar_decl.num_dimensions ) return 0;
	for ( i =1 ; i< dim ; i++ ) expr_list = NODE_OPERAND1(expr_list);
	ddot   = NODE_OPERAND0(expr_list);
	if (ddot == LLNULL) return 0;
	range_op =NODE_OPERAND0(ddot);
	if (range_op == LLNULL) return 0;
	lp=NODE_OPERAND0(range_op);
	if (lp == LLNULL) {
		*lbound = 1;
		return 1;
	}
	if (check_initialization_expr(lp))
	{
		if ( isInteger(lp) ) 
                	comput_const_expr(lp,0);
		*lbound = lp->const_val;
		return 1;
	}
	else
		return 0;
}

int get_array_ubound(type,dim,ubound)
PTR_TYPE type;
int dim;
int *ubound;
{
	PTR_LLND   expr_list,ddot,range_op,rp;
	int	   i;

	if (type->variant != T_ARRAY ) return 0;
	expr_list = type->entry.ar_decl.ranges;
	if ( dim > type->entry.ar_decl.num_dimensions ) return 0;
	for ( i =1 ; i< dim ; i++ ) expr_list = NODE_OPERAND1(expr_list);
	ddot   = NODE_OPERAND0(expr_list);
	if (ddot == LLNULL) return 0;
	range_op =NODE_OPERAND0(ddot);
	if (range_op == LLNULL) return 0;
	rp=NODE_OPERAND1(range_op);
	if (rp == LLNULL) {
		return 0;
	}
	if (rp->variant != STAR_RANGE && check_initialization_expr(rp))
	{
		if ( isInteger(rp) ) 
                	comput_const_expr(rp,0);
		*ubound = rp->const_val;
		return 1;
	}
	else
		return 0;
}

int get_array_rank(ll_ptr)
PTR_LLND ll_ptr;
{
        int num=0;
        PTR_LLND expr_list;

	expr_list=ll_ptr->entry.Template.ll_ptr1;
	if (expr_list == LLNULL) expr_list=ll_ptr->entry.Template.ll_ptr2;

        for ( ; expr_list ;expr_list=expr_list->entry.Template.ll_ptr2)
                num++;
        return num;
}

/*
	check array_spec   -- R512
	for explicit shape ,
	    assumed shape ,
	    defered shape
            assumed size
*/
int check_array_range(ll_ptr)
PTR_LLND ll_ptr;
{
        PTR_LLND expr_list,ele,lp,rp;
	int      err_code;

	if (ll_ptr==LLNULL) return;
        for (expr_list=ll_ptr;expr_list;
		expr_list=expr_list->entry.Template.ll_ptr2)
	{
			/* ele => DDOT */
		ele = expr_list->entry.Template.ll_ptr1;
		if (ele==LLNULL) continue;
			/* ele => RANGE_OP */
		ele = ele->entry.Template.ll_ptr1;
		if (ele==LLNULL) continue;
				/* lower bound */
		lp=ele->entry.Template.ll_ptr1;
				/* upper bound */
		rp=ele->entry.Template.ll_ptr2;
		if (lp) 
		   if (err_code=check_spec_expr(lp))
                	error1(err_code);
		if (rp) {
		   if (rp->variant == STAR_RANGE ) continue;
		   if (err_code=check_spec_expr(rp))
                	error1(err_code);
		}
	}
}


/*
	check if have duplicate dummy
*/
int check_dummy_dup(ranges)
PTR_LLND ranges;
{
	PTR_LLND llnd,ll,ele;

	for (llnd=ranges->entry.Template.ll_ptr2; llnd ; 
		llnd=llnd->entry.Template.ll_ptr2) {
		ele=llnd->entry.Template.ll_ptr1;
		for(ll=ranges ; ll!=llnd; 
			ll=ll->entry.Template.ll_ptr2) {
			if (strcasecmp(ele->entry.Template.symbol->ident,
			     ll->entry.Template.ll_ptr1->entry.Template.symbol->ident)==0)
			error3(242,ele->entry.Template.symbol->ident);
		}
	}
}

/****************************************************************************
				RECORD
*****************************************************************************/

/*
 llnd : a RECORD_REF llnd.
*/
PTR_LLND  get_last_ref(llnd)
PTR_LLND  llnd;
{
	PTR_LLND expr_list,this;
	
	for (expr_list = llnd->entry.Template.ll_ptr2 ; expr_list;
		expr_list = expr_list->entry.Template.ll_ptr2) {
		this = expr_list->entry.Template.ll_ptr1;
	}
	return this;
}

/*
 llnd : a RECORD_REF llnd.
*/
PTR_SYMB  get_record_name(llnd)
PTR_LLND  llnd;
{
	return llnd->entry.Template.ll_ptr1->entry.Template.ll_ptr1->
		entry.Template.symbol;
}

PTR_SYMB get_var_name(llnd)
PTR_LLND llnd;
{
	if (llnd->variant == SUB_STRING)
		llnd = llnd->entry.Template.ll_ptr1;

        if (llnd->variant == RECORD_REF)
                llnd = llnd->entry.Template.ll_ptr1->entry.Template.ll_ptr1;

	switch (llnd->variant ) {
        case VAR_REF:
        case ARRAY_REF:
                return  llnd->entry.Template.symbol;
                break;
	}
	return SMNULL;
}

/******************************************************************************

				TYPE

*****************************************************************************/


/*   TYPE */
int  isIntegerType(tp)
PTR_TYPE tp;
{
        PTR_TYPE type;

        if (tp->variant == T_ARRAY)
                type=tp->entry.ar_decl.base_type;
        else
                type=tp;
        if (type->variant == T_KIND) type=type->entry.kind_decl.base_type;
        return type->variant == T_INT ?  1:0;
}

int  isFloatType(tp)
PTR_TYPE tp;
{
        PTR_TYPE type;

        if (tp->variant == T_ARRAY)
                type=tp->entry.ar_decl.base_type;
        else
                type=tp;
        if (type->variant == T_KIND) type=type->entry.kind_decl.base_type;
        return type->variant == T_FLOAT ?  2:0;
}

int  isDoubleType(tp)
PTR_TYPE tp;
{
        PTR_TYPE type;

        if (tp->variant == T_ARRAY)
                type=tp->entry.ar_decl.base_type;
        else
                type=tp;
        if (type->variant == T_KIND) type=type->entry.kind_decl.base_type;
        return type->variant == T_DOUBLE ?  3:0;
}

int  isComplexType(tp)
PTR_TYPE tp;
{
        PTR_TYPE type;

        if (tp->variant == T_ARRAY)
                type=tp->entry.ar_decl.base_type;
        else
                type=tp;
        if (type->variant == T_KIND) type=type->entry.kind_decl.base_type;
        return type->variant == T_COMPLEX ?  4:0;
}

int  isDComplexType(tp)
PTR_TYPE tp;
{
        PTR_TYPE type;

        if (tp->variant == T_ARRAY)
                type=tp->entry.ar_decl.base_type;
        else
                type=tp;
        if (type->variant == T_KIND) type=type->entry.kind_decl.base_type;
        return type->variant == T_DCOMPLEX ?  5:0;
}

int  isBoolType(tp)
PTR_TYPE tp;
{
        PTR_TYPE type;

        if (tp->variant == T_ARRAY)
                type=tp->entry.ar_decl.base_type;
        else
                type=tp;
        if (type->variant == T_KIND) type=type->entry.kind_decl.base_type;
        return type->variant == T_BOOL ?  1:0;
}

int  isStringType(tp)
PTR_TYPE tp;
{
        PTR_TYPE type;

        if (tp->variant == T_ARRAY)
                type=tp->entry.ar_decl.base_type;
        else
                type=tp;
        if (type->variant == T_KIND) type=type->entry.kind_decl.base_type;
        return type->variant == T_STRING ?  1:0;
}


/*   LLND   */
int  isInteger(ll_ptr)
PTR_LLND ll_ptr;
{
	return  isIntegerType(ll_ptr->type);
}

int  isFloat(ll_ptr)
PTR_LLND ll_ptr;
{
	return  isFloatType(ll_ptr->type);
}

int  isDouble(ll_ptr)
PTR_LLND ll_ptr;
{
	return  isDoubleType(ll_ptr->type);
}

int  isComplex(ll_ptr)
PTR_LLND ll_ptr;
{
	return  isComplexType(ll_ptr->type);
}

int  isNumber(ll_ptr)
PTR_LLND ll_ptr;
{
        int m;

        if (m=isInteger(ll_ptr)) return m;
        if (m=isFloat(ll_ptr)) return m;
        if (m=isDouble(ll_ptr)) return m;
        if (m=isComplex(ll_ptr)) return m;
        return 0;
}

int  isBool(ll_ptr)
PTR_LLND ll_ptr;
{
	return  isBoolType(ll_ptr->type);
}

int  isChar(ll_ptr)
PTR_LLND ll_ptr;
{
        PTR_TYPE type;

        if (ll_ptr->type->variant == T_ARRAY)
                type=ll_ptr->type->entry.ar_decl.base_type;
        else
                type=ll_ptr->type;
	if (type->variant == T_KIND) type=type->entry.kind_decl.base_type;
        return type->variant == T_CHAR ?  1:0;
}

int  isString(ll_ptr)
PTR_LLND ll_ptr;
{
	return isStringType(ll_ptr->type);
}


PTR_TYPE  get_base_type(tp)
PTR_TYPE tp;
{
        PTR_TYPE type;

        type=tp;
        if (type->variant == T_ARRAY)
                type=type->entry.ar_decl.base_type;

        if (type->variant == T_KIND )
                type=type->entry.kind_decl.base_type;
        return type;
}

/*  
	1: if tp1 & tp2 is same intrinsic type 
	0: if not .
*/
int is_same_intrinsic_type(tp1,tp2)
PTR_TYPE tp1,tp2;
{
	switch (tp1->variant) {
	case T_INT:
	case T_FLOAT:
	case T_DOUBLE:
	case T_COMPLEX:
	case T_DCOMPLEX:
	case T_BOOL:
	case T_STRING:
		if (tp2->variant == tp1->variant)
			return 1;
	}
	return 0;
}

/*   same type  , not same kind   not same length 
	0: succeed ;
	>0 err_code;
*/
int is_same_basetype(tp1,tp2,sequence)
PTR_TYPE tp1,tp2;
int	sequence;
{
	int rank1,rank2;
	PTR_TYPE  btp1,btp2;

        if (tp1==tp2) return 0;
	if (sequence) return 0;

        if (is_scalar(tp1) && !is_scalar(tp2) ||
		!is_scalar(tp1) && is_scalar(tp2) )
		return 556;

	btp1=get_base_type(tp1);
	btp2=get_base_type(tp2);
	if (is_same_intrinsic_type(btp1,btp2)) ;
	else 			/* base type not equal */
		if (btp1->variant == T_RECORD && btp2->variant == T_RECORD)
		{
			if (!is_same_record(btp1,btp2)) return 556;
		}
		else if (btp1!=btp2)
			return 556;	

	if (!is_scalar(tp1))
	{
		rank1=tp1->entry.ar_decl.num_dimensions;
		rank2=tp2->entry.ar_decl.num_dimensions;
		if (rank1 != rank2) return 556;
	}
	return 0;
}

/*   same type  ,  same kind   not same length  of base_type
	0: succeed ;
	>0 err_code;
	typeop is the function header 's type_op
*/
int is_exact_same_basetype(tp1,typeop)
PTR_TYPE tp1;
PTR_LLND typeop;
{
	int rank1,rank2;
	PTR_TYPE  btp1,btp2;
	int kind1,kind2;
	PTR_LLND  expr_list,kind_op;

	if (tp1->variant == T_ARRAY) 
		btp1=tp1->entry.ar_decl.base_type;
	else
		btp1=tp1;
	btp2=typeop->type;
/*
	if (!is_same_intrinsic_type(get_base_type(btp1),btp2)) return 556;
*/
	if (!is_same_type(get_base_type(btp1),btp2) ) return 556;

	kind1=get_kind(btp1);

	kind2=-1;
	expr_list=typeop->entry.Template.ll_ptr1;
	for (; expr_list ; expr_list=expr_list->entry.Template.ll_ptr2)
	{
		if (expr_list->entry.Template.ll_ptr1->variant == KIND_OP)
		{
			kind_op=expr_list->entry.Template.ll_ptr1->entry.Template.ll_ptr1;
			comput_const_expr(kind_op,1);
			kind2=kind_op->const_val;
			break;
		}
	}
	if (kind1!=kind2) return 556;

	return 0;
}

/*   same type  , same kind   not same length 
	1: yes
	0: no
*/
int is_same_type(tp1,tp2)
PTR_TYPE tp1,tp2;
{
	int kind1,kind2;
	int rank1,rank2;
	PTR_TYPE  btp1,btp2;

        if (tp1==tp2) return 1;

        if (is_scalar(tp1) && !is_scalar(tp2) ||
		!is_scalar(tp1) && is_scalar(tp2) )
		return 0;

	btp1=get_base_type(tp1);
	btp2=get_base_type(tp2);
	if (is_same_intrinsic_type(btp1,btp2)) ;
	else 			/* base type not equal */
		if (btp1->variant == T_RECORD && btp2->variant == T_RECORD)
		{
			if (!is_same_record(btp1,btp2)) return 0;
		}
		else if (btp1 != btp2)
			return 0;	

	if (!is_scalar(tp1))
	{
		rank1=tp1->entry.ar_decl.num_dimensions;
		rank2=tp2->entry.ar_decl.num_dimensions;
		if (rank1 != rank2) return 0;
		tp1=tp1->entry.ar_decl.base_type;
		tp2=tp2->entry.ar_decl.base_type;
	}
	kind1=get_kind(tp1);			
	kind2=get_kind(tp2);			
	if (kind1 != kind2)  return 0;
	return 1;
}

int is_same_record(tp1,tp2)
PTR_TYPE tp1,tp2;
{
	int num_f1,num_f2;
	PTR_SYMB   sym1,sym2;

	num_f1=tp1->entry.re_decl.num_fields;
	num_f2=tp2->entry.re_decl.num_fields;
	if (num_f1 != num_f2) return 0;
	
	if (strcasecmp(tp1->name->ident,tp2->name->ident) !=0) return 0;

	if (((tp1->name->attr & SEQUENCE_BIT) ==0)  ||
		((tp2->name->attr & SEQUENCE_BIT) ==0 ))
	return 0;

	for (sym1=tp1->entry.re_decl.first,sym2=tp2->entry.re_decl.first;
		sym1; 
		sym1=sym1->next_symb,sym2=sym2->next_symb)
	{
		if (strcasecmp(sym1->ident ,sym2->ident) !=0) return 0;
		if (sym1->attr & PRIVATE_BIT) return 0;
		if (sym2->attr & PRIVATE_BIT) return 0;
		if (!is_same_type(sym1->type,sym2->type)) return 0;
	}
	return 1;
}

/*  if var is declared in current scope , return 1 
    else return 0;
*/
int var_declared(sym)
PTR_SYMB sym;
{
	PTR_BLOB blob;
	PTR_BFND bfnd;
	PTR_LLND  llnd;

	bfnd=cur_scope();
	blob=bfnd->entry.Template.bl_ptr1;
	for ( ; blob ; blob=blob->next) {
		bfnd=blob->ref;
		if (bfnd->variant == VAR_DECL)
		{
			for (llnd=bfnd->entry.Template.ll_ptr1; llnd;
				llnd=llnd->entry.Template.ll_ptr2) 
			{
			  if (get_var_name(llnd->entry.Template.ll_ptr1) == sym)
					return 1;
			}
		}
	}
	return 0;
}


/******************************************************************************
			KIND
******************************************************************************/


int count_kindexp(type)
PTR_TYPE type;
{
	PTR_LLND expr_list;
	PTR_LLND kind_op=LLNULL,len_op=LLNULL,nonlen_op=LLNULL,expr=LLNULL;

	expr_list=type->entry.kind_decl.kindexp->entry.Template.ll_ptr1;
	for (;expr_list;expr_list=expr_list->entry.Template.ll_ptr2)	
	{
		switch  (expr_list->variant ){
		case KIND_OP:
			comput_const_expr(expr_list->entry.Template.ll_ptr1,1);
			if (!isInteger(expr_list->entry.Template.ll_ptr1))
				error1(196);
			else if(expr_list->entry.Template.ll_ptr1->const_val<0)
				error1(238);
			break;
		case LEN_OP:
		case NON_LEN_OP:
			comput_const_expr(expr_list->entry.Template.ll_ptr1,1);
                        break;
		default:
			comput_const_expr(expr_list,1);
                        break;
		}
	}
}

/*   scalar type */
int get_kind(type)
PTR_TYPE type;
{
	PTR_LLND expr_list,kind_op;

	if (type->variant != T_KIND ) return -1;		/* default */
	
	expr_list=type->entry.kind_decl.kindexp->entry.Template.ll_ptr1;
        for (;expr_list;expr_list=expr_list->entry.Template.ll_ptr2)   
        {
                if (expr_list->variant==KIND_OP)
		{
			kind_op=expr_list->entry.Template.ll_ptr1;
			if ((kind_op->attr & GOT_KIND) ==0)
			{
                        	comput_const_expr(kind_op,1);
				kind_op->attr |= GOT_KIND;
			}
			return kind_op->const_val;
                }
        }
	return -1;
}



/******************************************************************************
			LENGTH
******************************************************************************/

int is_const_size_string(sym)
PTR_SYMB sym;
{
	PTR_TYPE type;
	PTR_LLND expr_list;

	type = sym->type;
	if (type->variant == T_ARRAY)
		type= type->entry.ar_decl.base_type;
	if (type->variant == T_STRING )
		return 1;
						/* must be T_KIND */
	expr_list=type->entry.kind_decl.kindexp->entry.Template.ll_ptr1;
        for (;expr_list;expr_list=expr_list->entry.Template.ll_ptr2)
        {
		switch (expr_list->variant) {
		case KIND_OP:
			break;
		case LEN_OP:
                case NON_LEN_OP:
			return 0;
		default: 
			return 1;
		}
	}
	return 1;
	
}

PTR_LLND  get_len_expr(type)
PTR_TYPE type;
{
	PTR_LLND expr_list;
	PTR_LLND kind_op=LLNULL,len_op=LLNULL,nonlen_op=LLNULL,expr=LLNULL;

	expr_list=type->entry.kind_decl.kindexp->entry.Template.ll_ptr1;
	for (;expr_list;expr_list=expr_list->entry.Template.ll_ptr2)	
	{
		switch  (expr_list->variant ){
		case LEN_OP:
		case NON_LEN_OP:
			return expr_list->entry.Template.ll_ptr1;
                        break;
		default:
			return expr_list;
                        break;
		}
	}
	return LLNULL;
}

/*****************************************************************************
				PURE
****************************************************************************/

/*
 *   is_in_pure_or_forall() -- check if in PURE or forall constructure 
 */
int is_in_pure_or_forall()
{
	if (scope_status != NON_PURE )
		return 1;
	return 0;
}

int is_in_pure()
{
	if (scope_status != NON_PURE && scope_status!=FORALL_IN)
		return 1;
	return 0;
}

/***
 0: legal
 error kind : illegal ,such as use a symbol as the assignment variable of an assignment.
 1:    IO
 2:    scope error : global variable 
**/
int pure_var_sym(sym)
PTR_SYMB sym;
{
	PTR_BFND  scope;

	if (scope_status == NON_PURE || scope_status==FORALL_IN ) return 0;
	scope = cur_scope();
        if (sym->entry.var_decl.local == IO ) 
		if (scope_status != PURE_PROC) return 1;
if (debug1) printf("PURE:  checking:%d ,Cur_scope:%d ,sym scope:%d \n",
		checking_part,scope->id, sym->scope->id);

        if (sym->scope != scope)
        	if (checking_part ==3 && sym->scope == scope->control_parent);
        	else return 2;
	return 0;
}

int pure_var_llnd(llnd)
PTR_LLND llnd;
{
	if (scope_status == NON_PURE) return 0;

        switch (llnd->variant ) {
        case RECORD_REF:
        case SUB_STRING:
                llnd = llnd->entry.Template.ll_ptr1;
        }
        switch (llnd->variant ) {
        case VAR_REF:
        case ARRAY_REF:
		return pure_var_sym(llnd->entry.Template.symbol);
	}
	return 0;
}


/*****************************************************************************
			compute the aX+b of align statement
****************************************************************************/

static PTR_SYMB  cur_dummy;
static int       err_code;

int  get_a_b(dummy,expr,a,b)
PTR_LLND dummy,expr,*a,*b;
{
	cur_dummy = SMNULL;
	err_code  = 0;
	if (expr) get_a_b_expr(dummy,expr,a,b);
	return err_code;
}


int get_a_b_expr(dummy,expr,a,b)
PTR_LLND dummy,expr,*a,*b;
{
	PTR_LLND a1,b1,a2,b2;
	PTR_LLND lp,rp,exprList,ele;
	PTR_SYMB sym;
	int	 is_dummy;

	*a = *b = LLNULL;

	lp = expr->entry.Template.ll_ptr1;
	rp = expr->entry.Template.ll_ptr2;

	if (lp) get_a_b_expr(dummy,lp,&a1,&b1);
	if (err_code) return;
	if (rp) get_a_b_expr(dummy,rp,&a2,&b2);
	if (err_code) return;

	if (!lp & !rp) {
		is_dummy = 0;
		if (expr->variant == VAR_REF) {
			sym = expr->entry.Template.symbol;
			if (cur_dummy)
				if (!strcasecmp(cur_dummy->ident,sym->ident))
				   is_dummy =1;
			if (is_dummy == 0)
			  for (exprList = dummy;exprList;exprList=
			    exprList->entry.Template.ll_ptr2) {
				ele = exprList->entry.Template.ll_ptr1;
				if (!ele ) continue;
				if (ele->entry.Template.symbol==SMNULL) return;
				if (!strcasecmp(ele->entry.Template.symbol->
						ident, sym->ident))
				{
					if (cur_dummy) {
						err_code = 222;
						return;
					}
					cur_dummy = sym;
					is_dummy =1;
					break;
				}   /* if */
			   }	/* for */
		}   /* if */
		if (is_dummy) {
			*a = makeLlnd(fi,INT_VAL,LLNULL,LLNULL,SMNULL);
			(*a)->entry.ival = 1;
			(*a)->type = global_int;
		}		/* if */
		else {
			*b = expr;
		}
		return ;
	}	/* if */

/*  one oprand operatin : + - */
	if (lp && !rp) {	
		if (a1)  *a = makeLlnd(fi,expr->variant,a1,LLNULL,SMNULL);
		if (b1)  *b = makeLlnd(fi,expr->variant,b1,LLNULL,SMNULL);	
		return;
	}

/*  two oprand operatin : + - * / */
	switch (expr->variant) {
	case ADD_OP:
	case MINUS_OP:
		if (a1 && a2)            /* a1X + b1  +  a2X + b2 */
			*a = makeLlnd(fi,expr->variant,a1,a2,SMNULL);
		else if (a1 || a2)
			*a = a1 ? a1 : a2;
		if (b1 && b2) 
			*b = makeLlnd(fi,expr->variant,b1,b2,SMNULL);
		else if (b1 || b2)
			*b = b1 ? b1 : b2;
		return;
	case MULT_OP:
		if ( a1 && a2) {
			err_code = 223;
			return;
		}
		if (a1) {     /*   a1X + b1 *  b2  */
			if (b2)
				*a = makeLlnd(fi,MULT_OP,a1,b2,SMNULL);
			if (b1 && b2)
				*b = makeLlnd(fi,MULT_OP,b1,b2,SMNULL);
		}
		if (a2) {    /*    b1 *  (a2X + b2)    */
			if (b1)
                                *a = makeLlnd(fi,MULT_OP,b1,a2,SMNULL);
                        if (b1 && b2)
                                *b = makeLlnd(fi,MULT_OP,b1,b2,SMNULL);
		}
		if (!a1 && !a2) {  /*   b1 * b2 */
			if (b1 && b2)  
                                *b = makeLlnd(fi,MULT_OP,b1,b2,SMNULL);
		}
		return;
	case DIV_OP:
		if ( a1 || a2 ) {
			err_code = 223;
			return;
		}
		if (b1 && b2)     /*    b1 / b2   */
                	*b = makeLlnd(fi,DIV_OP,b1,b2,SMNULL);
		return;
	}   /* switch */
}


/***************************************************************************

			others
****************************************************************************/

int symb_in_use(symbol)
PTR_SYMB symbol;
{
	PTR_BFND bfnd;
	PTR_LLND llnd;
	int	 num;

	num=0;
	/* search global bfnd */
	for (bfnd=fi->head_bfnd ; bfnd ; bfnd=bfnd->thread )
	{
		if (bfnd->entry.Template.symbol &&
			symbol==bfnd->entry.Template.symbol )
		{
		   num++;
		   if (num>1) return 1;
		}
	}

	/* search global llnd */
	for (llnd=fi->head_llnd ; llnd ; llnd=llnd->thread )
	{
		if (llnd->entry.Template.symbol &&
			symbol==llnd->entry.Template.symbol )
		{
		   num++;
		   if (num>1) return 1;
		}
	}

	return 0;
}


int get_binary_val(llnd)
PTR_LLND llnd;
{
	char *str;
	int   i,val=0;

	/* make sure it has not been converted */
	if (llnd->attr & COUNTED_BINARY) return llnd->const_val;
	str=llnd->entry.string_val;
        for (i=2; i< strlen(str)-1 ; i++) {
                val*=2 ;
                val+=(str[i]-'0');
          }
	llnd->attr |= COUNTED_BINARY;
        return val;
}

int get_octn_val(llnd)
PTR_LLND llnd;
{
	char *str;
	int   i,val=0;

	/* make sure it has not been converted */
	if (llnd->attr & COUNTED_BINARY) return llnd->const_val;
	str=llnd->entry.string_val;
        for (i=2; i< strlen(str)-1 ; i++) {
                val*=8 ;
                val+=(str[i]-'0');
          }
	llnd->attr |= COUNTED_BINARY;
        return val;
}

int get_hex_val(llnd)
PTR_LLND llnd;
{
	char *str;
	int   i,tmp,val=0;

	/* make sure it has not been converted */
	if (llnd->attr & COUNTED_BINARY) return llnd->const_val;
	str=llnd->entry.string_val;
        for (i=2; i< strlen(str)-1 ; i++) {
		val*=16 ;
                if (toupper(str[i]) >= 'A' && toupper(str[i]) <= 'F')
                        tmp=toupper(str[i])-'A'+10;
                else
                        tmp=str[i]-'0';
                val+=tmp;
        }
	llnd->attr |= COUNTED_BINARY;
        return val;
}

PTR_BLOB  get_contain_blob(bfnd)
PTR_BFND bfnd;
{
	PTR_BLOB blob;

	for (blob=bfnd->entry.Template.bl_ptr1; blob ; blob=blob->next) 
		if (blob->ref->variant == CONTAINS_STMT) return blob;
	return BLNULL;
}

/**********************************************************************

		maintain rename_list utility

	in use statement ,
	since after renamed , the origin name in the module is not 
	accessible to the program unit , so make a rename list to record 
	the origin name so that symbol look up function will not get them

***********************************************************************/

/*
 *   insert_rename_list(symbol)  -- insert a rename symbol to rename_list
 */
int  insert_rename_list(sym)
PTR_SYMB sym;
{
	SYMB_LIST new_list;
	extern SYMB_LIST rename_list;

	new_list=(SYMB_LIST) chkalloc(sizeof(struct _symbol_list));
	new_list->sym=sym;
	new_list->next=rename_list;
	rename_list=new_list;
/*
	for (new_list=rename_list; new_list; new_list=new_list->next)
		printf("%s\n",new_list->sym->ident);
*/
}


/*
 *   symb_in_rename_list(sym)  -- if sym in rename_list , return 1 , else 0
 */
int symb_in_rename_list(sym)
PTR_SYMB sym;
{
	SYMB_LIST tmp;
	extern SYMB_LIST  rename_list;
	
	for (tmp=rename_list; tmp; tmp=tmp->next)
		if (sym==tmp->sym) return 1;
	return 0;
}


/**************************************************************************

		Maintain  current subname table

*************************************************************************/

int init_record_table()
{
	top_record=-1;
}

void push_record()
{
	if (top_record >= 20 )
	{
		printf("push_record: out of range \n");
		return;
	}	
	record_table[++top_record] = cur_subname;
}

void pop_record()
{
	if (top_record < -1)
		printf("pop_cursub: requested level non-existent\n");
	else if (top_record >= 0)
		cur_subname=record_table[top_record];
	top_record--;
}

/**************************************************************************

		is facility

*************************************************************************/

/*
 *   if sym is a named variable return 1
 */
int  is_named_var(sym)
PTR_SYMB sym;
{
	switch (sym->variant) {
	case VARIABLE_NAME:
	case CONST_NAME:
		return 1;
	default:
		return 0;
	}
}


/*
 *  is_interface_name(sym)  -- check if is interface name .
 */
int is_interface_name(sym)
PTR_SYMB sym;
{
	if (sym->variant == INTERFACE_NAME || sym->attr & INTERFACE_BIT )
		return 1;
	else 
		return 0;
}


int is_variable_llnd(llnd)
PTR_LLND llnd;
{
	if ((llnd->variant==VAR_REF) || (llnd->variant==ARRAY_REF) 
		|| llnd->variant==RECORD_REF || llnd->variant==SUB_STRING )
		return 1;
	else
		return 0;
}

int  is_operator(var)
int var;
{
	switch (var) {
	case ADD_OP:
	case MINUS_OP:
	case MULT_OP:
	case DIV_OP:
	case EXP_OP:
	case EQ_OP:
	case NOTEQL_OP:
	case CONCAT_OP:
	case GT_OP:
	case GTEQL_OP:
	case LT_OP:
	case LTEQL_OP:
	case NOT_OP:
	case AND_OP:
	case OR_OP:
	case EQV_OP:
	case NEQV_OP:
		return 1;
	default:
		return 0;
	}
}

int  ll_has_sym(var)
int var;
{
        switch (var) {
/*
	case INT_VAL:
        case BOOL_VAL:
        case CHAR_VAL:
        case BINARY_VAL:
        case OCTN_VAL:
        case HEX_VAL:
        case DOUBLE_VAL:
        case FLOAT_VAL:
        case STMT_STR:
        case STRING_VAL:
        case KEYWORD_VAL:
	case LABEL_REF:
	case ERR_LABEL:
	case END_LABEL:
	case LABEL_LIST:
	case TYPE_OP:
	case ARITH_ASSGN_OP:
                        return 0;
*/
	case VAR_REF:
	case ARRAY_REF:
	case CONST_REF:
        		return 1;
	default:
			return 0;
        }
}

int is_main_header(bfnd)
PTR_BFND bfnd;
{
	switch (bfnd->variant) {
	case  MODULE_STMT:
	case  PROG_HEDR:
        case  FUNC_HEDR:
        case  PROC_HEDR:
        case  BLOCK_DATA:
		return 1;
	}
	return 0;
}


/* check if this bfnd is in do construct */
int is_in_do_construct(bfnd)
PTR_BFND bfnd;
{
	if (bfnd->control_parent->variant == FOR_NODE || 
		bfnd->control_parent->variant ==  DO_WHILE_NODE ||
		bfnd->control_parent->variant == FORALL_CONSTRUCT_STMT ) {
		return 1;
	}
	return 0;
}


/* 
 * is_result_name() -- if sym is the result name of scope , return 1
*/
int is_result_name(sym,scope)
PTR_SYMB sym;
PTR_BFND scope;
{
	PTR_LLND ftype;

	if (scope->variant != FUNC_HEDR) return 0;
	ftype = scope->entry.func_stmt.ftype;
	if (ftype == LLNULL) return 0;
	if (sym == ftype->entry.Template.symbol) return 1;
	return 0;
}


int is_dummy(scope,sym)
PTR_BFND scope;
PTR_SYMB sym;
{
	PTR_SYMB  proc_sym,io_list;
	int local;

	local=sym->entry.var_decl.local;
	if (local==IO || local==INPUT || local==OUTPUT) return 1;
	
	proc_sym = scope->entry.Template.symbol;
	if (proc_sym == SMNULL)
		return 0;
	io_list = proc_sym->entry.proc_decl.symb_list;
	for ( ; io_list ; io_list=io_list->entry.var_decl.next_in ) {
		if (strcasecmp(sym->ident,io_list->ident)==0) return 1;
	}
	return 0;
}

/*  check if two symbol is the same ,  same ident , same type */
int is_same_symbol_var(sym1,sym2)
PTR_SYMB sym1,sym2;
{
	if (strcasecmp(sym1->ident,sym2->ident) != 0) return 0;
	if (!is_same_type(sym1->type,sym2->type) ) return 0;
	return 1;
}


/*************************************************************************
		serach a symbol in an expression
*************************************************************************/

int RefToSymb(expr,symb)
	PTR_LLND expr;
	PTR_SYMB symb;
{
	if (!expr) return 0;
	if (expr->variant != VAR_REF) return 0;
	if (!strcasecmp(expr->entry.Template.symbol->ident,symb->ident) ) return 1;
	return 0;
}

PTR_LLND IsSymbolInExpression(exprold, symb)
     PTR_SYMB symb;
     PTR_LLND exprold;
{
  PTR_LLND pt =NULL;
  if (!exprold)
    return NULL;
        /*  add by zheng.gb   1997/2/14  */
  if (RefToSymb(exprold,symb))
    return exprold;

  if (RefToSymb(NODE_OPERAND0(exprold),symb))
    return NODE_OPERAND0(exprold);
  else
    pt = IsSymbolInExpression(NODE_OPERAND0(exprold), symb);
  if (pt)
    return pt;

   if (RefToSymb(NODE_OPERAND1(exprold),symb))
    return NODE_OPERAND1(exprold) ;
  else
    pt = IsSymbolInExpression(NODE_OPERAND1(exprold), symb);

  return pt;
}

/*---------------------------------------------------------------------------
		Check if two Proc Header matched
-----------------------------------------------------------------------------*/
int compare_headers(hedr1,hedr2)
PTR_SYMB hedr1,hedr2;
{
/*printf("Compare_headers:%s,%s\n",hedr1->ident,hedr2->ident);*/
	if (hedr1 == hedr2) return 1;
	if (hedr1->variant != hedr2->variant) return 0;
	if (strcasecmp(hedr1->ident ,hedr2->ident) != 0 ) return 0;
	if (hedr1->entry.proc_decl.num_input != hedr2->entry.proc_decl.num_input ||
	    hedr1->entry.proc_decl.num_output != hedr2->entry.proc_decl.num_output ||
	    hedr1->entry.proc_decl.num_io != hedr2->entry.proc_decl.num_io )
	return 0;
	if (!compare_symblist(hedr1->entry.proc_decl.symb_list,hedr2->entry.proc_decl.symb_list))
	return 0;
	return 1;
}

int compare_symblist(symlist1,symlist2)
PTR_SYMB symlist1,symlist2;
{
	PTR_SYMB sym1=symlist1,sym2=symlist2;
	for (; sym1 && sym2 ; sym1=sym1->entry.var_decl.next_in , sym2=sym2->entry.var_decl.next_in)
		if (! is_same_symbol_var(sym1,sym2) ) return 0;
	if (sym1 || sym2) return 0;
	return 1;
}

/*---------------------------------------------------------------------------
		Seaech a function 
-----------------------------------------------------------------------------*/
PTR_BFND search_function(fi,func)
PTR_FILE fi;
PTR_SYMB func;
{
	PTR_BLOB blob;

printf("Search function :%s in line:%d\n",func->ident,cur_bfnd->g_line);
	for(blob=fi->global_bfnd->entry.Template.bl_ptr1;blob;blob=blob->next)
		if ( compare_headers(blob->ref->entry.Template.symbol , func))
		{
			break;
		}
	return  blob ? blob->ref:BFNULL;
}

