/************************  ll.h ***********************/


struct EXPR_LIST_S {      /* for SgExprListExp  */
	PTR_SYMB    null;     /* not used */

	PTR_LLND    item;    /* a element expr in the expr_list */
	PTR_LLND    next;    /* next node in the expr_list */
};
					
struct KIND_VAL_S {	   
	   PTR_SYMB    null;
	   PTR_LLND    value;          /* to a SgValueExp */
	   PTR_LLND    kind;           /* to a SgKindExp */
};                 
             
struct COMPLEX_S {    /* for SgValueExp. variant==COMPLEX_VAL */
	   PTR_SYMB    null;
	   PTR_LLND    real_part;
	   PTR_LLND    imag_part;
};

struct STRUCTURE_CONSTRUCTOR_S {    /* for SgStructureConstExp */
	   PTR_SYMB    null;
	   PTR_LLND    type;            /* to a SgTypeExp */
	   PTR_LLND    values;          /* to a SgExprListExp */
};
					   
struct CONSTRUCTOR_REF_S { /* for SgConstExp */
	   PTR_SYMB    null_1;
	   PTR_LLND    values;          /* to a SgExprListExp */
	   PTR_LLND    null_2;
};

struct IMPLIED_DO_S { /* for SgImpliedDoExp */
	   PTR_SYMB    symbol;           /* to a SgVarSymbol of do_varible */

	   PTR_LLND    objects;        /* to a SgExprListExp */
	   PTR_LLND    range_stride;   /* to a SgExprListExp. Only the first 
										three are useful */
};

struct TYPE_OP_S { /* for SgTypeExp */
	   PTR_SYMB    null_1;
			
	   PTR_LLND    selector;   /* added by us:
									   to a SgKindSelectorExp or a
									   SgCharSlectorExp */ 
	   PTR_LLND    null_2;
};

struct KIND_OP_S{ /* for SgKindExp */
	   PTR_SYMB    null_1;
			
	   PTR_LLND    exp;            /* to a SgExpression */
	   PTR_LLND    null_2;
};


struct ARRAY_REF_S { /* for SgArrayRefExp */
			PTR_SYMB    symbol;     /* to a SgSymbol for part_name */

			PTR_LLND    subscripts; /* to a SgExprListExp of SgSubscriptexp 
										or SgVectorSubExp */
			PTR_LLND    null;
		};

struct LEN_OP_S { /* for SgStringLengthExp */
	   PTR_SYMB    null_1;
			
	   PTR_LLND    len;            /* to a SgExpression */
	   PTR_LLND    null_2;
};

struct ATTRIBUTE_EXP_S { /* for SgAttributeExp */
	   PTR_SYMB    null_1;

	   PTR_LLND    subscripts; /* used for DIMENSION_OP */
	   PTR_LLND    null_3;
};

struct DDOT_S { /* for SgSubscriptExp */
	   PTR_SYMB    null;
			
	   PTR_LLND    range;          /* to a SgRangeExp */
	   PTR_LLND    stride;          /* to a SgExpression */
};

struct RANGE_VAL_S { /* for SgRangeExp */
	   PTR_SYMB    null;

	   PTR_LLND    lower;     /* lower bound of range */ 
	   PTR_LLND    upper;     /* upper bound of range */
};

struct DATA_STMT_SET_S { /* for SgDataStmtSetExp */
	   PTR_SYMB    null;
			
	   PTR_LLND    objects;    /* to a SgExprListExp  */
	   PTR_LLND    values;     /* to a SgExprListExp of SgDataValueExp */
};

struct DATA_VALUE_S { /* for SgDataValueExp */
	   PTR_SYMB    null;
			
	   PTR_LLND    repeat;    /* for data_stmt_repeat */
	   PTR_LLND    value;     /* for data_stmt_constant */
};

struct IMPL_TYPE_S { /* for SgImplicitTypExp */
	   PTR_SYMB    null_1;

	   PTR_LLND    list;       /* to a SgExprListExp of RANGE_VAL */
	   PTR_LLND    type_spec;  /* to a SgTypeExp for type_spec */
};

struct OBJECT_LIST_S { /* for SgObjectListExp */
			PTR_SYMB    symbol;     /* to SgSymbol of namelist_group_name or 
										common_block_name */
			PTR_LLND    list;       /* to a SgExprListExp of objects */
			PTR_LLND    null;
		};

struct VAR_REF_S {  /* for SgVarRefExp */
		   PTR_SYMB  symbol;    /* to a SgVarSymbol */

		   PTR_LLND  null_1;
		   PTR_LLND  null_2;
		};
struct SUB_STRING_S { /* for SgSubString */
		PTR_SYMB    null;
		
		PTR_LLND    parent;    /* to a parent_string SgExpression */
		PTR_LLND    range;     /* to a SgRangeExp */  
	};

struct RECORD_REF_S { /* for SgRecordRefExp */
			PTR_SYMB    null;

			PTR_LLND    rec;        /* to a SgExpression for part_ref[%part_ref]... 
*/
			PTR_LLND    field;      /* to a SgVarRefExp for field */
		};
struct VECTOR_SUB_S { /* for SgVectorSubExp */
			PTR_SYMB    null_1;

			PTR_LLND    vector; /* to a SgExpression for vector_subscript */
			PTR_LLND    null_2;
		};

struct UNARY_OP_S { /* for SgUnaryExp */
			PTR_SYMB    null_1;

			PTR_LLND    operand;  
			PTR_LLND    null_2;
		};
struct BINARY_OP_S { /* for SgExpression */
			PTR_SYMB  null_1;

			PTR_LLND  l_operand;    /* to the left operand */
			PTR_LLND  r_operand;    /* to the right operand */
		};
struct DEFINED_BINARY_OP_S { /* for SgDefinedBinaryOpExp */
			PTR_SYMB    symbol;     /* for operator string */

			PTR_LLND    l_operand;   /* to the left operand */
			PTR_LLND    r_operand;   /* to the right operand */
		};

struct DEFINED_UNARY_OP_S { /* for SgDefinedUnaryOpExp */
			PTR_SYMB    symbol;     /* for operator string */

			PTR_LLND    operand;
			PTR_LLND    null_1;
		};
struct LABEL_LIST_S {  /* for SgLabelListExp */
		  PTR_LABEL lab_ptr;     /* to a label */

		  PTR_LLND  null_1;
		  PTR_LLND  next;        /* next label_list node */
		};
struct  USENAME_NODE{
	PTR_SYMB null_1;

	PTR_LLND lname; /*local name or generic,...*/
	PTR_LLND uname; /*use name*/
	};
struct RENAME_NODE_S { /* for SgUseRenameExp */ 
	PTR_SYMB null_1;

	PTR_LLND lname; /*local name */
	PTR_LLND uname; /*use name*/
	};
struct REF_EXP_S {  /* for SgRefExp */
		PTR_SYMB    symbol;  /* to the symbel */

		PTR_LLND    null_1;
		PTR_LLND    null_2;
	   };
struct LABEL_REF_S { /* for SgLabelRefExp */
	PTR_LABEL   lab_ptr;  /* to a SgLabel */

	PTR_LLND    null_1;
	PTR_LLND    null_2;
		};

struct FUNC_CALL_S { /* for SgFunctionCallExp */
			PTR_SYMB    symbol;     /* for fuction name */

			PTR_LLND    param_list; /* for paramter list */
			PTR_LLND    next_call;
		};

struct   KEYWORD_ARG_S  {
	PTR_SYMB    null;

	PTR_LLND    expr;  /* for the arg expression */
	PTR_LLND    keyword;   /* for the keyword string */
	};


 struct  DISTRIBUTE_S  {
		  PTR_SYMB null_1;

		  PTR_LLND dist_format; /*point to distribute format*/
		  PTR_LLND dist_target; /*point to distribute target*/
 };

struct  DATADIST_S {
	PTR_SYMB  null_1;
        PTR_LLND   int_expa ; /*point to a int_exp(can be nil), STAR_OP
				 or  COLON_OP*/
	PTR_LLND   null_2;
};

struct  ALIGN_ATTR_S {
		  PTR_SYMB null_1;

		  PTR_LLND align_source; /*point to align source list*/
		  PTR_LLND align_with; /*point to align_with clause*/
		 };
	   
	 

/* added for HPF*/
struct llnd{
	int         variant, id;    /* variant and identification tags */
	PTR_LLND    thread;      /* connects nodes together by allocation order */
	PTR_TYPE    type;       /* to be modified */
	
	int         attr;   /*  add by zheng.gb to indicate intermediate expression has been computed !  */
	int         const_val;    /*  add by zheng.gb to  hold intermediate expression */
	union llnd_union_u {
		char*   string_val;     /* for integers, floats, doubles, strings*/
		int     ival;       /* fot integers */
		double  dval;               /* for floats and doubles */
		char    cval;               /* for chars */
		int     bval;               /* for booleans */
		/* fields above are all for SgValueExp */
		
	struct {
			PTR_SYMB    symbol;

			PTR_LLND    ll_ptr1;
			PTR_LLND    ll_ptr2;
		}    Template;


	struct {			/* for range, upper, and lower */
		PTR_SYMB  symbol;
		int	  dim;
	       }					array_op;


	struct {	    /* for complexes and double complexes */
		PTR_SYMB  null;

		PTR_LLND  real_part;
		PTR_LLND  imag_part;
	       }					complex;

	struct {
		PTR_LABEL lab_ptr;

		PTR_LLND  null_1;
		PTR_LLND  next;
	       }					label_list;

	struct {
		PTR_SYMB  null_1;

		PTR_LLND  item; 
		PTR_LLND  next;
	       }					list;

	struct {
		PTR_SYMB  null_1;

		PTR_LLND  size;
		PTR_LLND  list;
	       }					cons;
	
	struct {
		PTR_SYMB  control_var;
		   
		PTR_LLND  array;
		PTR_LLND  range;
	       }					access;

	struct {
		PTR_SYMB  control_var;

		PTR_LLND  array;
		PTR_LLND  range;
	       }					ioaccess;

	struct {
		PTR_SYMB  symbol;

		PTR_LLND  null_1;
		PTR_LLND  null_2;
	       }					const_ref;

	struct {
		PTR_SYMB  symbol;

		PTR_LLND  null_1;
		PTR_LLND  null_2;
	       }					var_ref;

	struct {
		PTR_SYMB  symbol;

		PTR_LLND  index;
		PTR_LLND  array_elt;
	       }					array_ref;

	struct {
		PTR_SYMB  null_1;

		PTR_LLND  access;
		PTR_LLND  index;
	       }					access_ref;

	struct {
		PTR_SYMB  null_1;

		PTR_LLND  cons;
		PTR_LLND  index;
	       }					cons_ref;

	struct {
		PTR_SYMB  symbol;

		PTR_LLND  null_1;
		PTR_LLND  rec_field;  /* for record fields */
	       }					record_ref; 


	struct {
		PTR_SYMB  symbol;

		PTR_LLND  param_list;
		PTR_LLND  next_call;
	       }					proc;

	struct {
		PTR_SYMB  null_1;

		PTR_LLND  operand;  
		PTR_LLND  null_2;
	       }					unary_op; 

	struct {
		PTR_SYMB  null_1;

		PTR_LLND  l_operand;
		PTR_LLND  r_operand;
	       }					binary_op;

	struct {
		PTR_SYMB  null_1;

		PTR_LLND  ddot;
		PTR_LLND  stride;
	       }					seq;

	struct {
		PTR_SYMB  null_1;

		PTR_LLND  sp_label;
		PTR_LLND  sp_value;
	       }					spec_pair;




		struct EXPR_LIST_S          list_s;           /* SgExprListExp */
	        struct KIND_VAL_S           literal;        /* SgValueExp */
		struct COMPLEX_S            complex_s;        /* SgValueExp */
		struct STRUCTURE_CONSTRUCTOR_S  struct_const;   /* SgStructConstExp */
		struct CONSTRUCTOR_REF_S    constructor;    /* SgConstExp */
		struct IMPLIED_DO_S         implied_do;     /* SgImpliedDoExp */
		struct TYPE_OP_S            type_op;        /* SgTypeExp */
		struct KIND_OP_S            kind_op;        /* SgKindExp */
		struct LEN_OP_S             string_length;  /* SgStringLengthExp */
		struct ATTRIBUTE_EXP_S      atribute;       /* SgAttributeExp */
		struct DDOT_S               subscript;      /* SgSubscriptExp */
		struct RANGE_VAL_S          range;          /* SgRangeExp */
		struct DATA_STMT_SET_S      data_stmt_set;  /* SgDataStmtSetExp */
		struct DATA_VALUE_S         data_value;     /* SgDataValueExp */
		struct IMPL_TYPE_S          implicit_type;  /* SgImplicitTypExp */
		struct OBJECT_LIST_S        object_list;        /* SgObjcetListExp */
		struct VAR_REF_S            var_ref_s;            /* SgVarRefExp */
		struct SUB_STRING_S         substring;          /* SgSubstringExp */
		struct ARRAY_REF_S          array_ref_s;      /* SgArrayRefExp */
		struct RECORD_REF_S         record_ref_s;     /* SgRecordRefExp */
		struct VECTOR_SUB_S         vector_sub;     /* SgVectorSubExp */
		struct UNARY_OP_S           unary_op_s;       /* SgUnaryExp */
		struct BINARY_OP_S          binary_op_s;      /* SgExpression */
		struct DEFINED_BINARY_OP_S  def_binary_op;  /* SgDefinedBinaryOpExp */
		struct DEFINED_UNARY_OP_S   def_unary_op;   /* SgDefinedUnaryOpExp */
		struct LABEL_LIST_S         label_list_s;     /* SgLabelListExp */
		struct RENAME_NODE_S        rename_node;    /* SgUseRenameExp */
		struct REF_EXP_S            symbol_ref;     /* SgRefExp */
		struct LABEL_REF_S          label_ref;      /* SgLabelRefExp */
		struct FUNC_CALL_S          func_call;      /* SgFuctionCallExp */
		struct KEYWORD_ARG_S        keyword;        /* SgKeywordArgExp */
                struct  DISTRIBUTE_S	    distribute_exp;  /*SgDistributeAttrExp*/
                struct	DATADIST_S          datadist_exp;    /*SgDataDistExp*/
		struct  ALIGN_ATTR_S       alignattr_exp;   /*SgAlignAttrExp*/
	} entry;        
};

# define __LL_DEF__  


