/************************************************************************
 *                                                                      *
 *                    hash and symbol table entries                     *
 *           ( Notes: Please set tabstop=4 when use vi to edit)         *
 *                                                                      *
 ************************************************************************/

struct cnt {					/* common block name table. added by Feng Xiaobing */
	PTR_SYMB	symbol;			/* common block name, if it is a nonname common block, this field is null*/
	struct cnt * 	next_common_item;	/* point the next common item*/
	int 		attr;			/* attr=1 this common block is a sequence common block 
						   attr=0 otherwise */
	int 		size;			/* common block length */
	PTR_SYMB	ft,lt;			/* point the first and the last symbol item of this common block */
};

struct cml { 					/* the structure of common link, added by Feng Xiaobing */
	PTR_SYMB	previouse,next;		/* point the previous and succeding symbol of this common block */
	struct cnt *	common_item;		/* point the common block which include this symbol */
	int 		offset;			/* if offset=0 then this object is not appearing in any common link */
	PTR_SYMB	group_next;		/* point the next symbol of same aggregate variable group */
};

struct eq_link {				/* the structure of equivalence link, added by Feng Xiaobing */
	int	 	offset; 		/* the offset of this object according to the base object */
	PTR_SYMB	next;			/* point the next object of this equivalence link */
};

struct mr_link {				/* added by Feng Xiaobing */
	int 		offset;			/* the offset of this object according to the base object */
	PTR_SYMB	next_object;		/* point the next object of this equivalence ring */
	struct mr_link * next;			/* if there are more than one equivalence link associated with this object,
						   then this field point the next equivalence ring.
						   And this field is useful for equivalence merging. */
	int 		code;			/* the ring code */
	int 		line_number;            /* the line which this statement appear */
};


struct hash_entry {
	char                *ident;	    
						/* Pointer to character string of  the symbol */
	struct hash_entry *next_entry;    
						/* Pointer to the next hast-entry with the same hash    
						value */
	PTR_SYMB            id_attr;        
						/* Point the hash entry to the symbol table entry */
};

struct symb {
		int         variant;        /* variant tag of the symbol */
		int         id;             /* unique identification tag */
		char        *ident;         /* charater string of  the symbol */
		struct hash_entry *parent;        
					/* point the symbol table entry to the hash_entry 
					see hast_entry */
		PTR_SYMB    outer;      
					/* pointer to symbol in enclosing block; The enclosing block    
					begin with the control parent of the declaration statement. */
		PTR_SYMB    next_symb;  /* pointer to next symbol in same block */
		PTR_SYMB    id_list;        /* be used to make lists of ids 
					For example, the parser may want to set up a type for variables
					and parameters; In the case, these varables and parameters are
					chained by this pointer*/
		PTR_SYMB    thread;     /* list of all allocated symbol pointers, which points the  
					Symbol Table entry allocated just after this symbol */
		PTR_TYPE    type;       /* data type of this identifier */
		PTR_BFND    scope;      /* level at which ident is declared, i.e. the control parent of the 
					declaration statement. In FORTRAN, this is the Program  
					Header or the Subroutine Header or the Function Header  
					where the symbol is defined behind them */ 
		PTR_BLOB    ud_chain;   /* use_definition chain, used for flow analysis */
		int         attr;       /* attributes of the variable. see Attribute Bit*/
		int         dovar;      /* set if used as loop's control variable */
		int         decl;       /* field that the parser use in keeping track
								of declarations If the variable has not been 
								declared, is SOFT else HARD */

		union symb_union_u {

		struct {                    /* for enum-field and record field */
			int         tag;        /* used to distinguish the type of the field*/  
			int         offset;         
						/* the field offset of the enum or record structure */
			PTR_SYMB declared_name ;   /* used for friend construct */
			PTR_SYMB    next;       /* point to the next field */
			PTR_SYMB    base_name;  /* name of record or enumerated type */
			PTR_LLND  restricted_bit ;
		} field;

		struct {                /* for program */
						/* variant == PROGRAM_NAME */
			int         null1;
			int         null2,null3,null4;
			PTR_SYMB    null5,null6;
			PTR_SYMB    symb_list;  
			int         null7;
			PTR_LABEL   label_list; /* Label list occur in this subroutine */
			PTR_BFND    prog_hedr;  /* Program Header statement */
			PTR_LLND    null8;
			int         null9, null10;
			PTR_SYMB    declared_name,next,null13;

			PTR_LLND	use_list;/*added by Yanmi*/
			PTR_LLND	interface_list;/*added by zheng.gb*/
		
			struct cml   null14;
                        struct eq_link null15;
                        struct mr_link *null16;
			struct cnt * common_table; /* common name table, added by Feng Xiaobing */
		} prog_decl;

		struct {                /* for PROC; 
						variant==PROCEDURE_NAME | ROUTINE_NAME */
			int     seen;       /* If the procedure has not been declared   
							   formally, set it to be "NO" , else  "YES" */ 
			int     num_input;  /* the number of input arguments */
			int     num_output; /* the number of output arguments */
			int     num_io;     /* the number of input and output
								arguments*/
			PTR_SYMB    in_list;        /* input arguments' symbol list */
			PTR_SYMB    out_list;       /* output arguments' symbol list */
			PTR_SYMB    symb_list;      /* arguments' symbol list */
                int        local_size;

			PTR_LABEL   label_list; /* Label list occur in this subroutine */
			PTR_BFND    proc_hedr;  /* Subroutine Header statement */
			PTR_LLND    call_list;      /* point to the last procedure-call's  llnd
							in this procedure. This procedure-call llnd's
							next-call( which should be the last-call indeed
							according to "match_parameters( )" in Sage++'s
							stat.c file) points to the last-call(the 2nd call
							from the end occurs in this procedure), and so 
							on,  to form the call_list. */
			
			int      null1;
                        int      null2;
                        PTR_SYMB declared_name;
                        PTR_SYMB next , null5;

			PTR_LLND	use_list;/*added by Yanmi*/
			PTR_LLND	interface_list;/*added by zheng.gb*/

			struct cml   null6;
                        struct eq_link null7;
                        struct mr_link *null8;          /* add by zheng.gb */

			struct cnt * common_table; /* common name table, added by Feng Xiaobing */
		} proc_decl;    /* for FORTRAN, procedure means subroutine and function,
				but here only subroutine*/

		struct {                /* for FUNC; variant=FUNCTION_NAME*/
			int     seen;       /* If the function has not been declared    
								formally, set it to be "NO" , else  "YES" */
			int     num_input;  /* the number of input arguments */
			int     num_output; /* the number of output arguments */
			int     num_io;     /* the number of input and output
								arguments*/
			PTR_SYMB    in_list;        /* input arguments' symbol list */
			PTR_SYMB    out_list;       /* output arguments' symbol list */
			PTR_SYMB    symb_list;  /* arguments' symbol list */
                int        local_size;

			PTR_LABEL   label_list; /* Label list occur in this subroutine */
			PTR_BFND    func_hedr;  /* Function Header statement */
			PTR_LLND    call_list;  
							/* point to the first procedure-call's  llnd
							in this function. The procedure-call llnd's
							next-call points to the next-call(the 2nd call  
							occurs in this procedure), and so on,  to 
							form the call_list. */
			int      null1;
			int      null2;
			PTR_SYMB declared_name;
			PTR_SYMB next , null5;

			PTR_LLND	use_list;/*added by Yanmi*/
			PTR_LLND	interface_list;/*added by zheng.gb*/

			struct cml   null6;
			struct eq_link null7;
			struct mr_link *null8;		/* add by zheng.gb */
			struct cnt * common_table; /* common name table, added by Feng Xiaobing */

		} func_decl;

		struct {                    /* for variable declaration. 
							variant=VARIABLE_NAME */
			 int        local;          /* local or input or output or both param*/
			 PTR_SYMB   next_in;    /* for list of input parameters*/
			 PTR_SYMB   next_out;   /* for list of output parameters*/
			 int        offset;     
			 int        dovar;          /* set if being used as DO control var */
			int	associated; /*added by Yanmi , for dummy*/
                         PTR_LLND  hpfattr; /*added by wzl,for distribute and align attribute*/
			struct cml common_link; /* common link , added by Feng Xiaobing */
			struct eq_link eq_link; /* equivalence link, added by Feng Xiaobing */
			struct mr_link * MR; /* point to an equivalence ring, added by Feng Xiaobing */
			PTR_LLND  const_value;      /* for constants;  variant=CONSTANT_NAME*/
		} var_decl;


		struct {
		  int	   seen ;
		  int	   num_input,  num_output, num_io ;
		  PTR_SYMB   in_list ;
		  PTR_SYMB   out_list ;
		  PTR_SYMB   symb_list;
		  int	   local_size;
		  PTR_LABEL  label_list ;
		  PTR_BFND   func_hedr ;
		  PTR_LLND   call_list ;
				      /* the following information for field */
		  int	   tag ;
		  int	   offset ;
		  PTR_SYMB   declared_name; /* used for friend construct */
		  PTR_SYMB   next ;
		  PTR_SYMB   base_name ;
				      /* the following is newly added */

		} member_func	    ;	      /* New  one for VPC */


           	struct {
			int seen;
			int  num_input,num_ouput,num_io;
			PTR_SYMB	in_list;
			PTR_SYMB	out_list;
			PTR_SYMB	symb_list;
			int			local_size;
			PTR_LABEL	label_list;
			PTR_BFND	func_hedr;
			PTR_LLND	call_list;
				/* the following information for field */
			int	tag;
			int	offset;
			PTR_SYMB	declared_name;
			PTR_SYMB	next;
		        PTR_SYMB		base_name;
			
			PTR_LLND	use_list;/*added by Yanmi*/
			PTR_LLND	interface_list;/*added by zheng.gb*/
			struct cml	common_link; /* common link, added by Feng Xiaobing */
			struct eq_link	eq_link; /* equivalence link, added by Feng Xiaobing */
			struct mr_link * MR; /* equivalence ring, added by Feng Xiaobing */
			struct cnt * common_table; /* common block name table, added by Feng Xiaobing */
			PTR_LLND  const_value;      /* for constants;  variant=CONSTANT_NAME*/

		} Template;


	} entry;
};

/************************************************************
*                                                           *
*            The Data Type of the Symbol                    *
*                                                           *
*************************************************************/
struct data_type {
		int         variant;  /* the type of the data, such as T_INT, T_ARRAY  and T_* etc. */
		int         id;     /* unique indentification tag */
		int         length;     /* length of the type */
		PTR_TYPE    thread;     /* list of all allocated type pointers */
		PTR_SYMB    name;       /* type name */
		PTR_BLOB    ud_chain;   /* use_definition chain */
	
	union type_union_u {
	/* no entry needed for T_INT, T_CHAR, T_FLOAT, T_DOUBLE,  T_BOOL */


		struct {        /* for T_ARRAY */
				PTR_TYPE    base_type;  /* New order   */
				int         num_dimensions;
				PTR_LLND    ranges;
		} ar_decl;

		struct {        /* for T_KIND, F90 extensions */
				PTR_TYPE    base_type;  /* New order   */
				PTR_LLND    kindexp;        /* Points to a llnd with variant= SgKindExp */
		} kind_decl;

		struct {        /* for T_RECORD or T_ENUM */
				int         num_fields;
				int         recordize;
				PTR_SYMB    first;
				int         mapped_flag;
		} re_decl;

				/* add for unparse */
		struct {                /* for class T_DERIVED_COLLECTION   */
            		PTR_SYMB collection_name;
            		PTR_TYPE base_type; /* base type or inherited collection */
        	} col_decl ;

		struct {                /* for T_DESCRIPT */
            		PTR_TYPE  base_type ;
            		int signed_flag ;
            		PTR_LLND ranges    ;
            		int long_short_flag ;
            		int mod_flag ;
            		int storage_flag;
            		int access_flag;
         	} descriptive ;

		struct {
			PTR_SYMB symbol;
			PTR_SYMB scope_symbol;
        	} derived_type ; /* for type name deriving type */

		struct {                /* for class T_DERIVED_TEMPLATE   */
			PTR_SYMB templ_name;
			PTR_LLND args;      /* argument list for templ */
        	} templ_decl ;

		struct {                /* for class T_CLASS T_UNION T_STRUCT */
            		int num_fields;
            		int record_size;
            		PTR_SYMB first;
            		PTR_BFND original_class ;
            		PTR_TYPE base_type; /* base type or inherited collection */
        	} derived_class ;

		struct {                /* for T_SUBRANGE */
            		PTR_TYPE base_type; /* = to T_INT, T_CHAR, T_FLOAT */
            		PTR_LLND lower, upper;
        	} subrange;


		PTR_TYPE base_type;     /* for T_LIST */

		struct {
				PTR_TYPE    base_type ; /* Type specification */
				int     dummy1;
				PTR_LLND    ranges    ; /* lengspec */
				int     dummy2 ;
				int     dummy3;
				int     dummy4;
				int     dummy5;
		}  Template ;   /* for T_ARRAY,T_FUNCTION,T_POINTER */

	} entry;
}; 

#define __SYMB_DEF__



