%{
#ifdef HAVE_CONFIG_H
#include <config.h>                     /* config header file */
#endif

#if defined(STDC_HEADERS) && (STDC_HEADERS==1)
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>
#include "tags.h"
#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"
#include "defnodes.h"
#include "makenodes.h"
#include "extern.h"
#include "makespec.h"
#include "exec_part.h"
#include "decl.h"
#define  errResynch() { throw_away(); yyerrok; yyclearin; }

#ifndef YYTEXT_IS_POINTER
#ifdef IS_UNSIGNED_CHAR
 extern unsigned char yytext[YYLMAX];
#else
 extern char yytext[YYLMAX];
#endif
#else
#ifdef IS_UNSIGNED_CHAR
 extern unsigned char *yytext;
#else
 extern char *yytext;
#endif
#endif

#include "err_token.h"   /* xli, 1/21/97 */

int outer_scope;                     /* indicate outest function declare */
int default_access=0;                  /* Zheng Gengbin 1996.5.22 */
PTR_BFND newProgram_g;  /* Lxy 4.30 */
PTR_LABEL cur_label;    /* zheng.gb */

%}

%union{
    int token;
    char charv;
    char *charp;
    char charp1[STR_LENGTH];
    PTR_BFND bf_node;
    PTR_LLND ll_node;
    PTR_SYMB symbol;
    PTR_TYPE data_type;
    PTR_HASH hash_entry;
    PTR_CMNT cmnt_node;
    PTR_LABEL label;
 }


%token ABSTRACT     BOOLEAN    BREAK    BYTE     CASE      CATCH
%token CHAR         CLASS      CONST    CONTINUE DEFAULT_   DO        DOUBLE
%token ELSE         EXTENDS    FINAL    FINALLY  FLOAT     FOR     GOTO
%token IF           IMPLEMENTS IMPORT   INSTANCEOF   INT       INTERFACE
%token LONG         NATIVE     NEW      PACKAGE  PRIVATE   PROTECTED
%token PUBLIC       RETURN     SHORT    STATIC   SUPER     SWITCH
%token SYNCHRONIZED THIS       THROW    THROWS   TRANSIENT TRY
%token VOID         VOLATILE   WHILE

%token EQ_     LE_     GE_     NE_     AND_    OR_
%token PP_     MM_     LL_     RR_     RRR_
%token PIS_    MINIS_  MULIS_  DIS_    ANDIS_  ORIS_
%token UIS_    IDIVIS_ LLIS_   RRIS_   RRRIS_  

%token<charp>  CHAR_LITERAL STRING_LITERAL
%token<charp>  IDENTIFIER
%token NULL_LITERAL BOOL_TRUE_LITERAL BOOL_FALSE_LITERAL 
%token INT_DEC_LITERAL INT_OCT_LITERAL INT_HEX_LITERAL 
%token REAL_LITERAL DOUBLE_LITERAL 

%token XXX_


%start compilation_unit

%type<bf_node>   opt_pack opt_import opt_type
%type<bf_node>   importdecls importdecl typedecls typedecl
 
%type<ll_node>   opt_mod modifiers modifier
%type<ll_node>   variabledeclaratorid methoddeclarator 

%type<ll_node>   type primitivetype numerictype integraltype
%type<ll_node>   fptype referencetype c_i_type classtype
%type<ll_node>   interfacetype arraytype opt_super

%type<ll_node>   name qualifiedname opt_interfaces interfacetypelist
%type<ll_node>   variableinitializer variableinitializers arrayinitializer
%type<ll_node>   stmtexp stmtexplist opt_forinit opt_forupdate
%type<ll_node>   primary literal primarynonewarray classinst_exp opt_argl
%type<ll_node>   argumentlist arrayinst_exp dim_part dimexps dimexp
%type<ll_node>   dims dim fieldaccess methodinvocation arrayaccess postfixexp
%type<ll_node>   postincrementexp postdecrementexp unaryexp preincrementexp
%type<ll_node>   predecrementexp unaryexpnotplusminus castexp
%type<ll_node>   additiveexp shiftexp relationalexp equalityexp andexp
%type<ll_node>   inclusiveorexp conditionalandexp conditionalorexp
%type<ll_node>   assignmentexp assignment lefthandside exp opt_exp opt_extends
%type<ll_node>   opt_formal formalparameterlist formalparameter classtypelist
%type<ll_node>   exclusiveorexp extendsinterfaces conditionalexp multiplicativeexp

%type<ll_node>   variabledeclarators variabledeclarator localvariabledecl
%type<bf_node>   classdecl 
/* classbody */ classbodydecls
%type<bf_node>   classbodydecl classmemberdecl staticinitializer constructordecl
%type<bf_node>   fielddecl methoddecl abstractmethoddecl 
/* methodbody constructorbody */
%type<bf_node>   methodheader interfacedecl 
/* interfacebody */ interfacememberdecls
%type<bf_node>   interfacememberdecl constantdecl block opt_blockstmt blockstmts
%type<bf_node>   localvariablestmt stmt stmtnoshortif stmtwithouttrailingsubstmt
%type<bf_node>   emptystmt labeledstmt labeledstmtnoshortif expstmt breakstmt
%type<bf_node>   ifstmt elsestmt 
%type<bf_node>   ifthenstmt ifthenelsestmt ifthenelsestmtnoshortif
%type<bf_node>   switchstmt switchblock 
/* switchblockstmtgroups switchblockstmtgroup */
%type<bf_node>   switchlabel whilestmt whilestmtnoshortif dostmt forstmt
%type<bf_node>   continuestmt returnstmt throwstmt synchronizedstmt
%type<bf_node>   trystmt finally_block catches catchclause act_block alt_stmt
%type<bf_node>   blockstmt forstmtnoshortif 
/* switchlabels */

%type<token>  assignop
%type<ll_node>   constructordeclarator 
%type<bf_node>   thisandsuper
%type<bf_node>   classdecl_header interface_header constructordecl_header
%type<bf_node>   switchbegin whilestmtbegin dostmtbegin forstmtbegin
%type<bf_node>   tryheader finallyheader catchheader
%type<bf_node>   staticheader synchronizeheader blockbegin ifthenelsestmtbegin

%%

/*** Chapter  19.6 * 2/11/97 **/

compilation_unit 
    : opt_pack opt_import opt_type {
         }
    ;

opt_pack         
    : PACKAGE name ';' {
         $$ = makeBfnd(fi,PACKAGE_STMT);
         $$->entry.Template.ll_ptr1=$2;
         setBlob($$,global_bfnd); 
         } 
    | {
        $$ = BFNULL;
    	 }                     
    ;

opt_import       
    : importdecls 
    |  {
        $$ = BFNULL;
         }
    ;

importdecls      
    : importdecl {
          $$ = setBfndList(BFNULL,$1);
          }
    | importdecls importdecl {
          $$ = setBfndList($1,$2);
          }
    ;

importdecl       
    : IMPORT name ';' {
         $$ = makeBfnd(fi,IMPORT_STMT);
         $$->entry.Template.ll_ptr1 = $2;
         }       
    | IMPORT name '.' '*' ';' {
         PTR_LLND l;
         l = makeLlnd(fi,DOTSTAR_OP,$2,LLNULL,SMNULL);
         $$ = makeBfnd(fi,IMPORT_STMT);
         $$->entry.Template.ll_ptr1 = l; 
         } 
    ;


opt_type         
    : typedecls
    |  {
        $$ = BFNULL;
         }
    ;

typedecls        
    : typedecl
    | typedecls typedecl    
    ;

typedecl         
    : classdecl 
    | interfacedecl 
 /*   | error err_sep { } */
    ;

/*** Chapter 19.7 * 2/11/97 **/

modifiers        
    :  modifier {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  modifiers modifier {
          $$ = set_ll_list($1,$2,EXPR_LIST);
          }
    ;

modifier
    :  PUBLIC {
       /*   type_options = type_options | PUBLIC_BIT; */
          $$ = makeLlnd(fi, PUBLIC_OP, LLNULL, LLNULL, SMNULL);
          }
    |  PROTECTED {
       /*   type_options = type_options | PROTECTED_BIT; */
          $$ = makeLlnd(fi, PROTECTED_OP, LLNULL, LLNULL, SMNULL);
          }
    |  PRIVATE {
       /*   type_options = type_options | PRIVATE_BIT; */
          $$ = makeLlnd(fi, PRIVATE_OP, LLNULL, LLNULL, SMNULL);
          }
    |  STATIC {
       /*   type_options = type_options | STATIC_BIT; */
          $$ = makeLlnd(fi, STATIC_OP, LLNULL, LLNULL, SMNULL);
          }
    |  ABSTRACT {
       /*   type_options = type_options | ABSTRACT_BIT; */
          $$ = makeLlnd(fi, ABSTRACT_OP, LLNULL, LLNULL, SMNULL);
          }
    |  FINAL {
       /*   type_options = type_options | FINAL_BIT; */
          $$ = makeLlnd(fi, FINAL_OP, LLNULL, LLNULL, SMNULL);
          }
    |  NATIVE {
       /*   type_options = type_options | NATIVE_BIT; */
          $$ = makeLlnd(fi, NATIVE_OP, LLNULL, LLNULL, SMNULL);
          }
    |  SYNCHRONIZED {
       /*   type_options = type_options | SYNCHRONIZED_BIT; */
          $$ = makeLlnd(fi, SYNCHRONIZED_OP, LLNULL, LLNULL, SMNULL);
          }
    |  TRANSIENT {
       /*   type_options = type_options | TRANSIENT_BIT; */
          $$ = makeLlnd(fi, TRANSIENT_OP, LLNULL, LLNULL, SMNULL);
          }
    |  VOLATILE  {
       /*   type_options = type_options | VOLATILE_BIT; */
          $$ = makeLlnd(fi, VOLATILE_OP, LLNULL, LLNULL, SMNULL);
          }
    ;

/*** Chapter 19.8 * 2/11/97 **/

classdecl
    :  classdecl_header  '{' classbodydecls '}'  {
         PTR_BFND p;
         p = makeEnd (fi);
         endlineNum();
         delete_beyond_scope_level(pred_bfnd);

         $$ = makeMain_l($1,$3,BFNULL,BFNULL,p);
         $1->entry.interface.interface_end=p;
         containsNum_g--;
        }
    |  classdecl_header  '{'  '}'  {
           $$ = BFNULL;
           containsNum_g--;
           } 
    ;

classdecl_header
    :  opt_mod CLASS IDENTIFIER opt_super opt_interfaces {
         PTR_SYMB s;
         s =  makeSymbUnithead(fi,CLASS_NAME,$3);
         $$ = makeClassInterface(fi,s,CLASS_DECL);
         $$ -> entry.Template.ll_ptr1=$1;
         $$ -> entry.Template.ll_ptr2=$4;
         $$ -> entry.Template.ll_ptr3=$5;
         add_scope_level($$,NON);
          outer_scope=1;
         containsNum_g++;
         }
    ;

opt_mod
    :  modifiers {
         $$ = makeLlnd(fi,MODIFIERS_OP,$1,LLNULL,SMNULL);
         }
    |  {
        $$ = LLNULL;
         }
    ;

opt_super
    :  EXTENDS classtype {
         $$ = makeLlnd(fi,EXTENDS_OP,$2,LLNULL,LLNULL,SMNULL);
         }
    |  {
         $$ = LLNULL;
         }
    ;

opt_interfaces
    :  IMPLEMENTS interfacetypelist {
         $$ = makeLlnd(fi,IMPLEMENTS_OP,$2,LLNULL,LLNULL,SMNULL);
          }
    |  {
         $$ = LLNULL;
         }
    ;

interfacetypelist
    :  interfacetype{
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  interfacetypelist ',' interfacetype {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;

classbodydecls
    :  classbodydecl {
          if(($1->variant!=FUNC_HEDR)&&($1->variant!=STATIC_STAT))
          $$ = setBfndList(BFNULL,$1);
          }
    |  classbodydecls classbodydecl {
          if(($2->variant!=FUNC_HEDR)&&($2->variant!=STATIC_STAT))
          $$ = setBfndList($1,$2);
          }
    ;

classbodydecl
    :  classmemberdecl
    |  staticinitializer
    |  constructordecl
 /*   |  error err_sep { } */
    ;

classmemberdecl
    :  fielddecl
    |  methoddecl
    ;

fielddecl
    :  opt_mod type variabledeclarators ';' {
         $$ = makeTypedecl(fi,$3,$2,$1);
         }
    ;

variabledeclarators
    :  variabledeclarator {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  variabledeclarators ',' variabledeclarator {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;

variabledeclarator
    :  variabledeclaratorid
    |  variabledeclaratorid '=' variableinitializer {
          $$ = makeLlnd(fi,ASSGN_OP,$1,$3,SMNULL);
          }
    ;

variabledeclaratorid
    :  IDENTIFIER {
          PTR_SYMB s;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,1);
          $$ = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          }
    |  variabledeclaratorid '[' ']' {
/*          PTR_LLND l;
          l = makeLlnd(fi,DDOT,LLNULL,LLNULL,SMNULL);
          $$ = makeLlnd(fi,ARRAY_REF,l,LLNULL,$1->entry.Template.symbol);
*/
          $$ = makeLlnd(fi,JAVA_ARRAY_REF,$1,LLNULL,SMNULL);
          type_options = type_options | DIMENSION_BIT; 
          }
    ;

variableinitializer
    :  exp 
    |  arrayinitializer
    ;

/*
methoddecl
    :  methodheader methodbody {
          $$ = makeMain_l($1,$2,BFNULL,BFNULL,BFNULL);
          }
    ;
*/

methoddecl
    :  methodheader '{' opt_blockstmt '}'  {
         PTR_BFND p;
         p = makeEnd (fi);
         endlineNum();
         delete_beyond_scope_level(pred_bfnd);

          $$ = makeMain_l($1,$3,BFNULL,BFNULL,p);
          $1->entry.interface.interface_end=p;
         containsNum_g--;
          }
    |  methodheader ';' {
         PTR_BFND p;
         p = makeEnd (fi);
         endlineNum();
         delete_beyond_scope_level(pred_bfnd);

         $$ = makeMain_l($1,BFNULL,BFNULL,BFNULL,p);
         $1->entry.interface.interface_end=p;
         containsNum_g--;
         } 
    ;

methodheader
    :  opt_mod type methoddeclarator THROWS classtypelist {
           int status=outer_scope;
           $$ = makeJFunction(fi,$3,$2,$5,$1);
           containsNum_g++;
         /* if (containsNum_g!=0 || status==0) */
                         add_scope_level($$,NON);
          vartype = TYNULL;
           }
    |  opt_mod type methoddeclarator {
           int status=outer_scope;
           $$ = makeJFunction(fi,$3,$2,LLNULL,$1);
           containsNum_g++;
          /* if (containsNum_g!=0 || status==0) */
                         add_scope_level($$,NON);
          vartype = TYNULL;
           }
    |  opt_mod VOID methoddeclarator THROWS classtypelist {
           int status=outer_scope;
           PTR_LLND l;
           l=makeLlnd(fi,VOID_OP,LLNULL,LLNULL,SMNULL);
           $$ = makeJFunction(fi,$3,l,$5,$1);
           containsNum_g++;
          /* if (containsNum_g!=0 || status==0) */
                         add_scope_level($$,NON);
          vartype = TYNULL;
           }
    |  opt_mod VOID methoddeclarator {
           int status=outer_scope;
           PTR_LLND l;
           l=makeLlnd(fi,VOID_OP,LLNULL,LLNULL,SMNULL);
           $$ = makeJFunction(fi,$3,l,LLNULL,$1);
           containsNum_g++;
          /* if (containsNum_g!=0 || status==0) */
                         add_scope_level($$,NON);
          vartype = TYNULL;
           }
    ;

methoddeclarator
    :  IDENTIFIER '(' opt_formal ')' {
          PTR_SYMB s;
          s = makeSymbUnithead(fi,FUNCTION_NAME,$1);
          $$ = makeLlnd(fi,FUNCTION_REF,$3,LLNULL,s);
          }
    |  methoddeclarator  '[' ']' {
/*          $$ = makeLlnd(fi,ARRAY_REF,$1,LLNULL,$1->entry.Template.symbol);
*/
          $$ = makeLlnd(fi,JAVA_ARRAY_REF,$1,LLNULL,$1->entry.Template.symbol);
          }
    ;

opt_formal
    :  formalparameterlist
    |   { $$ = LLNULL;
          }
    ;

formalparameterlist
    :  formalparameter {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  formalparameterlist ',' formalparameter {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;

formalparameter
    :  type variabledeclaratorid {
          $$ = makeLlnd(fi,FORMAL_PAR_OP,$1,$2,SMNULL);
          }
    ;

classtypelist       
    : classtype  {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    | classtypelist ',' classtype   {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;

/*
methodbody          
    : block
    | ';' {
          $$ = BFNULL;
          } 
    ;
*/

staticinitializer   
    : staticheader block {
          PTR_BFND endFor;
          if($1->entry.Template.bl_ptr1->ref->id!=$2->id)
            $$ = lnkStmts($1,NULL,$2,NULL);
          endFor = makeEnd(fi);
          setBfndList($2,endFor);
          }          
    ;

staticheader
    : STATIC  {
          $$ = makeBfnd(fi,STATIC_STAT); 
          makeSonBlob($$,1);
       }
    ;

constructordecl_header
    : opt_mod constructordeclarator THROWS classtypelist {
           int status=outer_scope;
           $$ = makeJFunction(fi,$2,LLNULL,$4,$1);
           containsNum_g++;
         /* if (containsNum_g!=0 || status==0) */
                         add_scope_level($$,NON);
          vartype = TYNULL;
         }
    | opt_mod constructordeclarator {
           int status=outer_scope;
           $$ = makeJFunction(fi,$2,LLNULL,LLNULL,$1);
           containsNum_g++;
        /*  if (containsNum_g!=0 || status==0) */
                         add_scope_level($$,NON);
          vartype = TYNULL;
           }
    ;

/*
constructordecl       
    : constructordecl_header constructorbody {
         }
    ;
*/

constructordecl    
    : constructordecl_header '{' opt_blockstmt '}' {
         PTR_BFND p;
         p = makeEnd (fi);
         endlineNum();
         delete_beyond_scope_level(pred_bfnd);

          $$ = makeMain_l($1,$3,BFNULL,BFNULL,p);
          $1->entry.interface.interface_end=p;
         containsNum_g--;
          }
    | constructordecl_header '{' thisandsuper opt_blockstmt '}' {
         PTR_BFND p;
         p = makeEnd (fi);
         endlineNum();
         delete_beyond_scope_level(pred_bfnd);

          $$ = makeMain_l($1,$3,BFNULL,BFNULL,p);
          $1->entry.interface.interface_end=p;
         containsNum_g--;
          }
    ;

thisandsuper
    :  THIS  '(' opt_argl ')' ';' {
          $$ = makeBfnd(fi,THIS_STMT);
          $$->entry.Template.ll_ptr1=$3;
          $$ = lnkStmts(NULL,NULL,$$,NULL);
         }
    |  SUPER '(' opt_argl ')' ';' {
          $$ = makeBfnd(fi,SUPER_STMT);
          $$->entry.Template.ll_ptr1=$3;
          $$ = lnkStmts(NULL,NULL,$$,NULL);
        }
    ;

constructordeclarator 
    : IDENTIFIER '(' opt_formal ')'  {
          PTR_SYMB s;
          s = makeSymbUnithead(fi,FUNCTION_NAME,$1);
          $$ = makeLlnd(fi,FUNCTION_REF,$3,LLNULL,s);
         }
    ;

/*
constructorbody       : '{' THIS  '(' opt_argl ')' ';' opt_blockstmt '}' {
      						}
                      | '{' SUPER '(' opt_argl ')' ';' opt_blockstmt '}' {
							}
                      | '{' opt_blockstmt '}' {
 							}
                      ;
*/

/*** Chapter 19.9 * 2/11/97 **/

interfacedecl
    : interface_header '{' interfacememberdecls '}' {
         PTR_BFND p;
         p = makeEnd (fi);
         endlineNum();
         delete_beyond_scope_level(pred_bfnd);

          $$ = makeMain_l($1,$3,BFNULL,BFNULL,p);
          $1->entry.interface.interface_end=p;
         containsNum_g--;
        }
    |  interface_header  '{'  '}'  {
          $$ = BFNULL;
         containsNum_g--;
          }
    ;

interface_header         
    : opt_mod INTERFACE IDENTIFIER opt_extends{
         PTR_SYMB s;
         s =  makeSymbUnithead(fi,INTERFACE_NAME,$3);
         $$ = makeClassInterface(fi,s,INTERFACE_STMT);
         $$ -> entry.Template.ll_ptr1=$1;
         $$ -> entry.Template.ll_ptr2=$4;
         add_scope_level($$,NON); 
          outer_scope=1;
         containsNum_g++;
         }
    ;

opt_extends           
    : extendsinterfaces
    |  { $$ = LLNULL; }
    ;

extendsinterfaces     
    : EXTENDS interfacetype {
         $$ = set_ll_list($2,LLNULL,EXPR_LIST);
         }
    | extendsinterfaces ',' interfacetype  {
         $$ = set_ll_list($1,$3,EXPR_LIST); 
         }
    ;

interfacememberdecls  
    : interfacememberdecl {
          $$ = setBfndList(BFNULL,$1);
          }
    | interfacememberdecls interfacememberdecl   {
          $$ = setBfndList($1,$2);
          }
    ;

interfacememberdecl   
    : constantdecl
    | abstractmethoddecl
 /*   | error err_sep { } */
    ;

constantdecl          
    : fielddecl
    ;

abstractmethoddecl    
    : methodheader ';' {
         $$ = $1;
         }
    ;


/*** Chapter 19.10 ***/

arrayinitializer      
    : '{'  '}' {
          $$ = makeLlnd(fi,INIT_LIST,LLNULL,LLNULL,SMNULL);
          }
    | '{' ','  '}' {
          $$ = makeLlnd(fi,INIT_LIST,LLNULL,LLNULL,SMNULL);
          }
    | '{' variableinitializers     '}' {
          $$ = makeLlnd(fi,INIT_LIST,$2,LLNULL,SMNULL);
			}
    | '{' variableinitializers ',' '}' {
          $$ = makeLlnd(fi,INIT_LIST,$2,LLNULL,SMNULL); 
			}
    ;

variableinitializers  
    : variableinitializer {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    | variableinitializers ',' variableinitializer {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;

/*** Chapter 19.11 ***/


     /* *****************************
        *** Blocks and Statements ***
        ***************************** */

block                 
    : blockbegin opt_blockstmt '}' {
       if($1==BFNULL) $$ = $2;
       else {
          PTR_BFND end;
          end = makeEnd(fi);
          setBfndList($2,end);
          }
       delete_beyond_scope_level(pred_bfnd);
       containsNum_g--;
       } 
    ;

blockbegin 
    : '{' {
        if((last_bfnd->variant!=IF_NODE)
           &&(!((pred_bfnd->entry.Template.bl_ptr2!=NULL)&&(pred_bfnd->entry.Template.bl_ptr2->ref==NULL))) /*
ELSE */
           &&(last_bfnd->variant!=FOR_NODE)
           &&(last_bfnd->variant!=WHILE_NODE)
           &&(last_bfnd->variant!=DO_WHILE_NODE)
           &&(last_bfnd->variant!=SWITCH_NODE)
           &&(last_bfnd->variant!=TRY_STAT)
           &&(last_bfnd->variant!=FINAL_STAT)
           &&(last_bfnd->variant!=CATCH_STAT)
           &&(last_bfnd->variant!=SYNCHRONIZE_STAT)
           &&(last_bfnd->variant!=STATIC_STAT)
           &&(last_bfnd->variant!=BASIC_BLOCK))
         { 
          PTR_SYMB symb_ptr;
          $$ = makeBfnd(fi,BASIC_BLOCK);
          symb_ptr = makeSymbUnithead(fi,BLOCK_NAME,"BASIC_BLOCK_NAME");
          $$->entry.prog_stmt.prog_symb=symb_ptr;
          makeSonBlob($$,1);
          add_scope_level($$,NON);
          if(debugFlag_g==1) printf("Here { block\n");
          }
        else 
         {
          PTR_BFND scope_bfnd;
          $$ = BFNULL;

          if((pred_bfnd->entry.Template.bl_ptr2!=NULL)&&(pred_bfnd->entry.Template.bl_ptr2->ref==NULL))
             scope_bfnd=pred_bfnd;
          else
             scope_bfnd=last_bfnd;
          if(scope_bfnd->entry.Template.symbol==SMNULL)
           { PTR_SYMB symb_ptr;
             symb_ptr = makeSymbUnithead(fi,BLOCK_NAME,"BASIC_BLOCK_NAME");
             scope_bfnd->entry.prog_stmt.prog_symb=symb_ptr;
             }
          add_scope_level(scope_bfnd,NON);
          }
        containsNum_g++;
       }
    ;

opt_blockstmt         
    : blockstmts
    | { $$ = BFNULL;
		}
    ;

blockstmts            
    : blockstmt {
          $$ = lnkStmts(NULL,NULL,$1,NULL);
          }
    | blockstmts blockstmt  {
          $$ = lnkStmts($1,NULL,$2,NULL);
          } 
    ;

blockstmt             
    : localvariablestmt
    | stmt
    ;

localvariablestmt     
   : localvariabledecl ';'  {
        $$ = makeTypedecl(fi,$1->entry.Template.ll_ptr2,$1->entry.Template.ll_ptr1,LLNULL);
        vartype=TYNULL;    /* add by zheng.gb  1995.5.5 */
        type_options = 0;
        }
   ;

localvariabledecl     
   : type variabledeclarators    {
        $$ = makeLlnd(fi,LOCAL_DECL_OP,$1,$2,SMNULL); 
        }
   ;

stmt                  : stmtwithouttrailingsubstmt
                      | labeledstmt
                      | ifthenstmt
                      | ifthenelsestmt 
                      | whilestmt
                      | forstmt
                      ;

stmtnoshortif         : stmtwithouttrailingsubstmt
                      | labeledstmtnoshortif
                      | ifthenelsestmtnoshortif
                      | whilestmtnoshortif
                      | forstmtnoshortif
                      ;

stmtwithouttrailingsubstmt : block                        
                           | emptystmt
                           | expstmt
                           | switchstmt
                           | dostmt
                           | breakstmt
                           | continuestmt
                           | returnstmt
                           | synchronizedstmt
                           | throwstmt
                           | trystmt
                           ;

emptystmt                  
   : ';' {
        $$ = makeBfnd(fi,EMPTY_STMT);
        }
   ;

labeledstmt                
   : IDENTIFIER ':' stmt {
        PTR_LABEL lab;
        PTR_SYMB s;
        s = makeSymbVar(fi,cur_scope(),INPUT,$1,1);
        s->variant=LABEL_NAME;
        lab = make_label(fi,$3->id);
        cur_label=lab;
        lab->label_name=s;
        lab->statbody=$3;
        $3->entry.Template.lbl_ptr = lab;  
        $3->label=lab;
        $$ = $3;
        }            
   ;

labeledstmtnoshortif       
   : IDENTIFIER ':' stmtnoshortif {
        PTR_LABEL lab;
        PTR_SYMB s;
        s = makeSymbVar(fi,cur_scope(),INPUT,$1,1);
        s->variant=LABEL_NAME;
        lab = make_label(fi,$3->id);
        cur_label=lab;
        lab->label_name=s;
        lab->statbody=$3;
        $3->entry.Template.lbl_ptr = lab; 
        $3->label=lab;
        $$ = $3;
        }   
   ;

expstmt                    
   : stmtexp ';'      {
        $$ = makeBfnd(fi,EXPR_STMT_NODE);
        $$ -> entry.Template.ll_ptr1 = $1;
        }
   ;

stmtexp                    
   : assignment
   | preincrementexp
   | predecrementexp
   | postincrementexp
   | postdecrementexp
   | methodinvocation
   | classinst_exp
   ;

/*
ifthenstmt                 
   : IF '(' exp ')' stmt   {
       }
   ;
*/

ifthenstmt
   : ifstmt stmt {
          PTR_BFND p;

          if($1->entry.Template.bl_ptr1->ref->id!=$2->id) 
            $$ = lnkStmts($1,NULL,$2,NULL);

          p = makeEnd(fi);
          setBfndList(cur_blob->ref,p);
          pred_bfnd = $1;
          /* if($4)
          cur_blob = follow_blob(pred_bfnd->entry.Template.bl_ptr2);
          p = makeBfnd(fi,CONTROL_END);
          setBlob(p,pred_bfnd); */
          pred_bfnd = pred_bfnd->control_parent;
          cur_blob = findBlob($1);
          $$ = $1;
      }
   ;

ifthenelsestmtbegin
   : ifstmt stmtnoshortif 
      {     if($1->entry.Template.bl_ptr1->ref->id!=$2->id)
            $$ = lnkStmts($1,NULL,$2,NULL);
           }
   ;

ifthenelsestmt
   : ifthenelsestmtbegin elsestmt stmt  {
          /* Now cur_blob is pointing to the last
          statement in the most inner if-structure*/
          PTR_BFND p;

          if($1->entry.Template.bl_ptr2->ref->id!=$3->id)
            $$ = lnkStmts(NULL,NULL,$3,NULL);

          p = makeEnd(fi);
          setBfndList(cur_blob->ref,p);

          pred_bfnd = $1;
          /*cur_blob = follow_blob(pred_bfnd->entry.Template.bl_ptr2);
          p = makeBfnd(fi,CONTROL_END);
          setBlob(p,pred_bfnd); */
          pred_bfnd = pred_bfnd->control_parent;
          cur_blob = findBlob($1);
          $$ = $1;
       }
   ;

ifthenelsestmtnoshortif
   : ifthenelsestmtbegin elsestmt  stmtnoshortif  {
          /* Now cur_blob is pointing to the last
          statement in the most inner if-structure*/
          PTR_BFND p;

          if($1->entry.Template.bl_ptr1->ref->id!=$3->id)
            $$ = lnkStmts(NULL,NULL,$3,NULL);

          p = makeEnd(fi);
          setBfndList(cur_blob->ref,p);

          pred_bfnd = $1;
          /*cur_blob = follow_blob(pred_bfnd->entry.Template.bl_ptr2);
          p = makeBfnd(fi,CONTROL_END);
          setBlob(p,pred_bfnd); */
          pred_bfnd = pred_bfnd->control_parent;
          cur_blob = findBlob($1);
          $$ = $1;
       }
   ;

/*
ifthenelsestmt             
   : IF '(' exp ')' stmtnoshortif ELSE stmt  {
       }
   ; 

ifthenelsestmtnoshortif    
   : IF '(' exp ')' stmtnoshortif ELSE stmtnoshortif  {
       }
   ;
*/

ifstmt
   :  IF '(' exp ')' {
          lastBranchEnd = cur_blob;
          $$ = makeBfnd(fi,IF_NODE);
          $$ = makeIfBfnd($$,SMNULL,$3);
          /* setBfndList(cur_blob->ref,$$); */
          makeSonBlob($$,1);
          }
   ;

elsestmt 
   : ELSE {
          PTR_BFND p;
          p = makeEnd(fi);
          --(p->g_line); --(p->l_line);
          setBfndList(cur_blob->ref,p);
          makeSonBlob(cur_blob->ref,0);
        }
   ;


/*
switchstmt            
   : SWITCH '(' exp ')' switchblock         {
          }
   ;
*/

/*
switchstmt
   : switchbegin switchblock {
         PTR_BFND p;
         p = makeEnd(fi);
         setBfndList($2,p);
          }
   ;
*/

switchstmt
   : switchbegin '{' switchblock '}' {
         PTR_BFND p;
         p = makeEnd(fi);
         setBfndList($3,p);
          }
   ;

switchbegin
   : SWITCH '(' exp ')' {
          $$ = makeBfnd(fi,SWITCH_NODE);
          $$ = makeSeleBfnd($$,SMNULL,$3);
          makeSonBlob($$,1);
          }
   ;

/*
switchblock           
   : '{' '}'  {
          $$ = BFNULL;
          }
   | '{' switchblockstmtgroups '}'  {
          $$ = $2;
          }
   | '{' SWITCHLABELS '}' {
          $$ = $2;
          }
   | '{' switchblockstmtgroups switchlabels '}' {
          $$ = $2;
          }
   ;
*/

switchblock
   : {
       $$ = BFNULL;
          }
   | switchblock switchlabel blockstmts {
        PTR_BFND p;
          p = makeEnd(fi);
          /* --(p->g_line); --(p->l_line); */
          setBfndList($3,p);
          }
   | switchblock switchlabel {
        PTR_BFND p;
          p = makeEnd(fi);
          /* --(p->g_line); --(p->l_line); */
          setBfndList($2,p);
          }
   ;

/*
switchblockstmtgroups 
   : switchblockstmtgroup 
   | switchblockstmtgroups switchblockstmtgroup 
   ;

switchblockstmtgroup  
   : switchlabels blockstmts {
         PTR_BFND p;
          p = makeEnd(fi);
          setBfndList($2,p);
          } 
   ;

switchlabels          
   : switchlabel 
   | switchlabels switchlabel   
   ;
*/

switchlabel           
   : CASE    exp ':'  {
          $$ = makeBfnd(fi,CASE_NODE);
          $$ = makeCaseBfnd($$,SMNULL,$2,BFNULL);
          makeSonBlob($$,1);
          }
   | DEFAULT_     ':'    {
          PTR_LLND l;
          $$ = makeBfnd(fi,DEFAULT_NODE);
          makeSonBlob($$,1);
          } 
   ;

/*
whilestmt             
   : WHILE '(' exp ')' stmt  {
 }
   ;

whilestmtnoshortif    
   : WHILE '(' exp ')' stmtnoshortif  {
 }
   ; 
*/

whilestmt
   : whilestmtbegin stmt {
          PTR_BFND endFor;
          if($1->entry.Template.bl_ptr1->ref->id!=$2->id)
            $$ = lnkStmts($1,NULL,$2,NULL);

          endFor = makeEnd(fi);
          setBfndList($2,endFor);
        }
   ;

whilestmtnoshortif
   : whilestmtbegin stmtnoshortif {
          PTR_BFND endFor;
          if($1->entry.Template.bl_ptr1->ref->id!=$2->id)
            $$ = lnkStmts($1,NULL,$2,NULL);

          endFor = makeEnd(fi);
          setBfndList($2,endFor);
        }
   ;

whilestmtbegin
   : WHILE '(' exp ')' {
          $$ = makeBfnd(fi,WHILE_NODE);
          $$ = makeForallBfnd($$,$3,LLNULL);
          makeSonBlob($$,1);
        }
   ;

/*
dostmt                
   : DO stmt WHILE '(' exp ')' ';'  {
 }
   ; 
*/

dostmt
   : dostmtbegin stmt WHILE '(' exp ')' ';'  {
          PTR_BFND endFor;
          if($1->entry.Template.bl_ptr1->ref->id!=$2->id)
            $$ = lnkStmts($1,NULL,$2,NULL);

          endFor = makeEnd(fi);
          setBfndList($2,endFor);
          $1->entry.Template.ll_ptr1=$5;
         }
   ;

dostmtbegin
   : DO {
          $$ = makeBfnd(fi,DO_WHILE_NODE);
          makeSonBlob($$,1);
       }
   ;
 
forstmt
   : forstmtbegin stmt {
          PTR_BFND endFor;
          if((($1->entry).Template.bl_ptr1)->ref->id!=$2->id) {
            $$ = lnkStmts($1,NULL,$2,NULL);
            }
          endFor = makeEnd(fi);
          setBfndList($2,endFor);
          }
   ;
/*
forstmt               
   : FOR '('  opt_forinit ';' opt_exp ';' opt_forupdate ')' stmt {
 }
   ;
*/
 
forstmtbegin 
   :  FOR '('  opt_forinit ';' opt_exp ';' opt_forupdate ')' {
        /*
          PTR_LLND range,ddot;
          range = makeLlnd(fi,RANGE_OP,$3,$5,SMNULL);
          ddot = makeLlnd(fi,DDOT,range,$7,SMNULL);

          $$ = makeBfnd(fi,FOR_NODE);
          $$ = makeForallBfnd($$,ddot,ddot->entry.Template.ll_ptr2);
         */
          $$ = makeBfnd(fi,FOR_NODE);
		  $$->entry.Template.ll_ptr1=$3;
          $$->entry.Template.ll_ptr2=$5;
          $$->entry.Template.ll_ptr3=$7;
          makeSonBlob($$,1);
          }
   ;

/*
forstmtnoshortif      
   : FOR '('  opt_forinit ';' opt_exp ';' opt_forupdate ')' stmtnoshortif {
 }
   ;
*/

forstmtnoshortif
   : forstmtbegin stmtnoshortif {
          PTR_BFND endFor;
          if((($1->entry).Template.bl_ptr1)->ref->id!=$2->id) {
            $$ = lnkStmts($1,NULL,$2,NULL);
			}
          endFor = makeEnd(fi);
          setBfndList($2,endFor);
          }
   ;

opt_forinit           
   : stmtexplist       
   | localvariabledecl  
   |  { 
       $$ = LLNULL;
          } 
   ;

opt_forupdate         
   : stmtexplist
   |  {
        $$ = LLNULL;
        }	
   ;

stmtexplist           
   : stmtexp   {
        $$ = set_ll_list($1,LLNULL,EXPR_LIST);
        }
   | stmtexplist ',' stmtexp {
         $$ = set_ll_list($1,$3,EXPR_LIST);
          } 
   ;

breakstmt             
   : BREAK IDENTIFIER ';'   {
          PTR_SYMB s;
          PTR_LLND l;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$2,0);
          l = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          $$ = makeBfnd(fi,BREAK_NODE);
          $$->entry.return_stmt.expr = l;
          }
   | BREAK     ';'   {
          $$ = makeBfnd(fi,BREAK_NODE);
          }
   ;

continuestmt          
   : CONTINUE IDENTIFIER ';'  {
          PTR_SYMB s;
          PTR_LLND l;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$2,0);
          l = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          $$ = makeBfnd(fi,CONTINUE_NODE);
          $$->entry.return_stmt.expr = l;
          }
   | CONTINUE     ';'  {
          $$ = makeBfnd(fi,CONTINUE_NODE);
          }
   ;

returnstmt            
   : RETURN opt_exp ';'  {
          $$ = makeBfnd(fi,RETURN_STAT);
          $$->entry.return_stmt.expr = $2;
          }
   ;

throwstmt             
   : THROW exp ';'    {
          $$ = makeBfnd(fi,THROW_STMT);
          $$->entry.return_stmt.expr = $2;
          }
   ;

synchronizedstmt
   :  synchronizeheader act_block
   ;

synchronizeheader      
   : SYNCHRONIZED '(' exp ')' {
          $$ = makeBfnd(fi,SYNCHRONIZE_STAT);
          $$ -> entry.Template.ll_ptr1 = $3;
          makeSonBlob($$,1);
       }
   ;

trystmt               
   : tryheader act_block catches 
   | tryheader act_block catches finally_block 
   | tryheader act_block finally_block 
   ;

tryheader
   : TRY {
          $$ = makeBfnd(fi,TRY_STAT);
          makeSonBlob($$,1);
       }
   ;

finally_block         
   :  finallyheader act_block    
   ;

finallyheader
   : FINALLY {
          $$ = makeBfnd(fi,FINAL_STAT);
          makeSonBlob($$,1);
       }
   ;

catches               
   : catchclause
   | catches catchclause   
   ;

catchclause           
   : catchheader act_block  
   ;

catchheader
   : CATCH '(' formalparameter ')' {
         $$ = makeBfnd(fi,CATCH_STAT);
         $$->entry.Template.ll_ptr1=$3;
         makeSonBlob($$,1);
       }
   ;


     /* Grammar Extension to allow frequently used construct */

act_block            
   : block {
          PTR_BFND endFor;
          endFor = makeEnd(fi);
          setBfndList($1,endFor);
          }
   | alt_stmt {
          PTR_BFND endFor;
          lnkStmts(NULL,NULL,$1,NULL);
          endFor = makeEnd(fi);
          setBfndList($1,endFor);
          }
   ;

alt_stmt              
   : emptystmt
   | expstmt
   ;


/*** Chapte 19.12 * 2/7/97 **/

primary             
    :  primarynonewarray
    |  arrayinst_exp
    ;

primarynonewarray   
    : literal
    | THIS {
         $$ = makeLlnd(fi,THIS_NODE,LLNULL,LLNULL,SMNULL);
         }
    | '(' exp ')'  { 
         $$ = $2; 
         }
    | classinst_exp
    | fieldaccess
    | methodinvocation
    | arrayaccess
    ;

classinst_exp  
    : NEW classtype '(' opt_argl ')'  {
         PTR_LLND l;
         PTR_SYMB s;
         if($2->variant==VAR_REF)
         { s = $2->entry.Template.symbol;
           l = makeLlnd(fi,FUNC_CALL,$4, LLNULL,s);
           }
         else {
           s=$2->entry.Template.ll_ptr2->entry.Template.symbol;
           $2->entry.Template.ll_ptr2 = makeLlnd(fi,FUNC_CALL,$4, LLNULL,s);
           l = $2;
           }
         $$ = makeLlnd(fi,NEW_OP,l,LLNULL,SMNULL);
         } 
    ;

opt_argl 
    : argumentlist
    | {
        $$ = LLNULL;
        }
    ;

argumentlist   
    : exp {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          } 
    | argumentlist ',' exp {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          } 
    ;

arrayinst_exp  
    : NEW primitivetype dim_part   {
         PTR_LLND l;
         l = makeLlnd(fi,ARRAY_TYPE,$2,$3,SMNULL);
         $$ = makeLlnd(fi,NEW_OP,l,LLNULL,SMNULL);
         }
    | NEW c_i_type      dim_part  {
         PTR_LLND l;
         l = makeLlnd(fi,ARRAY_TYPE,$2,$3,SMNULL);
         $$ = makeLlnd(fi,NEW_OP,l,LLNULL,SMNULL);
         } 
    ;

dim_part       
    : dimexps  
    | dimexps dims {
          $$ = makeLlnd(fi,DIM_LIST,$1,$2,SMNULL);
          }
    ;

dimexps        
    : dimexp {
         $$ = makeLlnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);
          } 
    | dimexps dimexp {
          $$ = set_ll_list($1,$2,EXPR_LIST);
          } 
    ; 

dimexp 
    :  '[' exp ']' {
         $$ = makeLlnd(fi, DIMENSION_OP, $2, LLNULL, SMNULL);
          }
    ;

dims
   :  dim {
          $$ = makeLlnd(fi,EXPR_LIST, $1, LLNULL, SMNULL);
          }
   |  dims dim {
         $$ = set_ll_list($1, $2, EXPR_LIST);
          }
   ;

dim
   : '[' ']' {
        $$ = makeLlnd(fi, DIMENSION_OP, LLNULL, LLNULL, SMNULL);
          }
   ;


fieldaccess    
   : primary  '.' IDENTIFIER {
          PTR_SYMB s;
          PTR_LLND l;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$3,0);
          l = makeLlnd(fi,VAR_REF,LLNULL, LLNULL,s);
          $$ = makeLlnd(fi,RECORD_REF,$1,l,SMNULL);  
        } 
   | SUPER   '.' IDENTIFIER  {
          PTR_SYMB s;
          PTR_LLND l,m;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$3,0);
          l = makeLlnd(fi,VAR_REF,LLNULL, LLNULL,s);
          m = makeLlnd(fi,SUPER_OP, LLNULL, LLNULL, SMNULL);
          $$ = makeLlnd(fi,RECORD_REF,m,l,SMNULL);
        }
   ;

methodinvocation 
   : name '(' opt_argl ')'  {
         PTR_SYMB s;
         if($1->variant==VAR_REF)
         { s = $1->entry.Template.symbol;
           $$ = makeLlnd(fi,FUNC_CALL,$3, LLNULL,s);
           }
         else {
         s=$1->entry.Template.ll_ptr2->entry.Template.symbol;
         if(debugFlag_g==1) printf("s: %s\n",s->ident);
         $1->entry.Template.ll_ptr2 = makeLlnd(fi,FUNC_CALL,$3, LLNULL,s);
         $$ = $1;
         }
        }
   | primary '.' IDENTIFIER '(' opt_argl ')'  {
          PTR_SYMB s;
          PTR_LLND l;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$3,0);
          l = makeLlnd(fi,FUNC_CALL,$5,LLNULL,s);
          $$ = makeLlnd(fi,RECORD_REF,$1,l,SMNULL);
        }
   | SUPER   '.' IDENTIFIER '(' opt_argl ')'  {
          PTR_SYMB s;
          PTR_LLND l,m;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$3,0);
          l = makeLlnd(fi,FUNC_CALL,$5, LLNULL,s);
          m = makeLlnd(fi,SUPER_OP, LLNULL, LLNULL, SMNULL);
          $$ = makeLlnd(fi,RECORD_REF,m,l,SMNULL);
        }
   ;

arrayaccess 
   : name  '[' exp ']'   {
        $$ = makeLlnd(fi,JAVA_ARRAY_REF,$1,$3,SMNULL);
        }
   | primarynonewarray '[' exp ']' {
        $$ = makeLlnd(fi,JAVA_ARRAY_REF,$1,$3,SMNULL); 
        } 
   ;

postfixexp          
   : primary
   | name  
   | postincrementexp
   | postdecrementexp
   ;

postincrementexp    
   : postfixexp PP_  {
        $$ = makeLlnd(fi,PLUSPLUS_OP,LLNULL,$1,SMNULL);
        } 
   ;

postdecrementexp    
   : postfixexp MM_  {
        $$ = makeLlnd(fi,MINUSMINUS_OP,LLNULL,$1,SMNULL);
        } 
   ;

unaryexp            
   : preincrementexp
   | predecrementexp
   | '+' unaryexp  {
          $$ = makeLlnd(fi,UNARY_ADD_OP,$2,LLNULL,SMNULL);
          }
   | '-' unaryexp {
          $$ = makeLlnd(fi,MINUS_OP,$2,LLNULL,SMNULL);
          }
   | unaryexpnotplusminus
   ;

preincrementexp     
   : PP_ unaryexp {
        $$ = makeLlnd(fi,PLUSPLUS_OP,$2,LLNULL,SMNULL);
        }
   ; 

predecrementexp     
   : MM_ unaryexp {
        $$ = makeLlnd(fi,MINUSMINUS_OP,$2,LLNULL,SMNULL);
        }
   ; 

unaryexpnotplusminus 
   : postfixexp
   | '~' unaryexp {        
        $$ = makeLlnd(fi,BITNOT_OP,LLNULL,$2,SMNULL);
        }
   | '!' unaryexp {        
        $$ = makeLlnd(fi,NOT_OP,LLNULL,$2,SMNULL);
        }
   | castexp
   ;

castexp              
   : '(' primitivetype ')'  unaryexp {        
        $$ = makeLlnd(fi,CAST_OP,$4,$2,SMNULL);
        }
   | '(' primitivetype dims ')'  unaryexp {        
          PTR_LLND l2;
          PTR_TYPE t;
          type_options = type_options | DIMENSION_BIT;
/*          l1 = makeLlnd(fi,DIMENSION_OP,$3,LLNULL,SMNULL); */
          t= makeTypeArray($3,vartype);
          vartype=t;
          l2 = makeLlnd(fi,ARRAY_TYPE,$2,$3,SMNULL);
         $$ = makeLlnd(fi,CAST_OP,$5,l2,SMNULL);
        }
   | '(' exp ')' unaryexpnotplusminus {        
        $$ = makeLlnd(fi,CAST_OP,$4,$2,SMNULL);
        }
   | '(' name dims ')'  unaryexpnotplusminus {        
          PTR_LLND l1,l2;
          PTR_TYPE t;
          type_options = type_options | DIMENSION_BIT;
/*          l1 = makeLlnd(fi,DIMENSION_OP,$3,LLNULL,SMNULL); */
          t= makeTypeArray($3,vartype); 
          vartype=t;
          l2 = makeLlnd(fi,ARRAY_TYPE,$2,$3,SMNULL);
         $$ = makeLlnd(fi,CAST_OP,$5,l2,SMNULL);
        }
   ;

multiplicativeexp    
    : unaryexp
    | multiplicativeexp '*' unaryexp   {
          $$ =  makeLlnd(fi,MULT_OP,$1,$3,SMNULL);
          }
    | multiplicativeexp '/' unaryexp   {
          $$ =  makeLlnd(fi,DIV_OP,$1,$3,SMNULL);
          }
    | multiplicativeexp '%' unaryexp   {
          $$ =  makeLlnd(fi,MOD_OP,$1,$3,SMNULL);
          }
    ;

additiveexp         
    : multiplicativeexp
    | additiveexp '+' multiplicativeexp   {
          $$ = makeLlnd(fi,ADD_OP,$1,$3,SMNULL);
          }
    | additiveexp '-' multiplicativeexp   {
          $$ = makeLlnd(fi,SUBT_OP,$1,$3,SMNULL);
          }
    ;

shiftexp            
    : additiveexp
    | shiftexp LL_  additiveexp    {
          $$ =  makeLlnd(fi,LSHIFT_OP,$1,$3,SMNULL);
          }
    | shiftexp RR_  additiveexp    {
          $$ =  makeLlnd(fi,RSHIFT_OP,$1,$3,SMNULL);
          }
    | shiftexp RRR_ additiveexp  {
          $$ =  makeLlnd(fi,RRSHIFT_OP,$1,$3,SMNULL);
          }  
    ;

relationalexp       
    : shiftexp
    | relationalexp '<'    shiftexp        {
          $$ = makeLlnd(fi,LT_OP,$1,$3,SMNULL);
          }
    | relationalexp '>'    shiftexp        {
          $$ =  makeLlnd(fi,GT_OP,$1,$3,SMNULL);
          }
    | relationalexp LE_     shiftexp       {
          $$ =  makeLlnd(fi,LTEQL_OP,$1,$3,SMNULL);
          }
    | relationalexp GE_     shiftexp {
          $$ =  makeLlnd(fi,GTEQL_OP,$1,$3,SMNULL);
          }       
    | relationalexp INSTANCEOF referencetype  {
          $$ =  makeLlnd(fi,INSTANCEOF_OP,$1,$3,SMNULL);
          }
    ;

equalityexp         
    : relationalexp
    | equalityexp EQ_ relationalexp  {
          $$ =  makeLlnd(fi,EQ_OP,$1,$3,SMNULL);
          }
    | equalityexp NE_ relationalexp  {
          $$ =  makeLlnd(fi,NOTEQL_OP,$1,$3,SMNULL);
          }
    ;

andexp              
    : equalityexp
    | andexp '&' equalityexp        {
          $$ =  makeLlnd(fi,BITAND_OP,$1,$3,SMNULL);
          }
    ;

exclusiveorexp      
   : andexp
   | exclusiveorexp '^' andexp     {
          $$ =  makeLlnd(fi,XOR_OP,$1,$3,SMNULL);
          }
   ;

inclusiveorexp      
   : exclusiveorexp
   | inclusiveorexp '|' exclusiveorexp { 
         $$ =  makeLlnd(fi,BITOR_OP,$1,$3,SMNULL);
         }
   ;

conditionalandexp   
   : inclusiveorexp
   | conditionalandexp AND_ inclusiveorexp   {
          $$ =  makeLlnd(fi,AND_OP,$1,$3,SMNULL);
          }
   ;

conditionalorexp    
   : conditionalandexp
   | conditionalorexp  OR_ conditionalandexp  {
          $$ =  makeLlnd(fi,OR_OP,$1,$3,SMNULL);
          }
   ;

conditionalexp      
   : conditionalorexp
   | conditionalorexp '?' exp ':' conditionalexp {
          PTR_LLND l;
          l = makeLlnd(fi,CONDITIONEXP_COLON_OP,$3,$5,SMNULL);
          $$ =  makeLlnd(fi,CONDITIONEXP_OP,$1,l,SMNULL);
          }
   ;

assignmentexp       
   : conditionalexp
   | assignment
   ;

assignment          
   : lefthandside assignop assignmentexp  {
         $$ = makeLlnd(fi,$2,$1,$3,SMNULL);
         }
   ;

assignop            
   : '='  {        
          $$ = ASSGN_OP;
          } 
   | PIS_  {
          $$ = PLUS_ASSGN_OP;
          } 
   | MINIS_ {
          $$ = MINUS_ASSGN_OP;
          } 
   | MULIS_ {
          $$ = MULT_ASSGN_OP;
          }       
   | DIS_ {
          $$ = DIV_ASSGN_OP;
          }         
   | ANDIS_ {
          $$ = BITANDIS_OP;
          }        
   | ORIS_ {
          $$ = BITORIS_OP;
          }        
   | UIS_ {
          $$ = XOR_ASSGN_OP;
          }         
   | IDIVIS_ {
          $$ = MOD_ASSGN_OP;
          }      
   | LLIS_ {
          $$ = LSHIFT_ASSGN_OP;
          }        
   | RRIS_ {
          $$ = RSHIFT_ASSGN_OP;
          }        
   | RRRIS_ {
          $$ = RRSHIFTIS_OP;
          }        
   ;

lefthandside        
    : name 
    | fieldaccess            
    | arrayaccess            
    ;

opt_exp             
    : exp
    |  {        
        $$ = LLNULL; 
         } 
    ;

exp                 
    : assignmentexp
    ;


/*** Chapter 19.3 * 2/7/97 **/

literal
   :  INT_DEC_LITERAL {
          $$ = makeLlnd(fi,INT_VAL,LLNULL,LLNULL,SMNULL);
          $$->entry.ival = atoi(yytext);
          $$->type = global_int;
          }
   |  INT_HEX_LITERAL {
          if(debugFlag_g==1) printf("%s\n",yytext);
          $$ = makeLlnd(fi,HEX_VAL,LLNULL,LLNULL,SMNULL);
          $$->entry.string_val = copys(yytext);
          $$->type = global_int;
          }
   |  INT_OCT_LITERAL {
          $$ = makeLlnd(fi,OCTN_VAL, LLNULL, LLNULL, SMNULL);
          $$->entry.string_val = copys(yytext);
          $$->type = global_int;
          }     
   |  REAL_LITERAL {
          $$ = makeLlnd(fi,FLOAT_VAL,LLNULL,LLNULL,SMNULL);
          $$->entry.string_val = copys(yytext);
          $$->type = global_float;
          } 
   |  DOUBLE_LITERAL {
          $$ = makeLlnd(fi,DOUBLE_VAL, LLNULL, LLNULL, SMNULL);
          $$->entry.string_val = copys(yytext);
          $$->type = global_double;
          }
   |  STRING_LITERAL {
          if(debugFlag_g==1) printf("STRING %s\n",$1);
          $$ = makeLlnd(fi,STRING_VAL, LLNULL, LLNULL, SMNULL);
          $$->entry.string_val = $1; /* Modified by Zheng Qiang */
          $$->type = global_string;
          }
   |  CHAR_LITERAL {
          if(debugFlag_g==1) printf("CHAR %s\n",$1);
          $$ = makeLlnd(fi,CHAR_VAL, LLNULL, LLNULL, SMNULL);
/*          $$->entry.string_val = $1;  Modified by Zheng Qiang */
          $$->entry.cval=$1[0];
          $$->type = global_string;
          }
   |  BOOL_TRUE_LITERAL {
         $$ = makeLlnd(fi,BOOL_VAL, LLNULL, LLNULL, SMNULL);
         $$->entry.bval = 1;
         $$->type = global_bool;
         }
   |  BOOL_FALSE_LITERAL {
         $$ = makeLlnd(fi,BOOL_VAL, LLNULL, LLNULL, SMNULL);
         $$->entry.bval = 0;
         $$->type = global_bool;
         }
   |  NULL_LITERAL {
         $$ = makeLlnd(fi,NULL_VAL, LLNULL, LLNULL, SMNULL);
         }
   ;

/*** Chapter 19.4 * 2/7/97 **/

type             
   :  primitivetype
   |  referencetype
   ;

primitivetype    
   :  numerictype
   |  BOOLEAN {
         $$ = makeTypespec_ll(fi,global_bool,LLNULL);
          }
   ; 

numerictype      
   :  integraltype
   |  fptype
   ;

integraltype     
   :  BYTE {
         $$ = makeTypespec_ll(fi,global_byte,LLNULL);
          }
   |  SHORT {
         $$ = makeTypespec_ll(fi,global_short,LLNULL);
          }
   |  INT {
          $$ = makeTypespec_ll(fi,global_int,LLNULL);
          }
   |  LONG {
          $$ = makeTypespec_ll(fi,global_long,LLNULL);
          }
   |  CHAR {
          $$ = makeTypespec_ll(fi,global_string,LLNULL);
          }
   ;

fptype           
   :  FLOAT {
          $$ = makeTypespec_ll(fi,global_float,LLNULL);
          }
   |  DOUBLE {
          $$ = makeTypespec_ll(fi,global_double,LLNULL);
          }
   ;

referencetype    
   : c_i_type
   | arraytype
   ;

classtype        
   : c_i_type {
/*        PTR_LLND s;
       int i=0;
        for(s=$1; (s!= LLNULL)&&(i<4);i++, s=$1->entry.Template.ll_ptr1)
         if(s->variant==VAR_REF) $1->entry.Template.symbol->variant=CLASS_NAME;
         else
         s->entry.Template.ll_ptr2->entry.Template.symbol->variant=CLASS_NAME;  
        if (i==4) printf("Dead Loop\n");
*/
       }
   ;

interfacetype    
   : c_i_type {
/*       PTR_LLND s;
        for(s=$1; s!= LLNULL; s=$1->entry.Template.ll_ptr1)
         if(s->variant==VAR_REF) $1->entry.Template.symbol->variant=INTERFACE_NAME;
         else
         s->entry.Template.ll_ptr2->entry.Template.symbol->variant=INTERFACE_NAME;
*/
       }
   ;

c_i_type         
   : name 
   ;


arraytype 
   : primitivetype dims {
/*          PTR_LLND l; */
          PTR_TYPE t;
          type_options = type_options | DIMENSION_BIT;
/*          l = makeLlnd(fi,DIMENSION_OP,$2,LLNULL,SMNULL); */
          t= makeTypeArray($2,vartype);
          vartype=t;
          $$ = makeLlnd(fi,ARRAY_TYPE,$1,$2,SMNULL); 
          } 
   | name dims {
/*          PTR_LLND l;  */
          PTR_TYPE t;
          type_options = type_options | DIMENSION_BIT;
/*          l = makeLlnd(fi,DIMENSION_OP,$2,LLNULL,SMNULL); */
          t= makeTypeArray($2,vartype);
          vartype=t;
          $$ = makeLlnd(fi,ARRAY_TYPE,$1,$2,SMNULL);
          } 
   ;
 
/*** Chapter 19.5 * 2/7/97 **/

name
    :  IDENTIFIER {
          PTR_SYMB s;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          $$ = makeLlnd(fi,VAR_REF,LLNULL, LLNULL,s);
          }
    |  qualifiedname
    ;

qualifiedname
    :  name '.' IDENTIFIER {
          PTR_SYMB s;
          PTR_LLND l;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$3,0);
          l = makeLlnd(fi,VAR_REF,LLNULL, LLNULL,s);
          $$ = makeLlnd(fi,RECORD_REF,$1,l,SMNULL);
          }
    ;

/*
err_sep             : ';'
                    | '}'
                    ;
*/

%%

yyerror(str)
char *str;
{
  char *lxyError_m();

  globeErr_g=1;
  printf("line(%d) syntax error:%d %s\n",lineNum_g,yychar,lxyError_m(yychar));
/*  errResynch();*/
}

char *
lxyError_m(a)
int a;
{
  int a1;
  int i;
  char *error_str;

  error_str=(char *) calloc(1,(unsigned)60);
  a1=a-ABSTRACT;           
  for(i=0;i<=a1;i++)
      strcpy(error_str,TOKEN_G[i]);
  return(error_str);
}

throw_away()
{
   while(yytext[0]!='\n') {
    if (yytext[0]==0)
    {
        exit(1);
    }
        yylex();
   }
   lineNum_g++;
   lineNum_l++;
}

