/*********************************************************************/
/*                 modified on  12.23 1995   for HPF                 */
/*                               PACT                                */ 
/*********************************************************************/

/*------------------------------------------------------*
 *							*
 *	This is a program that can dump BIF graph	*
 *	into human readable from:			*
 *							*
 *	Usage:						*
 *		dumpdep <dep_filename>			*
 *							*
 *------------------------------------------------------*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if defined(STDC_HEADERS) && (STDC_HEADERS==1)
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>

#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "dep.h"
#include "dep_struct.h"

int	debug,debug_m;

static void
usage()
{
	fprintf(stderr,"Usage: dumpdep [-d nnn][-m] dep_file\n");
	exit(1);
}

static void
write_line(fname)
char   *fname;
{
  FILE   *fp1,*fp2;
  char   ch;
  char   buf[1024]; 
  int    i = 1;  

  buf[0] = '\0';
  if ((fp1 = fopen (fname,"r"))==NULL)
       {
         printf("cannot  open  this  file\n");
         exit(0);
        }
  sprintf(buf,"%s.html",fname); 
  if ((fp2 = fopen (buf,"w"))==NULL)
       {
         printf("cannot  open  this  file\n");
         exit(0);
       }

  fputs("<PRE>\n",fp2);
  buf[0]='\0'; 
  sprintf(buf,"<A NAME = \"%d\"> %4d:</A>   ",i,i); 
  ch = getc(fp1);	
  while(!feof(fp1))
	{
	  sprintf(buf,"%s%c",buf,ch);
	  if(ch=='\n')
		{
		  fputs(buf,fp2);
		  buf[0] = '\0';
		  i++;
		  sprintf(buf,"<A NAME = \"%d\"> %4d:</A>   ",i,i);
		}
	  ch = getc(fp1);	
	}
  fputs("</PRE>\n",fp2);

  fclose(fp1);
  fclose(fp2);

}

int main(argc, argv, envp)
    int	  argc;
    char *argv[];
    char *envp[];
{
	FILE	 *fd;
	PTR_FILE  f;

	char     *filename;
        int       len;
 
	argv++; argc--;
	if (!argc)
		usage();
	if (**argv == '-')
		if ((*argv)[1] == 'd') {
			argv++;
			debug = atoi(*argv++);
			printf("debug = %d\n",debug);
		} else
                       {
                        if ((*argv)[1] == 'm')
                          {
                            argv++;
                            debug_m = 1;
                   /*          printf("debug_m = %d     preduce   ",debug_m); */
                          }
                        else 
	   		     usage();
              	       }
	
	if((fd=fopen(*argv, "r")) == NULL) {
		fprintf(stderr,"Cannot open file \"%s\"\n", *argv);
		exit(1);
	}
	if ((f = (PTR_FILE) calloc(1, sizeof(struct file_obj))) == NULL) {
		fprintf(stderr, "main -- No more space\n");
		exit(1);
	}
	f->fid = fd;

	if (readNodes(f) >= 0) {
		f->global_bfnd->control_parent = NULL;
                
 		if (debug_m)
                  {
		   write_line(f->filename);
		   len = strlen(f->filename)-2;
    		   if (!(filename = malloc(len*2)))
       			printf("ERROR!");
    		   strncpy(filename,f->filename,len);
 
		    /* sprintf(filename,"%s.dep.html",filename);
                   printf("%s  file\n",filename); */
		   dump_nodes(f, ""); /* zgs, we need stand out also */
 	  	  }
                else	
		     dump_nodes(f, "");
	}
	return 0;
}
