/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993                  */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

/* This file is used to automatically generate a "#include" header */
/* 
mkCextern $SAGEROOT/lib/newsrc/low_level.c > ! $SAGEROOT/lib/include/ext_low.h
mkC++extern $SAGEROOT/lib/newsrc/low_level.c > ! $SAGEROOT/lib/include/extcxx_low.h
*/

#include <stdio.h>

#ifndef NeXT
#  include <malloc.h>
#endif
 
#include <stdlib.h>
#include <stdarg.h> /* ANSI variable argument header */

#include "compatible.h"   /* Make different system compatible... (PHB) */
#ifdef SYS5
#include <string.h>
#else
#include <strings.h>
#endif

#include "vpc.h"
#include "defs.h"
#include "bif.h"
#include "ll.h"
#include "symb.h"
#include "dep.h"
#include "sets.h"
#include "db.h"
#include "vparse.h"
#include "macro.h"
#include "ext_lib.h"

#define MAX_FILE 1000 /*max number of files in a project*/
#define MAXFIELDSYMB 10
#define MAXFIELDTYPE 10
#define MAX_SYMBOL_FOR_DUPLICATE 1000
char Current_File_name[256];

int debug =NO; /* used in db.c*/

PTR_FILE pointer_on_file_proj;
static int number_of_bif_node = 0;
int number_of_ll_node = 0; /* this counters are useless anymore ??*/
static int number_of_symb_node  = 0;
static int number_of_type_node = 0;
char  *default_filename;
int Warning_count = 0;

/* FORWARD DECLARATIONS (phb) */
int buildLinearRepSign();
int makeLinearExpr_Sign();
int getLastLabelId();
int isItInSection();
int Init_Tool_Box();
int Message();
PTR_BFND rec_num_near_search();
PTR_BFND Redo_Bif_Next_Chain_Internal();
PTR_SYMB duplicateSymbol();
void Redo_Bif_Next_Chain();
PTR_LABEL getLastLabel();
PTR_BFND getNodeBefore ();
char *filter();
PTR_BFND getLastNodeList();
int *evaluateExpression();

extern int writeNodes();
extern char* Tool_Unparse2_LLnode(); 
extern void Init_Unparser();
extern char* Tool_Unparse_Bif ();
extern char* Tool_Unparse_Type();

static int CountNullBifNext = 0; /* for internal debugging */

/* records propoerties and type of node */
char node_code_type[LAST_CODE];
/* Number of argument-words in each kind of tree-node.  */
int node_code_length[LAST_CODE];
enum typenode node_code_kind[LAST_CODE];
/* special table for infos on type and symbol */
char info_type[LAST_CODE][MAXFIELDTYPE];
char info_symb[LAST_CODE][MAXFIELDSYMB];
char general_info[LAST_CODE][MAXFIELDSYMB];

static struct bif_stack_level   *stack_level = NULL;
static struct bif_stack_level *current_level = NULL;

PTR_BFND  getFunctionHeader();

/*****************************************************************************
 *                                                                           *
 *                   Procedure of general use                                *
 *                                                                           *
 *****************************************************************************/

/* Modified to return a pointer (64bit clean) (phb) */
/***************************************************************************/
char* xmalloc(size)
     int size;
{
  char *val;
  val = (char *) malloc (size);
  
  if (val == 0)
    Message("Virtual memory exhausted (malloc failed)",0);
  return val;
}

/* list of allocated data */
static ptstack_chaining Current_Allocated_Data = NULL;
static ptstack_chaining First_STACK= NULL;

/***************************************************************************/
void make_a_malloc_stack()
{
  ptstack_chaining pt;
    
  pt = (ptstack_chaining) malloc(sizeof(struct stack_chaining));
  if (!pt)
    {
      Message("sorry : out of memory\n",0);
      exit(1);
    }
  
  if (Current_Allocated_Data)
    Current_Allocated_Data->next = pt;
  pt->first = NULL;
  pt->last = NULL;
  pt->prev = Current_Allocated_Data;
  if (Current_Allocated_Data)
    pt->level = Current_Allocated_Data->level +1;
  else
    pt->level = 0;
/*  printf("make_a_malloc_stack %d \n",pt->level);*/
  Current_Allocated_Data = pt;
  if (First_STACK == NULL)
    First_STACK = pt;
}

/***************************************************************************/
void myfree()
{
  ptstack_chaining pt;
  ptchaining pt1, pt2;
  if (!Current_Allocated_Data)
     {
      Message("Stack not defined\n",0);
      exit(1);
    }

  pt2 = Current_Allocated_Data->first;

/*  printf("myfree %d \n", Current_Allocated_Data->level);*/
  while (pt2)
    {
      free(pt2->zone);
      pt2->zone = 0;
      pt2 = pt2->list;
    }

  pt2 = Current_Allocated_Data->first;
  while (pt2)
    {
      pt1 = pt2;
      pt2 = pt2->list;
      free(pt1);
    } 
  pt = Current_Allocated_Data;
  Current_Allocated_Data = pt->prev;
  Current_Allocated_Data->next = NULL;
  free(pt);
}


/***************************************************************************/
char* mymalloc(size)
int size;
{
  char *pt1;
  ptchaining pt2;
  if (!Current_Allocated_Data)
    {
      Message("Allocated Stack not defined\n",0);
      exit(1);
    }

/*  if (Current_Allocated_Data->level > 0)
    printf("mymalloc  %d \n", Current_Allocated_Data->level); */
  pt1 = (char *) malloc(size);
  if (!pt1)
    {
      Message("sorry : out of memory\n",0);
      exit(1);
    }
 
  pt2 = (ptchaining) malloc(sizeof(struct chaining));
  if (!pt2 )
    {
      Message("sorry : out of memory\n",0);
      exit(1);
    }
  
  pt2->zone = pt1;
  pt2->list = NULL;

  if (Current_Allocated_Data->first == NULL)
    Current_Allocated_Data->first = pt2;
  
  if (Current_Allocated_Data->last == NULL)
    Current_Allocated_Data->last = pt2;
  else
    {
      Current_Allocated_Data->last->list = pt2;
      Current_Allocated_Data->last = pt2;
    }
  return pt1;
}

/***************** Provides infos on nodes ********************************
 *                                                                        *
 *     based on the table info in include dir *.def                       *
 *                                                                        *
 **************************************************************************/

/***************************************************************************/
int isATypeNode(variant)
int variant;
{
  return (TYPENODE == (int) node_code_kind[variant]);
}

/***************************************************************************/
int isASymbNode(variant)
int variant;
{
  return (SYMBNODE == (int) node_code_kind[variant]);
}

/***************************************************************************/
int isABifNode(variant)
int variant;
{
  return (BIFNODE == (int) node_code_kind[variant]);
}

/***************************************************************************/
int isALoNode(variant)
int variant;
{
  return (LLNODE == (int) node_code_kind[variant]);
}

/***************************************************************************/
int hasTypeBaseType(variant)
int variant;
{
  if (!isATypeNode(variant))
    {
      Message("hasTypeBaseType not applied to a type node",0);
      return 0;
    }
  if (info_type[variant][2] == 'b')
    return TRUE;
  else
    return FALSE;
}

/***************************************************************************/
int isStructType(variant)
int variant;
{
  if (!isATypeNode(variant))
    {
      Message("isStructType not applied to a type node",0);
      return 0;
    }
  if (info_type[variant][0] == 's')
    return TRUE;
  else
    return FALSE;
}

/***************************************************************************/
int isPointerType(variant)
int variant;
{
  if (!isATypeNode(variant))
    {
      Message("isPointerType not applied to a type node",0);
      return 0;
    }
  if (info_type[variant][0] == 'p')
    return TRUE;
  else
    return FALSE;
}


/***************************************************************************/
int isUnionType(variant)
int variant;
{
  if (!isATypeNode(variant))
    {
      Message("isUnionType not applied to a type node",0);
      return 0;
    }
  if (info_type[variant][0] == 'u')
    return TRUE;
  else
    return FALSE;
}


/***************************************************************************/
int isEnumType(variant)
int variant;
{
  if (!isATypeNode(variant))
    {
      Message("EnumType not applied to a type node",0);
      return 0;
    }
  if (info_type[variant][0] == 'e')
    return TRUE;
  else
    return FALSE;
}


/***************************************************************************/
int hasTypeSymbol(variant)
int variant;
{
  if (!isATypeNode(variant))
    {
      Message("hasTypeSymbol not applied to a type node",0);
      return 0;
    }
  if (info_type[variant][1] == 's')
    return TRUE;
  else
    return FALSE;
}

/***************************************************************************/
int isAtomicType(variant)
int variant;
{
  if (!isATypeNode(variant))
    {
      Message("isAtomicType not applied to a type node",0);
      return 0;
    }
  if (info_type[variant][0] == 'a')
    return TRUE;
  else
    return FALSE;
}

/***************************************************************************/
int hasNodeASymb(variant)
int variant;
{
  if ((!isABifNode(variant)) && (!isALoNode(variant)))
    {
      Message("hasNodeASymb not applied to a bif or low level node",0);
      return 0;
    }
  if (general_info[variant][2] == 's')
    return TRUE;
  else
    return FALSE;
}

/***************************************************************************/
int isNodeAConst(variant)
int variant;
{
  if ((!isABifNode(variant)) && (!isALoNode(variant)))
    {
      Message("isNodeAConst not applied to a bif or low level node",0);
      return 0;
    }
  if (general_info[variant][1] == 'c')
    return TRUE;
  else
    return FALSE;
}


/***************************************************************************/
int isAStructDeclBif(variant)
int variant;
{
  if (!isABifNode(variant))
    {
      Message("isAStructDeclBif not applied to a bif",0);
      return 0;
    }
  if (general_info[variant][1] == 's')
    return TRUE;
  else
    return FALSE;
}

/***************************************************************************/
int isAUnionDeclBif(variant)
int variant;
{
  if (!isABifNode(variant))
    {
      Message("isAUnionDeclBif not applied to a bif",0);
      return 0;
    }
  if (general_info[variant][1] == 'u')
    return TRUE;
  else
    return FALSE;
}

/***************************************************************************/
int isAEnumDeclBif(variant)
int variant;
{
  if (!isABifNode(variant))
    {
      Message("isAEnumDeclBif not applied to a bif",0);
      return 0;
    }
  if (general_info[variant][1] == 'e')
    return TRUE;
  else
    return FALSE;
}

/***************************************************************************/
int isADeclBif(variant)
int variant;
{
  if (!isABifNode(variant))
    {
      Message("isADeclBif not applied to a bif",0);
      return 0;
    }
  if (general_info[variant][0] == 'd')
    return TRUE;
  else
    return FALSE;
}

/***************************************************************************/
int isAControlEnd(variant)
int variant;
{
  if (!isABifNode(variant))
    {
      Message("isAControlEnd not applied to a bif",0);
      return 0;
    }
  if (general_info[variant][0] == 'c')
    return TRUE;
  else
    return FALSE;
}


/***************************************************************************/
int Message(s, l)
char *s;
int l;
{
  if (l != 0)
    fprintf(stderr,"Warning : %s line %d\n",s, l);
  else
    fprintf(stderr,"Warning : %s\n",s);
 Warning_count++;
}

/***************************************************************************/
/* A set of functions for dealing with a free list for low_level node      */
/***************************************************************************/

static int ExpressionNodeInFreeList = 0;
static ptstack_chaining expressionFreeNodeList = NULL;

void setFreeListForExpressionNode()
{
  if (ExpressionNodeInFreeList) return;
  
  ExpressionNodeInFreeList = 1;
  if (!expressionFreeNodeList)
    {
      expressionFreeNodeList = (ptstack_chaining) xmalloc(sizeof(struct stack_chaining));
      expressionFreeNodeList->first = NULL;
      expressionFreeNodeList->last = NULL;
      expressionFreeNodeList->prev = NULL;
      expressionFreeNodeList->level = 0;
    }
}


void resetFreeListForExpressionNode()
{
  ExpressionNodeInFreeList = 0;
}


/* Added for garbage collection */
void libFreeExpression(ll)
     PTR_LLND ll;
{
  ptchaining  pt2;

  if (!ExpressionNodeInFreeList) return;
  if (!ll)  return;
  if (!expressionFreeNodeList)
     {
      Message("Free list for expression node not defined\n",0);
      exit(1);
    }
  pt2 = (ptchaining) xmalloc(sizeof(struct chaining));
  pt2->zone = (char *) ll;
  pt2->list = NULL;

  if (expressionFreeNodeList->first == NULL)
    expressionFreeNodeList->first = pt2;

  if (expressionFreeNodeList->last == NULL)
    expressionFreeNodeList->last = pt2;
  else
    {
      expressionFreeNodeList->last->list = pt2;
      expressionFreeNodeList->last = pt2;
    }
}

char *allocateFreeListNodeExpression()
{
  char *pt;
  ptchaining  pt2;

  if (!ExpressionNodeInFreeList) return xmalloc(sizeof (struct llnd));
  if (!expressionFreeNodeList)
     {
      Message("Free list for expression node not defined\n",0);
      exit(1);
    }
  if (expressionFreeNodeList->first == NULL) return xmalloc(sizeof (struct llnd));
  
  pt2 = expressionFreeNodeList->first;
  if (expressionFreeNodeList->first == expressionFreeNodeList->last)
    {
      expressionFreeNodeList->first = NULL;
      expressionFreeNodeList->last = NULL;
    } else
      expressionFreeNodeList->first = pt2->list;
  
  pt = pt2->zone;
  free(pt2);
  memset((char *) pt, 0 , sizeof (struct llnd));
  return pt;
}


/***************************************************************************/
POINTER newNode(code)
     int code;
{
   PTR_BFND tb;
   PTR_LLND tl;
   PTR_TYPE tt;
   PTR_SYMB ts;
   PTR_LABEL tlab;
   PTR_CMNT tcmnt;
   PTR_BLOB tbl;
   int length;
   int kind;
  
  if (code == CMNT_KIND)
    { /* lets create a comment */
      
      length = sizeof (struct cmnt); 
      tcmnt = (PTR_CMNT) xmalloc(length);
      memset((char *) tcmnt,0, length);
      CMNT_ID(tcmnt) = ++CUR_FILE_NUM_CMNT();
      CMNT_NEXT(tcmnt) = PROJ_FIRST_CMNT ();
      PROJ_FIRST_CMNT () = tcmnt;
      return (POINTER) tcmnt;
    }

  if (code == LABEL_KIND)
    { /* lets create a label */
      PTR_LABEL last;
      
      /* allocating space... PHB */
      length = sizeof (struct Label); 
      tlab = (PTR_LABEL) xmalloc(length);
      memset((char *) tlab, 0, length);
      LABEL_ID(tlab) = ++CUR_FILE_NUM_LABEL();

      if (last=getLastLabel()) /* is there an existing label? PHB */
        {
        LABEL_NEXT(last)=tlab;
        return (POINTER) tlab;
        }
      else  /* There is no existing label, make one PHB */
        {
        LABEL_NEXT(tlab) = LBNULL;
        PROJ_FIRST_LABEL() = tlab;  /* set pointer to first label */
        return (POINTER) tlab;
        }
    }

  if (code == BLOB_KIND)
    { 
      length = sizeof (struct blob);
      tbl = (PTR_BLOB) xmalloc (length);
      memset((char *) tbl, 0, length);
      CUR_FILE_NUM_BLOBS()++; 
      return (POINTER) tbl;
    }
  

  kind = (int) node_code_kind[(int) code];
  switch (kind)
    {
    case BIFNODE:
      length = sizeof (struct bfnd);      
      break;
    case LLNODE :
     length = sizeof (struct llnd);  
      break;
    case SYMBNODE:
     length = sizeof (struct symb);  
      break;
    case TYPENODE:
     length = sizeof (struct data_type);   
      break;
    default:
      Message("Node inconnu",0);
    }

  switch (kind)
    {
    case BIFNODE:
      tb = (PTR_BFND) xmalloc(length);
      memset((char *) tb, 0, length);
      BIF_ID (tb)  = ++CUR_FILE_NUM_BIFS ();
      number_of_bif_node++;
      /*BIF_ID (tb) = number_of_bif_node++;*/
      BIF_CODE(tb) = code;
      BIF_FILE_NAME(tb) = CUR_FILE_HEAD_FILE();/* recently added, to check */
      CUR_FILE_CUR_BFND() = tb;
      BIF_LINE(tb) = 0; /* set to know that this is a new node */ 
      break;
    case LLNODE :
      if (ExpressionNodeInFreeList)
        tl = (PTR_LLND) allocateFreeListNodeExpression();
      else
        {
          tl = (PTR_LLND) xmalloc(length);
          memset((char *) tl, 0, length);
        }
      NODE_ID (tl) = ++CUR_FILE_NUM_LLNDS();
      NODE_NEXT (tl) = LLNULL;
      number_of_ll_node++;
      if (CUR_FILE_NUM_LLNDS() == 1)
	PROJ_FIRST_LLND () = tl;
      else
	NODE_NEXT (CUR_FILE_CUR_LLND()) = tl;
      CUR_FILE_CUR_LLND() = tl;
      NODE_CODE(tl) = code;
      break;
    case SYMBNODE:
      ts = (PTR_SYMB)  xmalloc(length); 
      memset((char *) ts, 0, length);
      number_of_symb_node++;
      SYMB_ID (ts) = ++CUR_FILE_NUM_SYMBS();
      SYMB_CODE(ts) = code;
      if (CUR_FILE_NUM_SYMBS() == 1)
	PROJ_FIRST_SYMB () =  ts;
      else
	SYMB_NEXT (CUR_FILE_CUR_SYMB()) = ts;
      CUR_FILE_CUR_SYMB() = ts;
      SYMB_NEXT (ts) = NULL;
      SYMB_SCOPE (ts) = PROJ_FIRST_BIF();/* the default value */
      break;
    case TYPENODE:
      /*tt = (PTR_TYPE) alloc_type ( cur_file ); xmalloc(length);
      number_of_type_node++;
      TYPE_ID (tt) = number_of_type_node++;
      TYPE_NEXT (tt) = NULL;*/
      
      tt = (PTR_TYPE) xmalloc (length);
      memset((char *) tt, 0, length);
      number_of_type_node++;
      TYPE_ID (tt) = ++CUR_FILE_NUM_TYPES();
      TYPE_CODE (tt) = code;
      TYPE_NEXT (tt) = NULL;
      if (CUR_FILE_NUM_TYPES () == 1)
        PROJ_FIRST_TYPE() = tt;
      else 
        TYPE_NEXT (CUR_FILE_CUR_TYPE()) = tt;
      CUR_FILE_CUR_TYPE() = tt;
      /* for VPC very ugly and should be removed later */
      if (code == T_POINTER)  TYPE_TEMPLATE_DUMMY1(tt) = 1 ;
      if (code == T_REFERENCE) TYPE_TEMPLATE_DUMMY1(tt) = 1 ;
      break;
    default:
      Message("Node inconnu",0);
    }


  switch (kind)
    {
    case BIFNODE:
      return (POINTER) tb; 
    case LLNODE :
      return (POINTER) tl;
    case SYMBNODE:
      return (POINTER) ts; 
    case TYPENODE:
      return (POINTER) tt;
    default:
      Message("Node inconnu",0);
    }
   return NULL;
}

/***************************************************************************/
PTR_LLND copyLlNode(node)
     PTR_LLND node;
{
   PTR_LLND t;
   int code;
  
  if (!node)
    return NULL;

  code = NODE_CODE (node);
  if (node_code_kind[(int) code] != LLNODE)
    Message("bif_copy_node != low_level_node",0);

  t = (PTR_LLND) newNode (code);
  
  NODE_SYMB(t)  = NODE_SYMB(node);
  NODE_TYPE(t) = NODE_TYPE(node);
  NODE_OPERAND0(t) = copyLlNode(NODE_OPERAND0(node));
  NODE_OPERAND1(t) = copyLlNode(NODE_OPERAND1(node));
  return t;
}

/***************************************************************************/
PTR_LLND makeInt(low)
     int low;
{
   PTR_LLND t =  (PTR_LLND) newNode(INT_VAL);
  NODE_TYPE(t) = NULL;
  NODE_INT_CST_LOW (t) = low;
  return t;
}

/* Originally coded by fbodin, but the code used K&R varargs conventions,
   I have rewritten the code to use ANSI conventions (phb) */
/***************************************************************************/
PTR_LLND newExpr(int code, PTR_TYPE ntype, ... )
{
  va_list p;
  PTR_LLND t;
  int length;

  /* Create a new node of type 'code' */
  t = (PTR_LLND) newNode(code);
  NODE_TYPE(t) = ntype;

  /* calculate the number of args required for this type of node */
  length = node_code_length[code];

  /* Set pointer p to the very first variable argument in list */
  va_start(p,ntype);  

  if (hasNodeASymb(code))
    {
      /* Extract third argument (type PTR_SYMB), inc arg pointer p */
      PTR_SYMB arg0 = va_arg(p, PTR_SYMB);
      NODE_SYMB(t) = arg0;
    } 
  if (length != 0)
    {
      if (length == 2)
	{
	  /* This is equivalent to the loop below, but faster.  */
	  /* Extract another argument (type PTR_LLND), inc arg pointer p */
	  PTR_LLND arg0 = va_arg(p, PTR_LLND);
	  /* Extract another argument (type PTR_LLND), inc arg pointer p */
	  PTR_LLND arg1 = va_arg(p, PTR_LLND);
	  NODE_OPERAND0(t) = arg0;
	  NODE_OPERAND1(t) = arg1;
	  va_end (p);
	  return t;
	}
      else 
	if (length == 1)
	  {
	    /* This is equivalent to the loop below, but faster.  */
	    /* Extract another argument (type PTR_LLND), inc arg pointer p */
	    PTR_LLND arg0 = va_arg(p, PTR_LLND);
	    NODE_OPERAND0(t) = arg0;
	    va_end(p);
	    return t;
	  } else
	    Message("A low level node have more than two operands",0);
    }
  va_end(p);
  return t;
}

/***************************************************************************/
PTR_SYMB newSymbol(code, name, type)
     int code;
     char *name;
     PTR_TYPE type;
{
   PTR_SYMB t;
  char *str;
  
  if(name){
    str = (char *) xmalloc(strlen(name) +1);
    strcpy(str,name);
    }
  else str=NULL;
  t = (PTR_SYMB) newNode (code);
  SYMB_IDENT (t) = str;
  SYMB_TYPE (t) = type;
  return t;
}

/***************************************************************************/
int Check_Lang_Java(proj)
PTR_PROJ proj;
{
  PTR_FILE ptf;
  PTR_BLOB ptb;
  if (!proj)
    return TRUE;
  for (ptb = PROJ_FILE_CHAIN (proj); ptb ; ptb =  BLOB_NEXT (ptb))
    {
      ptf = (PTR_FILE) BLOB_VALUE (ptb);

/*      if (debug)
    fprintf(stderr,"%s\n",FILE_FILENAME (ptf)); */

      if (FILE_LANGUAGE (ptf) != JavaSrc)
    return(FALSE);
    }
  return(TRUE);
}

/***************************************************************************/
int Check_Lang_C(proj)
PTR_PROJ proj;
{
  PTR_FILE ptf;
  PTR_BLOB ptb;
  if (!proj)
    return TRUE;
  for (ptb = PROJ_FILE_CHAIN (proj); ptb ; ptb =  BLOB_NEXT (ptb))
    {
      ptf = (PTR_FILE) BLOB_VALUE (ptb);

/*      if (debug)
	fprintf(stderr,"%s\n",FILE_FILENAME (ptf)); */

      if (FILE_LANGUAGE (ptf) != CSrc)
	return(FALSE);
    }
  return(TRUE);
}


/***************************************************************************/
int Check_Lang_Fortran(proj)
PTR_PROJ proj;
{
  PTR_FILE ptf;
  PTR_BLOB ptb;
  if (!proj)
    return FALSE;
  for (ptb = PROJ_FILE_CHAIN (proj); ptb ; ptb =  BLOB_NEXT (ptb))
    {
      ptf = (PTR_FILE) BLOB_VALUE (ptb);
    /*  if (debug)
	fprintf(stderr,"%s\n",FILE_FILENAME (ptf)); */

      if (FILE_LANGUAGE(ptf) != ForSrc)
	return(FALSE);
    }
  return(TRUE);
}


/* Procedure for unparse a program use when debug is required 
   the current project is taking */
/***************************************************************************/
void UnparseProgram(fout)
     FILE *fout;
{
  char *s;
  PTR_BLOB b, bl;
  PTR_FILE f;

  if (Check_Lang_Fortran(cur_proj))
    {  
      Init_Unparser();
      
      fprintf(fout,"%s",filter(Tool_Unparse_Bif(PROJ_FIRST_BIF())));
    } else
      {
	Init_Unparser();
	fprintf(fout,"%s",Tool_Unparse_Bif(PROJ_FIRST_BIF()));
      }
}

/* Procedure for unparse a program use when debug is required 
   the current project is taking */
/***************************************************************************/
void UnparseBif(bif)
     PTR_BFND bif;
{
  char *s;
  PTR_BLOB b, bl;

  if (Check_Lang_Fortran(cur_proj))
    {  
      Init_Unparser();
      printf("%s",filter(Tool_Unparse_Bif(bif)));
    } else
      {
	Init_Unparser();
	printf("%s",(Tool_Unparse_Bif(bif)));
      }

}

/* Procedure for unparse a program use when debug is required 
   the current project is taking */
/***************************************************************************/
void UnparseLLND(ll)
     PTR_LLND ll;
{
  Init_Unparser();
  printf("%s",Tool_Unparse2_LLnode(ll));
}

/***************************************************************************/
char* UnparseTypeBuffer(type)
     PTR_TYPE type;
{
  Init_Unparser();
  return Tool_Unparse_Type(type);
}

/***************************************************************************/
int open_proj_toolbox(proj_name, proj_file)
char * proj_name;
char * proj_file;
{
        char *mem[MAX_FILE];          /* for file in the project */
        int   no = 0;           /* number of file in the project */
        int   c;
        FILE *fd;               /* file descriptor for project */
        char **p, *t;
        char *tmp, tmpa[2000];

        tmp = &(tmpa[0]);

        if ((fd = fopen(proj_file, "r")) == NULL)
                return -1;

        p = mem;
        t = tmp;
        while((c = getc(fd)) != EOF){
            if(c != ' ')        /* assum no blanks in filename */
                if(c == '\n') {
                    if (t != tmp) {
                        /* not a blank line */
                        *t = '\0';
                        *p = (char *) malloc((unsigned) (strlen(tmp) + 1));
                        strcpy(*p++, tmp);
                        t = tmp;
                      }
                } else  *t++ = c;
        }

        fclose(fd);
        no = p - mem;
        if (no > 0)
            /* Now make it the active project */
            if ((cur_proj = OpenProj(proj_name, no, mem))) {
                cur_file = (PTR_FILE) BLOB_VALUE (CUR_PROJ_FILE_CHAIN());
                pointer_on_file_proj = cur_file;
                return 0;
            } else{
                fprintf(stderr,"-2 Cannot open project\n");
                return -2;
                }
        else{
            fprintf(stderr,"-3 No files in the project\n");
            return -3;

            }
}

static int ToolBOX_INIT = 0;
/***************************************************************************/
void Reset_Tool_Box()
{
  Init_Tool_Box();
}

/***************************************************************************/
void Reset_Bif_Next()
{
  PTR_BLOB ptb;
  if (cur_proj)
    {
      for (ptb = PROJ_FILE_CHAIN (cur_proj); ptb ; ptb =  BLOB_NEXT (ptb))
	{
	  pointer_on_file_proj = (PTR_FILE) BLOB_VALUE (ptb);
	  Redo_Bif_Next_Chain(PROJ_FIRST_BIF());
	}
    } else
      if(pointer_on_file_proj)
	Redo_Bif_Next_Chain(PROJ_FIRST_BIF());
}

/***************************************************************************/
int Init_Tool_Box()
{

  PTR_BLOB ptb;

  pointer_on_file_proj = cur_file;
  number_of_type_node = CUR_FILE_NUM_TYPES() + 1;
  number_of_ll_node = CUR_FILE_NUM_LLNDS() + 1 ;
  number_of_bif_node = CUR_FILE_NUM_BIFS() + 1;
  number_of_symb_node = CUR_FILE_NUM_SYMBS() + 1;

  if (CUR_FILE_NAME()) strcpy(Current_File_name,CUR_FILE_NAME());
  if (ToolBOX_INIT)
    return 0;

  ToolBOX_INIT = 1;

  make_a_malloc_stack();

/* initialisation des noeuds */
#define DEFNODECODE(SYM, NAME, TYPE, LENGTH, NT,f1,f2,f3,f4,f5) node_code_type[SYM] = TYPE;
#include"bif_node.def"
#undef DEFNODECODE

#define DEFNODECODE(SYM, NAME, TYPE, LENGTH, NT,f1,f2,f3,f4,f5) node_code_length[SYM] =LENGTH;
#include"bif_node.def"
#undef DEFNODECODE

#define DEFNODECODE(SYM, NAME, TYPE, LENGTH, NT,f1,f2,f3,f4,f5) node_code_kind[SYM] = NT;
#include"bif_node.def"
#undef DEFNODECODE
/*
{
	int i;
	for (i=0;i<1101;i++)
		printf("the %dth kind is %d\n", i, node_code_kind[i]);
}
*/
/*
printf("this is 705 %d\n", node_code_kind[705]);
*/
/* set special table for symbol and type */
#define DEFNODECODE(SYMB,f1,f2,f3,f4,f5) info_type[SYMB][0] = f1; info_type[SYMB][1] = f2; info_type[SYMB][2] = f3;  info_type[SYMB][3] = f4;   info_type[SYMB][4] = f5;  
#include"type.def"
#undef DEFNODECODE

#define DEFNODECODE(SYMB,f1,f2,f3,f4,f5) info_symb[SYMB][0] = f1; info_symb[SYMB][1] = f2; info_symb[SYMB][2] = f3;  info_symb[SYMB][3] = f4;   info_symb[SYMB][4] = f5;  
#include"symb.def"
#undef DEFNODECODE

#define DEFNODECODE(SYM, NAME, TYPE, LENGTH, NT,f1,f2,f3,f4,f5) general_info[SYM][0] = f1; general_info[SYM][1] = f2; general_info[SYM][2] = f3;  general_info[SYM][3] = f4;   general_info[SYM][4] = f5; 
#include"bif_node.def"
#undef DEFNODECODE

  if (cur_proj)
    {
      for (ptb = PROJ_FILE_CHAIN (cur_proj); ptb ; ptb =  BLOB_NEXT (ptb))
	{
	  pointer_on_file_proj = (PTR_FILE) BLOB_VALUE (ptb);
	  Redo_Bif_Next_Chain_Internal(PROJ_FIRST_BIF());
	}
    }
  pointer_on_file_proj = cur_file;
  number_of_type_node = CUR_FILE_NUM_TYPES() + 1;
  number_of_ll_node = CUR_FILE_NUM_LLNDS() + 1 ;
  number_of_bif_node = CUR_FILE_NUM_BIFS() + 1;
  number_of_symb_node = CUR_FILE_NUM_SYMBS() + 1;
  
  return 1;
  
}

/* For debug  */
/***************************************************************************/
void writeDepFileInDebugdep()
{
  PTR_BFND thebif;
  int i;

  thebif = PROJ_FIRST_BIF();
  i = 1;
  for (;thebif;thebif=BIF_NEXT(thebif), i++) 
       BIF_ID(thebif) = i;     
   
  CUR_FILE_NUM_BIFS() = i-1;

  if (writeNodes(cur_file,"debug.dep") < 0);
      Message("Error, writeNodes() failed (000)",0);

}

/* cut at 72 can cut everywhere...*/
/***************************************************************************/
char* filter(char *s)
{
  char c;
  int i = 1;

  char temp[1024];

  int temp_i = 0;
  int buf_i = 0;

  int commentline = 0;
  
  int hpfline=0;

  char *resul, *init;
  
  if (!s) 
    return NULL;

  if (strlen(s)==0) 
    return s;

  /* allocate very simple, but to redo later, allocate two times the size */

  make_a_malloc_stack();
  resul = (char *) mymalloc(2*strlen(s));

  memset(resul, 0, 2*strlen(s));
  init = resul;
  
  /* find the separator */
  c = s[0];

  if ((c != ' ')
      &&(c != '\n')
      && (c != '0')
      && (c != '1') 
      && (c != '2') 
      && (c != '3') 
      && (c != '4') 
      && (c != '5') 
      && (c != '6') 
      && (c != '7') 
      && (c != '8') 
      && (c != '9'))
    commentline = 1;
  else
    commentline = 0;

  temp_i = 0;
  i = 0;
  buf_i =0;

  while (c!='\0') {
    c = s[i];
    temp[ buf_i] = c;

    if (c == '\n')  {
      temp[ buf_i+1] = '\0';
      sprintf(resul,"%s",temp);
      resul = resul + strlen(temp);

      temp_i = -1;
      buf_i = -1;

      if ((s[i+1] != ' ')
	  &&(s[i+1] != '\n')
	  && (s[i+1] != '0')
	  && (s[i+1] != '1') 
	  && (s[i+1] != '2') 
	  && (s[i+1] != '3') 
	  && (s[i+1] != '4') 
	  && (s[i+1] != '5') 
	  && (s[i+1] != '6') 
	  && (s[i+1] != '7') 
	  && (s[i+1] != '8') 
	  && (s[i+1] != '9'))
	commentline = 1;
      else
	commentline = 0;

      if (strncmp(&s[i+1], "!HPF$", strlen("!HPF$"))==0)
	hpfline=1;
      else
	hpfline=0;

    } 
    else {
      if ((temp_i == 71)) {
	/* We don't care about commentline at present time */
	/*   if ((temp_i == 71)&& !commentline) {          */

	/* insert & symbol when necessary */

	temp[ buf_i+1]  = '\0';
	
	if (s[i+1]=='\n') {
	  sprintf(resul,"%s\n",temp);
	  resul = resul + strlen(temp)+1;
	  commentline = 0;
	  memset(temp, 0, 1024);
	} 
	else {
	  sprintf(resul,"%s&\n",temp);
	  resul = resul + strlen(temp)+2;
	  
	  if (!hpfline)
	    sprintf(resul,"     &");
	  else
	    sprintf(resul,"!HPF$&");

	  resul = resul + strlen("     &");
	  commentline = 0;
	  memset(temp, 0, 1024);
	  temp_i = strlen("     &")-1;

	};

	buf_i = -1;
      }
    }

    i++;
    temp_i++;
    buf_i++;
  }

  return init;  
}

/* BW, june 1994
   this function is used in duplicateStmtsBlock to determine how many
   bif nodes need to be copied
*/
/***************************************************************************/
int numberOfBifsInBlobList(blob)
PTR_BLOB blob;
{
  PTR_BFND cur_bif;

  if(!blob) return 0;
  cur_bif = BLOB_VALUE(blob);
  return (numberOfBifsInBlobList(BIF_BLOB1(cur_bif))
       + numberOfBifsInBlobList(BIF_BLOB2(cur_bif))
       + numberOfBifsInBlobList(BLOB_NEXT(blob)) + 1);
}

/***************************************************************************/
int findBifInList1(bif_source, bif_cherche)
PTR_BFND bif_source, bif_cherche;
{
  PTR_BLOB temp;
  
  if ((bif_cherche == NULL) || (bif_source == NULL)) 
    return FALSE;
  
  for (temp = BIF_BLOB1 (bif_source); temp ; temp = BLOB_NEXT (temp))
    if (BLOB_VALUE (temp) == bif_cherche)
      return TRUE;
  return FALSE;
}

/***************************************************************************/
int findBifInList2(bif_source, bif_cherche)
PTR_BFND bif_source, bif_cherche;
{
  PTR_BLOB temp;
  
  if ((bif_cherche == NULL) || (bif_source == NULL)) 
    return FALSE;

  for (temp = BIF_BLOB2 (bif_source); temp ; temp = BLOB_NEXT (temp))
    if (BLOB_VALUE (temp) == bif_cherche)
      return TRUE;
  return FALSE;
}

/***************************************************************************/
int findBif(bif_source, bif_target, i)
PTR_BFND bif_source, bif_target;
int i;
{
  switch(i){
  case 0:
    if (findBifInList1 (bif_source, bif_target))
      return TRUE;
    else return findBifInList2 (bif_source, bif_target);
    break;
  case 1:
    return findBifInList1 (bif_source, bif_target);
    break;
  case 2:
    return findBifInList2 (bif_source, bif_target);
    break;
  }
  return 0;
}


/***************************************************************************/
PTR_BLOB appendBlob(b1, b2)
PTR_BLOB b1, b2;
{
    if (b1) {
         PTR_BLOB p, q;

        for (p = b1; p; p = BLOB_NEXT (p)) /* skip to the end of b1 */
            q = p;
        BLOB_NEXT (q) = b2;
    } else
        b1 = b2;
    return b1;
}

/* 
 *delete a bif node from the list of blob node
 */
/***************************************************************************/
PTR_BFND deleteBfndFromBlobAndLabel(bf,label)
     PTR_BFND bf;
     PTR_LABEL label;
{
    PTR_BLOB first;
    PTR_BLOB bl1, bl2;

    if (label) {
      first = LABEL_UD_CHAIN(label);     
      if (first && (BLOB_VALUE (first) == bf))
	{
	  bl2 = first;
	  LABEL_UD_CHAIN(label) = BLOB_NEXT (first);
	  return (BLOB_VALUE (bl2));
	}

      for (bl1 = bl2 = first; bl1; bl1 = BLOB_NEXT (bl1)) {
	if (BLOB_VALUE (bl1) == bf) {
	  BLOB_NEXT (bl2) = BLOB_NEXT (bl1);
	  return (BLOB_VALUE (bl2));
	}
	bl2 = bl1;
      }
      return NULL;
    }
    return NULL;
}

/***************************************************************************/
PTR_BLOB lookForBifInBlobList(first, bif)
PTR_BLOB first;
PTR_BFND bif;
{
  PTR_BLOB tail;
  if (first == NULL)
    return NULL;
  for (tail = first; tail; tail = BLOB_NEXT(tail) )
    {
      if (BLOB_VALUE(tail) == bif)
        return tail;
    }
  return NULL;
}

/***************************************************************************/
PTR_BFND childfInBlobList(first, num)
PTR_BLOB first;
int num;
{
  PTR_BLOB tail;
  int len = 0;
  if (first == NULL)
    return NULL;
  for (tail = first; tail; tail = BLOB_NEXT(tail) )
    {
      if (len == num)
        return BLOB_VALUE(tail);
      len++;
    }
  return NULL;
}

/***************************************************************************/
int blobListLength(first)
PTR_BLOB first;
{
  PTR_BLOB tail;
  int len = 0;
  if (first == NULL)
    return(0);
  for (tail = first; tail; tail = BLOB_NEXT(tail) )
    len++;
  return(len);
}

/***************************************************************************/
PTR_BFND lastBifInBlobList1(noeud)
     PTR_BFND noeud;
{
  PTR_BLOB bl1 = NULL;
  if (!noeud )
    return NULL;
  /* on va cherche le dernier dans la liste */
  for (bl1 = BIF_BLOB1(noeud); bl1; bl1 = BLOB_NEXT(bl1)) 
    {
      if (BLOB_NEXT(bl1) == NULL)
	break;
    }
  if (bl1)
    return BLOB_VALUE(bl1);
  else
    return NULL;
}

/***************************************************************************/
PTR_BFND lastBifInBlobList2(noeud)
     PTR_BFND noeud;
{
  PTR_BLOB bl1 = NULL;
  if (!noeud )
    return NULL;
  /* on va cherche le dernier dans la liste */
  for (bl1 = BIF_BLOB2(noeud); bl1; bl1 = BLOB_NEXT(bl1)) 
    {
      if (BLOB_NEXT(bl1) == NULL)
	break;
    }
  if (bl1)
    return BLOB_VALUE(bl1);
  else
    return NULL;
}

/***************************************************************************/
PTR_BFND lastBifInBlobList(noeud)
     PTR_BFND noeud;
{
  if (!BIF_INDEX(noeud))
    return lastBifInBlobList1( noeud);
  else
    return lastBifInBlobList2( noeud);
}

/***************************************************************************/
PTR_BLOB lastBlobInBlobList1(noeud)
     PTR_BFND noeud;
{
  PTR_BLOB bl1 = NULL;
  if (!noeud )
    return NULL;
  /* on va cherche le dernier dans la liste */
  for (bl1 = BIF_BLOB1(noeud); bl1; bl1 = BLOB_NEXT(bl1)) 
    {
      if (BLOB_NEXT(bl1) == NULL)
	break;
    }
  if (bl1)
    return bl1;
  else
    return NULL;
}

/***************************************************************************/
PTR_BLOB lastBlobInBlobList2(noeud)
     PTR_BFND noeud;
{
  PTR_BLOB bl1 = NULL;
  if (!noeud )
    return NULL;
  /* on va cherche le dernier dans la liste */
  for (bl1 = BIF_BLOB2(noeud); bl1; bl1 = BLOB_NEXT(bl1)) 
    {
      if (BLOB_NEXT(bl1) == NULL)
	break;
    }
  if (bl1)
    return bl1;
  else
    return NULL;
}

/***************************************************************************/
PTR_BLOB lastBlobInBlobList(noeud)
     PTR_BFND noeud;
{
  if (!BIF_INDEX(noeud))
    return lastBlobInBlobList1( noeud);
  else
    return lastBlobInBlobList2( noeud);
}

/*
 *
 * append dans la blob liste d'un noeud bif, un noeud bif
 *
 */
/***************************************************************************/
int appendBfndToList1(biftoinsert, noeud)
     PTR_BFND biftoinsert, noeud;
{
  PTR_BLOB bl1;

  if (!noeud || !biftoinsert)
    return 0;
  if (BIF_BLOB1(noeud) == NULL)
    {
      BIF_BLOB1(noeud) = (PTR_BLOB) newNode (BLOB_KIND);
      BLOB_VALUE(BIF_BLOB1(noeud)) = biftoinsert; 
      BLOB_NEXT(BIF_BLOB1(noeud)) = NULL;
      BIF_CP(biftoinsert) = noeud;
    } else
      {
        /* on va cherche le dernier dans la liste */
        for (bl1 = BIF_BLOB1(noeud); bl1; bl1 = BLOB_NEXT(bl1)) 
          {
            if (BLOB_NEXT(bl1) == NULL)
              break;
          }
        BLOB_NEXT(bl1) = (PTR_BLOB) newNode (BLOB_KIND);
        BLOB_VALUE(BLOB_NEXT(bl1)) = biftoinsert;
	BIF_CP(biftoinsert) = noeud;
        BLOB_NEXT(BLOB_NEXT(bl1)) = NULL;
      }
  
  return 1;
}

/***************************************************************************/
int appendBfndToList2(biftoinsert, noeud)
     PTR_BFND biftoinsert, noeud;
{
  PTR_BLOB bl1;

  if (!noeud || !biftoinsert)
    return 0;
  if (BIF_BLOB2(noeud) == NULL)
    {
      BIF_BLOB2(noeud) = (PTR_BLOB) newNode (BLOB_KIND);
      BLOB_VALUE (BIF_BLOB2(noeud)) = biftoinsert;      
      BLOB_NEXT (BIF_BLOB2(noeud)) = NULL;
      BIF_CP(biftoinsert) = noeud;
    } else
      {
        /* on va cherche le dernier dans la liste */
        for (bl1 = BIF_BLOB2(noeud); bl1; bl1 = BLOB_NEXT(bl1)) 
          {
            if (BLOB_NEXT(bl1) == NULL)
              break;
          }
        BLOB_NEXT(bl1) = (PTR_BLOB) newNode (BLOB_KIND);
        BLOB_VALUE(BLOB_NEXT(bl1)) = biftoinsert;
        BLOB_NEXT(BLOB_NEXT(bl1)) = NULL;
	BIF_CP(biftoinsert) = noeud;
      }
  
  return 1;
}

/* replace chain_up() */
/***************************************************************************/
int appendBfndToList(noeud, biftoinsert)
     PTR_BFND biftoinsert, noeud;
{
  /* use the index field to set the right blob node list */
  if (!noeud || !biftoinsert)
    return 0;
  if (!BIF_INDEX(noeud))
    return appendBfndToList1(biftoinsert, noeud);
  else
    return appendBfndToList2(biftoinsert, noeud);
}


/***************************************************************************/
int firstBfndInList1(biftoinsert, noeud)
     PTR_BFND biftoinsert, noeud;
{
  PTR_BLOB bl2;

  if (!noeud || !biftoinsert)
    return 0;
  if (BIF_BLOB1(noeud) == NULL)
    {
      BIF_BLOB1(noeud) = (PTR_BLOB) newNode (BLOB_KIND);
      BLOB_VALUE (BIF_BLOB1(noeud)) = biftoinsert;
      BLOB_NEXT (BIF_BLOB1(noeud)) = NULL;
      BIF_CP(biftoinsert) = noeud;
    } else
      {
        bl2 = BIF_BLOB1(noeud);
        BIF_BLOB1(noeud) = (PTR_BLOB) newNode (BLOB_KIND);
        BLOB_VALUE (BIF_BLOB1(noeud)) = biftoinsert;
        BLOB_NEXT (BIF_BLOB1(noeud)) =  bl2 ;
	BIF_CP(biftoinsert) = noeud;
      }
  return 1;
}


/***************************************************************************/
int firstBfndInList2(biftoinsert, noeud)
     PTR_BFND biftoinsert, noeud;
{
  PTR_BLOB bl2;
  if (!noeud || !biftoinsert)
    return 0;
  if (BIF_BLOB2(noeud) == NULL)
    {
      BIF_BLOB2(noeud) = (PTR_BLOB) newNode (BLOB_KIND);
      BLOB_VALUE (BIF_BLOB2(noeud)) = biftoinsert;
      BLOB_NEXT (BIF_BLOB2(noeud)) = NULL;
      BIF_CP(biftoinsert) = noeud;
    } else
      {
        bl2 = BIF_BLOB2(noeud);
        BIF_BLOB2(noeud) = (PTR_BLOB) newNode (BLOB_KIND);
        BLOB_VALUE (BIF_BLOB2(noeud)) = biftoinsert; 
        BLOB_NEXT (BIF_BLOB2(noeud)) =  bl2 ;
	BIF_CP(biftoinsert) = noeud;
      }
  return 1;
}

/***************************************************************************/
int insertBfndInList1(biftoinsert, current, noeud)
     PTR_BFND biftoinsert, noeud,current;
{
  PTR_BLOB bl1 = NULL, bl2;
  if (!noeud || !biftoinsert || !current)
    return 0;
  if (BIF_BLOB1(noeud) == NULL)
    {
      BIF_BLOB1(noeud) = (PTR_BLOB) newNode (BLOB_KIND);
      BLOB_VALUE (BIF_BLOB1(noeud)) = biftoinsert;
      BLOB_NEXT (BIF_BLOB1(noeud)) = NULL;
      BIF_CP(biftoinsert) = noeud;
    } else
      {
       /* on va cherche current  dans la liste */
        for (bl1 = BIF_BLOB1(noeud); bl1; bl1 = BLOB_NEXT(bl1)) 
          {
            if (BLOB_VALUE(bl1) == current)
              break;
          }

        if (!bl1)
          {
            Message("insertBfndInList1 failed",0);
	    return FALSE;
          }

        bl2 = BLOB_NEXT(bl1);
        BLOB_NEXT(bl1) = (PTR_BLOB) newNode (BLOB_KIND);
        BLOB_VALUE (BLOB_NEXT(bl1)) = biftoinsert;
        BLOB_NEXT (BLOB_NEXT(bl1)) =  bl2; 
	BIF_CP(biftoinsert) = noeud;
      }
  return TRUE;
}

/***************************************************************************/
int insertBfndInList2(biftoinsert, current, noeud)
     PTR_BFND biftoinsert, noeud,current;
{
  PTR_BLOB bl1 = NULL, bl2;

  if (!noeud || !biftoinsert || !current)
    return 0;
  if (BIF_BLOB2(noeud) == NULL)
    {
      BIF_BLOB2(noeud) = (PTR_BLOB)  newNode (BLOB_KIND);
      BLOB_VALUE (BIF_BLOB2(noeud)) = biftoinsert;
      BLOB_NEXT (BIF_BLOB2(noeud)) = NULL;
      BIF_CP(biftoinsert) = noeud;
    } else
      {
       /* on va cherche current  dans la liste */
        for (bl1 = BIF_BLOB2(noeud); bl1; bl1 = BLOB_NEXT(bl1)) 
          {
            if (BLOB_VALUE(bl1) == current)
              break;
          }

        if (!bl1)
          {
            Message("insertBfndInList2 failed",0);
            abort();
          }

        bl2 = BLOB_NEXT(bl1);
        BLOB_NEXT(bl1) = (PTR_BLOB)  newNode (BLOB_KIND);
        BLOB_VALUE (BLOB_NEXT(bl1)) = biftoinsert;
        BLOB_NEXT(BLOB_NEXT(bl1)) =   bl2 ; 
	BIF_CP(biftoinsert) = noeud;

      }
  return 1;
}

/* enleve in noeud de la liste de bif node si s'y trouve */
/***************************************************************************/
PTR_BLOB deleteBfndFrom(b1,b2)
     PTR_BFND b1,b2;
{
  PTR_BLOB temp, last, res = NULL;
  
  if (!b1)
    return NULL;
  
  last = NULL;
  for (temp = BIF_BLOB1(b1) ; temp ; temp = BLOB_NEXT (temp))
    {
      if (BLOB_VALUE(temp) == b2)
        {
          res = temp;
          if (last  == NULL)
            {
              BIF_BLOB1(b1) = BLOB_NEXT (temp);              
              break;
            }          
          else
            {
              BLOB_NEXT (last) = BLOB_NEXT (temp);
              break;
            }
        }
      last = temp;      
    }
  
  if (!res)
    {
      last = NULL;
      for (temp = BIF_BLOB2(b1) ; temp ; temp = BLOB_NEXT (temp))
        {
          if (BLOB_VALUE(temp) == b2)
            {
               res = temp;
              if (last  == NULL)
                {
                  BIF_BLOB2(b1) = BLOB_NEXT (temp);
                  break;
                }          
              else
                {
                  BLOB_NEXT (last) = BLOB_NEXT (temp);
                  break;
                }
            }
          last = temp; 
        }
    }
  return res;
}


/***************************************************************************/
PTR_BFND getNodeBefore(b)
     PTR_BFND b;
{
  PTR_BFND temp, first;
  
  if (!b)
    return NULL;

  if (BIF_CP(b))
    first = BIF_CP(b);
  else
    first = PROJ_FIRST_BIF();

  for (temp = first; temp ; temp = BIF_NEXT(temp))
    {
      if (BIF_NEXT(temp) == b)
        return temp;
    }
 
  if (BIF_CP(b))
    {
      for (temp = BIF_CP(BIF_CP(b)); temp ; temp = BIF_NEXT(temp))
        {
          if (BIF_NEXT(temp) == b)
            return temp;
        }
    }
  if (debug)
    Message("Node Before not found ",0);
  return NULL;
}

/***************************************************************************/
void updateControlParent(first,last,cp)
PTR_BFND first,cp,last;

{
  PTR_BFND temp;
  
  for (temp = first; temp && (temp != last); temp = BIF_NEXT(temp))
    {      
      if (!isItInSection(first,last,BIF_CP(temp)))
        BIF_CP(temp) = cp;
    }

  if (!isItInSection(first,last,BIF_CP(last)))
    BIF_CP(last) = cp;
}


/***************************************************************************/
PTR_BFND getWhereToInsertInBfnd(where,cpin)
PTR_BFND where, cpin;
{
  PTR_BFND temp;
  PTR_BLOB blob;
  
  if (!cpin || !where)
    return NULL;

  if (findBifInList1 (cpin, where))
    return where;
  if (findBifInList2 (cpin, where))
    return where;

  
  for (blob = BIF_BLOB1(cpin) ; blob; blob = BLOB_NEXT(blob))
    {
      temp = getWhereToInsertInBfnd(where,BLOB_VALUE(blob));
      if (temp)
        return BLOB_VALUE(blob);
    }

  for (blob = BIF_BLOB2(cpin) ; blob; blob = BLOB_NEXT(blob))
    {
      temp = getWhereToInsertInBfnd(where,BLOB_VALUE(blob));
      if (temp)
        return BLOB_VALUE(blob);
    }

  return NULL;
  
}


/* Given a node where we want to insert another node, 
   compute the control parent */
/***************************************************************************/
PTR_BFND computeControlParent(where)
PTR_BFND where;
{
  PTR_BFND cp;

      
  if (!where)
    {
      Message("where not defined in computeControlParent: abort()",0);
      abort();
    }

  if (!BIF_CP(where))
    {
      switch(BIF_CODE(where))
        { /* node that can be a bif control parent */
        case  GLOBAL	       :
        case  PROG_HEDR      :
        case  PROC_HEDR	:	
        case  PROS_HEDR	:	
        case  BASIC_BLOCK	:
        case  IF_NODE		:
	case WHERE_BLOCK_STMT :
        case  LOOP_NODE	:	
        case  FOR_NODE	:	
        case  FORALL_NODE	:
        case  WHILE_NODE	:
        case  CDOALL_NODE	:
        case  SDOALL_NODE	:
        case  DOACROSS_NODE	:
        case  CDOACROSS_NODE	:
        case  FUNC_HEDR	:
	case  ENUM_DECL:
	case  STRUCT_DECL:
	case  UNION_DECL:
	case  CLASS_DECL:
	case  TECLASS_DECL:
	case  COLLECTION_DECL:
	case  SWITCH_NODE:
        case   ELSEIF_NODE    :
          return where;     
        default:
          Message("No Control Parent in computeControlParent: abort()",0);
          abort();
        }
    }

  switch(BIF_CODE(where))
    {
    case CONT_STAT :
      if (BIF_CP(where) &&
          (BIF_CODE(BIF_CP(where)) != FOR_NODE) &&
          (BIF_CODE(BIF_CP(where)) != WHILE_NODE) &&
          (BIF_CODE(BIF_CP(where)) != LOOP_NODE) &&
          (BIF_CODE(BIF_CP(where)) != CDOALL_NODE) &&
          (BIF_CODE(BIF_CP(where)) != SDOALL_NODE) &&
          (BIF_CODE(BIF_CP(where)) != DOACROSS_NODE) &&
          (BIF_CODE(BIF_CP(where)) != CDOACROSS_NODE))
        {
          cp = BIF_CP(where);
          break;
        }
    case CONTROL_END :
	  cp = BIF_CP(BIF_CP(where)); /* handle by the function insert in */
          break;
      /* that a node with a list of blobs */
    case  GLOBAL	:
    case  PROG_HEDR     :
    case  PROC_HEDR	:	
    case  PROS_HEDR	:	
    case  BASIC_BLOCK	:
    case  IF_NODE	:
    case WHERE_BLOCK_STMT :
    case  LOOP_NODE	:	
    case  FOR_NODE	:	
    case  FORALL_NODE	:
    case  WHILE_NODE	:
    case  CDOALL_NODE	:
    case  SDOALL_NODE	:
    case  DOACROSS_NODE	:
    case  CDOACROSS_NODE :
    case  FUNC_HEDR	:
    case  ENUM_DECL:
    case  STRUCT_DECL:
    case  UNION_DECL:
    case  CLASS_DECL:
    case  TECLASS_DECL:
    case  COLLECTION_DECL:
    case  SWITCH_NODE:
    case   ELSEIF_NODE    :
      cp = where;
          break; 
        default:
          cp = BIF_CP(where); /* dont specify it */
    }

  return cp;  
}


/***************************************************************************/
int insertBfndListIn(first,where,cpin)
PTR_BFND first,where;
PTR_BFND cpin;
{
  PTR_BFND cp;
  PTR_BFND biforblob;
  PTR_BFND temp, last;  
  int inblob2;

  if (!first)
    return 0;
  
  if (!where)
    {
      Message("where not defined in insertBfndListIn: abort()",0);
      abort();
    }

  if (!cpin)
    cp = computeControlParent(where);
  else
    cp = cpin;

  /* find where in the blob list where to insert it */
  /* treat first the special case of if_node */
  if ((BIF_CODE(where) == CONTROL_END) && BIF_CP(where) &&
      (BIF_CODE(BIF_CP(where)) == IF_NODE) &&
      (!findBifInList2 (BIF_CP(where),where)) &&
      BIF_BLOB2(BIF_CP(where)))
    {
      cp = BIF_CP(where);
      inblob2 = TRUE;
      biforblob = NULL;
      last =  getLastNodeList(first);
    }
    else
      {
        biforblob =  getWhereToInsertInBfnd(where,cp);
        last =  getLastNodeList(first);
        inblob2 = findBifInList2 (cp,biforblob);
/*        if (BIF_CODE(where) == ELSEIF_NODE)
          inblob2 = TRUE;*/
      }

  for (temp = first; temp; temp = BIF_NEXT(temp))
    {      
      if (!isItInSection(first,last,BIF_CP(temp)))
        {
          if (!biforblob)
            {
              if (inblob2)
                firstBfndInList2(temp, cp);
              else
                firstBfndInList1(temp, cp);
            } else
              {
                if (inblob2)
                  insertBfndInList2(temp,biforblob, cp);
                else
                  insertBfndInList1(temp,biforblob, cp);
              }          
          biforblob = temp;       
        }
    }

  updateControlParent(first,last,cp); 
  BIF_NEXT(last) = BIF_NEXT(where);
  BIF_NEXT(where) = first;
  return 1;  
}

/***************************************************************************/
int insertBfndListInList1(first,cpin)
PTR_BFND first;
PTR_BFND cpin;
{
  PTR_BFND biforblob;
  PTR_BFND temp, last;  

  if (!first || !cpin)
    return 0;
  
  biforblob = NULL; 
  last =  getLastNodeList(first);
  for (temp = first; temp; temp = BIF_NEXT(temp))
    {      
      if (!isItInSection(first,last,BIF_CP(temp)))
        {
          if (!biforblob)
            {
                firstBfndInList1(temp, cpin);
            } else
              {
                  insertBfndInList1(temp,biforblob, cpin);
              }          
          biforblob = temp;       
        }
    }

  updateControlParent(first,last,cpin); 
  return 1;
}

/***************************************************************************/
int appendBfndListToList1(first,cpin)
PTR_BFND first;
PTR_BFND cpin;
{
  PTR_BFND biforblob;
  PTR_BFND temp, last;  

  if (!first || !cpin)
    return 0;
  
  biforblob = NULL; 
  last =  getLastNodeList(first);
  for (temp = first; temp; temp = BIF_NEXT(temp))
    {      
      if (!isItInSection(first,last,BIF_CP(temp)))
        {
          if (!biforblob)
            {
                appendBfndToList1(temp, cpin);
            } else
              {
                  insertBfndInList1(temp,biforblob, cpin);
              }          
          biforblob = temp;       
        }
    }
  
  updateControlParent(first,last,cpin); 
  
  return 1;
}


/***************************************************************************/
int firstInBfndList2(first,cpin)
PTR_BFND first;
PTR_BFND cpin;
{
  PTR_BFND biforblob;
  PTR_BFND temp, last;  

  if (!first || !cpin)
    return 0;
  
  biforblob = NULL;  
  last =  getLastNodeList(first);
  for (temp = first; temp; temp = BIF_NEXT(temp))
    {      
      if (!isItInSection(first,last,BIF_CP(temp)))
        {
          if (!biforblob)
            {
                firstBfndInList2(temp, cpin);
            } else
              {
                  insertBfndInList2(temp,biforblob, cpin);
              }          
          biforblob = temp;       
        }
    }

  updateControlParent(first,last,cpin); 
  return 1;
}

/***************************************************************************/
int appendBfndListToList2(first,cpin)
PTR_BFND first;
PTR_BFND cpin;
{
  PTR_BFND biforblob;
  PTR_BFND temp, last;  

  if (!first || !cpin)
    return 0;
  
  biforblob = NULL; 
  last =  getLastNodeList(first);
  for (temp = first; temp; temp = BIF_NEXT(temp))
    {      
      if (!isItInSection(first,last,BIF_CP(temp)))
        {
          if (!biforblob)
            {
                appendBfndToList2(temp, cpin);
            } else
              {
                  insertBfndInList2(temp,biforblob, cpin);
              }          
          biforblob = temp;       
        }
    }

  updateControlParent(first,last,cpin); 
  return 1;
}

/***************************************************************************/
void insertBfndBeforeIn(biftoinsert, bif_current, cpin)
     PTR_BFND bif_current, biftoinsert,cpin;
{
  PTR_BFND  the_one_before = NULL;

  if (! bif_current || ! biftoinsert)
    {
      Message("NULL bif node in biftoinsert\n",0);
      exit(-1);
    }
  
  
  if (BIF_CODE (bif_current) == GLOBAL)
    {
      Message("Cannot insert before global\n",0);
      exit(-1);
    }  

  the_one_before = getNodeBefore (bif_current);
  insertBfndListIn (biftoinsert, the_one_before,cpin);
  
} 


/* warning to be used carefully; i.e. remove sons before a root */
/***************************************************************************/
PTR_BFND deleteBfnd(bif)
     PTR_BFND bif;
{
  PTR_BFND temp;
  
  temp = getNodeBefore (bif);
  deleteBfndFrom (BIF_CP (bif), bif);
  if (temp) 
    BIF_NEXT (temp) = BIF_NEXT (bif);
  return temp;
}


/***************************************************************************/
int isItInSection(bif_depart, bif_fin, noeud)
     PTR_BFND bif_depart, bif_fin, noeud;
{
  PTR_BFND temp;
  
  if (! noeud)
    return FALSE;
  
  for (temp = bif_depart; temp; temp = BIF_NEXT (temp))
    {
      if (temp ==  noeud)
        return TRUE;
      if (temp == bif_fin)
        return FALSE;
    }
  return FALSE;
  
}


/***************************************************************************/
PTR_BFND extractBifSectionBetween(bif_depart, bif_fin)
     PTR_BFND bif_depart, bif_fin;
{
  PTR_BFND temp;
  
  if (bif_depart && bif_fin)
    {
      for (temp = bif_depart; temp !=  bif_fin; temp = BIF_NEXT (temp))
        {
          if (!isItInSection(bif_depart, bif_fin,BIF_CP (temp)))
            {
              deleteBfndFrom(BIF_CP (temp),temp);
              BIF_CP (temp) = NULL;              
            }
        }
  
      /* on traite maintenant bif_fin */
      if (!isItInSection(bif_depart, bif_fin,BIF_CP ( bif_fin)))
        {
          deleteBfndFrom(BIF_CP (bif_fin), bif_fin);
           BIF_CP (bif_fin) = NULL;   
        }

      temp = getNodeBefore(bif_depart);
      if (temp && bif_fin)
        BIF_NEXT(temp) = BIF_NEXT (bif_fin);
      BIF_NEXT (bif_fin) = NULL;
    }  
  
  return bif_depart;
}

/***************************************************************************/
PTR_BFND getLastNodeList(b)
     PTR_BFND b;
{
  PTR_BFND temp;  
  for (temp = b; temp; temp = BIF_NEXT(temp))
    {      
      if (!BIF_NEXT(temp))
        {
          return temp;          
        }
    }
  return temp;  
}

/***************************************************************************/
PTR_BFND getLastNodeOfStmt(b)
     PTR_BFND b;
{
  PTR_BLOB temp,last = NULL;
  if (!b)
    return NULL;
  if (BIF_BLOB2(b))
    {
      for (temp = BIF_BLOB2(b); temp ; temp = BLOB_NEXT(temp))
        {
          last = temp;
        }
    } else
     {
       for (temp = BIF_BLOB1(b); temp ; temp = BLOB_NEXT(temp))
         {
           last = temp;
         }      
     } 
  if (last)
    {  
      if (Check_Lang_Fortran(cur_proj))
        return BLOB_VALUE(last);
      else
        { /* in C the Control end may not exist */
          return getLastNodeOfStmt(BLOB_VALUE(last));
        }
    }
  else
    return b;
}

/* version that does not assume, there is a last */
/***************************************************************************/
PTR_BFND getLastNodeOfStmtNoControlEnd(b)
     PTR_BFND b;
{
  PTR_BLOB temp,last = NULL;
  if (!b)
    return NULL;
  if (BIF_BLOB2(b))
    {
      for (temp = BIF_BLOB2(b); temp ; temp = BLOB_NEXT(temp))
        {
          last = temp;
        }
    } else
     {
       for (temp = BIF_BLOB1(b); temp ; temp = BLOB_NEXT(temp))
         {
           last = temp;
         }      
     } 
  if (last)
    {  
      return getLastNodeOfStmt(BLOB_VALUE(last));
    }
  else
    return b;
}

/* preset some values of symbols for evaluateExpression*/
#define ALLOCATECHUNKVALUE  100
static PTR_SYMB  *ValuesSymb = NULL;
static int       *ValuesInt  = NULL;
static int        NbValues   = 0;
static int        NbElement   = 0;

/***************************************************************************/
void allocateValueEvaluate()
{
  int i;
  PTR_SYMB  *pt1;
  int       *pt2;
  
  pt1 = (PTR_SYMB  *) xmalloc( sizeof(PTR_SYMB  *) * 
			      (NbValues + ALLOCATECHUNKVALUE));
  pt2 =  (int *) xmalloc( sizeof(int  *) * (NbValues + ALLOCATECHUNKVALUE));
  
  for (i=0; i<NbValues + ALLOCATECHUNKVALUE; i++) {
    pt1[i] = NULL;
    pt2[i] = 0;
  }
  
  for (i=0 ; i < NbValues; i++) {
    pt1[i] = ValuesSymb[i];
    pt2[i] = ValuesInt[i];
  }
  
  if (NbValues) {
    free(ValuesSymb);
    free(ValuesInt);
  }
    
  ValuesSymb = pt1;
  ValuesInt = pt2;
  NbValues = NbValues + ALLOCATECHUNKVALUE;
}

/***************************************************************************/
void addElementEvaluate(symb, val)
     PTR_SYMB symb;
     int val;
{
  if (!symb)
    return;
  while (NbValues <= ( NbElement+1))
    {
      allocateValueEvaluate();
    }
  ValuesSymb[NbElement] = symb;
  ValuesInt[NbElement] = val;
  NbElement++;
}


/***************************************************************************/
int getElementEvaluate(symb)
     PTR_SYMB symb;
{
  int i;
  if (!symb)
    return -1;
  for (i=0 ; i < NbElement; i++)
    {
      if (ValuesSymb[i] == symb)
        return i;
    }
  return -1;
}


/***************************************************************************/
void resetPresetEvaluate()
{
  NbValues = 0;
  NbElement  = 0;
  if (ValuesSymb)
    free(ValuesSymb);
  if (ValuesInt)
    free(ValuesInt);
  ValuesSymb = NULL;
  ValuesInt = NULL;
}

/***************************************************************************/
int* evaluateExpression(expr)
     PTR_LLND expr;
{
  int *res, *op1, *op2;
  
  res = (int *) xmalloc(2 * sizeof(int));
  memset((char *) res, 0, 2 * sizeof (int));
  op1 = (int *) xmalloc(2 * sizeof(int));
  memset((char *)op1, 0, 2 * sizeof (int));
  op2 = (int *) xmalloc(2 * sizeof(int));
  memset((char *) op2, 0, 2 * sizeof (int));
  if (! expr)
    {
      res [0] = -1;
      return res;
    }
  
  switch (BIF_CODE (expr)) 
    {
    case INT_VAL:
      res [1] = NODE_INT_CST_LOW (expr);
      free(op1); free(op2);
      return res;
    case ADD_OP :
      op1  = evaluateExpression (NODE_OPERAND0 (expr));
      op2  = evaluateExpression (NODE_OPERAND1 (expr));
      if ((op1 [0] == -1) || (op2 [0] == -1))
        res [0] = -1;
      else
        res [1] = op1 [1] + op2 [1];
      free(op1); free(op2);
      return res;
   case MULT_OP :
      op1  = evaluateExpression (NODE_OPERAND0 (expr));
      op2  = evaluateExpression (NODE_OPERAND1 (expr));
      if ((op1 [0] == -1) || (op2 [0] == -1))
        res [0] = -1;
      else
        res [1] = op1 [1] * op2 [1];
      free(op1); free(op2);
      return res;
   case SUBT_OP :
      op1  = evaluateExpression (NODE_OPERAND0 (expr));
      op2  = evaluateExpression (NODE_OPERAND1 (expr));
      if ((op1 [0] == -1) || (op2 [0] == -1))
        res [0] = -1;
      else
        res [1] = op1 [1] - op2 [1];
      free(op1); free(op2);
      return res;
   case DIV_OP :
        op1  = evaluateExpression (NODE_OPERAND0 (expr));
      op2  = evaluateExpression (NODE_OPERAND1 (expr));
      if ((op1 [0] == -1) || (op2 [0] == -1))
        res [0] = -1;
      else
        res [1] = op1 [1] / op2 [1];
      free(op1); free(op2);
      return res;
   case MOD_OP :
      op1  = evaluateExpression (NODE_OPERAND0 (expr));
      op2  = evaluateExpression (NODE_OPERAND1 (expr));
      if ((op1 [0] == -1) || (op2 [0] == -1))
        res [0] = -1;
      else
        res [1] = op1 [1] % op2 [1];
      free(op1); free(op2);
      return res;
   case EXP_OP :
      op1  = evaluateExpression (NODE_OPERAND0 (expr));
      op2  = evaluateExpression (NODE_OPERAND1 (expr));
      if ((op1 [0] == -1) || (op2 [0] == -1))
        res [0] = -1;
      else
        res [1] = op1 [1] ^ op2 [1];
      free(op1); free(op2);
      return res;

    case MINUS_OP :
      op1  = evaluateExpression (NODE_OPERAND0 (expr));
      if (op1 [0] == -1)
        res [0] = -1;
      else
        res [1] = - op1 [1];      
      free(op1);
      return res;
    case VAR_REF: /* assume here that some value for Symbole are given*/
      {
        int ind;
        if ((ind = getElementEvaluate(NODE_SYMB(expr))) != -1)
          {
             res [1] = ValuesInt[ind];
             free(op1); free(op2);
             return res;
           } else
             {
                res [0] = -1;
                free(op1); free(op2);
                return res;
             }
        break;
      }
   default :
     res [0] = -1;
      free(op1); free(op2);
      return res;
    }
}

/***************************************************************************/
PTR_BFND duplicateStmts(body)
     PTR_BFND body;
{
 PTR_BFND copie, last, temp, cherche, lastnode;
 int lenght,i,j;
 PTR_BFND *alloue;
 PTR_BLOB blobtemp;
 PTR_LABEL *label_insection;
 PTR_LABEL lab;
 int maxlabelname;

 if (! body) return NULL;
  /* on calcul d'abord la longueur */

 maxlabelname = getLastLabelId();
 
 lenght = 0;
 for (temp = body; temp ; temp = BIF_NEXT(temp))
   {
     lenght++;
     lastnode = temp;     
   }
 alloue = (PTR_BFND *) xmalloc(2*lenght * sizeof(PTR_BFND));
 memset((char *) alloue, 0, 2* lenght * sizeof(PTR_BFND));
 
 /* label part, we record label */
 label_insection = (PTR_LABEL *) xmalloc(2*lenght * sizeof(PTR_LABEL));
 memset((char *) label_insection, 0, 2* lenght * sizeof(PTR_LABEL)); 
 temp = body;
 last = NULL;
 for (i = 0; i < lenght; i++)
   {
      copie = (PTR_BFND) newNode (BIF_CODE (temp));
      BIF_SYMB (copie) = BIF_SYMB (temp);
      BIF_LL1 (copie) = copyLlNode(BIF_LL1 (temp));
      BIF_LL2 (copie) = copyLlNode(BIF_LL2 (temp));
      BIF_LL3 (copie) = copyLlNode(BIF_LL3 (temp));
      BIF_DECL_SPECS (copie) = BIF_DECL_SPECS(temp);
      if (last)
        BIF_NEXT(last) = copie;

     
      if (BIF_LABEL(temp))/* && (LABEL_BODY(BIF_LABEL(temp)) == temp))*/
	{
	  /* create a new label */
	  label_insection[2*i+1] = (PTR_LABEL) newNode(LABEL_KIND); 
	  maxlabelname++;
	  LABEL_STMTNO(label_insection[2*i+1]) = maxlabelname;
	  LABEL_BODY(label_insection[2*i+1]) = copie;
	  LABEL_USED(label_insection[2*i+1]) = LABEL_USED(BIF_LABEL(temp));
	  LABEL_ILLEGAL(label_insection[2*i+1])=LABEL_ILLEGAL(BIF_LABEL(temp));
	  LABEL_DEFINED(label_insection[2*i+1])=LABEL_DEFINED(BIF_LABEL(temp));
	  BIF_LABEL(copie) = label_insection[2*i+1];
	  label_insection[2*i] = BIF_LABEL(temp);
	} 	  

      /* on fait corresponde temp et copie */
      alloue[2*i] = temp;
      alloue[2*i+1] = copie;
      temp = BIF_NEXT(temp);
      last = copie;
   }

 /* On met a jour les labels */
 temp = body;
 for (i = 0; i < lenght; i++)
   {
     int cas;
     copie = alloue[2*i+1]; 
     lab = NULL;
     
     /* We treat first the COMGOTO_NODE first */
     if (BIF_CODE(temp) == COMGOTO_NODE)
       {
         PTR_LLND listlab, ptl;
         int trouve = 0;	
         
         listlab = BIF_LL1(copie);
         while (listlab)
           {
             ptl = NODE_OPERAND0(listlab);
             /* we look in the list */
             if (ptl)
               {                
                 lab = NODE_LABEL(ptl);
                 trouve = 0;	 
                 for (j = 0; j < lenght; j++)
                   {
                     if (label_insection[2*j])
                       if (LABEL_STMTNO(label_insection[2*j]) == LABEL_STMTNO(lab))
                         {
                           trouve = j+1;
                           break;
                         }
                   }
                 if(trouve)
                   {
                     NODE_LABEL(ptl) =  label_insection[2*(trouve-1)+1];
                   }
               }
             listlab = NODE_OPERAND1(listlab);             
           }
         temp = BIF_NEXT(temp);
         continue;         
       }
     
         
     if (BIF_LL3(temp) && (NODE_CODE(BIF_LL3(temp)) == LABEL_REF))
       {
	 lab = NODE_LABEL(BIF_LL3(temp));
	 cas = 2;	
       }
     else
       {
	 lab = BIF_LABEL_USE(temp);
	 cas = 1;
       }
     if (lab)
       { /* look where the label is the label is defined somewhere */
	 int trouve = 0;	 
	 for (j = 0; j < lenght; j++)
	   {
	     if (label_insection[2*j])
	       if (LABEL_STMTNO(label_insection[2*j]) == LABEL_STMTNO(lab))
		 {
		   trouve = j+1;
		   break;
		 }
	   }
	 if(trouve)
	   {
	     if (cas == 1)
	       {
		 BIF_LABEL_USE(copie) = label_insection[2*(trouve-1)+1];
	       }
	     if (cas == 2)
	       {
		 if (BIF_LL3(copie))
		   {
		     NODE_LABEL(BIF_LL3(copie)) = label_insection[2*(trouve-1)+1];
		   }
	       }
	   } else
	     {
	       if (cas == 1)
		 BIF_LABEL_USE(copie) = lab; /* outside */
	       /* if ((cas == 2) no change */
	     }
       }
     temp = BIF_NEXT(temp);
   }
 
 /* on met a jour le blob list */
 copie = alloue[1];
 for (temp = body; temp ; temp = BIF_NEXT(temp))
   {
     if (BIF_BLOB1(temp))
       { /* on doit cree la blob liste */
         for (blobtemp = BIF_BLOB1(temp);blobtemp; 
              blobtemp = BLOB_NEXT(blobtemp)) 
           {
             /* on cherche la reference dans le tableaux allouer */
             cherche = NULL;
             for (i = 0; i <lenght ; i++)
               {
                 if (alloue[2*i] == BLOB_VALUE(blobtemp))
                     {
                       cherche = alloue[2*i+1];
                       break;
                     }
               }
             appendBfndToList1(cherche, copie);
           }
       }
     if (BIF_BLOB2(temp))
       { /* on doit cree la blob liste */
         for (blobtemp = BIF_BLOB2(temp);blobtemp; 
              blobtemp = BLOB_NEXT(blobtemp)) 
           {
             /* on cherche la reference dans le tableaux allouer */
             cherche = NULL;
             for (i = 0; i <lenght ; i++)
               {
                 if (alloue[2*i] == BLOB_VALUE(blobtemp))
                     {
                       cherche = alloue[2*i+1];
                       break;
                     }
               }
             appendBfndToList2(cherche, copie);
           }
       }
     copie = BIF_NEXT(copie);
   }

 /* on remet ici a jour les CP */
 copie = alloue[1];
 for (temp = body; temp ; temp = BIF_NEXT(temp))
   {
     if (isItInSection(body, lastnode, BIF_CP(temp)))
       { /* on cherche le bif_cp pour la copie */
         cherche = NULL;
         for (i = 0; i <lenght ; i++)
           {
             if (alloue[2*i] == BIF_CP(temp))
               {
                 cherche = alloue[2*i+1];
                 break;
               }
           }
         BIF_CP(copie) = cherche;
       }
     copie = BIF_NEXT(copie);
   }
 copie = alloue[1];
 free(alloue);
 free(label_insection);
 return copie;
}

/************************************** New version, does not need extract **************/
/********************************* only copies a statement and the children *************/
PTR_BFND duplicateStmtsNoExtract(body)
     PTR_BFND body;
{
 PTR_BFND copie, last, temp, cherche, lastnode;
 int lenght,i,j;
 PTR_BFND *alloue;
 PTR_BLOB blobtemp;
 PTR_LABEL *label_insection;
 PTR_LABEL lab;
 int maxlabelname;

 if (! body) return NULL;
  /* on calcul d'abord la longueur */

 maxlabelname = getLastLabelId();

 lastnode = getLastNodeOfStmt(body);
 
 lenght = 0;
 for (temp = body; temp ; temp = BIF_NEXT(temp))
   {
     lenght++;
     if (lastnode == temp)
       break;
   }
 alloue = (PTR_BFND *) xmalloc(2*lenght * sizeof(PTR_BFND));
 memset((char *) alloue, 0, 2* lenght * sizeof(PTR_BFND));
 
 /* label part, we record label */
 label_insection = (PTR_LABEL *) xmalloc(2*lenght * sizeof(PTR_LABEL));
 memset((char *) label_insection, 0, 2* lenght * sizeof(PTR_LABEL)); 
 temp = body;
 last = NULL;
 for (i = 0; i < lenght; i++)
   {
      copie = (PTR_BFND) newNode (BIF_CODE (temp));
      BIF_SYMB (copie) = BIF_SYMB (temp);
      BIF_LL1 (copie) = copyLlNode(BIF_LL1 (temp));
      BIF_LL2 (copie) = copyLlNode(BIF_LL2 (temp));
      BIF_LL3 (copie) = copyLlNode(BIF_LL3 (temp));
      if (last)
        BIF_NEXT(last) = copie;

     
      if (BIF_LABEL(temp))/* && (LABEL_BODY(BIF_LABEL(temp)) == temp))*/
	{
	  /* create a new label */
	  label_insection[2*i+1] = (PTR_LABEL) newNode(LABEL_KIND); 
	  maxlabelname++;
	  LABEL_STMTNO(label_insection[2*i+1]) = maxlabelname;
	  LABEL_BODY(label_insection[2*i+1]) = copie;
	  LABEL_USED(label_insection[2*i+1]) = LABEL_USED(BIF_LABEL(temp));
	  LABEL_ILLEGAL(label_insection[2*i+1])=LABEL_ILLEGAL(BIF_LABEL(temp));
	  LABEL_DEFINED(label_insection[2*i+1])=LABEL_DEFINED(BIF_LABEL(temp));
	  BIF_LABEL(copie) = label_insection[2*i+1];
	  label_insection[2*i] = BIF_LABEL(temp);
	} 	  

      /* on fait corresponde temp et copie */
      alloue[2*i] = temp;
      alloue[2*i+1] = copie;
      temp = BIF_NEXT(temp);
      last = copie;
   }

 /* On met a jour les labels */
 temp = body;
 for (i = 0; i < lenght; i++)
   {
     int cas;
     copie = alloue[2*i+1]; 
     lab = NULL;
     
     /* We treat first the COMGOTO_NODE first */
     if (BIF_CODE(temp) == COMGOTO_NODE)
       {
         PTR_LLND listlab, ptl;
         int trouve = 0;	
         
         listlab = BIF_LL1(copie);
         while (listlab)
           {
             ptl = NODE_OPERAND0(listlab);
             /* we look in the list */
             if (ptl)
               {                
                 lab = NODE_LABEL(ptl);
                 trouve = 0;	 
                 for (j = 0; j < lenght; j++)
                   {
                     if (label_insection[2*j])
                       if (LABEL_STMTNO(label_insection[2*j]) == LABEL_STMTNO(lab))
                         {
                           trouve = j+1;
                           break;
                         }
                   }
                 if(trouve)
                   {
                     NODE_LABEL(ptl) =  label_insection[2*(trouve-1)+1];
                   }
               }
             listlab = NODE_OPERAND1(listlab);             
           }
         temp = BIF_NEXT(temp);
         continue;         
       }
     
         
     if (BIF_LL3(temp) && (NODE_CODE(BIF_LL3(temp)) == LABEL_REF))
       {
	 lab = NODE_LABEL(BIF_LL3(temp));
	 cas = 2;	
       }
     else
       {
	 lab = BIF_LABEL_USE(temp);
	 cas = 1;
       }
     if (lab)
       { /* look where the label is the label is defined somewhere */
	 int trouve = 0;	 
	 for (j = 0; j < lenght; j++)
	   {
	     if (label_insection[2*j])
	       if (LABEL_STMTNO(label_insection[2*j]) == LABEL_STMTNO(lab))
		 {
		   trouve = j+1;
		   break;
		 }
	   }
	 if(trouve)
	   {
	     if (cas == 1)
	       {
		 BIF_LABEL_USE(copie) = label_insection[2*(trouve-1)+1];
	       }
	     if (cas == 2)
	       {
		 if (BIF_LL3(copie))
		   {
		     NODE_LABEL(BIF_LL3(copie)) = label_insection[2*(trouve-1)+1];
		   }
	       }
	   } else
	     {
	       if (cas == 1)
		 BIF_LABEL_USE(copie) = lab; /* outside */
	       /* if ((cas == 2) no change */
	     }
       }
     temp = BIF_NEXT(temp);
   }
 
 /* on met a jour le blob list */
 copie = alloue[1];
 for (temp = body; temp ; temp = BIF_NEXT(temp))
   {
     if (BIF_BLOB1(temp))
       { /* on doit cree la blob liste */
         for (blobtemp = BIF_BLOB1(temp);blobtemp; 
              blobtemp = BLOB_NEXT(blobtemp)) 
           {
             /* on cherche la reference dans le tableaux allouer */
             cherche = NULL;
             for (i = 0; i <lenght ; i++)
               {
                 if (alloue[2*i] == BLOB_VALUE(blobtemp))
                     {
                       cherche = alloue[2*i+1];
                       break;
                     }
               }
             appendBfndToList1(cherche, copie);
           }
       }
     if (BIF_BLOB2(temp))
       { /* on doit cree la blob liste */
         for (blobtemp = BIF_BLOB2(temp);blobtemp; 
              blobtemp = BLOB_NEXT(blobtemp)) 
           {
             /* on cherche la reference dans le tableaux allouer */
             cherche = NULL;
             for (i = 0; i <lenght ; i++)
               {
                 if (alloue[2*i] == BLOB_VALUE(blobtemp))
                     {
                       cherche = alloue[2*i+1];
                       break;
                     }
               }
             appendBfndToList2(cherche, copie);
           }
       }
     copie = BIF_NEXT(copie);
     if (temp == lastnode)
       break;
   }

 /* on remet ici a jour les CP */
 copie = alloue[1];
 for (temp = body; temp ; temp = BIF_NEXT(temp))
   {
     if (isItInSection(body, lastnode, BIF_CP(temp)))
       { /* on cherche le bif_cp pour la copie */
         cherche = NULL;
         for (i = 0; i <lenght ; i++)
           {
             if (alloue[2*i] == BIF_CP(temp))
               {
                 cherche = alloue[2*i+1];
                 break;
               }
           }
         BIF_CP(copie) = cherche;
       } else
         BIF_CP(copie) = NULL;
     copie = BIF_NEXT(copie);
     if (temp == lastnode)
       break;
   }
 copie = alloue[1];
 free(alloue);
 free(label_insection);
 return copie;
}



/* (ajm)
   This function will copy one statement and all of its children 
   (presumably; I didn't touch that one way or the other). 

   It differs from low_level.c:duplicateStmt (v1.00) in that does not 
   copy all of the BIF_NEXT successors of the statement as well.

*/

/***************************************************************************/
PTR_BFND duplicateOneStmt(body)
     PTR_BFND body;
{
 PTR_BFND copie, last, temp, cherche, lastnode;
 int lenght,i,j;
 PTR_BFND *alloue;
 PTR_BLOB blobtemp;
 PTR_LABEL *label_insection;
 PTR_LABEL lab;
 int maxlabelname;

 if (! body) return NULL;
  /* on calcul d'abord la longueur */

 maxlabelname = getLastLabelId();
 
 lenght = 0;
/* Changed area, by ajm 1-Feb-94 */
#if 0
 for (temp = body; temp ; temp = BIF_NEXT(temp))
   {
     lenght++;
     lastnode = temp;     
   }
#else
 if ( body != 0 )
 {
      lenght = 1;
 }
#endif /* ajm */

 alloue = (PTR_BFND *) xmalloc(2*lenght * sizeof(PTR_BFND));
 memset((char *) alloue, 0, 2* lenght * sizeof(PTR_BFND));
 
 /* label part, we record label */
 label_insection = (PTR_LABEL *) xmalloc(2*lenght * sizeof(PTR_LABEL));
 memset((char *) label_insection, 0, 2* lenght * sizeof(PTR_LABEL)); 
 temp = body;
 last = NULL;
 for (i = 0; i < lenght; i++)
   {
      copie = (PTR_BFND) newNode (BIF_CODE (temp));
      BIF_SYMB (copie) = BIF_SYMB (temp);
      BIF_LL1 (copie) = copyLlNode(BIF_LL1 (temp));
      BIF_LL2 (copie) = copyLlNode(BIF_LL2 (temp));
      BIF_LL3 (copie) = copyLlNode(BIF_LL3 (temp));
      BIF_DECL_SPECS (copie) = BIF_DECL_SPECS(temp);

      if (last)
        BIF_NEXT(last) = copie;

     
      if (BIF_LABEL(temp))/* && (LABEL_BODY(BIF_LABEL(temp)) == temp))*/
	{
	  /* create a new label */
	  label_insection[2*i+1] = (PTR_LABEL) newNode(LABEL_KIND); 
	  maxlabelname++;
	  LABEL_STMTNO(label_insection[2*i+1]) = maxlabelname;
	  LABEL_BODY(label_insection[2*i+1]) == copie;
	  LABEL_USED(label_insection[2*i+1]) = LABEL_USED(BIF_LABEL(temp));
	  LABEL_ILLEGAL(label_insection[2*i+1])=LABEL_ILLEGAL(BIF_LABEL(temp));
	  LABEL_DEFINED(label_insection[2*i+1])=LABEL_DEFINED(BIF_LABEL(temp));
	  BIF_LABEL(copie) = label_insection[2*i+1];
	  label_insection[2*i] = BIF_LABEL(temp);
	} 	  

      /* on fait corresponde temp et copie */
      alloue[2*i] = temp;
      alloue[2*i+1] = copie;
      temp = BIF_NEXT(temp);
      last = copie;
   }

 /* On met a jour les labels */
 temp = body;
 for (i = 0; i < lenght; i++)
   {
     int cas;
     copie = alloue[2*i+1]; 
     lab = NULL;
     
     /* We treat first the COMGOTO_NODE first */
     if (BIF_CODE(temp) == COMGOTO_NODE)
       {
         PTR_LLND listlab, ptl;
         int trouve = 0;	
         
         listlab = BIF_LL1(copie);
         while (listlab)
           {
             ptl = NODE_OPERAND0(listlab);
             /* we look in the list */
             if (ptl)
               {                
                 lab = NODE_LABEL(ptl);
                 trouve = 0;	 
                 for (j = 0; j < lenght; j++)
                   {
                     if (label_insection[2*j])
                       if (LABEL_STMTNO(label_insection[2*j]) == LABEL_STMTNO(lab))
                         {
                           trouve = j+1;
                           break;
                         }
                   }
                 if(trouve)
                   {
                     NODE_LABEL(ptl) =  label_insection[2*(trouve-1)+1];
                   }
               }
             listlab = NODE_OPERAND1(listlab);             
           }
         temp = BIF_NEXT(temp);
         continue;         
       }
     
         
     if (BIF_LL3(temp) && (NODE_CODE(BIF_LL3(temp)) == LABEL_REF))
       {
	 lab = NODE_LABEL(BIF_LL3(temp));
	 cas = 2;	
       }
     else
       {
	 lab = BIF_LABEL_USE(temp);
	 cas = 1;
       }
     if (lab)
       { /* look where the label is the label is defined somewhere */
	 int trouve = 0;	 
	 for (j = 0; j < lenght; j++)
	   {
	     if (label_insection[2*j])
	       if (LABEL_STMTNO(label_insection[2*j]) == LABEL_STMTNO(lab))
		 {
		   trouve = j+1;
		   break;
		 }
	   }
	 if(trouve)
	   {
	     if (cas == 1)
	       {
		 BIF_LABEL_USE(copie) = label_insection[2*(trouve-1)+1];
	       }
	     if (cas == 2)
	       {
		 if (BIF_LL3(copie))
		   {
		     NODE_LABEL(BIF_LL3(copie)) = label_insection[2*(trouve-1)+1];
		   }
	       }
	   } else
	     {
	       if (cas == 1)
		 BIF_LABEL_USE(copie) = lab; /* outside */
	       /* if ((cas == 2) no change */
	     }
       }
     temp = BIF_NEXT(temp);
   }
 
 /* on met a jour le blob list */
 copie = alloue[1];
/* Change by ajm */
#if 0
   for (temp = body; temp ; temp = BIF_NEXT(temp))
#else
   for (temp = body; temp ; temp = 0 /* not BIF_NEXT(temp)!! */ )
#endif
   {
     if (BIF_BLOB1(temp))
       { /* on doit cree la blob liste */
         for (blobtemp = BIF_BLOB1(temp);blobtemp; 
              blobtemp = BLOB_NEXT(blobtemp)) 
           {
             /* on cherche la reference dans le tableaux allouer */
             cherche = NULL;
             for (i = 0; i <lenght ; i++)
               {
                 if (alloue[2*i] == BLOB_VALUE(blobtemp))
                     {
                       cherche = alloue[2*i+1];
                       break;
                     }
               }
             appendBfndToList1(cherche, copie);
           }
       }
     if (BIF_BLOB2(temp))
       { /* on doit cree la blob liste */
         for (blobtemp = BIF_BLOB2(temp);blobtemp; 
              blobtemp = BLOB_NEXT(blobtemp)) 
           {
             /* on cherche la reference dans le tableaux allouer */
             cherche = NULL;
             for (i = 0; i <lenght ; i++)
               {
                 if (alloue[2*i] == BLOB_VALUE(blobtemp))
                     {
                       cherche = alloue[2*i+1];
                       break;
                     }
               }
             appendBfndToList2(cherche, copie);
           }
       }
     copie = BIF_NEXT(copie);
   }

 /* on remet ici a jour les CP */
 copie = alloue[1];

/* Change by ajm */
#if 0
   for (temp = body; temp ; temp = BIF_NEXT(temp))
#else
   for (temp = body; temp ; temp = 0 /* not BIF_NEXT(temp)!! */ )
#endif
   {
     if (isItInSection(body, lastnode, BIF_CP(temp)))
       { /* on cherche le bif_cp pour la copie */
         cherche = NULL;
         for (i = 0; i <lenght ; i++)
           {
             if (alloue[2*i] == BIF_CP(temp))
               {
                 cherche = alloue[2*i+1];
                 break;
               }
           }
         BIF_CP(copie) = cherche;
       }
     copie = BIF_NEXT(copie);
   }
 copie = alloue[1];
 free(alloue);
 free(label_insection);
 return copie;
}

/* BW, june 1994
   This function will copy all the remaining statements in the block to which
   the given statement belongs (and all of its children) including the given statement 

   It is yet another variation on duplicateStmts and duplicateOneStmt. It
   is not "fundamentally right" because it does not reproduce the "top-level" blob
   structure of the block being copied (but it does reproduce the internal 
   blob structure). 
   As a result, calling duplicateStmtsBlock with an argument that is itself a result 
   of duplicateStmtsBlock will not work.

*/

/***************************************************************************/
PTR_BFND duplicateStmtsBlock(body)
     PTR_BFND body;
{
 PTR_BFND copie, last, temp, cherche, lastnode;
 int lenght,i,j;
 PTR_BFND *alloue;
 PTR_BLOB blobtemp;
 PTR_LABEL *label_insection;
 PTR_LABEL lab;
 int maxlabelname;
 PTR_BLOB blob;
 int iii;

 if (! body) return NULL;
  /* on calcul d'abord la longueur */

 maxlabelname = getLastLabelId();
 
 lenght = 0;

/* need to find the correct blob chain and then count how many bif nodes we want to copy */
  if (!BIF_CP(body))
    {
     Message("Error in duplicateStmtsBlock, can't find control parent", 0);
     exit(0);
    }
  else
    {
      blob = lookForBifInBlobList(BIF_BLOB1(BIF_CP(body)), body);
      if (!blob)
        blob = lookForBifInBlobList(BIF_BLOB2(BIF_CP(body)), body);
      if (!blob)
        {
         Message("Error in duplicateStmtsBlock, can't find the blob", 0);
         exit(0);
        }
    }

 lenght = numberOfBifsInBlobList(blob);

 for (temp = body, i = 0; i < lenght ; temp = BIF_NEXT(temp), i++)
     lastnode = temp;     

 alloue = (PTR_BFND *) xmalloc(2*lenght * sizeof(PTR_BFND));
 memset((char *) alloue, 0, 2* lenght * sizeof(PTR_BFND));
 
 /* label part, we record label */
 label_insection = (PTR_LABEL *) xmalloc(2*lenght * sizeof(PTR_LABEL));
 memset((char *) label_insection, 0, 2* lenght * sizeof(PTR_LABEL)); 
 temp = body;
 last = NULL;
 for (i = 0; i < lenght; i++)
   {
      copie = (PTR_BFND) newNode (BIF_CODE (temp));
      BIF_SYMB (copie) = BIF_SYMB (temp);
      BIF_LL1 (copie) = copyLlNode(BIF_LL1 (temp));
      BIF_LL2 (copie) = copyLlNode(BIF_LL2 (temp));
      BIF_LL3 (copie) = copyLlNode(BIF_LL3 (temp));
      BIF_DECL_SPECS (copie) = BIF_DECL_SPECS(temp);

      if (last)
        BIF_NEXT(last) = copie;

     
      if (BIF_LABEL(temp))/* && (LABEL_BODY(BIF_LABEL(temp)) == temp))*/
	{
	  /* create a new label */
	  label_insection[2*i+1] = (PTR_LABEL) newNode(LABEL_KIND); 
	  maxlabelname++;
	  LABEL_STMTNO(label_insection[2*i+1]) = maxlabelname;
	  LABEL_BODY(label_insection[2*i+1]) = copie;
	  LABEL_USED(label_insection[2*i+1]) = LABEL_USED(BIF_LABEL(temp));
	  LABEL_ILLEGAL(label_insection[2*i+1])=LABEL_ILLEGAL(BIF_LABEL(temp));
	  LABEL_DEFINED(label_insection[2*i+1])=LABEL_DEFINED(BIF_LABEL(temp));
	  BIF_LABEL(copie) = label_insection[2*i+1];
	  label_insection[2*i] = BIF_LABEL(temp);
	} 	  

      /* on fait corresponde temp et copie */
      alloue[2*i] = temp;
      alloue[2*i+1] = copie;
      temp = BIF_NEXT(temp);
      last = copie;
   }

 /* On met a jour les labels */
 temp = body;
 for (i = 0; i < lenght; i++)
   {
     int cas;
     copie = alloue[2*i+1]; 
     lab = NULL;
     
     /* We treat first the COMGOTO_NODE first */
     if (BIF_CODE(temp) == COMGOTO_NODE)
       {
         PTR_LLND listlab, ptl;
         int trouve = 0;	
         
         listlab = BIF_LL1(copie);
         while (listlab)
           {
             ptl = NODE_OPERAND0(listlab);
             /* we look in the list */
             if (ptl)
               {                
                 lab = NODE_LABEL(ptl);
                 trouve = 0;	 
                 for (j = 0; j < lenght; j++)
                   {
                     if (label_insection[2*j])
                       if (LABEL_STMTNO(label_insection[2*j]) == LABEL_STMTNO(lab))
                         {
                           trouve = j+1;
                           break;
                         }
                   }
                 if(trouve)
                   {
                     NODE_LABEL(ptl) =  label_insection[2*(trouve-1)+1];
                   }
               }
             listlab = NODE_OPERAND1(listlab);             
           }
         temp = BIF_NEXT(temp);
         continue;         
       }
     
         
     if (BIF_LL3(temp) && (NODE_CODE(BIF_LL3(temp)) == LABEL_REF))
       {
	 lab = NODE_LABEL(BIF_LL3(temp));
	 cas = 2;	
       }
     else
       {
	 lab = BIF_LABEL_USE(temp);
	 cas = 1;
       }
     if (lab)
       { /* look where the label is the label is defined somewhere */
	 int trouve = 0;	 
	 for (j = 0; j < lenght; j++)
	   {
	     if (label_insection[2*j])
	       if (LABEL_STMTNO(label_insection[2*j]) == LABEL_STMTNO(lab))
		 {
		   trouve = j+1;
		   break;
		 }
	   }
	 if(trouve)
	   {
	     if (cas == 1)
	       {
		 BIF_LABEL_USE(copie) = label_insection[2*(trouve-1)+1];
	       }
	     if (cas == 2)
	       {
		 if (BIF_LL3(copie))
		   {
		     NODE_LABEL(BIF_LL3(copie)) = label_insection[2*(trouve-1)+1];
		   }
	       }
	   } else
	     {
	       if (cas == 1)
		 BIF_LABEL_USE(copie) = lab; /* outside */
	       /* if ((cas == 2) no change */
	     }
       }
     temp = BIF_NEXT(temp);
   }
 
 /* on met a jour le blob list */
 copie = alloue[1];
 for (temp = body, iii = 0; iii <lenght ; temp = BIF_NEXT(temp), iii++)
   {
     if (BIF_BLOB1(temp))
       { /* on doit cree la blob liste */
         for (blobtemp = BIF_BLOB1(temp);blobtemp; 
              blobtemp = BLOB_NEXT(blobtemp)) 
           {
             /* on cherche la reference dans le tableaux allouer */
             cherche = NULL;
             for (i = 0; i <lenght ; i++)
               {
                 if (alloue[2*i] == BLOB_VALUE(blobtemp))
                     {
                       cherche = alloue[2*i+1];
                       break;
                     }
               }
             appendBfndToList1(cherche, copie);
           }
       }
     if (BIF_BLOB2(temp))
       { /* on doit cree la blob liste */
         for (blobtemp = BIF_BLOB2(temp);blobtemp; 
              blobtemp = BLOB_NEXT(blobtemp)) 
           {
             /* on cherche la reference dans le tableaux allouer */
             cherche = NULL;
             for (i = 0; i <lenght ; i++)
               {
                 if (alloue[2*i] == BLOB_VALUE(blobtemp))
                     {
                       cherche = alloue[2*i+1];
                       break;
                     }
               }
             appendBfndToList2(cherche, copie);
           }
       }
     copie = BIF_NEXT(copie);
   }

 /* on remet ici a jour les CP */
 copie = alloue[1];
 for (temp = body, iii = 0; iii < lenght ; temp = BIF_NEXT(temp), iii++)
   {
     if (isItInSection(body, lastnode, BIF_CP(temp)))
       { /* on cherche le bif_cp pour la copie */
         cherche = NULL;
         for (i = 0; i <lenght ; i++)
           {
             if (alloue[2*i] == BIF_CP(temp))
               {
                 cherche = alloue[2*i+1];
                 break;
               }
           }
         BIF_CP(copie) = cherche;
       }
     copie = BIF_NEXT(copie);
   }
 copie = alloue[1];
 free(alloue);
 free(label_insection);
 return copie;
}
   
/***************************************************************************/
PTR_BFND getFunctionHeader(symb)
     PTR_SYMB symb;
{
  PTR_BFND thebif;
  if ((SYMB_CODE(symb) != FUNCTION_NAME) &&
      (SYMB_CODE(symb) != PROCESS_NAME) &&
      (SYMB_CODE(symb) != PROCEDURE_NAME))
    return NULL;

/*  if (SYMB_FUNC_HEDR(symb))
    return SYMB_FUNC_HEDR(symb); */

  thebif = PROJ_FIRST_BIF();
  for (;thebif;thebif=BIF_NEXT(thebif)) 
    {
      if (((BIF_CODE(thebif) == FUNC_HEDR)  ||
           (BIF_CODE(thebif) == PROC_HEDR)  || 
           (BIF_CODE(thebif) == PROS_HEDR)  || 
           (BIF_CODE(thebif) == PROG_HEDR))
          &&
          (BIF_SYMB(thebif) == symb))
        return thebif;
    }
  return NULL;
}

/******* same as getFunctionHeader but looks in all the files *******/

PTR_BFND getFunctionHeaderAllFile(symb)
     PTR_SYMB symb;
{
  PTR_FILE ptf, saveptf;
  PTR_BLOB ptb;
  PTR_BFND tmp;

  if ((SYMB_CODE(symb) != FUNCTION_NAME) &&
      (SYMB_CODE(symb) != PROCESS_NAME) &&
      (SYMB_CODE(symb) != PROCEDURE_NAME))
    return NULL;
  
  /* look in currentfile first*/
  tmp = getFunctionHeader(symb);
  if (tmp)
    {
      return tmp;
    }

  saveptf = pointer_on_file_proj;
  /* have to look in the bif list   return SYMB_FUNC_HEDR(symb); seens not to be set */
  
  for (ptb = PROJ_FILE_CHAIN (cur_proj); ptb ; ptb =  BLOB_NEXT (ptb))
    {
      ptf = (PTR_FILE) BLOB_VALUE (ptb);
      cur_file = ptf;      
      /* reset the toolbox and pointers*/
      Init_Tool_Box();
      tmp = getFunctionHeader(symb);
      if (tmp)
        {
          /* reset the pointers */
          cur_file = saveptf;
          Init_Tool_Box();
          return tmp;
        }
    }
  cur_file = saveptf;
  Init_Tool_Box();
  return NULL;
}
     
/***************************************************************************/
PTR_BFND getGlobalFunctionHeader(name)
     char *name;
{
  PTR_SYMB tsymb;
  PTR_FILE ptf;
  PTR_BLOB ptb;
  PTR_BFND tmp;
  

  for (ptb = PROJ_FILE_CHAIN (cur_proj); ptb ; ptb =  BLOB_NEXT (ptb))
    {
      ptf = (PTR_FILE) BLOB_VALUE (ptb);
      cur_file = ptf;      
      /* reset the toolbox and pointers*/
      Init_Tool_Box();
      
      for (tsymb = PROJ_FIRST_SYMB() ; tsymb; tsymb = SYMB_NEXT(tsymb))
        {
          if ( SYMB_IDENT(tsymb) && (strcmp (name, SYMB_IDENT(tsymb)) == 0)
              && ((SYMB_CODE(tsymb) == FUNCTION_NAME) ||
                  (SYMB_CODE(tsymb) == PROCESS_NAME) ||
                  (SYMB_CODE(tsymb) == PROCEDURE_NAME)))
            {
              tmp = getFunctionHeader(tsymb);
              if (tmp)
                return tmp;
            }
        }
    }
  return NULL;
}


/* return true if declare in the function or global */
/***************************************************************************/
int inScope(header, symb)
     PTR_BFND header;
     PTR_SYMB symb;
{
  PTR_BFND temp;

  if (!SYMB_SCOPE(symb))
     return FALSE;

  if (BIF_CODE(SYMB_SCOPE(symb)) == GLOBAL)
    return TRUE;

  temp = SYMB_SCOPE(symb);
  while (temp)
    {
      if (temp == header)
	return TRUE;
      temp = BIF_CP(temp);
    }
  return FALSE;
}

/* return return FUNC_HEDR or Global*/
/***************************************************************************/
PTR_BFND getFuncScope(header)
     PTR_BFND header;
{
  PTR_BFND temp;
  
  if (!header)
    return NULL;

  if (BIF_CODE(header) == GLOBAL)
    return header;
  if (BIF_CODE(header) == FUNC_HEDR)
    return header;
  return getFuncScope(BIF_CP(header));
}

/***************************************************************************/
int localToFunction(header, symb)
     PTR_BFND header;
     PTR_SYMB symb;
{
  PTR_BFND temp;

  if (!SYMB_SCOPE(symb))
     return FALSE;

  if (BIF_CODE(SYMB_SCOPE(symb)) == GLOBAL)
    return FALSE;

  temp = SYMB_SCOPE(symb);
  if (temp == header)
    return FALSE;    /* this a parameter */
  while (temp)
    {
      if (temp == header)
	return TRUE;
      temp = BIF_CP(temp);
    }
  return FALSE;
}

/***************************************************************************/
int isInStmt(stmt,pt)
     PTR_BFND stmt,pt;
{
  if (!stmt || !pt)
    return FALSE;

 if (BIF_CODE(stmt) == GLOBAL)
    return TRUE;
  
  if (BIF_CODE(pt) == GLOBAL)
    return FALSE;

  if (stmt == BIF_CP(pt))
    return TRUE;

  return isInStmt(stmt,BIF_CP(pt));
}

/***************************************************************************/
int exprListLength(first)
PTR_LLND first;
{
  PTR_LLND tail;
  int len = 0;
  if (first == NULL)
    return(0);
  for (tail = first; tail; tail = NODE_OPERAND1(tail) )
    len++;
  return(len);
}

/****************************************************************
 *								*
 *   Get_ll_with_id  -- find the low level node in the current	*
 *		   active file with given id number		*
 *								*
 *   Input:							*
 *	id -- the low level node id number			*
 *								*
 *   Output:							*
 *	the corresponding low level node pointer if found	*
 *	nil otherwise						*
 *								*
 ****************************************************************/
/***************************************************************************/
PTR_LLND Get_ll_with_id(id)
    int id;
{
    PTR_LLND ll;

    for (ll = PROJ_FIRST_LLND (); ll ; ll = NODE_NEXT (ll))
	if (NODE_ID (ll) == id)
	    return ll;
    return NULL;
}

/***************************************************************************/
PTR_BFND Get_bif_with_id(id)
     int id;
{
  PTR_BFND bif;
  
  for (bif = PROJ_FIRST_BIF(); bif ; bif = BIF_NEXT (bif))
    if (BIF_ID (bif) == id)
      return bif;
  return NULL;
}

/***************************************************************************/
PTR_SYMB Get_Symb_with_id(id)
     int id;
{
  PTR_SYMB symb;
  
  for (symb = PROJ_FIRST_SYMB (); symb ; symb = SYMB_NEXT (symb))
    if (SYMB_ID (symb) == id)
      return symb;
  return NULL;
}

/***************************************************************************/
PTR_TYPE Get_type_with_id(id)
     int id;
     
{
  PTR_TYPE type;
  
  for (type = PROJ_FIRST_TYPE (); type ; type = TYPE_NEXT (type))
    if (TYPE_ID (type) == id)
      return type;
  return NULL;
}

/***************************************************************************/
PTR_LABEL Get_label_with_id(id)
     int id;
{
  PTR_LABEL label;
  
  for (label = PROJ_FIRST_LABEL (); label ; label = LABEL_NEXT (label))
    if (LABEL_ID (label) == id)
      return label;
  return NULL;
}

/***************************************************************************/
PTR_CMNT Get_cmnt_with_id(id)
     int id;
{
  PTR_CMNT comment;
  
  for (comment = PROJ_FIRST_CMNT (); comment ; comment = CMNT_NEXT (comment))
    if (CMNT_ID (comment) == id)
      return comment;
  return NULL;
}
   
/***************************************************************************/
int getLastLabelId()
{
  int maxlabelname;
  PTR_LABEL lab;
  
  maxlabelname = 0;
  for (lab = PROJ_FIRST_LABEL(); lab; lab = LABEL_NEXT(lab))
    {
      if (maxlabelname < LABEL_STMTNO(lab))
      {
	maxlabelname =  LABEL_STMTNO(lab);
       }
    }

  return maxlabelname;
}
   
 
/***************************************************************************/
PTR_LABEL getLastLabel()
{
  PTR_LABEL lab;
  
  for (lab = PROJ_FIRST_LABEL(); lab; lab = LABEL_NEXT(lab))
    {
      if  (!LABEL_NEXT(lab))
	return lab;
    }
  return NULL;
}
    
/***************************************************************************/
PTR_SYMB getSymbolWithName(name, scope)
     char *name;
     PTR_BFND scope;
{
  PTR_SYMB tsymb;
  PTR_BFND temp;
  
 for (tsymb = PROJ_FIRST_SYMB() ; tsymb; tsymb = SYMB_NEXT(tsymb))
   {
     if ( SYMB_IDENT(tsymb) && (strcmp (name, SYMB_IDENT(tsymb)) == 0))
       {
         /* we check the scope */
         temp = scope;         
         while (temp)
           {
             if (SYMB_SCOPE(tsymb) == temp)
                  return tsymb;
	     if (BIF_CODE(temp) != GLOBAL)
	       temp = BIF_CP(temp);
	     else
	       temp = NULL;
           }
       }
   }
  /* si non trouver on en recupere 1 */
  for (tsymb = PROJ_FIRST_SYMB() ; tsymb; tsymb = SYMB_NEXT(tsymb))
    {
       if ( SYMB_IDENT(tsymb) && (strcmp (name, SYMB_IDENT(tsymb)) == 0))
         {
           return tsymb;
         }
     }
  return NULL;
}


/***************************************************************************/
PTR_SYMB getSymbolWithNameInScope(name, scope)
     char *name;
     PTR_BFND scope;
{
  PTR_SYMB tsymb;
  PTR_BFND temp;
  
 for (tsymb = PROJ_FIRST_SYMB() ; tsymb; tsymb = SYMB_NEXT(tsymb))
   {
     if ( SYMB_IDENT(tsymb) && (strcmp (name, SYMB_IDENT(tsymb)) == 0))
       {
         /* we check the scope */
         if (scope)
           return tsymb;
         temp = scope;         
         while (temp)
           {
             if (SYMB_SCOPE(tsymb) == temp)
                  return tsymb;
	     if (BIF_CODE(temp) != GLOBAL)
	       temp = BIF_CP(temp);
	     else
	       temp = NULL;
           }
       }
   }
  return NULL;
}

/***************************************************************************/
int makeLinearExpr(exp,coef,symb,size, last)
     PTR_LLND exp;
     int *coef;
     PTR_SYMB *symb;
     int size;
     int *last;    
{
  return makeLinearExpr_Sign(exp,coef,symb,size, last,1,1);
}

/* initialy coeff are 0, return 1 if Ok, 0 if abort*/
/***************************************************************************/
int makeLinearExpr_Sign(exp,coef,symb,size, last,sign,factor)
     PTR_LLND exp;
     int *coef;
     PTR_SYMB *symb;
     int size;
     int *last;  
     int sign;     
     int factor;
{
  int code;
  int i, *res1,*res2;
  
  if (!exp)
    return TRUE;
  
  code = NODE_CODE(exp);
  switch (code)
    {
    case VAR_REF:
      for (i=0; i< size; i++)
        {
          if (NODE_SYMB(exp) == symb[i])
            {
              coef[i] = coef[i] + sign*factor;
              break;
            }
        }
      break;
    case SUBT_OP:
      makeLinearExpr_Sign(NODE_OPERAND0(exp),coef,symb,size,last,sign,factor);
      makeLinearExpr_Sign(NODE_OPERAND1(exp),coef,symb,size,last,-1*sign,factor);
      break;
    case ADD_OP:
      makeLinearExpr_Sign(NODE_OPERAND0(exp),coef,symb,size,last,sign,factor);
      makeLinearExpr_Sign(NODE_OPERAND1(exp),coef,symb,size,last,sign,factor);
      break;
    case MULT_OP:
      res1 = evaluateExpression (NODE_OPERAND0(exp));
      res2 = evaluateExpression (NODE_OPERAND1(exp));
      if ((res1[0] != -1) && (res2[0] != -1))
        {
          *last = *last + factor*sign*(res1[1]*res2[1]);
        } else
          {
            if (res1[0] != -1) 
              {
                /* la constante est le fils gauche */
                if (NODE_CODE(NODE_OPERAND1(exp)) != VAR_REF)
                  return  makeLinearExpr_Sign(NODE_OPERAND1(exp),coef,symb,size, last,sign,res1[1]*factor);
                for (i=0; i< size; i++)
                  {
                    if (NODE_SYMB(NODE_OPERAND1(exp)) == symb[i])
                      {
                        coef[i] = coef[i] + factor*sign*(res1[1]);
                        break;
                      }
                  }
              } else
                if (res2[0] != -1) 
                  {
                    /* la constante est le fils droit */
                    if (NODE_CODE(NODE_OPERAND0(exp)) != VAR_REF)
                      return  makeLinearExpr_Sign(NODE_OPERAND0(exp),coef,symb,size, last,sign,res2[1]*factor);

                    for (i=0; i< size; i++)
                      {
                        if (NODE_SYMB(NODE_OPERAND0(exp)) == symb[i])
                          {
                            coef[i] = coef[i] + factor*sign*(res2[1]);
                            break;
                          }
                      }
                  } else                    
                    return FALSE;
          }
      break;
    case INT_VAL:
      *last = *last + factor*sign*(NODE_INT_CST_LOW(exp));
      break;
    default:
      
      return FALSE;
    }
  return TRUE;
}


/***************************************************************************/
char* Get_Function_Name_For_Call(pt)
PTR_LLND pt;
{
  if (!pt)
    return NULL;

  if (NODE_CODE(pt) != FUNC_CALL)
    return NULL;
  if (NODE_SYMB(pt))
    return SYMB_IDENT(NODE_SYMB(pt));
  else
    return NULL;
}

/***************************************************************************/
PTR_BFND Get_Last_Node_Of_Project()
{
  PTR_BFND temp;

  for (temp = PROJ_FIRST_BIF();  temp;  temp = BIF_NEXT(temp))
    {
      if (!BIF_NEXT(temp))
	return temp;
    }
  return NULL;
}

/***************************************************************************/
PTR_LLND Follow_Llnd(ll,c)
PTR_LLND ll;
int c;
{
  PTR_LLND pt;
  if(c == 2)
    {
      pt = ll;
      while(pt)
	{
	  if (NODE_OPERAND1(pt) == NULL)
	    return pt;
	  pt = NODE_OPERAND1(pt);	  
	}
    } else
      {
        pt = ll;
        while(pt)
          {
            if (NODE_OPERAND1(pt) == NULL)
              return NODE_OPERAND0(pt);
            pt = NODE_OPERAND1(pt);	  
          }
      }
  return NULL;
}

/***************************************************************************/
PTR_LLND Follow_Llnd0(ll)
PTR_LLND ll;
{
  PTR_LLND pt;
  pt = ll;
  while(pt)
    {
      if (NODE_OPERAND0(pt) == NULL)
	return pt;
      pt = NODE_OPERAND0(pt);	  
    }
  return NULL;
}

/***************************************************************************/
PTR_LLND Get_Th_Parameter_For_Call(ptin,n)
     PTR_LLND ptin;
     int n;
{
  int i;
  PTR_LLND pt;
  pt = ptin;
  
  if (!pt)
    return NULL;

  if (NODE_CODE(pt) != FUNC_CALL)
    return NULL;

  if (!NODE_OPERAND0(pt))
    return NULL;

  pt = NODE_OPERAND0(pt); 
  
  if (!NODE_OPERAND0(pt))
    return NULL; /* the node is an expression list with only 
                    one node, an expression list */
  pt = NODE_OPERAND0(pt); 
  for (i = 0; (i < n) && pt; i++)
    {
      pt = NODE_OPERAND1 (pt);
    }
  
  if (pt)
    return NODE_OPERAND0(pt);
  else
     return NULL;
}

/* old function kept for the annotation part */
/***************************************************************************/
PTR_LLND Get_First_Parameter_For_Call(pt)
PTR_LLND pt;
{
  if (!pt)
    return NULL;

  if (NODE_CODE(pt) != FUNC_CALL)
    return NULL;

  if (!NODE_OPERAND0(pt))
    return NULL;
  pt = NODE_OPERAND0 (NODE_OPERAND0(pt));
  return pt;

}

/***************************************************************************/
PTR_LLND Get_Second_Parameter_For_Call(pt)
PTR_LLND pt;
{
  if (!pt)
    return NULL;

  if (NODE_CODE(pt) != FUNC_CALL)
    return NULL;

  if (!NODE_OPERAND0(pt))
    return NULL;

  pt = NODE_OPERAND1(NODE_OPERAND0(pt));
  if (!pt)
    return NULL;
  else
    return NODE_OPERAND0(pt);

}

/***************************************************************************/
int Is_String_Val_With_Val(expr,str)
     PTR_LLND expr;
     char *str;
{
  if (!str)
    return FALSE;
  if (!expr)
    return FALSE;

  if (NODE_CODE(expr) != STRING_VAL)
    return FALSE;

  if (strcmp(NODE_STRING_POINTER(expr),str) == 0)
    return TRUE;

    return FALSE;

}

/***************************************************************************/
int Replace_String_In_Expression(exprold, str, exprnew)
     char *str;
     PTR_LLND exprold, exprnew;
{
  if (!exprold || !exprnew)
    return ;

  if (Is_String_Val_With_Val(NODE_OPERAND0(exprold),str))
    NODE_OPERAND0(exprold) = exprnew;
  else
    Replace_String_In_Expression(NODE_OPERAND0(exprold), str, exprnew);
  
      
  if (Is_String_Val_With_Val(NODE_OPERAND1(exprold),str))
    NODE_OPERAND1(exprold) = exprnew;
  else
    Replace_String_In_Expression(NODE_OPERAND1(exprold), str, exprnew);
  
}

/* Originally coded by fbodin, but the code used K&R varargs conventions,
   I have rewritten the code to use ANSI conventions (phb) */
/***************************************************************************/
PTR_LLND Make_Function_Call(PTR_SYMB symb, PTR_TYPE type, int taille, ...)
{
  va_list p;
  PTR_LLND func_call, temp, op, last;
  int i; /* nb parametres*/  /* FRENCH! */
  
  /* Set pointer p to the very first variable argument in list */
  va_start(p,taille);

  func_call = newExpr(FUNC_CALL,type,NULL);
  NODE_SYMB(func_call) = symb;

  last = NULL;
  temp = NULL;
  
  /* Loop through remaining arguments, extracting them */
  for (i=1;i<=taille;i++)
    {
      /* Extract 3+ith argument (type PTR_LLND), inc arg pointer p */
      op = va_arg(p,PTR_LLND);
      temp = newExpr(EXPR_LIST,NULL,op,NULL);
      if (!last) 
        NODE_OPERAND0(func_call) = temp;
      else
        NODE_OPERAND1(last) = temp;
      last  = temp;      
    }
  va_end(p);
  return func_call;
}

/*******************************MISCELLANEOUS*******************************/
char* Remove_Carriage_Return(str)
char *str;
{
  int i =0;

  if (str == NULL)
    return NULL;

  while (str[i] != '\0')
    {
      if (str[i] == '\n')
	str[i] = ' ';
      i++;
    }
  return str;
}



/***************************************************************************/
int Apply_To_Bif(bif, f)
     PTR_BFND bif;
     int (*f)();
{
  PTR_BLOB blob;
  int resul;
  
  if (!bif)
    return FALSE;
  
  resul = f(bif);  

  for (blob = BIF_BLOB1 (bif); blob; blob = BLOB_NEXT (blob))
    {
      resul = resul |  Apply_To_Bif (BLOB_VALUE (blob), f);
    }
  
  for (blob = BIF_BLOB2 (bif); blob; blob = BLOB_NEXT (blob))
    {
      resul =  resul | Apply_To_Bif (BLOB_VALUE (blob), f);
    }
  return resul;
  
}

/* reset to null the bif_next */
/***************************************************************************/
void Reset_Bif_Next_Chain(start)
     PTR_BFND start;
{
  PTR_BLOB blob;

  if (!start)
    return ;
    
  BIF_NEXT(start) = NULL;

  for (blob = BIF_BLOB1(start); blob ; blob = BLOB_NEXT(blob))
    {
      Reset_Bif_Next_Chain(BLOB_VALUE(blob));
    }
  for (blob = BIF_BLOB2(start); blob ; blob = BLOB_NEXT(blob))
    {
       Reset_Bif_Next_Chain(BLOB_VALUE(blob));
    }
}

/***************************************************************************/
void Count_Bif_Next_Chain(start)
     PTR_BFND start;
{
  PTR_BLOB blob;

  if (!start)
    return;
    
  if (BIF_NEXT(start) == NULL)
    {
      CountNullBifNext++;
/*      Message("Bif_Next is Null", BIF_LINE(start));*/
      
    }

  for (blob = BIF_BLOB1(start); blob ; blob = BLOB_NEXT(blob))
    {
      Count_Bif_Next_Chain(BLOB_VALUE(blob));
    }
  for (blob = BIF_BLOB2(start); blob ; blob = BLOB_NEXT(blob))
    {
       Count_Bif_Next_Chain(BLOB_VALUE(blob));
    }
}

/* Redo the BIF_NEXT Field for the DATA base so it is correct in the data 
   return the last also reset the BIF_ID to be added to low level and call
   in init toolbax */
static idfirst = 1;
/***************************************************************************/
PTR_BFND Redo_Bif_Next_Chain_Internal(start)
     PTR_BFND start;
{
  PTR_BLOB blob;
  PTR_BFND last;

  if (!start)
    return NULL;
  
  BIF_ID(start) = idfirst;
  idfirst++;
  
  if (BIF_BLOB1(start))
    {
      BIF_NEXT(start) = BLOB_VALUE(BIF_BLOB1(start));
    }
  last = start;
  for (blob = BIF_BLOB1(start); blob ; blob = BLOB_NEXT(blob))
    {
      last = Redo_Bif_Next_Chain_Internal(BLOB_VALUE(blob));
      if (BLOB_NEXT(blob))
        BIF_NEXT(last) = BLOB_VALUE(BLOB_NEXT(blob));
      
      if (!last)
        last = BLOB_VALUE(blob);
    }

  if (last)
    {
      if (BIF_BLOB2(start))
        BIF_NEXT(last) = BLOB_VALUE(BIF_BLOB2(start));
    }
  for (blob = BIF_BLOB2(start); blob ; blob = BLOB_NEXT(blob))
    {
      last = Redo_Bif_Next_Chain_Internal(BLOB_VALUE(blob));
      if (BLOB_NEXT(blob))
        BIF_NEXT(last) = BLOB_VALUE(BLOB_NEXT(blob));
      if (!last)
        last = BLOB_VALUE(blob);
    }
  return last;
}


/***************************************************************************/
PTR_BFND LocalRedoBifNextChain(start)
     PTR_BFND start;
{
  PTR_BLOB blob;
  PTR_BFND last;

  if (!start)
    return NULL;  
  if (BIF_BLOB1(start))
    {
      BIF_NEXT(start) = BLOB_VALUE(BIF_BLOB1(start));
    }
  last = start;
  for (blob = BIF_BLOB1(start); blob ; blob = BLOB_NEXT(blob))
    {
      last = LocalRedoBifNextChain(BLOB_VALUE(blob));
      if (BLOB_NEXT(blob))
        BIF_NEXT(last) = BLOB_VALUE(BLOB_NEXT(blob));
      
      if (!last)
        last = BLOB_VALUE(blob);
    }

  if (last)
    {
      if (BIF_BLOB2(start))
        BIF_NEXT(last) = BLOB_VALUE(BIF_BLOB2(start));
    }
  for (blob = BIF_BLOB2(start); blob ; blob = BLOB_NEXT(blob))
    {
      last = LocalRedoBifNextChain(BLOB_VALUE(blob));
      if (BLOB_NEXT(blob))
        BIF_NEXT(last) = BLOB_VALUE(BLOB_NEXT(blob));
      if (!last)
        last = BLOB_VALUE(blob);
    }
  return last;
}

/***************************************************************************/
void Redo_Bif_Next_Chain(start)
     PTR_BFND start;
{
  int i;
  PTR_BFND thebif;
  Reset_Bif_Next_Chain(start);
  Redo_Bif_Next_Chain_Internal(start);
  Count_Bif_Next_Chain(start);
  thebif = PROJ_FIRST_BIF();
  i = 1;
  for (;thebif;thebif=BIF_NEXT(thebif), i++) 
    BIF_ID(thebif) = i;        
  CUR_FILE_NUM_BIFS() = i-1;
}
