/************************************************************************/
/*               The typedef of the nodes_type is here.			*/
/*            (This part can reference to sage++/h/defs.h.)             */
/*                    11.28  1995    Lxy.				*/
/************************************************************************/

#ifndef FILE
#   include <stdio.h>
#endif
#include "tags.h"

typedef struct bfnd	*PTR_BFND;
typedef struct llnd	*PTR_LLND;
typedef struct blob	*PTR_BLOB;
typedef struct symb	*PTR_SYMB;
typedef struct hash_entry *PTR_HASH;  
typedef struct data_type  *PTR_TYPE;
typedef struct Label	*PTR_LABEL;
typedef struct cmnt     *PTR_CMNT;
typedef struct file_name *PTR_FNAME;

typedef struct dep	*PTR_DEP;
typedef struct sets	*PTR_SETS;
typedef struct prop_link *PTR_PLNK;

/*  
typedef struct string	*PTR_STRING;  
typedef struct def	*PTR_DEF;   
typedef struct deflst	*PTR_DEFLST;
*/

typedef struct proj_obj *PTR_PROJ;
typedef struct file_obj *PTR_FILE;

/******************************************************************/
/*       The defination of node "blob,Label,cmnt,file_name"       */
/*        &  "file_object,proj_obj".  			          */
/* 		  11, 30, 1995   Lxy.				  */
/******************************************************************/

struct blob {
        PTR_BFND  ref;
        PTR_BLOB  next;
};

struct Label {
        int             id;             /* identification tag */
        PTR_BFND        scope;          /* level at which ident is declared */
        PTR_BLOB        ud_chain;       /* use-definition chain */
        unsigned        labused :1;     /* if it's been referenced */
        unsigned        labinacc:1;     /* illegal use of this label */
        unsigned        labdefined:1;   /* if this label been defined */
        unsigned        labtype:2;      /* UNKNOWN, EXEC, FORMAT, and OTHER */
        long            stateno;        /* statement label */
        PTR_LABEL       next;           /* point to next label entry */
        PTR_BFND        statbody;       /* point to body of statement */
        PTR_SYMB        label_name;     /* label name for VPC++       */
                                        /* The variant will be LABEL_NAME */
};

struct cmnt {
        int id;
        int type;
        int counter;                     /* New Added for VPC++ */
        char* string;
        struct cmnt *next;
        struct cmnt *thread;
};

struct file_name {              /* for keep source filenames in the project */
        int id;
        char *name;
        PTR_FNAME next;
};

/*
 * Structure for each files in the project
 */
struct file_obj {
        char     *filename;             /* filename of the .dep file */
        FILE     *fid;                  /* its file id */
        int       lang;                 /* type of language */
        PTR_HASH *hash_tbl;             /* hash table for this file obj */
        PTR_BFND  global_bfnd;          /* global BIF node for this file */
        PTR_BFND  head_bfnd,            /* head of BIF node for this file */
                  cur_bfnd;
        PTR_LLND  head_llnd,            /* head of low level node */
                  cur_llnd;
        PTR_SYMB  head_symb,            /* head of symbol node */
                  cur_symb;
        PTR_TYPE  head_type,            /* head of type node */
                  cur_type;
        PTR_BLOB  head_blob,            /* head of blob node */
                  cur_blob;
        PTR_DEP   head_dep,             /* head of dependence node */
                  cur_dep;
        PTR_LABEL head_lab,             /* head of label node */
                  cur_lab;
        PTR_CMNT  head_cmnt,            /* head of comment node */
                  cur_cmnt;
        PTR_FNAME head_file;
        int       num_blobs,            /* no. of blob nodes */
                  num_bfnds,            /* no. of bif nodes */
                  num_llnds,            /* no. of ll nodes */
                  num_symbs,            /* no. of symb nodes */
                  num_label,            /* no. of label nodes */
                  num_types,            /* no. of type nodes */
                  num_files,            /* no. of filename nodes */
                  num_dep,              /* no. of dependence nodes */
                  num_cmnt;             /* no. of comment nodes */
};

/*
 * structure for the whole project
 */
struct proj_obj {
        char     *proj_name;    /* project filename */
        PTR_BLOB  file_chain;   /* list of all opened files in the project */
        PTR_BLOB *hash_tbl;     /* hash table of procedures declared */
        PTR_PROJ  next;         /* point to next project */
};


 /***
  NOTE:
     dep, sets, prop_link are defined as null here,
   because they aren't filled in the construction of AST. If
   you need to use them ,please get them out ,
   then modify them.     11,30,1995  Lxy of HIT
 ***/

struct prop_link {
        PTR_PLNK next;       
};

struct sets {
        PTR_SETS next;
};

/*
struct dep {
        PTR_DEP next;
};
*/

#define __TYPEDEF__
