/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993                  */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

#include <stdio.h>

#ifndef __GNUC__
# include <stdlib.h>
#else
extern "C" void abort(void);
extern "C" void exit(int status);
# pragma implementation
#endif

#include "typedef.h"
#include "bif.h"
#include "ll.h"
#include "symb.h"

#include "defnodes.h"
#include "db.h"
#include "vparse.h"

#include "macro.h"

#include "vpc.h"
//#include "f90.h"

#include "extcxx_low.h"
extern int number_of_ll_node;

#undef USER


//
// define for having the debugging
//
//define  DEBUGLIB 1
#define  MAX_FILES 1000
//
//
// Array to keep track of table for a file
//
//

#define ALLOCATECHUNK 1000

////////////////////////////  ATTRIBUTES /////////////////////////////////
// Array to keep track of the attributes for statement, symbol, ...
///////////////////////////////////////////////////////////////////////////

class SgAttribute;

SgAttribute **tablebfndAttribute[MAX_FILES];
SgAttribute **tablellndAttribute[MAX_FILES];
SgAttribute **tabletypeAttribute[MAX_FILES];
SgAttribute **tablesymbolAttribute[MAX_FILES];
SgAttribute **tablelabelAttribute[MAX_FILES];

int numtablebfndAttribute[MAX_FILES];
int numtablellndAttribute[MAX_FILES];
int numtabletypeAttribute[MAX_FILES];
int numtablesymbolAttribute[MAX_FILES];
int numtablelabelAttribute[MAX_FILES];


//
// Table definition for attributes 
// 
//

SgAttribute **fileTableAttribute;
int allocatedForfileTableAttribute;
SgAttribute **bfndTableAttribute;
int allocatedForbfndTableAttribute;
SgAttribute **llndTableAttribute;
int allocatedForllndTableAttribute;
SgAttribute **typeTableAttribute;
int allocatedFortypeTableAttribute;
SgAttribute **symbolTableAttribute;
int allocatedForsymbolTableAttribute;
SgAttribute **labelTableAttribute;
int allocatedForlabelTableAttribute;

// add a chunk to the size 
void ReallocatefileTableAttribute()
{
  int i;
  SgAttribute **pt;
  
  pt  =  new SgAttribute *[allocatedForfileTableAttribute + ALLOCATECHUNK];
  for (i=0; i<allocatedForfileTableAttribute + ALLOCATECHUNK; i++)
    pt[i] = NULL;
  
  for (i=0 ; i < allocatedForfileTableAttribute; i++)
    {
      pt[i] = fileTableAttribute[i];
    }
  if (allocatedForfileTableAttribute)
    delete fileTableAttribute;
  fileTableAttribute = pt;
  allocatedForfileTableAttribute = allocatedForfileTableAttribute + ALLOCATECHUNK;
}


void ReallocatebfndTableAttribute()
{
  int i;
  SgAttribute **pt;
  
  pt  =  new SgAttribute *[allocatedForbfndTableAttribute + ALLOCATECHUNK];
  for (i=0; i<allocatedForbfndTableAttribute + ALLOCATECHUNK; i++)
    pt[i] = NULL;
  for (i=0 ; i < allocatedForbfndTableAttribute; i++)
    {
      pt[i] = bfndTableAttribute[i];
    }
  if (allocatedForbfndTableAttribute)
    delete bfndTableAttribute;
  bfndTableAttribute = pt;
  allocatedForbfndTableAttribute = allocatedForbfndTableAttribute + ALLOCATECHUNK;
}


void ReallocatellndTableAttribute()
{
  int i;
  SgAttribute **pt;
  
  pt  =  new SgAttribute *[allocatedForllndTableAttribute + ALLOCATECHUNK];
  for (i=0; i<allocatedForllndTableAttribute + ALLOCATECHUNK; i++)
    pt[i] = NULL;
  for (i=0 ; i < allocatedForllndTableAttribute; i++)
    {
      pt[i] = llndTableAttribute[i];
    }
  if (allocatedForllndTableAttribute)
    delete llndTableAttribute;
  llndTableAttribute = pt;
  allocatedForllndTableAttribute = allocatedForllndTableAttribute + ALLOCATECHUNK;
}

void ReallocatesymbolTableAttribute()
{
  int i;
  SgAttribute **pt;
  
  pt  =  new SgAttribute *[allocatedForsymbolTableAttribute + ALLOCATECHUNK];
  for (i=0; i<allocatedForsymbolTableAttribute + ALLOCATECHUNK; i++)
    pt[i] = NULL;
  for (i=0 ; i < allocatedForsymbolTableAttribute; i++)
    {
      pt[i] = symbolTableAttribute[i];
    }
  if (allocatedForsymbolTableAttribute)
    delete symbolTableAttribute;
  symbolTableAttribute = pt;
  allocatedForsymbolTableAttribute = allocatedForsymbolTableAttribute + ALLOCATECHUNK;
}


void ReallocatelabelTableAttribute()
{
  int i;
  SgAttribute **pt;
  
  pt  =  new SgAttribute *[allocatedForlabelTableAttribute + ALLOCATECHUNK];
  for (i=0; i<allocatedForlabelTableAttribute + ALLOCATECHUNK; i++)
    pt[i] = NULL;
  for (i=0 ; i < allocatedForlabelTableAttribute; i++)
    {
      pt[i] = labelTableAttribute[i];
    }
  if (allocatedForlabelTableAttribute)
    delete labelTableAttribute;
  labelTableAttribute = pt;
  allocatedForlabelTableAttribute = allocatedForlabelTableAttribute + ALLOCATECHUNK;
}


void ReallocatetypeTableAttribute()
{
  int i;
  SgAttribute **pt;
  
  pt  =  new SgAttribute *[allocatedFortypeTableAttribute + ALLOCATECHUNK];
  for (i=0; i<allocatedFortypeTableAttribute + ALLOCATECHUNK; i++)
    pt[i] = NULL;
  for (i=0 ; i < allocatedFortypeTableAttribute; i++)
    {
      pt[i] = typeTableAttribute[i];
    }
  if (allocatedFortypeTableAttribute)
    delete typeTableAttribute;
  typeTableAttribute = pt;
  allocatedFortypeTableAttribute = allocatedFortypeTableAttribute + ALLOCATECHUNK;
}


void 
SetMappingInTableForBfndAttribute(PTR_BFND bif, SgAttribute *pt)
{
  if (!bif)
    return ;
  while (allocatedForbfndTableAttribute <= BIF_ID(bif))
    {
      ReallocatebfndTableAttribute();
    }
  bfndTableAttribute[BIF_ID(bif)] = pt;
}


void 
SetMappingInTableForTypeAttribute(PTR_TYPE type, SgAttribute *pt)
{
  if (!type)
    return ;
  while (allocatedFortypeTableAttribute <= TYPE_ID(type))
    {
      ReallocatetypeTableAttribute();
    }
  typeTableAttribute[TYPE_ID(type)] = pt;
}


void 
SetMappingInTableForSymbolAttribute(PTR_SYMB symb, SgAttribute *pt)
{
  if (!symb)
    return ;
  while (allocatedForsymbolTableAttribute <= SYMB_ID(symb))
    {
      ReallocatesymbolTableAttribute();
    }
  symbolTableAttribute[SYMB_ID(symb)] = pt;
}

void 
SetMappingInTableForLabelAttribute(PTR_LABEL lab, SgAttribute *pt)
{
  if (!lab)
    return ;
  while (allocatedForlabelTableAttribute <= LABEL_ID(lab))
    {
      ReallocatelabelTableAttribute();
    }
  labelTableAttribute[SYMB_ID(lab)] = pt;
}



void 
SetMappingInTableForLlndAttribute(PTR_LLND ll, SgAttribute *pt)
{
  if (!ll)
    return ;
  while (allocatedForllndTableAttribute <= NODE_ID(ll))
    {
      ReallocatellndTableAttribute();
    }
  llndTableAttribute[NODE_ID(ll)] = pt;
}


void 
SetMappingInTableForFileAttribute(PTR_FILE file, SgAttribute *pt)
{
  int id;
  if (!file)
    return ;
  id = GetFileNum(FILE_FILENAME(file));
  while (allocatedForfileTableAttribute <= id)
    {
      ReallocatefileTableAttribute();
    }
  fileTableAttribute[id] = pt;
}


SgAttribute *
GetMappingInTableForSymbolAttribute(PTR_SYMB symb)
{
  int id;
  if (!symb)
    return NULL;
  id = SYMB_ID(symb);
  if (allocatedForsymbolTableAttribute <= id)    
    {
      return NULL;
    }
  return  symbolTableAttribute[id];
}



SgAttribute *
GetMappingInTableForLabelAttribute(PTR_LABEL lab)
{
  int id;
  if (!lab)
    return NULL;
  id = LABEL_ID(lab);
  if (allocatedForlabelTableAttribute <= id)    
    {
      return NULL;
    }
  return  labelTableAttribute[id];
}


SgAttribute *
GetMappingInTableForBfndAttribute(PTR_BFND bf)
{
  int id;
  if (!bf)
    return NULL;
  id = BIF_ID(bf);
  if (allocatedForbfndTableAttribute <= id)    
    {
      return NULL;
    }
  return bfndTableAttribute[id];
}


SgAttribute *
GetMappingInTableForTypeAttribute(PTR_TYPE t)
{
  int id;
  if (!t)
    return NULL;
  id = TYPE_ID(t);
  if (allocatedFortypeTableAttribute <= id)    
    {
      return NULL;
    }
  return  typeTableAttribute[id];
}


SgAttribute *
GetMappingInTableForLlndAttribute(PTR_LLND ll)
{
  int id;
  if (!ll)
    return NULL;
  id = NODE_ID(ll);
  if (allocatedForllndTableAttribute <= id)    
    {
      return NULL;
    }
  return  llndTableAttribute[id];
}


SgAttribute *
GetMappingInTableForFileAttribute(PTR_FILE file)
{
  int id;
  if (!file)
    return NULL;
  id = GetFileNum(FILE_FILENAME(file));
  if (allocatedForfileTableAttribute <= id)
    {
      return NULL;
    }
  return  fileTableAttribute[id];
}



//////////////////////////////////END ATTRIBUTE STUFFS/////////////////////////////////////////
