      MODULE RATIONAL_NUMBERS
         TYPE RATIONAL
           PRIVATE
           INTEGER :: NUMERATOR
           INTEGER :: DENOMINATOR
         END TYPE RATIONAL

        INTERFACE OPERATOR(==)
           LOGICAL FUNCTION EQUAL(X,Y)
           TYPE (RATIONAL), INTENT(IN) :: X,Y 
           END FUNCTION EQUAL
      END INTERFACE

      INTERFACE OPERATOR(+)
           TYPE (RATIONAL) FUNCTION ADD_RATIONALS(X,Y)
           TYPE (RATIONAL), INTENT(IN) :: X,Y
         END FUNCTION ADD_RATIONALS
      END INTERFACE

        CONTAINS

      LOGICAL FUNCTION EQUAL(X,Y)
         TYPE (RATIONAL),INTENT(IN) :: X,Y
         EQUAL = X%NUMERATOR*Y%DENOMINATOR==Y%NUMERATOR*X%DENOMINATOR
      END FUNCTION EQUAL

      TYPE (RATIONAL) FUNCTION MAKE_RATIONAL(X,Y)
         INTEGER,INTENT(IN) :: X,Y
         IF (Y>0) THEN
             MAKE_RATIONAL = RATIONAL(X,Y)
         ELSE
             MAKE_RATIONAL = RATIONAL(-X,-Y)
         END IF
      END FUNCTION MAKE_RATIONAL

        TYPE (RATIONAL) FUNCTION  ADD_RATIONALS(X,Y)
        TYPE (RATIONAL),INTENT(IN) :: X,Y
         ADD_RATIONALS = RATIONAL(X%NUMERATOR*Y%DENOMINATOR + Y%NUMERATOR  &
                           *X%DENOMINATOR, X%DENOMINATOR*Y%DENOMINATOR)
      END FUNCTION ADD_RATIONALS

      END MODULE RATIONAL_NUMBERS               
 
      PROGRAM HPF_3_7_3   
         USE RATIONAL_NUMBERS
         TYPE(RATIONAL) :: X,Y
          X = MAKE_RATIONAL(1,2)
         Y = X + MAKE_RATIONAL(3,-6)
         IF (Y == MAKE_RATIONAL(0,1)) THEN
            PRINT *,"PASSES TEST"
         ELSE 
              PRINT *,"FAILS TEST"
         END  IF
      END PROGRAM HPF_3_7_3 

