//DrawCanvas.jav
import java.awt.*;
import java.applet.*;

public class DrawCanvas extends Canvas {

    Graphics g;
    String curMode="Rect";
    mPoint curObj;
    public boolean fill=true;
    mPoint objList[]=new mPoint[100];
    int index=0;


    public DrawCanvas() {

        super();
        setBackground(Color.blue);
        setForeground(Color.yellow);
    }

    public void setDrawMode(String s) {
        if(s.equals("Clear")) {
            index=0;
            repaint();
        } else if(s.equals("Redraw")) repaint();
        else curMode=s;
    }

    public void paint(Graphics g) {

        g.setColor(Color.yellow);
        super.paint(g);
        for(int i=0; i<index; i++)
            objList[i].draw(g);
    }
    public boolean mouseDown(Event e, int x, int y) {

        if (curMode.equals("Rect")) curObj=new mRectangle(x, y, x, y);
        else if (curMode.equals("Circ")) curObj=new mCircle(x, y, x, y);
        else if (curMode.equals("Line")) curObj=new mLine(x, y, x+1, y+1);
        else if (curMode.equals("Round")) curObj=new mRound(x, y, x, y);
        return true;
    }

    public boolean mouseDrag(Event e, int x, int y) {

        g=getGraphics();
        g.setXORMode(Color.black);
        curObj.draw(g);
        curObj.setEnds(x, y);
        curObj.draw(g);

        return true;
    }

    public boolean mouseUp(Event e, int x, int y) {

        g=getGraphics();
        g.setPaintMode();
        curObj.setEnds(x, y);
        curObj.setFill(fill);
        objList[index++]=curObj;
        curObj.draw(g);
        if(index>=100) index=100;

        return true;
    }
}

