import java.awt.*;
import java.lang.Math;
import java.util.Random;

public class mySliders extends java.applet.Applet  {

   MyCanvasClass MyCanvas;
   MyControlPanel MyPanel;
   public void init() {
       setLayout(new GridLayout(1,2,15,10));
       MyCanvas = new  MyCanvasClass(this);
       MyPanel  = new  MyControlPanel(this);
       add(MyCanvas);
       add(MyPanel);
   }
   
   public void paint(Graphics g)  {
      MyCanvas.setBackground(Color.black);
      MyPanel.setBackground(Color.lightGray);
      MyCanvas.paint(g);
      MyPanel.paint(g);
   }
  
   public  void  start()  {
      MyCanvas.start();
      MyPanel.start();
   }

   public  void  stop()  {
       MyCanvas.stop();
   }
   
   public  void  update(Graphics g)  {
       MyCanvas.paint(g);
   }
}

  class MyCanvasClass extends  Canvas {
     mySliders outerparent;
     public int W, H;
     public final Color bg = Color.black;
     Image im;
     Graphics offscreen;
     NBrick nbricks;
     Color  color;

     MyCanvasClass(mySliders outerparent) {
        this.outerparent = outerparent;
        Rectangle r=outerparent.bounds();
        W=(r.width-60)/2;
        H=r.height;        
        try {
            im = createImage(W, H);
            offscreen = im.getGraphics();
        } catch (Exception e) {
            offscreen = null;
        }
      }


      public  void  start()  {
        if (nbricks == null)  {
            nbricks = new NBrick(this, (W/2), 10, Color.blue, bg, bounds());
                nbricks.start();
            }
        repaint();
      }

      public  void paint(Graphics g) {
      if  (offscreen  != null) {
            paintCanvas(offscreen);
            g.drawImage(im, 0, 0, this);
          } else {
            paintCanvas(g);
          }
      }


      public  void  stop()  {
         nbricks.stop();
           nbricks=null;
      }

      public void paintCanvas(Graphics g) {
         boolean changed = false;
         g.setColor(bg);
         g.fillRect(0, 0, W, H);
             nbricks.paint(g);
      }
}



class NBrick  implements  Runnable {

    static int threadNum = 1;   
    int oldfactor=0;

    private Color color = null;
    private Color bg = Color.black;
    private int x = 0;
    private int y = 0;
    private int dx=0;
    private int dy=3;
    private int naptime;
    private Rectangle rect;
    private int w, h;
    public Thread thread = null;
    public boolean changed = true;
    public MyCanvasClass tempcanvas;

    final int const_naptime=200;
    final int start_width=20;
    final int start_height=80;

    Color  colorarray[] = { Color.lightGray, Color.darkGray,  Color.red,
       Color.green, Color.blue,  Color.yellow,  Color.magenta, 
       Color.cyan,  Color.pink,  Color.orange};

    public NBrick(MyCanvasClass tempcanvas, 
     int _x, int _y, Color c, Color bg, Rectangle r) {
        this.tempcanvas = tempcanvas;
        x = _x;
        y = _y;
        w = start_width;
        h = start_height;
        color = c;
        rect = r;
        naptime = const_naptime;
        if (color == null) {
            color = Color.black;
        }
    }

    public void run() {
        thread.setPriority(Thread.MIN_PRIORITY+1);
        while (thread != null) {
            changed = true;
            update();
            try { thread.sleep(naptime); } catch (InterruptedException e) {};
            tempcanvas.repaint();
        }
        thread = null;
    }

    public void update() {
        checkBoundry();
        move();
      }

    public void move() {
     x += dx;    
     y += dy;
    }

    public  void  change_velocity(int v_factor)  {
         naptime = const_naptime / v_factor;
    }


    public  void  left_right(int lr_factor)  {
         if(oldfactor < lr_factor)
           x = x+20;
         else
           x = x-20;
       oldfactor = lr_factor;
    }

    public  void change_color(int tempcolor)  {
         color = colorarray[tempcolor];
    }         

    public void start() {
         if (thread == null) {
             thread = new Thread(this, Integer.toString(threadNum++));
             thread.start();
         }
    }

    public void stop() {
        thread = null;
    }

    public void paint(Graphics g) {
    g.setColor(color);
    g.fillRect(x, y, w, h);
    g.setColor(Color.white);
    g.drawRect(x, y, w, h);
    }

    public void  checkBoundry() {
        if(y>=rect.height) {
                y=0;
        }
    }
}


class  MyControlPanel extends  Panel{

        Scrollbar  vf, lrf;
        TextField  tvf, tlrf;
        Button  clear_button;
        List lst;
        mySliders  parent;    
        final int  start_width = 20;
        final int  start_height = 10;

        MyControlPanel(mySliders parent)  {
            this.parent  = parent;
            vf = new Scrollbar(Scrollbar.HORIZONTAL,1,1,1,10);
            lrf = new Scrollbar(Scrollbar.HORIZONTAL,1,1,-5,5);
            tvf = new TextField("0", 5);
            tlrf = new TextField("0", 5);
            clear_button = new Button("Clear");
   
//  Make a List of Colours

            lst  = new List(5, false);
            lst.addItem("LightGray");
            lst.addItem("DarkGray");
            lst.addItem("Red");
            lst.addItem("Green");
            lst.addItem("Blue");
            lst.addItem("Yellow");
            lst.addItem("Magenta");
            lst.addItem("Cyan");
            lst.addItem("Pink");
            lst.addItem("Orange");

            GridBagLayout gridbag = new GridBagLayout();
            GridBagConstraints c = new GridBagConstraints ();
            setFont(new  Font("Helvetica", Font.BOLD, 12));
            setLayout(gridbag);      
            c.fill = GridBagConstraints.BOTH;
            c.weightx = 1.0;      
            c.gridwidth=1;

            make_label("VELOCITY", gridbag,c);
            make_scroll(vf,gridbag,c);
            make_textedit(tvf,gridbag,c);
            tvf.setText(String.valueOf(1));

            make_label("LEFT<-->RIGHT", gridbag,c);
            make_scroll(lrf,gridbag,c);
            make_textedit(tlrf,gridbag,c);
            tlrf.setText(String.valueOf(20));

            make_label("COLOR", gridbag,c);
            make_list(lst,gridbag,c);

            make_button(clear_button, gridbag, c);
       }

        public void start() {
                vf.setValue(1);
                lrf.setValue(0);
                tvf.setText("1");               
                tlrf.setText("0");
          }
        public  void  paint(Graphics g)  {
            Dimension   d = size();
            g.setColor(new Color(0,0,0));
            g.draw3DRect(0, 7,d.width-1,
                   d.height-10,false);
        }

       protected  void  make_scroll(Scrollbar tempsc, GridBagLayout gridbag, 
               GridBagConstraints c) {
          c.weightx = 0.0;
          c.gridwidth = GridBagConstraints.REMAINDER;
          gridbag.setConstraints(tempsc,c);
          add(tempsc);
        }

        protected  void  make_list(List templist, GridBagLayout gridbag, 
               GridBagConstraints c) {
          c.weightx = 0.0;
          c.gridwidth = GridBagConstraints.REMAINDER;
          gridbag.setConstraints(templist,c);
          add(templist);
        }

        protected  void  make_label(String  name, GridBagLayout gridbag, 
               GridBagConstraints c) {
          Label label = new Label(name, Label.CENTER);
          c.weightx = 0.0;
          c.gridwidth = GridBagConstraints.REMAINDER;
          gridbag.setConstraints(label,c);
          add(label);
        }

        protected  void  make_textedit(TextField temptex,
           GridBagLayout gridbag, GridBagConstraints c) {
          c.weightx = 1.0;
          c.gridwidth = GridBagConstraints.REMAINDER;
          gridbag.setConstraints(temptex,c);
          add(temptex);
        }

       protected  void  make_button(Button infobutton, GridBagLayout gridbag, 
               GridBagConstraints c) {
    //      c.gridwidth = GridBagConstraints.REMAINDER;
    //      gridbag.setConstraints(infobutton,c);
          add(infobutton);
        }

       public  boolean  handleEvent(Event evt)  {
          int  temp_velocity, temp_lr, temp_select;
        
          if  (evt.target  instanceof Scrollbar)  {
             if  ((Scrollbar) evt.target == vf) {
                  temp_velocity = vf.getValue();
                  tvf.setText(String.valueOf(temp_velocity));
                  parent.MyCanvas.nbricks.change_velocity(temp_velocity);
             }
             if  ((Scrollbar) evt.target == lrf) {
                  temp_lr = lrf.getValue();  
                  tlrf.setText(String.valueOf(temp_lr));
                  parent.MyCanvas.nbricks.left_right(temp_lr);
             }
             return true;
          }
         else {
              if (evt.target  instanceof  List)  {
                if  ((List) evt.target == lst) {
                 temp_select = lst.getSelectedIndex();
                 parent.MyCanvas.nbricks.change_color(temp_select);
                 }
                return true;
              }
              else {
                   if (evt.target  instanceof Button) {
                     parent.stop();
                     parent.start();
                     return true;
                     }
                   else return false;
                   }
              }
     }

}
