%{
#ifdef HAVE_CONFIG_H
#include <config.h>                     /* config header file */
#endif

#if defined(STDC_HEADERS) && (STDC_HEADERS==1)
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>
#include "tags.h"
#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"
#include "defnodes.h"
#include "makenodes.h"
#include "extern.h"
#include "makespec.h"
#include "exec_part.h"
#include "decl.h"
#define  errResynch() { throw_away(); yyerrok; yyclearin; }

#ifndef YYTEXT_IS_POINTER
#ifdef IS_UNSIGNED_CHAR
 extern unsigned char yytext[YYLMAX];
#else
 extern char yytext[YYLMAX];
#endif
#else
#ifdef IS_UNSIGNED_CHAR
 extern unsigned char *yytext;
#else
 extern char *yytext;
#endif
#endif

#include "err_token.h"   /* xli, 1/21/97 */

int intent_l=0;/* used in intent_stmt to pass the value of local */
int combinedFlag_g=0;
int para_app_flag = NON; /* flag of PARAMETER statement appearence, added by Feng Xiaobing */
int init_flag = 0; /* flag of initilization expression appearing, added by Feng Xiaobing */
int double_colon_flag = 0; /* flag of double colon appearing, added by Feng Xiaobing */
int outer_scope;                     /* indicate outest function declare */
int default_access=0;                  /* Zheng Gengbin 1996.5.22 */

int keyword_flag;
PTR_SYMB module_name,type_name;
PTR_BFND newProgram_g;  /* Lxy 4.30 */
PTR_LABEL cur_label;    /* zheng.gb */

%}

%union{
    int token;
    char charv;
    char *charp;
    char charp1[STR_LENGTH];
    PTR_BFND bf_node;
    PTR_LLND ll_node;
    PTR_SYMB symbol;
    PTR_TYPE data_type;
    PTR_HASH hash_entry;
    PTR_CMNT cmnt_node;
    PTR_LABEL label;
 } 

/*  FORTRAN 90  */
%token  FORMAT  ALLOCATE  DEALLOCATE  COMMON  NAMELIST 
%token  OPEN  READ WRITE  REWIND  BACKSPACE  ENDFILE  CLOSE INQUIRE  
%token  IMPLICIT WAIT /* HPF2.0 */
%token  EXTRINSIC RECURSIVE PURE ELEMENTAL

%token  ALLOCATABLE ASSIGN  ASSIGNMENT  /* ASSOCIATED  zheng.gb */
%token  BLOCKDATA  CALL  CASE 
%token  CONTAINS  CONTINUE  CYCLE  DATA  DEFAULTL
%token  DIMENSION  DO  DOUBLEPRE
%token  ELSE   END 
%token  ENTRY   EQUIVALENCE  EXIT  EXTERNAL
%token  FORALL  FUNCTION  GOTO IF  
%token  IN  INOUT  OUT  INTENT
%token  INTERFACE  INTRINSIC 
%token  MODULE  NONE  NULLIFY  ONLY  OPERATOR  OPTIONAL
%token  PARAMETER  PAUSE  POINTER  PRINT  PRIVATE
%token  PROGRAM PROCEDURE  PUBLIC  
%token  INTEGER  LOGICAL  COMPLEX  REAL CHARACTER
%token  RESULT  RETURN  SAVE  SELECTCASE  
%token  SEQUENCE   STOP  SUBROUTINE  
%token  TARGET  THEN  TO  TYPE  USE  WHERE  WHILE  
%token  INCLUDE

/*  Fortran D  */
%token  ALIGN  BLOCK CYCLIC DISTRIBUTE DYNAMIC HPF HPF_LOCAL
%token  INDEPENDENT INHERIT NEW NO ONTO PROCESSORS REALIGN
%token  REDISTRIBUTE TEMPLATE WITH  

/*  HP Fortran 2.0 */
%token  REDUCTION ACTIVE SHADOW GEN_BLOCK INDIRECT HOME RESIDENT
%token  TASK_REGION HPF_SERIAL MAP_TO LAYOUT PASS_BY

%token  ID DONE ASYNCH LANGUAGE MODEL EXTERNAL_NAME
%token  RANGE ALL ON_HOME DIRBEGIN DIREND
%token  ENDON_HOME ENDRESIDENT ENDTASK_REGION
%token  EXE_ACTIVE 
/*
%token  LEFTBRACKET_DIST
*/
%token  DIRDIMENSION DIRSEQUENCE

/***************/
%token  I  B  O  Z  F  E  EN  ES  G  L  A  D  P  T  TL  TR
%token  X  S  SP  SS  BN  BZ  H  

%token  ACCESSL ACTION ADVANCE BLANK DELIM DIRECT ERR STATUS READWRITE
%token  IOLENGTH  IOSTAT UNFORMATTED  UNIT  SEQUENTIAL  SIZE REC  RECL
%token  PAD POSITION OPENED NUMBER NAMEI  NAMED  NEXTREC
%token  NML EOR FILEI  FMT FORM  FORMATTED
%token  STAT KINDEQ  LENEQ READI WRITEI EXIST ENDR
%token  ELSEWHERE  ELSEIF
%token  ENDDO  ENDIF  ENDSELECT  ENDWHERE  ENDFORALL ENDTYPE  ENDBLOCKDATA
%token  ENDINTERFACE  ENDMODULE  ENDSUBROUTINE  ENDFUNCTION ENDPROGRAM

%token  COMMA1  COMMA2
%token  CARRIAGE1 CARRIAGE2  PERCENT  COMMA  FULLPOINT  SINGLEQUO  DOUBLEQUO
%token  LEFTBRACKET  RIGHTBRACKET  PLUS  MINUS  MULTIPLY  POWER  DIVIDE
%token  COLON  EQUAL  UNDERSCORE  DOUBLECOLON  FALSEL  TRUEL EQV
%token  NEQV  OR  AND  NOT  EQ  EQGT  NE  LT  LE  GT  GE  CONCAT
%token  LEFTBRACKET1  LEFTBRACKET2 
%token  QUESTION  HCHAR  ACVALUE1  ACVALUE2  UNDERSCORE1 
%token  IMPLICITLETTER

%token<charp> STRING
%token  DEFINED_OPERATOR
%token  DIGIT_STRING  KIND_PARAM
%token  FUNNAME NAME 
%token  BINARY_CONST OCTAL_CONST HEX_CONST
%token  INT_LITERAL_CONST   REAL_LITERAL_CONST   DOUBLE_LITERAL_CONST 
%token  LOGICAL_LITERAL_CONST
%token  LABEL COMMENT

/*  FORTRAN 90  */
%start executable_program
%type<bf_node> executable_program program_unit 
%type<bf_node> external_subprogram  module block_data  main_program
%type<bf_node> specification... executable...
%type<bf_node> internal_subprogram_part module_subprogram_part
%type<bf_node> internal_subprogram... internal_subprogram 
%type<bf_node> module_subprogram... module_subprogram
%type<bf_node> function_subprogram  subroutine_subprogram

%type<label>   label1  opt_label1
%type<ll_node> label_list  label

%type<bf_node> program_stmt end_program_stmt 
%type<bf_node> block_data_stmt end_block_data_stmt 
%type<bf_node> module_stmt end_module_stmt
%type<bf_node> function_stmt end_function_stmt 
%type<bf_node> subroutine_stmt end_subroutine_stmt
%type<cmnt_node> cmnt 
%type<bf_node> specification executable  

%type<bf_node> use_stmt 
%type<bf_node> parameter_stmt 
%type<bf_node> format_stmt 
%type<bf_node> implicit_stmt
%type<bf_node> common_stmt 
%type<bf_node> data_stmt 
%type<bf_node> dimension_stmt 
%type<bf_node> save_stmt 
%type<bf_node> equivalence_stmt
%type<bf_node> external_stmt 
%type<bf_node> intrinsic_stmt 
%type<bf_node> namelist_stmt 
%type<bf_node> intent_stmt 
%type<bf_node> access_stmt
%type<bf_node> optional_stmt 
%type<bf_node> pointer_stmt 
%type<bf_node> target_stmt 
%type<bf_node> allocatable_stmt
%type<bf_node> sequence_stmt 
%type<bf_node> entry_stmt
%type<bf_node> derived_type_stmt 
%type<bf_node> module_procedure_stmt 
%type<bf_node> interface_stmt
%type<bf_node> contains_stmt
%type<bf_node> type_declaration_stmt
%type<bf_node> assignment_stmt
%type<bf_node> backspace_stmt 
%type<bf_node> call_stmt 
%type<bf_node> close_stmt 
%type<bf_node> computed_goto_stmt 
%type<bf_node> continue_stmt 
%type<bf_node> open_stmt 
%type<bf_node> endfile_stmt 
%type<bf_node> forall_stmt
%type<bf_node> forall_stmt_begin                        /* add by zheng.gb */
%type<bf_node> print_stmt 
%type<bf_node> read_stmt 
%type<bf_node> return_stmt 
%type<bf_node> rewind_stmt 
%type<bf_node> stop_stmt 
%type<bf_node> write_stmt
%type<bf_node> arithmetic_if_stmt 
%type<bf_node> pause_stmt
%type<bf_node> goto_stmt 
%type<bf_node> if_stmt 
%type<bf_node> if_stmt_begin                            /* add by zheng.gb */
%type<bf_node> where_stmt
%type<bf_node> inquire_stmt 
%type<bf_node> exit_stmt 
%type<bf_node> cycle_stmt
%type<bf_node> deallocate_stmt 
%type<bf_node> allocate_stmt 
%type<bf_node> nullify_stmt
/*%type<bf_node> associated_stmt  */
%type<bf_node> assign_label_stmt 
%type<bf_node> assign_goto_stmt 
%type<bf_node> pointer_assignment_stmt
%type<bf_node> action_stmt 
%type<bf_node> case_construct 
%type<bf_node> do_construct 
%type<bf_node> where_construct 
%type<bf_node> if_construct
%type<bf_node> select_case_stmt case_stmt end_select_stmt 
%type<bf_node> nonlabel_do_stmt end_do_stmt label_do_stmt
%type<bf_node> end_if_stmt if_then_stmt else_if_stmt else_stmt
%type<bf_node> end_where_stmt elsewhere_stmt
%type<bf_node> block_do_construct nonblock_do_construct
%type<bf_node> assignment_stmt...
%type<bf_node> module_procedure_stmt...
%type<bf_node> newname10... newname11... block

%type<bf_node> interface_block interface_body... interface_body 
%type<bf_node> end_interface_stmt
%type<bf_node> derived_type_def  private_sequence_stmt...
%type<bf_node> component_def_stmt...
%type<bf_node> component_def_stmt private_sequence_stmt 
%type<ll_node> component_attr_spec_list component_decl_list
%type<ll_node> component_attr_spec component_decl component_array_spec
%type<bf_node> end_type_stmt

%type<ll_node> implicit_spec letter_spec_list letter_spec 
%type<charv>   letter
%type<symbol>  comblock namelist_group_name /* added by Feng Xiaobing*/
%type<ll_node> rename_list  only_list  rename only
%type<symbol>  generic_spec 
%type<ll_node> named_constant_def_list named_constant_def
%type<ll_node> common_block_object
%type<ll_node> saved_entity_list  saved_entity
%type<ll_node> dims  array_spec
%type<ll_node> equivalence_set equivalence_object_list equivalence_object
%type<ll_node> intent_spec
%type<ll_node> access_spec access_id_list access_id
%type<ll_node> format_specification
%type<charp> format_item_list
%type<charp1> format_item
%type<charp> r control_edit_desc data_edit_desc
%type<charp> char_string_edit_desc position_edit_desc w
%type<charp> sign_edit_desc k blank_interp_edit_desc n c
/* %type<charp> rep_char1 */
%type<ll_node> type_spec 
%type<ll_node> attr_spec... entity_decl_list
%type<ll_node> attr_spec entity_decl 
%type<ll_node> kind_selector char_selector length_selector
%type<ll_node> initialization_expr char_length type_param_value 
%type<ll_node> data_stmt_list
%type<ll_node> data_stmt_set data_stmt_object_list data_stmt_object
%type<ll_node> data_implied_do data_stmt_value 
%type<ll_node> data_stmt_constant data_stmt_repeat
%type<ll_node> data_stmt_value_list data_i_do_object_list data_i_do_object
%type<symbol>  data_i_do_variable  
%type<ll_node> structure_constructor expr_list
%type<ll_node> procedure_name_list 

%type<ll_node> actual_arg_spec_list
%type<ll_node> actual_arg_spec actual_arg  
%type<ll_node> stat_variable allocation_list allocation allocate_object
%type<ll_node> allocate_object_list  
%type<ll_node> pointer_object_list pointer_object
/*%type<ll_node> target_pointer              zheng.gb 1996.5.13 */
%type<ll_node> stop_code 
%type<ll_node> case_expr case_selector
%type<ll_node> case_value_range_list case_value_range case_value
%type<ll_node> do_variable 
%type<ll_node> int_initialization_expr 
%type<bf_node> loop_control
%type<ll_node> numeric_expr logical_expr  mask_expr  
%type<bf_node> where_construct_begin
%type<bf_node> where_stmt_begin                         /* add by zheng.gb */
%type<ll_node> external_file_unit 
%type<ll_node> position_spec_list position_spec
%type<ll_node> close_spec_list  close_spec 
%type<ll_node> inquire_spec_list inquire_spec 
%type<ll_node> connect_spec_list connect_spec
%type<ll_node> file_name_expr default_char_expr
%type<ll_node> format output_item_list output_item
%type<ll_node> io_control_spec_list 
%type<ll_node> input_item_list input_item 
%type<ll_node> io_implied_do io_implied_do1
%type<symbol>  io_implied_variable
%type<ll_node> io_implied_do_object_list /* io_implied_do_object */
/*%type<ll_node> io_implied_do_control     xli 1996.10*/
%type<ll_node> io_control_spec io_unit

%type<ll_node> opt_result 
%type<symbol>  progname blockname procname funcname  module_name
%type<charp>   name  /* hash_entry */ opt_name       /* add by zheng.gb */
%type<symbol>  func_ref_name
%type<symbol>  dummy_args dummy_arg arglist func_arglist
%type<ll_node> inhe_dummy_args
%type<ll_node> prefix...  prefix  

%type<charp>   digit_string real_constant
%type<ll_node> kind_param 

%type<ll_node> explicit_shape_spec_list explicit_shape_spec 
%type<ll_node> assumed_shape_spec_list assumed_size_spec assumed_shape_spec
%type<ll_node> lower_bound upper_bound 

%type<ll_node> expr
%type<symbol>  operator
%type<token>   equiv_op or_op and_op not_op rel_op concat_op mult_op add_op
%type<token>   power_op intrinsic_operator
%type<charp>   defined_operator
%type<ll_node> level_5_expr equiv_operand 
%type<ll_node> or_operand and_operand 
%type<ll_node> level_4_expr level_3_expr level_2_expr 
%type<ll_node> add_operand mult_operand level_1_expr 
%type<ll_node> primary  literal_constant 
%type<ll_node> array_constructor function_reference 
%type<ll_node> ac_value_list ac_value ac_implied_do ac_implied_do_control  
%type<symbol>  ac_implied_do_var
%type<ll_node> variable 
%type<ll_node> subobject1 array_section_element_funcref
%type<ll_node> structure_component substring data_ref substring_range
%type<ll_node> part_ref1 part_ref newname3 section_subscript_list
%type<ll_node> section_subscript subscript subscript_triplet 
%type<ll_node> constant
%type<ll_node> int_literal_constant real_literal_constant 
%type<ll_node> complex_literal_constant
%type<ll_node> logical_literal_constant char_literal_constant 
%type<ll_node> boz_literal_constant
%type<ll_node> double_literal_constant
%type<ll_node> signed_int_literal_constant signed_real_literal_constant 
%type<ll_node> complex_expr complex_add_operand complex_mult_operand
%type<ll_node> complex_level_1_expr
%type<ll_node> expr1 complex_expr1

/*  FORTRAN D  */
%type<bf_node> hpf_spec_directives hpf_exec_directives 
%type<bf_node> forall_construct
%type<bf_node> processors_directive align_directive distribute_directive
%type<bf_node> dynamic_directive inherit_directive template_directive
%type<bf_node> combined_directive sequence_directive 
%type<bf_node> realign_directive redistribute_directive independent_directive

%type<ll_node> combined_attribute combined_attribute_list
%type<ll_node> dist_directive_stuff dist_attribute_stuff distributee
%type<ll_node> dist_format_clause dist_format_list dist_format
%type<ll_node> dist_onto_clause dist_target 
%type<ll_node> distributee_list 
%type<symbol>  processors_name template_name align_target
%type<ll_node> align_target1   /* extension for hpf2.0 (xli 1/21/97) */
%type<ll_node> align_directive_stuff align_attribute_stuff alignee 
%type<ll_node> alignee_list align_source align_dummy align_with_clause
%type<ll_node> align_source_list
%type<ll_node> align_spec align_subscript_list align_subscript
%type<ll_node> alignee_distributee_list alignee_distributee
%type<ll_node> processors_decl_list processors_decl
%type<ll_node> template_decl_list template_decl 
%type<ll_node> association_name_list association_name new_clause variable_list

%type<bf_node> forall_construct_begin 
%type<bf_node> forall_body forall_body...
%type<ll_node> forall_script_control forall_script_control_list
%type<ll_node> forall_control
%type<bf_node> forall_assignment
%type<ll_node> extrinsic_prefix extrinsic_kind_keyword

/*  HP FORTRAN 2.0  */
%type<bf_node> range_directive shadow_directive
%type<bf_node> active_directive  simple_on_directive
%type<bf_node> block_on_directive end_on_directive 
%type<bf_node> simple_resident_directive block_resident_directive
%type<bf_node> end_resident_directive
%type<bf_node> on_resident_end
%type<bf_node> task_region_directive end_task_directive
/*
%type<bf_node> task_region on_block resident_block
*/
%type<bf_node> wait_directive
%type<ll_node> reduction_clause reduction_variable_list 
%type<ll_node> range_attr_stuff_list shadow_attr_stuff
%type<ll_node> range_attr_stuff range_attr_list range_attr
%type<ll_node> range_dist_format
%type<ll_node> shadow_spec_list shadow_spec
%type<ll_node> width low_width high_width
%type<ll_node> home_expr resident_clause  
%type<ll_node> processors_elmt 
%type<ll_node> local_var_list local_var
%type<ll_node> wait_spec_list wait_spec default_int_expr int_array ranger /* zheng.gb */
%type<ll_node>  shadow_target           /* zheng.gb */
%type<ll_node> extrinsic_spec_arg_list extrinsic_spec_arg
%type<ll_node> language model external_name

%%
       
executable_program       
    :  program_unit
    |  executable_program  program_unit {
          PTR_BFND p;
          if(!(($1->variant==MODULE_STMT)||($1->variant==BLOCK_DATA))) {
             for(p=$1;p->entry.prog_stmt.next_prog;p=p->entry.prog_stmt.next_prog)
                ;
             p->entry.prog_stmt.next_prog=$2;
             }
          }
    ;
       
needkeywordson
    :  { keyword_flag = ON; }

needkeywordsoff
    :  { keyword_flag = OFF; }

program_unit             
    :  external_subprogram {
                                     /* zheng.gb 1996.5.5 */
          newProgram_g=makeProgram(fi,SMNULL);
          add_scope_level(newProgram_g,NON);
          outer_scope = 1;
          default_access = 0;       /* Zheng Gengbin 1996.5.22 */
       }
    |  module {
                                     /* zheng.gb 1996.5.5 */
          newProgram_g=makeProgram(fi,SMNULL);
          add_scope_level(newProgram_g,NON);
          outer_scope = 1;
          default_access = 0;       /* Zheng Gengbin 1996.5.22 */
       }
    |  block_data {
                                     /* zheng.gb 1996.5.5 */
          newProgram_g=makeProgram(fi,SMNULL);
          add_scope_level(newProgram_g,NON);
          outer_scope = 1;
          default_access = 0;       /* Zheng Gengbin 1996.5.22 */
       }
    |  main_program {
                                     /* zheng.gb 1996.5.5 */
          newProgram_g=makeProgram(fi,SMNULL);
          add_scope_level(newProgram_g,NON);
          outer_scope = 1;
          default_access = 0;       /* Zheng Gengbin 1996.5.22 */
       }
    ;
       
main_program             
    :  specification...
       executable...
       internal_subprogram_part
       end_program_stmt cmnt {
          $$ = makeMain_l(BFNULL,$1,$2,$3,$4); 
                                                           /* add by zheng.gb */
          if ($4->control_parent->variant != PROG_HEDR )
                err_g("Unexpected end of program :",lineNum_g,newProgram_g->entry.Template.symbol->ident);
          }
    |  executable...
       internal_subprogram_part
       end_program_stmt cmnt {
          $$ = makeMain_l(BFNULL,BFNULL,$1,$2,$3); 
                                                        /* add by zheng.gb */
            if ($3->control_parent->variant != PROG_HEDR )
                err_g("Unexpected end of program :",lineNum_g,newProgram_g->entry.Template
.symbol->ident);
          }
    |  program_stmt cmnt
       specification...
       executable...
       internal_subprogram_part
       end_program_stmt cmnt {
          $$ = makeMain_l($1,$3,$4,$5,$6); 
                                                        /* add by zheng.gb */
          if ($6->control_parent->variant != PROG_HEDR )
                err_g("Unexpected end of program :",lineNum_g,$1->entry.Template
.symbol->ident);
          }
    |  program_stmt cmnt
       executable...
       internal_subprogram_part
       end_program_stmt cmnt {
          $$ = makeMain_l($1,BFNULL,$3,$4,$5); 
                                                        /* add by zheng.gb */
          if ($5->control_parent->variant != PROG_HEDR )
                err_g("Unexpected end of program :",lineNum_g,$1->entry.Template
.symbol->ident);
          }
    ;

program_stmt
    :  PROGRAM progname  {
          $$ = makeProgram(fi,$2); 
          /*add_scope_level($$,NON);*/
          }
    ;
       
end_program_stmt
    :  ENDPROGRAM opt_name {
          PTR_SYMB s;

          $$ = makeEnd(fi);
          if ($2) {
                if (strcasecmp(pred_bfnd->entry.Template.symbol->ident,$2) !=0)
                {
                err_g("Program name not matched :",lineNum_g,$2);
                s= makeSymbUnithead(fi,PROGRAM_NAME,$2);
                }
           else
                s=pred_bfnd->entry.Template.symbol;
                $$->entry.Template.symbol=s;
          }
          endlineNum();
          delete_beyond_scope_level(pred_bfnd);
          lblDoErrSearch();
          }
    |  END  {
          $$ = makeEnd(fi);
          endlineNum();  
          delete_beyond_scope_level(pred_bfnd);
          lblDoErrSearch();
          }
    ;
       
specification...
    :  specification cmnt  {
          if(debugFlag_g==1) printf("Specification...\n");
          $1->entry.Template.cmnt_ptr=$2;
          if(($1->variant!=INTERFACE_STMT)&&($1->variant!= STRUCT_DECL))
             $$ = setBfndList(BFNULL,$1);
          }
    |  specification... specification cmnt {
          if(debugFlag_g==1) printf("Specification...\n");
          $2->entry.Template.cmnt_ptr=$3;
          if(($2->variant!=INTERFACE_STMT)&&($2->variant!=STRUCT_DECL)) 
             $$ = setBfndList($1,$2); 
          }
    |  error {
        if(debugFlag_g==1) printf("error_here\n");
        errResynch();
         $$ = BFNULL;
        }
    ;
       
executable...
    :  {
          $$ = BFNULL; 
          }
    |  executable... opt_label1 executable  cmnt {
          if(debugFlag_g==1) printf("Executable...\n"); 
          $$ = lnkStmts($1,$2,$3,$4);
          }
    ;
       
external_subprogram      
    :  function_subprogram
    |  subroutine_subprogram
    ;
       
function_subprogram      
    :  function_stmt cmnt
       specification...
       executable...
       internal_subprogram_part
       end_function_stmt cmnt {
          $$ = makeMain_l($1,$3,$4,$5,$6); 
          }
    |  function_stmt cmnt
       executable...
       internal_subprogram_part
       end_function_stmt cmnt {
          $$ = makeMain_l($1,BFNULL,$3,$4,$5);
          }
    ;
       
subroutine_subprogram    
    :  subroutine_stmt cmnt
       specification...
       executable...
       internal_subprogram_part
       end_subroutine_stmt cmnt {
          $$ = makeMain_l($1,$3,$4,$5,$6);
          }
    |  subroutine_stmt cmnt
       executable...
       internal_subprogram_part
       end_subroutine_stmt cmnt {
          $$ = makeMain_l($1,BFNULL,$3,$4,$5);
          }
    ;
       
module                   
    :  module_stmt cmnt
       specification...
       module_subprogram_part
       end_module_stmt cmnt {
          $$ = makeMain_l($1,$3,BFNULL,$4,$5);
          $1->entry.block_data.blockdata_end=$5;
          }
    |  module_stmt cmnt
       module_subprogram_part
       end_module_stmt cmnt {
          $$ = makeMain_l($1,BFNULL,BFNULL,$3,$4);
          $1->entry.block_data.blockdata_end=$4;
          }
    ;
       
module_subprogram_part   
    :  {
          $$ = BFNULL; 
          }
    |  contains_stmt cmnt
       module_subprogram... {
          containsNum_g--; 
          }
    ;
       
module_subprogram...     
    :  module_subprogram
    |  module_subprogram... module_subprogram {
          PTR_BFND p;
          for(p=$1;p->entry.prog_stmt.next_prog;p=p->entry.prog_stmt.next_prog)
             ;
          p->entry.prog_stmt.next_prog=$2;
          }
    ;
       
module_subprogram        
    :  function_subprogram
    |  subroutine_subprogram
    ;
       
module_stmt
    :  MODULE name {
          PTR_SYMB s;
          s= makeSymbUnithead(fi,MODULE_NAME,$2);
          $$ = makeModule(fi,s); 
          /*add_scope_level($$,NON);*/
          }
    ;
       
end_module_stmt
    :  ENDMODULE opt_name {
          PTR_SYMB s;

          $$ = makeEnd(fi);
          endlineNum();  
                                        /* add by zheng.gb */
          if ($2) {
                if (strcasecmp(pred_bfnd->entry.Template.symbol->ident,
$2) !=0 )
                {
                err_g("Moudle name not matched :",lineNum_g,$2);
                s= makeSymbUnithead(fi,MODULE_NAME,$2);
                }
           else
                s=pred_bfnd->entry.Template.symbol;
                $$->entry.Template.symbol=s;
          }
          delete_beyond_scope_level(pred_bfnd);
          lblDoErrSearch();
          }
    |  END {
          $$ = makeEnd(fi);
          endlineNum();  
          delete_beyond_scope_level(pred_bfnd);
          lblDoErrSearch();
          }
    ;
       
block_data               
    :  block_data_stmt cmnt
       specification...
       end_block_data_stmt cmnt {
          $$ = makeMain_l($1,$3,BFNULL,BFNULL,$4);
          $1->entry.module_stmt.module_end=$4;
          }
    |  block_data_stmt cmnt
       end_block_data_stmt cmnt {
          $$ = makeMain_l($1,BFNULL,BFNULL,BFNULL,$3);
          $1->entry.module_stmt.module_end=$3;
          }
    ;
       
block_data_stmt
    :  BLOCKDATA blockname {
          $$ = makeBlock(fi,$2);
          /*add_scope_level($$,NON);*/
          }
    ;
       
end_block_data_stmt
    :  ENDBLOCKDATA opt_name {
          PTR_SYMB s;

          $$ = makeEnd(fi);
          if ($2) {
                if (strcasecmp(pred_bfnd->entry.Template.symbol->ident,$2) !=0)
                {
                err_g("Block data name not matched :",lineNum_g,$2);
                s= makeSymbUnithead(fi,BLOCKDATA_NAME,$2);
                }
           else
                s=pred_bfnd->entry.Template.symbol;
                $$->entry.Template.symbol=s;
          }
          endlineNum();
          delete_beyond_scope_level(pred_bfnd); 
          }
    |  END  {
          $$ = makeEnd(fi);
          endlineNum();
          delete_beyond_scope_level(pred_bfnd); 
          }
    ;
       
internal_subprogram_part 
    :  {
          $$ = BFNULL; 
          }
    |  contains_stmt cmnt
       internal_subprogram... {
          containsNum_g--; 
          }
    ;
        
internal_subprogram...   
    :  internal_subprogram
    |  internal_subprogram... internal_subprogram {
          PTR_BFND p;
          for(p=$1;p->entry.prog_stmt.next_prog;p=p->entry.prog_stmt.next_prog)
             ;
          p->entry.prog_stmt.next_prog=$2;
          }
    ;
       
internal_subprogram      
    :  function_subprogram
    |  subroutine_subprogram
    ;
       
       
cmnt
    :  CARRIAGE1 {
          if(debugFlag_g==1) printf("cmnt :carriage\n");
          lineNum_g++;
          lineNum_l++;
          lineNum_g=lineNum_g + countCont;
          lineNum_l=lineNum_l + countCont;
          $$ = CMNULL;
          }
    |  CARRIAGE2 {
          if(debugFlag_g==1) printf("cmnt :carriage ;\n");
          $$ = CMNULL;
          }
    |  CARRIAGE2  CARRIAGE1 {              /* add by zheng.gb */
          if(debugFlag_g==1) printf("cmnt : ; carriage \n");
          $$ = CMNULL;
          }
    |  CARRIAGE2 COMMENT {                 /* add by zheng.gb */
          $$ = CMNULL;
          }
    |  COMMENT    {
          $$ = CMNULL;  
          }
    ;
       
function_stmt
    :  prefix... FUNCTION funcname func_arglist opt_result {
          int status=outer_scope;

          install_param_list($3, $4, $5, FUNCTION_NAME);
          $$ = makeFunction(fi,$3,$4,$5,$1);
          if (containsNum_g!=0 || status==0) 
                         add_scope_level($$,NON);
/* the next statement is added by Feng Xiaobing, which is a flag of PARAMETER
        statement appearance */
          para_app_flag = NON;
                                               /* add by zheng.gb 1996.5.5*/
          $3->decl= 0;
          if (vartype) {
             $3->decl= HARD;
             $3->type=vartype;
          }
                                       /* add by zheng.gb 1996.5.9 */
          setimpl(global_float, 'A', 'Z');
          setimpl(global_int, 'I', 'N');
          if ($3->type == NULL){
                $3->type=impltype[toupper($3->ident[0])-'A'];
          }
          vartype = TYNULL;
          }
    |  FUNCTION funcname func_arglist opt_result {
          int status=outer_scope;

          install_param_list($2,$3,$4,FUNCTION_NAME);
          $$ = makeFunction(fi,$2,$3,$4,LLNULL);
          if (containsNum_g!=0 || status==0) 
                         add_scope_level($$,NON);
/* the next statement is added by Feng Xiaobing, which is a flag of PARAMETER
        statement appearance */
          para_app_flag = NON;
                                               /* add by zheng.gb 1996.5.5*/
          $2->decl= 0;
                                       /* add by zheng.gb 1996.5.9 */
          setimpl(global_float, 'A', 'Z');
          setimpl(global_int, 'I', 'N');
          $2->type=impltype[toupper($2->ident[0])-'A'];
          vartype = TYNULL;
          }
    ;
       
subroutine_stmt
    :  SUBROUTINE procname arglist {
          int status=outer_scope;

          install_param_list($2,$3,LLNULL, PROCEDURE_NAME);
          $$ = makeSubroutine(fi,$2,$3,LLNULL);
          if (containsNum_g!=0 || status==0) 
                         add_scope_level($$,NON);
          vartype = TYNULL;
/* the next statement is added by Feng Xiaobing, which is a flag of PARAMETER
        statement appearance */
          para_app_flag = NON;
                                       /* add by zheng.gb 1996.5.9 */
          setimpl(global_float, 'A', 'Z');
          setimpl(global_int, 'I', 'N');
          }
    |  prefix... SUBROUTINE procname arglist {
          int status=outer_scope;

          install_param_list($3, $4, LLNULL, PROCEDURE_NAME);
          $$ = makeSubroutine(fi,$3,$4,$1);
          if (containsNum_g!=0 || status==0) 
                         add_scope_level($$,NON);
/* the next statement is added by Feng Xiaobing, which is a flag of PARAMETER
        statement appearance */
          para_app_flag = NON;
                                       /* add by zheng.gb 1996.5.9 */
          setimpl(global_float, 'A', 'Z');
          setimpl(global_int, 'I', 'N');
          }
    ;
       
end_function_stmt
    :  ENDFUNCTION opt_name {
          PTR_SYMB s;

          $$ = makeEnd(fi); 
          if ($2) {
                if (strcasecmp(pred_bfnd->entry.Template.symbol->ident,$2) !=0)
                {
                err_g("Function name not matched :",lineNum_g,$2);
                s= makeSymbUnithead(fi,FUNCTION_NAME,$2);
                }
           else
                s=pred_bfnd->entry.Template.symbol;
                $$->entry.Template.symbol=s;
          }
          endlineNum();
          delete_beyond_scope_level(pred_bfnd); 
          lblDoErrSearch();
          }
    |  END  {
          $$ =  makeEnd(fi);
          endlineNum();
          delete_beyond_scope_level(pred_bfnd);
          lblDoErrSearch();
          }
    ;
       
end_subroutine_stmt
    :  ENDSUBROUTINE opt_name {
          PTR_SYMB s;

          $$ = makeEnd(fi);
          if ($2) {
                if (strcasecmp(pred_bfnd->entry.Template.symbol->ident,$2) !=0)
                {
                err_g("Procedure name not matched :",lineNum_g,$2);
                s= makeSymbUnithead(fi,PROCEDURE_NAME,$2);
                }
           else
                s=pred_bfnd->entry.Template.symbol;
                $$->entry.Template.symbol=s;
          }
          endlineNum();
          delete_beyond_scope_level(pred_bfnd);
          lblDoErrSearch();
          }
    |  END {
          $$ = makeEnd(fi);  
          endlineNum();
          delete_beyond_scope_level(pred_bfnd);
          lblDoErrSearch();
          }
    ;
       
progname                 
    :  name {
          $$ = makeSymbUnithead(fi,PROGRAM_NAME,$1); 
          }
    ;
       
blockname                 
    :  {
          $$ = SMNULL ; 
          }
    |  name {
          $$ = makeSymbUnithead(fi,BLOCKDATA_NAME,$1);
          }
    ;
       
procname                  
    :  name {
          $$ = makeSymbUnithead(fi,PROCEDURE_NAME,$1);  
          }
    ;
       
funcname                  
    :  name {
          $$ = makeSymbUnithead(fi,FUNCTION_NAME,$1);  
          }
    ;
       
       
func_arglist                          /* add by Zheng Gengbin   1996.7.10 */
    : LEFTBRACKET RIGHTBRACKET {
          $$ = SMNULL; 
          }
    |  LEFTBRACKET needkeywordsoff dummy_args needkeywordson RIGHTBRACKET    {
          $$ = $3; 
          }
    ;
       
arglist                   
    :  {
          $$ = SMNULL; 
          }
    |  LEFTBRACKET RIGHTBRACKET {
          $$ = SMNULL; 
          }
    |  LEFTBRACKET needkeywordsoff dummy_args needkeywordson RIGHTBRACKET    {
          $$ = $3; 
          }
    ;
       
dummy_args               
    :  dummy_arg
    |  dummy_args COMMA dummy_arg {
          $$ = set_id_list($1, $3); 
          }
    ;
       
dummy_arg                
    :  name   {
         /* $$ = makeSymbVar(fi,cur_scope(),INPUT,$1,1); */
          $$ = makeSymbUnithead(fi,VARIABLE_NAME,$1);
          $$->decl=SOFT ;                /* zheng.gb 1996.5.5 */
          $$->entry.var_decl.local = INPUT;
                                                /*  modified zheng.gb */
          $$->type = impltype[toupper($$->ident[0]) - 'A'];
          }
    |  MULTIPLY    {
                                                /* modified by zheng.gb */
/*
          $$ = fi->head_symb;
*/
	  $$ = make_symb(fi,VARIABLE_NAME,"*");
                                                /* added by zheng.gb */
          $$->id_list = SMNULL;
          }
    ;
       
opt_result
    :  {
          $$ = LLNULL; 
          }
    |  RESULT LEFTBRACKET name RIGHTBRACKET  {
          PTR_SYMB s;
/*                                             zheng.gb 1996.5.22
          s= makeSymbVar(fi,cur_scope(),OUTPUT,$3,1); 
*/
          s = makeSymbUnithead(fi,VARIABLE_NAME,$3);
          $$ = makeLlnd(fi, VAR_REF, LLNULL, LLNULL, s);
          }
    ;
       
opt_name
    :     {                                 /* added by zheng.gb */
          $$=NULL;
          }
    |  name {
          $$=$1;
          }
    ;
       
name
    :  NAME {
          char *tmp;
          char *trim_blank();

          tmp = copys(yytext);
          $$ = trim_blank(tmp);                  /* add by zheng.gb 1996.5.15*/ 
          if(debugFlag_g==1) printf("name:%s\n",$$);
          }
    ;
       
prefix...
    :  prefix {
          $$=makeLlnd(fi,EXPR_LIST,$1,LLNULL,SMNULL); 
          }
    |  prefix...  prefix {
          $$=set_ll_list($1,$2,EXPR_LIST);  
          }
    ;
        
prefix
    :  PURE   {
          $$ = makeLlnd(fi,PREFIX_PURE,LLNULL,LLNULL,SMNULL); 
          }
    |  extrinsic_prefix
    |  RECURSIVE   {
          $$ = makeLlnd(fi,PREFIX_RECURSIVE,LLNULL,LLNULL,SMNULL);
          }
    |  type_spec 
    ;
       
extrinsic_prefix
    :  EXTRINSIC  LEFTBRACKET extrinsic_kind_keyword
       RIGHTBRACKET {
          $$ = makeLlnd(fi,PREFIX_EXTRINSIC,$3,LLNULL,SMNULL); /* xli 5/12/97 */
          }
    ;
       
extrinsic_kind_keyword
    :  HPF    {
          $$ = makeLlnd(fi,PREFIX_HPF,LLNULL,LLNULL,SMNULL);
          }
    |  HPF_LOCAL   {
          $$ = makeLlnd(fi,PREFIX_HPFLOCAL,LLNULL,LLNULL,SMNULL);
          }
    ;
       
       
in_prog
    :  {
/*                         zheng.gb    1996.5.5
          PTR_SYMB s;

          if (pred_bfnd->variant == GLOBAL)
             {  s = makeSymbUnithead(fi,PROGRAM_NAME,"PROG_NAME");
                newProgram_g  = makeProgram(fi,s);
                add_scope_level(newProgram_g,NON);

                s = fi->head_symb;
                do {
                    if ((s -> variant != PROGRAM_NAME)&&
                        (s -> variant != MODULE_NAME)&&
                        (s -> variant != FUNCTION_NAME)&&
                        (s -> variant != BLOCKDATA_NAME)&&
                        (s -> variant != PROCEDURE_NAME)&&
                        (s -> variant != DEFAULT)&&
                        (s->scope == global_bfnd))
                        s->scope = newProgram_g;
                    s=s->thread;
                 } while (s!= NULL);

              }
*/
          }
    ;

/*************    Grammar for specification        ****************/
/*************         8 . 25 . 1995           ********************/
       
specification
    :  implicit_stmt   
    |  use_stmt       
/*    |  entry_stmt               commented by zheng.gb  1996.5.4 */
    |  format_stmt                /* zheng.gb 1996.5.6 */
    |  interface_block
    |  parameter_stmt  
    |  derived_type_def
    |  type_declaration_stmt  
    |  common_stmt     
    |  data_stmt      
    |  dimension_stmt
    |  save_stmt       
    |  equivalence_stmt
    |  external_stmt   
    |  intrinsic_stmt  
    |  namelist_stmt  
    |  intent_stmt   
    |  access_stmt     /* it contains public & private */
    |  optional_stmt
    |  pointer_stmt
    |  target_stmt
    |  allocatable_stmt
    |  sequence_stmt   
    |  INCLUDE char_literal_constant in_prog {
          $$ = makeInclude(fi,$2);
          }
    ;
       
       
implicit_stmt            
    :  IMPLICIT implicit_spec in_prog {
          PTR_LLND l;
          l = makeLlnd(fi, EXPR_LIST, $2, LLNULL, SMNULL);
          $$ = makeImplicit(fi,IMPL_DECL,l);
          }
    |  implicit_stmt  COMMA implicit_spec {
          PTR_LLND l;
          l = makeLlnd(fi, EXPR_LIST, $3, LLNULL, SMNULL);
          add_to_lowLevelList(l, $1->entry.implicit_decl.list);
          }
    |  IMPLICIT NONE in_prog {
          $$ = makeImplicit(fi,IMPL_DECL,LLNULL);
        /* the next statement is added by Feng Xiaobing */
          if (para_app_flag==YES)
                err_g("cannot appear after PARAMETER statement",lineNum_g,"IMPLICIT NONE statement");
          else implicitNone_g = YES;
          /*implicitNone_g = YES;*/
          }
    ;
       
       
implicit_spec            
    :  type_spec LEFTBRACKET2  /* LEFTBRACKET */
       letter_spec_list RIGHTBRACKET {
          $$ = makeLlnd(fi,IMPL_TYPE,$3,$1,SMNULL);
          vartype=TYNULL;          /* add by zheng.gb 1995.5.5 */
          }
    ;
       
letter_spec_list         
    :  letter_spec {
          $$ = makeLlnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);
          }
    |  letter_spec_list COMMA letter_spec {
          $$ = set_ll_list($1, $3, EXPR_LIST);
          }
    ;
       
letter_spec              
    :  letter MINUS letter {
          PTR_LLND p,q;
                                        /* modified by zheng.gb */
          setimpl(vartype, toupper((int)$1), toupper((int)$3));
          p = makeLlnd(fi,CHAR_VAL, LLNULL, LLNULL, SMNULL);
          p->entry.cval = $1; 
          q = makeLlnd(fi,CHAR_VAL, LLNULL, LLNULL, SMNULL);
          q->entry.cval = $3;  
          $$= makeLlnd(fi,DDOT, p, q, SMNULL);
          }
    |  letter {
                                        /* modified by zheng.gb */
          setimpl(vartype, toupper((int)$1), toupper((int)$1));
          $$ = makeLlnd(fi,CHAR_VAL, LLNULL, LLNULL, SMNULL);
          $$->entry.cval = $1;  
          }
    ;
       
/*
letter
    :  NAME {
          $$=yytext[0];
          }
    ;
*/
letter
    :  IMPLICITLETTER {
          $$=yytext[0];
          }
    ;
       
use_stmt                 
    :  USE module_name COMMA rename_list in_prog {
          $$=makeUse(fi,$2,LLNULL,$4);
          link_uselist($2,$$); /* added by Yanmi*/
          }
    |  USE module_name in_prog {
          $$=makeUse(fi,$2,LLNULL,LLNULL);
          link_uselist($2,$$); /*added by Yanmi*/
          }
    |  USE module_name COMMA ONLY COLON only_list in_prog {
          PTR_LLND l;
          l = makeLlnd(fi, ONLY_NODE, $6, LLNULL, SMNULL);
          $$ = makeUse(fi,$2,l,LLNULL);
          }
    |  USE module_name COMMA ONLY COLON in_prog {
          PTR_LLND l;
          l = makeLlnd(fi, ONLY_NODE, LLNULL, LLNULL, SMNULL);
          $$ = makeUse(fi,$2,l,LLNULL);
          }
    ;
       
       
module_name                   
    :  name {
          $$ = lookupSymbModule($1);
          if ($$==SMNULL)
             $$= makeSymbUnithead(fi,MODULE_NAME,$1);
          module_name = $$; 
          }
    ;
       
rename_list              
    :  rename {
          $$ = set_ll_list($1, LLNULL, EXPR_LIST); 
          }
    |  rename_list COMMA rename {
          $$ = set_ll_list($1, $3, EXPR_LIST);
          }
    ;
       
rename                   
    :  name EQGT name {
          PTR_LLND l, m;        
          PTR_SYMB s1,s2;
          s1=makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          s2=lookupSymbrename($3,module_name);
          s1->entry.Template.declared_name=s2;  
          l = makeLlnd(fi, VAR_REF, LLNULL, LLNULL, s2);
          m = makeLlnd(fi, VAR_REF, LLNULL, LLNULL, s1);
          $$ = makeLlnd(fi, RENAME_NODE, m, l, SMNULL);  
          }
    ;
        
only_list                
    :  only {
          $$ = set_ll_list($1, LLNULL, EXPR_LIST); 
          }
    |  only_list COMMA only {
          $$ = set_ll_list($1, $3, EXPR_LIST);
          }
    ;
        
only                     
    :  name EQGT name {
          PTR_LLND l, m;
          PTR_SYMB s1,s2;
          s1=makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          s2=lookupSymbrename($3,module_name);
          s1->entry.Template.declared_name=s2;
          l = makeLlnd(fi, VAR_REF, LLNULL, LLNULL, s2);
          m = makeLlnd(fi, VAR_REF, LLNULL, LLNULL, s1);
          $$ = makeLlnd(fi,RENAME_NODE, m, l, SMNULL);
/* HIT
          $$ = makeLlnd(fi,ONLY_NODE, m, l, SMNULL);
*/
          }
    |  name    {
          PTR_LLND  m;
          PTR_SYMB s1,s2;
          s2=lookupSymbrename($1,module_name);
          /*added by Yanmmi*/
          s1=makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          s1->entry.Template.declared_name=s2;
/* HIT */                    /* zheng.gb  1995.5.13   s2=>s1 */
          $$ = makeLlnd(fi, VAR_REF, LLNULL, LLNULL,s1 );
/*
          m = makeLlnd(fi, VAR_REF, LLNULL, LLNULL,s2 );
          $$ = makeLlnd(fi, ONLY_NODE, m, LLNULL, SMNULL);
*/
          }
/*  | access_id        */
/* HIT */
    |  OPERATOR LEFTBRACKET
       operator RIGHTBRACKET {
          PTR_SYMB s2;
          if(debugFlag_g==1) printf(" only .operator.\n");
          s2=lookupSymbrename($3->ident,module_name);
          $$ = makeLlnd(fi, VAR_REF, LLNULL, LLNULL,s2 );
          /*  Lxy 4/26 */
          }
    |  ASSIGNMENT
       LEFTBRACKET EQUAL RIGHTBRACKET {
          PTR_SYMB s;
          if(debugFlag_g==1) printf(" assignment= \n");
          s=lookupSymbrename("=",module_name);
          $$ = makeLlnd(fi, VAR_REF, LLNULL, LLNULL,s );
          /* $$ = makeSymb(fi,cur_scope(),INTERFACE_NAME,"=",1); */
          /*  Lxy 4/26 */
          }
    ;
       
entry_stmt
    :  ENTRY name arglist opt_result in_prog {
          PTR_BFND bif;
          PTR_SYMB q;
          bif = cur_scope();
          if (bif->variant == FUNC_HEDR) 
             q = makeSymbUnithead(fi,FUNCTION_NAME,$2);
          else   {
             if ((bif->variant == PROC_HEDR) || (bif->variant == PROG_HEDR)) 
                q = makeSymbUnithead(fi,PROCEDURE_NAME,$2);
             }
          install_param_list(q,$3,$4,bif->variant);
          $$ = makeEntry(fi,q,$3,$4);
          q=$$->entry.Template.symbol;/*added by Yanmi*/
          q->attr=q->attr | ENTRY_BIT;
          /* by Yanmi*/
          q->scope=bif->entry.Template.symbol->scope;
          q->entry.Template.func_hedr=$$;

          }
    ;
       
       
interface_block          
    :  interface_stmt cmnt
       interface_body...
       module_procedure_stmt...
       end_interface_stmt  {
                                /*add by zheng.gb */
          PTR_BLOB blob;
          PTR_BFND bfnd;
	  PTR_LLND llnd;

          $$ = makeMain_l($1,$3,$4,BFNULL,$5);
          $1->entry.interface.interface_end=$5;

/* modified the scope of defined function ,so that others can find them */
                                        /* add by zheng.gb */
/*
             for (blob= $1->entry.interface.control;blob->next;blob=blob->next)
             {
                bfnd = blob->ref;
                if (bfnd->entry.Template.symbol)
                      bfnd->entry.Template.symbol->scope = $1->control_parent;
		else if (bfnd->variant== MODULE_PROC_STMT)
			{
			  for (llnd=bfnd->entry.Template.ll_ptr1;llnd;
				llnd=llnd->entry.Template.ll_ptr2)
				llnd->entry.Template.ll_ptr1->entry.Template.symbol->scope=$1->control_parent;
			}
             }
*/
          }
    ;
       
interface_body...        
    :  {
          $$ = BFNULL; 
          }
    |  interface_body... interface_body {
          if ($1==BFNULL) 
             $$=$2;
          }
    ;
       
module_procedure_stmt... 
    :  {
          $$ = BFNULL; 
          }
    |  module_procedure_stmt...
       module_procedure_stmt cmnt {
          $$ = setBfndList($1,$2);  
          }
    ;
       
end_interface_stmt       
    :  ENDINTERFACE  {
          $$ = makeEnd (fi); 
          endlineNum();
          delete_beyond_scope_level(pred_bfnd);
          }
    ;
       
interface_body           
    :  function_stmt cmnt
       specification...
       end_function_stmt cmnt {
          $$ = makeMain_l($1,$3,BFNULL,BFNULL,$4);
          }
    |  function_stmt cmnt
       end_function_stmt cmnt {
          $$ = makeMain_l($1,BFNULL,BFNULL,BFNULL,$3);
          }
    |  subroutine_stmt cmnt
       specification...
       end_subroutine_stmt cmnt {
          $$ = makeMain_l($1,$3,BFNULL,BFNULL,$4);
          }
    |  subroutine_stmt cmnt
       end_subroutine_stmt cmnt {
          $$ = makeMain_l($1,BFNULL,BFNULL,BFNULL,$3);
          }
    ;
       
module_procedure_stmt    
    :  MODULE PROCEDURE 
       procedure_name_list  {
          if(debugFlag_g==1) printf("module_proc\n");
          $$ = makeVarlistdecl(fi,MODULE_PROC_STMT,$3);
          }
    ;
       
procedure_name_list      
   :  name /*procedure_*/ {
          PTR_SYMB s;
          PTR_LLND p, q;
          s=makeSymbUnithead(fi,PROCEDURE_NAME,$1);
          s->variant = ROUTINE_NAME;
          q = makeLlnd(fi, VAR_REF, LLNULL, LLNULL, s);
          $$ = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
          }
    |  procedure_name_list COMMA name {
          PTR_LLND p, q;
          PTR_SYMB s;
          s = makeSymbUnithead(fi,PROCEDURE_NAME,$3);
          s->variant = ROUTINE_NAME;
          p = makeLlnd(fi, VAR_REF, LLNULL, LLNULL, s);
          q = makeLlnd(fi,EXPR_LIST, p, LLNULL, SMNULL);
/*                          zheng.gb 1996.5.7
          add_to_lowLevelList(q, $1->entry.Template.ll_ptr1);
*/
	  for (p=$1 ; p->entry.Template.ll_ptr2 ; p=p->entry.Template.ll_ptr2);
	  p->entry.Template.ll_ptr2 = q;
          }
    ;
                                
interface_stmt           
    :  INTERFACE generic_spec in_prog {
          $$= makeInterface(fi,$2);
          link_interfacelist($$);     /* zheng.gb 1996.5.10 */
          add_scope_level($$,NON);
          }
    |  INTERFACE  in_prog {
          PTR_SYMB s;
                                         /* zheng.gb 1996.5.20 */
          s=make_symb(fi,INTERFACE_NAME,NULL_UNIT_HEAD);
          $$ = makeInterface(fi,s); 
          link_interfacelist($$);     /* zheng.gb 1996.5.10 */
          add_scope_level($$,NON);
          }
    ;
       
generic_spec
    :  name   {
/*
          $$ = makeSymbUnithead(fi,FUNCTION_NAME,$1);
          $$->variant = INTERFACE_NAME;
*/
          PTR_SYMB s;                                /* add by zheng.gb */

          s= lookupSymb($1,cur_scope()->entry.prog_stmt.prog_symb);
          if (s==NULL )
                s = makeSymbUnithead(fi,INTERFACE_NAME,$1);
          $$ = s;
          }
    |  OPERATOR LEFTBRACKET
       operator RIGHTBRACKET {
          if(debugFlag_g==1) printf(" .operator.\n");
          $$=$3;

          $$->attr=$$->attr | DEFINED_OPERATOR_BIT; /*added by Yanmi*/
          }
    |  ASSIGNMENT
       LEFTBRACKET EQUAL RIGHTBRACKET {
          PTR_SYMB s; 
          if(debugFlag_g==1) printf(" assignment= \n");
/*
          $$ = makeSymb(fi,cur_scope(),INTERFACE_NAME,"=",1);
*/
                                                        /* add by zheng.gb */
          s= lookupSymb("=",cur_scope()->entry.prog_stmt.prog_symb);
          if (s==NULL )
             s = makeSymb(fi,cur_scope(),INTERFACE_NAME,"=",1);
          $$ = s;

          $$->attr=$$->attr | DEFINED_ASSIGNMENT_BIT; /*added by Yanmi*/
          }
    ;
       
operator
    :  defined_operator  {
          PTR_SYMB s;
/*
          $$ = makeSymb(fi,cur_scope(),INTERFACE_NAME,$1,1);
*/
                                                        /* add by zheng.gb */
          s= lookupSymb($1,cur_scope()->entry.prog_stmt.prog_symb);
          if (s==NULL )
             s = makeSymb(fi,cur_scope(),INTERFACE_NAME,$1,1);
          $$=s;
          }
    |  intrinsic_operator {
          $$ = lookupOp($1);
          }
    ;
       
defined_operator
    :  DEFINED_OPERATOR {
          $$ = copys(yytext); 
          }
    ;
       
intrinsic_operator       
    :  rel_op
    |  not_op
    |  or_op
    |  and_op
    |  equiv_op
    |  concat_op
    |  add_op
    |  mult_op
    |  power_op
    ;
       
parameter_stmt           
    :  PARAMETER LEFTBRACKET named_constant_def_list
       RIGHTBRACKET in_prog {
          $$=makeVarlistdecl(fi,PARAM_DECL,$3);
          }
    ;
       
named_constant_def_list  
    :  named_constant_def {
          $$ = set_ll_list($1, LLNULL, EXPR_LIST); 
          }
    |  named_constant_def_list COMMA
       named_constant_def {
          $$ = set_ll_list($1, $3, EXPR_LIST); 
          }
    ;

named_constant_def                               /* modified by Feng Xiaobing */
    :  name EQUAL expr {
          PTR_SYMB s;
          s = makeSymbConst(fi,$1);
          if (s->type == TYNULL)
                err_g("variable declared no type !",lineNum_g,$1);
          if (s->attr & PARAMETER_BIT)
                err_g("variable redeclaration",lineNum_g,$1);
          else s->attr = s->attr | PARAMETER_BIT;
          s->variant = CONST_NAME;
          s->entry.Template.const_value = $3;
          $$ = makeLlnd(fi,CONST_REF, LLNULL, LLNULL, s);
          }
    ;
       
common_stmt              
    :  COMMON  comblock  common_block_object in_prog  {
          PTR_LLND p, q;
          p = makeLlnd(fi,EXPR_LIST, $3, LLNULL, SMNULL);
          q = makeLlnd(fi,COMM_LIST, p, LLNULL, $2);
          $$ = makeNest(fi,COMM_STAT,q);
          }
    |  COMMON  common_block_object  in_prog {
          PTR_LLND p, q;
          p = makeLlnd(fi,EXPR_LIST, $2, LLNULL, SMNULL);
          q = makeLlnd(fi,COMM_LIST, p, LLNULL, SMNULL);
          $$ = makeNest(fi,COMM_STAT,q); 
          }
    |  common_stmt opt_comma1 comblock /* opt_comma1 */ common_block_object {
          PTR_LLND p, q;
          p = makeLlnd(fi,EXPR_LIST, $4, LLNULL, SMNULL);
          q = makeLlnd(fi,COMM_LIST, p, LLNULL, $3);
          add_to_lowList(q, $1->entry.Template.ll_ptr1);
          }
    |  common_stmt COMMA common_block_object {
          PTR_LLND p, q, r;
          p = makeLlnd(fi,EXPR_LIST, $3, LLNULL, SMNULL);
/*          q = makeLlnd(fi,COMM_LIST, p, LLNULL, SMNULL);  zheng.gb 1996.5.20*/
          for (r = $1->entry.Template.ll_ptr1; r->entry.list.next; r = r->entry.list.next)
                ;
          add_to_lowLevelList(p, r->entry.Template.ll_ptr1);
          }
    ;
       
       
comblock                  
    :  DIVIDE DIVIDE {
          $$ = SMNULL; 
          }
    |  DIVIDE name DIVIDE {
          PTR_SYMB s;
/*                                              modified by zheng.gb
          $$ = makeSymbVar(fi,cur_scope(),LOCAL,$2,1);
*/
          s = lookupSymb($2,fi->head_symb);
          if (s == SMNULL)
                s = makeSymb(fi,global_bfnd,COMMON_NAME,$2,1);
          $$ = s;
          }
    ;
       
opt_comma1                 
    :   
    |  COMMA1 
    ;
       
common_block_object      
    :  name LEFTBRACKET
       explicit_shape_spec_list RIGHTBRACKET {
          PTR_SYMB s;
          s=makeSymbVar(fi,cur_scope(),LOCAL,$1,1);
          if (!(s->attr & DIMENSION_BIT)) {
                  s->attr = s->attr | DIMENSION_BIT;
                s->type = makeTypeArray($3,s->type);
          }

          s->attr=s->attr | DIMENSION_BIT;
          $$ = makeLlnd(fi,ARRAY_REF,$3,LLNULL,s);
          }
    |  name {
          PTR_SYMB s;
          s=makeSymbVar(fi,cur_scope(),LOCAL,$1,1);

          $$ = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          }
    ;
       
namelist_stmt                                     /*modified by Feng Xiaobing */
    :  NAMELIST namelist_group_name  name in_prog {
          PTR_LLND p, q,r;
          PTR_SYMB s;
          s=makeSymbVar(fi,cur_scope(),LOCAL,$3,0);
          r = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          p = makeLlnd(fi,EXPR_LIST, r, LLNULL, SMNULL);
          q = makeLlnd(fi,NAME_LIST, p, LLNULL, $2);
/*
          p = makeLlnd(fi,EXPR_LIST,LLNULL , LLNULL, s);
          r = makeLlnd(fi,EXPR_LIST,p , LLNULL, SMNULL);
          o = makeLlnd(fi,EXPR_LIST,r , LLNULL, SMNULL);
          q = makeLlnd(fi,NAME_LIST, o, LLNULL, $2);
*/
          $$ = makeNest(fi,NAMELIST_STAT,q);
          }
    |  namelist_stmt COMMA name {
          PTR_LLND p,q,r;
          PTR_SYMB s;
          s=makeSymbVar(fi,cur_scope(),LOCAL,$3,0);
          p = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          q = makeLlnd(fi,EXPR_LIST, p, LLNULL, SMNULL);
/*
          q = makeLlnd(fi,NAME_LIST, r, LLNULL, SMNULL);
          r = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          p = makeLlnd(fi,EXPR_LIST, r, LLNULL, SMNULL);
          q = makeLlnd(fi,COMM_LIST, p, LLNULL, SMNULL);
          for (r = $1->entry.Template.ll_ptr1; r->entry.list.next; r = r->entry.list.next)
                ;
*/
                                                               /*Feng Xiaobing*/
                                                        /* zheng.gb */
          add_to_lowLevelList(q, $1->entry.nest_decl.list->
                                                entry.Template.ll_ptr1);
          }
    |  namelist_stmt opt_comma1 namelist_group_name name {
          PTR_LLND p, q,r;
          PTR_SYMB s;
          s=makeSymbVar(fi,cur_scope(),LOCAL,$4,0);
          r = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          p = makeLlnd(fi,EXPR_LIST, r, LLNULL, SMNULL);
          q = makeLlnd(fi,NAME_LIST, p, LLNULL, $3);
          add_to_lowList(q, $1->entry.Template.ll_ptr1);
          }
    ;

namelist_group_name /* added by Feng Xiaobing */
        : DIVIDE name DIVIDE
                {
                        PTR_SYMB s;
                        s = lookupSymb($2,fi->head_symb);
                        if (s == SMNULL)
                                s = makeSymb(fi,global_bfnd,NAMELIST_GROUP_NAME,$2,1);
                        $$ = s;
                }
     ;

equivalence_stmt         
    :  EQUIVALENCE equivalence_set in_prog {
          $$ = makeNest(fi,EQUI_STAT,$2);
          }
    |  equivalence_stmt COMMA equivalence_set {
          add_to_lowLevelList($3, $1->entry.Template.ll_ptr1);
          }
    ;
       
       
equivalence_set          
    :  LEFTBRACKET equivalence_object_list RIGHTBRACKET {
          $$ = makeLlnd(fi,EQUI_LIST, $2,LLNULL,SMNULL);
          }
    ;
       
equivalence_object_list  
    :  equivalence_object COMMA equivalence_object {
          PTR_LLND p;
          p = makeLlnd(fi,EXPR_LIST, $3, LLNULL, SMNULL);
          $$ = makeLlnd(fi,EXPR_LIST, $1, p, SMNULL);
          }
    |  equivalence_object_list
       COMMA equivalence_object {
          PTR_LLND p;
          p = makeLlnd(fi,EXPR_LIST, $3, LLNULL, SMNULL);
          add_to_lowLevelList(p, $1);
          }
    ;
       
equivalence_object 
    : name /* variable */  {
          PTR_SYMB s;
                                /* modified by zheng.gb 1996.5.6  SOFT=>HARD */
          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,1);

          $$ = makeLlnd(fi,VAR_REF, LLNULL, LLNULL,s); 
          }
    |  array_section_element_funcref   /* array_element */
    |  substring
    ;
       
save_stmt                
    :  SAVE opt_double_colon saved_entity_list in_prog {
          $$=makeVarlistdecl(fi,SAVE_DECL,$3);
          }
    |  SAVE in_prog {
          $$=makeVarlistdecl(fi,SAVE_DECL,LLNULL);
          }
    ;
       
saved_entity_list        
    :  saved_entity {
          $$ = makeLlnd(fi,EXPR_LIST, $1, LLNULL, SMNULL); 
          }
    |  saved_entity_list  COMMA saved_entity {
          $$ = set_ll_list($1, $3, EXPR_LIST);
          }
    ;
       
saved_entity             
    :  name   {
          PTR_SYMB s;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          s->attr=s->attr | SAVE_BIT;
          $$ = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s); 
          }
    |  DIVIDE name DIVIDE {
          PTR_SYMB s;
/*modified by Feng Xiaobing
          s = makeSymbVar(fi,cur_scope(),LOCAL,$2,0); */
          s = lookupSymb($2,fi->head_symb);
          if (s == SMNULL)
                s = makeSymb(fi,global_bfnd,COMMON_NAME,$2,1);

          s->attr=s->attr | SAVE_BIT;
          $$ = makeLlnd(fi,COMM_LIST, LLNULL, LLNULL, s);
          }
    ;
       
       
dimension_stmt           
    :  DIMENSION opt_double_colon name dims in_prog {
          PTR_LLND q,r;
          PTR_SYMB s;
                             /* modified by zheng.gb 1996.5.6 SOFT=>HARD */
          s=makeSymbVar(fi,cur_scope(),LOCAL, $3,1);
          if (s->attr & DIMENSION_BIT) err_g("variable redeclaration",lineNum_g,$3);        /* added by Feng Xiaobing */
          s->attr = s->attr | DIMENSION_BIT;
          s->type=makeTypeArray($4,s->type);
          q = makeLlnd(fi,ARRAY_REF, $4, LLNULL, s);
          r = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
          $$ = makeVarlistdecl(fi,DIM_STAT,r);
          }
    |  dimension_stmt COMMA name dims {
          PTR_LLND q,r;
          PTR_SYMB s;
                             /* modified by zheng.gb 1996.5.6 SOFT=>HARD */
          s= makeSymbVar(fi,cur_scope(),LOCAL,$3,1);
          if (s->attr & DIMENSION_BIT) err_g("variable redeclaration",lineNum_g,$3);                /*added by Feng Xiaobing */
          s->attr = s->attr | DIMENSION_BIT;
          s->type=makeTypeArray($4,s->type);
          q = makeLlnd(fi,ARRAY_REF, $4, LLNULL, s);
          r = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
          add_to_lowLevelList(r, $1->entry.Template.ll_ptr1);
          }
    ;

dims
    :  {
          $$ = LLNULL; 
          }
    |  LEFTBRACKET array_spec RIGHTBRACKET {
          $$ = $2; 
          }
    ;


external_stmt            
    :  EXTERNAL name in_prog {
          PTR_LLND p, q;
          PTR_SYMB s;
/*   
          s=makeSymbUnithead(fi,PROCEDURE_NAME,$2);
          s=makeSymbVar(fi,cur_scope(),LOCAL,$2,1);
*/ 
                                    /*   modified by zheng.gb  1996.5.5 */
          s = makeSymb(fi,cur_scope(),VARIABLE_NAME,$2,1);
          /* s->variant=ROUTINE_NAME; */
          s->attr = s->attr | EXTERNAL_BIT;
          q = makeLlnd(fi, VAR_REF, LLNULL, LLNULL, s);
          p = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
/*
          $$ = makeVarlistdecl(fi,EXTERN_STAT,q);
*/
          $$ = makeVarlistdecl(fi,EXTERN_STAT,p);/*added by Yanmi*/

          }
    |  external_stmt  COMMA name {
          PTR_LLND p, q;
          PTR_SYMB s;
/*
          s=makeSymbUnithead(fi,PROCEDURE_NAME,$3);
          s=makeSymbVar(fi,cur_scope(),LOCAL,$3,1);
*/
                                    /*   modified by zheng.gb  1996.5.5 */
          s = makeSymb(fi,cur_scope(),VARIABLE_NAME,$3,1);
          /* s->variant=ROUTINE_NAME; */
          s->attr = s->attr | EXTERNAL_BIT;
          q = makeLlnd(fi, VAR_REF, LLNULL, LLNULL, s);
/* 
          p = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
          add_to_lowLevelList(q, $1->entry.Template.ll_ptr1);
*/
          /*added by Yanmi*/
          p=$1->entry.Template.ll_ptr1;
          set_ll_list(p,q,EXPR_LIST);

          }
    ;
       
       
intrinsic_stmt           
    :  INTRINSIC name in_prog {
          PTR_LLND p, q;
          PTR_SYMB s;
          s=makeSymbUnithead(fi,FUNCTION_NAME,$2);
          s->attr = s->attr | INTRINSIC_BIT; /*modified by Yanmi*/

          /* s->variant=ROUTINE_NAME;*/ /* BY Yanmi*/

          q = makeLlnd(fi, VAR_REF, LLNULL, LLNULL, s);
          p = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
          $$ = makeVarlistdecl(fi,INTRIN_STAT,p);
          }
    |  intrinsic_stmt COMMA name {
          PTR_LLND p, q;  
          PTR_SYMB s;     
          s=makeSymbUnithead(fi,FUNCTION_NAME,$3);   
          s->attr = s->attr |INTRINSIC_BIT;   /*added by Yanmi*/    

          /* s->variant=ROUTINE_NAME; */ /* BY Yanmi*/

          q = makeLlnd(fi, VAR_REF, LLNULL, LLNULL, s);
/*
          p = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
          add_to_lowLevelList(q, $1->entry.Template.ll_ptr1);
*/
          /*added by Yanmi*/
          p=$1->entry.Template.ll_ptr1;
          set_ll_list(p,q,EXPR_LIST);
          }
    ;
       
       
       
intent_stmt              
    :  INTENT LEFTBRACKET intent_spec
       RIGHTBRACKET opt_double_colon name in_prog {
          PTR_LLND q, r;
          PTR_SYMB s;
                             /* modified by zheng.gb 1996.5.6 SOFT=>HARD */
          s = makeSymbVar(fi,cur_scope(),intent_l,$6,1);
          s->attr |= type_options;
          q = makeLlnd(fi,VAR_REF, LLNULL, LLNULL, s);
          r = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
          $$ = makeIntent(fi,$3,r);
          }
    |  intent_stmt COMMA name {
          PTR_LLND q, r;
          PTR_SYMB s;
                             /* modified by zheng.gb 1996.5.6 SOFT=>HARD */
          s = makeSymbVar(fi,cur_scope(),intent_l,$3,1);
          s->attr |= type_options;
          q = makeLlnd(fi,VAR_REF, LLNULL, LLNULL, s);
          r = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
          add_to_lowLevelList(r, $1->entry.intent.list);
          }
    ;
       
intent_spec              
    :  IN    {
          intent_l=INPUT;
          type_options = type_options | IN_BIT;
          $$ = makeLlnd(fi, IN_OP, LLNULL, LLNULL, SMNULL); 
          }
    |  OUT   {
          intent_l=OUTPUT;
          type_options = type_options | OUT_BIT;
          $$ = makeLlnd(fi, OUT_OP, LLNULL, LLNULL, SMNULL); 
          }
    |  INOUT  {
          intent_l=IO;
          type_options = type_options | INOUT_BIT; 
          $$ = makeLlnd(fi, INOUT_OP, LLNULL, LLNULL, SMNULL);
          }
    ;
       
       
access_stmt              
    :  access_spec opt_double_colon access_id_list in_prog {
/*          $$ = makeVarlistdecl(fi,$1,$3);*/
/* modified by Feng Xiaobing */
                PTR_BFND p;
                p = makeVarlistdecl(fi,ACCESS_STMT,$3);
                p->entry.var_list_decl.access_expr=$1;
                $$ = p;
                type_options = 0;
          }
    |  access_spec in_prog {
/*         $$ = makeVarlistdecl(fi,$1,LLNULL);*/
/* modified by Feng Xiaobing */
                PTR_BFND p;
                p = makeVarlistdecl(fi,ACCESS_STMT,LLNULL);
                p->entry.var_list_decl.access_expr=$1;
                $$=p;
                                  /* Zheng Gengbin 1996.5.22 */
                if (pred_bfnd->variant == MODULE_STMT)
                {
                        default_access = type_options;
                }
                type_options = 0;
          }
    ;
       
access_id_list           
    :  access_id {
          $$ = makeLlnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);
          }
    |  access_id_list COMMA access_id {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;
       
access_id                
    :  name   {
          PTR_SYMB s;                                /* add by zheng.gb */

          s= lookupSymb($1,cur_scope()->entry.prog_stmt.prog_symb);
          if (s==NULL )
                s = makeSymb(fi,cur_scope(),VARIABLE_NAME,$1,1);
          s->attr |= type_options;
                               /*  default access invalid  zheng.gb 1996.5.23 */
          if (type_options != default_access)
		s->attr &= ~default_access;
          $$ = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          }
    |  OPERATOR LEFTBRACKET
       operator RIGHTBRACKET {
          if(debugFlag_g==1) printf(" .operator.\n");
          $3->attr=$$->attr | DEFINED_OPERATOR_BIT; /*added by Yanmi*/
          $3->attr |= type_options;
                               /*  default access invalid  zheng.gb 1996.5.23 */
          if (type_options != default_access)
		$3->attr &= ~default_access;
          $$=makeLlnd(fi,VAR_REF,LLNULL,LLNULL,$3);
          }
    |  ASSIGNMENT
       LEFTBRACKET EQUAL RIGHTBRACKET {
          PTR_SYMB s; 
          if(debugFlag_g==1) printf(" assignment= \n");
                                                        /* add by zheng.gb */
          s= lookupSymb("=",cur_scope()->entry.prog_stmt.prog_symb);
          if (s==NULL )
             s = makeSymb(fi,cur_scope(),INTERFACE_NAME,"=",1);

          s->attr=s->attr | DEFINED_ASSIGNMENT_BIT; /*added by Yanmi*/
          s->attr |= type_options;
                               /*  default access invalid  zheng.gb 1996.5.23 */
          if (type_options != default_access)
		s->attr &= ~default_access;
          $$ = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          }
    ;
       
       
access_spec              
    :  PUBLIC   {
          type_options = type_options | PUBLIC_BIT;
          $$ = makeLlnd(fi, PUBLIC_OP, LLNULL, LLNULL, SMNULL);
          }
    |  PRIVATE  {
          type_options = type_options | PRIVATE_BIT;
          $$ = makeLlnd(fi, PRIVATE_OP, LLNULL, LLNULL, SMNULL);
          }
    ;
       
optional_stmt            
    :  OPTIONAL opt_double_colon  name in_prog {
          PTR_LLND q, r;
          PTR_SYMB s;
                             /* modified by zheng.gb 1996.5.6 SOFT=>HARD */
          s=makeSymbVar(fi,cur_scope(),INPUT,$3,1);
          s->attr = s->attr | OPTIONAL_BIT;
          q = makeLlnd(fi,VAR_REF, LLNULL, LLNULL, s);
          r = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
          $$ = makeVarlistdecl(fi,OPTIONAL_STMT,r);
          }
    |  optional_stmt COMMA name {
          PTR_LLND q, r;
          PTR_SYMB s;
                             /* modified by zheng.gb 1996.5.6 SOFT=>HARD */
          s=makeSymbVar(fi,cur_scope(),INPUT,$3,1);
          s->attr = s->attr | OPTIONAL_BIT;
          q = makeLlnd(fi,VAR_REF, LLNULL, LLNULL, s);
          r = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
          add_to_lowLevelList(r, $1->entry.Template.ll_ptr1);
          }
    ;
       
allocatable_stmt         
    :  ALLOCATABLE opt_double_colon name dims in_prog {
          PTR_LLND q,r;
          PTR_SYMB s;
                             /* modified by zheng.gb 1996.5.6 SOFT=>HARD */
          s= makeSymbVar(fi,cur_scope(),LOCAL,$3,1);
          s->attr = s->attr | ALLOCATABLE_BIT;
          s->type=makeTypeArray($4,s->type);
          q = makeLlnd(fi,ARRAY_REF, $4, LLNULL, s);
          r = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
          $$ = makeVarlistdecl(fi,ALLOCATABLE_STMT,r);
          }
    |  allocatable_stmt COMMA name dims {
          PTR_LLND q,r;
          PTR_SYMB s;
                             /* modified by zheng.gb 1996.5.6 SOFT=>HARD */
          s= makeSymbVar(fi,cur_scope(),LOCAL,$3,1);
          s->attr = s->attr | ALLOCATABLE_BIT;
          s->type=makeTypeArray($4,s->type);
          q = makeLlnd(fi,ARRAY_REF, $4, LLNULL, s);
          r = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
          add_to_lowLevelList(r, $1->entry.Template.ll_ptr1);
          }
    ;
       
       
pointer_stmt             
    :  POINTER opt_double_colon name dims in_prog {
          PTR_LLND q,r;
          PTR_SYMB s;
                             /* modified by zheng.gb 1996.5.6 SOFT=>HARD */
          s=makeSymbVar(fi,cur_scope(),LOCAL, $3,1);
          s->attr = s->attr | POINTER_BIT;
                                        /* modified by zheng.gb */
          if ($4) s->type=makeTypeArray($4,s->type);
/*
          s->type=makeTypeArray($4,s->type);
          q = makeLlnd(fi,ARRAY_REF, $4, LLNULL, s);
*/
          q = makeLlnd(fi,$4?ARRAY_REF:VAR_REF, $4, LLNULL, s);
          r = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
          $$ = makeVarlistdecl(fi,POINTER_STMT,r);        
          }
    |  pointer_stmt COMMA name dims {
          PTR_LLND q,r;
          PTR_SYMB s;
                             /* modified by zheng.gb 1996.5.6 SOFT=>HARD */
          s= makeSymbVar(fi,cur_scope(),LOCAL,$3,1);
          s->attr = s->attr | POINTER_BIT;
                                        /* modified by zheng.gb */
          if ($4) s->type=makeTypeArray($4,s->type);
/*
          s->type=makeTypeArray($4,s->type);
          q = makeLlnd(fi,ARRAY_REF, $4, LLNULL, s);
*/
          q = makeLlnd(fi,$4?ARRAY_REF:VAR_REF, $4, LLNULL, s);
          r = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
          add_to_lowLevelList(r, $1->entry.Template.ll_ptr1);
          }
    ;
       
       
target_stmt              
    :  TARGET  opt_double_colon name dims in_prog {
          PTR_LLND q,r;
          PTR_SYMB s;
                             /* modified by zheng.gb 1996.5.6 SOFT=>HARD */
          s= makeSymbVar(fi,cur_scope(),LOCAL,$3,1);
          s->attr = s->attr | TARGET_BIT;
          s->type=makeTypeArray($4,s->type);
          q = makeLlnd(fi,ARRAY_REF, $4, LLNULL, s);
          r = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
          $$ = makeVarlistdecl(fi,TARGET_STMT,r);
          }
    |  target_stmt COMMA name dims {
          PTR_LLND q,r;
          PTR_SYMB s;
          s= makeSymbVar(fi,cur_scope(),LOCAL,$3,1);
          s->attr = s->attr | TARGET_BIT;
          s->type=makeTypeArray($4,s->type);
          q = makeLlnd(fi,ARRAY_REF, $4, LLNULL, s);
          r = makeLlnd(fi,EXPR_LIST, q, LLNULL, SMNULL);
          add_to_lowLevelList(r, $1->entry.Template.ll_ptr1);
          }
    ;
       
       
derived_type_stmt        
    :  TYPE COMMA access_spec opt_double_colon name in_prog {
          PTR_SYMB s;
/*                                            changed by zheng.gb 1996.5.16
          s = make_symb(fi,TYPE_NAME,$5);
*/
          s = makeSymb(fi,cur_scope(),TYPE_NAME,$5,1);
          s->attr = s->attr | type_options;
          $$ = makeDerived(fi,s,$3);
          add_scope_level($$,NON); 
          }
    |  TYPE opt_double_colon name in_prog {
          PTR_SYMB s;
/*
          s = make_symb(fi,TYPE_NAME,$3);
*/
          s = makeSymb(fi,cur_scope(),TYPE_NAME,$3,1);
          $$ = makeDerived(fi,s,LLNULL);
          add_scope_level($$,NON); 
          }
    ;
        
       
derived_type_def         
    :  derived_type_stmt cmnt
       private_sequence_stmt...
       component_def_stmt...
       end_type_stmt  {
          $$ = derivedDeal($1,$3,$4,$5);
          $1->entry.struct_decl.type_end=$5;
          }
    ;
/* modified by Feng Xiaobing
end_type_stmt                  
    :  ENDTYPE opt_name {
          $$ = makeEnd(fi);
          delete_beyond_scope_level(pred_bfnd);
          }
    ;
*/
end_type_stmt
    :  ENDTYPE {
                $$ = makeEnd(fi);
                delete_beyond_scope_level(pred_bfnd);
        }
    |   ENDTYPE name {
                $$ = makeEnd(fi);
                delete_beyond_scope_level(pred_bfnd);
                if (strcasecmp($2,pred_bfnd->entry.Template.symbol->ident)!=0)
                        err_g("name should be matched with this type defined:",lineNum_g,pred_bfnd->entry.Template.symbol->ident);
        }
        ;
       
private_sequence_stmt... 
    :  {
          $$ = BFNULL; 
          }
    |  private_sequence_stmt... private_sequence_stmt cmnt {
          $$ = setBfndList($1,$2);
          }
    ;
       
private_sequence_stmt    
    :  PRIVATE {
          $$ = makeMiscell(fi,PRIVATE_STMT); 
          }
    |  sequence_stmt
    ;
       
component_def_stmt...    
    :  component_def_stmt cmnt {
          $$ = setBfndList(BFNULL,$1);
          }
    |  component_def_stmt... component_def_stmt  cmnt {
          $$ = setBfndList($1,$2);
          }
    ;
       
component_def_stmt       
    :  type_spec COMMA component_attr_spec_list
       DOUBLECOLON component_decl_list  {
          $$ = makeTypedecl(fi,$5,$1,$3); 
          vartype=TYNULL;             /* add by zheng.gb 1995.5.5 */
          }
    |  type_spec opt_double_colon component_decl_list  {
          $$ = makeTypedecl(fi,$3,$1,LLNULL);
          vartype=TYNULL;             /* add by zheng.gb 1995.5.5 */
          }
    ;
       
component_attr_spec_list 
    :  component_attr_spec  {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  component_attr_spec_list COMMA component_attr_spec {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;
       
component_decl_list      
    :  component_decl   {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  component_decl_list COMMA component_decl {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;
       
       
component_attr_spec      
    :  POINTER {
          /* by zheng.gb */
          type_options = type_options | POINTER_BIT;
          $$=makeLlnd(fi,POINTER_OP,LLNULL,LLNULL,SMNULL);
          }
    |  DIMENSION LEFTBRACKET
       component_array_spec RIGHTBRACKET {
          PTR_LLND l;
          PTR_TYPE t;
          type_options = type_options | DIMENSION_BIT;
          l=makeLlnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
          $$ = makeLlnd(fi,DIMENSION_OP,l,LLNULL,SMNULL);
          t= makeTypeArray($3,vartype);
          vartype=t; 
          }
    ;
       
component_array_spec     
    :  array_spec
    ;
       
component_decl           
    :  name LEFTBRACKET
       component_array_spec RIGHTBRACKET
       MULTIPLY char_length {
          PTR_SYMB s;
          s= makeSymbField(fi,$1);
          $$ = makeEntity_ll(s,$3,$6,LLNULL); 
          }
    |  name   {
          PTR_SYMB s;
          s= makeSymbField(fi,$1);
          $$ = makeEntity_ll(s,LLNULL,LLNULL,LLNULL); 
          }
    |  name LEFTBRACKET
       component_array_spec RIGHTBRACKET {
          PTR_SYMB s;
          s= makeSymbField(fi,$1); 
          $$ = makeEntity_ll(s,$3,LLNULL,LLNULL);
          }
    |  name MULTIPLY char_length {
          PTR_SYMB s;
          s= makeSymbField(fi,$1); 
          $$ = makeEntity_ll(s,LLNULL,$3,LLNULL);
          }
    ;
       
       
sequence_stmt            
    :  SEQUENCE in_prog {
          $$ = makeMiscell(fi,SEQUENCE_STMT);
	  if (pred_bfnd->variant == STRUCT_DECL) 
		if (pred_bfnd->entry.Template.symbol->attr & SEQUENCE_BIT)
                	err_g("Duplicate sequence in type",lineNum_g,pred_bfnd->entry.Template.symbol->ident);
                else
			pred_bfnd->entry.Template.symbol->attr |= SEQUENCE_BIT;
          }
    ;
       
opt_double_colon /* modified by Feng Xiaobing */
    :   {
                double_colon_flag = 0;
        }
    |  DOUBLECOLON {
                double_colon_flag = 1;
        }
    ;
       
       
/**********   Type_declaration      8.22.95    ****************/
       
type_declaration_stmt    
    :  type_spec COMMA attr_spec... DOUBLECOLON  
       needkeywordsoff entity_decl_list needkeywordson in_prog {
          if(debugFlag_g==1)printf("type:%s\n");
          $$ = makeTypedecl(fi,$6,$1,$3);
          init_flag = 0; /* added by Feng Xiaobing */
          vartype=TYNULL;    /* add by zheng.gb  1995.5.5 */
          type_options = 0;
          }
    |  type_spec opt_double_colon needkeywordsoff entity_decl_list needkeywordson in_prog {
          if(debugFlag_g==1)printf("type: \n");
          $$ = makeTypedecl(fi,$4,$1,LLNULL);
          /* the following statement is added by Feng Xiaobing */
          if (init_flag)
                if (!double_colon_flag) err_g("double colon must appear",lineNum_g,"");
          init_flag = 0;
          double_colon_flag = 0;
          vartype=TYNULL;    /* add by zheng.gb  1995.5.5 */
          type_options = 0;
          }
    ;
               
attr_spec...                 
    :  attr_spec  {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  attr_spec... COMMA attr_spec {
          $$=set_ll_list($1,$3,EXPR_LIST);
          }
    ;
       
entity_decl_list         
    :  entity_decl {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  entity_decl_list COMMA entity_decl {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;
       
type_spec                
    :  INTEGER  {
          $$ = makeTypespec_ll(fi,global_int,LLNULL);
          }
    |  REAL  {
          $$ = makeTypespec_ll(fi,global_float,LLNULL);
          }
    |  COMPLEX  {
          $$ = makeTypespec_ll(fi,global_complex,LLNULL);
          }
    |  DOUBLEPRE  {
                            /* modified by zheng.gb 1996.5.6 */
          $$ = makeTypespec_ll(fi,global_double,LLNULL);
          }
    |  CHARACTER  {
          $$ = makeTypespec_ll(fi,global_string,LLNULL);
          }
    |  LOGICAL  {
          $$ = makeTypespec_ll(fi,global_bool,LLNULL);
          }
    |  TYPE LEFTBRACKET name RIGHTBRACKET {
          $$=makeTypespec_ll(fi,makeTypederivedref(fi,$3),LLNULL);
          }
    |  REAL kind_selector {
          $$ = makeTypespec_ll(fi,global_float,$2);
          }
    |  COMPLEX kind_selector {
          $$ = makeTypespec_ll(fi,global_complex,$2);
          }
    |  CHARACTER char_selector {
          $$ = makeTypespec_ll(fi,global_string,$2);
          }
    |  LOGICAL kind_selector {
          $$ =makeTypespec_ll(fi,global_bool,$2); 
          }
    |  INTEGER kind_selector  {
          $$ =makeTypespec_ll(fi,global_int,$2); 
          }
    ;
                
attr_spec                
    :  PARAMETER  {
          type_options = type_options | PARAMETER_BIT;        
          $$=makeLlnd(fi,PARAMETER_OP,LLNULL,LLNULL,SMNULL);
          }
    |  DIMENSION   
       LEFTBRACKET array_spec RIGHTBRACKET  {
          PTR_LLND l;
          PTR_TYPE t;
          type_options = type_options | DIMENSION_BIT;
/*
          l=makeLlnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
          $$ = makeLlnd(fi,DIMENSION_OP,l,LLNULL,SMNULL);
*/
          $$ = makeLlnd(fi,DIMENSION_OP,$3,LLNULL,SMNULL);
          t= makeTypeArray($3,vartype);
          vartype=t;
          }
    |  EXTERNAL  {
          type_options = type_options | EXTERNAL_BIT;
          $$=makeLlnd(fi,EXTERNAL_OP,LLNULL,LLNULL,SMNULL);
          }
    |  INTRINSIC  {
          type_options = type_options | INTRINSIC_BIT;
          $$=makeLlnd(fi,INTRINSIC_OP,LLNULL,LLNULL,SMNULL);
          }
    |  SAVE  {
          type_options = type_options | SAVE_BIT;
          $$=makeLlnd(fi,SAVE_OP,LLNULL,LLNULL,SMNULL);
          }
    |  OPTIONAL  {
          type_options = type_options | OPTIONAL_BIT;
          $$=makeLlnd(fi,OPTIONAL_OP,LLNULL,LLNULL,SMNULL);
          }
    |  INTENT LEFTBRACKET intent_spec RIGHTBRACKET {
          $$ = $3;
          }
    |  access_spec 
    |  POINTER  {
          type_options = type_options | POINTER_BIT;
          $$=makeLlnd(fi,POINTER_OP,LLNULL,LLNULL,SMNULL);
          }
    |  ALLOCATABLE  {
          type_options = type_options | ALLOCATABLE_BIT;
          $$=makeLlnd(fi,ALLOCATABLE_OP,LLNULL,LLNULL,SMNULL);
          }
    |  TARGET  {
          type_options = type_options | TARGET_BIT;
          $$=makeLlnd(fi,TARGET_OP,LLNULL,LLNULL,SMNULL);
          }
    ;
               
entity_decl
    : name MULTIPLY char_length /* contain "funcname" */ {
          PTR_SYMB s;
          if(debugFlag_g==1) printf("entity:%s\n",$$); 
          if(combinedFlag_g == 1)
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          else
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,1);
          $$ = makeEntity_ll(s,LLNULL,$3,LLNULL);
          }
    |  name  LEFTBRACKET array_spec RIGHTBRACKET {
          PTR_SYMB s;
          if(debugFlag_g==1) printf("entity:%s\n",$$);
          if(combinedFlag_g == 1)
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          else
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,1);
          $$ = makeEntity_ll(s,$3,LLNULL,LLNULL);
          }
    |  name LEFTBRACKET array_spec RIGHTBRACKET 
       MULTIPLY char_length {
          PTR_SYMB s;
          if(debugFlag_g==1) printf("entity:%s\n",$$);
          if(combinedFlag_g == 1)
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          else
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,1);
          $$ = makeEntity_ll(s,$3,$6,LLNULL);
          }
    |  name  EQUAL initialization_expr {
          PTR_SYMB s;
          if(debugFlag_g==1) printf("entity:%s\n",$$); 
          if(combinedFlag_g == 1)
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          else
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,1);
          $$ = makeEntity_ll(s,LLNULL,LLNULL,$3);
          init_flag = 1; /* added by Feng Xiaobing */
          }
    |  name LEFTBRACKET array_spec RIGHTBRACKET 
       EQUAL initialization_expr {
          PTR_SYMB s;
          if(debugFlag_g==1) printf("entity:%s\n",$$);
          if(combinedFlag_g == 1)
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          else
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,1);
          $$ = makeEntity_ll(s,$3,LLNULL,$6);
          init_flag = 1; /* added by Feng Xiaobing */
          }
    |  name MULTIPLY char_length EQUAL initialization_expr {
          PTR_SYMB s;
          if(debugFlag_g==1) printf("entity:%s\n",$$);
          if(combinedFlag_g == 1)
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          else
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,1);
          $$ = makeEntity_ll(s,LLNULL,$3,$5);
          init_flag = 1; /* added by Feng Xiaobing */
          }
    |  name LEFTBRACKET array_spec RIGHTBRACKET 
       MULTIPLY char_length
       EQUAL initialization_expr {
          PTR_SYMB s;
          if(debugFlag_g==1) printf("entity:%s\n",$$);
          if(combinedFlag_g == 1)
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          else
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,1);
          $$ = makeEntity_ll(s,$3,$6,$8);
          init_flag = 1; /* added by Feng Xiaobing */
          }
    |  name {
          PTR_SYMB s;
          if(debugFlag_g==1) printf("entity:%s\n",$$);
          if(combinedFlag_g == 1)
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          else
             s = makeSymbVar(fi,cur_scope(),LOCAL,$1,1);
          $$ = makeEntity_ll(s,LLNULL,LLNULL,LLNULL);
          }
/*        | funcname dims length      */
    ;
       
kind_selector            
    :  LEFTBRACKET KINDEQ 
       int_initialization_expr RIGHTBRACKET {
          $$ = makeLlnd(fi,KIND_OP,$3,LLNULL,SMNULL);
          }
    |  LEFTBRACKET int_initialization_expr
       RIGHTBRACKET  {
          $$ = makeLlnd(fi,NON_KIND_OP,$2,LLNULL,SMNULL);
          }
    ;
       
int_initialization_expr  
    :  expr
    ;
       
char_selector            
    :  length_selector   {
          if(debugFlag_g==1) printf("char_ : %s\n",$$); 
/* HIT */
          $$ = $1;
          mynop();
          }
    |  LEFTBRACKET LENEQ type_param_value
       COMMA KINDEQ
       int_initialization_expr RIGHTBRACKET {
          PTR_LLND p,q;
          p=makeLlnd(fi,LEN_OP,$3,LLNULL,SMNULL);
          q=makeLlnd(fi,KIND_OP,$6,LLNULL,SMNULL);
          $$ = add_to_lowLevelList(q,p);
          }
    |  LEFTBRACKET type_param_value   
       COMMA KINDEQ 
       int_initialization_expr RIGHTBRACKET {
          PTR_LLND p,q;
          p=makeLlnd(fi,NON_LEN_OP,$2,LLNULL,SMNULL);
          q=makeLlnd(fi,KIND_OP,$5,LLNULL,SMNULL);
          $$ = add_to_lowLevelList(q,p); 
          }
    |  LEFTBRACKET type_param_value COMMA
       int_initialization_expr RIGHTBRACKET {
          PTR_LLND p,q;
          p=makeLlnd(fi,NON_LEN_OP,$2,LLNULL,SMNULL);
          q=makeLlnd(fi,NON_KIND_OP,$4,LLNULL,SMNULL);
          $$ = add_to_lowLevelList(q,p);
          }
    |  LEFTBRACKET KINDEQ
       int_initialization_expr COMMA
       LENEQ type_param_value RIGHTBRACKET {
          PTR_LLND p,q;
          p=makeLlnd(fi,LEN_OP,$6,LLNULL,SMNULL);
          q=makeLlnd(fi,KIND_OP,$3,LLNULL,SMNULL);
          $$ = add_to_lowLevelList(p,q); 
          }
    |  LEFTBRACKET KINDEQ 
       int_initialization_expr RIGHTBRACKET {
          $$ = makeLlnd(fi,KIND_OP,$3,LLNULL,SMNULL);  
          }
    ;
       
       
length_selector          
    :  LEFTBRACKET LENEQ 
       type_param_value RIGHTBRACKET {
          $$ = makeLlnd(fi,LEN_OP,$3,LLNULL,SMNULL);
          }
/*  | MULTIPLY char_length COMMA 
        { 
          }   */
    |  LEFTBRACKET type_param_value RIGHTBRACKET {
          $$ = makeLlnd(fi,NON_LEN_OP,$2,LLNULL,SMNULL);
          }
    |  MULTIPLY char_length {
          $$ = $2;
          mynop();
          }
    ;
       
char_length              
    :  LEFTBRACKET type_param_value RIGHTBRACKET {
          PTR_LLND p;
/* HIT */
          mynop();
/*
          p = makeLlnd(fi,STAR_OP,$2,LLNULL,SMNULL);
          $$ = makeLlnd(fi,NON_LEN_OP,p,LLNULL,SMNULL);
*/
          $$ = makeLlnd(fi,NON_LEN_OP,$2,LLNULL,SMNULL);
          }
    |  int_literal_constant {
          PTR_LLND p,q;

          mynop();
/*
          p = makeLlnd(fi,INT_VAL,LLNULL,LLNULL,SMNULL);
          q = makeLlnd(fi,STAR_OP,p,LLNULL,SMNULL);
          $$ = makeLlnd(fi,NON_LEN_OP,q,LLNULL,SMNULL);
*/
          $$=$1;/* modified by zheng.gb 1996.1.20 */
          }
    ;
       
type_param_value         
    :  expr
    |  MULTIPLY {
          $$ = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,fi->head_symb);
          }
    ;
       
initialization_expr      
    :  expr
    ;
       
       
/***********    Data_stmt     8.22.95     ***********************/
       
data_stmt                
    :  DATA data_stmt_list in_prog {
          $$ = makeVarlistdecl(fi,DATA_DECL,$2);
          }
    ;
       
data_stmt_list
    :  data_stmt_set {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST); 
          }
    |  data_stmt_list COMMA data_stmt_set {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    |  data_stmt_list data_stmt_set {
          $$ = set_ll_list($1,$2,EXPR_LIST);
          }
    ;
       
       
data_stmt_set            
    :  data_stmt_object_list  DIVIDE data_stmt_value_list DIVIDE {
          $$ = makeLlnd(fi,DATA_STMT_SET,$1,$3,SMNULL); 
          }
    ;
       
       
data_stmt_object_list    
    :  data_stmt_object {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  data_stmt_object_list COMMA data_stmt_object {
          $$ = set_ll_list($1,$3,EXPR_LIST); 
          }
    ;
       
data_stmt_object         
    :  variable
    |  data_implied_do
    ;
       
data_stmt_value_list     
    :  data_stmt_value {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  data_stmt_value_list COMMA data_stmt_value {
          $$ = set_ll_list($1,$3,EXPR_LIST); 
          }
    ;
       
data_stmt_value          
    :  data_stmt_constant {
                                /* modified by zheng.gb */
/*
          $$ = makeLlnd(fi,DATA_VALUE,$1,LLNULL,SMNULL);
*/
          $$ = makeLlnd(fi,DATA_VALUE,LLNULL,$1,SMNULL);
          }
    |  data_stmt_repeat MULTIPLY data_stmt_constant {
          $$ = makeLlnd(fi,DATA_VALUE,$1,$3,SMNULL);
          }
    ;
       
data_stmt_constant       
    :  constant
    |  signed_int_literal_constant
    |  signed_real_literal_constant      
    |  structure_constructor      
    ;
       
data_stmt_repeat         
    :  constant
    ;
        
       
data_implied_do                 
    :  LEFTBRACKET data_i_do_object_list COMMA
       data_i_do_variable EQUAL expr
       COMMA expr RIGHTBRACKET {
          PTR_LLND l,p;
          /* l= set_ll_list($6,$8,EXPR_LIST);        */
                                        /* modified by zheng.gb */
          p = makeLlnd(fi,RANGE_OP,$6,$8,SMNULL);
          l = makeLlnd(fi,DDOT,p,LLNULL,SMNULL);

          $$ = makeLlnd(fi, DATA_IMPL_DO, $2,l ,$4 );
          if(debugFlag_g==1)printf("data_implied_do\n");
          }
    |  LEFTBRACKET data_i_do_object_list COMMA
       data_i_do_variable EQUAL expr 
       COMMA expr COMMA 
       expr RIGHTBRACKET {
          PTR_LLND l,p;
          /* l= set_ll_list($6,set_ll_list($8,$10,EXPR_LIST),EXPR_LIST); */
                                        /* modified by zheng.gb */
          p = makeLlnd(fi,RANGE_OP,$6,$8,SMNULL);
          l = makeLlnd(fi,DDOT,p,$10,SMNULL);

          $$ = makeLlnd(fi, DATA_IMPL_DO, $2,l ,$4);
          if(debugFlag_g==1)printf("data_implied_do\n");
          }
    ;
       
data_i_do_object_list    
    :  data_i_do_object {
          $$ = $1; 
          }
    |  data_i_do_object_list COMMA data_i_do_object { /* zheng.gb 1996.5.21 */
          $$ = add_to_lowLevelList($3, $1); 
          }
    ;
       
data_i_do_object          
    :  subobject1   {
          $$ = makeLlnd(fi, DATA_ELT, $1, LLNULL,SMNULL );
          if(debugFlag_g==1)printf("data_i_do,subobject\n");
          }
    |  data_implied_do {
          $$ = makeLlnd(fi, DATA_ELT, $1, LLNULL, SMNULL);
          if(debugFlag_g==1)printf("data_i_do,implieddo\n");
          }
    ;
       
data_i_do_variable
    :  name   /*  variable */ {
          $$ = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          $$->dovar =1;
          $$->entry.var_decl.dovar =1;
          }
    ;
       
       
/******************** Grammmar for executable ****************************/
/********************    8 . 25 . 1995        ****************************/
       
opt_label1
    :  {
          $$ = LBNULL;
	  cur_label=$$;				/* zheng.gb 1996/12/20 */
          }
    |  label1 {
          $$ = $1;
	  cur_label=$$;				/* zheng.gb 1996/12/20 */
          }
    ;
       
executable
    :  action_stmt
    |  case_construct    
    |  do_construct   
    |  if_construct
    |  where_construct
    ;
        
action_stmt
    :  assignment_stmt      /* contain "stmt_function_stmt" */
    |  assign_label_stmt   
    |  assign_goto_stmt   
    |  pointer_assignment_stmt
    |  allocate_stmt         
    |  nullify_stmt         
/*    |  associated_stmt       zheng.gb 1996.5.13 */
    |  deallocate_stmt    
    |  call_stmt         
    |  return_stmt      
  /*  control  operate  */
    |  goto_stmt       
    |  computed_goto_stmt   
    |  continue_stmt       
    |  stop_stmt          
    |  pause_stmt        
    |  exit_stmt        
    |  cycle_stmt      
    |  forall_stmt           /*  HPF */        
    |  if_stmt        
    |  arithmetic_if_stmt   
    |  where_stmt          
  /*   I/O  File operate   */
    |  format_stmt    
    |  print_stmt
    |  read_stmt
    |  write_stmt
    |  open_stmt
    |  close_stmt
    |  inquire_stmt
    |  rewind_stmt
    |  backspace_stmt
    |  endfile_stmt
    |  end_do_stmt                /* below is added  by zheng.gb 1996.5.5 */
    |  entry_stmt
    |  data_stmt     
    ;

assignment_stmt                 /* modified by zheng.gb 1997/1/2  */
    :  variable EQUAL needkeywordsoff expr needkeywordson in_prog {
          $$ = makeBfnd(fi,ASSIGN_STAT);
          $$ = makeAssgnBfnd($$,SMNULL,$1,$4,LLNULL);
          }
/* HIT */
    |  name LEFTBRACKET RIGHTBRACKET EQUAL needkeywordsoff expr needkeywordson in_prog {
          PTR_SYMB s;
/*
          s = makeSymbUnithead(fi,FUNCTION_NAME,$1);
*/
                            /* zheng.gb    1996.5.9 */
          s = makeSymb(fi,cur_scope(),VARIABLE_NAME,$1,1);
          s->variant = FUNCTION_NAME;
          $$ = makeBfnd(fi,STMTFN_STAT);
          $$ = makeAssgnBfnd($$,s,$6,LLNULL,LLNULL);
          /*  Lxy 4/26 */
          }
    ;
       
/*
stmt_function_stmt       : name
                             LEFTBRACKET dummy_arg_name_list 
                             RIGHTBRACKET EQUAL expr 
                         | name LEFTBRACKET
                              RIGHTBRACKET EQUAL expr 
                         ;
*/
       
assign_label_stmt        
    :  ASSIGN label TO variable in_prog {
          $$ = makeBfnd(fi,ASSLAB_STAT);
          $$ = makeAsslabBfnd($$,SMNULL,$4,$2,LLNULL);
          }
    ;
       
/* WHAT IS THE MEANING ? WHAT DOES name PRESENT ? NO BOOK BY HAND EXPLAINS. */
assign_goto_stmt
    :  GOTO  name in_prog {
          PTR_SYMB s;

          s = makeSymbVar(fi,cur_scope(),LOCAL,$2,0);
          $$ = makeBfnd(fi,ASSGOTO_NODE);
          $$ = makeAssgotoBfnd($$,s,LLNULL,LLNULL,LLNULL);
          }
    |  GOTO  name COMMA LEFTBRACKET label_list RIGHTBRACKET in_prog {
          PTR_SYMB s;

          s = makeSymbVar(fi,cur_scope(),LOCAL,$2,0);
          $$ = makeBfnd(fi,ASSGOTO_NODE);
          $$ = makeAssgotoBfnd($$,s,$5,LLNULL,LLNULL);
          }
    |  GOTO  name LEFTBRACKET label_list RIGHTBRACKET in_prog {
          PTR_SYMB s;

          s = makeSymbVar(fi,cur_scope(),LOCAL,$2,0);
          $$ = makeBfnd(fi,ASSGOTO_NODE);
          $$ = makeAssgotoBfnd($$,s,$4,LLNULL,LLNULL);
          }
    ;
       
contains_stmt            /* completed by Lxy */
    :  CONTAINS in_prog {
          $$ = makeMiscell(fi,CONTAINS_STMT);
          containsNum_g++;
          setBlob($$,pred_bfnd);  
          }
    ;
       
return_stmt              
    :  RETURN expr in_prog {
          $$ = makeBfnd(fi,RETURN_STAT);
          $$ = makeRetnBfnd($$,$2);
          }
    |  RETURN in_prog {
          $$ = makeBfnd(fi,RETURN_STAT);
          /* Return node has no relation to llnd and symbol table */
          }
       
    ;
       
call_stmt                
    :  CALL name LEFTBRACKET               /* modified by zheng.gb 1997/2/2 */
       needkeywordsoff actual_arg_spec_list needkeywordson RIGHTBRACKET in_prog {
          PTR_SYMB s;

          /* s = makeSymbUnithead(fi,PROCEDURE_NAME,$2);*/
                   /* make symbol tag as LOCAL , so that we can do check in
hpfcc to find if this proc is defined elsewhere */
          s = makeSymb(fi,cur_scope(),LOCAL,$2,0);
          s->entry.var_decl.local=LOCAL;
          $$ = makeBfnd(fi,PROC_STAT);
          $$ = makeCallBfnd($$,$5,s);
          }
    |  CALL name in_prog {
          PTR_SYMB s;
          s = makeSymb(fi,cur_scope(),LOCAL,$2,0);
          s->entry.var_decl.local=LOCAL;
          $$ = makeBfnd(fi,PROC_STAT);
          $$ = makeCallBfnd($$,LLNULL,s);
          }
    |  CALL name LEFTBRACKET RIGHTBRACKET in_prog {
          PTR_SYMB s;

          /*s = makeSymbUnithead(fi,PROCEDURE_NAME,$2);*/
          s = makeSymb(fi,cur_scope(),LOCAL,$2,0);
          s->entry.var_decl.local=LOCAL;
          $$ = makeBfnd(fi,PROC_STAT);
          $$ = makeCallBfnd($$,LLNULL,s);
          }
    ;
       
actual_arg_spec_list     
    :  actual_arg_spec {
/*
          $$ = makeLlnd(fi,NAMELIST_LIST,$1,LLNULL,SMNULL);
          $$ = makeLlExpLst($$,$1,LLNULL,SMNULL);
*/
          $$=set_ll_list($1,LLNULL,EXPR_LIST);  /*added by Yanmi*/
          }
    |  actual_arg_spec_list COMMA actual_arg_spec {
          /*
          $$ = makeLlnd(fi,NAMELIST_LIST,$3,LLNULL,SMNULL);
          $$ = makeLlExpLst($$,$3,$1,SMNULL);
          */
          $$=set_ll_list($1,$3,EXPR_LIST); /*added by Yanmi*/
          }
    ;
       
actual_arg_spec          
    :  name  EQUAL actual_arg {
                                                /*the following added by Yanmi*/
          PTR_LLND        l;
          l=makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          l->entry.string_val=$1;
          l->type=global_string;
          $$=makeLlnd(fi,KEYWORD_ARG,$3,l,SMNULL);
          /*$$=makeLlnd(fi,KEYWORD_ARG,l,$3,SMNULL);*/ /* I think this order is better for unparser.  Z.Q*/
          }
    |  actual_arg {
          $$ = $1;
          }
                                             /* add by zheng.gb 1996.5.16 */
    |  KINDEQ actual_arg {
          PTR_LLND        l;
          l=makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          l->entry.string_val="kind";
          l->type=global_string;
          $$=makeLlnd(fi,KEYWORD_ARG,$2,l,SMNULL);
          }
    ;
       
actual_arg     
    :  expr   /* contain variable */ {
          $$ = $1;
          }
    |  MULTIPLY label  {
          $$ = $2;                                /*added by Yanmi*/
          /* $$->entry.var_ref_s.symbol= fi->head_symb; by zheng.gb 1996.5.4 */
          }
    ;
       
       
allocate_stmt            
    :  ALLOCATE LEFTBRACKET allocation_list
       COMMA STAT stat_variable RIGHTBRACKET in_prog {
          $$ = makeBfnd(fi,ALLOCATE_STMT);
          $$ = makeAllocBfnd($$,$3,$6);
          }
    |  ALLOCATE LEFTBRACKET allocation_list RIGHTBRACKET in_prog {
          $$ = makeBfnd(fi,ALLOCATE_STMT);
          $$ = makeAllocBfnd($$,$3,LLNULL);
          }
    ;
       
stat_variable            
    :  variable
    ;
       
allocation_list          
    :  allocation {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  allocation_list COMMA allocation {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;
       
allocation
    :  allocate_object
    ;
       
allocate_object          
    :  name {
          PTR_SYMB s;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);        
          $$ = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          }
    |  structure_component
    |  array_section_element_funcref   
    ;
       
/*  Lxy. 1/10/1996
allocation 
    : allocate_object LEFTBRACKET allocate_shape_spec_list RIGHTBRACKET
          {
          $$ = makeLlnd(fi,ARRAY_REF,$3,LLNULL,$1);
          /* In this statement the space ARRAAY used will be allocated ??
          }
    | allocate_object
    ;

allocate_shape_spec_list
    :  allocate_shape_spec
           {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    | allocate_shape_spec_list COMMA allocate_shape_spec
          {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;
 
allocate_shape_spec 
    : allocate_lower_bound COLON allocate_upper_bound
          {
          PTR_LLND llnd1;
          llnd1 = makeLlnd(fi,RANGE_OP,$1,$3,SMNULL);
          $$ = makeLlnd(fi,DDOT,llnd1,LLNULL,SMNULL);
          }
    | allocate_lower_bound 
        {
          /* In fact ,$1 represent allocate_upper_bound here. ??
          PTR_LLND llnd1,llnd2;
          llnd1 = makeLlnd(fi,INT_VAL,LLNULL,LLNULL,1);
          /* llnd1 = makeLlnd(fi,INT_VAL,LLNULL,LLNULL,PTR_SYMB (1) ); ??
          llnd2 = makeLlnd(fi,RANGE_OP,llnd1,$1,SMNULL);
          $$ = makeLlnd(fi,DDOT,llnd2,LLNULL,SMNULL);
          }
    ;

allocate_lower_bound     : expr
                         ;

allocate_upper_bound     : expr
                         ;

*/
       
deallocate_stmt          
    :  DEALLOCATE LEFTBRACKET allocate_object_list
       COMMA STAT stat_variable RIGHTBRACKET in_prog {
          $$ = makeBfnd(fi,DEALLOCATE_STMT);
          $$ = makeAllocBfnd($$,$3,$6);
          }
    |  DEALLOCATE LEFTBRACKET allocate_object_list RIGHTBRACKET in_prog {
          $$ = makeBfnd(fi,DEALLOCATE_STMT);
          $$ = makeAllocBfnd($$,$3,LLNULL);
          }
    ;
        
allocate_object_list     
    :  allocate_object {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  allocate_object_list COMMA allocate_object {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;
       
nullify_stmt             
    :  NULLIFY LEFTBRACKET pointer_object_list RIGHTBRACKET in_prog {
          $$ = makeBfnd(fi,NULLIFY_STMT);
          $$ = makeNulfyBfnd($$,$3);
          }
    ;
       
pointer_object_list         
    :  pointer_object {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  pointer_object_list COMMA pointer_object {
          $$ = set_ll_list($1,$3,EXPR_LIST); 
          }
    ;
               
/*
associated_stmt          
    :  ASSOCIATED LEFTBRACKET pointer_object
       target_pointer RIGHTBRACKET in_prog {
          PTR_LLND result;
          result = makeLlnd(fi,BOOL_VAL,LLNULL,LLNULL,SMNULL);
          $$ = makeBfnd(fi,ASSOCIATED_STMT);
          $$ = makeAssoBfnd($$,$3,$4,result);
          }
    ;

target_pointer          
    :  {
          }
    |  COMMA  variable       {
          $$ = $2;
          }
    ;
*/
       
              /* modified by zheng.gb 1996.5.5  replace variable by expr */
pointer_assignment_stmt  
    :  pointer_object EQGT expr in_prog  {
          $$ = makeBfnd(fi,POINTER_ASSIGN_STAT);
          $$ = makeAssgnBfnd($$,SMNULL,$1,$3,LLNULL);
          /* using the same structure as assgin_statement */
          }
    ;
       
/*                                                substitute by zheng.gb
pointer_object
    :  variable
    ;
*/
pointer_object
    :  name  {
          PTR_SYMB s;
          if(debugFlag_g==1) printf(" variable_name: %s\n",$1);
          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          $$ = makeLlnd(fi,VAR_REF, LLNULL, LLNULL, s);
          set_expr_type($$);
          }
                                        /* add by zheng.gb  on 7/3 1996  */
    |  name LEFTBRACKET section_subscript_list RIGHTBRACKET  {
          PTR_SYMB s;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          if(debugFlag_g==1) printf(" variable_name: %s\n",$1);
          $$ = makeLlnd(fi,ARRAY_REF,$3,LLNULL,s);
          set_expr_type($$);
          }
    |  structure_component
    ;
       
       
exit_stmt                
    :  EXIT name in_prog {
          PTR_SYMB s;

          s=makeSymb(fi,cur_scope(),CONSTRUCT_NAME,$2,0);
          $$ = makeBfnd(fi,EXIT_STMT);
          $$ = makeExitBfnd($$,s);
          }
    |  EXIT in_prog {
          $$ = makeBfnd(fi,EXIT_STMT);
          }
    ;
       
stop_stmt                
    :  STOP stop_code in_prog {
          $$ = makeBfnd(fi,STOP_STAT);
          $$ = makeStopBfnd($$,$2);
          }
    |  STOP in_prog {
          $$ = makeBfnd(fi,STOP_STAT);
          $$ = makeStopBfnd($$,LLNULL); 
          }
    ;
       
stop_code                
    :  char_literal_constant
    |  name {
          PTR_SYMB s;                                  /* added by zheng.gb*/
          if(debugFlag_g==1) printf(" variable_name: %s\n",$1);
          s=makeSymb(fi,cur_scope(),VARIABLE_NAME,$1,0);
          $$ = makeLlnd(fi,VAR_REF, LLNULL, LLNULL, s);
        }
/*
    |  label {
          }
*/
    |  digit_string {
          $$ = makeLlnd(fi,INT_VAL, LLNULL, LLNULL, SMNULL);
          $$->entry.ival = atoi($1);
          $$->type = global_int;
          }
    ;
       
       
pause_stmt               
    :  PAUSE stop_code in_prog {
          $$ = makeBfnd(fi,PAUSE_NODE);
          $$ = makeStopBfnd($$,$2); 
          /* Using the same structure as stop */
          }
    |  PAUSE in_prog {
          $$ = makeBfnd(fi,PAUSE_NODE); 
          }
    ;
       
goto_stmt                
    :  GOTO  label in_prog {
          $$ = makeBfnd(fi,GOTO_NODE);
          $$ = makeGotoBfnd($$,SMNULL,LLNULL,LLNULL,$2);
          }
    ;
       
computed_goto_stmt       
    :  GOTO  LEFTBRACKET label_list 
       RIGHTBRACKET COMMA expr in_prog {
          $$ = makeBfnd(fi,COMGOTO_NODE);
          $$ = makeComGotoBfnd($$,$3,$6);
          }
    |  GOTO  LEFTBRACKET label_list
       RIGHTBRACKET expr in_prog {
          $$ = makeBfnd(fi,COMGOTO_NODE);
          $$ = makeComGotoBfnd($$,$3,$5);
          }
    ;
       
label_list               
    :  label {
          /* $$ = makeLblLst(fi,LABEL_LIST,LLNULL,$1->entry.label_list.lab_ptr);  Z.Q. 4.30.96  delete */
          $$ = set_ll_list($1,LLNULL,LABEL_LIST); /* ZQ added 4.30.96 */
          }
    |  label_list COMMA label {
          /* $$ = makeLblLst(fi,LABEL_LIST,$1,$3->entry.label_list.lab_ptr);  Z.Q. deleted 4.30.96 */

          $$ = set_ll_list($1,$3,LABEL_LIST);
          /* $$ = makeLlnd(fi,LABEL_LIST,$3,LLNULL,SMNULL);
          $$ = makeLlExpLst($$,$3,$1,SMNULL); */ /* Link $3 to $1 */
          }
    ;
                          
continue_stmt            
    :  CONTINUE in_prog {
          $$ = makeBfnd(fi,CONTINUE_NODE);
          /* THE CONTINUE_NODE IS NEWLY MADE FOR VPC ? */
          }
    ;
       
cycle_stmt
    : CYCLE /*do_construct_*/name in_prog {
          PTR_SYMB s;

          s=makeSymb(fi,cur_scope(),CONSTRUCT_NAME,$2,0);
          $$ = makeBfnd(fi,CYCLE_STMT);
          $$ = makeCycleBfnd($$,s);
          }
    |  CYCLE in_prog {
          $$ = makeBfnd(fi,CYCLE_STMT);
          $$ = makeCycleBfnd($$,SMNULL);
          }
    ;
       
/****************  Forall belongs to  HPF  **************/

forall_stmt
    :  forall_stmt_begin forall_assignment {
          PTR_BFND endFor;

          endFor = makeEnd(fi);
          --(endFor->g_line);
          --(endFor->l_line);
          setBfndList($2,endFor);
          $$ = $1;
          }
    ;

forall_stmt_begin
    :  FORALL LEFTBRACKET forall_control
       RIGHTBRACKET {
          $$ = makeBfnd(fi,FORALL_STMT);
          $$ = makeForallBfnd($$,$3,$3->entry.Template.ll_ptr2);
          makeSonBlob($$,1);
          /*setBlob($5,pred_bfnd);*/
       }
    ;

forall_control           
    :  forall_script_control_list COMMA level_5_expr {
          $$ = makeLlnd(fi,FORALL_HEADER_OP,$1,$3,SMNULL);
          /* makeSonBlob($$,1)*/;
          }
    |  forall_script_control_list {
          $$ = makeLlnd(fi,FORALL_HEADER_OP,$1,LLNULL,SMNULL);
          /* makeSonBlob($$,1) */;
          }
    ;
       
forall_script_control_list 
    :  forall_script_control {
          $$ = set_ll_list($1,LLNULL,CONTROL_LIST);
          }
    |  forall_script_control_list COMMA
       forall_script_control {
          $$ = set_ll_list($1,$3,CONTROL_LIST);
          }
    ;
       
forall_script_control           
    :  name EQUAL expr COLON expr {
          PTR_LLND range,ddot,varRef;
          PTR_SYMB s;

          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          range = makeLlnd(fi,RANGE_OP,$3,$5,SMNULL);
          ddot = makeLlnd(fi,DDOT,range,LLNULL,SMNULL);
          varRef = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          $$ = makeLlnd(fi,INDEX_OP,varRef,ddot,SMNULL);
          }
    |  name EQUAL expr COLON expr COLON expr {
          PTR_LLND range,ddot,varRef;
          PTR_SYMB s;

          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          range = makeLlnd(fi,RANGE_OP,$3,$5,SMNULL);
          ddot = makeLlnd(fi,DDOT,range,$7,SMNULL);
          varRef = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          $$ = makeLlnd(fi,INDEX_OP,varRef,ddot,SMNULL);
          }
    ;
       
forall_assignment
    :  assignment_stmt {
          setBlob($1,pred_bfnd);
          lastBranchEnd = cur_blob;
          $$ = $1;
          }
    |  pointer_assignment_stmt {
          setBlob($1,pred_bfnd);
          lastBranchEnd = cur_blob;
          $$ = $1;
          }
    ;
       
/* -------------------------------- */
       
forall_construct
    :  forall_construct_begin cmnt
       forall_body...
       opt_label1 ENDFORALL {
          PTR_BFND endFor;
          endFor = makeEnd(fi);
          setBfndList($3,endFor);
          }
    ;
       
forall_construct_begin
    :  FORALL LEFTBRACKET forall_control
       RIGHTBRACKET {
          $$ = makeBfnd(fi,FORALL_CONSTRUCT_STMT);
          $$ = makeForallBfnd($$,$3,$3->entry.Template.ll_ptr2);
          makeSonBlob($$,1);
          }
    ;
       
forall_body...
    :   {
         $$ = BFNULL;
          }
    |  forall_body... forall_body cmnt {
          /* $$ = lnkStmts($1,LBNULL,$3,$4);*/
/* HIT */
          /* setBfndList($1,$2); */
          }
    ;
       
forall_body
    :  forall_assignment
    |  where_stmt
    |  forall_stmt
    |  where_construct
    |  forall_construct
    ;
       
/**********************   Case_stmt  **********************************/ 
       
case_construct           
    :  select_case_stmt cmnt
       newname10...
       end_select_stmt  {
          /* PTR_BFND caseBody;  commented off on 4.17.96 */
          setBfndList($3,$4);
          }
    ;
       
                              /*newname10... = [case_stmt block]...*/
newname10...                 
    :   {
          $$ = BFNULL;
          }
    |  newname10... case_stmt 
       block {
          PTR_BFND p;
          p = makeEnd(fi);
          /* --(p->g_line); --(p->l_line); */
          setBfndList($3,p);
          }
    ;
                       
select_case_stmt 
    :  /*case_construct_*/name COLON SELECTCASE 
       LEFTBRACKET case_expr RIGHTBRACKET in_prog {
          PTR_SYMB s;

          s=makeSymb(fi,cur_scope(),CONSTRUCT_NAME,$1,1);
          $$ = makeBfnd(fi,SWITCH_NODE);
          $$ = makeSeleBfnd($$,s,$5);
          makeSonBlob($$,1);
          }
    |  SELECTCASE LEFTBRACKET case_expr RIGHTBRACKET in_prog {
          $$ = makeBfnd(fi,SWITCH_NODE);
          $$ = makeSeleBfnd($$,SMNULL,$3);
          makeSonBlob($$,1);
          }
    ;
       
case_stmt                
    :  CASE case_selector /*case_construct_*/name cmnt  {
          PTR_SYMB s;
                                                /* add by zheng.gb */
          s= lookupSymb($3,cur_scope()->entry.prog_stmt.prog_symb);
          if (s==NULL )
             err_g("nondeclared select case construct name :",lineNum_g,$3);
          else
             s = makeSymb(fi,cur_scope(),CONSTRUCT_NAME,$3,0);
          if (s->variant!=CONSTRUCT_NAME)
             err_g("Invalid select case construct name: ",lineNum_g,$3);
          $$ = makeBfnd(fi,CASE_NODE);
          $$ = makeCaseBfnd($$,s,$2,$4);
          makeSonBlob($$,1);
          }
    |  CASE case_selector cmnt {
          $$ = makeBfnd(fi,CASE_NODE);
          $$ = makeCaseBfnd($$,SMNULL,$2,$3);
          makeSonBlob($$,1);
          }
    ;
       
block
    :  executable...    
    ;
       
end_select_stmt          
    :  ENDSELECT /*case_construct_*/name  {
          PTR_SYMB s;
                                                /* add by zheng.gb */
          s= lookupSymb($2,cur_scope()->entry.prog_stmt.prog_symb);
          if (s==NULL )
             err_g("nondeclared select case  construct name :",lineNum_g,$2);
          else
             s = makeSymb(fi,cur_scope(),CONSTRUCT_NAME,$2,0);
          if (s->variant!=CONSTRUCT_NAME)
             err_g("Invalid select case construct name: ",lineNum_g,$2);

          $$ = makeEnd(fi);
          $$->entry.case_stmt.construct_name=s; /* add by zheng.gb */
          }
    |  ENDSELECT  {
          $$ = makeEnd(fi);
          }
    ;
       
case_expr                
    :  expr {
          $$ = $1;
          }
    ;
       
       
case_selector            
    :  LEFTBRACKET case_value_range_list
       RIGHTBRACKET  {
          $$ = $2;
          }
    |  DEFAULTL {
          $$ = makeLlnd(fi,DEFAULT,LLNULL,LLNULL,SMNULL);
          }
    ;
       
case_value_range_list    
    :  case_value_range {
          $$ = makeLlnd(fi,RANGE_LIST,$1,LLNULL,SMNULL);
          $$ = makeLlExpLst($$,$1,LLNULL,SMNULL);
          }
    |  case_value_range_list COMMA case_value_range {
          $$ = makeLlnd(fi,RANGE_LIST,$3,LLNULL,SMNULL);
          $$ = makeLlExpLst($$,$3,$1,SMNULL); /* Link $3 to $1 */                               
          }
    ;
       
case_value_range         
    :  case_value
    |  case_value COLON {
          $$ = makeLlnd(fi,RANGE_OP,$1,LLNULL,SMNULL);
          }
    |  COLON case_value {
          $$ = makeLlnd(fi,RANGE_OP,LLNULL,$2,SMNULL);
          }
    |  case_value COLON case_value {
          $$ = makeLlnd(fi,RANGE_OP,$1,$3,SMNULL);
          }
    ;
       
case_value               
    :  int_initialization_expr {
          $$ = $1;
          }
    ;
       
logical_expr
    :  expr {
          $$ = $1;
          }
    ;
       
       
/*******************    Do_stmt  **************************************/
                       
do_construct             
    :  block_do_construct {
          $$ = $1;
          }
    |  nonblock_do_construct  {
          $$ = $1;
          }
    ;
       
block_do_construct           /* modififed by zheng.gb    1996.5.4 */
    :  nonlabel_do_stmt {
        }
    ;

/*
block_do_construct       
    :  nonlabel_do_stmt cmnt
       executable...    
       opt_label1 end_do_stmt  {
          setBfndList($3,$5);
          } */
/*     | label_do_stmt cmnt 
        executable...
          end_do_stmt      (12/17/1995)Zheng 
        {
          PTR_BFND doBody;
          setBfndList($3,$4);
          }
    ;
*/
       
/*
end_do_stmt                 
    :  ENDDO {
          $$ = makeEnd(fi);
          }
    |  ENDDO name {
        PTR_SYMB s;
          s= lookupSymb($2,cur_scope()->entry.prog_stmt.prog_symb);
          if (s==NULL ) {
             err_g("nondeclared Do construct name :",lineNum_g,$2);
             s = makeSymb(fi,cur_scope(),CONSTRUCT_NAME,$2,0);
          }
          if (s->variant!=CONSTRUCT_NAME)
             err_g("Invalid Do construct name: ",lineNum_g,$2);

          $$ = makeEnd(fi);
          $$->entry.Template.symbol = s;
          }
*/
/*  | continue_stmt
         {
          $$ = makeEnd(fi);
          --($$->g_line); --($$->l_line);
          $$->variant = CONTINUE_NODE;
          }        Lxy. 1/10/1996
    ;
       
*/
                                        /*  by zheng.gb 1996.5.4 */
end_do_stmt
    :  ENDDO {
          PTR_BFND do_end;

                               /* make a ENDDO statement */
          do_end=makeBfnd(fi,ENDDO_STMT);
          /* setBlob(do_end,pred_bfnd); */
          $$ = do_end;
                                         /* check if wrong matched */
          if (pred_bfnd->variant!=FOR_NODE && pred_bfnd->variant!=DO_WHILE_NODE)
                err_g("End do mismatched ! ",lineNum_g,"");
          else if (cur_label != LBNULL)
                          /*  if current statement carray a label   */
               {
                 if ( lblStackTop() != cur_label->stateno)
                 {
                          /* if current label not match the stack , end up here or we will close group in lnkStmts */
		   do_end->label=cur_label;	/* zheng.gb 1996/12/20 */
		   cur_label->statbody = do_end;
                   setBlob(do_end,pred_bfnd);
                   $$ = makeEnd(fi);
                 }
               }
               else {
                          /*  if current statement carray no label   */
                   setBlob(do_end,pred_bfnd);
                   $$ = makeEnd(fi);
               }
          }
    |  ENDDO name {
          PTR_SYMB s;
          PTR_BFND do_end;

          s= lookupSymb($2,cur_scope()->entry.prog_stmt.prog_symb);
          if (s==NULL )
             err_g("nondeclared Do construct name :",lineNum_g,$2);
          if (s->variant!=CONSTRUCT_NAME)
             err_g("Invalid Do construct name: ",lineNum_g,$2);

          do_end=makeBfnd(fi,ENDDO_STMT);
          do_end->entry.Template.symbol = s;
          /* setBlob(do_end,pred_bfnd); */
          $$ = do_end;
          if (pred_bfnd->variant!=FOR_NODE && pred_bfnd->variant!=DO_WHILE_NODE)
                err_g("End do mismatched ! ",lineNum_g,"");
          else if (cur_label != LBNULL )
               {
                 if ( lblStackTop() != cur_label->stateno)
                 {
		   do_end->label=cur_label;	/* zheng.gb 1996/12/20 */
                   setBlob(do_end,pred_bfnd);
                   $$ = makeEnd(fi);
                 }
               }
               else {
                   setBlob(do_end,pred_bfnd);
                   $$ = makeEnd(fi);
               }
          }
    ;

label_do_stmt            
    :  /*do_construct_*/name COLON
       DO label loop_control in_prog {
          PTR_LLND nameRef;
          PTR_SYMB s;

          $$ = $5;
          nameRef = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,SMNULL);
                                                /*  add by zheng.gb    */
          s= lookupSymb($1,cur_scope()->entry.prog_stmt.prog_symb);
          if (s!=NULL ) 
             err_g("Redeclared do  construct name :",lineNum_g,$1);
          else 
             s = makeSymb(fi,cur_scope(),CONSTRUCT_NAME,$1,1);
          if (s->variant!=CONSTRUCT_NAME)
             err_g("Invalid Do construct name: ",lineNum_g,$1);
          nameRef = makeLlVarRef(nameRef,LLNULL,LLNULL,s);
                                /*  modified by zheng.gb    */
          $$ = modiDoBfnd($$,nameRef,$4->entry.label_ref.lab_ptr);
/*
          $$ = modiDoBfnd($$,nameRef,$4->entry.label_ref.lab_ptr,SMNULL);
*/
          makeSonBlob($$,1);
          pushLblStack($4->entry.label_ref.lab_ptr->stateno);
          }
    |  DO label in_prog {
          $$ = makeBfnd(fi,FOR_NODE);
          $$ = makeDoBfnd($$,SMNULL,LLNULL,LLNULL,LLNULL,$2->entry.label_ref.lab_ptr);
          makeSonBlob($$,1);
          pushLblStack($2->entry.label_ref.lab_ptr->stateno);
          }
    | /*do_construct_*/name COLON DO label in_prog {
          PTR_LLND nameRef;
          PTR_SYMB s;

          $$ = makeBfnd(fi,FOR_NODE);
          nameRef = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,SMNULL);   
                                                /*  add by zheng.gb    */
          s= lookupSymb($1,cur_scope()->entry.prog_stmt.prog_symb);
          if (s!=NULL ) 
             err_g("Redeclared do  construct name :",lineNum_g,$1);
          else
             s = makeSymb(fi,cur_scope(),CONSTRUCT_NAME,$1,1);
          if (s->variant!=CONSTRUCT_NAME)
             err_g("Invalid Do construct name: ",lineNum_g,$1);
          nameRef = makeLlVarRef(nameRef,LLNULL,LLNULL,s);
          $$ = makeDoBfnd($$,SMNULL,LLNULL,LLNULL,nameRef,$4->entry.label_ref.lab_ptr);
          makeSonBlob($$,1);
          pushLblStack($4->entry.label_ref.lab_ptr->stateno);
          }
    |  DO label loop_control in_prog {
          PTR_LLND nameRef;
          $$ = $3;
                                /*  modified by zheng.gb    */
          $$ = modiDoBfnd($$,LLNULL,$2->entry.label_list.lab_ptr);
          /*$$ = modiDoBfnd($$,LLNULL,$2->entry.label_ref.lab_ptr,SMNULL);*/
          makeSonBlob($$,1);
          pushLblStack($2->entry.label_ref.lab_ptr->stateno);
          } 
    ;
       
       
nonlabel_do_stmt       
    :  /*do_construct_*/name COLON
       DO loop_control in_prog {
          PTR_LLND nameRef;
          PTR_SYMB s;

                                          /*  add by zheng.gb    */
          s= lookupSymb($1,cur_scope()->entry.prog_stmt.prog_symb);
          if (s!=NULL ) 
             err_g("Redeclared do  construct name :",lineNum_g,$1);
          else
             s = makeSymb(fi,cur_scope(),CONSTRUCT_NAME,$1,1);
          if (s->variant!=CONSTRUCT_NAME)
             err_g("Invalid Do construct name: ",lineNum_g,$1);
          $$ = $4;
          nameRef = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,SMNULL);
          nameRef = makeLlVarRef(nameRef,LLNULL,LLNULL,s);
          $$ = modiDoBfnd($$,nameRef,LBNULL);
/*
          $$ = modiDoBfnd($$,nameRef,LBNULL,SMNULL);
*/
          makeSonBlob($$,1);
          }
    |  /*do_construct_*/name COLON DO in_prog {
          PTR_LLND nameRef;
          PTR_SYMB s;

                                                /*  add by zheng.gb    */
          s= lookupSymb($1,cur_scope()->entry.prog_stmt.prog_symb);
          if (s!=NULL ) 
             err_g("Redeclared do  construct name :",lineNum_g,$1);
          else
             s = makeSymb(fi,cur_scope(),CONSTRUCT_NAME,$1,1);
          if (s->variant!=CONSTRUCT_NAME)
             err_g("Invalid Do construct name: ",lineNum_g,$1);
          $$ = makeBfnd(fi,FOR_NODE);
          nameRef = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,SMNULL); 
          nameRef = makeLlVarRef(nameRef,LLNULL,LLNULL,s);
          $$ = makeDoBfnd($$,SMNULL,LLNULL,LLNULL,nameRef,LBNULL);
          makeSonBlob($$,1);
          }
    |  DO in_prog {
          $$ = makeBfnd(fi,FOR_NODE);
          makeSonBlob($$,1);
          }
    |  DO loop_control in_prog {
          $$ = $2;
          makeSonBlob($$,1);
          }
    ;
       
loop_control             
    :  COMMA do_variable EQUAL numeric_expr
       COMMA numeric_expr
       COMMA numeric_expr {
          PTR_LLND doRange,doDdot;
          $$ = makeBfnd(fi,FOR_NODE);
          doRange = makeLlnd(fi,RANGE_OP,$4,$6,SMNULL);
          doDdot = makeLlnd(fi,DDOT,doRange,$8,SMNULL);
/*
          doDdot = makeLlnd(fi,DDOT,doRange,$8,$2->entry.Template.symbol);
*/
          /*What shall I fit into the second llnd pointer ? */
          $$ = makeDoBfnd($$,$2->entry.Template.symbol,doDdot,LLNULL,LLNULL,LBNULL);
          }
    |  do_variable EQUAL numeric_expr COMMA
       numeric_expr {
          PTR_LLND doRange,doDdot;
          $$ = makeBfnd(fi,FOR_NODE);
          doRange = makeLlnd(fi,RANGE_OP,$3,$5,SMNULL);
          doDdot = makeLlnd(fi,DDOT,doRange,LLNULL,SMNULL);
/*
          doDdot = makeLlnd(fi,DDOT,doRange,LLNULL,$1->entry.Template.symbol);
*/
          /*What shall I fit into the second llnd pointer ? */
          $$ = makeDoBfnd($$,$1->entry.Template.symbol,doDdot,LLNULL,LLNULL,LBNULL);
          }
    |  do_variable EQUAL numeric_expr COMMA
       numeric_expr COMMA
       numeric_expr {
          PTR_LLND doRange,doDdot;
          $$ = makeBfnd(fi,FOR_NODE);
          doRange = makeLlnd(fi,RANGE_OP,$3,$5,SMNULL);
          doDdot = makeLlnd(fi,DDOT,doRange,$7,SMNULL);
/*
          doDdot = makeLlnd(fi,DDOT,doRange,$7,$1->entry.Template.symbol);
*/
          /*What shall I fit into the second llnd pointer ? */
          $$ = makeDoBfnd($$,$1->entry.Template.symbol,doDdot,LLNULL,LLNULL,LBNULL);
          }
    |  COMMA do_variable EQUAL numeric_expr
       COMMA numeric_expr {
          PTR_LLND doRange,doDdot;
          $$ = makeBfnd(fi,FOR_NODE);
          doRange = makeLlnd(fi,RANGE_OP,$2,$4,SMNULL);
          doDdot = makeLlnd(fi,DDOT,doRange,LLNULL,SMNULL);
/*
          doDdot = makeLlnd(fi,DDOT,doRange,LLNULL,$2->entry.Template.symbol);
*/
          /*What shall I fit into the second llnd pointer ? */
          $$ = makeDoBfnd($$,$2->entry.Template.symbol,doDdot,LLNULL,LLNULL,LBNULL);
          }
    |  COMMA WHILE LEFTBRACKET
       logical_expr RIGHTBRACKET {
          $$ = makeBfnd(fi,DO_WHILE_NODE);
          $$ = makeDoWhileBfnd($$,$4);
          }
    |  WHILE LEFTBRACKET
       logical_expr RIGHTBRACKET {
          $$ = makeBfnd(fi,DO_WHILE_NODE);
          $$ = makeDoWhileBfnd($$,$3);
          }
    ;
       
numeric_expr
    :  expr {
          $$ = $1;
          }
    ;
       
do_variable
    :  name /* variable    Lxy 1/10/1996  */ {
          PTR_SYMB s;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          s->dovar =1;
          $$ = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          }
    ;
       
nonblock_do_construct    
    :  label_do_stmt {
          /* Use a stack to store the previous label? */
          }
    ;
       
/*
nonblock_do_construct    : outer_shared_do_construct
                                {
          $$ = $1;
          }
                         ;

outer_shared_do_construct: label_do_stmt cmnt executable... 
                         | outer_shared_do_construct
                           label_do_stmt cmnt executable...
                         ;
*/
       
/*********************   If_construct   8.25.95 ***************************/
       
if_construct             
    :  if_then_stmt cmnt
       block
       newname11...
       else_stmt cmnt
       block
       end_if_stmt {
          /* Now cur_blob is pointing to the last 
          statement in the most inner if-structure*/
          PTR_BFND p;
          pred_bfnd = $1;
          /*cur_blob = follow_blob(pred_bfnd->entry.Template.bl_ptr2);
          p = makeBfnd(fi,CONTROL_END);
          setBlob(p,pred_bfnd); */
          pred_bfnd = pred_bfnd->control_parent;
          cur_blob = findBlob($1);
          $$ = $1;
          }
    |  if_then_stmt cmnt
       block
       newname11...
       end_if_stmt  {
          PTR_BFND p;
          pred_bfnd = $1;
          /* if($4)
          cur_blob = follow_blob(pred_bfnd->entry.Template.bl_ptr2);
          p = makeBfnd(fi,CONTROL_END);
          setBlob(p,pred_bfnd); */
          pred_bfnd = pred_bfnd->control_parent;
          cur_blob = findBlob($1);
          $$ = $1;
          }
    ;
       
                           /*newname11... = [else_if_stmt block]...*/
newname11...                 
    :   {
          $$ = BFNULL;
          }
    |  newname11... else_if_stmt cmnt block {
          }
    ;
       
if_then_stmt             
   :  /*if_construct_*/name COLON
       IF LEFTBRACKET logical_expr
       RIGHTBRACKET THEN in_prog {
          PTR_SYMB s;

          s= lookupSymb($1,cur_scope()->entry.prog_stmt.prog_symb);
          if (s!=NULL ) 
             err_g("Redeclared if  construct name :",lineNum_g,$1);
          else
             s = makeSymb(fi,cur_scope(),CONSTRUCT_NAME,$1,1);
          if (s->variant!=CONSTRUCT_NAME)
             err_g("Invalid IF construct name: ",lineNum_g,$1);
          lastBranchEnd = cur_blob;
          $$ = makeBfnd(fi,LOGIF_NODE);
          $$ = makeIfBfnd($$,s,$5);
          /* setBfndList(cur_blob->ref,$$); */
          makeSonBlob($$,1);
          }
    |  IF LEFTBRACKET logical_expr
       RIGHTBRACKET THEN in_prog {
          lastBranchEnd = cur_blob;
          $$ = makeBfnd(fi,LOGIF_NODE);
          $$ = makeIfBfnd($$,SMNULL,$3);
          /* setBfndList(cur_blob->ref,$$); */
          makeSonBlob($$,1);
          }
    ;
       
else_if_stmt             
    :  ELSEIF LEFTBRACKET logical_expr
       RIGHTBRACKET THEN name  {
          PTR_BFND p;
          PTR_SYMB s;
                                                /* add by zheng.gb */
          s= lookupSymb($6,cur_scope()->entry.prog_stmt.prog_symb);
          if (s==NULL ) {
             err_g("nondeclared if  construct name :",lineNum_g,$6);
             s = makeSymb(fi,cur_scope(),CONSTRUCT_NAME,$6,0);
          }
          if (s->variant!=CONSTRUCT_NAME)
             err_g("Invalid IF construct name: ",lineNum_g,$6);

          p = makeEnd(fi);
          --(p->g_line); --(p->l_line);
          setBfndList(cur_blob->ref,p); 
          makeSonBlob(cur_blob->ref,0);
          $$ = makeBfnd(fi,ELSEIF_NODE);
          $$ = makeElseIfBfnd($$,$3,s);
          /* setBfndList(BFNULL,$$); */
          makeSonBlob($$,1);
          }
    |  ELSEIF LEFTBRACKET logical_expr
       RIGHTBRACKET THEN  {
          PTR_BFND p;
          p = makeEnd(fi);
          --(p->g_line); --(p->l_line);
          setBfndList(cur_blob->ref,p);
          makeSonBlob(cur_blob->ref,0);
          $$ = makeBfnd(fi,ELSEIF_NODE);
          $$ = makeElseIfBfnd($$,$3,SMNULL);                                               
          /* setBfndList(BFNULL,$$); */
          makeSonBlob($$,1);                             
          }
    ;
       
else_stmt                
    :  ELSE /*if_construct_*/name  {
          PTR_BFND p;
          PTR_SYMB s;
                                                /*   add by zheng.gb       */
          s= lookupSymb($2,cur_scope()->entry.prog_stmt.prog_symb);
          if (s==NULL ) {
             err_g("nondeclared IF construct name :",lineNum_g,$2);
             s = makeSymb(fi,cur_scope(),CONSTRUCT_NAME,$2,0);
          }
          if (s->variant!=CONSTRUCT_NAME)
             err_g("Invalid IF construct name: ",lineNum_g,$2);

          p = makeEnd(fi);
          p->entry.contol_end.control_name=s;   /* add by zheng.gb */
          --(p->g_line); --(p->l_line);
          setBfndList(cur_blob->ref,p);
          makeSonBlob(cur_blob->ref,0);
          }
    |  ELSE  {
          PTR_BFND p;
          p = makeEnd(fi);
          --(p->g_line); --(p->l_line);
          setBfndList(cur_blob->ref,p);
          makeSonBlob(cur_blob->ref,0);
          }
    ;
       
end_if_stmt             
    :  ENDIF /*if_construct_*/name  {
          PTR_SYMB s;
                                                  /*   add by zheng.gb       */
          s= lookupSymb($2,cur_scope()->entry.prog_stmt.prog_symb);
          if (s==NULL ) {
             err_g("nondeclared IF construct name :",lineNum_g,$2);
             s = makeSymb(fi,cur_scope(),CONSTRUCT_NAME,$2,0);
          }
          if (s->variant!=CONSTRUCT_NAME)
             err_g("Invalid IF construct name: ",lineNum_g,$2);

          $$ = makeEnd(fi);
          $$->entry.contol_end.control_name=s;  /* add by zheng.gb */
          setBfndList(cur_blob->ref,$$);
          --($$->g_line); --($$->l_line);
          }
    |  ENDIF  {
          $$ = makeEnd(fi);
          setBfndList(cur_blob->ref,$$);
          }
    ;
       
/*
if_stmt                  
    :  IF LEFTBRACKET logical_expr
       RIGHTBRACKET action_stmt in_prog {
          PTR_BFND endIf;
          $$ = makeBfnd(fi,LOGIF_NODE);
          $$ = makeLogIfBfnd($$,$3,$5);
          makeSonBlob($$,1);
          setBlob($5,pred_bfnd);
          endIf = makeEnd(fi);
          --($$->g_line); --($$->l_line);
          setBfndList($5,endIf);
          }
    ;
*/
if_stmt
    :  if_stmt_begin action_stmt {
          PTR_BFND bf,endIf;
/*
          $$=$1;
          setBlob($2,pred_bfnd);
          $$ = makeEnd(fi);
          --($$->g_line); --($$->l_line);
*/
          $$=$1;
	  if ($2->variant != WHERE_NODE && $2->variant != FORALL_STMT )
            setBlob($2,$1);
          endIf = makeEnd(fi);
          --(endIf->g_line); --(endIf->l_line);
	  setBfndList($2,endIf);
        }
    ;


if_stmt_begin
    :  IF LEFTBRACKET logical_expr
       RIGHTBRACKET {
        $$ = makeBfnd(fi,LOGIF_STMT);
        $$->entry.if_stmt.condition = $3;
        makeSonBlob($$,1);
          }
    ;
       
       
arithmetic_if_stmt       
    :  IF LEFTBRACKET logical_expr  /* level_2_expr */
       RIGHTBRACKET 
       label COMMA label COMMA label in_prog {
          PTR_LLND labList;
          labList = set_ll_list($5,$7,LABEL_LIST);
          labList = set_ll_list(labList,$9,LABEL_LIST);
          $$ = makeBfnd(fi,ARITHIF_NODE);
          $$ = makeArithIfBfnd($$,$3,labList);
          }
    ;
       
/******************    Where_stmt  ****************************************/
       
where_construct          
    :  where_construct_begin cmnt
       assignment_stmt...
       end_where_stmt  {
          setBfndList($3,$4);
          }
    |  where_construct_begin cmnt
       assignment_stmt...
       elsewhere_stmt cmnt
       assignment_stmt...
       end_where_stmt  {
          PTR_BFND p;
          $$ = makeElseBranch($1,$3,$6,$7);
          setBfndList($6,$7);
          }
    ;
       
assignment_stmt...         
    :  {
          $$ = BFNULL;
          }
    |  assignment_stmt... assignment_stmt cmnt {
          $$ = setBfndList($1,$2);
          }
    ;
       
       
mask_expr                
    :  logical_expr
    ;
       
elsewhere_stmt           
    :  ELSEWHERE  {
                                                /* zheng.gb */
          $$ = makeBfnd(fi,CONTROL_END);
          setBlob($$,pred_bfnd);

          lastBranchEnd = cur_blob;
          }
    ;
       
end_where_stmt           
    :  ENDWHERE  {
          /* $$ = makeBfnd(fi,CONTROL_END); */
          $$ = makeEnd(fi); 
          }
    ;
              
where_construct_begin        
    :  WHERE LEFTBRACKET mask_expr RIGHTBRACKET  in_prog {
          $$ = makeBfnd(fi,WHERE_BLOCK_STMT);
          $$ = makeWhereBfnd($$,$3);
          /* because the action is the same as where_node bfnd here */
          }
    ;
       
                                /*   new !  add by zheng.gb */
where_stmt_begin
    :  WHERE LEFTBRACKET mask_expr RIGHTBRACKET {
          $$ = makeBfnd(fi,WHERE_NODE);
          $$ = makeWhereStmt($$,$3);
          makeSonBlob($$,1);
        }
    ;

               /*   substitute by zheng.gb */
where_stmt
    :  where_stmt_begin
        assignment_stmt {
          PTR_BFND endWhere;

          setBlob($2,$1);
          $$= $1;
          endWhere = makeEnd(fi);
          --($$->g_line); --($$->l_line);
          setBfndList($2,endWhere);
        }
    ;

/*
where_stmt
    :  WHERE LEFTBRACKET mask_expr RIGHTBRACKET 
       assignment_stmt in_prog {
          PTR_BFND endWhere;

          $$ = makeBfnd(fi,WHERE_NODE);
          $$ = makeLogIfBfnd($$,$3,$5);
          makeSonBlob($$,1);
          setBlob($5,pred_bfnd);
          endWhere = makeEnd(fi);
          --($$->g_line); --($$->l_line);
          setBfndList($5,endWhere);
          }
    ;
*/
       
       
/************************   8.25.1995  ************************************/
       
/********************    I/O File Operate  ********************************/
       
backspace_stmt           
    :  BACKSPACE external_file_unit in_prog {
          $$ = makeBfnd(fi,BACKSPACE_STAT);
          $$ = makeBackspceBfnd($$,$2,LLNULL); 
          }
    |  BACKSPACE LEFTBRACKET
       position_spec_list RIGHTBRACKET in_prog {
          $$ = makeBfnd(fi,BACKSPACE_STAT);
          $$ = makeBackspceBfnd($$,LLNULL,$3); 
          }
    ;
       
external_file_unit       
    :  variable
    |  int_literal_constant  /*  Lxy 4/26 */
    ;
       
position_spec_list         
    :  position_spec {
          $$ = makeLlnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);
          $$ = makeLlExpLst($$,$1,LLNULL,SMNULL);
          }
    |  position_spec_list COMMA position_spec {
          $$ = makeLlnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
          $$ = makeLlExpLst($$,$3,$1,SMNULL); /* Link $3 to $1 */
          }
    ;
position_spec            
    :  UNIT external_file_unit {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"unit";
          /* $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL); */
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  external_file_unit {
          /* $$ = makeLlnd(fi,SPEC_PAIR,LLNULL,$1,SMNULL); */
          $$ = makeLlnd(fi,SPEC_PAIR,LLNULL,$1,SMNULL);
          /* $$ = $1; */
          }
    |  IOSTAT variable {
	  /* added by Yanmi*/
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"iostat";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);

	  /* deleted by Yanmi
          $$ = makeLlnd(fi,IOSTAT_STORE,LLNULL,$2,SMNULL);
	  */
          }
    |  ERR label    {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"err";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          /* $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL); */
          }
    ;
       
rewind_stmt              
    :  REWIND external_file_unit in_prog {
          $$ = makeBfnd(fi,REWIND_STAT);
          $$ = makeBackspceBfnd($$,$2,LLNULL);
          /* Using the same structure as backspace_stmt */
          }
    |  REWIND LEFTBRACKET  position_spec_list 
       RIGHTBRACKET in_prog {
          $$ = makeBfnd(fi,REWIND_STAT);
          $$ = makeBackspceBfnd($$,LLNULL,$3);
          /* Using the same structure as backspace_stmt */
          }
    ;
       
endfile_stmt             
    :  ENDFILE external_file_unit in_prog {
          $$ = makeBfnd(fi,ENDFILE_STAT);
          $$ = makeBackspceBfnd($$,$2,LLNULL);
          /* Using the same structure as backspace_stmt */
          }
    |  ENDFILE LEFTBRACKET position_spec_list 
       RIGHTBRACKET in_prog {
          $$ = makeBfnd(fi,ENDFILE_STAT);
          $$ = makeBackspceBfnd($$,LLNULL,$3);
          /* Using the same structure as backspace_stmt */
          }
    ;
       
       
close_stmt               
    :  CLOSE LEFTBRACKET close_spec_list  
       RIGHTBRACKET in_prog {
          $$ = makeBfnd(fi,CLOSE_STAT);
          $$ = makeCloseBfnd($$,$3); 
          }
    ;
       
close_spec_list                 
    :  close_spec {
          $$ = makeLlnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);
          $$ = makeLlExpLst($$,$1,LLNULL,SMNULL);
          }
    |  close_spec_list COMMA close_spec {
          $$ = makeLlnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
          $$ = makeLlExpLst($$,$3,$1,SMNULL); /* Link $3 to $1 */
          }
    ;
        
close_spec               
    :  UNIT external_file_unit     {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val =  (char *)"unit"; /* copys(yytext);*/
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          /* $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);*/
          }
    |  external_file_unit {
          $$ = makeLlnd(fi,SPEC_PAIR,LLNULL,$1,SMNULL); 
		/*modified by Yanmi*/
          /*$$ = makeLlnd(fi,SPEC_PAIR,$1,LLNULL,SMNULL);*/
          /* $$ = $1;*/
          }
    |  IOSTAT variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"iostat";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          /* $$ = makeLlnd(fi,IOSTAT_STORE,p,$2,SMNULL);*/
          }
    |  ERR label {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"err";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  STATUS default_char_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"status";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    ;
       
               
inquire_stmt             
    :  INQUIRE LEFTBRACKET inquire_spec_list
       RIGHTBRACKET in_prog {
          $$ = makeBfnd(fi,INQUIRE_STAT);
          $$ = makeInquireBfnd($$,$3,LLNULL,LLNULL);
          }
    |  INQUIRE LEFTBRACKET IOLENGTH 
       variable RIGHTBRACKET 
       output_item_list in_prog {
          /* modified by Yanmi */
          PTR_LLND p,q;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"iolength";
          q = makeLlnd(fi,SPEC_PAIR,p,$4,SMNULL);
          $$ = makeBfnd(fi,INQUIRE_STAT);
          $$ = makeInquireBfnd($$,LLNULL,q,$6);
          /* Made by Zheng Qiang 
          $$ = makeBfnd(fi,INQUIRE_STAT);
          $$ = makeInquireBfnd($$,LLNULL,$4,$6); */
          }
    ;
       
inquire_spec_list         
    :  inquire_spec {
          $$ = makeLlnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);
          $$ = makeLlExpLst($$,$1,LLNULL,SMNULL);
          }
    |  inquire_spec_list COMMA inquire_spec {
          $$ = makeLlnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
          $$ = makeLlExpLst($$,$3,$1,SMNULL); /* Link $3 to $1 */
          }
    ;
       
inquire_spec 
    :  external_file_unit {
          $$ = makeLlnd(fi,SPEC_PAIR,LLNULL,$1,SMNULL);
          }
    |  UNIT external_file_unit {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"unit";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  FILEI file_name_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"file";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  IOSTAT variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"iostat";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  ERR label  {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"err";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  EXIST variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"exist";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  OPENED variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"opened";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  NUMBER variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"number";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  NAMED variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"named";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  NAMEI variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"namei";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  ACCESSL variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"access";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  SEQUENTIAL variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"sequential";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  DIRECT variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"direct";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  FORM variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"form";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  FORMATTED variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"formatted";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  UNFORMATTED variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"unformatted";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  RECL variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"recl";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  NEXTREC variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"nextrec";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  BLANK variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"blank";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  POSITION variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"position";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  ACTION variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"action";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  READI variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"read";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  WRITEI variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"write";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  READWRITE variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"readwrite";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  DELIM variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"delim";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  PAD variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"pad";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    ;
                       
       
       
open_stmt                
    :  OPEN LEFTBRACKET connect_spec_list
       RIGHTBRACKET in_prog {
          $$ = makeBfnd(fi,OPEN_STAT);
          $$ = makeOpenBfnd($$,$3);
          }
    ;
       
connect_spec_list         
    :  connect_spec {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  connect_spec_list COMMA connect_spec {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;
       
connect_spec             
    :  UNIT external_file_unit {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"unit";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  external_file_unit {
          $$ = makeLlnd(fi,SPEC_PAIR,LLNULL,$1,SMNULL);
          }
    |  IOSTAT variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"iostat";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  ERR label {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"err";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  FILEI file_name_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"file";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  STATUS default_char_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"status";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  ACCESSL default_char_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"access";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  FORM default_char_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"form";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  RECL expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"recl";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  BLANK default_char_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"blank";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  POSITION default_char_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"position";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  ACTION default_char_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"action";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  DELIM default_char_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"delim";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  PAD default_char_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"pad";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    ;
       
file_name_expr           /* modified by zheng.gb 1997/1/2  */
    :  char_literal_constant
    |  variable
    ;
       
default_char_expr         
    :  char_literal_constant
    ;
        
print_stmt               
    :  PRINT format COMMA output_item_list in_prog {
          $$ = makeBfnd(fi,PRINT_STAT);
          $$ = makePrintBfnd($$,$2,$4);
          }
    |  PRINT format in_prog {
          $$ = makeBfnd(fi,PRINT_STAT);
          $$ = makePrintBfnd($$,$2,LLNULL);
          }
    ;
       
format                         
    :  STRING {
          /* all the format: delete KIND_VAL node by Yanmi
          PTR_LLND pp;
          pp = makeLlnd(fi,STRING_VAL, LLNULL, LLNULL, SMNULL);
          pp->entry.string_val = $1; */
          /* Made by Zheng Qiang */
          PTR_LLND pp;
          pp = makeLlnd(fi,STRING_VAL, LLNULL, LLNULL, SMNULL);
          pp->entry.string_val = copys($1);
          pp->type = global_string;
          $$ =  makeLlnd(fi,KIND_VAL,pp,LLNULL,SMNULL); 
          }
    |  label {
          $$ = $1; 
          }
    |  MULTIPLY  {
          /* all the format: delete KIND_VAL node by Yanmi 
          $$=makeLlnd(fi,STRING_VAL, LLNULL, LLNULL, SMNULL);
          $$->entry.string_val=(char *)"*";*/
          /* Made by Zheng Qiang*/
          $$ =  makeLlnd(fi,KIND_VAL,LLNULL,LLNULL,SMNULL);
          $$->entry.var_ref_s.symbol= fi->head_symb; 
          }
    |  variable   {
          /* added  byYanmi
          $$=$1;*/
          /*deleted by Yanmi Made by Zheng Qiang*/
          $$ = makeLlnd(fi,KIND_VAL,$1,LLNULL,SMNULL);
          }
    ;
       
                        
output_item_list         
    :  output_item {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  output_item_list COMMA output_item {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;
       
output_item             
    :  expr1     {
          $$ = $1;
          }
    |  LEFTBRACKET /*real_part*/ expr1
       COMMA /*image_part*/ expr1 RIGHTBRACKET   {
          if(debugFlag_g==1) printf("complex_const:%s\n",$$);
          $$ = makeLlnd(fi,COMPLEX_VAL, $2, $4, SMNULL);
          $$->type = global_complex;
          }
    |  io_implied_do     {
          $$ = $1;
          }
    ;
               
read_stmt                
    :  READ LEFTBRACKET io_control_spec_list
       RIGHTBRACKET input_item_list in_prog {
          $$ = makeBfnd(fi,READ_STAT);
          $$ = makeReadBfnd($$,LLNULL,$3,$5); 
          }
    |  READ LEFTBRACKET io_control_spec_list
       RIGHTBRACKET in_prog {
          $$ = makeBfnd(fi,READ_STAT);
          $$ = makeReadBfnd($$,LLNULL,$3,LLNULL); 
          }
    |  READ format COMMA input_item_list in_prog  {
          $$ = makeBfnd(fi,READ_STAT);
          $$ = makeReadBfnd($$,$2,LLNULL,$4); 
          }
    |  READ format in_prog {
          $$ = makeBfnd(fi,READ_STAT);
          $$ = makeReadBfnd($$,$2,LLNULL,LLNULL); 
          }
    ;
       
input_item_list                 
    :  input_item {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          /* $$ = makeLlnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);*/
          }
    |  input_item_list COMMA input_item {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          /* PTR_LLND llnd;
          llnd = makeLlnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
          $$ = AppendllndList($1,llnd); */
          }
    ;
       
input_item               
    :  variable {
          $$ = $1;
          }
    |  io_implied_do {
          $$ = $1; 
          }
    ;
       
/*
io_implied_do            
    :  LEFTBRACKET io_implied_do_object_list COMMA
       io_implied_do_control RIGHTBRACKET {
                                    /* modified by zheng.gb 1996.5.17 
          $$ = makeLlnd(fi,IMPLIED_DO,$2,$4,$4->entry.Template.symbol); 
          $4->entry.Template.symbol=SMNULL;
          }
    ;
       
*/ /* xli. 10/21/1996 */

io_implied_do
	:  LEFTBRACKET io_implied_do1  RIGHTBRACKET 
		{ $$ = $2; }
	|  LEFTBRACKET io_implied_do COMMA
       io_implied_variable EQUAL expr COMMA
       expr RIGHTBRACKET {
          PTR_LLND p,q,l;                 /* modified by zheng.gb 1997/1/2 */
          p = makeLlnd(fi,RANGE_OP,$6,$8,SMNULL);
          q = makeLlnd(fi,DDOT,p,LLNULL,$4);

          l = makeLlnd(fi,EXPR_LIST,$2,LLNULL,SMNULL);
          $$ = makeLlnd(fi,IMPLIED_DO,l,q,q->entry.Template.symbol);
          q->entry.Template.symbol=SMNULL;
		 }
    |  LEFTBRACKET io_implied_do COMMA
       io_implied_variable EQUAL expr COMMA
       expr COMMA expr RIGHTBRACKET {
          PTR_LLND p,q,l;        /* modified by zheng.gb 1997/1/2 */
          p = makeLlnd(fi,RANGE_OP,$6,$8,SMNULL);
          q = makeLlnd(fi,DDOT,p,$10,$4);

          l = makeLlnd(fi,EXPR_LIST,$2,LLNULL,SMNULL);
	  $$ = makeLlnd(fi,IMPLIED_DO,l,q,q->entry.Template.symbol);
          q->entry.Template.symbol=SMNULL;
		 } 
	;

io_implied_do1
    :  io_implied_do_object_list COMMA
       io_implied_variable EQUAL expr COMMA
       expr COMMA expr { 
		  PTR_LLND p,q;
          p = makeLlnd(fi,RANGE_OP,$5,$7,SMNULL);
          q = makeLlnd(fi,DDOT,p,$9,$3);

          $$ = makeLlnd(fi,IMPLIED_DO,$1,q,q->entry.Template.symbol);
          q->entry.Template.symbol=SMNULL;
			}
	|  io_implied_do_object_list  COMMA
	   io_implied_variable EQUAL expr COMMA expr { 
          PTR_LLND p,q;
          p = makeLlnd(fi,RANGE_OP,$5,$7,SMNULL);
          q = makeLlnd(fi,DDOT,p,LLNULL,$3);

          $$ = makeLlnd(fi,IMPLIED_DO,$1,q,q->entry.Template.symbol);
          q->entry.Template.symbol=SMNULL;
			}
    |  expr1 COMMA
       io_implied_variable EQUAL expr COMMA
       expr COMMA expr { 
          PTR_LLND p,q,r;                /* modified by zheng.gb 1996/10/26 */
          p = makeLlnd(fi,RANGE_OP,$5,$7,SMNULL);
          q = makeLlnd(fi,DDOT,p,$9,$3);

	  r = makeLlnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);

          $$ = makeLlnd(fi,IMPLIED_DO,r,q,q->entry.Template.symbol);
          q->entry.Template.symbol=SMNULL;
			}
    |  expr1  COMMA
       io_implied_variable EQUAL expr COMMA expr { 
	  PTR_LLND p,q,r;                /* modified by zheng.gb 1996/10/26 */
          p = makeLlnd(fi,RANGE_OP,$5,$7,SMNULL);
          q = makeLlnd(fi,DDOT,p,LLNULL,$3);

	  r = makeLlnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);

          $$ = makeLlnd(fi,IMPLIED_DO,r,q,q->entry.Template.symbol);
          q->entry.Template.symbol=SMNULL;
			}
	;
	
io_implied_do_object_list
    :  expr1  COMMA expr1  /* io_implied_do_object */{
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
		  $$ = set_ll_list($$,$3,EXPR_LIST);
          }
    |  io_implied_do_object_list
       COMMA  expr1 /* io_implied_do_object */ {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    |  expr1  COMMA LEFTBRACKET expr1  COMMA expr1  RIGHTBRACKET {
          PTR_LLND p;

          p = makeLlnd(fi,COMPLEX_VAL, $4, $6, SMNULL);
          p ->type = global_complex;

          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          $$ = set_ll_list($$,p,EXPR_LIST);
		 }
    |  LEFTBRACKET expr1  COMMA expr1  RIGHTBRACKET { 
          PTR_LLND p;

          p = makeLlnd(fi,COMPLEX_VAL, $2, $4, SMNULL);
          p ->type = global_complex;

          $$ = set_ll_list(p,LLNULL,EXPR_LIST);
		}
    |  io_implied_do_object_list
       COMMA  LEFTBRACKET expr1  COMMA expr1  RIGHTBRACKET {
          PTR_LLND p;

          p = makeLlnd(fi,COMPLEX_VAL, $4, $6, SMNULL);
          p ->type = global_complex;

		  $$ = set_ll_list($$,p,EXPR_LIST);
       }
    ;
       
/*
io_implied_do_object  
    : expr1  /*  array_element  input_item  
    | io_implied_do   
    ;
*/ 			/* xli. 10/21/1996 */
       
/*
io_implied_do_control    
    :  variable EQUAL numeric_expr COMMA
       numeric_expr COMMA
       numeric_expr {
          PTR_LLND p;
          p = makeLlnd(fi,RANGE_OP,$3,$5,SMNULL);
          $$ = makeLlnd(fi,DDOT,p,$7,$1->entry.Template.symbol);
          }
    |  variable EQUAL numeric_expr COMMA
       numeric_expr         {
          PTR_LLND p;
          p = makeLlnd(fi,RANGE_OP,$3,$5,SMNULL);
          $$ = makeLlnd(fi,DDOT,p,LLNULL,$1->entry.Template.symbol);
          }
    ;
*/ /* xli. 10/21/1996 */
       
io_implied_variable
    :   name   /*  variable */ {
          $$ = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          $$->dovar =1;
          $$->entry.var_decl.dovar =1;
          }
    ;

write_stmt               
    :  WRITE LEFTBRACKET io_control_spec_list
       RIGHTBRACKET output_item_list in_prog {
          $$ = makeBfnd(fi,WRITE_STAT);
          $$ = makeWriteBfnd($$,$5,$3);  /*modified by Yanmi 12/17/96*/
          }
    |  WRITE LEFTBRACKET io_control_spec_list
       RIGHTBRACKET in_prog {
          $$ = makeBfnd(fi,WRITE_STAT);
          $$ = makeWriteBfnd($$,LLNULL,$3); /*Yanmi 12/17/96 */                         
          }
    ;
       
io_control_spec_list     
    :  io_control_spec {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST);
          }
    |  io_control_spec_list COMMA2 io_control_spec {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;
       
       
io_control_spec          
    :  UNIT io_unit {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"unit";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
                         | NML /*namelist_group_*/name {
          PTR_SYMB s;
          PTR_LLND ss,ll;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$2,0); 
          ss = makeLlnd(fi,VAR_REF, LLNULL, LLNULL,s);
          ll = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          ll->entry.string_val = (char *)"nml";
          $$ = makeLlnd(fi,SPEC_PAIR,ll,ss,SMNULL);         
          }
    |  FMT format {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"fmt";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  REC expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"rec";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  IOSTAT variable {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"iostat";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  ERR label {
          PTR_LLND ss,ll;
                     /* modified by zheng.gb  1996.5.6  */
          ss = makeLblLst(fi,ERR_LABEL,LLNULL,$2->entry.label_ref.lab_ptr);
          ll = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          ll->entry.string_val = (char *)"err";
/*deleted by Yanmi
          $$ = makeLlnd(fi,SPEC_PAIR,ll,ss,SMNULL);
*/
/*deleted by Yanmi*/
	$$ = makeLlnd(fi,SPEC_PAIR,ll,$2,SMNULL);
          }
    |  ENDR label {
                     /* modified by zheng.gb  1996.5.6  */
          PTR_LLND p,ll;
          ll = makeLblLst(fi,END_LABEL,LLNULL,$2->entry.label_ref.lab_ptr);
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"end";
/*deleteed by Yanmi
          $$ = makeLlnd(fi,SPEC_PAIR,p,ll,SMNULL);
*/
/*added by Yanmi*/
	$$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  ADVANCE default_char_expr {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"advance";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  SIZE variable {
          PTR_LLND p;        
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"size";
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  EOR label   {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"eor"; 
          $$ = makeLlnd(fi,SPEC_PAIR,p,$2,SMNULL);
          }
    |  STRING   {
          PTR_LLND ll;
          ll = makeLlnd(fi,STRING_VAL,LLNULL,LLNULL,SMNULL);
          ll->entry.string_val = $1;
          $$ = makeLlnd(fi,SPEC_PAIR,LLNULL,ll,SMNULL);
          }
    |  label  {
          $$ = makeLlnd(fi,SPEC_PAIR,LLNULL,$1,SMNULL);
          }
    |  MULTIPLY  {
          PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"*";
          $$ = makeLlnd(fi,SPEC_PAIR,LLNULL,p,SMNULL); 
          }
    |  variable   {
          /*  PTR_LLND p;
          p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          Zgs asked to comment it off so that th unparser can deal with it easily */
          $$ = makeLlnd(fi,SPEC_PAIR,LLNULL,$1,SMNULL);
          }
    ;
       
       
io_unit                  
    :  MULTIPLY {
          $$ =  makeLlnd(fi,KIND_VAL,LLNULL,LLNULL,SMNULL);
          $$->entry.var_ref_s.symbol= fi->head_symb;
          /* PTR_LLND p;
          p = makeLlnd(fi,SPEC_PAIR,LLNULL,LLNULL,SMNULL);
          p->entry.string_val = (char *)"*";
          $$ = makeLlnd(fi,SPEC_PAIR,p,LLNULL,SMNULL); */
          }
    |  expr
    ;
       
/*********************      8.22.1995     *****************************/
       
/****************     Format_stmt   8.23.1995    **********************/
       
format_stmt           
    :  /*_labelnu*/ FORMAT format_specification in_prog {
          if(debugFlag_g==1) printf("format :%s\n",$$);
          $$ = makeBfnd(fi,FORMAT_STAT);
          $$ = makeFmtBfnd($$,$2);
          }
    ;
       
format_specification     
    :  LEFTBRACKET format_item_list RIGHTBRACKET {
          char sp1[STR_LENGTH];

          sp1[0]='\0';                  /* by zheng.gb   1996.5.4 */
          if(debugFlag_g==1)
          printf("format_spec :%s\n",$$);

          $$ = makeLlnd(fi,STMT_STR,LLNULL,LLNULL,SMNULL);
          mynop();
          strcpy(sp1,"(");
          strcat(sp1,$2);
          strcat(sp1,")");
          $$->entry.string_val = copys(sp1);
          $$->type = global_string;
          }
    |  LEFTBRACKET RIGHTBRACKET {
          $$ = makeLlnd(fi,STMT_STR,LLNULL,LLNULL,SMNULL);
          $$->entry.string_val = "()";
          $$->type = global_string;
          }
    ;
       
format_item_list         
    :  format_item {
          char sp1[STR_LENGTH];

          sp1[0]='\0';
          strcpy(sp1,$1);
          $$ = copys(sp1);               /* zheng.gb 1996.5.29 */
          }
    |  format_item_list opt_comma /*COMMA*/ format_item {
          char  sp1[STR_LENGTH];

          if(debugFlag_g==1) printf("format_item :%s\n",$3);
          sp1[0]='\0';
          strcat(sp1,$1);
          strcat(sp1,(char *)",");
          strcat(sp1,$3);
          $$=copys(sp1);
/*                                         zheng.gb   1996.5.4
          strcat($1,(char *)",");
          strcat($1,$3);
          strcpy($$,$1);
*/
          }
    ;

opt_comma
    :
    |  COMMA
    ;

format_item              
    :  r data_edit_desc {
        strcpy($$,$1);
        strcat($$,$2);
        }
    |  data_edit_desc {
        strcpy($$,$1);
        }
    |  control_edit_desc {
        strcpy($$,$1);
        }
    |  char_string_edit_desc {
        strcpy($$,$1);
        }
    |  r LEFTBRACKET format_item_list RIGHTBRACKET {
        strcpy($$,$1);
        strcat($$,(char *)"(");
        strcat($$,$3);
        strcat($$,(char *)")");
        }
    |  LEFTBRACKET format_item_list RIGHTBRACKET {
        strcpy($$,(char *)"(");
        strcat($$,$2);
        strcat($$,(char *)")");
        }
    ;

r                        
    :  digit_string 
    ;
       
data_edit_desc        
    : I real_literal_constant /* w FULLPOINT m */ {
        strcpy($$,(char *)"I");
        strcat($$,$2->entry.string_val);
          }
    |  I w {
        strcpy($$,(char *)"I");
        strcat($$,$2);
          }
    |  B real_literal_constant /* w FULLPOINT m */ {
        strcpy($$,(char *)"B");
        strcat($$,$2->entry.string_val);
          }
    |  B w {
        strcpy($$,(char *)"B");
        strcat($$,$2);
          }
    |  O real_literal_constant /* w FULLPOINT m */ {
        strcpy($$,(char *)"O");
        strcat($$,$2->entry.string_val);
          }
    |  O w {
        strcpy($$,(char *)"O");
        strcat($$,$2);
          }
    |  Z real_literal_constant /* w FULLPOINT m */ {
        strcpy($$,(char *)"Z");
        strcat($$,$2->entry.string_val);
          }
    |  Z w {
        strcpy($$,(char *)"Z");
        strcat($$,$2);
          }
    |  F real_literal_constant /* w FULLPOINT d */ {
        strcpy($$,(char *)"F");
        strcat($$,$2->entry.string_val);
          }
    |  F w {
        strcpy($$,(char *)"F");
        strcat($$,$2);
          }
    |  E real_literal_constant /* w FULLPOINT d */ {
        strcpy($$,(char *)"E");
        strcat($$,$2->entry.string_val);
          }
    |  EN real_literal_constant /* w FULLPOINT d E e */ {
        strcpy($$,(char *)"EN");
        strcat($$,$2->entry.string_val);
          }
    |  ES real_literal_constant /*w FULLPOINT d E e */ {
        strcpy($$,(char *)"ES");
        strcat($$,$2->entry.string_val);
          }
    |  G real_literal_constant /*w FULLPOINT d E e*/ {
        strcpy($$,(char *)"G");
        strcat($$,$2->entry.string_val);
          }
    |  L w {
        strcpy($$,(char *)"L");
        strcat($$,$2);
          }
    |  A w {
        strcpy($$,(char *)"A");
        strcat($$,$2);
          }
    |  D real_literal_constant /*w FULLPOINT d*/ {
        strcpy($$,(char *)"D");
        strcat($$,$2->entry.string_val);
          }
    |  A {
        $$ = (char *)"A";
          }
    ;
       
w                        
    :  digit_string 
    ;
       
control_edit_desc        
    :  position_edit_desc
    |  r DIVIDE {
        strcpy($$,$1);
        strcat($$,(char *)" /");
          }
    |  DIVIDE {
/*
        strcpy($$,(char *)"/");
*/
        $$=copys((char *)"/");
          }
    |  COLON {
        strcpy($$,(char *)":");
          }
    |  sign_edit_desc
    |  k P {
        strcpy($$,$1);
        strcat($$,(char *)"P");
          }
    |  blank_interp_edit_desc
    ;
       
k                        
    :  digit_string 
    ;
       
position_edit_desc       
    :  T n {
        strcpy($$,(char *)"T");
        strcat($$,$2);
          }
    |  TL n {
        strcpy($$, (char *)"TL");
        strcat($$,$2);
          }
    |  TR n {
        strcpy($$, (char *)"TR");
        strcat($$,$2);
          }
    |  n X {
        strcpy($$, $1);
        strcat($$,(char *)"X");
          }
    ;
       
n                        
    :  digit_string 
    ;
       
sign_edit_desc           
    :  S {
         $$ = "S";  
          }
    |  SP {
         $$ = "SP";  
          }
    |  SS {
         $$ = "SS";  
          }
    ;
       
blank_interp_edit_desc   
    :  BN {
         $$ = copys(yytext); /*"BN";*/  
          }
    |  BZ {
          $$ = copys(yytext); /* "BZ"; */
          }
    ;

char_string_edit_desc    /* Lxy 4/30 */
    :  STRING {
          $$=copys($1);                   /* zheng.gb 1996.5.15 */
          }
    |  c H { 
        char  sp1[STR_LENGTH];

        sp1[0]='\0';
        strcpy(sp1,$1);
        strcat(sp1,yytext);
        $$=copys(sp1);
/*
        strcpy($$,$1);
        strcat($$,yytext);
*/
        
        if(debugFlag_g==1)   
           printf("H: %s\n",$$);
          }
    ;

/*       
char_string_edit_desc    
    :  STRING 
    |  c H rep_char1 {
        strcpy($$,$1);
        strcat($$,(char *)"H");
        strcat($$,$3);
          }
    ;
       
rep_char1                
    :  HCHAR  {
        $$ = copys(yytext); 
          }
    |  rep_char1 HCHAR {
        strcpy($$,$1);
        strcat($$,yytext); 
          }
    ;
*/       
c                        
    :  digit_string
    ;
       
       
/*********************   Array_spec 8.25.95 ****************************/
       
array_spec
    :  explicit_shape_spec_list
    |  assumed_shape_spec_list
    |  assumed_size_spec         
    ;
       
assumed_shape_spec_list  
    :  assumed_shape_spec {
          $$ = makeLlnd(fi,EXPR_LIST, $1, LLNULL, SMNULL);
          }
    |  assumed_shape_spec_list COMMA
       assumed_shape_spec {
          $$ = set_ll_list($1, $3, EXPR_LIST); 
          }
    ;
       
assumed_shape_spec       
    :  lower_bound COLON {
          PTR_LLND l;
          l= makeLlnd(fi,RANGE_OP,$1,LLNULL,SMNULL);
          $$ = makeLlnd(fi,DDOT,l , LLNULL, SMNULL); 
          }
    |  COLON {
          $$ = makeLlnd(fi, DDOT, LLNULL, LLNULL, SMNULL);
          }
    ;
       
assumed_size_spec        
    :  explicit_shape_spec_list COMMA lower_bound 
       COLON MULTIPLY {
          PTR_LLND l,p,q,m;
          m = makeLlnd(fi,STAR_RANGE,LLNULL,LLNULL,fi->head_symb);
          l= makeLlnd(fi,RANGE_OP,$3,m,SMNULL);
          p = makeLlnd(fi,DDOT,l , LLNULL, SMNULL); 
          q = makeLlnd(fi,EXPR_LIST, p, LLNULL, SMNULL);
                                                /* modified by zheng.gb */
          for (m=$1;m->entry.Template.ll_ptr2;
                        m=m->entry.Template.ll_ptr2);
          m->entry.Template.ll_ptr2=q;
/*
          $$ = set_ll_list($1, q , EXPR_LIST);
*/
          }
    |  MULTIPLY {
          PTR_LLND l,p,m;
          m = makeLlnd(fi,STAR_RANGE,LLNULL,LLNULL,fi->head_symb);
                                                /* modified by zheng.gb */
          l= makeLlnd(fi,RANGE_OP,LLNULL,m,SMNULL);
          /*l= makeLlnd(fi,RANGE_OP,m,LLNULL,SMNULL);*/
          p = makeLlnd(fi,DDOT,l , LLNULL, SMNULL);
          $$ = makeLlnd(fi,EXPR_LIST, p, LLNULL, SMNULL);
          }
    |  explicit_shape_spec_list COMMA MULTIPLY {
          PTR_LLND l,p,q,m;
          m = makeLlnd(fi,STAR_RANGE,LLNULL,LLNULL,fi->head_symb);
                                                /* modified by zheng.gb */
          l= makeLlnd(fi,RANGE_OP,LLNULL,m,SMNULL);
          /*l= makeLlnd(fi,RANGE_OP,m,LLNULL,SMNULL);*/
          p = makeLlnd(fi,DDOT,l , LLNULL, SMNULL);
          q = makeLlnd(fi,EXPR_LIST, p, LLNULL, SMNULL);
                                                /* modified by zheng.gb */
          for (m=$1;m->entry.Template.ll_ptr2;
                        m=m->entry.Template.ll_ptr2);
          m->entry.Template.ll_ptr2=q;
/*
          $$ = set_ll_list($1, q , EXPR_LIST);
*/
          }
    |  lower_bound COLON MULTIPLY         {
          PTR_LLND l,p,m;
          m = makeLlnd(fi,STAR_RANGE,LLNULL,LLNULL,fi->head_symb);
                                                /* modified by zheng.gb */
          l= makeLlnd(fi,RANGE_OP,$1,m,SMNULL);
          /*l= makeLlnd(fi,RANGE_OP,$1,LLNULL,SMNULL);*/
          p = makeLlnd(fi,DDOT,l , LLNULL, SMNULL);
          $$ = makeLlnd(fi,EXPR_LIST, p, LLNULL, SMNULL); 
          }
    ;
       
       
explicit_shape_spec_list 
    :  explicit_shape_spec {
          $$ = makeLlnd(fi,EXPR_LIST, $1, LLNULL, SMNULL); 
          }
    |  explicit_shape_spec_list COMMA
       explicit_shape_spec {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;
       
explicit_shape_spec      
    :  lower_bound COLON upper_bound {
          PTR_LLND l;
          l= makeLlnd(fi,RANGE_OP,$1,$3,SMNULL);
          $$ = makeLlnd(fi,DDOT,l,LLNULL,SMNULL);   
          }
    |  upper_bound {
          PTR_LLND l;
          l= makeLlnd(fi,RANGE_OP,LLNULL,$1,SMNULL);
          $$ = makeLlnd(fi,DDOT,l,LLNULL,SMNULL);
          }
    ;
       
lower_bound              
    :  expr 
    ;
       
upper_bound              
    :  expr
    ;
       
       
/************************     EXPRESSION     ******************************/
       
expr
    :  expr1 { if(debugFlag_g==1) printf("expr\n"); }          
    |  complex_expr
    ;
       
expr1
    :  expr1  defined_operator level_5_expr {
          PTR_SYMB s;
          if(debugFlag_g==1)printf("expr_defined_op\n");
          s = makeSymb(fi,cur_scope(),INTERFACE_NAME,$2,0);
          $$ = makeLlnd(fi,DEFINED_OP,$1,$3,s); 
          }
    |  level_5_expr {
          if(debugFlag_g==1) printf("expr1\n"); 
          }
    ;
       
level_5_expr             
    :  level_5_expr equiv_op equiv_operand {
          $$ = makeLlnd(fi,$2,$1,$3,SMNULL); 
          }
    |  equiv_operand  {
          if(debugFlag_g==1) printf("level_5_expr\n"); 
          }
    ;
       
equiv_op                 
    :  EQV {
          $$ = EQV_OP;
          }
    |  NEQV {
          $$ = NEQV_OP; 
          }
    ;
               
equiv_operand            
    :  equiv_operand or_op or_operand {
          $$ = makeLlnd(fi,$2,$1,$3,SMNULL);
          }
    |  or_operand
    ;
       
or_op                    
    :  OR {
          $$ = OR_OP;
          }
    ;
       
or_operand               
    :  or_operand and_op and_operand {
          $$ = makeLlnd(fi,$2,$1,$3,SMNULL);
          }
    |  and_operand
    ;
       
and_op                   
    :  AND {
          $$ = AND_OP; 
          }
    ;
       
and_operand              
    :  not_op level_4_expr {
          $$ = makeLlnd(fi,$1,$2,LLNULL,SMNULL);
          }
    |  level_4_expr
/*
    |  not_op associated_stmt {
          $$ = LLNULL;
          }
    |  associated_stmt   {
          $$ = LLNULL;
          }
*/
    |  not_op allocate_stmt {
          $$ = LLNULL; 
          }
    |  allocate_stmt {
          $$ = LLNULL; 
          }
    ;
       
not_op                   
    :  NOT {
          $$ = NOT_OP; 
          }
    ;
               
level_4_expr             
    :  level_3_expr rel_op level_3_expr {
          if(debugFlag_g==1)printf("level_4_expr:rel_op\n");  
          $$ = makeLlnd(fi,$2,$1,$3,SMNULL);
          }
    |  level_3_expr   {
          if(debugFlag_g==1) printf("level_4_expr\n"); 
          }
    ;
       
rel_op                   
    :  EQ {
          $$ = EQ_OP; 
          }
    |  NE {
          $$ = NOTEQL_OP;
          }
    |  LT {
          $$ = LT_OP;
          }
    |  LE {
          $$ = LTEQL_OP;
          }
    |  GT {
          $$ = GT_OP;
          }
    |  GE {
          $$ = GTEQL_OP;
          }
    ;
       
level_3_expr             
    :  level_3_expr concat_op level_2_expr {
          $$ = makeLlnd(fi,$2,$1,$3,SMNULL); 
          }
    |  level_2_expr  {
          if(debugFlag_g==1) printf("level_3_expr\n"); 
          }
    ;
       
concat_op                
    :  CONCAT  {
          $$ = CONCAT_OP; 
          }
    ;
       
level_2_expr             
    :  level_2_expr add_op add_operand {
             $$ = makeLlnd(fi,$2,$1,$3,SMNULL);
          }
    |  add_operand  {
          if(debugFlag_g==1) printf("level_2_expr\n"); 
          }
    |  add_op add_operand {
          $$ = makeLlnd(fi,$1,$2,LLNULL,SMNULL);
          }
    ;
       
add_op                   
    :  PLUS {
          $$ =ADD_OP; 
          }
    |  MINUS {
          $$= MINUS_OP; 
          }
    ;
       
add_operand              
    :  add_operand mult_op mult_operand {
          $$ =  makeLlnd(fi,$2,$1,$3,SMNULL);
          }
    |  mult_operand
    ;
       
mult_op                  
    :  MULTIPLY {
          $$ = MULT_OP; 
          }
    |  DIVIDE {
          $$ = DIV_OP; 
          }
    ;
       
mult_operand                 
    :  level_1_expr 
    |  mult_operand power_op level_1_expr {
          $$ =  makeLlnd(fi,$2,$1,$3,SMNULL);
          }
    ;
       
power_op                 
    :  POWER {
          $$ = EXP_OP; 
          }
    ;
       
level_1_expr             
    :  defined_operator primary   {
          PTR_SYMB s;
          if(debugFlag_g==1)printf("level_1_expr,defined_op \n");
          s = makeSymb(fi,cur_scope(),INTERFACE_NAME,$1,0);
          $$ = makeLlnd(fi,DEFINED_OP,$2,LLNULL,s); 
          }
    |  primary   {
          if(debugFlag_g==1) printf("level_1_expr \n");  
          }
    ;
       
/*** Primary *****/
       
primary
    :  literal_constant  
    |  variable  
    |  function_reference 
    |  array_constructor
/*  | constant_subobject     */
/*  | structure_constructor    */
    |  LEFTBRACKET expr RIGHTBRACKET {
          $$ = $2; 
          }
    ;
       
/*
constant_subobject       : subobject   
                          ;
*/
       
structure_constructor    
    :  name LEFTBRACKET 
       expr_list RIGHTBRACKET {
          PTR_SYMB s;
          PTR_TYPE t;
          PTR_LLND ptr;

          t = makeTypederivedref(fi,$1);
          if (t != NULL)
                s=t->name;
          else
                s=NULL;
                               /* modified by zheng.gb */
          ptr=makeLlnd(fi,TYPE_OP,LLNULL, LLNULL,s);
          ptr->type = t;
          $$ = makeLlnd(fi,STRUCTURE_CONSTRUCTOR,ptr,$3,SMNULL);
          }
    ;
       
expr_list                
    :  expr {
          $$ = set_ll_list($1,LLNULL,EXPR_LIST); 
          }
    |  expr_list COMMA expr {
          $$ = set_ll_list($1,$3,EXPR_LIST); 
          }
    ;
       
array_constructor        
    :  ACVALUE1 ac_value_list ACVALUE2 {
/* HIT */
          $$ = makeLlnd(fi,ARRAY_CONSTRUCTOR,LLNULL,$2,SMNULL);
          }
    ;
       
ac_value_list            
    :  ac_value {
          $$ = makeLlnd(fi,EXPR_LIST,$1,LLNULL,SMNULL); 
          }
    |  ac_value_list COMMA ac_value  {
          $$ = set_ll_list($1,$3,EXPR_LIST);
          }
    ;
       
ac_value                 
    :  expr
    |  ac_implied_do
    ;
       
ac_implied_do            
    :  LEFTBRACKET1 ac_value_list COMMA 
       ac_implied_do_control RIGHTBRACKET {
          $$ = $4;
          $$ -> entry.implied_do.objects=$2;
          }
    ;
       
ac_implied_do_control    
    :  ac_implied_do_var EQUAL expr COMMA
       expr COMMA expr  {
/*
          PTR_LLND l; 
          l=makeLlnd(fi,EXPR_LIST,$7,LLNULL,SMNULL);
          l=makeLlnd(fi,EXPR_LIST,$5,l,SMNULL);
          l=makeLlnd(fi,EXPR_LIST,$3,l,SMNULL);
*/
          PTR_LLND p,l;
          p = makeLlnd(fi,RANGE_OP,$3,$5,SMNULL);
          l = makeLlnd(fi,DDOT,p,$7,LLNULL);

          $$=makeLlnd(fi,IMPLIED_DO,LLNULL,l,$1);
          }
    |  ac_implied_do_var EQUAL expr COMMA   
       expr         {
          PTR_LLND p,l;
          p = makeLlnd(fi,RANGE_OP,$3,$5,SMNULL);
          l = makeLlnd(fi,DDOT,p,LLNULL,LLNULL);
/*
          PTR_LLND l;
          l= set_ll_list($3,$5,EXPR_LIST);
*/
          $$=makeLlnd(fi,IMPLIED_DO,LLNULL,l,$1); 
          }
    ;
       
ac_implied_do_var        
    :  name   {
                                           /* modified by zheng.gb 1996.5.17 */
          $$ = makeSymbVar(fi,cur_scope(),VARIABLE_NAME,$1,1);
          $$->dovar =1;
          $$->entry.var_decl.dovar =1;
          }
    ;
                               
function_reference       
    :  /*function_*/name LEFTBRACKET  
       RIGHTBRACKET   {
          PTR_SYMB s;
          s = makeSymbUnithead(fi,FUNCTION_NAME,$1);        
          $$ = makeLlnd(fi,FUNC_CALL,LLNULL,LLNULL,s);
          $$ -> type = s ->type;
          if(debugFlag_g==1) printf("func_ref : %s\n",$$); 
          }
    |  func_ref_name LEFTBRACKET RIGHTBRACKET {
          $$ = makeLlnd(fi,FUNC_CALL,LLNULL,LLNULL,$1); 
          $$ -> type = $1 ->type;
          if(debugFlag_g==1) printf("func_ref : %s\n",$$); 
          }
    |  func_ref_name LEFTBRACKET
       actual_arg_spec_list RIGHTBRACKET {
          $$ = makeLlnd(fi,FUNC_CALL,$3,LLNULL,$1);
          $$ -> type = $1->type;
          if(debugFlag_g==1) printf("func_ref : %s\n",$$); 
          }
    ;
       
func_ref_name                
    :  FUNNAME {
          char *tmp;
          char *trim_blank();

          if(debugFlag_g==1) printf("funname %s\n");
          tmp = trim_blank(yytext);                 /* zheng.gb 1996.5.15 */
          $$ = makeSymbUnithead(fi,FUNCTION_NAME,tmp);
          }
    ;
                       
/**********************   Expression end  *******************************/
       
/********************  Variable   8.25.1995 *****************************/
       
variable
    :  name  {
          PTR_SYMB s;
          if(debugFlag_g==1) printf(" variable_name: %s\n",$$);
          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          $$ = makeLlnd(fi,VAR_REF, LLNULL, LLNULL, s);
          set_expr_type($$);
          }
    |  subobject1 {
          if(debugFlag_g==1) printf("subobject1: %s\n",$$);
          }
    |  substring {
          if(debugFlag_g==1) printf("substring : %s\n",$$);
          }
    ;
       
subobject1
    :  array_section_element_funcref 
    |  structure_component            
    ;
       
       
array_section_element_funcref
    :  data_ref LEFTBRACKET
       substring_range RIGHTBRACKET {
          PTR_LLND ptr,new;

          if(debugFlag_g==1) printf("array_section: %s\n",$$); 
                                                        /* add by zheng.gb */
          $$ = makeLlnd(fi,SUB_STRING,$1,$3,$1->entry.Template.symbol);
/*
          $$ = makeLlnd(fi,ARRAY_REF,$3,LLNULL,$1->entry.Template.symbol);
*/
          set_expr_type($$);
          }
    |  data_ref {
          if(debugFlag_g==1) printf("array_section: %s\n",$$); 
          }
    ;
       
data_ref                 
    :  name LEFTBRACKET
       section_subscript_list RIGHTBRACKET {
          PTR_SYMB s;
          s=makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          $$ = makeLlnd(fi,ARRAY_REF,$3,LLNULL,s);
          set_expr_type($$);
          }
    |  structure_component LEFTBRACKET
       section_subscript_list RIGHTBRACKET {
          $$ = makeLlnd(fi,ARRAY_REF,$3,LLNULL,$1->entry.
          record_ref_s.field->entry.Template.symbol); 
          set_expr_type($$);
          }
    ;
       
section_subscript_list   
    :  section_subscript {
          $$ = makeLlnd(fi,EXPR_LIST, $1, LLNULL, SMNULL);
          }
    |  section_subscript_list 
       COMMA section_subscript {
          $$ = set_ll_list($1, $3, EXPR_LIST);
          }
    ;
         
section_subscript        
    :  subscript_triplet       /* array_section */
    |  subscript               /* array_element */
    |  name  EQUAL actual_arg /*part of function_reference*/ {
/*
          PTR_SYMB s;
          s = makeSymbUnithead(fi,FUNCTION_NAME,$1);
          $$ = makeLlnd(fi, FUNC_CALL, $3, LLNULL, s);
*/
                                           /*the following added by zheng.gb*/
          PTR_LLND        l;
          l=makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          l->entry.string_val=$1;
          l->type=global_string;
          $$=makeLlnd(fi,KEYWORD_ARG,$3,l,SMNULL);
          }
    |  KINDEQ  actual_arg /*part of function_reference*/ {
                                           /*the following added by zheng.gb*/
          PTR_LLND        l;
          l=makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
          l->entry.string_val="kind";
          l->type=global_string;
          $$=makeLlnd(fi,KEYWORD_ARG,$2,l,SMNULL);
          }
    ;
       
       
subscript_triplet        
    :  expr COLON expr COLON expr    {
          $$ = makeLlnd(fi,DDOT,makeLlnd(fi,RANGE_OP,
          $1,$3,SMNULL),$5,SMNULL); 
          }
    |  COLON expr COLON expr {
          $$ = makeLlnd(fi,DDOT, makeLlnd(fi,RANGE_OP,
          LLNULL,$2,SMNULL),$4,SMNULL); 
          }
    |  COLON COLON expr   {
          $$ = makeLlnd(fi,DDOT,makeLlnd(fi,RANGE_OP,
          LLNULL,LLNULL,SMNULL),$3,SMNULL);
          }
    |  expr  COLON COLON expr {
          $$ = makeLlnd(fi,DDOT,makeLlnd(fi,RANGE_OP,
          $1,LLNULL,SMNULL),$4,SMNULL);
          }
    |  DOUBLECOLON expr  {
          $$ = makeLlnd(fi,DDOT,makeLlnd(fi,RANGE_OP,
          LLNULL,LLNULL,SMNULL),$2,SMNULL);
          }
    |  expr DOUBLECOLON expr {
          $$ = makeLlnd(fi,DDOT,makeLlnd(fi,RANGE_OP,
          $1,LLNULL,SMNULL),$3,SMNULL);
          }
    |  substring_range
    ;
       
substring_range          
    :  expr COLON expr  {
                                                /* modified by zheng.gb */
          $$ = makeLlnd(fi,DDOT,makeLlnd(fi,RANGE_OP,
                $1,$3,SMNULL),LLNULL,SMNULL);
          /* $$ = makeLlnd(fi,DDOT,$1,$3,SMNULL); */
          }
    |  COLON expr {
                                                /* modified by zheng.gb */
          $$ = makeLlnd(fi,DDOT,makeLlnd(fi,RANGE_OP,
                LLNULL,$2,SMNULL),LLNULL,SMNULL);
          /*$$ = makeLlnd(fi,DDOT,LLNULL,$2,SMNULL); */
          }
    |  expr COLON {
                                                /* modified by zheng.gb */
          $$ = makeLlnd(fi,DDOT,makeLlnd(fi,RANGE_OP,
                $1,LLNULL,SMNULL),LLNULL,SMNULL);
          /*$$ = makeLlnd(fi,DDOT,$1,LLNULL,SMNULL); */
          }
    |  COLON {
                                                /* modified by zheng.gb */
          $$ = makeLlnd(fi,DDOT,makeLlnd(fi,RANGE_OP,
                LLNULL,LLNULL,SMNULL),LLNULL,SMNULL);
          /*$$ = makeLlnd(fi,DDOT,LLNULL,LLNULL,SMNULL);*/
          }
    ;
       
       
substring
    :  name LEFTBRACKET
       substring_range RIGHTBRACKET {
          PTR_SYMB s;
          PTR_LLND l;
          s= makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          l=makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          $$=makeLlnd(fi,SUB_STRING,l,$3,SMNULL); 
          }
    |  structure_component LEFTBRACKET
       substring_range RIGHTBRACKET {
          $$=makeLlnd(fi,SUB_STRING,$1,$3,SMNULL); 
          }
    |  array_section_element_funcref /* array_element */ LEFTBRACKET
       substring_range RIGHTBRACKET {
          $$=makeLlnd(fi,SUB_STRING,$1,$3,SMNULL); 
          }
    |  char_literal_constant LEFTBRACKET
       substring_range RIGHTBRACKET {
          $$=makeLlnd(fi,SUB_STRING,$1,$3,SMNULL); 
          }
    ;

subscript
    :  expr
    ;
       
       
structure_component
    :  part_ref1 newname3 {
          PTR_LLND l,p,q,temp;
          l=makeLlnd(fi,EXPR_LIST,$1,LLNULL,SMNULL); 
/*                                            modified by zheng.gb 1996/10/29
          p = set_ll_list(l,$2,EXPR_LIST);
          for(temp=p;temp->entry.list.next->entry.list.next;temp=temp->entry.list.next)
             ;
          q=temp->entry.list.next;
          temp->entry.list.next=LLNULL;
          $$ = makeLlnd(fi,RECORD_REF,l,q,SMNULL);
*/
          $$ = makeLlnd(fi,RECORD_REF,l,$2,SMNULL);
          set_expr_type($$);
          }
    ;
       
newname3                 
    :  part_ref {
          PTR_LLND l;
/*                               modified by zheng.gb 1996/11/5
          $$=makeLlnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);
*/
          $$=makeLlnd(fi,RECORD_REF,$1,LLNULL,SMNULL); 
		  /* set_expr_type($$);  modified by zheng.gb 1996/11/15 */
		  $$->type=$1->type;
          }
    |  newname3 PERCENT part_ref {
          PTR_LLND l;
/*				modified by zheng.gb 1996/10/29
          l=makeLlnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
          $$ = set_ll_list($1,l,EXPR_LIST); 
*/
/*                               modified by zheng.gb 1996/11/5
          $$ = set_ll_list($1,$3,EXPR_LIST); 
*/

          $$ = set_ll_list($1,$3,RECORD_REF); 
          set_expr_type($$);
          }
    ;
       
/*    modified by zheng.gb    */
part_ref1
    :  name PERCENT {
          PTR_SYMB s;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
/*                                      must not report error !!! zheng.gb
          if(s->type->name == SMNULL)
             err_g("Derived_type Variable nondeclared",lineNum_g,$1);
*/
                                            /* add by zheng.gb  on 1/27 1996  */
          if (s->type && s->type->variant == T_RECORD ) {
                if (s->type->variant == T_ARRAY)
                        type_name=s->type->entry.ar_decl.base_type->name;
                else
                        type_name = s->type->name;
          }
          /* type_name = s->type->name; */
          $$ = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          set_expr_type($$);
          }
    |  name LEFTBRACKET section_subscript_list RIGHTBRACKET PERCENT {
          PTR_SYMB s;
          s=makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
/*
          if(s->type->entry.ar_decl.base_type->name == SMNULL)
             err_g("Derived_type Variable nondeclared",lineNum_g,$1);
          type_name = s->type->entry.ar_decl.base_type->name;
*/
                                            /* add by zheng.gb  on 1/27 1996  */
          if (s->type && s->type->variant == T_RECORD ) {
                if (s->type->variant == T_ARRAY)
                        type_name=s->type->entry.ar_decl.base_type->name;
                else
                        type_name = s->type->name;
          }
          $$ = makeLlnd(fi,ARRAY_REF,$3,LLNULL,s);
          set_expr_type($$);
          }
    ;
       
/*   modified by zheng.gb  1996. 1.27 */
part_ref
    :  name  {
          PTR_SYMB s;
          /* s = lookupSymbField($1,type_name); */
          if (type_name) s = lookupSymbField($1,type_name);
          else  {
                          /* if not find , create FIELD anyway */
                s=make_symb(fi,FIELD_NAME,$1);
                s->type=TYNULL;
          }
                                            /* add by zheng.gb  on 1/27 1996  */
	  if (s == SMNULL) {
		fprintf(stderr,"Unexpected error , Abort .");
		exit(1);
	  }
          if (s->type) {
                if (s->type->variant == T_ARRAY)
                        type_name=s->type->entry.ar_decl.base_type->name;
                else
                        type_name = s->type->name;
          }
          $$ = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          set_expr_type($$);
          }
    |  name LEFTBRACKET section_subscript_list RIGHTBRACKET  {
          PTR_SYMB s;
          /* s = lookupSymbField($1,type_name); */
          if (type_name) s = lookupSymbField($1,type_name);
          else  {
                s=make_symb(fi,FIELD_NAME,$1);           /*  create without */
                s->type=TYNULL;
          }
                                        /* add by zheng.gb  on 1/27 1996  */
	  if (s == SMNULL) {
		fprintf(stderr,"Unexpected error , Abort .");
		exit(1);
	  }
          if (s->type) {
                if (s->type->variant == T_ARRAY)
                        type_name=s->type->entry.ar_decl.base_type->name;
                else
                        type_name = s->type->name;
          }
          $$ = makeLlnd(fi,ARRAY_REF,$3,LLNULL,s);
          set_expr_type($$);
          }
    ;
       
/*
stride                   : expr
                         ;
*/
       
/************************   8.25.1995     *******************************/

/********************   Constant     8.24.1995  *************************/
       
constant
    :  literal_constant
    |  complex_literal_constant
    |  name  {
          PTR_SYMB s;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0); 
          /* s -> variant = CONST_NAME;*/         /* Zheng Gengbin 1996.5.28 */
          $$ = makeLlnd(fi,CONST_REF,LLNULL,LLNULL,s);
          $$->type = global_default;
          }
    ;
       
literal_constant
    :  int_literal_constant
    |  real_literal_constant
    |  logical_literal_constant
    |  char_literal_constant
    |  boz_literal_constant     
    |  double_literal_constant  
    ;
       
real_literal_constant
    :  real_constant  {
          if(debugFlag_g==1) printf("real_const:%s\n",$$);
          $$ = makeLlnd(fi,FLOAT_VAL,LLNULL,LLNULL,SMNULL);
          $$->entry.string_val = $1;
          $$->type = global_float;
          }
    |  real_constant UNDERSCORE kind_param {
          PTR_LLND l,p,q;
          PTR_TYPE tp;                                  /* add by zheng.gb */
          p=makeLlnd(fi,FLOAT_VAL,LLNULL,LLNULL,SMNULL);
                                                        /* add by zheng.gb */
          tp=make_type(fi,T_KIND);
/*
          p->type = global_float;
*/
          if(debugFlag_g==1) printf("real_const %s\n",$1);
          p->entry.string_val = $1;
          l=makeLlnd(fi,KIND_OP,$3,LLNULL,SMNULL);
                                                        /* add by zheng.gb */
          q=makeLlnd(fi,EXPR_LIST,l,LLNULL,SMNULL);
          tp->entry.kind_decl.base_type=global_float;
          tp->entry.kind_decl.kindexp=q;
          p->type = tp;

          $$ = makeLlnd(fi,KIND_VAL,p,l,SMNULL);
          }
    ;
       
real_constant
    :  REAL_LITERAL_CONST {
        $$ = copys(yytext);
          }
    ;
       
double_literal_constant
    :  DOUBLE_LITERAL_CONST {
          if(debugFlag_g==1) printf("double_const:%s\n",$$);
          $$ = makeLlnd(fi,DOUBLE_VAL, LLNULL, LLNULL, SMNULL);
          $$->entry.string_val = copys(yytext);        
          $$->type = global_double;
          }
    ;
       
boz_literal_constant     
    :  BINARY_CONST   {
          $$ = makeLlnd(fi,BINARY_VAL,LLNULL,LLNULL,SMNULL);
          $$->entry.string_val = copys(yytext);
          $$->type = global_int;
          }
    |  OCTAL_CONST    {
          $$ = makeLlnd(fi,OCTN_VAL,LLNULL,LLNULL,SMNULL);
          $$->entry.string_val = copys(yytext);
          $$->type = global_int;
          }
    |  HEX_CONST   {
          $$ = makeLlnd(fi,HEX_VAL,LLNULL,LLNULL,SMNULL);
          $$->entry.string_val = copys(yytext);
          $$->type = global_int;
          }
    ;
       
logical_literal_constant 
    :  TRUEL  {
          $$ = makeLlnd(fi,BOOL_VAL, LLNULL, LLNULL, SMNULL);
          $$->entry.bval = 1;
          $$->type = global_bool;
          }
    |  FALSEL  {
          $$ = makeLlnd(fi,BOOL_VAL, LLNULL, LLNULL, SMNULL);
          $$->entry.bval = 0;
          $$->type = global_bool;
          }
    |  TRUEL UNDERSCORE kind_param {
          PTR_LLND l,p,q;
          PTR_TYPE tp;                                  /* add by zheng.gb */
          p=makeLlnd(fi,BOOL_VAL,LLNULL,LLNULL,SMNULL);
                                                        /* add by zheng.gb */
          tp=make_type(fi,T_KIND);
/*
          p->type = global_bool;
*/
          p->entry.bval = 1;
          l=makeLlnd(fi,KIND_OP,$3,LLNULL,SMNULL);
                                                        /* add by zheng.gb */
          q=makeLlnd(fi,EXPR_LIST,l,LLNULL,SMNULL);
          tp->entry.kind_decl.base_type=global_bool;
          tp->entry.kind_decl.kindexp=q;
          p->type = tp;

          $$ = makeLlnd(fi,KIND_VAL,p,l,SMNULL); 
          }
    |  FALSEL UNDERSCORE kind_param {
          PTR_LLND l,p,q;
          PTR_TYPE tp;                                  /* add by zheng.gb */
          p=makeLlnd(fi,BOOL_VAL,LLNULL,LLNULL,SMNULL);
                                                        /* add by zheng.gb */
          tp=make_type(fi,T_KIND);
/*
          p->type = global_bool;
*/
          p->entry.bval = 0;
          l=makeLlnd(fi,KIND_OP,$3,LLNULL,SMNULL);
                                                        /* add by zheng.gb */
          q=makeLlnd(fi,EXPR_LIST,l,LLNULL,SMNULL);
          tp->entry.kind_decl.base_type=global_bool;
          tp->entry.kind_decl.kindexp=q;
          p->type = tp;

          $$ = makeLlnd(fi,KIND_VAL,p,l,SMNULL);
          }
    ;
       
char_literal_constant    
    :  kind_param UNDERSCORE1 STRING {
          PTR_LLND l,p,q;
          PTR_TYPE tp;                                  /* add by zheng.gb */
          if(debugFlag_g==1) printf("char_const %s\n",yytext);
          p = makeLlnd(fi,STRING_VAL, LLNULL, LLNULL, SMNULL);
/*
          p->type = global_string;
*/
          /* p->entry.string_val = copys(yytext); */
          p->entry.string_val = $3;  /* Modified by Zheng Qiang */
          l=makeLlnd(fi,KIND_OP,$1,LLNULL,SMNULL);
                                                        /* add by zheng.gb */
          q=makeLlnd(fi,EXPR_LIST,l,LLNULL,SMNULL);
          tp=make_type(fi,T_KIND);
          tp->entry.kind_decl.base_type=global_string;
          tp->entry.kind_decl.kindexp=q;
          p->type = tp;
                                    /* modifed by zheng.gb 5.3 1996 */
          $$ = makeLlnd(fi,KIND_VAL,l,p,SMNULL);
          }
    |  STRING  {
          $$ = makeLlnd(fi,STRING_VAL, LLNULL, LLNULL, SMNULL);
          /* $$->entry.string_val = copys(yytext); */
          $$->entry.string_val = $1; /* Modified by Zheng Qiang */
          $$->type = global_string;
          }
    ;
       
int_literal_constant     
    :  digit_string UNDERSCORE kind_param {
          PTR_LLND l,p,q;
          PTR_TYPE tp;
          p = makeLlnd(fi,INT_VAL, LLNULL, LLNULL, SMNULL);
/*
          p->type = global_int;
*/
          p->entry.ival = atoi($1);
          l=makeLlnd(fi,KIND_OP,$3,LLNULL,SMNULL);
                                                        /* add by zheng.gb */
          q=makeLlnd(fi,EXPR_LIST,l,LLNULL,SMNULL);
          tp=make_type(fi,T_KIND);
          tp->entry.kind_decl.base_type=global_int;
          tp->entry.kind_decl.kindexp=q;
          p->type = tp;

          $$ = makeLlnd(fi,KIND_VAL,p,l,SMNULL);
          }
    |  digit_string {
          $$ = makeLlnd(fi,INT_VAL, LLNULL, LLNULL, SMNULL);
          $$->entry.ival = atoi($1);
          $$->type = global_int;
          }
    ;
       
signed_real_literal_constant 
    :  PLUS real_literal_constant {
          $$ = $2;
          }
    |  MINUS real_literal_constant {
          char str[20];
          $$ = $2;
          strcpy(str,"-"); 
          $$->entry.string_val = strcat(str,$2->entry.string_val);
          }
/*  | real_literal_constant              */
    ;
       
signed_int_literal_constant 
    :  PLUS int_literal_constant {
          if(debugFlag_g==1) printf("signed_const:%s\n",$$);
          $$ = $2;
          }
    |  MINUS int_literal_constant {
          char str[20]; 
          if(debugFlag_g==1) printf("signed_const:%s\n",$$);
          $$ = $2;
          strcpy(str,"-");
          $$->entry.string_val = strcat(str,$2->entry.string_val);
          }
/*  | int_literal_constant                 */
    ;
       
complex_literal_constant 
    :  LEFTBRACKET /*real_part*/ expr1
       COMMA /*image_part*/ expr1 RIGHTBRACKET   {
          if(debugFlag_g==1) printf("complex_const:%s\n",$$);
          $$ = makeLlnd(fi,COMPLEX_VAL, $2, $4, SMNULL);
          $$->type = global_complex;
          }
    ;
       
       
complex_expr                
    :  complex_expr defined_operator complex_expr1 {
          PTR_SYMB s;
          if(debugFlag_g==1)printf("expr_defined_op\n");
          s = makeSymb(fi,cur_scope(),INTERFACE_NAME,$2,0);
          $$ = makeLlnd(fi,DEFINED_OP,$1,$3,s);
          }
    |  complex_expr1
    ;
       
complex_expr1
    :  complex_expr1 add_op complex_add_operand {
          $$ = makeLlnd(fi,$2,$1,$3,SMNULL);
          }
    |  complex_add_operand {
          if(debugFlag_g==1)printf("complex_add_expr\n");
          }
    |  add_op complex_add_operand {
          $$ = makeLlnd(fi,$1,$2,LLNULL,SMNULL);
          }
    ;
       
complex_add_operand      
    :  complex_add_operand mult_op complex_mult_operand {
          $$ =  makeLlnd(fi,$2,$1,$3,SMNULL);
          }
    |  complex_mult_operand
    ;
       
complex_mult_operand     
    :  complex_level_1_expr
    |  complex_mult_operand power_op complex_level_1_expr {
          $$ =  makeLlnd(fi,$2,$1,$3,SMNULL);
          }
    ;
       
complex_level_1_expr     
    :  defined_operator complex_literal_constant {
          PTR_SYMB s;
          if(debugFlag_g==1)printf("level_1_expr,defined_op \n");
          s = makeSymb(fi,cur_scope(),INTERFACE_NAME,$1,0);
          $$ = makeLlnd(fi,DEFINED_OP,$2,LLNULL,s);
          }
    |  complex_literal_constant {
          if(debugFlag_g==1)printf("complex_constant\n");
          }
    ;
       
/*********************   8.23.1995  ********************************/

digit_string
    :  DIGIT_STRING 
        {
         $$ = copys(yytext);
        }
    ;

kind_param               
    :  digit_string {
          $$ = makeLlnd(fi,INT_VAL, LLNULL, LLNULL, SMNULL);
          $$->entry.ival = atoi($1);
                                                /* add by zheng.gb */
          $$->type= global_int;
          }
    |  name  /*int_constant_*/ {
          PTR_SYMB s;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
                                                /* add by zheng.gb */
          $$ = makeLlnd(fi,VAR_REF, LLNULL, LLNULL, s);
/*
          $$ = makeLlnd(fi,STRING_VAL, LLNULL, LLNULL, SMNULL);
          $$->entry.string_val = copys(s->ident);
*/
          }
    ;

label1
    :  LABEL  {
          $$ = make_label(fi,atol(yytext));
                                                        /* add by zheng.gb */
          if ($$->statbody != BFNULL)
                err_g("Redeclared Label :",lineNum_g,yytext);
          }
    ;

label
    :  digit_string  {
          PTR_LABEL p;
          p = make_label(fi,atol($1));
          $$ = make_llnd_label(fi,LABEL_REF,p); 
          }
    ;

/**********************   THE END of f90.y  ***************************/

/*****************   Fortran D . This part is made by Lxy. ************/

sequence_directive
    :  DIRSEQUENCE {
          $$=makeVarlistdecl(fi,DIRSEQUENCE_STMT,LLNULL);
          }
    |  NO DIRSEQUENCE  {
          $$=makeVarlistdecl(fi,NOSEQUENCE_STMT,LLNULL);
          }
    |  DIRSEQUENCE opt_double_colon association_name_list {
          $$=makeVarlistdecl(fi,DIRSEQUENCE_STMT,$3);
          }
    |  NO DIRSEQUENCE opt_double_colon association_name_list {
          $$= makeVarlistdecl(fi,NOSEQUENCE_STMT,$4);
          }
    ;

association_name_list
    :  association_name {
          $$ = makeLlnd(fi,EXPR_LIST, $1, LLNULL, SMNULL); 
          }
    |  association_name_list COMMA association_name {
           $$ = set_ll_list($1, $3, EXPR_LIST);
           }
    ;

association_name
    :  name {
          PTR_SYMB s;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$1,0);
          $$ = makeLlnd(fi,VAR_REF,LLNULL,LLNULL,s);
          }
    |  DIVIDE  name DIVIDE {
          PTR_SYMB s;
          s = makeSymbVar(fi,cur_scope(),LOCAL,$2,0);
                                                /* modified by Feng Xiaobing */
/*
          $$ = makeLlnd(fi,COMM_LIST, LLNULL, LLNULL, $2);
*/
          $$ = makeLlnd(fi,COMM_LIST, LLNULL, LLNULL, s);
          }
    ;

/***************************   1/2/1996  ******************************/

/***********   The next part of AST is made by ZhongJidong   **********/
